/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/mozILocaleService.idl
 */

#ifndef __gen_mozILocaleService_h__
#define __gen_mozILocaleService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
// Define Contractid and CID
#define MOZ_LOCALESERVICE_CID \
  { 0x92735ff4, 0x6384, 0x4ad6, { 0x85, 0x08, 0x75, 0x70, 0x10, 0xe1, 0x49, 0xee } }
#define MOZ_LOCALESERVICE_CONTRACTID "@mozilla.org/intl/localeservice;1"

/* starting interface:    mozILocaleService */
#define MOZILOCALESERVICE_IID_STR "c27f8983-b48b-4d1a-92d7-feb8106f212d"

#define MOZILOCALESERVICE_IID \
  {0xc27f8983, 0xb48b, 0x4d1a, \
    { 0x92, 0xd7, 0xfe, 0xb8, 0x10, 0x6f, 0x21, 0x2d }}

class NS_NO_VTABLE mozILocaleService : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(MOZILOCALESERVICE_IID)

  enum {
    langNegStrategyFiltering = 0,
    langNegStrategyMatching = 1,
    langNegStrategyLookup = 2
  };

  /* readonly attribute ACString defaultLocale; */
  NS_IMETHOD GetDefaultLocale(nsACString & aDefaultLocale) = 0;

  /* void getAppLocalesAsLangTags ([optional] out unsigned long aCount, [array, size_is (aCount), retval] out string aLocales); */
  NS_IMETHOD GetAppLocalesAsLangTags(uint32_t *aCount, char * **aLocales) = 0;

  /* void getAppLocalesAsBCP47 ([optional] out unsigned long aCount, [array, size_is (aCount), retval] out string aLocales); */
  NS_IMETHOD GetAppLocalesAsBCP47(uint32_t *aCount, char * **aLocales) = 0;

  /* void getRegionalPrefsLocales ([optional] out unsigned long aCount, [array, size_is (aCount), retval] out string aOutArray); */
  NS_IMETHOD GetRegionalPrefsLocales(uint32_t *aCount, char * **aOutArray) = 0;

  /* void negotiateLanguages ([array, size_is (aRequestedCount)] in string aRequested, [array, size_is (aAvailableCount)] in string aAvailable, [optional] in string aDefaultLocale, [optional] in long langNegStrategy, [optional] in unsigned long aRequestedCount, [optional] in unsigned long aAvailableCount, [optional] out unsigned long aCount, [array, size_is (aCount), retval] out string aLocales); */
  NS_IMETHOD NegotiateLanguages(const char * *aRequested, const char * *aAvailable, const char * aDefaultLocale, int32_t langNegStrategy, uint32_t aRequestedCount, uint32_t aAvailableCount, uint32_t *aCount, char * **aLocales) = 0;

  /* ACString getAppLocaleAsLangTag (); */
  NS_IMETHOD GetAppLocaleAsLangTag(nsACString & _retval) = 0;

  /* ACString getAppLocaleAsBCP47 (); */
  NS_IMETHOD GetAppLocaleAsBCP47(nsACString & _retval) = 0;

  /* void getRequestedLocales ([optional] out unsigned long aCount, [array, size_is (aCount), retval] out string aLocales); */
  NS_IMETHOD GetRequestedLocales(uint32_t *aCount, char * **aLocales) = 0;

  /* ACString getRequestedLocale (); */
  NS_IMETHOD GetRequestedLocale(nsACString & _retval) = 0;

  /* void setRequestedLocales ([array, size_is (aRequestedCount)] in string aRequested, [optional] in unsigned long aRequestedCount); */
  NS_IMETHOD SetRequestedLocales(const char * *aRequested, uint32_t aRequestedCount) = 0;

  /* void getAvailableLocales ([optional] out unsigned long aCount, [array, size_is (aCount), retval] out string aLocales); */
  NS_IMETHOD GetAvailableLocales(uint32_t *aCount, char * **aLocales) = 0;

  /* readonly attribute boolean isAppLocaleRTL; */
  NS_IMETHOD GetIsAppLocaleRTL(bool *aIsAppLocaleRTL) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(mozILocaleService, MOZILOCALESERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZILOCALESERVICE \
  NS_IMETHOD GetDefaultLocale(nsACString & aDefaultLocale) override; \
  NS_IMETHOD GetAppLocalesAsLangTags(uint32_t *aCount, char * **aLocales) override; \
  NS_IMETHOD GetAppLocalesAsBCP47(uint32_t *aCount, char * **aLocales) override; \
  NS_IMETHOD GetRegionalPrefsLocales(uint32_t *aCount, char * **aOutArray) override; \
  NS_IMETHOD NegotiateLanguages(const char * *aRequested, const char * *aAvailable, const char * aDefaultLocale, int32_t langNegStrategy, uint32_t aRequestedCount, uint32_t aAvailableCount, uint32_t *aCount, char * **aLocales) override; \
  NS_IMETHOD GetAppLocaleAsLangTag(nsACString & _retval) override; \
  NS_IMETHOD GetAppLocaleAsBCP47(nsACString & _retval) override; \
  NS_IMETHOD GetRequestedLocales(uint32_t *aCount, char * **aLocales) override; \
  NS_IMETHOD GetRequestedLocale(nsACString & _retval) override; \
  NS_IMETHOD SetRequestedLocales(const char * *aRequested, uint32_t aRequestedCount) override; \
  NS_IMETHOD GetAvailableLocales(uint32_t *aCount, char * **aLocales) override; \
  NS_IMETHOD GetIsAppLocaleRTL(bool *aIsAppLocaleRTL) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_MOZILOCALESERVICE \
  nsresult GetDefaultLocale(nsACString & aDefaultLocale); \
  nsresult GetAppLocalesAsLangTags(uint32_t *aCount, char * **aLocales); \
  nsresult GetAppLocalesAsBCP47(uint32_t *aCount, char * **aLocales); \
  nsresult GetRegionalPrefsLocales(uint32_t *aCount, char * **aOutArray); \
  nsresult NegotiateLanguages(const char * *aRequested, const char * *aAvailable, const char * aDefaultLocale, int32_t langNegStrategy, uint32_t aRequestedCount, uint32_t aAvailableCount, uint32_t *aCount, char * **aLocales); \
  nsresult GetAppLocaleAsLangTag(nsACString & _retval); \
  nsresult GetAppLocaleAsBCP47(nsACString & _retval); \
  nsresult GetRequestedLocales(uint32_t *aCount, char * **aLocales); \
  nsresult GetRequestedLocale(nsACString & _retval); \
  nsresult SetRequestedLocales(const char * *aRequested, uint32_t aRequestedCount); \
  nsresult GetAvailableLocales(uint32_t *aCount, char * **aLocales); \
  nsresult GetIsAppLocaleRTL(bool *aIsAppLocaleRTL); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZILOCALESERVICE(_to) \
  NS_IMETHOD GetDefaultLocale(nsACString & aDefaultLocale) override { return _to GetDefaultLocale(aDefaultLocale); } \
  NS_IMETHOD GetAppLocalesAsLangTags(uint32_t *aCount, char * **aLocales) override { return _to GetAppLocalesAsLangTags(aCount, aLocales); } \
  NS_IMETHOD GetAppLocalesAsBCP47(uint32_t *aCount, char * **aLocales) override { return _to GetAppLocalesAsBCP47(aCount, aLocales); } \
  NS_IMETHOD GetRegionalPrefsLocales(uint32_t *aCount, char * **aOutArray) override { return _to GetRegionalPrefsLocales(aCount, aOutArray); } \
  NS_IMETHOD NegotiateLanguages(const char * *aRequested, const char * *aAvailable, const char * aDefaultLocale, int32_t langNegStrategy, uint32_t aRequestedCount, uint32_t aAvailableCount, uint32_t *aCount, char * **aLocales) override { return _to NegotiateLanguages(aRequested, aAvailable, aDefaultLocale, langNegStrategy, aRequestedCount, aAvailableCount, aCount, aLocales); } \
  NS_IMETHOD GetAppLocaleAsLangTag(nsACString & _retval) override { return _to GetAppLocaleAsLangTag(_retval); } \
  NS_IMETHOD GetAppLocaleAsBCP47(nsACString & _retval) override { return _to GetAppLocaleAsBCP47(_retval); } \
  NS_IMETHOD GetRequestedLocales(uint32_t *aCount, char * **aLocales) override { return _to GetRequestedLocales(aCount, aLocales); } \
  NS_IMETHOD GetRequestedLocale(nsACString & _retval) override { return _to GetRequestedLocale(_retval); } \
  NS_IMETHOD SetRequestedLocales(const char * *aRequested, uint32_t aRequestedCount) override { return _to SetRequestedLocales(aRequested, aRequestedCount); } \
  NS_IMETHOD GetAvailableLocales(uint32_t *aCount, char * **aLocales) override { return _to GetAvailableLocales(aCount, aLocales); } \
  NS_IMETHOD GetIsAppLocaleRTL(bool *aIsAppLocaleRTL) override { return _to GetIsAppLocaleRTL(aIsAppLocaleRTL); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZILOCALESERVICE(_to) \
  NS_IMETHOD GetDefaultLocale(nsACString & aDefaultLocale) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDefaultLocale(aDefaultLocale); } \
  NS_IMETHOD GetAppLocalesAsLangTags(uint32_t *aCount, char * **aLocales) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAppLocalesAsLangTags(aCount, aLocales); } \
  NS_IMETHOD GetAppLocalesAsBCP47(uint32_t *aCount, char * **aLocales) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAppLocalesAsBCP47(aCount, aLocales); } \
  NS_IMETHOD GetRegionalPrefsLocales(uint32_t *aCount, char * **aOutArray) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRegionalPrefsLocales(aCount, aOutArray); } \
  NS_IMETHOD NegotiateLanguages(const char * *aRequested, const char * *aAvailable, const char * aDefaultLocale, int32_t langNegStrategy, uint32_t aRequestedCount, uint32_t aAvailableCount, uint32_t *aCount, char * **aLocales) override { return !_to ? NS_ERROR_NULL_POINTER : _to->NegotiateLanguages(aRequested, aAvailable, aDefaultLocale, langNegStrategy, aRequestedCount, aAvailableCount, aCount, aLocales); } \
  NS_IMETHOD GetAppLocaleAsLangTag(nsACString & _retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAppLocaleAsLangTag(_retval); } \
  NS_IMETHOD GetAppLocaleAsBCP47(nsACString & _retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAppLocaleAsBCP47(_retval); } \
  NS_IMETHOD GetRequestedLocales(uint32_t *aCount, char * **aLocales) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRequestedLocales(aCount, aLocales); } \
  NS_IMETHOD GetRequestedLocale(nsACString & _retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRequestedLocale(_retval); } \
  NS_IMETHOD SetRequestedLocales(const char * *aRequested, uint32_t aRequestedCount) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRequestedLocales(aRequested, aRequestedCount); } \
  NS_IMETHOD GetAvailableLocales(uint32_t *aCount, char * **aLocales) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAvailableLocales(aCount, aLocales); } \
  NS_IMETHOD GetIsAppLocaleRTL(bool *aIsAppLocaleRTL) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsAppLocaleRTL(aIsAppLocaleRTL); } 


#endif /* __gen_mozILocaleService_h__ */
