/* THIS FILE IS AUTOGENERATED FROM WebAuthentication.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_WebAuthenticationBinding_h
#define mozilla_dom_WebAuthenticationBinding_h

#include "WebAuthenticationBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/UnionMember.h"
#include "mozilla/dom/UnionTypes.h"

namespace mozilla {
namespace dom {

class ArrayBufferViewOrArrayBuffer;
class AuthenticatorAssertionResponse;
struct AuthenticatorAssertionResponseAtoms;
class AuthenticatorAttestationResponse;
struct AuthenticatorAttestationResponseAtoms;
class AuthenticatorResponse;
struct AuthenticatorResponseAtoms;
struct AuthenticatorSelectionCriteria;
struct AuthenticatorSelectionCriteriaAtoms;
class BooleanOrString;
struct CollectedClientDataAtoms;
struct MakeCredentialOptionsAtoms;
struct NativePropertyHooks;
class OwningArrayBufferViewOrArrayBuffer;
class OwningBooleanOrString;
class ProtoAndIfaceCache;
class PublicKeyCredential;
struct PublicKeyCredentialAtoms;
struct PublicKeyCredentialDescriptor;
struct PublicKeyCredentialDescriptorAtoms;
struct PublicKeyCredentialEntity;
struct PublicKeyCredentialEntityAtoms;
struct PublicKeyCredentialParameters;
struct PublicKeyCredentialParametersAtoms;
struct PublicKeyCredentialRequestOptionsAtoms;
struct PublicKeyCredentialUserEntity;
struct PublicKeyCredentialUserEntityAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

enum class Attachment : uint8_t {
  Platform,
  Cross_platform,
  EndGuard_
};

namespace AttachmentValues {
extern const EnumEntry strings[3];
} // namespace AttachmentValues

bool
ToJSValue(JSContext* aCx, Attachment aArgument, JS::MutableHandle<JS::Value> aValue);


enum class PublicKeyCredentialType : uint8_t {
  Public_key,
  EndGuard_
};

namespace PublicKeyCredentialTypeValues {
extern const EnumEntry strings[2];
} // namespace PublicKeyCredentialTypeValues

bool
ToJSValue(JSContext* aCx, PublicKeyCredentialType aArgument, JS::MutableHandle<JS::Value> aValue);


enum class WebAuthnTransport : uint8_t {
  Usb,
  Nfc,
  Ble,
  EndGuard_
};

namespace WebAuthnTransportValues {
extern const EnumEntry strings[4];
} // namespace WebAuthnTransportValues

bool
ToJSValue(JSContext* aCx, WebAuthnTransport aArgument, JS::MutableHandle<JS::Value> aValue);


struct AuthenticatorSelectionCriteria : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<Attachment> mAttachment;
  MOZ_INIT_OUTSIDE_CTOR bool mRequireResidentKey;

  AuthenticatorSelectionCriteria();

  explicit inline AuthenticatorSelectionCriteria(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline AuthenticatorSelectionCriteria(const AuthenticatorSelectionCriteria& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  AuthenticatorSelectionCriteria&
  operator=(const AuthenticatorSelectionCriteria& aOther);

private:
  static bool
  InitIds(JSContext* cx, AuthenticatorSelectionCriteriaAtoms* atomsCache);
};

namespace binding_detail {
struct FastAuthenticatorSelectionCriteria : public AuthenticatorSelectionCriteria
{
  inline FastAuthenticatorSelectionCriteria()
    : AuthenticatorSelectionCriteria(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class BooleanOrString
{
  friend class BooleanOrStringArgument;
  enum Type
  {
    eUninitialized,
    eBoolean,
    eString
  };

  union Value
  {
    UnionMember<bool > mBoolean;
    UnionMember<binding_detail::FakeString > mString;

  };

  Type mType;
  Value mValue;

  BooleanOrString(const BooleanOrString&) = delete;
  BooleanOrString& operator=(const BooleanOrString&) = delete;
public:
  explicit inline BooleanOrString()
    : mType(eUninitialized)
  {
  }

  inline ~BooleanOrString()
  {
    Uninit();
  }

  inline bool&
  RawSetAsBoolean()
  {
    if (mType == eBoolean) {
      return mValue.mBoolean.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eBoolean;
    return mValue.mBoolean.SetValue();
  }

  inline bool&
  SetAsBoolean()
  {
    if (mType == eBoolean) {
      return mValue.mBoolean.Value();
    }
    Uninit();
    mType = eBoolean;
    return mValue.mBoolean.SetValue();
  }

  inline bool
  IsBoolean() const
  {
    return mType == eBoolean;
  }

  inline bool&
  GetAsBoolean()
  {
    MOZ_ASSERT(IsBoolean(), "Wrong type!");
    return mValue.mBoolean.Value();
  }

  inline bool
  GetAsBoolean() const
  {
    MOZ_ASSERT(IsBoolean(), "Wrong type!");
    return mValue.mBoolean.Value();
  }

  inline binding_detail::FakeString&
  RawSetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline binding_detail::FakeString&
  SetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    Uninit();
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline binding_detail::FakeString&
  GetAsString()
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline const nsAString&
  GetAsString() const
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eBoolean: {
        DestroyBoolean();
        break;
      }
      case eString: {
        DestroyString();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyBoolean()
  {
    MOZ_ASSERT(IsBoolean(), "Wrong type!");
    mValue.mBoolean.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyString()
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    mValue.mString.Destroy();
    mType = eUninitialized;
  }
};


class OwningBooleanOrString : public AllOwningUnionBase
{
  friend void ImplCycleCollectionUnlink(OwningBooleanOrString& aUnion);
  enum Type
  {
    eUninitialized,
    eBoolean,
    eString
  };

  union Value
  {
    UnionMember<bool > mBoolean;
    UnionMember<nsString > mString;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningBooleanOrString()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningBooleanOrString(const OwningBooleanOrString& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningBooleanOrString()
  {
    Uninit();
  }

  bool&
  RawSetAsBoolean();

  bool&
  SetAsBoolean();

  bool
  TrySetToBoolean(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsBoolean() const
  {
    return mType == eBoolean;
  }

  inline bool&
  GetAsBoolean()
  {
    MOZ_ASSERT(IsBoolean(), "Wrong type!");
    return mValue.mBoolean.Value();
  }

  inline bool const &
  GetAsBoolean() const
  {
    MOZ_ASSERT(IsBoolean(), "Wrong type!");
    return mValue.mBoolean.Value();
  }

  nsString&
  RawSetAsString();

  nsString&
  SetAsString();

  bool
  TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline void
  SetStringData(const nsString::char_type* aData, nsString::size_type aLength)
  {
    RawSetAsString().Assign(aData, aLength);
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline nsString&
  GetAsString()
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline nsString const &
  GetAsString() const
  {
    MOZ_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceUnion(JSTracer* trc);

  OwningBooleanOrString&
  operator=(const OwningBooleanOrString& aOther);

private:
  void
  DestroyBoolean();

  void
  DestroyString();
};


struct CollectedClientData : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR nsString mChallenge;
  MOZ_INIT_OUTSIDE_CTOR nsString mHashAlg;
  MOZ_INIT_OUTSIDE_CTOR nsString mOrigin;
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mTokenBinding;

  CollectedClientData();

  explicit inline CollectedClientData(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline CollectedClientData(const CollectedClientData& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  CollectedClientData&
  operator=(const CollectedClientData& aOther);

private:
  static bool
  InitIds(JSContext* cx, CollectedClientDataAtoms* atomsCache);
};

namespace binding_detail {
struct FastCollectedClientData : public CollectedClientData
{
  inline FastCollectedClientData()
    : CollectedClientData(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct PublicKeyCredentialDescriptor : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningArrayBufferViewOrArrayBuffer mId;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<WebAuthnTransport>> mTransports;
  MOZ_INIT_OUTSIDE_CTOR PublicKeyCredentialType mType;

  PublicKeyCredentialDescriptor();

  explicit inline PublicKeyCredentialDescriptor(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  PublicKeyCredentialDescriptor(const PublicKeyCredentialDescriptor&) = delete;
  PublicKeyCredentialDescriptor& operator=(const PublicKeyCredentialDescriptor&) = delete;

  static bool
  InitIds(JSContext* cx, PublicKeyCredentialDescriptorAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastPublicKeyCredentialDescriptor : public PublicKeyCredentialDescriptor
{
  inline FastPublicKeyCredentialDescriptor()
    : PublicKeyCredentialDescriptor(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct PublicKeyCredentialEntity : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mIcon;
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mId;
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mName;

  PublicKeyCredentialEntity();

  explicit inline PublicKeyCredentialEntity(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline PublicKeyCredentialEntity(const PublicKeyCredentialEntity& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  PublicKeyCredentialEntity&
  operator=(const PublicKeyCredentialEntity& aOther);

private:
  static bool
  InitIds(JSContext* cx, PublicKeyCredentialEntityAtoms* atomsCache);
};

namespace binding_detail {
struct FastPublicKeyCredentialEntity : public PublicKeyCredentialEntity
{
  inline FastPublicKeyCredentialEntity()
    : PublicKeyCredentialEntity(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct PublicKeyCredentialParameters : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningBooleanOrString mAlgorithm;
  MOZ_INIT_OUTSIDE_CTOR PublicKeyCredentialType mType;

  PublicKeyCredentialParameters();

  explicit inline PublicKeyCredentialParameters(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline PublicKeyCredentialParameters(const PublicKeyCredentialParameters& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  PublicKeyCredentialParameters&
  operator=(const PublicKeyCredentialParameters& aOther);

private:
  static bool
  InitIds(JSContext* cx, PublicKeyCredentialParametersAtoms* atomsCache);
};

namespace binding_detail {
struct FastPublicKeyCredentialParameters : public PublicKeyCredentialParameters
{
  inline FastPublicKeyCredentialParameters()
    : PublicKeyCredentialParameters(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct PublicKeyCredentialRequestOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Sequence<PublicKeyCredentialDescriptor> mAllowList;
  MOZ_INIT_OUTSIDE_CTOR OwningArrayBufferViewOrArrayBuffer mChallenge;
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mRpId;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mTimeout;

  PublicKeyCredentialRequestOptions();

  explicit inline PublicKeyCredentialRequestOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  PublicKeyCredentialRequestOptions(const PublicKeyCredentialRequestOptions&) = delete;
  PublicKeyCredentialRequestOptions& operator=(const PublicKeyCredentialRequestOptions&) = delete;

  static bool
  InitIds(JSContext* cx, PublicKeyCredentialRequestOptionsAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastPublicKeyCredentialRequestOptions : public PublicKeyCredentialRequestOptions
{
  inline FastPublicKeyCredentialRequestOptions()
    : PublicKeyCredentialRequestOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct PublicKeyCredentialUserEntity : public PublicKeyCredentialEntity
{
  MOZ_INIT_OUTSIDE_CTOR Optional<nsString> mDisplayName;

  PublicKeyCredentialUserEntity();

  explicit inline PublicKeyCredentialUserEntity(const FastDictionaryInitializer& )
    : PublicKeyCredentialEntity(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline PublicKeyCredentialUserEntity(const PublicKeyCredentialUserEntity& aOther)
  {
    *this = aOther;
  }

  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(const nsAString& aJSON);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  bool
  ToJSON(nsAString& aJSON) const;

  void
  TraceDictionary(JSTracer* trc);

  PublicKeyCredentialUserEntity&
  operator=(const PublicKeyCredentialUserEntity& aOther);

private:
  static bool
  InitIds(JSContext* cx, PublicKeyCredentialUserEntityAtoms* atomsCache);
};

namespace binding_detail {
struct FastPublicKeyCredentialUserEntity : public PublicKeyCredentialUserEntity
{
  inline FastPublicKeyCredentialUserEntity()
    : PublicKeyCredentialUserEntity(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct MakeCredentialOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR AuthenticatorSelectionCriteria mAuthenticatorSelection;
  MOZ_INIT_OUTSIDE_CTOR OwningArrayBufferViewOrArrayBuffer mChallenge;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<PublicKeyCredentialDescriptor>> mExcludeList;
  MOZ_INIT_OUTSIDE_CTOR Sequence<PublicKeyCredentialParameters> mParameters;
  MOZ_INIT_OUTSIDE_CTOR PublicKeyCredentialEntity mRp;
  MOZ_INIT_OUTSIDE_CTOR Optional<uint32_t> mTimeout;
  MOZ_INIT_OUTSIDE_CTOR PublicKeyCredentialUserEntity mUser;

  MakeCredentialOptions();

  explicit inline MakeCredentialOptions(const FastDictionaryInitializer& )
    : mAuthenticatorSelection(FastDictionaryInitializer()),
      mRp(FastDictionaryInitializer()),
      mUser(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  MakeCredentialOptions(const MakeCredentialOptions&) = delete;
  MakeCredentialOptions& operator=(const MakeCredentialOptions&) = delete;

  static bool
  InitIds(JSContext* cx, MakeCredentialOptionsAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastMakeCredentialOptions : public MakeCredentialOptions
{
  inline FastMakeCredentialOptions()
    : MakeCredentialOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace AuthenticatorAssertionResponseBinding {

  typedef mozilla::dom::AuthenticatorAssertionResponse NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::AuthenticatorAssertionResponse* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace AuthenticatorAssertionResponseBinding



namespace AuthenticatorAttestationResponseBinding {

  typedef mozilla::dom::AuthenticatorAttestationResponse NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::AuthenticatorAttestationResponse* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace AuthenticatorAttestationResponseBinding



namespace AuthenticatorResponseBinding {

  typedef mozilla::dom::AuthenticatorResponse NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::AuthenticatorResponse* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JSObject*
  GetProtoObject(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace AuthenticatorResponseBinding



namespace PublicKeyCredentialBinding {

  typedef mozilla::dom::PublicKeyCredential NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  JSObject*
  DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::PublicKeyCredential* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace PublicKeyCredentialBinding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_WebAuthenticationBinding_h
