/* THIS FILE IS AUTOGENERATED FROM WebExtensionPolicy.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_WebExtensionPolicyBinding_h
#define mozilla_dom_WebExtensionPolicyBinding_h

#include "WebExtensionContentScriptBinding.h"
#include "js/RootingAPI.h"
#include "jspubtd.h"
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/CallbackFunction.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/ToJSValue.h"
#include "mozilla/extensions/MatchGlob.h"
#include "mozilla/extensions/MatchPattern.h"

namespace mozilla {

namespace dom {

struct NativePropertyHooks;
class ProtoAndIfaceCache;
struct WebExtensionContentScriptInit;
struct WebExtensionInitAtoms;
class WebExtensionLocalizeCallback;

} // namespace dom

namespace extensions {

class MatchGlob;
class MatchPatternSet;
class WebExtensionPolicy;
struct WebExtensionPolicyAtoms;

} // namespace extensions

} // namespace mozilla

namespace mozilla {
namespace dom {

struct WebExtensionInit : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR OwningNonNull<mozilla::extensions::MatchPatternSet> mAllowedOrigins;
  MOZ_INIT_OUTSIDE_CTOR Nullable<Sequence<nsString>> mBackgroundScripts;
  MOZ_INIT_OUTSIDE_CTOR nsString mBaseURL;
  MOZ_INIT_OUTSIDE_CTOR Sequence<WebExtensionContentScriptInit> mContentScripts;
  MOZ_INIT_OUTSIDE_CTOR nsString mContentSecurityPolicy;
  MOZ_INIT_OUTSIDE_CTOR nsString mId;
  MOZ_INIT_OUTSIDE_CTOR OwningNonNull<WebExtensionLocalizeCallback> mLocalizeCallback;
  MOZ_INIT_OUTSIDE_CTOR nsCString mMozExtensionHostname;
  MOZ_INIT_OUTSIDE_CTOR nsString mName;
  MOZ_INIT_OUTSIDE_CTOR Sequence<nsString> mPermissions;
  MOZ_INIT_OUTSIDE_CTOR Sequence<OwningNonNull<mozilla::extensions::MatchGlob>> mWebAccessibleResources;

  WebExtensionInit();

  explicit inline WebExtensionInit(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  WebExtensionInit(const WebExtensionInit&) = delete;
  WebExtensionInit& operator=(const WebExtensionInit&) = delete;

  static bool
  InitIds(JSContext* cx, WebExtensionInitAtoms* atomsCache);

public:
  bool
  Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastWebExtensionInit : public WebExtensionInit
{
  inline FastWebExtensionInit()
    : WebExtensionInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class WebExtensionLocalizeCallback : public CallbackFunction
{
public:
  explicit inline WebExtensionLocalizeCallback(JSContext* aCx, JS::Handle<JSObject*> aCallback, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCx, aCallback, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(JS::Handle<JSObject*> aCallback, const FastCallbackConstructor& )
    : CallbackFunction(aCallback, FastCallbackConstructor())
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(JS::Handle<JSObject*> aCallback, JS::Handle<JSObject*> aAsyncStack, nsIGlobalObject* aIncumbentGlobal)
    : CallbackFunction(aCallback, aAsyncStack, aIncumbentGlobal)
  {
    MOZ_ASSERT(JS::IsCallable(mCallback));
  }

  explicit inline WebExtensionLocalizeCallback(CallbackFunction* aOther)
    : CallbackFunction(aOther)
  {
  }

  template <typename T>
  inline void
  Call(const T& thisVal, const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JSCompartment* aCompartment = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "WebExtensionLocalizeCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aCompartment);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    JS::Rooted<JS::Value> thisValJS(s.GetContext());
    if (!ToJSValue(s.GetContext(), thisVal, &thisValJS)) {
      aRv.Throw(NS_ERROR_FAILURE);
      return;
    }
    return Call(s.GetContext(), thisValJS, unlocalizedText, aRetVal, aRv);
  }

  inline void
  Call(const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv, const char* aExecutionReason = nullptr, ExceptionHandling aExceptionHandling = eReportExceptions, JSCompartment* aCompartment = nullptr)
  {
    MOZ_ASSERT(!aRv.Failed(), "Don't pass an already-failed ErrorResult to a callback!");
    if (!aExecutionReason) {
      aExecutionReason = "WebExtensionLocalizeCallback";
    }
    CallSetup s(this, aRv, aExecutionReason, aExceptionHandling, aCompartment);
    if (!s.GetContext()) {
      MOZ_ASSERT(aRv.Failed());
      return;
    }
    return Call(s.GetContext(), JS::UndefinedHandleValue, unlocalizedText, aRetVal, aRv);
  }

  template <typename T>
  inline void
  Call(const T& thisVal, const nsAString& unlocalizedText, nsString& aRetVal, const char* aExecutionReason = nullptr)
  {
    IgnoredErrorResult rv;
    return Call(thisVal, unlocalizedText, aRetVal, rv, aExecutionReason);
  }

  inline void
  Call(const nsAString& unlocalizedText, nsString& aRetVal, const char* aExecutionReason = nullptr)
  {
    IgnoredErrorResult rv;
    return Call(unlocalizedText, aRetVal, rv, aExecutionReason, eReportExceptions, nullptr);
  }

  inline bool
  operator==(const WebExtensionLocalizeCallback& aOther) const
  {
    return CallbackFunction::operator==(aOther);
  }

private:
  void Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& unlocalizedText, nsString& aRetVal, ErrorResult& aRv);
};


namespace binding_detail {
class FastWebExtensionLocalizeCallback : public WebExtensionLocalizeCallback
{
public:
  explicit inline FastWebExtensionLocalizeCallback(JS::Handle<JSObject*> aCallback)
    : WebExtensionLocalizeCallback(aCallback, FastCallbackConstructor())
  {
  }

  inline void
  Trace(JSTracer* aTracer)
  {
    WebExtensionLocalizeCallback::Trace(aTracer);
  }

  inline void
  FinishSlowJSInitIfMoreThanOneOwner(JSContext* aCx)
  {
    WebExtensionLocalizeCallback::FinishSlowJSInitIfMoreThanOneOwner(aCx);
  }
};
} // namespace binding_detail


namespace WebExtensionPolicyBinding {

  typedef mozilla::extensions::WebExtensionPolicy NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::extensions::WebExtensionPolicy* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  ClearCachedPermissionsValue(mozilla::extensions::WebExtensionPolicy* aObject);

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  JS::Handle<JSObject*>
  GetProtoObjectHandle(JSContext* aCx);

  JS::Handle<JSObject*>
  GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true);

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace WebExtensionPolicyBinding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_WebExtensionPolicyBinding_h
