/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIDOMEvent.idl
 */

#ifndef __gen_nsIDOMEvent_h__
#define __gen_nsIDOMEvent_h__


#ifndef __gen_domstubs_h__
#include "domstubs.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMEventTarget; /* forward declaration */

#ifdef ERROR
#undef ERROR
#endif
#include "mozilla/EventForwards.h"
class nsPresContext;
class nsInvalidateRequestList;
namespace IPC {
class Message;
}
class PickleIterator;
namespace mozilla {
namespace dom {
class Event;
class EventTarget;
} // namespace dom
} // namespace mozilla

/* starting interface:    nsIDOMEvent */
#define NS_IDOMEVENT_IID_STR "f58daacf-4d1a-4002-8fd7-06b614dfbcf6"

#define NS_IDOMEVENT_IID \
  {0xf58daacf, 0x4d1a, 0x4002, \
    { 0x8f, 0xd7, 0x06, 0xb6, 0x14, 0xdf, 0xbc, 0xf6 }}

class NS_NO_VTABLE nsIDOMEvent : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IDOMEVENT_IID)

  enum {
    NONE = 0U,
    CAPTURING_PHASE = 1U,
    AT_TARGET = 2U,
    BUBBLING_PHASE = 3U
  };

  /* readonly attribute DOMString type; */
  NS_IMETHOD GetType(nsAString & aType) = 0;

  /* readonly attribute nsIDOMEventTarget target; */
  NS_IMETHOD GetTarget(nsIDOMEventTarget * *aTarget) = 0;

  /* readonly attribute nsIDOMEventTarget currentTarget; */
  NS_IMETHOD GetCurrentTarget(nsIDOMEventTarget * *aCurrentTarget) = 0;

  /* readonly attribute unsigned short eventPhase; */
  NS_IMETHOD GetEventPhase(uint16_t *aEventPhase) = 0;

  /* readonly attribute boolean bubbles; */
  NS_IMETHOD GetBubbles(bool *aBubbles) = 0;

  /* readonly attribute boolean cancelable; */
  NS_IMETHOD GetCancelable(bool *aCancelable) = 0;

  /* readonly attribute DOMTimeStamp timeStamp; */
  NS_IMETHOD GetTimeStamp(DOMTimeStamp *aTimeStamp) = 0;

  /* void stopPropagation (); */
  NS_IMETHOD StopPropagation(void) = 0;

  /* void preventDefault (); */
  NS_IMETHOD PreventDefault(void) = 0;

  /* [nostdcall,notxpcom] void initEvent (in DOMString eventTypeArg, in boolean canBubbleArg, in boolean cancelableArg); */
  virtual void InitEvent(const nsAString & eventTypeArg, bool canBubbleArg, bool cancelableArg) = 0;

  /* readonly attribute boolean defaultPrevented; */
  NS_IMETHOD GetDefaultPrevented(bool *aDefaultPrevented) = 0;

  /* void stopImmediatePropagation (); */
  NS_IMETHOD StopImmediatePropagation(void) = 0;

  enum {
    ALT_MASK = 1,
    CONTROL_MASK = 2,
    SHIFT_MASK = 4,
    META_MASK = 8
  };

  /* readonly attribute nsIDOMEventTarget originalTarget; */
  NS_IMETHOD GetOriginalTarget(nsIDOMEventTarget * *aOriginalTarget) = 0;

  /* readonly attribute nsIDOMEventTarget explicitOriginalTarget; */
  NS_IMETHOD GetExplicitOriginalTarget(nsIDOMEventTarget * *aExplicitOriginalTarget) = 0;

  /* boolean getPreventDefault (); */
  NS_IMETHOD GetPreventDefault(bool *_retval) = 0;

  /* readonly attribute boolean isTrusted; */
  NS_IMETHOD GetIsTrusted(bool *aIsTrusted) = 0;

  /* attribute boolean cancelBubble; */
  NS_IMETHOD GetCancelBubble(bool *aCancelBubble) = 0;
  NS_IMETHOD SetCancelBubble(bool aCancelBubble) = 0;

  /* [noscript] void duplicatePrivateData (); */
  NS_IMETHOD DuplicatePrivateData(void) = 0;

  /* [noscript] void setTarget (in nsIDOMEventTarget aTarget); */
  NS_IMETHOD SetTarget(nsIDOMEventTarget *aTarget) = 0;

  /* [notxpcom] boolean IsDispatchStopped (); */
  NS_IMETHOD_(bool) IsDispatchStopped(void) = 0;

  /* [notxpcom] WidgetEvent WidgetEventPtr (); */
  NS_IMETHOD_(mozilla::WidgetEvent *) WidgetEventPtr(void) = 0;

  /* [noscript,notxpcom] void SetTrusted (in boolean aTrusted); */
  NS_IMETHOD_(void) SetTrusted(bool aTrusted) = 0;

  /* [notxpcom] void Serialize (in IPCMessagePtr aMsg, in boolean aSerializeInterfaceType); */
  NS_IMETHOD_(void) Serialize(IPC::Message *aMsg, bool aSerializeInterfaceType) = 0;

  /* [notxpcom] boolean Deserialize (in ConstIPCMessagePtr aMsg, in PickleIterator aIter); */
  NS_IMETHOD_(bool) Deserialize(const IPC::Message *aMsg, PickleIterator *aIter) = 0;

  /* [noscript,notxpcom] void SetOwner (in EventTargetPtr aOwner); */
  NS_IMETHOD_(void) SetOwner(mozilla::dom::EventTarget *aOwner) = 0;

  /* [notxpcom] DOMEventPtr InternalDOMEvent (); */
  NS_IMETHOD_(mozilla::dom::Event *) InternalDOMEvent(void) = 0;

  /* [noscript] void stopCrossProcessForwarding (); */
  NS_IMETHOD StopCrossProcessForwarding(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIDOMEvent, NS_IDOMEVENT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIDOMEVENT \
  NS_IMETHOD GetType(nsAString & aType) override; \
  NS_IMETHOD GetTarget(nsIDOMEventTarget * *aTarget) override; \
  NS_IMETHOD GetCurrentTarget(nsIDOMEventTarget * *aCurrentTarget) override; \
  NS_IMETHOD GetEventPhase(uint16_t *aEventPhase) override; \
  NS_IMETHOD GetBubbles(bool *aBubbles) override; \
  NS_IMETHOD GetCancelable(bool *aCancelable) override; \
  NS_IMETHOD GetTimeStamp(DOMTimeStamp *aTimeStamp) override; \
  NS_IMETHOD StopPropagation(void) override; \
  NS_IMETHOD PreventDefault(void) override; \
  virtual void InitEvent(const nsAString & eventTypeArg, bool canBubbleArg, bool cancelableArg) override; \
  NS_IMETHOD GetDefaultPrevented(bool *aDefaultPrevented) override; \
  NS_IMETHOD StopImmediatePropagation(void) override; \
  NS_IMETHOD GetOriginalTarget(nsIDOMEventTarget * *aOriginalTarget) override; \
  NS_IMETHOD GetExplicitOriginalTarget(nsIDOMEventTarget * *aExplicitOriginalTarget) override; \
  NS_IMETHOD GetPreventDefault(bool *_retval) override; \
  NS_IMETHOD GetIsTrusted(bool *aIsTrusted) override; \
  NS_IMETHOD GetCancelBubble(bool *aCancelBubble) override; \
  NS_IMETHOD SetCancelBubble(bool aCancelBubble) override; \
  NS_IMETHOD DuplicatePrivateData(void) override; \
  NS_IMETHOD SetTarget(nsIDOMEventTarget *aTarget) override; \
  NS_IMETHOD_(bool) IsDispatchStopped(void) override; \
  NS_IMETHOD_(mozilla::WidgetEvent *) WidgetEventPtr(void) override; \
  NS_IMETHOD_(void) SetTrusted(bool aTrusted) override; \
  NS_IMETHOD_(void) Serialize(IPC::Message *aMsg, bool aSerializeInterfaceType) override; \
  NS_IMETHOD_(bool) Deserialize(const IPC::Message *aMsg, PickleIterator *aIter) override; \
  NS_IMETHOD_(void) SetOwner(mozilla::dom::EventTarget *aOwner) override; \
  NS_IMETHOD_(mozilla::dom::Event *) InternalDOMEvent(void) override; \
  NS_IMETHOD StopCrossProcessForwarding(void) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIDOMEVENT \
  nsresult GetType(nsAString & aType); \
  nsresult GetTarget(nsIDOMEventTarget * *aTarget); \
  nsresult GetCurrentTarget(nsIDOMEventTarget * *aCurrentTarget); \
  nsresult GetEventPhase(uint16_t *aEventPhase); \
  nsresult GetBubbles(bool *aBubbles); \
  nsresult GetCancelable(bool *aCancelable); \
  nsresult GetTimeStamp(DOMTimeStamp *aTimeStamp); \
  nsresult StopPropagation(void); \
  nsresult PreventDefault(void); \
  void InitEvent(const nsAString & eventTypeArg, bool canBubbleArg, bool cancelableArg); \
  nsresult GetDefaultPrevented(bool *aDefaultPrevented); \
  nsresult StopImmediatePropagation(void); \
  nsresult GetOriginalTarget(nsIDOMEventTarget * *aOriginalTarget); \
  nsresult GetExplicitOriginalTarget(nsIDOMEventTarget * *aExplicitOriginalTarget); \
  nsresult GetPreventDefault(bool *_retval); \
  nsresult GetIsTrusted(bool *aIsTrusted); \
  nsresult GetCancelBubble(bool *aCancelBubble); \
  nsresult SetCancelBubble(bool aCancelBubble); \
  nsresult DuplicatePrivateData(void); \
  nsresult SetTarget(nsIDOMEventTarget *aTarget); \
  nsresult_(bool) IsDispatchStopped(void); \
  nsresult_(mozilla::WidgetEvent *) WidgetEventPtr(void); \
  nsresult_(void) SetTrusted(bool aTrusted); \
  nsresult_(void) Serialize(IPC::Message *aMsg, bool aSerializeInterfaceType); \
  nsresult_(bool) Deserialize(const IPC::Message *aMsg, PickleIterator *aIter); \
  nsresult_(void) SetOwner(mozilla::dom::EventTarget *aOwner); \
  nsresult_(mozilla::dom::Event *) InternalDOMEvent(void); \
  nsresult StopCrossProcessForwarding(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIDOMEVENT(_to) \
  NS_IMETHOD GetType(nsAString & aType) override { return _to GetType(aType); } \
  NS_IMETHOD GetTarget(nsIDOMEventTarget * *aTarget) override { return _to GetTarget(aTarget); } \
  NS_IMETHOD GetCurrentTarget(nsIDOMEventTarget * *aCurrentTarget) override { return _to GetCurrentTarget(aCurrentTarget); } \
  NS_IMETHOD GetEventPhase(uint16_t *aEventPhase) override { return _to GetEventPhase(aEventPhase); } \
  NS_IMETHOD GetBubbles(bool *aBubbles) override { return _to GetBubbles(aBubbles); } \
  NS_IMETHOD GetCancelable(bool *aCancelable) override { return _to GetCancelable(aCancelable); } \
  NS_IMETHOD GetTimeStamp(DOMTimeStamp *aTimeStamp) override { return _to GetTimeStamp(aTimeStamp); } \
  NS_IMETHOD StopPropagation(void) override { return _to StopPropagation(); } \
  NS_IMETHOD PreventDefault(void) override { return _to PreventDefault(); } \
  virtual void InitEvent(const nsAString & eventTypeArg, bool canBubbleArg, bool cancelableArg) override { return _to InitEvent(eventTypeArg, canBubbleArg, cancelableArg); } \
  NS_IMETHOD GetDefaultPrevented(bool *aDefaultPrevented) override { return _to GetDefaultPrevented(aDefaultPrevented); } \
  NS_IMETHOD StopImmediatePropagation(void) override { return _to StopImmediatePropagation(); } \
  NS_IMETHOD GetOriginalTarget(nsIDOMEventTarget * *aOriginalTarget) override { return _to GetOriginalTarget(aOriginalTarget); } \
  NS_IMETHOD GetExplicitOriginalTarget(nsIDOMEventTarget * *aExplicitOriginalTarget) override { return _to GetExplicitOriginalTarget(aExplicitOriginalTarget); } \
  NS_IMETHOD GetPreventDefault(bool *_retval) override { return _to GetPreventDefault(_retval); } \
  NS_IMETHOD GetIsTrusted(bool *aIsTrusted) override { return _to GetIsTrusted(aIsTrusted); } \
  NS_IMETHOD GetCancelBubble(bool *aCancelBubble) override { return _to GetCancelBubble(aCancelBubble); } \
  NS_IMETHOD SetCancelBubble(bool aCancelBubble) override { return _to SetCancelBubble(aCancelBubble); } \
  NS_IMETHOD DuplicatePrivateData(void) override { return _to DuplicatePrivateData(); } \
  NS_IMETHOD SetTarget(nsIDOMEventTarget *aTarget) override { return _to SetTarget(aTarget); } \
  NS_IMETHOD_(bool) IsDispatchStopped(void) override { return _to IsDispatchStopped(); } \
  NS_IMETHOD_(mozilla::WidgetEvent *) WidgetEventPtr(void) override { return _to WidgetEventPtr(); } \
  NS_IMETHOD_(void) SetTrusted(bool aTrusted) override { return _to SetTrusted(aTrusted); } \
  NS_IMETHOD_(void) Serialize(IPC::Message *aMsg, bool aSerializeInterfaceType) override { return _to Serialize(aMsg, aSerializeInterfaceType); } \
  NS_IMETHOD_(bool) Deserialize(const IPC::Message *aMsg, PickleIterator *aIter) override { return _to Deserialize(aMsg, aIter); } \
  NS_IMETHOD_(void) SetOwner(mozilla::dom::EventTarget *aOwner) override { return _to SetOwner(aOwner); } \
  NS_IMETHOD_(mozilla::dom::Event *) InternalDOMEvent(void) override { return _to InternalDOMEvent(); } \
  NS_IMETHOD StopCrossProcessForwarding(void) override { return _to StopCrossProcessForwarding(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIDOMEVENT(_to) \
  NS_IMETHOD GetType(nsAString & aType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetType(aType); } \
  NS_IMETHOD GetTarget(nsIDOMEventTarget * *aTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTarget(aTarget); } \
  NS_IMETHOD GetCurrentTarget(nsIDOMEventTarget * *aCurrentTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCurrentTarget(aCurrentTarget); } \
  NS_IMETHOD GetEventPhase(uint16_t *aEventPhase) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEventPhase(aEventPhase); } \
  NS_IMETHOD GetBubbles(bool *aBubbles) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBubbles(aBubbles); } \
  NS_IMETHOD GetCancelable(bool *aCancelable) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCancelable(aCancelable); } \
  NS_IMETHOD GetTimeStamp(DOMTimeStamp *aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTimeStamp(aTimeStamp); } \
  NS_IMETHOD StopPropagation(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StopPropagation(); } \
  NS_IMETHOD PreventDefault(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->PreventDefault(); } \
  virtual void InitEvent(const nsAString & eventTypeArg, bool canBubbleArg, bool cancelableArg) override; \
  NS_IMETHOD GetDefaultPrevented(bool *aDefaultPrevented) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDefaultPrevented(aDefaultPrevented); } \
  NS_IMETHOD StopImmediatePropagation(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StopImmediatePropagation(); } \
  NS_IMETHOD GetOriginalTarget(nsIDOMEventTarget * *aOriginalTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOriginalTarget(aOriginalTarget); } \
  NS_IMETHOD GetExplicitOriginalTarget(nsIDOMEventTarget * *aExplicitOriginalTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExplicitOriginalTarget(aExplicitOriginalTarget); } \
  NS_IMETHOD GetPreventDefault(bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPreventDefault(_retval); } \
  NS_IMETHOD GetIsTrusted(bool *aIsTrusted) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsTrusted(aIsTrusted); } \
  NS_IMETHOD GetCancelBubble(bool *aCancelBubble) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCancelBubble(aCancelBubble); } \
  NS_IMETHOD SetCancelBubble(bool aCancelBubble) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetCancelBubble(aCancelBubble); } \
  NS_IMETHOD DuplicatePrivateData(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DuplicatePrivateData(); } \
  NS_IMETHOD SetTarget(nsIDOMEventTarget *aTarget) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetTarget(aTarget); } \
  NS_IMETHOD_(bool) IsDispatchStopped(void) override; \
  NS_IMETHOD_(mozilla::WidgetEvent *) WidgetEventPtr(void) override; \
  NS_IMETHOD_(void) SetTrusted(bool aTrusted) override; \
  NS_IMETHOD_(void) Serialize(IPC::Message *aMsg, bool aSerializeInterfaceType) override; \
  NS_IMETHOD_(bool) Deserialize(const IPC::Message *aMsg, PickleIterator *aIter) override; \
  NS_IMETHOD_(void) SetOwner(mozilla::dom::EventTarget *aOwner) override; \
  NS_IMETHOD_(mozilla::dom::Event *) InternalDOMEvent(void) override; \
  NS_IMETHOD StopCrossProcessForwarding(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StopCrossProcessForwarding(); } 


#endif /* __gen_nsIDOMEvent_h__ */
