/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsINetworkInterceptController.idl
 */

#ifndef __gen_nsINetworkInterceptController_h__
#define __gen_nsINetworkInterceptController_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIContentPolicyBase_h__
#include "nsIContentPolicyBase.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIChannel; /* forward declaration */

class nsIConsoleReportCollector; /* forward declaration */

class nsIOutputStream; /* forward declaration */

class nsIURI; /* forward declaration */

#include "nsIConsoleReportCollector.h"
namespace mozilla {
class TimeStamp;
namespace dom {
class ChannelInfo;
}
}

/* starting interface:    nsIInterceptedChannel */
#define NS_IINTERCEPTEDCHANNEL_IID_STR "f4b82975-6a86-4cc4-87fe-9a1fd430c86d"

#define NS_IINTERCEPTEDCHANNEL_IID \
  {0xf4b82975, 0x6a86, 0x4cc4, \
    { 0x87, 0xfe, 0x9a, 0x1f, 0xd4, 0x30, 0xc8, 0x6d }}

class nsIInterceptedChannel : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IINTERCEPTEDCHANNEL_IID)

  /* void resetInterception (); */
  NS_IMETHOD ResetInterception(void) = 0;

  /* void synthesizeStatus (in uint16_t status, in ACString reason); */
  NS_IMETHOD SynthesizeStatus(uint16_t status, const nsACString & reason) = 0;

  /* void synthesizeHeader (in ACString name, in ACString value); */
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) = 0;

  /* void finishSynthesizedResponse (in ACString finalURLSpec); */
  NS_IMETHOD FinishSynthesizedResponse(const nsACString & finalURLSpec) = 0;

  /* void cancel (in nsresult status); */
  NS_IMETHOD Cancel(nsresult status) = 0;

  /* readonly attribute nsIOutputStream responseBody; */
  NS_IMETHOD GetResponseBody(nsIOutputStream * *aResponseBody) = 0;

  /* readonly attribute nsIChannel channel; */
  NS_IMETHOD GetChannel(nsIChannel * *aChannel) = 0;

  /* readonly attribute nsIURI secureUpgradedChannelURI; */
  NS_IMETHOD GetSecureUpgradedChannelURI(nsIURI * *aSecureUpgradedChannelURI) = 0;

  /* [noscript] void setChannelInfo (in ChannelInfo channelInfo); */
  NS_IMETHOD SetChannelInfo(mozilla::dom::ChannelInfo *channelInfo) = 0;

  /* [noscript] readonly attribute nsContentPolicyType internalContentPolicyType; */
  NS_IMETHOD GetInternalContentPolicyType(nsContentPolicyType *aInternalContentPolicyType) = 0;

  /* [noscript] readonly attribute nsIConsoleReportCollector consoleReportCollector; */
  NS_IMETHOD GetConsoleReportCollector(nsIConsoleReportCollector * *aConsoleReportCollector) = 0;

  /* [noscript] void SetLaunchServiceWorkerStart (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetLaunchServiceWorkerStart(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetLaunchServiceWorkerEnd (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetLaunchServiceWorkerEnd(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetDispatchFetchEventStart (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetDispatchFetchEventStart(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetDispatchFetchEventEnd (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetDispatchFetchEventEnd(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetHandleFetchEventStart (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetHandleFetchEventStart(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetHandleFetchEventEnd (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetHandleFetchEventEnd(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetFinishResponseStart (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetFinishResponseStart(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetFinishSynthesizedResponseEnd (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetFinishSynthesizedResponseEnd(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SetChannelResetEnd (in TimeStamp aTimeStamp); */
  NS_IMETHOD SetChannelResetEnd(mozilla::TimeStamp aTimeStamp) = 0;

  /* [noscript] void SaveTimeStamps (); */
  NS_IMETHOD SaveTimeStamps(void) = 0;

     already_AddRefed<nsIConsoleReportCollector>
    GetConsoleReportCollector()
    {
      nsCOMPtr<nsIConsoleReportCollector> reporter;
      GetConsoleReportCollector(getter_AddRefs(reporter));
      return reporter.forget();
    }
  /* [noscript] void setReleaseHandle (in nsISupports aHandle); */
  NS_IMETHOD SetReleaseHandle(nsISupports *aHandle) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIInterceptedChannel, NS_IINTERCEPTEDCHANNEL_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIINTERCEPTEDCHANNEL \
  NS_IMETHOD ResetInterception(void) override; \
  NS_IMETHOD SynthesizeStatus(uint16_t status, const nsACString & reason) override; \
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) override; \
  NS_IMETHOD FinishSynthesizedResponse(const nsACString & finalURLSpec) override; \
  NS_IMETHOD Cancel(nsresult status) override; \
  NS_IMETHOD GetResponseBody(nsIOutputStream * *aResponseBody) override; \
  NS_IMETHOD GetChannel(nsIChannel * *aChannel) override; \
  NS_IMETHOD GetSecureUpgradedChannelURI(nsIURI * *aSecureUpgradedChannelURI) override; \
  NS_IMETHOD SetChannelInfo(mozilla::dom::ChannelInfo *channelInfo) override; \
  NS_IMETHOD GetInternalContentPolicyType(nsContentPolicyType *aInternalContentPolicyType) override; \
  NS_IMETHOD GetConsoleReportCollector(nsIConsoleReportCollector * *aConsoleReportCollector) override; \
  NS_IMETHOD SetLaunchServiceWorkerStart(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetLaunchServiceWorkerEnd(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetDispatchFetchEventStart(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetDispatchFetchEventEnd(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetHandleFetchEventStart(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetHandleFetchEventEnd(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetFinishResponseStart(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetFinishSynthesizedResponseEnd(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SetChannelResetEnd(mozilla::TimeStamp aTimeStamp) override; \
  NS_IMETHOD SaveTimeStamps(void) override; \
  NS_IMETHOD SetReleaseHandle(nsISupports *aHandle) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIINTERCEPTEDCHANNEL \
  nsresult ResetInterception(void); \
  nsresult SynthesizeStatus(uint16_t status, const nsACString & reason); \
  nsresult SynthesizeHeader(const nsACString & name, const nsACString & value); \
  nsresult FinishSynthesizedResponse(const nsACString & finalURLSpec); \
  nsresult Cancel(nsresult status); \
  nsresult GetResponseBody(nsIOutputStream * *aResponseBody); \
  nsresult GetChannel(nsIChannel * *aChannel); \
  nsresult GetSecureUpgradedChannelURI(nsIURI * *aSecureUpgradedChannelURI); \
  nsresult SetChannelInfo(mozilla::dom::ChannelInfo *channelInfo); \
  nsresult GetInternalContentPolicyType(nsContentPolicyType *aInternalContentPolicyType); \
  nsresult GetConsoleReportCollector(nsIConsoleReportCollector * *aConsoleReportCollector); \
  nsresult SetLaunchServiceWorkerStart(mozilla::TimeStamp aTimeStamp); \
  nsresult SetLaunchServiceWorkerEnd(mozilla::TimeStamp aTimeStamp); \
  nsresult SetDispatchFetchEventStart(mozilla::TimeStamp aTimeStamp); \
  nsresult SetDispatchFetchEventEnd(mozilla::TimeStamp aTimeStamp); \
  nsresult SetHandleFetchEventStart(mozilla::TimeStamp aTimeStamp); \
  nsresult SetHandleFetchEventEnd(mozilla::TimeStamp aTimeStamp); \
  nsresult SetFinishResponseStart(mozilla::TimeStamp aTimeStamp); \
  nsresult SetFinishSynthesizedResponseEnd(mozilla::TimeStamp aTimeStamp); \
  nsresult SetChannelResetEnd(mozilla::TimeStamp aTimeStamp); \
  nsresult SaveTimeStamps(void); \
  nsresult SetReleaseHandle(nsISupports *aHandle); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIINTERCEPTEDCHANNEL(_to) \
  NS_IMETHOD ResetInterception(void) override { return _to ResetInterception(); } \
  NS_IMETHOD SynthesizeStatus(uint16_t status, const nsACString & reason) override { return _to SynthesizeStatus(status, reason); } \
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) override { return _to SynthesizeHeader(name, value); } \
  NS_IMETHOD FinishSynthesizedResponse(const nsACString & finalURLSpec) override { return _to FinishSynthesizedResponse(finalURLSpec); } \
  NS_IMETHOD Cancel(nsresult status) override { return _to Cancel(status); } \
  NS_IMETHOD GetResponseBody(nsIOutputStream * *aResponseBody) override { return _to GetResponseBody(aResponseBody); } \
  NS_IMETHOD GetChannel(nsIChannel * *aChannel) override { return _to GetChannel(aChannel); } \
  NS_IMETHOD GetSecureUpgradedChannelURI(nsIURI * *aSecureUpgradedChannelURI) override { return _to GetSecureUpgradedChannelURI(aSecureUpgradedChannelURI); } \
  NS_IMETHOD SetChannelInfo(mozilla::dom::ChannelInfo *channelInfo) override { return _to SetChannelInfo(channelInfo); } \
  NS_IMETHOD GetInternalContentPolicyType(nsContentPolicyType *aInternalContentPolicyType) override { return _to GetInternalContentPolicyType(aInternalContentPolicyType); } \
  NS_IMETHOD GetConsoleReportCollector(nsIConsoleReportCollector * *aConsoleReportCollector) override { return _to GetConsoleReportCollector(aConsoleReportCollector); } \
  NS_IMETHOD SetLaunchServiceWorkerStart(mozilla::TimeStamp aTimeStamp) override { return _to SetLaunchServiceWorkerStart(aTimeStamp); } \
  NS_IMETHOD SetLaunchServiceWorkerEnd(mozilla::TimeStamp aTimeStamp) override { return _to SetLaunchServiceWorkerEnd(aTimeStamp); } \
  NS_IMETHOD SetDispatchFetchEventStart(mozilla::TimeStamp aTimeStamp) override { return _to SetDispatchFetchEventStart(aTimeStamp); } \
  NS_IMETHOD SetDispatchFetchEventEnd(mozilla::TimeStamp aTimeStamp) override { return _to SetDispatchFetchEventEnd(aTimeStamp); } \
  NS_IMETHOD SetHandleFetchEventStart(mozilla::TimeStamp aTimeStamp) override { return _to SetHandleFetchEventStart(aTimeStamp); } \
  NS_IMETHOD SetHandleFetchEventEnd(mozilla::TimeStamp aTimeStamp) override { return _to SetHandleFetchEventEnd(aTimeStamp); } \
  NS_IMETHOD SetFinishResponseStart(mozilla::TimeStamp aTimeStamp) override { return _to SetFinishResponseStart(aTimeStamp); } \
  NS_IMETHOD SetFinishSynthesizedResponseEnd(mozilla::TimeStamp aTimeStamp) override { return _to SetFinishSynthesizedResponseEnd(aTimeStamp); } \
  NS_IMETHOD SetChannelResetEnd(mozilla::TimeStamp aTimeStamp) override { return _to SetChannelResetEnd(aTimeStamp); } \
  NS_IMETHOD SaveTimeStamps(void) override { return _to SaveTimeStamps(); } \
  NS_IMETHOD SetReleaseHandle(nsISupports *aHandle) override { return _to SetReleaseHandle(aHandle); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIINTERCEPTEDCHANNEL(_to) \
  NS_IMETHOD ResetInterception(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ResetInterception(); } \
  NS_IMETHOD SynthesizeStatus(uint16_t status, const nsACString & reason) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SynthesizeStatus(status, reason); } \
  NS_IMETHOD SynthesizeHeader(const nsACString & name, const nsACString & value) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SynthesizeHeader(name, value); } \
  NS_IMETHOD FinishSynthesizedResponse(const nsACString & finalURLSpec) override { return !_to ? NS_ERROR_NULL_POINTER : _to->FinishSynthesizedResponse(finalURLSpec); } \
  NS_IMETHOD Cancel(nsresult status) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Cancel(status); } \
  NS_IMETHOD GetResponseBody(nsIOutputStream * *aResponseBody) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetResponseBody(aResponseBody); } \
  NS_IMETHOD GetChannel(nsIChannel * *aChannel) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChannel(aChannel); } \
  NS_IMETHOD GetSecureUpgradedChannelURI(nsIURI * *aSecureUpgradedChannelURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSecureUpgradedChannelURI(aSecureUpgradedChannelURI); } \
  NS_IMETHOD SetChannelInfo(mozilla::dom::ChannelInfo *channelInfo) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetChannelInfo(channelInfo); } \
  NS_IMETHOD GetInternalContentPolicyType(nsContentPolicyType *aInternalContentPolicyType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInternalContentPolicyType(aInternalContentPolicyType); } \
  NS_IMETHOD GetConsoleReportCollector(nsIConsoleReportCollector * *aConsoleReportCollector) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConsoleReportCollector(aConsoleReportCollector); } \
  NS_IMETHOD SetLaunchServiceWorkerStart(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLaunchServiceWorkerStart(aTimeStamp); } \
  NS_IMETHOD SetLaunchServiceWorkerEnd(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLaunchServiceWorkerEnd(aTimeStamp); } \
  NS_IMETHOD SetDispatchFetchEventStart(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDispatchFetchEventStart(aTimeStamp); } \
  NS_IMETHOD SetDispatchFetchEventEnd(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDispatchFetchEventEnd(aTimeStamp); } \
  NS_IMETHOD SetHandleFetchEventStart(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHandleFetchEventStart(aTimeStamp); } \
  NS_IMETHOD SetHandleFetchEventEnd(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHandleFetchEventEnd(aTimeStamp); } \
  NS_IMETHOD SetFinishResponseStart(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFinishResponseStart(aTimeStamp); } \
  NS_IMETHOD SetFinishSynthesizedResponseEnd(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFinishSynthesizedResponseEnd(aTimeStamp); } \
  NS_IMETHOD SetChannelResetEnd(mozilla::TimeStamp aTimeStamp) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetChannelResetEnd(aTimeStamp); } \
  NS_IMETHOD SaveTimeStamps(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SaveTimeStamps(); } \
  NS_IMETHOD SetReleaseHandle(nsISupports *aHandle) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetReleaseHandle(aHandle); } 


/* starting interface:    nsINetworkInterceptController */
#define NS_INETWORKINTERCEPTCONTROLLER_IID_STR "70d2b4fe-a552-48cd-8d93-1d8437a56b53"

#define NS_INETWORKINTERCEPTCONTROLLER_IID \
  {0x70d2b4fe, 0xa552, 0x48cd, \
    { 0x8d, 0x93, 0x1d, 0x84, 0x37, 0xa5, 0x6b, 0x53 }}

class NS_NO_VTABLE nsINetworkInterceptController : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_INETWORKINTERCEPTCONTROLLER_IID)

  /* bool shouldPrepareForIntercept (in nsIURI aURI, in bool aIsNonSubresourceRequest); */
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool aIsNonSubresourceRequest, bool *_retval) = 0;

  /* void channelIntercepted (in nsIInterceptedChannel aChannel); */
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsINetworkInterceptController, NS_INETWORKINTERCEPTCONTROLLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSINETWORKINTERCEPTCONTROLLER \
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool aIsNonSubresourceRequest, bool *_retval) override; \
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSINETWORKINTERCEPTCONTROLLER \
  nsresult ShouldPrepareForIntercept(nsIURI *aURI, bool aIsNonSubresourceRequest, bool *_retval); \
  nsresult ChannelIntercepted(nsIInterceptedChannel *aChannel); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSINETWORKINTERCEPTCONTROLLER(_to) \
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool aIsNonSubresourceRequest, bool *_retval) override { return _to ShouldPrepareForIntercept(aURI, aIsNonSubresourceRequest, _retval); } \
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel) override { return _to ChannelIntercepted(aChannel); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSINETWORKINTERCEPTCONTROLLER(_to) \
  NS_IMETHOD ShouldPrepareForIntercept(nsIURI *aURI, bool aIsNonSubresourceRequest, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ShouldPrepareForIntercept(aURI, aIsNonSubresourceRequest, _retval); } \
  NS_IMETHOD ChannelIntercepted(nsIInterceptedChannel *aChannel) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ChannelIntercepted(aChannel); } 


#endif /* __gen_nsINetworkInterceptController_h__ */
