/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIObjectLoadingContent.idl
 */

#ifndef __gen_nsIObjectLoadingContent_h__
#define __gen_nsIObjectLoadingContent_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIRequest; /* forward declaration */

class nsIFrame; /* forward declaration */

class nsIObjectFrame; /* forward declaration */

class nsIPluginTag; /* forward declaration */

class nsIDOMElement; /* forward declaration */

class nsIDOMClientRect; /* forward declaration */

class nsIURI; /* forward declaration */

class nsNPAPIPluginInstance;

/* starting interface:    nsIObjectLoadingContent */
#define NS_IOBJECTLOADINGCONTENT_IID_STR "2eb3195e-3eea-4083-bb1d-d2d70fa35ccb"

#define NS_IOBJECTLOADINGCONTENT_IID \
  {0x2eb3195e, 0x3eea, 0x4083, \
    { 0xbb, 0x1d, 0xd2, 0xd7, 0x0f, 0xa3, 0x5c, 0xcb }}

class NS_NO_VTABLE nsIObjectLoadingContent : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IOBJECTLOADINGCONTENT_IID)

  enum {
    TYPE_LOADING = 0U,
    TYPE_IMAGE = 1U,
    TYPE_PLUGIN = 2U,
    TYPE_FAKE_PLUGIN = 3U,
    TYPE_DOCUMENT = 4U,
    TYPE_NULL = 5U,
    PLUGIN_ACTIVE = 255U,
    PLUGIN_UNSUPPORTED = 0U,
    PLUGIN_ALTERNATE = 1U,
    PLUGIN_DISABLED = 2U,
    PLUGIN_BLOCKLISTED = 3U,
    PLUGIN_OUTDATED = 4U,
    PLUGIN_CRASHED = 5U,
    PLUGIN_SUPPRESSED = 6U,
    PLUGIN_USER_DISABLED = 7U,
    PLUGIN_CLICK_TO_PLAY = 8U,
    PLUGIN_VULNERABLE_UPDATABLE = 9U,
    PLUGIN_VULNERABLE_NO_UPDATE = 10U
  };

  /* readonly attribute ACString actualType; */
  NS_IMETHOD GetActualType(nsACString & aActualType) = 0;

  /* readonly attribute unsigned long displayedType; */
  NS_IMETHOD GetDisplayedType(uint32_t *aDisplayedType) = 0;

  /* unsigned long getContentTypeForMIMEType (in AUTF8String aMimeType); */
  NS_IMETHOD GetContentTypeForMIMEType(const nsACString & aMimeType, uint32_t *_retval) = 0;

  /* [noscript] readonly attribute nsIURI baseURI; */
  NS_IMETHOD GetBaseURI(nsIURI * *aBaseURI) = 0;

  /* [noscript] readonly attribute nsNPAPIPluginInstancePtr pluginInstance; */
  NS_IMETHOD GetPluginInstance(nsNPAPIPluginInstance **aPluginInstance) = 0;

  /* [noscript] void hasNewFrame (in nsIObjectFrame aFrame); */
  NS_IMETHOD HasNewFrame(nsIObjectFrame *aFrame) = 0;

  /* [noscript] nsIFrame getPrintFrame (); */
  NS_IMETHOD GetPrintFrame(nsIFrame * *_retval) = 0;

  /* [noscript] void pluginDestroyed (); */
  NS_IMETHOD PluginDestroyed(void) = 0;

  /* [noscript] void pluginCrashed (in nsIPluginTag pluginTag, in AString pluginDumpID, in AString browserDumpID, in boolean submittedCrashReport); */
  NS_IMETHOD PluginCrashed(nsIPluginTag *pluginTag, const nsAString & pluginDumpID, const nsAString & browserDumpID, bool submittedCrashReport) = 0;

  /* void reload (in boolean aClearActivation); */
  NS_IMETHOD Reload(bool aClearActivation) = 0;

  /* readonly attribute boolean activated; */
  NS_IMETHOD GetActivated(bool *aActivated) = 0;

  /* [noscript] void stopPluginInstance (); */
  NS_IMETHOD StopPluginInstance(void) = 0;

  /* [noscript] void syncStartPluginInstance (); */
  NS_IMETHOD SyncStartPluginInstance(void) = 0;

  /* [noscript] void asyncStartPluginInstance (); */
  NS_IMETHOD AsyncStartPluginInstance(void) = 0;

  /* [noscript] void initializeFromChannel (in nsIRequest request); */
  NS_IMETHOD InitializeFromChannel(nsIRequest *request) = 0;

  /* readonly attribute nsIURI srcURI; */
  NS_IMETHOD GetSrcURI(nsIURI * *aSrcURI) = 0;

  /* void skipFakePlugins (); */
  NS_IMETHOD SkipFakePlugins(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIObjectLoadingContent, NS_IOBJECTLOADINGCONTENT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIOBJECTLOADINGCONTENT \
  NS_IMETHOD GetActualType(nsACString & aActualType) override; \
  NS_IMETHOD GetDisplayedType(uint32_t *aDisplayedType) override; \
  NS_IMETHOD GetContentTypeForMIMEType(const nsACString & aMimeType, uint32_t *_retval) override; \
  NS_IMETHOD GetBaseURI(nsIURI * *aBaseURI) override; \
  NS_IMETHOD GetPluginInstance(nsNPAPIPluginInstance **aPluginInstance) override; \
  NS_IMETHOD HasNewFrame(nsIObjectFrame *aFrame) override; \
  NS_IMETHOD GetPrintFrame(nsIFrame * *_retval) override; \
  NS_IMETHOD PluginDestroyed(void) override; \
  NS_IMETHOD PluginCrashed(nsIPluginTag *pluginTag, const nsAString & pluginDumpID, const nsAString & browserDumpID, bool submittedCrashReport) override; \
  NS_IMETHOD Reload(bool aClearActivation) override; \
  NS_IMETHOD GetActivated(bool *aActivated) override; \
  NS_IMETHOD StopPluginInstance(void) override; \
  NS_IMETHOD SyncStartPluginInstance(void) override; \
  NS_IMETHOD AsyncStartPluginInstance(void) override; \
  NS_IMETHOD InitializeFromChannel(nsIRequest *request) override; \
  NS_IMETHOD GetSrcURI(nsIURI * *aSrcURI) override; \
  NS_IMETHOD SkipFakePlugins(void) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIOBJECTLOADINGCONTENT \
  nsresult GetActualType(nsACString & aActualType); \
  nsresult GetDisplayedType(uint32_t *aDisplayedType); \
  nsresult GetContentTypeForMIMEType(const nsACString & aMimeType, uint32_t *_retval); \
  nsresult GetBaseURI(nsIURI * *aBaseURI); \
  nsresult GetPluginInstance(nsNPAPIPluginInstance **aPluginInstance); \
  nsresult HasNewFrame(nsIObjectFrame *aFrame); \
  nsresult GetPrintFrame(nsIFrame * *_retval); \
  nsresult PluginDestroyed(void); \
  nsresult PluginCrashed(nsIPluginTag *pluginTag, const nsAString & pluginDumpID, const nsAString & browserDumpID, bool submittedCrashReport); \
  nsresult Reload(bool aClearActivation); \
  nsresult GetActivated(bool *aActivated); \
  nsresult StopPluginInstance(void); \
  nsresult SyncStartPluginInstance(void); \
  nsresult AsyncStartPluginInstance(void); \
  nsresult InitializeFromChannel(nsIRequest *request); \
  nsresult GetSrcURI(nsIURI * *aSrcURI); \
  nsresult SkipFakePlugins(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIOBJECTLOADINGCONTENT(_to) \
  NS_IMETHOD GetActualType(nsACString & aActualType) override { return _to GetActualType(aActualType); } \
  NS_IMETHOD GetDisplayedType(uint32_t *aDisplayedType) override { return _to GetDisplayedType(aDisplayedType); } \
  NS_IMETHOD GetContentTypeForMIMEType(const nsACString & aMimeType, uint32_t *_retval) override { return _to GetContentTypeForMIMEType(aMimeType, _retval); } \
  NS_IMETHOD GetBaseURI(nsIURI * *aBaseURI) override { return _to GetBaseURI(aBaseURI); } \
  NS_IMETHOD GetPluginInstance(nsNPAPIPluginInstance **aPluginInstance) override { return _to GetPluginInstance(aPluginInstance); } \
  NS_IMETHOD HasNewFrame(nsIObjectFrame *aFrame) override { return _to HasNewFrame(aFrame); } \
  NS_IMETHOD GetPrintFrame(nsIFrame * *_retval) override { return _to GetPrintFrame(_retval); } \
  NS_IMETHOD PluginDestroyed(void) override { return _to PluginDestroyed(); } \
  NS_IMETHOD PluginCrashed(nsIPluginTag *pluginTag, const nsAString & pluginDumpID, const nsAString & browserDumpID, bool submittedCrashReport) override { return _to PluginCrashed(pluginTag, pluginDumpID, browserDumpID, submittedCrashReport); } \
  NS_IMETHOD Reload(bool aClearActivation) override { return _to Reload(aClearActivation); } \
  NS_IMETHOD GetActivated(bool *aActivated) override { return _to GetActivated(aActivated); } \
  NS_IMETHOD StopPluginInstance(void) override { return _to StopPluginInstance(); } \
  NS_IMETHOD SyncStartPluginInstance(void) override { return _to SyncStartPluginInstance(); } \
  NS_IMETHOD AsyncStartPluginInstance(void) override { return _to AsyncStartPluginInstance(); } \
  NS_IMETHOD InitializeFromChannel(nsIRequest *request) override { return _to InitializeFromChannel(request); } \
  NS_IMETHOD GetSrcURI(nsIURI * *aSrcURI) override { return _to GetSrcURI(aSrcURI); } \
  NS_IMETHOD SkipFakePlugins(void) override { return _to SkipFakePlugins(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIOBJECTLOADINGCONTENT(_to) \
  NS_IMETHOD GetActualType(nsACString & aActualType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActualType(aActualType); } \
  NS_IMETHOD GetDisplayedType(uint32_t *aDisplayedType) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDisplayedType(aDisplayedType); } \
  NS_IMETHOD GetContentTypeForMIMEType(const nsACString & aMimeType, uint32_t *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContentTypeForMIMEType(aMimeType, _retval); } \
  NS_IMETHOD GetBaseURI(nsIURI * *aBaseURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBaseURI(aBaseURI); } \
  NS_IMETHOD GetPluginInstance(nsNPAPIPluginInstance **aPluginInstance) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPluginInstance(aPluginInstance); } \
  NS_IMETHOD HasNewFrame(nsIObjectFrame *aFrame) override { return !_to ? NS_ERROR_NULL_POINTER : _to->HasNewFrame(aFrame); } \
  NS_IMETHOD GetPrintFrame(nsIFrame * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPrintFrame(_retval); } \
  NS_IMETHOD PluginDestroyed(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->PluginDestroyed(); } \
  NS_IMETHOD PluginCrashed(nsIPluginTag *pluginTag, const nsAString & pluginDumpID, const nsAString & browserDumpID, bool submittedCrashReport) override { return !_to ? NS_ERROR_NULL_POINTER : _to->PluginCrashed(pluginTag, pluginDumpID, browserDumpID, submittedCrashReport); } \
  NS_IMETHOD Reload(bool aClearActivation) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Reload(aClearActivation); } \
  NS_IMETHOD GetActivated(bool *aActivated) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActivated(aActivated); } \
  NS_IMETHOD StopPluginInstance(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->StopPluginInstance(); } \
  NS_IMETHOD SyncStartPluginInstance(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SyncStartPluginInstance(); } \
  NS_IMETHOD AsyncStartPluginInstance(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncStartPluginInstance(); } \
  NS_IMETHOD InitializeFromChannel(nsIRequest *request) override { return !_to ? NS_ERROR_NULL_POINTER : _to->InitializeFromChannel(request); } \
  NS_IMETHOD GetSrcURI(nsIURI * *aSrcURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSrcURI(aSrcURI); } \
  NS_IMETHOD SkipFakePlugins(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SkipFakePlugins(); } 


#endif /* __gen_nsIObjectLoadingContent_h__ */
