/* THIS FILE IS AUTOGENERATED FROM KeyboardEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "KeyboardEventBinding.h"
#include "UIEventBinding.h"
#include "WrapperFactory.h"
#include "XrayWrapper.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/KeyboardEvent.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "mozilla/dom/SimpleGlobalObject.h"
#include "mozilla/dom/XrayExpandoClass.h"
#include "nsContentUtils.h"
#include "nsGlobalWindow.h"

namespace mozilla {
namespace dom {


KeyboardEventInit::KeyboardEventInit()
  : EventModifierInit(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
KeyboardEventInit::InitIds(JSContext* cx, KeyboardEventInitAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->which_id.init(cx, "which") ||
      !atomsCache->repeat_id.init(cx, "repeat") ||
      !atomsCache->location_id.init(cx, "location") ||
      !atomsCache->keyCode_id.init(cx, "keyCode") ||
      !atomsCache->key_id.init(cx, "key") ||
      !atomsCache->isComposing_id.init(cx, "isComposing") ||
      !atomsCache->code_id.init(cx, "code") ||
      !atomsCache->charCode_id.init(cx, "charCode")) {
    return false;
  }
  return true;
}

bool
KeyboardEventInit::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  KeyboardEventInitAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<KeyboardEventInitAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!EventModifierInit::Init(cx, val)) {
    return false;
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->charCode_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mCharCode)) {
      return false;
    }
  } else {
    mCharCode = 0U;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->code_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mCode)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mCode.Rebind(data, ArrayLength(data) - 1);
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->isComposing_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &mIsComposing)) {
      return false;
    }
  } else {
    mIsComposing = false;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->key_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mKey)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    mKey.Rebind(data, ArrayLength(data) - 1);
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->keyCode_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mKeyCode)) {
      return false;
    }
  } else {
    mKeyCode = 0U;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->location_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mLocation)) {
      return false;
    }
  } else {
    mLocation = 0U;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->repeat_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &mRepeat)) {
      return false;
    }
  } else {
    mRepeat = false;
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->which_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &mWhich)) {
      return false;
    }
  } else {
    mWhich = 0U;
  }
  mIsAnyMemberPresent = true;
  return true;
}

bool
KeyboardEventInit::Init(const nsAString& aJSON)
{
  AutoJSAPI jsapi;
  JSObject* cleanGlobal = SimpleGlobalObject::Create(SimpleGlobalObject::GlobalType::BindingDetail);
  if (!cleanGlobal) {
    return false;
  }
  if (!jsapi.Init(cleanGlobal)) {
    return false;
  }
  JSContext* cx = jsapi.cx();
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
KeyboardEventInit::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  KeyboardEventInitAtoms* atomsCache = GetAtomCache<KeyboardEventInitAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!EventModifierInit::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mCharCode;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->charCode_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mCode;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->code_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    bool const & currentValue = mIsComposing;
    temp.setBoolean(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->isComposing_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mKey;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->key_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mKeyCode;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->keyCode_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mLocation;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->location_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    bool const & currentValue = mRepeat;
    temp.setBoolean(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->repeat_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint32_t const & currentValue = mWhich;
    temp.setNumber(currentValue);
    if (!JS_DefinePropertyById(cx, obj, atomsCache->which_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
KeyboardEventInit::ToJSON(nsAString& aJSON) const
{
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  // It's safe to use UnprivilegedJunkScopeOrWorkerGlobal here
  // because we'll only be creating objects, in ways that have no
  // side-effects, followed by a call to JS::ToJSONMaybeSafely,
  // which likewise guarantees no side-effects for the sorts of
  // things we will pass it.
  JSAutoCompartment ac(cx, binding_detail::UnprivilegedJunkScopeOrWorkerGlobal());
  JS::Rooted<JS::Value> val(cx);
  if (!ToObjectInternal(cx, &val)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &val.toObject());
  return StringifyToJSON(cx, obj, aJSON);
}

void
KeyboardEventInit::TraceDictionary(JSTracer* trc)
{
  EventModifierInit::TraceDictionary(trc);
}

KeyboardEventInit&
KeyboardEventInit::operator=(const KeyboardEventInit& aOther)
{
  EventModifierInit::operator=(aOther);
  mCharCode = aOther.mCharCode;
  mCode = aOther.mCode;
  mIsComposing = aOther.mIsComposing;
  mKey = aOther.mKey;
  mKeyCode = aOther.mKeyCode;
  mLocation = aOther.mLocation;
  mRepeat = aOther.mRepeat;
  mWhich = aOther.mWhich;
  return *this;
}

namespace binding_detail {
} // namespace binding_detail


namespace KeyboardEventBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<UIEventBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
isInstance(JSContext* cx, unsigned argc, JS::Value* vp)
{
  return InterfaceIsInstance(cx, argc, vp, prototypes::id::KeyboardEvent,
                             PrototypeTraits<prototypes::id::KeyboardEvent>::Depth);
}

static bool
get_charCode(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  uint32_t result(self->CharCode());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo charCode_getterinfo = {
  { (JSJitGetterOp)get_charCode },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_keyCode(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  uint32_t result(self->KeyCode());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo keyCode_getterinfo = {
  { (JSJitGetterOp)get_keyCode },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_altKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->AltKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo altKey_getterinfo = {
  { (JSJitGetterOp)get_altKey },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_ctrlKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->CtrlKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo ctrlKey_getterinfo = {
  { (JSJitGetterOp)get_ctrlKey },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_shiftKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->ShiftKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo shiftKey_getterinfo = {
  { (JSJitGetterOp)get_shiftKey },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_metaKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->MetaKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo metaKey_getterinfo = {
  { (JSJitGetterOp)get_metaKey },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
getModifierState(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent.getModifierState");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool result(self->GetModifierState(NonNullHelper(Constify(arg0))));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo getModifierState_methodinfo = {
  { (JSJitGetterOp)getModifierState },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_location(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  uint32_t result(self->Location());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setNumber(result);
  return true;
}

static const JSJitInfo location_getterinfo = {
  { (JSJitGetterOp)get_location },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_repeat(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->Repeat());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo repeat_getterinfo = {
  { (JSJitGetterOp)get_repeat },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_isComposing(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->IsComposing());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isComposing_getterinfo = {
  { (JSJitGetterOp)get_isComposing },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_key(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetKey(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo key_getterinfo = {
  { (JSJitGetterOp)get_key },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_code(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetCode(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo code_getterinfo = {
  { (JSJitGetterOp)get_code },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
initKeyboardEvent(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent.initKeyboardEvent");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool arg1;
  if (args.hasDefined(1)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
      return false;
    }
  } else {
    arg1 = false;
  }
  bool arg2;
  if (args.hasDefined(2)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[2], &arg2)) {
      return false;
    }
  } else {
    arg2 = false;
  }
  nsGlobalWindow* arg3;
  if (args.hasDefined(3)) {
    if (args[3].isObject()) {
      {
        nsresult rv = UnwrapObject<prototypes::id::Window, nsGlobalWindow>(args[3], arg3);
        if (NS_FAILED(rv)) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 4 of KeyboardEvent.initKeyboardEvent", "Window");
          return false;
        }
      }
    } else if (args[3].isNullOrUndefined()) {
      arg3 = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 4 of KeyboardEvent.initKeyboardEvent");
      return false;
    }
  } else {
    arg3 = nullptr;
  }
  binding_detail::FakeString arg4;
  if (args.hasDefined(4)) {
    if (!ConvertJSValueToString(cx, args[4], eStringify, eStringify, arg4)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 0 };
    arg4.Rebind(data, ArrayLength(data) - 1);
  }
  uint32_t arg5;
  if (args.hasDefined(5)) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[5], &arg5)) {
      return false;
    }
  } else {
    arg5 = 0U;
  }
  bool arg6;
  if (args.hasDefined(6)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[6], &arg6)) {
      return false;
    }
  } else {
    arg6 = false;
  }
  bool arg7;
  if (args.hasDefined(7)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[7], &arg7)) {
      return false;
    }
  } else {
    arg7 = false;
  }
  bool arg8;
  if (args.hasDefined(8)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[8], &arg8)) {
      return false;
    }
  } else {
    arg8 = false;
  }
  bool arg9;
  if (args.hasDefined(9)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[9], &arg9)) {
      return false;
    }
  } else {
    arg9 = false;
  }
  binding_detail::FastErrorResult rv;
  self->InitKeyboardEvent(NonNullHelper(Constify(arg0)), arg1, arg2, Constify(arg3), NonNullHelper(Constify(arg4)), arg5, arg6, arg7, arg8, arg9, rv);
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo initKeyboardEvent_methodinfo = {
  { (JSJitGetterOp)initKeyboardEvent },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_initDict(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  // Have to either root across the getter call or reget after.
  bool isXray;
  JS::Rooted<JSObject*> slotStorage(cx, GetCachedSlotStorageObject(cx, obj, &isXray));
  if (!slotStorage) {
    return false;
  }
  const size_t slotIndex = isXray ? (xpc::JSSLOT_EXPANDO_COUNT + 0) : (DOM_INSTANCE_RESERVED_SLOTS + 0);
  MOZ_ASSERT(JSCLASS_RESERVED_SLOTS(js::GetObjectClass(slotStorage)) > slotIndex);
  {
    // Scope for cachedVal
    JS::Value cachedVal = js::GetReservedSlot(slotStorage, slotIndex);
    if (!cachedVal.isUndefined()) {
      args.rval().set(cachedVal);
      // The cached value is in the compartment of slotStorage,
      // so wrap into the caller compartment as needed.
      return MaybeWrapNonDOMObjectValue(cx, args.rval());
    }
  }

  KeyboardEventInit result;
  self->GetInitDict(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  {
    JS::Rooted<JSObject*> conversionScope(cx, isXray ? obj : slotStorage);
    JSAutoCompartment ac(cx, conversionScope);
    do { // block we break out of when done wrapping
      if (!result.ToObjectInternal(cx, args.rval())) {
        return false;
      }
      break;
    } while (0);
  }
  { // And now store things in the compartment of our slotStorage.
    JSAutoCompartment ac(cx, slotStorage);
    // Make a copy so that we don't do unnecessary wrapping on args.rval().
    JS::Rooted<JS::Value> storedVal(cx, args.rval());
    if (!MaybeWrapNonDOMObjectValue(cx, &storedVal)) {
      return false;
    }
    js::SetReservedSlot(slotStorage, slotIndex, storedVal);
    if (!isXray) {
      // In the Xray case we don't need to do this, because getting the
      // expando object already preserved our wrapper.
      PreserveWrapper(self);
    }
  }
  // And now make sure args.rval() is in the caller compartment
  return MaybeWrapNonDOMObjectValue(cx, args.rval());
}

static const JSJitInfo initDict_getterinfo = {
  { (JSJitGetterOp)get_initDict },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasNone, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  true, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  (DOM_INSTANCE_RESERVED_SLOTS + 0)   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert((DOM_INSTANCE_RESERVED_SLOTS + 0) <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert((DOM_INSTANCE_RESERVED_SLOTS + 0) < 2, "There is no slot for us");

static bool
initKeyEvent(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent.initKeyEvent");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool arg1;
  if (args.hasDefined(1)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
      return false;
    }
  } else {
    arg1 = false;
  }
  bool arg2;
  if (args.hasDefined(2)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[2], &arg2)) {
      return false;
    }
  } else {
    arg2 = false;
  }
  nsGlobalWindow* arg3;
  if (args.hasDefined(3)) {
    if (args[3].isObject()) {
      {
        nsresult rv = UnwrapObject<prototypes::id::Window, nsGlobalWindow>(args[3], arg3);
        if (NS_FAILED(rv)) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 4 of KeyboardEvent.initKeyEvent", "Window");
          return false;
        }
      }
    } else if (args[3].isNullOrUndefined()) {
      arg3 = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 4 of KeyboardEvent.initKeyEvent");
      return false;
    }
  } else {
    arg3 = nullptr;
  }
  bool arg4;
  if (args.hasDefined(4)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[4], &arg4)) {
      return false;
    }
  } else {
    arg4 = false;
  }
  bool arg5;
  if (args.hasDefined(5)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[5], &arg5)) {
      return false;
    }
  } else {
    arg5 = false;
  }
  bool arg6;
  if (args.hasDefined(6)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[6], &arg6)) {
      return false;
    }
  } else {
    arg6 = false;
  }
  bool arg7;
  if (args.hasDefined(7)) {
    if (!ValueToPrimitive<bool, eDefault>(cx, args[7], &arg7)) {
      return false;
    }
  } else {
    arg7 = false;
  }
  uint32_t arg8;
  if (args.hasDefined(8)) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[8], &arg8)) {
      return false;
    }
  } else {
    arg8 = 0U;
  }
  uint32_t arg9;
  if (args.hasDefined(9)) {
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[9], &arg9)) {
      return false;
    }
  } else {
    arg9 = 0U;
  }
  self->InitKeyEvent(NonNullHelper(Constify(arg0)), arg1, arg2, Constify(arg3), arg4, arg5, arg6, arg7, arg8, arg9);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo initKeyEvent_methodinfo = {
  { (JSJitGetterOp)initKeyEvent },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
get_isTrusted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::KeyboardEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->IsTrusted());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isTrusted_getterinfo = {
  { (JSJitGetterOp)get_isTrusted },
  { prototypes::id::KeyboardEvent },
  { PrototypeTraits<prototypes::id::KeyboardEvent>::Depth },
  JSJitInfo::Getter,
  JSJitInfo::AliasDOMSets, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static_assert(0 < 2, "There is no slot for us");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::KeyboardEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::KeyboardEvent>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::KeyboardEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::KeyboardEvent>(obj);
  if (self) {
    ClearWrapper(self, self, obj);
    AddForDeferredFinalization<mozilla::dom::KeyboardEvent>(self);
  }
}

static size_t
_objectMoved(JSObject* obj, JSObject* old)
{
  mozilla::dom::KeyboardEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::KeyboardEvent>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }

  return 0;
}

// We deliberately use brace-elision to make Visual Studio produce better initalization code.
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wmissing-braces"
#endif
static const JSFunctionSpec sChromeStaticMethods_specs[] = {
  JS_FNSPEC("isInstance", isInstance, nullptr, 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};
#if defined(__clang__)
#pragma clang diagnostic pop
#endif


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sChromeStaticMethods[] = {
  { nullptr, &sChromeStaticMethods_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");

// We deliberately use brace-elision to make Visual Studio produce better initalization code.
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wmissing-braces"
#endif
static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getModifierState", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getModifierState_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("initKeyboardEvent", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&initKeyboardEvent_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("initKeyEvent", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&initKeyEvent_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};
#if defined(__clang__)
#pragma clang diagnostic pop
#endif


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { nullptr, &sMethods_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(3 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");

// We deliberately use brace-elision to make Visual Studio produce better initalization code.
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wmissing-braces"
#endif
static const JSPropertySpec sAttributes_specs[] = {
  { "charCode", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &charCode_getterinfo, nullptr, nullptr },
  { "keyCode", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &keyCode_getterinfo, nullptr, nullptr },
  { "altKey", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &altKey_getterinfo, nullptr, nullptr },
  { "ctrlKey", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &ctrlKey_getterinfo, nullptr, nullptr },
  { "shiftKey", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &shiftKey_getterinfo, nullptr, nullptr },
  { "metaKey", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &metaKey_getterinfo, nullptr, nullptr },
  { "location", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &location_getterinfo, nullptr, nullptr },
  { "repeat", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &repeat_getterinfo, nullptr, nullptr },
  { "isComposing", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &isComposing_getterinfo, nullptr, nullptr },
  { "key", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &key_getterinfo, nullptr, nullptr },
  { "code", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &code_getterinfo, nullptr, nullptr },
  { nullptr, 0, nullptr, nullptr, nullptr, nullptr }
};
#if defined(__clang__)
#pragma clang diagnostic pop
#endif


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { nullptr, &sAttributes_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(11 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");

// We deliberately use brace-elision to make Visual Studio produce better initalization code.
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wmissing-braces"
#endif
static const JSPropertySpec sChromeAttributes_specs[] = {
  { "initDict", JSPROP_SHARED | JSPROP_ENUMERATE, GenericBindingGetter, &initDict_getterinfo, nullptr, nullptr },
  { nullptr, 0, nullptr, nullptr, nullptr, nullptr }
};
#if defined(__clang__)
#pragma clang diagnostic pop
#endif


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sChromeAttributes[] = {
  { nullptr, &sChromeAttributes_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");

// We deliberately use brace-elision to make Visual Studio produce better initalization code.
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wmissing-braces"
#endif
static const JSPropertySpec sUnforgeableAttributes_specs[] = {
  { "isTrusted", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_PERMANENT, GenericBindingGetter, &isTrusted_getterinfo, nullptr, nullptr },
  { nullptr, 0, nullptr, nullptr, nullptr, nullptr }
};
#if defined(__clang__)
#pragma clang diagnostic pop
#endif


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sUnforgeableAttributes[] = {
  { nullptr, &sUnforgeableAttributes_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");

// We deliberately use brace-elision to make Visual Studio produce better initalization code.
#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wmissing-braces"
#endif
static const ConstantSpec sConstants_specs[] = {
  { "DOM_KEY_LOCATION_STANDARD", JS::NumberValue(0U) },
  { "DOM_KEY_LOCATION_LEFT", JS::NumberValue(1U) },
  { "DOM_KEY_LOCATION_RIGHT", JS::NumberValue(2U) },
  { "DOM_KEY_LOCATION_NUMPAD", JS::NumberValue(3U) },
  { "DOM_VK_CANCEL", JS::NumberValue(3U) },
  { "DOM_VK_HELP", JS::NumberValue(6U) },
  { "DOM_VK_BACK_SPACE", JS::NumberValue(8U) },
  { "DOM_VK_TAB", JS::NumberValue(9U) },
  { "DOM_VK_CLEAR", JS::NumberValue(12U) },
  { "DOM_VK_RETURN", JS::NumberValue(13U) },
  { "DOM_VK_SHIFT", JS::NumberValue(16U) },
  { "DOM_VK_CONTROL", JS::NumberValue(17U) },
  { "DOM_VK_ALT", JS::NumberValue(18U) },
  { "DOM_VK_PAUSE", JS::NumberValue(19U) },
  { "DOM_VK_CAPS_LOCK", JS::NumberValue(20U) },
  { "DOM_VK_KANA", JS::NumberValue(21U) },
  { "DOM_VK_HANGUL", JS::NumberValue(21U) },
  { "DOM_VK_EISU", JS::NumberValue(22U) },
  { "DOM_VK_JUNJA", JS::NumberValue(23U) },
  { "DOM_VK_FINAL", JS::NumberValue(24U) },
  { "DOM_VK_HANJA", JS::NumberValue(25U) },
  { "DOM_VK_KANJI", JS::NumberValue(25U) },
  { "DOM_VK_ESCAPE", JS::NumberValue(27U) },
  { "DOM_VK_CONVERT", JS::NumberValue(28U) },
  { "DOM_VK_NONCONVERT", JS::NumberValue(29U) },
  { "DOM_VK_ACCEPT", JS::NumberValue(30U) },
  { "DOM_VK_MODECHANGE", JS::NumberValue(31U) },
  { "DOM_VK_SPACE", JS::NumberValue(32U) },
  { "DOM_VK_PAGE_UP", JS::NumberValue(33U) },
  { "DOM_VK_PAGE_DOWN", JS::NumberValue(34U) },
  { "DOM_VK_END", JS::NumberValue(35U) },
  { "DOM_VK_HOME", JS::NumberValue(36U) },
  { "DOM_VK_LEFT", JS::NumberValue(37U) },
  { "DOM_VK_UP", JS::NumberValue(38U) },
  { "DOM_VK_RIGHT", JS::NumberValue(39U) },
  { "DOM_VK_DOWN", JS::NumberValue(40U) },
  { "DOM_VK_SELECT", JS::NumberValue(41U) },
  { "DOM_VK_PRINT", JS::NumberValue(42U) },
  { "DOM_VK_EXECUTE", JS::NumberValue(43U) },
  { "DOM_VK_PRINTSCREEN", JS::NumberValue(44U) },
  { "DOM_VK_INSERT", JS::NumberValue(45U) },
  { "DOM_VK_DELETE", JS::NumberValue(46U) },
  { "DOM_VK_0", JS::NumberValue(48U) },
  { "DOM_VK_1", JS::NumberValue(49U) },
  { "DOM_VK_2", JS::NumberValue(50U) },
  { "DOM_VK_3", JS::NumberValue(51U) },
  { "DOM_VK_4", JS::NumberValue(52U) },
  { "DOM_VK_5", JS::NumberValue(53U) },
  { "DOM_VK_6", JS::NumberValue(54U) },
  { "DOM_VK_7", JS::NumberValue(55U) },
  { "DOM_VK_8", JS::NumberValue(56U) },
  { "DOM_VK_9", JS::NumberValue(57U) },
  { "DOM_VK_COLON", JS::NumberValue(58U) },
  { "DOM_VK_SEMICOLON", JS::NumberValue(59U) },
  { "DOM_VK_LESS_THAN", JS::NumberValue(60U) },
  { "DOM_VK_EQUALS", JS::NumberValue(61U) },
  { "DOM_VK_GREATER_THAN", JS::NumberValue(62U) },
  { "DOM_VK_QUESTION_MARK", JS::NumberValue(63U) },
  { "DOM_VK_AT", JS::NumberValue(64U) },
  { "DOM_VK_A", JS::NumberValue(65U) },
  { "DOM_VK_B", JS::NumberValue(66U) },
  { "DOM_VK_C", JS::NumberValue(67U) },
  { "DOM_VK_D", JS::NumberValue(68U) },
  { "DOM_VK_E", JS::NumberValue(69U) },
  { "DOM_VK_F", JS::NumberValue(70U) },
  { "DOM_VK_G", JS::NumberValue(71U) },
  { "DOM_VK_H", JS::NumberValue(72U) },
  { "DOM_VK_I", JS::NumberValue(73U) },
  { "DOM_VK_J", JS::NumberValue(74U) },
  { "DOM_VK_K", JS::NumberValue(75U) },
  { "DOM_VK_L", JS::NumberValue(76U) },
  { "DOM_VK_M", JS::NumberValue(77U) },
  { "DOM_VK_N", JS::NumberValue(78U) },
  { "DOM_VK_O", JS::NumberValue(79U) },
  { "DOM_VK_P", JS::NumberValue(80U) },
  { "DOM_VK_Q", JS::NumberValue(81U) },
  { "DOM_VK_R", JS::NumberValue(82U) },
  { "DOM_VK_S", JS::NumberValue(83U) },
  { "DOM_VK_T", JS::NumberValue(84U) },
  { "DOM_VK_U", JS::NumberValue(85U) },
  { "DOM_VK_V", JS::NumberValue(86U) },
  { "DOM_VK_W", JS::NumberValue(87U) },
  { "DOM_VK_X", JS::NumberValue(88U) },
  { "DOM_VK_Y", JS::NumberValue(89U) },
  { "DOM_VK_Z", JS::NumberValue(90U) },
  { "DOM_VK_WIN", JS::NumberValue(91U) },
  { "DOM_VK_CONTEXT_MENU", JS::NumberValue(93U) },
  { "DOM_VK_SLEEP", JS::NumberValue(95U) },
  { "DOM_VK_NUMPAD0", JS::NumberValue(96U) },
  { "DOM_VK_NUMPAD1", JS::NumberValue(97U) },
  { "DOM_VK_NUMPAD2", JS::NumberValue(98U) },
  { "DOM_VK_NUMPAD3", JS::NumberValue(99U) },
  { "DOM_VK_NUMPAD4", JS::NumberValue(100U) },
  { "DOM_VK_NUMPAD5", JS::NumberValue(101U) },
  { "DOM_VK_NUMPAD6", JS::NumberValue(102U) },
  { "DOM_VK_NUMPAD7", JS::NumberValue(103U) },
  { "DOM_VK_NUMPAD8", JS::NumberValue(104U) },
  { "DOM_VK_NUMPAD9", JS::NumberValue(105U) },
  { "DOM_VK_MULTIPLY", JS::NumberValue(106U) },
  { "DOM_VK_ADD", JS::NumberValue(107U) },
  { "DOM_VK_SEPARATOR", JS::NumberValue(108U) },
  { "DOM_VK_SUBTRACT", JS::NumberValue(109U) },
  { "DOM_VK_DECIMAL", JS::NumberValue(110U) },
  { "DOM_VK_DIVIDE", JS::NumberValue(111U) },
  { "DOM_VK_F1", JS::NumberValue(112U) },
  { "DOM_VK_F2", JS::NumberValue(113U) },
  { "DOM_VK_F3", JS::NumberValue(114U) },
  { "DOM_VK_F4", JS::NumberValue(115U) },
  { "DOM_VK_F5", JS::NumberValue(116U) },
  { "DOM_VK_F6", JS::NumberValue(117U) },
  { "DOM_VK_F7", JS::NumberValue(118U) },
  { "DOM_VK_F8", JS::NumberValue(119U) },
  { "DOM_VK_F9", JS::NumberValue(120U) },
  { "DOM_VK_F10", JS::NumberValue(121U) },
  { "DOM_VK_F11", JS::NumberValue(122U) },
  { "DOM_VK_F12", JS::NumberValue(123U) },
  { "DOM_VK_F13", JS::NumberValue(124U) },
  { "DOM_VK_F14", JS::NumberValue(125U) },
  { "DOM_VK_F15", JS::NumberValue(126U) },
  { "DOM_VK_F16", JS::NumberValue(127U) },
  { "DOM_VK_F17", JS::NumberValue(128U) },
  { "DOM_VK_F18", JS::NumberValue(129U) },
  { "DOM_VK_F19", JS::NumberValue(130U) },
  { "DOM_VK_F20", JS::NumberValue(131U) },
  { "DOM_VK_F21", JS::NumberValue(132U) },
  { "DOM_VK_F22", JS::NumberValue(133U) },
  { "DOM_VK_F23", JS::NumberValue(134U) },
  { "DOM_VK_F24", JS::NumberValue(135U) },
  { "DOM_VK_NUM_LOCK", JS::NumberValue(144U) },
  { "DOM_VK_SCROLL_LOCK", JS::NumberValue(145U) },
  { "DOM_VK_WIN_OEM_FJ_JISHO", JS::NumberValue(146U) },
  { "DOM_VK_WIN_OEM_FJ_MASSHOU", JS::NumberValue(147U) },
  { "DOM_VK_WIN_OEM_FJ_TOUROKU", JS::NumberValue(148U) },
  { "DOM_VK_WIN_OEM_FJ_LOYA", JS::NumberValue(149U) },
  { "DOM_VK_WIN_OEM_FJ_ROYA", JS::NumberValue(150U) },
  { "DOM_VK_CIRCUMFLEX", JS::NumberValue(160U) },
  { "DOM_VK_EXCLAMATION", JS::NumberValue(161U) },
  { "DOM_VK_DOUBLE_QUOTE", JS::NumberValue(162U) },
  { "DOM_VK_HASH", JS::NumberValue(163U) },
  { "DOM_VK_DOLLAR", JS::NumberValue(164U) },
  { "DOM_VK_PERCENT", JS::NumberValue(165U) },
  { "DOM_VK_AMPERSAND", JS::NumberValue(166U) },
  { "DOM_VK_UNDERSCORE", JS::NumberValue(167U) },
  { "DOM_VK_OPEN_PAREN", JS::NumberValue(168U) },
  { "DOM_VK_CLOSE_PAREN", JS::NumberValue(169U) },
  { "DOM_VK_ASTERISK", JS::NumberValue(170U) },
  { "DOM_VK_PLUS", JS::NumberValue(171U) },
  { "DOM_VK_PIPE", JS::NumberValue(172U) },
  { "DOM_VK_HYPHEN_MINUS", JS::NumberValue(173U) },
  { "DOM_VK_OPEN_CURLY_BRACKET", JS::NumberValue(174U) },
  { "DOM_VK_CLOSE_CURLY_BRACKET", JS::NumberValue(175U) },
  { "DOM_VK_TILDE", JS::NumberValue(176U) },
  { "DOM_VK_VOLUME_MUTE", JS::NumberValue(181U) },
  { "DOM_VK_VOLUME_DOWN", JS::NumberValue(182U) },
  { "DOM_VK_VOLUME_UP", JS::NumberValue(183U) },
  { "DOM_VK_COMMA", JS::NumberValue(188U) },
  { "DOM_VK_PERIOD", JS::NumberValue(190U) },
  { "DOM_VK_SLASH", JS::NumberValue(191U) },
  { "DOM_VK_BACK_QUOTE", JS::NumberValue(192U) },
  { "DOM_VK_OPEN_BRACKET", JS::NumberValue(219U) },
  { "DOM_VK_BACK_SLASH", JS::NumberValue(220U) },
  { "DOM_VK_CLOSE_BRACKET", JS::NumberValue(221U) },
  { "DOM_VK_QUOTE", JS::NumberValue(222U) },
  { "DOM_VK_META", JS::NumberValue(224U) },
  { "DOM_VK_ALTGR", JS::NumberValue(225U) },
  { "DOM_VK_WIN_ICO_HELP", JS::NumberValue(227U) },
  { "DOM_VK_WIN_ICO_00", JS::NumberValue(228U) },
  { "DOM_VK_WIN_ICO_CLEAR", JS::NumberValue(230U) },
  { "DOM_VK_WIN_OEM_RESET", JS::NumberValue(233U) },
  { "DOM_VK_WIN_OEM_JUMP", JS::NumberValue(234U) },
  { "DOM_VK_WIN_OEM_PA1", JS::NumberValue(235U) },
  { "DOM_VK_WIN_OEM_PA2", JS::NumberValue(236U) },
  { "DOM_VK_WIN_OEM_PA3", JS::NumberValue(237U) },
  { "DOM_VK_WIN_OEM_WSCTRL", JS::NumberValue(238U) },
  { "DOM_VK_WIN_OEM_CUSEL", JS::NumberValue(239U) },
  { "DOM_VK_WIN_OEM_ATTN", JS::NumberValue(240U) },
  { "DOM_VK_WIN_OEM_FINISH", JS::NumberValue(241U) },
  { "DOM_VK_WIN_OEM_COPY", JS::NumberValue(242U) },
  { "DOM_VK_WIN_OEM_AUTO", JS::NumberValue(243U) },
  { "DOM_VK_WIN_OEM_ENLW", JS::NumberValue(244U) },
  { "DOM_VK_WIN_OEM_BACKTAB", JS::NumberValue(245U) },
  { "DOM_VK_ATTN", JS::NumberValue(246U) },
  { "DOM_VK_CRSEL", JS::NumberValue(247U) },
  { "DOM_VK_EXSEL", JS::NumberValue(248U) },
  { "DOM_VK_EREOF", JS::NumberValue(249U) },
  { "DOM_VK_PLAY", JS::NumberValue(250U) },
  { "DOM_VK_ZOOM", JS::NumberValue(251U) },
  { "DOM_VK_PA1", JS::NumberValue(253U) },
  { "DOM_VK_WIN_OEM_CLEAR", JS::NumberValue(254U) },
  { 0, JS::UndefinedValue() }
};
#if defined(__clang__)
#pragma clang diagnostic pop
#endif


// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const ConstantSpec> sConstants[] = {
  { nullptr, &sConstants_specs[0] },
  { nullptr, nullptr }
};

static_assert(1 <= 1ull << NUM_BITS_PROPERTY_INFO_PREF_INDEX,
    "We have a prefable index that is >= (1 << NUM_BITS_PROPERTY_INFO_PREF_INDEX)");
static_assert(189 <= 1ull << NUM_BITS_PROPERTY_INFO_SPEC_INDEX,
    "We have a spec index that is >= (1 << NUM_BITS_PROPERTY_INFO_SPEC_INDEX)");


static uint16_t sNativeProperties_sortedPropertyIndices[204];
static PropertyInfo sNativeProperties_propertyInfos[204];

static const NativePropertiesN<4> sNativeProperties = {
  false, 0,
  false, 0,
  true,  0 /* sMethods */,
  true,  1 /* sAttributes */,
  false, 0,
  true,  2 /* sUnforgeableAttributes */,
  true,  3 /* sConstants */,
  -1,
  204,
  sNativeProperties_sortedPropertyIndices,
  {
    { sMethods, &sNativeProperties_propertyInfos[0] },
    { sAttributes, &sNativeProperties_propertyInfos[3] },
    { sUnforgeableAttributes, &sNativeProperties_propertyInfos[14] },
    { sConstants, &sNativeProperties_propertyInfos[15] }
  }
};
static_assert(204 < 1ull << CHAR_BIT * sizeof(sNativeProperties.propertyInfoCount),
    "We have a property info count that is oversized");

static uint16_t sChromeOnlyNativeProperties_sortedPropertyIndices[2];
static PropertyInfo sChromeOnlyNativeProperties_propertyInfos[2];

static const NativePropertiesN<2> sChromeOnlyNativeProperties = {
  true,  0 /* sChromeStaticMethods */,
  false, 0,
  false, 0,
  true,  1 /* sChromeAttributes */,
  false, 0,
  false, 0,
  false, 0,
  -1,
  2,
  sChromeOnlyNativeProperties_sortedPropertyIndices,
  {
    { sChromeStaticMethods, &sChromeOnlyNativeProperties_propertyInfos[0] },
    { sChromeAttributes, &sChromeOnlyNativeProperties_propertyInfos[1] }
  }
};
static_assert(2 < 1ull << CHAR_BIT * sizeof(sChromeOnlyNativeProperties.propertyInfoCount),
    "We have a property info count that is oversized");

static bool
_constructor(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  JS::Rooted<JSObject*> obj(cx, &args.callee());
  if (!args.isConstructing()) {
    // XXXbz wish I could get the name from the callee instead of
    // Adding more relocations
    return ThrowConstructorWithoutNew(cx, "KeyboardEvent");
  }

  GlobalObject global(cx, obj);
  if (global.Failed()) {
    return false;
  }

  JS::Rooted<JSObject*> desiredProto(cx);
  if (!GetDesiredProto(cx, args, &desiredProto)) {
    return false;
  }

  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "KeyboardEvent");
  }
  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  binding_detail::FastKeyboardEventInit arg1;
  if (!arg1.Init(cx, (args.hasDefined(1)) ? args[1] : JS::NullHandleValue,  "Argument 2 of KeyboardEvent.constructor", false)) {
    return false;
  }
  Maybe<JSAutoCompartment> ac;
  if (objIsXray) {
    obj = js::CheckedUnwrap(obj);
    if (!obj) {
      return false;
    }
    ac.emplace(cx, obj);
    if (!JS_WrapObject(cx, &desiredProto)) {
      return false;
    }
  }
  binding_detail::FastErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::KeyboardEvent>(mozilla::dom::KeyboardEvent::Constructor(global, NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  if (MOZ_UNLIKELY(rv.MaybeSetPendingException(cx))) {
    return false;
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval(), desiredProto)) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const js::ClassOps sInterfaceObjectClassOps = {
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* newEnumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* finalize */
    _constructor, /* call */
    nullptr,               /* hasInstance */
    _constructor, /* construct */
    nullptr,               /* trace */
};

static const DOMIfaceAndProtoJSClass sInterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    &sInterfaceObjectClassOps,
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    &sInterfaceObjectClassObjectOps
  },
  eInterface,
  true,
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  sNativePropertyHooks,
  "function KeyboardEvent() {\n    [native code]\n}",
  UIEventBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass sPrototypeClass = {
  {
    "KeyboardEventPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE + 1 /* slot for the JSObject holding the unforgeable properties */),
    JS_NULL_CLASS_OPS,
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  false,
  prototypes::id::KeyboardEvent,
  PrototypeTraits<prototypes::id::KeyboardEvent>::Depth,
  sNativePropertyHooks,
  "[object KeyboardEventPrototype]",
  UIEventBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aDefineOnGlobal);
}

static const js::ClassOps sClassOps = {
  _addProperty, /* addProperty */
  nullptr,               /* delProperty */
  nullptr,               /* getProperty */
  nullptr,               /* setProperty */
  nullptr,               /* enumerate */
  nullptr, /* newEnumerate */
  nullptr, /* resolve */
  nullptr, /* mayResolve */
  _finalize, /* finalize */
  nullptr, /* call */
  nullptr,               /* hasInstance */
  nullptr,               /* construct */
  nullptr, /* trace */
};

static const js::ClassExtension sClassExtension = {
  nullptr, /* weakmapKeyDelegateOp */
  _objectMoved /* objectMovedOp */
};

static const DOMJSClass sClass = {
  { "KeyboardEvent",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_FOREGROUND_FINALIZE | JSCLASS_HAS_RESERVED_SLOTS(2) | JSCLASS_SKIP_NURSERY_FINALIZE,
    &sClassOps,
    JS_NULL_CLASS_SPEC,
    &sClassExtension,
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::Event, prototypes::id::UIEvent, prototypes::id::KeyboardEvent, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::KeyboardEvent >::value,
  sNativePropertyHooks,
  FindAssociatedGlobalForNative<mozilla::dom::KeyboardEvent>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::KeyboardEvent>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(2 >= 2,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return sClass.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::KeyboardEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::KeyboardEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::KeyboardEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::KeyboardEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::UIEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::UIEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::UIEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::Event*>(aObject) ==
             reinterpret_cast<mozilla::dom::Event*>(aObject),
             "Multiple inheritance for mozilla::dom::Event is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT_IF(aGivenProto, js::IsObjectInContextCompartment(aGivenProto, aCx));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> global(aCx, FindAssociatedGlobal(aCx, aObject->GetParentObject()));
  if (!global) {
    return false;
  }
  MOZ_ASSERT(JS_IsGlobalObject(global));
  MOZ_ASSERT(JS::ObjectIsNotGray(global));

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, global);
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::KeyboardEvent> creator(aCx);
  creator.CreateObject(aCx, sClass.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);

  // Important: do unforgeable property setup after we have handed
  // over ownership of the C++ object to obj as needed, so that if
  // we fail and it ends up GCed it won't have problems in the
  // finalizer trying to drop its ownership of the C++ object.
  JS::Rooted<JSObject*> unforgeableHolder(aCx,
    &js::GetReservedSlot(canonicalProto, DOM_INTERFACE_PROTO_SLOTS_BASE).toObject());
  if (!JS_InitializePropertiesFromCompatibleNativeObject(aCx, aReflector, unforgeableHolder)) {
    aCache->ReleaseWrapper(aObject);
    aCache->ClearWrapper();
    return false;
  }
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

// This may allocate too many slots, because we only really need
// slots for our non-interface-typed members that we cache.  But
// allocating slots only for those would make the slot index
// computations much more complicated, so let's do this the simple
// way for now.
DEFINE_XRAY_EXPANDO_CLASS(static, sXrayExpandoObjectClass, 1);

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  nullptr,
  { sNativeProperties.Upcast(), sChromeOnlyNativeProperties.Upcast() },
  prototypes::id::KeyboardEvent,
  constructors::id::KeyboardEvent,
  UIEventBinding::sNativePropertyHooks,
  &sXrayExpandoObjectClass
} };

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(UIEventBinding::GetProtoObjectHandle(aCx));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(UIEventBinding::GetConstructorObjectHandle(aCx));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sNativeProperties.Upcast())) {
      return;
    }
    if (!InitIds(aCx, sChromeOnlyNativeProperties.Upcast())) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::KeyboardEvent);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::KeyboardEvent);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &sPrototypeClass.mBase, protoCache,
                              constructorProto, &sInterfaceObjectClass.mBase, 1, nullptr,
                              interfaceCache,
                              sNativeProperties.Upcast(),
                              nsContentUtils::ThreadsafeIsSystemCaller(aCx) ? sChromeOnlyNativeProperties.Upcast() : nullptr,
                              "KeyboardEvent", aDefineOnGlobal,
                              nullptr,
                              false);

  JS::Rooted<JSObject*> unforgeableHolder(aCx);
  {
    JS::Rooted<JSObject*> holderProto(aCx, *protoCache);
    unforgeableHolder = JS_NewObjectWithoutMetadata(aCx, sClass.ToJSClass(), holderProto);
    if (!unforgeableHolder) {
      *protoCache = nullptr;
      if (interfaceCache) {
        *interfaceCache = nullptr;
      }
      return;
    }
  }

  if (!DefineUnforgeableAttributes(aCx, unforgeableHolder, sUnforgeableAttributes)) {
    *protoCache = nullptr;
    if (interfaceCache) {
      *interfaceCache = nullptr;
    }
    return;
  }

  if (*protoCache) {
    js::SetReservedSlot(*protoCache, DOM_INTERFACE_PROTO_SLOTS_BASE,
                        JS::ObjectValue(*unforgeableHolder));
  }
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  JSObject* global = JS::CurrentGlobalOrNull(aCx);
  if (!(js::GetObjectClass(global)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(global);
  if (!protoAndIfaceCache.HasEntryInSlot(prototypes::id::KeyboardEvent)) {
    JS::Rooted<JSObject*> rootedGlobal(aCx, global);
    CreateInterfaceObjects(aCx, rootedGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   *
   * Calling address() avoids the read read barrier that does gray
   * unmarking, but it's not possible for the object to be gray here.
   */

  const JS::Heap<JSObject*>& entrySlot = protoAndIfaceCache.EntrySlotMustExist(prototypes::id::KeyboardEvent);
  MOZ_ASSERT(JS::ObjectIsNotGray(entrySlot));
  return JS::Handle<JSObject*>::fromMarkedLocation(entrySlot.address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  JSObject* global = JS::CurrentGlobalOrNull(aCx);
  if (!(js::GetObjectClass(global)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(global);
  if (!protoAndIfaceCache.HasEntryInSlot(constructors::id::KeyboardEvent)) {
    JS::Rooted<JSObject*> rootedGlobal(aCx, global);
    CreateInterfaceObjects(aCx, rootedGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   *
   * Calling address() avoids the read read barrier that does gray
   * unmarking, but it's not possible for the object to be gray here.
   */

  const JS::Heap<JSObject*>& entrySlot = protoAndIfaceCache.EntrySlotMustExist(constructors::id::KeyboardEvent);
  MOZ_ASSERT(JS::ObjectIsNotGray(entrySlot));
  return JS::Handle<JSObject*>::fromMarkedLocation(entrySlot.address());
}

JSObject*
GetConstructorObject(JSContext* aCx)
{
  return GetConstructorObjectHandle(aCx);
}

} // namespace KeyboardEventBinding



} // namespace dom
} // namespace mozilla
