#include "AbortControllerBinding.h"
#include "AbortSignalBinding.h"
#include "BlobBinding.h"
#include "BroadcastChannelBinding.h"
#include "CacheBinding.h"
#include "CacheStorageBinding.h"
#include "ChromeUtilsBinding.h"
#include "ClientBinding.h"
#include "ClientsBinding.h"
#include "CloseEventBinding.h"
#include "ConsoleBinding.h"
#include "CryptoBinding.h"
#include "CustomEventBinding.h"
#include "DOMCursorBinding.h"
#include "DOMExceptionBinding.h"
#include "DOMRequestBinding.h"
#include "DOMStringListBinding.h"
#include "DedicatedWorkerGlobalScopeBinding.h"
#include "DirectoryBinding.h"
#include "DominatorTreeBinding.h"
#include "ErrorEventBinding.h"
#include "EventBinding.h"
#include "EventSourceBinding.h"
#include "EventTargetBinding.h"
#include "ExtendableEventBinding.h"
#include "ExtendableMessageEventBinding.h"
#include "FetchEventBinding.h"
#include "FetchObserverBinding.h"
#include "FileBinding.h"
#include "FileListBinding.h"
#include "FileReaderBinding.h"
#include "FileReaderSyncBinding.h"
#include "FormDataBinding.h"
#include "HeadersBinding.h"
#include "HeapSnapshotBinding.h"
#include "IDBCursorBinding.h"
#include "IDBDatabaseBinding.h"
#include "IDBFactoryBinding.h"
#include "IDBIndexBinding.h"
#include "IDBKeyRangeBinding.h"
#include "IDBObjectStoreBinding.h"
#include "IDBOpenDBRequestBinding.h"
#include "IDBRequestBinding.h"
#include "IDBTransactionBinding.h"
#include "IDBVersionChangeEventBinding.h"
#include "ImageBitmapBinding.h"
#include "ImageBitmapRenderingContextBinding.h"
#include "ImageDataBinding.h"
#include "MessageChannelBinding.h"
#include "MessageEventBinding.h"
#include "MessagePortBinding.h"
#include "NetworkInformationBinding.h"
#include "NotificationBinding.h"
#include "NotificationEventBinding.h"
#include "OffscreenCanvasBinding.h"
#include "PerformanceBinding.h"
#include "PerformanceEntryBinding.h"
#include "PerformanceMarkBinding.h"
#include "PerformanceMeasureBinding.h"
#include "PerformanceObserverBinding.h"
#include "PerformanceObserverEntryListBinding.h"
#include "ProgressEventBinding.h"
#include "PromiseRejectionEventBinding.h"
#include "PushEventBinding.h"
#include "PushManagerBinding.h"
#include "PushMessageDataBinding.h"
#include "PushSubscriptionBinding.h"
#include "PushSubscriptionOptionsBinding.h"
#include "RequestBinding.h"
#include "ResponseBinding.h"
#include "ServiceWorkerBinding.h"
#include "ServiceWorkerGlobalScopeBinding.h"
#include "ServiceWorkerRegistrationBinding.h"
#include "SharedWorkerGlobalScopeBinding.h"
#include "StorageManagerBinding.h"
#include "StructuredCloneHolderBinding.h"
#include "SubtleCryptoBinding.h"
#include "TextDecoderBinding.h"
#include "TextEncoderBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "WebGLContextEventBinding.h"
#include "WebGLRenderingContextBinding.h"
#include "WebSocketBinding.h"
#include "WorkerBinding.h"
#include "WorkerGlobalScopeBinding.h"
#include "WorkerLocationBinding.h"
#include "WorkerNavigatorBinding.h"
#include "XMLHttpRequestBinding.h"
#include "XMLHttpRequestEventTargetBinding.h"
#include "XMLHttpRequestUploadBinding.h"

namespace mozilla {
namespace dom {
bool
RegisterWorkerBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (!AbortControllerBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!AbortSignalBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!BlobBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!BroadcastChannelBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (CacheBinding::ConstructorEnabled(aCx, aObj) && !CacheBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (CacheStorageBinding::ConstructorEnabled(aCx, aObj) && !CacheStorageBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ChromeUtilsBinding::ConstructorEnabled(aCx, aObj) && !ChromeUtilsBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ChromeWorkerBinding::ConstructorEnabled(aCx, aObj) && !ChromeWorkerBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ClientBinding::ConstructorEnabled(aCx, aObj) && !ClientBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ClientsBinding::ConstructorEnabled(aCx, aObj) && !ClientsBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!CloseEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!CryptoBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!CustomEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!DOMCursorBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!DOMExceptionBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!DOMRequestBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!DOMStringListBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (DedicatedWorkerGlobalScopeBinding::ConstructorEnabled(aCx, aObj) && !DedicatedWorkerGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!DirectoryBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (DominatorTreeBinding::ConstructorEnabled(aCx, aObj) && !DominatorTreeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ErrorEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!EventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (EventSourceBinding::ConstructorEnabled(aCx, aObj) && !EventSourceBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!EventTargetBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ExtendableEventBinding::ConstructorEnabled(aCx, aObj) && !ExtendableEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ExtendableMessageEventBinding::ConstructorEnabled(aCx, aObj) && !ExtendableMessageEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (FetchEventBinding::ConstructorEnabled(aCx, aObj) && !FetchEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (FetchObserverBinding::ConstructorEnabled(aCx, aObj) && !FetchObserverBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!FileBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!FileListBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!FileReaderBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!FileReaderSyncBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!FormDataBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!HeadersBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (HeapSnapshotBinding::ConstructorEnabled(aCx, aObj) && !HeapSnapshotBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBCursorBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBCursorWithValueBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBDatabaseBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBFactoryBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBIndexBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBKeyRangeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (IDBLocaleAwareKeyRangeBinding::ConstructorEnabled(aCx, aObj) && !IDBLocaleAwareKeyRangeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBObjectStoreBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBOpenDBRequestBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBRequestBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBTransactionBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!IDBVersionChangeEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ImageBitmapBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ImageBitmapRenderingContextBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ImageDataBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!MessageChannelBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!MessageEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!MessagePortBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (NetworkInformationBinding::ConstructorEnabled(aCx, aObj) && !NetworkInformationBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (NotificationBinding::ConstructorEnabled(aCx, aObj) && !NotificationBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (NotificationEventBinding::ConstructorEnabled(aCx, aObj) && !NotificationEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (OffscreenCanvasBinding::ConstructorEnabled(aCx, aObj) && !OffscreenCanvasBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!PerformanceBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!PerformanceEntryBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!PerformanceMarkBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!PerformanceMeasureBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PerformanceObserverBinding::ConstructorEnabled(aCx, aObj) && !PerformanceObserverBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PerformanceObserverEntryListBinding::ConstructorEnabled(aCx, aObj) && !PerformanceObserverEntryListBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ProgressEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PromiseRejectionEventBinding::ConstructorEnabled(aCx, aObj) && !PromiseRejectionEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PushEventBinding::ConstructorEnabled(aCx, aObj) && !PushEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PushManagerBinding::ConstructorEnabled(aCx, aObj) && !PushManagerBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PushMessageDataBinding::ConstructorEnabled(aCx, aObj) && !PushMessageDataBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PushSubscriptionBinding::ConstructorEnabled(aCx, aObj) && !PushSubscriptionBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (PushSubscriptionOptionsBinding::ConstructorEnabled(aCx, aObj) && !PushSubscriptionOptionsBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!RequestBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ResponseBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ServiceWorkerBinding::ConstructorEnabled(aCx, aObj) && !ServiceWorkerBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ServiceWorkerGlobalScopeBinding::ConstructorEnabled(aCx, aObj) && !ServiceWorkerGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ServiceWorkerRegistrationBinding::ConstructorEnabled(aCx, aObj) && !ServiceWorkerRegistrationBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (SharedWorkerGlobalScopeBinding::ConstructorEnabled(aCx, aObj) && !SharedWorkerGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (StorageManagerBinding::ConstructorEnabled(aCx, aObj) && !StorageManagerBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (StructuredCloneHolderBinding::ConstructorEnabled(aCx, aObj) && !StructuredCloneHolderBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!SubtleCryptoBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!TextDecoderBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!TextEncoderBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!URLBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!URLSearchParamsBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLActiveInfoBinding::ConstructorEnabled(aCx, aObj) && !WebGLActiveInfoBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLBufferBinding::ConstructorEnabled(aCx, aObj) && !WebGLBufferBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLContextEventBinding::ConstructorEnabled(aCx, aObj) && !WebGLContextEventBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLFramebufferBinding::ConstructorEnabled(aCx, aObj) && !WebGLFramebufferBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLProgramBinding::ConstructorEnabled(aCx, aObj) && !WebGLProgramBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLRenderbufferBinding::ConstructorEnabled(aCx, aObj) && !WebGLRenderbufferBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLRenderingContextBinding::ConstructorEnabled(aCx, aObj) && !WebGLRenderingContextBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLShaderBinding::ConstructorEnabled(aCx, aObj) && !WebGLShaderBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLShaderPrecisionFormatBinding::ConstructorEnabled(aCx, aObj) && !WebGLShaderPrecisionFormatBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLTextureBinding::ConstructorEnabled(aCx, aObj) && !WebGLTextureBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WebGLUniformLocationBinding::ConstructorEnabled(aCx, aObj) && !WebGLUniformLocationBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WebSocketBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WindowClientBinding::ConstructorEnabled(aCx, aObj) && !WindowClientBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WorkerBinding::ConstructorEnabled(aCx, aObj) && !WorkerBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkerGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkerLocationBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkerNavigatorBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (XMLHttpRequestBinding::ConstructorEnabled(aCx, aObj) && !XMLHttpRequestBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (XMLHttpRequestEventTargetBinding::ConstructorEnabled(aCx, aObj) && !XMLHttpRequestEventTargetBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (XMLHttpRequestUploadBinding::ConstructorEnabled(aCx, aObj) && !XMLHttpRequestUploadBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!consoleBinding::GetConstructorObject(aCx)) {
    return false;
  }

  return true;
}

} // namespace dom
} // namespace mozilla

