#include "ConsoleBinding.h"
#include "EventTargetBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "WorkerDebuggerGlobalScopeBinding.h"

namespace mozilla {
namespace dom {
bool
RegisterWorkerDebuggerBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (!EventTargetBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!URLBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!URLSearchParamsBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkerDebuggerGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!consoleBinding::GetConstructorObject(aCx)) {
    return false;
  }

  return true;
}

} // namespace dom
} // namespace mozilla

