#include "AudioWorkletGlobalScopeBinding.h"
#include "ConsoleBinding.h"
#include "PaintWorkletGlobalScopeBinding.h"
#include "WorkletGlobalScopeBinding.h"

namespace mozilla {
namespace dom {
bool
RegisterWorkletBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (!AudioWorkletGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!PaintWorkletGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkletGlobalScopeBinding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!consoleBinding::GetConstructorObject(aCx)) {
    return false;
  }

  return true;
}

} // namespace dom
} // namespace mozilla

