/* THIS FILE IS AUTOGENERATED FROM WebComponents.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "WebComponentsBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/ScriptSettings.h"

namespace mozilla {
namespace dom {


ElementRegistrationOptions::ElementRegistrationOptions()
  : mPrototype(nullptr)
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
ElementRegistrationOptions::InitIds(JSContext* cx, ElementRegistrationOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->prototype_id.init(cx, "prototype") ||
      !atomsCache->extends_id.init(cx, "extends")) {
    return false;
  }
  return true;
}

bool
ElementRegistrationOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  ElementRegistrationOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<ElementRegistrationOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->extends_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, mExtends)) {
      return false;
    }
  } else {
    mExtends.SetIsVoid(true);
  }
  mIsAnyMemberPresent = true;

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->prototype_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
#ifdef __clang__
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunreachable-code"
#pragma clang diagnostic ignored "-Wunreachable-code-return"
#endif // __clang__
      if ((passedToJSImpl) && !CallerSubsumes(temp.ref())) {
        ThrowErrorMessage(cx, MSG_PERMISSION_DENIED_TO_PASS_ARG, "'prototype' member of ElementRegistrationOptions");
        return false;
      }
#ifdef __clang__
#pragma clang diagnostic pop
#endif // __clang__
      mPrototype = &temp.ref().toObject();
    } else if (temp.ref().isNullOrUndefined()) {
      mPrototype = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'prototype' member of ElementRegistrationOptions");
      return false;
    }
  } else {
    mPrototype = nullptr;
  }
  mIsAnyMemberPresent = true;
  return true;
}

bool
ElementRegistrationOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  ElementRegistrationOptionsAtoms* atomsCache = GetAtomCache<ElementRegistrationOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mExtends;
    if (!xpc::StringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->extends_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    JSObject* const & currentValue = mPrototype;
    if (currentValue) {
                  JS::ExposeObjectToActiveJS(currentValue);
                }
                temp.setObjectOrNull(currentValue);
    if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->prototype_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

void
ElementRegistrationOptions::TraceDictionary(JSTracer* trc)
{
  if (mPrototype) {
    JS::UnsafeTraceRoot(trc, &mPrototype, "ElementRegistrationOptions.mPrototype");
  }
}

namespace binding_detail {
} // namespace binding_detail



LifecycleCallbacks::LifecycleCallbacks()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
LifecycleCallbacks::InitIds(JSContext* cx, LifecycleCallbacksAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->detachedCallback_id.init(cx, "detachedCallback") ||
      !atomsCache->createdCallback_id.init(cx, "createdCallback") ||
      !atomsCache->attributeChangedCallback_id.init(cx, "attributeChangedCallback") ||
      !atomsCache->attachedCallback_id.init(cx, "attachedCallback")) {
    return false;
  }
  return true;
}

bool
LifecycleCallbacks::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  // Also evaluate isNullOrUndefined in order to avoid false-positive
  // checkers by static analysis tools
  MOZ_ASSERT_IF(!cx, val.isNull() && val.isNullOrUndefined());
  LifecycleCallbacksAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<LifecycleCallbacksAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    MOZ_ASSERT(cx);
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->attachedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAttachedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mAttachedCallback.Value()) = new LifecycleAttachedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'attachedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mAttachedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'attachedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->attributeChangedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mAttributeChangedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mAttributeChangedCallback.Value()) = new LifecycleAttributeChangedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'attributeChangedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mAttributeChangedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'attributeChangedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->createdCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mCreatedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mCreatedCallback.Value()) = new LifecycleCreatedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'createdCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mCreatedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'createdCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }

  if (!isNull) {
    if (!JS_GetPropertyById(cx, *object, atomsCache->detachedCallback_id, temp.ptr())) {
      return false;
    }
  }
  if (!isNull && !temp->isUndefined()) {
    mDetachedCallback.Construct();
    if (temp.ref().isObject()) {
      if (JS::IsCallable(&temp.ref().toObject())) {
      { // scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &temp.ref().toObject());
        (mDetachedCallback.Value()) = new LifecycleDetachedCallback(cx, tempRoot, GetIncumbentGlobal());
      }
      } else {
        ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "'detachedCallback' member of LifecycleCallbacks");
        return false;
      }
    } else if (temp.ref().isNullOrUndefined()) {
      (mDetachedCallback.Value()) = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'detachedCallback' member of LifecycleCallbacks");
      return false;
    }
    mIsAnyMemberPresent = true;
  }
  return true;
}

bool
LifecycleCallbacks::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  LifecycleCallbacksAtoms* atomsCache = GetAtomCache<LifecycleCallbacksAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mAttachedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleAttachedCallback> const & currentValue = mAttachedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->attachedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->attachedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(0);
  }

  if (mAttributeChangedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleAttributeChangedCallback> const & currentValue = mAttributeChangedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->attributeChangedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->attributeChangedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(0);
  }

  if (mCreatedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleCreatedCallback> const & currentValue = mCreatedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->createdCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->createdCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(0);
  }

  if (mDetachedCallback.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      RefPtr<LifecycleDetachedCallback> const & currentValue = mDetachedCallback.InternalValue();
      if (currentValue) {
        temp.setObjectOrNull(GetCallbackFromCallbackObject(currentValue));
        if (!MaybeWrapObjectOrNullValue(cx, &temp)) {
          return false;
        }
        if (!JS_DefinePropertyById(cx, obj, atomsCache->detachedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      } else {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->detachedCallback_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(0);
  }

  return true;
}

void
LifecycleCallbacks::TraceDictionary(JSTracer* trc)
{
}

namespace binding_detail {
} // namespace binding_detail


void
LifecycleCreatedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



void
LifecycleAttachedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



void
LifecycleDetachedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



void
LifecycleAttributeChangedCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, const nsAString& attrName, const nsAString& oldValue, const nsAString& newValue, const nsAString& namespaceURI, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx);
  JS::AutoValueVector argv(cx);
  if (!argv.resize(4)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 4;

  do {
    nsString mutableStr(namespaceURI);
    if (!xpc::StringToJsval(cx, mutableStr, argv[3])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  do {
    nsString mutableStr(newValue);
    if (!xpc::StringToJsval(cx, mutableStr, argv[2])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  do {
    nsString mutableStr(oldValue);
    if (!xpc::StringToJsval(cx, mutableStr, argv[1])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  do {
    nsString mutableStr(attrName);
    if (!xpc::NonVoidStringToJsval(cx, mutableStr, argv[0])) {
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.NoteJSContextException(cx);
    return;
  }
}



namespace binding_detail {
} // namespace binding_detail


namespace binding_detail {
} // namespace binding_detail


namespace binding_detail {
} // namespace binding_detail


namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
