//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct MessagePortIdentifier|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT MessagePortIdentifier::MessagePortIdentifier() :
    uuid_(),
    destinationUuid_(),
    sequenceId_(),
    neutered_()
{
    Init();
}

MessagePortIdentifier::~MessagePortIdentifier()
{
}

auto MessagePortIdentifier::operator==(const MessagePortIdentifier& _o) const -> bool
{
    if ((!((uuid()) == ((_o).uuid())))) {
        return false;
    }
    if ((!((destinationUuid()) == ((_o).destinationUuid())))) {
        return false;
    }
    if ((!((sequenceId()) == ((_o).sequenceId())))) {
        return false;
    }
    if ((!((neutered()) == ((_o).neutered())))) {
        return false;
    }
    return true;
}

auto MessagePortIdentifier::operator!=(const MessagePortIdentifier& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto MessagePortIdentifier::Init() -> void
{
}

auto MessagePortIdentifier::Assign(
        const nsID& _uuid,
        const nsID& _destinationUuid,
        const uint32_t& _sequenceId,
        const bool& _neutered) -> void
{
    uuid_ = _uuid;
    destinationUuid_ = _destinationUuid;
    sequenceId_ = _sequenceId;
    neutered_ = _neutered;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT ClonedMessageData::ClonedMessageData() :
    data_()
{
    Init();
}

ClonedMessageData::~ClonedMessageData()
{
}

auto ClonedMessageData::operator==(const ClonedMessageData& _o) const -> bool
{
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    if ((!((blobs()) == ((_o).blobs())))) {
        return false;
    }
    if ((!((inputStreams()) == ((_o).inputStreams())))) {
        return false;
    }
    if ((!((identfiers()) == ((_o).identfiers())))) {
        return false;
    }
    return true;
}

auto ClonedMessageData::operator!=(const ClonedMessageData& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto ClonedMessageData::Init() -> void
{
}

auto ClonedMessageData::Assign(
        const SerializedStructuredCloneBuffer& _data,
        const nsTArray<IPCBlob>& _blobs,
        const nsTArray<IPCStream>& _inputStreams,
        const nsTArray<MessagePortIdentifier>& _identfiers) -> void
{
    data_ = _data;
    blobs_ = _blobs;
    inputStreams_ = _inputStreams;
    identfiers_ = _identfiers;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
auto IPCDataTransferData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsString:
        {
            (ptr_nsString())->~nsString__tdef();
            break;
        }
    case TShmem:
        {
            (ptr_Shmem())->~Shmem__tdef();
            break;
        }
    case TIPCBlob:
        {
            (ptr_IPCBlob())->~IPCBlob__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const nsString& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsString()) nsString(aOther);
    mType = TnsString;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(Shmem& aOther)
{
    new (mozilla::KnownNotNull, ptr_Shmem()) Shmem(aOther);
    mType = TShmem;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const IPCBlob& aOther)
{
    new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob(aOther);
    mType = TIPCBlob;
}

MOZ_IMPLICIT IPCDataTransferData::IPCDataTransferData(const IPCDataTransferData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsString:
        {
            new (mozilla::KnownNotNull, ptr_nsString()) nsString((aOther).get_nsString());
            break;
        }
    case TShmem:
        {
            new (mozilla::KnownNotNull, ptr_Shmem()) Shmem((aOther).get_Shmem());
            break;
        }
    case TIPCBlob:
        {
            new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob((aOther).get_IPCBlob());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

IPCDataTransferData::~IPCDataTransferData()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto IPCDataTransferData::operator=(const nsString& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TnsString)) {
        new (mozilla::KnownNotNull, ptr_nsString()) nsString;
    }
    (*(ptr_nsString())) = aRhs;
    mType = TnsString;
    return (*(this));
}

auto IPCDataTransferData::operator=(Shmem& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TShmem)) {
        new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
    }
    (*(ptr_Shmem())) = aRhs;
    mType = TShmem;
    return (*(this));
}

auto IPCDataTransferData::operator=(const IPCBlob& aRhs) -> IPCDataTransferData&
{
    if (MaybeDestroy(TIPCBlob)) {
        new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob;
    }
    (*(ptr_IPCBlob())) = aRhs;
    mType = TIPCBlob;
    return (*(this));
}

auto IPCDataTransferData::operator=(const IPCDataTransferData& aRhs) -> IPCDataTransferData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsString()) nsString;
            }
            (*(ptr_nsString())) = (aRhs).get_nsString();
            break;
        }
    case TShmem:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
            }
            (*(ptr_Shmem())) = (aRhs).get_Shmem();
            break;
        }
    case TIPCBlob:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_IPCBlob()) IPCBlob;
            }
            (*(ptr_IPCBlob())) = (aRhs).get_IPCBlob();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto IPCDataTransferData::operator==(const nsString& aRhs) const -> bool
{
    return (get_nsString()) == (aRhs);
}

auto IPCDataTransferData::operator==(Shmem& aRhs) const -> bool
{
    return (get_Shmem()) == (aRhs);
}

auto IPCDataTransferData::operator==(const IPCBlob& aRhs) const -> bool
{
    return (get_IPCBlob()) == (aRhs);
}

auto IPCDataTransferData::operator==(const IPCDataTransferData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TnsString:
        {
            return (get_nsString()) == ((aRhs).get_nsString());
        }
    case TShmem:
        {
            return (get_Shmem()) == ((aRhs).get_Shmem());
        }
    case TIPCBlob:
        {
            return (get_IPCBlob()) == ((aRhs).get_IPCBlob());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto IPCDataTransferData::get(nsString* aOutValue) const -> void
{
    (*(aOutValue)) = get_nsString();
}

auto IPCDataTransferData::get(Shmem* aOutValue) const -> void
{
    (*(aOutValue)) = get_Shmem();
}

auto IPCDataTransferData::get(IPCBlob* aOutValue) const -> void
{
    (*(aOutValue)) = get_IPCBlob();
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT IPCDataTransferImage::IPCDataTransferImage() :
    width_(),
    height_(),
    stride_(),
    format_()
{
    Init();
}

IPCDataTransferImage::~IPCDataTransferImage()
{
}

auto IPCDataTransferImage::operator==(const IPCDataTransferImage& _o) const -> bool
{
    if ((!((width()) == ((_o).width())))) {
        return false;
    }
    if ((!((height()) == ((_o).height())))) {
        return false;
    }
    if ((!((stride()) == ((_o).stride())))) {
        return false;
    }
    if ((!((format()) == ((_o).format())))) {
        return false;
    }
    return true;
}

auto IPCDataTransferImage::operator!=(const IPCDataTransferImage& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto IPCDataTransferImage::Init() -> void
{
}

auto IPCDataTransferImage::Assign(
        const uint32_t& _width,
        const uint32_t& _height,
        const uint32_t& _stride,
        const uint8_t& _format) -> void
{
    width_ = _width;
    height_ = _height;
    stride_ = _stride;
    format_ = _format;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT IPCDataTransferItem::IPCDataTransferItem() :
    flavor_()
{
    Init();
}

IPCDataTransferItem::~IPCDataTransferItem()
{
}

auto IPCDataTransferItem::operator==(const IPCDataTransferItem& _o) const -> bool
{
    if ((!((flavor()) == ((_o).flavor())))) {
        return false;
    }
    if ((!((imageDetails()) == ((_o).imageDetails())))) {
        return false;
    }
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    return true;
}

auto IPCDataTransferItem::operator!=(const IPCDataTransferItem& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto IPCDataTransferItem::Init() -> void
{
}

auto IPCDataTransferItem::Assign(
        const nsCString& _flavor,
        const IPCDataTransferImage& _imageDetails,
        const IPCDataTransferData& _data) -> void
{
    flavor_ = _flavor;
    imageDetails_ = _imageDetails;
    data_ = _data;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT IPCDataTransfer::IPCDataTransfer()
{
    Init();
}

IPCDataTransfer::~IPCDataTransfer()
{
}

auto IPCDataTransfer::operator==(const IPCDataTransfer& _o) const -> bool
{
    if ((!((items()) == ((_o).items())))) {
        return false;
    }
    return true;
}

auto IPCDataTransfer::operator!=(const IPCDataTransfer& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto IPCDataTransfer::Init() -> void
{
}

auto IPCDataTransfer::Assign(const nsTArray<IPCDataTransferItem>& _items) -> void
{
    items_ = _items;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT ScreenDetails::ScreenDetails() :
    rect_(),
    rectDisplayPix_(),
    availRect_(),
    availRectDisplayPix_(),
    pixelDepth_(),
    colorDepth_(),
    contentsScaleFactor_(),
    defaultCSSScaleFactor_(),
    dpi_()
{
    Init();
}

ScreenDetails::~ScreenDetails()
{
}

auto ScreenDetails::operator==(const ScreenDetails& _o) const -> bool
{
    if ((!((rect()) == ((_o).rect())))) {
        return false;
    }
    if ((!((rectDisplayPix()) == ((_o).rectDisplayPix())))) {
        return false;
    }
    if ((!((availRect()) == ((_o).availRect())))) {
        return false;
    }
    if ((!((availRectDisplayPix()) == ((_o).availRectDisplayPix())))) {
        return false;
    }
    if ((!((pixelDepth()) == ((_o).pixelDepth())))) {
        return false;
    }
    if ((!((colorDepth()) == ((_o).colorDepth())))) {
        return false;
    }
    if ((!((contentsScaleFactor()) == ((_o).contentsScaleFactor())))) {
        return false;
    }
    if ((!((defaultCSSScaleFactor()) == ((_o).defaultCSSScaleFactor())))) {
        return false;
    }
    if ((!((dpi()) == ((_o).dpi())))) {
        return false;
    }
    return true;
}

auto ScreenDetails::operator!=(const ScreenDetails& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto ScreenDetails::Init() -> void
{
}

auto ScreenDetails::Assign(
        const LayoutDeviceIntRect& _rect,
        const DesktopIntRect& _rectDisplayPix,
        const LayoutDeviceIntRect& _availRect,
        const DesktopIntRect& _availRectDisplayPix,
        const int32_t& _pixelDepth,
        const int32_t& _colorDepth,
        const DesktopToLayoutDeviceScale& _contentsScaleFactor,
        const CSSToLayoutDeviceScale& _defaultCSSScaleFactor,
        const float& _dpi) -> void
{
    rect_ = _rect;
    rectDisplayPix_ = _rectDisplayPix;
    availRect_ = _availRect;
    availRectDisplayPix_ = _availRectDisplayPix;
    pixelDepth_ = _pixelDepth;
    colorDepth_ = _colorDepth;
    contentsScaleFactor_ = _contentsScaleFactor;
    defaultCSSScaleFactor_ = _defaultCSSScaleFactor;
    dpi_ = _dpi;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct DimensionInfo|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT DimensionInfo::DimensionInfo() :
    rect_(),
    size_(),
    orientation_(),
    clientOffset_(),
    chromeDisp_()
{
    Init();
}

DimensionInfo::~DimensionInfo()
{
}

auto DimensionInfo::operator==(const DimensionInfo& _o) const -> bool
{
    if ((!((rect()) == ((_o).rect())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((orientation()) == ((_o).orientation())))) {
        return false;
    }
    if ((!((clientOffset()) == ((_o).clientOffset())))) {
        return false;
    }
    if ((!((chromeDisp()) == ((_o).chromeDisp())))) {
        return false;
    }
    return true;
}

auto DimensionInfo::operator!=(const DimensionInfo& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto DimensionInfo::Init() -> void
{
}

auto DimensionInfo::Assign(
        const CSSRect& _rect,
        const CSSSize& _size,
        const ScreenOrientationInternal& _orientation,
        const LayoutDeviceIntPoint& _clientOffset,
        const LayoutDeviceIntPoint& _chromeDisp) -> void
{
    rect_ = _rect;
    size_ = _size;
    orientation_ = _orientation;
    clientOffset_ = _clientOffset;
    chromeDisp_ = _chromeDisp;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct FrameScriptInfo|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT FrameScriptInfo::FrameScriptInfo() :
    url_(),
    runInGlobalScope_()
{
    Init();
}

FrameScriptInfo::~FrameScriptInfo()
{
}

auto FrameScriptInfo::operator==(const FrameScriptInfo& _o) const -> bool
{
    if ((!((url()) == ((_o).url())))) {
        return false;
    }
    if ((!((runInGlobalScope()) == ((_o).runInGlobalScope())))) {
        return false;
    }
    return true;
}

auto FrameScriptInfo::operator!=(const FrameScriptInfo& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto FrameScriptInfo::Init() -> void
{
}

auto FrameScriptInfo::Assign(
        const nsString& _url,
        const bool& _runInGlobalScope) -> void
{
    url_ = _url;
    runInGlobalScope_ = _runInGlobalScope;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct CreatedWindowInfo|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT CreatedWindowInfo::CreatedWindowInfo() :
    rv_(),
    windowOpened_(),
    urlToLoad_(),
    textureFactoryIdentifier_(),
    layersId_(),
    compositorOptions_(),
    maxTouchPoints_()
{
    Init();
}

CreatedWindowInfo::~CreatedWindowInfo()
{
}

auto CreatedWindowInfo::operator==(const CreatedWindowInfo& _o) const -> bool
{
    if ((!((rv()) == ((_o).rv())))) {
        return false;
    }
    if ((!((windowOpened()) == ((_o).windowOpened())))) {
        return false;
    }
    if ((!((frameScripts()) == ((_o).frameScripts())))) {
        return false;
    }
    if ((!((urlToLoad()) == ((_o).urlToLoad())))) {
        return false;
    }
    if ((!((textureFactoryIdentifier()) == ((_o).textureFactoryIdentifier())))) {
        return false;
    }
    if ((!((layersId()) == ((_o).layersId())))) {
        return false;
    }
    if ((!((compositorOptions()) == ((_o).compositorOptions())))) {
        return false;
    }
    if ((!((maxTouchPoints()) == ((_o).maxTouchPoints())))) {
        return false;
    }
    if ((!((dimensions()) == ((_o).dimensions())))) {
        return false;
    }
    return true;
}

auto CreatedWindowInfo::operator!=(const CreatedWindowInfo& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto CreatedWindowInfo::Init() -> void
{
}

auto CreatedWindowInfo::Assign(
        const nsresult& _rv,
        const bool& _windowOpened,
        const nsTArray<FrameScriptInfo>& _frameScripts,
        const nsCString& _urlToLoad,
        const TextureFactoryIdentifier& _textureFactoryIdentifier,
        const uint64_t& _layersId,
        const CompositorOptions& _compositorOptions,
        const uint32_t& _maxTouchPoints,
        const DimensionInfo& _dimensions) -> void
{
    rv_ = _rv;
    windowOpened_ = _windowOpened;
    frameScripts_ = _frameScripts;
    urlToLoad_ = _urlToLoad;
    textureFactoryIdentifier_ = _textureFactoryIdentifier;
    layersId_ = _layersId;
    compositorOptions_ = _compositorOptions;
    maxTouchPoints_ = _maxTouchPoints;
    dimensions_ = _dimensions;
}

} // namespace dom
} // namespace mozilla
