//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union OverlayHandle|
//
namespace mozilla {
namespace layers {
auto OverlayHandle::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tint32_t:
        {
            (ptr_int32_t())->~int32_t__tdef();
            break;
        }
    case Tnull_t:
        {
            (ptr_null_t())->~null_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT OverlayHandle::OverlayHandle(const int32_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(aOther);
    mType = Tint32_t;
}

MOZ_IMPLICIT OverlayHandle::OverlayHandle(const null_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_null_t()) null_t(aOther);
    mType = Tnull_t;
}

MOZ_IMPLICIT OverlayHandle::OverlayHandle(const OverlayHandle& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t((aOther).get_int32_t());
            break;
        }
    case Tnull_t:
        {
            new (mozilla::KnownNotNull, ptr_null_t()) null_t((aOther).get_null_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

OverlayHandle::~OverlayHandle()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto OverlayHandle::operator=(const int32_t& aRhs) -> OverlayHandle&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = aRhs;
    mType = Tint32_t;
    return (*(this));
}

auto OverlayHandle::operator=(const null_t& aRhs) -> OverlayHandle&
{
    if (MaybeDestroy(Tnull_t)) {
        new (mozilla::KnownNotNull, ptr_null_t()) null_t;
    }
    (*(ptr_null_t())) = aRhs;
    mType = Tnull_t;
    return (*(this));
}

auto OverlayHandle::operator=(const OverlayHandle& aRhs) -> OverlayHandle&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = (aRhs).get_int32_t();
            break;
        }
    case Tnull_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_null_t()) null_t;
            }
            (*(ptr_null_t())) = (aRhs).get_null_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto OverlayHandle::operator==(const int32_t& aRhs) const -> bool
{
    return (get_int32_t()) == (aRhs);
}

auto OverlayHandle::operator==(const null_t& aRhs) const -> bool
{
    return (get_null_t()) == (aRhs);
}

auto OverlayHandle::operator==(const OverlayHandle& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tint32_t:
        {
            return (get_int32_t()) == ((aRhs).get_int32_t());
        }
    case Tnull_t:
        {
            return (get_null_t()) == ((aRhs).get_null_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto OverlayHandle::get(int32_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_int32_t();
}

auto OverlayHandle::get(null_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_null_t();
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct OverlaySource|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT OverlaySource::OverlaySource() :
    size_()
{
    Init();
}

OverlaySource::~OverlaySource()
{
}

auto OverlaySource::operator==(const OverlaySource& _o) const -> bool
{
    if ((!((handle()) == ((_o).handle())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    return true;
}

auto OverlaySource::operator!=(const OverlaySource& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto OverlaySource::Init() -> void
{
}

auto OverlaySource::Assign(
        const OverlayHandle& _handle,
        const IntSize& _size) -> void
{
    handle_ = _handle;
    size_ = _size;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorFileMapping|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorFileMapping::SurfaceDescriptorFileMapping() :
    handle_(),
    format_(),
    size_()
{
    Init();
}

SurfaceDescriptorFileMapping::~SurfaceDescriptorFileMapping()
{
}

auto SurfaceDescriptorFileMapping::operator==(const SurfaceDescriptorFileMapping& _o) const -> bool
{
    if ((!((handle()) == ((_o).handle())))) {
        return false;
    }
    if ((!((format()) == ((_o).format())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorFileMapping::operator!=(const SurfaceDescriptorFileMapping& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorFileMapping::Init() -> void
{
}

auto SurfaceDescriptorFileMapping::Assign(
        const WindowsHandle& _handle,
        const SurfaceFormat& _format,
        const IntSize& _size) -> void
{
    handle_ = _handle;
    format_ = _format;
    size_ = _size;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorDIB|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorDIB::SurfaceDescriptorDIB() :
    surface_()
{
    Init();
}

SurfaceDescriptorDIB::~SurfaceDescriptorDIB()
{
}

auto SurfaceDescriptorDIB::operator==(const SurfaceDescriptorDIB& _o) const -> bool
{
    if ((!((surface()) == ((_o).surface())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorDIB::operator!=(const SurfaceDescriptorDIB& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorDIB::Init() -> void
{
}

auto SurfaceDescriptorDIB::Assign(const uintptr_t& _surface) -> void
{
    surface_ = _surface;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorD3D10|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorD3D10::SurfaceDescriptorD3D10() :
    handle_(),
    format_(),
    size_()
{
    Init();
}

SurfaceDescriptorD3D10::~SurfaceDescriptorD3D10()
{
}

auto SurfaceDescriptorD3D10::operator==(const SurfaceDescriptorD3D10& _o) const -> bool
{
    if ((!((handle()) == ((_o).handle())))) {
        return false;
    }
    if ((!((format()) == ((_o).format())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorD3D10::operator!=(const SurfaceDescriptorD3D10& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorD3D10::Init() -> void
{
}

auto SurfaceDescriptorD3D10::Assign(
        const WindowsHandle& _handle,
        const SurfaceFormat& _format,
        const IntSize& _size) -> void
{
    handle_ = _handle;
    format_ = _format;
    size_ = _size;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorDXGIYCbCr|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr::SurfaceDescriptorDXGIYCbCr() :
    handleY_(),
    handleCb_(),
    handleCr_(),
    size_(),
    sizeY_(),
    sizeCbCr_()
{
    Init();
}

SurfaceDescriptorDXGIYCbCr::~SurfaceDescriptorDXGIYCbCr()
{
}

auto SurfaceDescriptorDXGIYCbCr::operator==(const SurfaceDescriptorDXGIYCbCr& _o) const -> bool
{
    if ((!((handleY()) == ((_o).handleY())))) {
        return false;
    }
    if ((!((handleCb()) == ((_o).handleCb())))) {
        return false;
    }
    if ((!((handleCr()) == ((_o).handleCr())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((sizeY()) == ((_o).sizeY())))) {
        return false;
    }
    if ((!((sizeCbCr()) == ((_o).sizeCbCr())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorDXGIYCbCr::operator!=(const SurfaceDescriptorDXGIYCbCr& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorDXGIYCbCr::Init() -> void
{
}

auto SurfaceDescriptorDXGIYCbCr::Assign(
        const WindowsHandle& _handleY,
        const WindowsHandle& _handleCb,
        const WindowsHandle& _handleCr,
        const IntSize& _size,
        const IntSize& _sizeY,
        const IntSize& _sizeCbCr) -> void
{
    handleY_ = _handleY;
    handleCb_ = _handleCb;
    handleCr_ = _handleCr;
    size_ = _size;
    sizeY_ = _sizeY;
    sizeCbCr_ = _sizeCbCr;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorMacIOSurface|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorMacIOSurface::SurfaceDescriptorMacIOSurface() :
    surfaceId_(),
    scaleFactor_(),
    isOpaque_()
{
    Init();
}

SurfaceDescriptorMacIOSurface::~SurfaceDescriptorMacIOSurface()
{
}

auto SurfaceDescriptorMacIOSurface::operator==(const SurfaceDescriptorMacIOSurface& _o) const -> bool
{
    if ((!((surfaceId()) == ((_o).surfaceId())))) {
        return false;
    }
    if ((!((scaleFactor()) == ((_o).scaleFactor())))) {
        return false;
    }
    if ((!((isOpaque()) == ((_o).isOpaque())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorMacIOSurface::operator!=(const SurfaceDescriptorMacIOSurface& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorMacIOSurface::Init() -> void
{
}

auto SurfaceDescriptorMacIOSurface::Assign(
        const uint32_t& _surfaceId,
        const double& _scaleFactor,
        const bool& _isOpaque) -> void
{
    surfaceId_ = _surfaceId;
    scaleFactor_ = _scaleFactor;
    isOpaque_ = _isOpaque;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceTextureDescriptor|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceTextureDescriptor::SurfaceTextureDescriptor() :
    handle_(),
    size_(),
    continuous_()
{
    Init();
}

SurfaceTextureDescriptor::~SurfaceTextureDescriptor()
{
}

auto SurfaceTextureDescriptor::operator==(const SurfaceTextureDescriptor& _o) const -> bool
{
    if ((!((handle()) == ((_o).handle())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((continuous()) == ((_o).continuous())))) {
        return false;
    }
    return true;
}

auto SurfaceTextureDescriptor::operator!=(const SurfaceTextureDescriptor& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceTextureDescriptor::Init() -> void
{
}

auto SurfaceTextureDescriptor::Assign(
        const uint64_t& _handle,
        const IntSize& _size,
        const bool& _continuous) -> void
{
    handle_ = _handle;
    size_ = _size;
    continuous_ = _continuous;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct EGLImageDescriptor|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT EGLImageDescriptor::EGLImageDescriptor() :
    image_(),
    fence_(),
    size_(),
    hasAlpha_()
{
    Init();
}

EGLImageDescriptor::~EGLImageDescriptor()
{
}

auto EGLImageDescriptor::operator==(const EGLImageDescriptor& _o) const -> bool
{
    if ((!((image()) == ((_o).image())))) {
        return false;
    }
    if ((!((fence()) == ((_o).fence())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((hasAlpha()) == ((_o).hasAlpha())))) {
        return false;
    }
    return true;
}

auto EGLImageDescriptor::operator!=(const EGLImageDescriptor& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto EGLImageDescriptor::Init() -> void
{
}

auto EGLImageDescriptor::Assign(
        const uintptr_t& _image,
        const uintptr_t& _fence,
        const IntSize& _size,
        const bool& _hasAlpha) -> void
{
    image_ = _image;
    fence_ = _fence;
    size_ = _size;
    hasAlpha_ = _hasAlpha;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorSharedGLTexture|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorSharedGLTexture::SurfaceDescriptorSharedGLTexture() :
    texture_(),
    target_(),
    fence_(),
    size_(),
    hasAlpha_()
{
    Init();
}

SurfaceDescriptorSharedGLTexture::~SurfaceDescriptorSharedGLTexture()
{
}

auto SurfaceDescriptorSharedGLTexture::operator==(const SurfaceDescriptorSharedGLTexture& _o) const -> bool
{
    if ((!((texture()) == ((_o).texture())))) {
        return false;
    }
    if ((!((target()) == ((_o).target())))) {
        return false;
    }
    if ((!((fence()) == ((_o).fence())))) {
        return false;
    }
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((hasAlpha()) == ((_o).hasAlpha())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorSharedGLTexture::operator!=(const SurfaceDescriptorSharedGLTexture& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorSharedGLTexture::Init() -> void
{
}

auto SurfaceDescriptorSharedGLTexture::Assign(
        const uint32_t& _texture,
        const uint32_t& _target,
        const uintptr_t& _fence,
        const IntSize& _size,
        const bool& _hasAlpha) -> void
{
    texture_ = _texture;
    target_ = _target;
    fence_ = _fence;
    size_ = _size;
    hasAlpha_ = _hasAlpha;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union GPUVideoSubDescriptor|
//
namespace mozilla {
namespace layers {
auto GPUVideoSubDescriptor::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TSurfaceDescriptorD3D10:
        {
            (ptr_SurfaceDescriptorD3D10())->~SurfaceDescriptorD3D10__tdef();
            break;
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            (ptr_SurfaceDescriptorDXGIYCbCr())->~SurfaceDescriptorDXGIYCbCr__tdef();
            break;
        }
    case Tnull_t:
        {
            (ptr_null_t())->~null_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT GPUVideoSubDescriptor::GPUVideoSubDescriptor(const SurfaceDescriptorD3D10& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10(aOther);
    mType = TSurfaceDescriptorD3D10;
}

MOZ_IMPLICIT GPUVideoSubDescriptor::GPUVideoSubDescriptor(const SurfaceDescriptorDXGIYCbCr& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr(aOther);
    mType = TSurfaceDescriptorDXGIYCbCr;
}

MOZ_IMPLICIT GPUVideoSubDescriptor::GPUVideoSubDescriptor(const null_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_null_t()) null_t(aOther);
    mType = Tnull_t;
}

MOZ_IMPLICIT GPUVideoSubDescriptor::GPUVideoSubDescriptor(const GPUVideoSubDescriptor& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TSurfaceDescriptorD3D10:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10((aOther).get_SurfaceDescriptorD3D10());
            break;
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr((aOther).get_SurfaceDescriptorDXGIYCbCr());
            break;
        }
    case Tnull_t:
        {
            new (mozilla::KnownNotNull, ptr_null_t()) null_t((aOther).get_null_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

GPUVideoSubDescriptor::~GPUVideoSubDescriptor()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto GPUVideoSubDescriptor::operator=(const SurfaceDescriptorD3D10& aRhs) -> GPUVideoSubDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorD3D10)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10;
    }
    (*(ptr_SurfaceDescriptorD3D10())) = aRhs;
    mType = TSurfaceDescriptorD3D10;
    return (*(this));
}

auto GPUVideoSubDescriptor::operator=(const SurfaceDescriptorDXGIYCbCr& aRhs) -> GPUVideoSubDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorDXGIYCbCr)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr;
    }
    (*(ptr_SurfaceDescriptorDXGIYCbCr())) = aRhs;
    mType = TSurfaceDescriptorDXGIYCbCr;
    return (*(this));
}

auto GPUVideoSubDescriptor::operator=(const null_t& aRhs) -> GPUVideoSubDescriptor&
{
    if (MaybeDestroy(Tnull_t)) {
        new (mozilla::KnownNotNull, ptr_null_t()) null_t;
    }
    (*(ptr_null_t())) = aRhs;
    mType = Tnull_t;
    return (*(this));
}

auto GPUVideoSubDescriptor::operator=(const GPUVideoSubDescriptor& aRhs) -> GPUVideoSubDescriptor&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TSurfaceDescriptorD3D10:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10;
            }
            (*(ptr_SurfaceDescriptorD3D10())) = (aRhs).get_SurfaceDescriptorD3D10();
            break;
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr;
            }
            (*(ptr_SurfaceDescriptorDXGIYCbCr())) = (aRhs).get_SurfaceDescriptorDXGIYCbCr();
            break;
        }
    case Tnull_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_null_t()) null_t;
            }
            (*(ptr_null_t())) = (aRhs).get_null_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto GPUVideoSubDescriptor::operator==(const SurfaceDescriptorD3D10& aRhs) const -> bool
{
    return (get_SurfaceDescriptorD3D10()) == (aRhs);
}

auto GPUVideoSubDescriptor::operator==(const SurfaceDescriptorDXGIYCbCr& aRhs) const -> bool
{
    return (get_SurfaceDescriptorDXGIYCbCr()) == (aRhs);
}

auto GPUVideoSubDescriptor::operator==(const null_t& aRhs) const -> bool
{
    return (get_null_t()) == (aRhs);
}

auto GPUVideoSubDescriptor::operator==(const GPUVideoSubDescriptor& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TSurfaceDescriptorD3D10:
        {
            return (get_SurfaceDescriptorD3D10()) == ((aRhs).get_SurfaceDescriptorD3D10());
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            return (get_SurfaceDescriptorDXGIYCbCr()) == ((aRhs).get_SurfaceDescriptorDXGIYCbCr());
        }
    case Tnull_t:
        {
            return (get_null_t()) == ((aRhs).get_null_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto GPUVideoSubDescriptor::get(SurfaceDescriptorD3D10* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorD3D10();
}

auto GPUVideoSubDescriptor::get(SurfaceDescriptorDXGIYCbCr* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorDXGIYCbCr();
}

auto GPUVideoSubDescriptor::get(null_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_null_t();
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorGPUVideo|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorGPUVideo::SurfaceDescriptorGPUVideo() :
    handle_()
{
    Init();
}

SurfaceDescriptorGPUVideo::~SurfaceDescriptorGPUVideo()
{
}

auto SurfaceDescriptorGPUVideo::operator==(const SurfaceDescriptorGPUVideo& _o) const -> bool
{
    if ((!((handle()) == ((_o).handle())))) {
        return false;
    }
    if ((!((subdesc()) == ((_o).subdesc())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorGPUVideo::operator!=(const SurfaceDescriptorGPUVideo& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorGPUVideo::Init() -> void
{
}

auto SurfaceDescriptorGPUVideo::Assign(
        const uint64_t& _handle,
        const GPUVideoSubDescriptor& _subdesc) -> void
{
    handle_ = _handle;
    subdesc_ = _subdesc;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct RGBDescriptor|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT RGBDescriptor::RGBDescriptor() :
    size_(),
    format_(),
    hasIntermediateBuffer_()
{
    Init();
}

RGBDescriptor::~RGBDescriptor()
{
}

auto RGBDescriptor::operator==(const RGBDescriptor& _o) const -> bool
{
    if ((!((size()) == ((_o).size())))) {
        return false;
    }
    if ((!((format()) == ((_o).format())))) {
        return false;
    }
    if ((!((hasIntermediateBuffer()) == ((_o).hasIntermediateBuffer())))) {
        return false;
    }
    return true;
}

auto RGBDescriptor::operator!=(const RGBDescriptor& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto RGBDescriptor::Init() -> void
{
}

auto RGBDescriptor::Assign(
        const IntSize& _size,
        const SurfaceFormat& _format,
        const bool& _hasIntermediateBuffer) -> void
{
    size_ = _size;
    format_ = _format;
    hasIntermediateBuffer_ = _hasIntermediateBuffer;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct YCbCrDescriptor|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT YCbCrDescriptor::YCbCrDescriptor() :
    ySize_(),
    yStride_(),
    cbCrSize_(),
    cbCrStride_(),
    yOffset_(),
    cbOffset_(),
    crOffset_(),
    stereoMode_(),
    yUVColorSpace_(),
    bitDepth_(),
    hasIntermediateBuffer_()
{
    Init();
}

YCbCrDescriptor::~YCbCrDescriptor()
{
}

auto YCbCrDescriptor::operator==(const YCbCrDescriptor& _o) const -> bool
{
    if ((!((ySize()) == ((_o).ySize())))) {
        return false;
    }
    if ((!((yStride()) == ((_o).yStride())))) {
        return false;
    }
    if ((!((cbCrSize()) == ((_o).cbCrSize())))) {
        return false;
    }
    if ((!((cbCrStride()) == ((_o).cbCrStride())))) {
        return false;
    }
    if ((!((yOffset()) == ((_o).yOffset())))) {
        return false;
    }
    if ((!((cbOffset()) == ((_o).cbOffset())))) {
        return false;
    }
    if ((!((crOffset()) == ((_o).crOffset())))) {
        return false;
    }
    if ((!((stereoMode()) == ((_o).stereoMode())))) {
        return false;
    }
    if ((!((yUVColorSpace()) == ((_o).yUVColorSpace())))) {
        return false;
    }
    if ((!((bitDepth()) == ((_o).bitDepth())))) {
        return false;
    }
    if ((!((hasIntermediateBuffer()) == ((_o).hasIntermediateBuffer())))) {
        return false;
    }
    return true;
}

auto YCbCrDescriptor::operator!=(const YCbCrDescriptor& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto YCbCrDescriptor::Init() -> void
{
}

auto YCbCrDescriptor::Assign(
        const IntSize& _ySize,
        const uint32_t& _yStride,
        const IntSize& _cbCrSize,
        const uint32_t& _cbCrStride,
        const uint32_t& _yOffset,
        const uint32_t& _cbOffset,
        const uint32_t& _crOffset,
        const StereoMode& _stereoMode,
        const YUVColorSpace& _yUVColorSpace,
        const uint32_t& _bitDepth,
        const bool& _hasIntermediateBuffer) -> void
{
    ySize_ = _ySize;
    yStride_ = _yStride;
    cbCrSize_ = _cbCrSize;
    cbCrStride_ = _cbCrStride;
    yOffset_ = _yOffset;
    cbOffset_ = _cbOffset;
    crOffset_ = _crOffset;
    stereoMode_ = _stereoMode;
    yUVColorSpace_ = _yUVColorSpace;
    bitDepth_ = _bitDepth;
    hasIntermediateBuffer_ = _hasIntermediateBuffer;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union BufferDescriptor|
//
namespace mozilla {
namespace layers {
auto BufferDescriptor::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TRGBDescriptor:
        {
            (ptr_RGBDescriptor())->~RGBDescriptor__tdef();
            break;
        }
    case TYCbCrDescriptor:
        {
            (ptr_YCbCrDescriptor())->~YCbCrDescriptor__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT BufferDescriptor::BufferDescriptor(const RGBDescriptor& aOther)
{
    new (mozilla::KnownNotNull, ptr_RGBDescriptor()) RGBDescriptor(aOther);
    mType = TRGBDescriptor;
}

MOZ_IMPLICIT BufferDescriptor::BufferDescriptor(const YCbCrDescriptor& aOther)
{
    new (mozilla::KnownNotNull, ptr_YCbCrDescriptor()) YCbCrDescriptor(aOther);
    mType = TYCbCrDescriptor;
}

MOZ_IMPLICIT BufferDescriptor::BufferDescriptor(const BufferDescriptor& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TRGBDescriptor:
        {
            new (mozilla::KnownNotNull, ptr_RGBDescriptor()) RGBDescriptor((aOther).get_RGBDescriptor());
            break;
        }
    case TYCbCrDescriptor:
        {
            new (mozilla::KnownNotNull, ptr_YCbCrDescriptor()) YCbCrDescriptor((aOther).get_YCbCrDescriptor());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

BufferDescriptor::~BufferDescriptor()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto BufferDescriptor::operator=(const RGBDescriptor& aRhs) -> BufferDescriptor&
{
    if (MaybeDestroy(TRGBDescriptor)) {
        new (mozilla::KnownNotNull, ptr_RGBDescriptor()) RGBDescriptor;
    }
    (*(ptr_RGBDescriptor())) = aRhs;
    mType = TRGBDescriptor;
    return (*(this));
}

auto BufferDescriptor::operator=(const YCbCrDescriptor& aRhs) -> BufferDescriptor&
{
    if (MaybeDestroy(TYCbCrDescriptor)) {
        new (mozilla::KnownNotNull, ptr_YCbCrDescriptor()) YCbCrDescriptor;
    }
    (*(ptr_YCbCrDescriptor())) = aRhs;
    mType = TYCbCrDescriptor;
    return (*(this));
}

auto BufferDescriptor::operator=(const BufferDescriptor& aRhs) -> BufferDescriptor&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TRGBDescriptor:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RGBDescriptor()) RGBDescriptor;
            }
            (*(ptr_RGBDescriptor())) = (aRhs).get_RGBDescriptor();
            break;
        }
    case TYCbCrDescriptor:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_YCbCrDescriptor()) YCbCrDescriptor;
            }
            (*(ptr_YCbCrDescriptor())) = (aRhs).get_YCbCrDescriptor();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto BufferDescriptor::operator==(const RGBDescriptor& aRhs) const -> bool
{
    return (get_RGBDescriptor()) == (aRhs);
}

auto BufferDescriptor::operator==(const YCbCrDescriptor& aRhs) const -> bool
{
    return (get_YCbCrDescriptor()) == (aRhs);
}

auto BufferDescriptor::operator==(const BufferDescriptor& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TRGBDescriptor:
        {
            return (get_RGBDescriptor()) == ((aRhs).get_RGBDescriptor());
        }
    case TYCbCrDescriptor:
        {
            return (get_YCbCrDescriptor()) == ((aRhs).get_YCbCrDescriptor());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto BufferDescriptor::get(RGBDescriptor* aOutValue) const -> void
{
    (*(aOutValue)) = get_RGBDescriptor();
}

auto BufferDescriptor::get(YCbCrDescriptor* aOutValue) const -> void
{
    (*(aOutValue)) = get_YCbCrDescriptor();
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union MemoryOrShmem|
//
namespace mozilla {
namespace layers {
auto MemoryOrShmem::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tuintptr_t:
        {
            (ptr_uintptr_t())->~uintptr_t__tdef();
            break;
        }
    case TShmem:
        {
            (ptr_Shmem())->~Shmem__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT MemoryOrShmem::MemoryOrShmem(const uintptr_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_uintptr_t()) uintptr_t(aOther);
    mType = Tuintptr_t;
}

MOZ_IMPLICIT MemoryOrShmem::MemoryOrShmem(Shmem& aOther)
{
    new (mozilla::KnownNotNull, ptr_Shmem()) Shmem(aOther);
    mType = TShmem;
}

MOZ_IMPLICIT MemoryOrShmem::MemoryOrShmem(const MemoryOrShmem& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tuintptr_t:
        {
            new (mozilla::KnownNotNull, ptr_uintptr_t()) uintptr_t((aOther).get_uintptr_t());
            break;
        }
    case TShmem:
        {
            new (mozilla::KnownNotNull, ptr_Shmem()) Shmem((aOther).get_Shmem());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MemoryOrShmem::~MemoryOrShmem()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto MemoryOrShmem::operator=(const uintptr_t& aRhs) -> MemoryOrShmem&
{
    if (MaybeDestroy(Tuintptr_t)) {
        new (mozilla::KnownNotNull, ptr_uintptr_t()) uintptr_t;
    }
    (*(ptr_uintptr_t())) = aRhs;
    mType = Tuintptr_t;
    return (*(this));
}

auto MemoryOrShmem::operator=(Shmem& aRhs) -> MemoryOrShmem&
{
    if (MaybeDestroy(TShmem)) {
        new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
    }
    (*(ptr_Shmem())) = aRhs;
    mType = TShmem;
    return (*(this));
}

auto MemoryOrShmem::operator=(const MemoryOrShmem& aRhs) -> MemoryOrShmem&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tuintptr_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_uintptr_t()) uintptr_t;
            }
            (*(ptr_uintptr_t())) = (aRhs).get_uintptr_t();
            break;
        }
    case TShmem:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_Shmem()) Shmem;
            }
            (*(ptr_Shmem())) = (aRhs).get_Shmem();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto MemoryOrShmem::operator==(const uintptr_t& aRhs) const -> bool
{
    return (get_uintptr_t()) == (aRhs);
}

auto MemoryOrShmem::operator==(Shmem& aRhs) const -> bool
{
    return (get_Shmem()) == (aRhs);
}

auto MemoryOrShmem::operator==(const MemoryOrShmem& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tuintptr_t:
        {
            return (get_uintptr_t()) == ((aRhs).get_uintptr_t());
        }
    case TShmem:
        {
            return (get_Shmem()) == ((aRhs).get_Shmem());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto MemoryOrShmem::get(uintptr_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_uintptr_t();
}

auto MemoryOrShmem::get(Shmem* aOutValue) const -> void
{
    (*(aOutValue)) = get_Shmem();
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SurfaceDescriptorBuffer|
//
namespace mozilla {
namespace layers {
MOZ_IMPLICIT SurfaceDescriptorBuffer::SurfaceDescriptorBuffer()
{
    Init();
}

SurfaceDescriptorBuffer::~SurfaceDescriptorBuffer()
{
}

auto SurfaceDescriptorBuffer::operator==(const SurfaceDescriptorBuffer& _o) const -> bool
{
    if ((!((desc()) == ((_o).desc())))) {
        return false;
    }
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    return true;
}

auto SurfaceDescriptorBuffer::operator!=(const SurfaceDescriptorBuffer& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto SurfaceDescriptorBuffer::Init() -> void
{
}

auto SurfaceDescriptorBuffer::Assign(
        const BufferDescriptor& _desc,
        const MemoryOrShmem& _data) -> void
{
    desc_ = _desc;
    data_ = _data;
}

} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union SurfaceDescriptor|
//
namespace mozilla {
namespace layers {
auto SurfaceDescriptor::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TSurfaceDescriptorBuffer:
        {
            (ptr_SurfaceDescriptorBuffer())->~SurfaceDescriptorBuffer__tdef();
            break;
        }
    case TSurfaceDescriptorDIB:
        {
            (ptr_SurfaceDescriptorDIB())->~SurfaceDescriptorDIB__tdef();
            break;
        }
    case TSurfaceDescriptorD3D10:
        {
            (ptr_SurfaceDescriptorD3D10())->~SurfaceDescriptorD3D10__tdef();
            break;
        }
    case TSurfaceDescriptorFileMapping:
        {
            (ptr_SurfaceDescriptorFileMapping())->~SurfaceDescriptorFileMapping__tdef();
            break;
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            (ptr_SurfaceDescriptorDXGIYCbCr())->~SurfaceDescriptorDXGIYCbCr__tdef();
            break;
        }
    case TSurfaceDescriptorX11:
        {
            (ptr_SurfaceDescriptorX11())->~SurfaceDescriptorX11__tdef();
            break;
        }
    case TSurfaceTextureDescriptor:
        {
            (ptr_SurfaceTextureDescriptor())->~SurfaceTextureDescriptor__tdef();
            break;
        }
    case TEGLImageDescriptor:
        {
            (ptr_EGLImageDescriptor())->~EGLImageDescriptor__tdef();
            break;
        }
    case TSurfaceDescriptorMacIOSurface:
        {
            (ptr_SurfaceDescriptorMacIOSurface())->~SurfaceDescriptorMacIOSurface__tdef();
            break;
        }
    case TSurfaceDescriptorSharedGLTexture:
        {
            (ptr_SurfaceDescriptorSharedGLTexture())->~SurfaceDescriptorSharedGLTexture__tdef();
            break;
        }
    case TSurfaceDescriptorGPUVideo:
        {
            (ptr_SurfaceDescriptorGPUVideo())->~SurfaceDescriptorGPUVideo__tdef();
            break;
        }
    case Tnull_t:
        {
            (ptr_null_t())->~null_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorBuffer& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorBuffer()) SurfaceDescriptorBuffer(aOther);
    mType = TSurfaceDescriptorBuffer;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorDIB& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDIB()) SurfaceDescriptorDIB(aOther);
    mType = TSurfaceDescriptorDIB;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorD3D10& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10(aOther);
    mType = TSurfaceDescriptorD3D10;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorFileMapping& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorFileMapping()) SurfaceDescriptorFileMapping(aOther);
    mType = TSurfaceDescriptorFileMapping;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorDXGIYCbCr& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr(aOther);
    mType = TSurfaceDescriptorDXGIYCbCr;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorX11& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11(aOther);
    mType = TSurfaceDescriptorX11;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceTextureDescriptor& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceTextureDescriptor()) SurfaceTextureDescriptor(aOther);
    mType = TSurfaceTextureDescriptor;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const EGLImageDescriptor& aOther)
{
    new (mozilla::KnownNotNull, ptr_EGLImageDescriptor()) EGLImageDescriptor(aOther);
    mType = TEGLImageDescriptor;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorMacIOSurface& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorMacIOSurface()) SurfaceDescriptorMacIOSurface(aOther);
    mType = TSurfaceDescriptorMacIOSurface;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorSharedGLTexture& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorSharedGLTexture()) SurfaceDescriptorSharedGLTexture(aOther);
    mType = TSurfaceDescriptorSharedGLTexture;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptorGPUVideo& aOther)
{
    new (mozilla::KnownNotNull, ptr_SurfaceDescriptorGPUVideo()) SurfaceDescriptorGPUVideo(aOther);
    mType = TSurfaceDescriptorGPUVideo;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const null_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_null_t()) null_t(aOther);
    mType = Tnull_t;
}

MOZ_IMPLICIT SurfaceDescriptor::SurfaceDescriptor(const SurfaceDescriptor& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TSurfaceDescriptorBuffer:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorBuffer()) SurfaceDescriptorBuffer((aOther).get_SurfaceDescriptorBuffer());
            break;
        }
    case TSurfaceDescriptorDIB:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDIB()) SurfaceDescriptorDIB((aOther).get_SurfaceDescriptorDIB());
            break;
        }
    case TSurfaceDescriptorD3D10:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10((aOther).get_SurfaceDescriptorD3D10());
            break;
        }
    case TSurfaceDescriptorFileMapping:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorFileMapping()) SurfaceDescriptorFileMapping((aOther).get_SurfaceDescriptorFileMapping());
            break;
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr((aOther).get_SurfaceDescriptorDXGIYCbCr());
            break;
        }
    case TSurfaceDescriptorX11:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11((aOther).get_SurfaceDescriptorX11());
            break;
        }
    case TSurfaceTextureDescriptor:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceTextureDescriptor()) SurfaceTextureDescriptor((aOther).get_SurfaceTextureDescriptor());
            break;
        }
    case TEGLImageDescriptor:
        {
            new (mozilla::KnownNotNull, ptr_EGLImageDescriptor()) EGLImageDescriptor((aOther).get_EGLImageDescriptor());
            break;
        }
    case TSurfaceDescriptorMacIOSurface:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorMacIOSurface()) SurfaceDescriptorMacIOSurface((aOther).get_SurfaceDescriptorMacIOSurface());
            break;
        }
    case TSurfaceDescriptorSharedGLTexture:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorSharedGLTexture()) SurfaceDescriptorSharedGLTexture((aOther).get_SurfaceDescriptorSharedGLTexture());
            break;
        }
    case TSurfaceDescriptorGPUVideo:
        {
            new (mozilla::KnownNotNull, ptr_SurfaceDescriptorGPUVideo()) SurfaceDescriptorGPUVideo((aOther).get_SurfaceDescriptorGPUVideo());
            break;
        }
    case Tnull_t:
        {
            new (mozilla::KnownNotNull, ptr_null_t()) null_t((aOther).get_null_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

SurfaceDescriptor::~SurfaceDescriptor()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorBuffer& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorBuffer)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorBuffer()) SurfaceDescriptorBuffer;
    }
    (*(ptr_SurfaceDescriptorBuffer())) = aRhs;
    mType = TSurfaceDescriptorBuffer;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorDIB& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorDIB)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDIB()) SurfaceDescriptorDIB;
    }
    (*(ptr_SurfaceDescriptorDIB())) = aRhs;
    mType = TSurfaceDescriptorDIB;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorD3D10& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorD3D10)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10;
    }
    (*(ptr_SurfaceDescriptorD3D10())) = aRhs;
    mType = TSurfaceDescriptorD3D10;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorFileMapping& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorFileMapping)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorFileMapping()) SurfaceDescriptorFileMapping;
    }
    (*(ptr_SurfaceDescriptorFileMapping())) = aRhs;
    mType = TSurfaceDescriptorFileMapping;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorDXGIYCbCr& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorDXGIYCbCr)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr;
    }
    (*(ptr_SurfaceDescriptorDXGIYCbCr())) = aRhs;
    mType = TSurfaceDescriptorDXGIYCbCr;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorX11& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorX11)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11;
    }
    (*(ptr_SurfaceDescriptorX11())) = aRhs;
    mType = TSurfaceDescriptorX11;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceTextureDescriptor& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceTextureDescriptor)) {
        new (mozilla::KnownNotNull, ptr_SurfaceTextureDescriptor()) SurfaceTextureDescriptor;
    }
    (*(ptr_SurfaceTextureDescriptor())) = aRhs;
    mType = TSurfaceTextureDescriptor;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const EGLImageDescriptor& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TEGLImageDescriptor)) {
        new (mozilla::KnownNotNull, ptr_EGLImageDescriptor()) EGLImageDescriptor;
    }
    (*(ptr_EGLImageDescriptor())) = aRhs;
    mType = TEGLImageDescriptor;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorMacIOSurface& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorMacIOSurface)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorMacIOSurface()) SurfaceDescriptorMacIOSurface;
    }
    (*(ptr_SurfaceDescriptorMacIOSurface())) = aRhs;
    mType = TSurfaceDescriptorMacIOSurface;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorSharedGLTexture& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorSharedGLTexture)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorSharedGLTexture()) SurfaceDescriptorSharedGLTexture;
    }
    (*(ptr_SurfaceDescriptorSharedGLTexture())) = aRhs;
    mType = TSurfaceDescriptorSharedGLTexture;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptorGPUVideo& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(TSurfaceDescriptorGPUVideo)) {
        new (mozilla::KnownNotNull, ptr_SurfaceDescriptorGPUVideo()) SurfaceDescriptorGPUVideo;
    }
    (*(ptr_SurfaceDescriptorGPUVideo())) = aRhs;
    mType = TSurfaceDescriptorGPUVideo;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const null_t& aRhs) -> SurfaceDescriptor&
{
    if (MaybeDestroy(Tnull_t)) {
        new (mozilla::KnownNotNull, ptr_null_t()) null_t;
    }
    (*(ptr_null_t())) = aRhs;
    mType = Tnull_t;
    return (*(this));
}

auto SurfaceDescriptor::operator=(const SurfaceDescriptor& aRhs) -> SurfaceDescriptor&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TSurfaceDescriptorBuffer:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorBuffer()) SurfaceDescriptorBuffer;
            }
            (*(ptr_SurfaceDescriptorBuffer())) = (aRhs).get_SurfaceDescriptorBuffer();
            break;
        }
    case TSurfaceDescriptorDIB:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDIB()) SurfaceDescriptorDIB;
            }
            (*(ptr_SurfaceDescriptorDIB())) = (aRhs).get_SurfaceDescriptorDIB();
            break;
        }
    case TSurfaceDescriptorD3D10:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorD3D10()) SurfaceDescriptorD3D10;
            }
            (*(ptr_SurfaceDescriptorD3D10())) = (aRhs).get_SurfaceDescriptorD3D10();
            break;
        }
    case TSurfaceDescriptorFileMapping:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorFileMapping()) SurfaceDescriptorFileMapping;
            }
            (*(ptr_SurfaceDescriptorFileMapping())) = (aRhs).get_SurfaceDescriptorFileMapping();
            break;
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorDXGIYCbCr()) SurfaceDescriptorDXGIYCbCr;
            }
            (*(ptr_SurfaceDescriptorDXGIYCbCr())) = (aRhs).get_SurfaceDescriptorDXGIYCbCr();
            break;
        }
    case TSurfaceDescriptorX11:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorX11()) SurfaceDescriptorX11;
            }
            (*(ptr_SurfaceDescriptorX11())) = (aRhs).get_SurfaceDescriptorX11();
            break;
        }
    case TSurfaceTextureDescriptor:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceTextureDescriptor()) SurfaceTextureDescriptor;
            }
            (*(ptr_SurfaceTextureDescriptor())) = (aRhs).get_SurfaceTextureDescriptor();
            break;
        }
    case TEGLImageDescriptor:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_EGLImageDescriptor()) EGLImageDescriptor;
            }
            (*(ptr_EGLImageDescriptor())) = (aRhs).get_EGLImageDescriptor();
            break;
        }
    case TSurfaceDescriptorMacIOSurface:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorMacIOSurface()) SurfaceDescriptorMacIOSurface;
            }
            (*(ptr_SurfaceDescriptorMacIOSurface())) = (aRhs).get_SurfaceDescriptorMacIOSurface();
            break;
        }
    case TSurfaceDescriptorSharedGLTexture:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorSharedGLTexture()) SurfaceDescriptorSharedGLTexture;
            }
            (*(ptr_SurfaceDescriptorSharedGLTexture())) = (aRhs).get_SurfaceDescriptorSharedGLTexture();
            break;
        }
    case TSurfaceDescriptorGPUVideo:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_SurfaceDescriptorGPUVideo()) SurfaceDescriptorGPUVideo;
            }
            (*(ptr_SurfaceDescriptorGPUVideo())) = (aRhs).get_SurfaceDescriptorGPUVideo();
            break;
        }
    case Tnull_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_null_t()) null_t;
            }
            (*(ptr_null_t())) = (aRhs).get_null_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorBuffer& aRhs) const -> bool
{
    return (get_SurfaceDescriptorBuffer()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorDIB& aRhs) const -> bool
{
    return (get_SurfaceDescriptorDIB()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorD3D10& aRhs) const -> bool
{
    return (get_SurfaceDescriptorD3D10()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorFileMapping& aRhs) const -> bool
{
    return (get_SurfaceDescriptorFileMapping()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorDXGIYCbCr& aRhs) const -> bool
{
    return (get_SurfaceDescriptorDXGIYCbCr()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorX11& aRhs) const -> bool
{
    return (get_SurfaceDescriptorX11()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceTextureDescriptor& aRhs) const -> bool
{
    return (get_SurfaceTextureDescriptor()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const EGLImageDescriptor& aRhs) const -> bool
{
    return (get_EGLImageDescriptor()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorMacIOSurface& aRhs) const -> bool
{
    return (get_SurfaceDescriptorMacIOSurface()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorSharedGLTexture& aRhs) const -> bool
{
    return (get_SurfaceDescriptorSharedGLTexture()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptorGPUVideo& aRhs) const -> bool
{
    return (get_SurfaceDescriptorGPUVideo()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const null_t& aRhs) const -> bool
{
    return (get_null_t()) == (aRhs);
}

auto SurfaceDescriptor::operator==(const SurfaceDescriptor& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TSurfaceDescriptorBuffer:
        {
            return (get_SurfaceDescriptorBuffer()) == ((aRhs).get_SurfaceDescriptorBuffer());
        }
    case TSurfaceDescriptorDIB:
        {
            return (get_SurfaceDescriptorDIB()) == ((aRhs).get_SurfaceDescriptorDIB());
        }
    case TSurfaceDescriptorD3D10:
        {
            return (get_SurfaceDescriptorD3D10()) == ((aRhs).get_SurfaceDescriptorD3D10());
        }
    case TSurfaceDescriptorFileMapping:
        {
            return (get_SurfaceDescriptorFileMapping()) == ((aRhs).get_SurfaceDescriptorFileMapping());
        }
    case TSurfaceDescriptorDXGIYCbCr:
        {
            return (get_SurfaceDescriptorDXGIYCbCr()) == ((aRhs).get_SurfaceDescriptorDXGIYCbCr());
        }
    case TSurfaceDescriptorX11:
        {
            return (get_SurfaceDescriptorX11()) == ((aRhs).get_SurfaceDescriptorX11());
        }
    case TSurfaceTextureDescriptor:
        {
            return (get_SurfaceTextureDescriptor()) == ((aRhs).get_SurfaceTextureDescriptor());
        }
    case TEGLImageDescriptor:
        {
            return (get_EGLImageDescriptor()) == ((aRhs).get_EGLImageDescriptor());
        }
    case TSurfaceDescriptorMacIOSurface:
        {
            return (get_SurfaceDescriptorMacIOSurface()) == ((aRhs).get_SurfaceDescriptorMacIOSurface());
        }
    case TSurfaceDescriptorSharedGLTexture:
        {
            return (get_SurfaceDescriptorSharedGLTexture()) == ((aRhs).get_SurfaceDescriptorSharedGLTexture());
        }
    case TSurfaceDescriptorGPUVideo:
        {
            return (get_SurfaceDescriptorGPUVideo()) == ((aRhs).get_SurfaceDescriptorGPUVideo());
        }
    case Tnull_t:
        {
            return (get_null_t()) == ((aRhs).get_null_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto SurfaceDescriptor::get(SurfaceDescriptorBuffer* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorBuffer();
}

auto SurfaceDescriptor::get(SurfaceDescriptorDIB* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorDIB();
}

auto SurfaceDescriptor::get(SurfaceDescriptorD3D10* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorD3D10();
}

auto SurfaceDescriptor::get(SurfaceDescriptorFileMapping* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorFileMapping();
}

auto SurfaceDescriptor::get(SurfaceDescriptorDXGIYCbCr* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorDXGIYCbCr();
}

auto SurfaceDescriptor::get(SurfaceDescriptorX11* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorX11();
}

auto SurfaceDescriptor::get(SurfaceTextureDescriptor* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceTextureDescriptor();
}

auto SurfaceDescriptor::get(EGLImageDescriptor* aOutValue) const -> void
{
    (*(aOutValue)) = get_EGLImageDescriptor();
}

auto SurfaceDescriptor::get(SurfaceDescriptorMacIOSurface* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorMacIOSurface();
}

auto SurfaceDescriptor::get(SurfaceDescriptorSharedGLTexture* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorSharedGLTexture();
}

auto SurfaceDescriptor::get(SurfaceDescriptorGPUVideo* aOutValue) const -> void
{
    (*(aOutValue)) = get_SurfaceDescriptorGPUVideo();
}

auto SurfaceDescriptor::get(null_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_null_t();
}

} // namespace layers
} // namespace mozilla
