//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/MemoryReportTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct MemoryReport|
//
namespace mozilla {
namespace dom {
MOZ_IMPLICIT MemoryReport::MemoryReport() :
    process_(),
    path_(),
    kind_(),
    units_(),
    amount_(),
    generation_(),
    desc_()
{
    Init();
}

MemoryReport::~MemoryReport()
{
}

auto MemoryReport::operator==(const MemoryReport& _o) const -> bool
{
    if ((!((process()) == ((_o).process())))) {
        return false;
    }
    if ((!((path()) == ((_o).path())))) {
        return false;
    }
    if ((!((kind()) == ((_o).kind())))) {
        return false;
    }
    if ((!((units()) == ((_o).units())))) {
        return false;
    }
    if ((!((amount()) == ((_o).amount())))) {
        return false;
    }
    if ((!((generation()) == ((_o).generation())))) {
        return false;
    }
    if ((!((desc()) == ((_o).desc())))) {
        return false;
    }
    return true;
}

auto MemoryReport::operator!=(const MemoryReport& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto MemoryReport::Init() -> void
{
}

auto MemoryReport::Assign(
        const nsCString& _process,
        const nsCString& _path,
        const int32_t& _kind,
        const int32_t& _units,
        const int64_t& _amount,
        const uint32_t& _generation,
        const nsCString& _desc) -> void
{
    process_ = _process;
    path_ = _path;
    kind_ = _kind;
    units_ = _units;
    amount_ = _amount;
    generation_ = _generation;
    desc_ = _desc;
}

} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union MaybeFileDesc|
//
namespace mozilla {
namespace dom {
auto MaybeFileDesc::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TFileDescriptor:
        {
            (ptr_FileDescriptor())->~FileDescriptor__tdef();
            break;
        }
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT MaybeFileDesc::MaybeFileDesc(const FileDescriptor& aOther)
{
    new (mozilla::KnownNotNull, ptr_FileDescriptor()) FileDescriptor(aOther);
    mType = TFileDescriptor;
}

MOZ_IMPLICIT MaybeFileDesc::MaybeFileDesc(const void_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT MaybeFileDesc::MaybeFileDesc(const MaybeFileDesc& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TFileDescriptor:
        {
            new (mozilla::KnownNotNull, ptr_FileDescriptor()) FileDescriptor((aOther).get_FileDescriptor());
            break;
        }
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MaybeFileDesc::~MaybeFileDesc()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto MaybeFileDesc::operator=(const FileDescriptor& aRhs) -> MaybeFileDesc&
{
    if (MaybeDestroy(TFileDescriptor)) {
        new (mozilla::KnownNotNull, ptr_FileDescriptor()) FileDescriptor;
    }
    (*(ptr_FileDescriptor())) = aRhs;
    mType = TFileDescriptor;
    return (*(this));
}

auto MaybeFileDesc::operator=(const void_t& aRhs) -> MaybeFileDesc&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto MaybeFileDesc::operator=(const MaybeFileDesc& aRhs) -> MaybeFileDesc&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TFileDescriptor:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_FileDescriptor()) FileDescriptor;
            }
            (*(ptr_FileDescriptor())) = (aRhs).get_FileDescriptor();
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto MaybeFileDesc::operator==(const FileDescriptor& aRhs) const -> bool
{
    return (get_FileDescriptor()) == (aRhs);
}

auto MaybeFileDesc::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto MaybeFileDesc::operator==(const MaybeFileDesc& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TFileDescriptor:
        {
            return (get_FileDescriptor()) == ((aRhs).get_FileDescriptor());
        }
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto MaybeFileDesc::get(FileDescriptor* aOutValue) const -> void
{
    (*(aOutValue)) = get_FileDescriptor();
}

auto MaybeFileDesc::get(void_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_void_t();
}

} // namespace dom
} // namespace mozilla
