//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStorageParent.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/cache/PCacheParent.h"
#include "mozilla/dom/cache/PCacheOpParent.h"
#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"
#include "mozilla/ipc/PChildToParentStreamParent.h"
#include "mozilla/ipc/PParentToChildStreamParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheStorageParent::RecvPCacheOpConstructor(
        PCacheOpParent* actor,
        const CacheOpArgs& aOpArgs) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}


MOZ_IMPLICIT PCacheStorageParent::PCacheStorageParent() :
    mozilla::ipc::IProtocol(mozilla::ipc::ParentSide),
    mState(PCacheStorage::__Dead)
{
    MOZ_COUNT_CTOR(PCacheStorageParent);
}

PCacheStorageParent::~PCacheStorageParent()
{
    MOZ_COUNT_DTOR(PCacheStorageParent);
}

auto PCacheStorageParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PCacheStorageParent::ManagedPCacheOpParent(nsTArray<PCacheOpParent*>& aArr) const -> void
{
    (mManagedPCacheOpParent).ToArray(aArr);
}

auto PCacheStorageParent::ManagedPCacheOpParent() const -> const ManagedContainer<PCacheOpParent>&
{
    return mManagedPCacheOpParent;
}

auto PCacheStorageParent::Send__delete__(PCacheStorageParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    IPC::Message* msg__ = PCacheStorage::Msg___delete__((actor)->Id());

    (actor)->Write(actor, msg__, false);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(875202478);



    if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
        mozilla::ipc::LogMessageForProtocol("PCacheStorageParent", (actor)->OtherPid(), "Sending ", (msg__)->type(), mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStorage::Msg___delete__", OTHER);
    PCacheStorage::Transition(PCacheStorage::Msg___delete____ID, (&((actor)->mState)));

    bool sendok__ = ((actor)->GetIPCChannel())->Send(msg__);

    IProtocol* mgr = (actor)->Manager();
    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    (mgr)->RemoveManagee(PCacheStorageMsgStart, actor);
    return sendok__;
}

auto PCacheStorageParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        {
            PCacheOpParent* actor = static_cast<PCacheOpParent*>(aListener);
            auto& container = mManagedPCacheOpParent;
            MOZ_RELEASE_ASSERT((container).Contains(actor), "actor not managed by this!");

            (container).RemoveEntry(actor);
            DeallocPCacheOpParent(actor);
            return;
        }
    default:
        {
            FatalError("unreached");
            return;
        }
    }
}

auto PCacheStorageParent::OnMessageReceived(const Message& msg__) -> PCacheStorageParent::Result
{
    switch ((msg__).type()) {
    case PCacheStorage::Msg_PCacheOpConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
                mozilla::ipc::LogMessageForProtocol("PCacheStorageParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg_PCacheOpConstructor", OTHER);

            PickleIterator iter__(msg__);
            ActorHandle handle__;
            PCacheOpParent* actor;
            CacheOpArgs aOpArgs;

            if ((!(Read((&(handle__)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 875202478)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            if ((!(Read((&(aOpArgs)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            // Sentinel = 'aOpArgs'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 2628124652)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__, (msg__).type());
            PCacheStorage::Transition(PCacheStorage::Msg_PCacheOpConstructor__ID, (&(mState)));
            actor = AllocPCacheOpParent(aOpArgs);
            if ((!(actor))) {
                NS_WARNING("Error constructing actor PCacheOpParent");
                return MsgValueError;
            }
            (actor)->SetManager(this);
            RegisterID(actor, (handle__).mId);
            (actor)->SetIPCChannel(GetIPCChannel());
            (mManagedPCacheOpParent).PutEntry(actor);
            (actor)->mState = mozilla::dom::cache::PCacheOp::__Start;

            if ((!(RecvPCacheOpConstructor(mozilla::Move(actor), mozilla::Move(aOpArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Msg_Teardown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
                mozilla::ipc::LogMessageForProtocol("PCacheStorageParent", OtherPid(), "Received ", ((&(msg__)))->type(), mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg_Teardown", OTHER);

            PCacheStorage::Transition(PCacheStorage::Msg_Teardown__ID, (&(mState)));
            if ((!(RecvTeardown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PCacheStorageParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageParent::Result
{
    return MsgNotKnown;
}

auto PCacheStorageParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStorageParent::GetProtocolTypeId() -> int32_t
{
    return PCacheStorageMsgStart;
}

auto PCacheStorageParent::ProtocolName() const -> const char*
{
    return "PCacheStorageParent";
}

auto PCacheStorageParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(Id());

    ActorDestroyReason subtreewhy = (((why) == (Deletion)) || ((why) == (FailedConstructor)) ? AncestorDeletion : why);

    {
        // Recursively shutting down PCacheOp kids
        nsTArray<PCacheOpParent*> kids;
        // Accumulate kids into a stable structure to iterate over
        ManagedPCacheOpParent(kids);
        for (auto& kid : kids) {
            // Guarding against a child removing a sibling from the list during the iteration.
            if ((mManagedPCacheOpParent).Contains(kid)) {
                (kid)->DestroySubtree(subtreewhy);
            }
        }
    }

    // Reject owning pending promises.
    (GetIPCChannel())->RejectPendingPromisesForActor(this);

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PCacheStorageParent::DeallocSubtree() -> void
{
    {
        // Recursively deleting PCacheOp kids
        for (auto iter = (mManagedPCacheOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            (((iter).Get())->GetKey())->DeallocSubtree();
        }

        for (auto iter = (mManagedPCacheOpParent).Iter(); (!((iter).Done())); (iter).Next()) {
            DeallocPCacheOpParent(((iter).Get())->GetKey());
        }
        (mManagedPCacheOpParent).Clear();
    }
}

auto PCacheStorageParent::Write(
        const SystemPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PCacheStorageParent::Read(
        SystemPrincipalInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<InputStreamParams>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);
    // Sentinel = ('length', 'InputStreamParams[]')
    (msg__)->WriteSentinel(348334258);

    for (auto& elem : v__) {
        Write(elem, msg__);
        // Sentinel = 'InputStreamParams[]'
        (msg__)->WriteSentinel(2927715197);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<InputStreamParams>* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    nsTArray<InputStreamParams> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        mozilla::ipc::ArrayLengthReadError("InputStreamParams[]");
        return false;
    }
    // Sentinel = ('length', 'InputStreamParams[]')
    if ((!((msg__)->ReadSentinel(iter__, 348334258)))) {
        mozilla::ipc::SentinelReadError("InputStreamParams[]");
        return false;
    }

    InputStreamParams* elems = (fa).AppendElements(length);
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(elems[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
        // Sentinel = 'InputStreamParams[]'
        if ((!((msg__)->ReadSentinel(iter__, 2927715197)))) {
            mozilla::ipc::SentinelReadError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const OptionalPrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef OptionalPrincipalInfo type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'OptionalPrincipalInfo'
    (msg__)->WriteSentinel(3041452007);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            // Sentinel = 'Tvoid_t'
            (msg__)->WriteSentinel(3041273328);
            return;
        }
    case type__::TPrincipalInfo:
        {
            Write((v__).get_PrincipalInfo(), msg__);
            // Sentinel = 'TPrincipalInfo'
            (msg__)->WriteSentinel(1396743580);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        OptionalPrincipalInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef OptionalPrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("OptionalPrincipalInfo");
        return false;
    }
    // Sentinel = 'OptionalPrincipalInfo'
    if ((!((msg__)->ReadSentinel(iter__, 3041452007)))) {
        mozilla::ipc::SentinelReadError("OptionalPrincipalInfo");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_void_t())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((msg__)->ReadSentinel(iter__, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TPrincipalInfo:
        {
            PrincipalInfo tmp = PrincipalInfo();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_PrincipalInfo())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TPrincipalInfo'
            if ((!((msg__)->ReadSentinel(iter__, 1396743580)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const nsTArray<CacheRequestResponse>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);
    // Sentinel = ('length', 'CacheRequestResponse[]')
    (msg__)->WriteSentinel(3350175795);

    for (auto& elem : v__) {
        Write(elem, msg__);
        // Sentinel = 'CacheRequestResponse[]'
        (msg__)->WriteSentinel(1625719430);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<CacheRequestResponse>* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    nsTArray<CacheRequestResponse> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        mozilla::ipc::ArrayLengthReadError("CacheRequestResponse[]");
        return false;
    }
    // Sentinel = ('length', 'CacheRequestResponse[]')
    if ((!((msg__)->ReadSentinel(iter__, 3350175795)))) {
        mozilla::ipc::SentinelReadError("CacheRequestResponse[]");
        return false;
    }

    CacheRequestResponse* elems = (fa).AppendElements(length);
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(elems[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'CacheRequestResponse[i]'");
            return false;
        }
        // Sentinel = 'CacheRequestResponse[]'
        if ((!((msg__)->ReadSentinel(iter__, 1625719430)))) {
            mozilla::ipc::SentinelReadError("Error deserializing 'CacheRequestResponse[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const StorageOpenArgs& v__,
        Message* msg__) -> void
{
    Write((v__).key(), msg__);
    // Sentinel = 'key'
    (msg__)->WriteSentinel(35142870);
}

auto PCacheStorageParent::Read(
        StorageOpenArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->key())), msg__, iter__)))) {
        FatalError("Error deserializing 'key' (nsString) member of 'StorageOpenArgs'");
        return false;
    }
    // Sentinel = 'key'
    if ((!((msg__)->ReadSentinel(iter__, 35142870)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'key' (nsString) member of 'StorageOpenArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheRequestResponse& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    // Sentinel = 'request'
    (msg__)->WriteSentinel(2366856172);
    Write((v__).response(), msg__);
    // Sentinel = 'response'
    (msg__)->WriteSentinel(2396115421);
}

auto PCacheStorageParent::Read(
        CacheRequestResponse* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'CacheRequestResponse'");
        return false;
    }
    // Sentinel = 'request'
    if ((!((msg__)->ReadSentinel(iter__, 2366856172)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'request' (CacheRequest) member of 'CacheRequestResponse'");
        return false;
    }
    if ((!(Read((&((v__)->response())), msg__, iter__)))) {
        FatalError("Error deserializing 'response' (CacheResponse) member of 'CacheRequestResponse'");
        return false;
    }
    // Sentinel = 'response'
    if ((!((msg__)->ReadSentinel(iter__, 2396115421)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'response' (CacheResponse) member of 'CacheRequestResponse'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const ContentPrincipalInfoOriginNoSuffix& v__,
        Message* msg__) -> void
{
    typedef ContentPrincipalInfoOriginNoSuffix type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'ContentPrincipalInfoOriginNoSuffix'
    (msg__)->WriteSentinel(2442066713);

    switch ((v__).type()) {
    case type__::TnsCString:
        {
            Write((v__).get_nsCString(), msg__);
            // Sentinel = 'TnsCString'
            (msg__)->WriteSentinel(2427411293);
            return;
        }
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            // Sentinel = 'Tvoid_t'
            (msg__)->WriteSentinel(3041273328);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        ContentPrincipalInfoOriginNoSuffix* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef ContentPrincipalInfoOriginNoSuffix type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("ContentPrincipalInfoOriginNoSuffix");
        return false;
    }
    // Sentinel = 'ContentPrincipalInfoOriginNoSuffix'
    if ((!((msg__)->ReadSentinel(iter__, 2442066713)))) {
        mozilla::ipc::SentinelReadError("ContentPrincipalInfoOriginNoSuffix");
        return false;
    }

    switch (type) {
    case type__::TnsCString:
        {
            nsCString tmp = nsCString();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_nsCString())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TnsCString'
            if ((!((msg__)->ReadSentinel(iter__, 2427411293)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_void_t())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((msg__)->ReadSentinel(iter__, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheRequest& v__,
        Message* msg__) -> void
{
    Write((v__).method(), msg__);
    // Sentinel = 'method'
    (msg__)->WriteSentinel(1846382781);
    Write((v__).urlWithoutQuery(), msg__);
    // Sentinel = 'urlWithoutQuery'
    (msg__)->WriteSentinel(3941647224);
    Write((v__).urlQuery(), msg__);
    // Sentinel = 'urlQuery'
    (msg__)->WriteSentinel(3512340437);
    Write((v__).urlFragment(), msg__);
    // Sentinel = 'urlFragment'
    (msg__)->WriteSentinel(843953064);
    Write((v__).headers(), msg__);
    // Sentinel = 'headers'
    (msg__)->WriteSentinel(4284175217);
    Write((v__).headersGuard(), msg__);
    // Sentinel = 'headersGuard'
    (msg__)->WriteSentinel(2295054805);
    Write((v__).referrer(), msg__);
    // Sentinel = 'referrer'
    (msg__)->WriteSentinel(3770987113);
    Write((v__).referrerPolicy(), msg__);
    // Sentinel = 'referrerPolicy'
    (msg__)->WriteSentinel(2269890057);
    Write((v__).mode(), msg__);
    // Sentinel = 'mode'
    (msg__)->WriteSentinel(3911367285);
    Write((v__).credentials(), msg__);
    // Sentinel = 'credentials'
    (msg__)->WriteSentinel(3085848153);
    Write((v__).body(), msg__);
    // Sentinel = 'body'
    (msg__)->WriteSentinel(2829965504);
    Write((v__).contentPolicyType(), msg__);
    // Sentinel = 'contentPolicyType'
    (msg__)->WriteSentinel(3089607692);
    Write((v__).requestCache(), msg__);
    // Sentinel = 'requestCache'
    (msg__)->WriteSentinel(397161175);
    Write((v__).requestRedirect(), msg__);
    // Sentinel = 'requestRedirect'
    (msg__)->WriteSentinel(3935301184);
    Write((v__).integrity(), msg__);
    // Sentinel = 'integrity'
    (msg__)->WriteSentinel(3061850140);
}

auto PCacheStorageParent::Read(
        CacheRequest* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->method())), msg__, iter__)))) {
        FatalError("Error deserializing 'method' (nsCString) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'method'
    if ((!((msg__)->ReadSentinel(iter__, 1846382781)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'method' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->urlWithoutQuery())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlWithoutQuery' (nsCString) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'urlWithoutQuery'
    if ((!((msg__)->ReadSentinel(iter__, 3941647224)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'urlWithoutQuery' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->urlQuery())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlQuery' (nsCString) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'urlQuery'
    if ((!((msg__)->ReadSentinel(iter__, 3512340437)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'urlQuery' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->urlFragment())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlFragment' (nsCString) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'urlFragment'
    if ((!((msg__)->ReadSentinel(iter__, 843953064)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'urlFragment' (nsCString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (HeadersEntry[]) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'headers'
    if ((!((msg__)->ReadSentinel(iter__, 4284175217)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'headers' (HeadersEntry[]) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->headersGuard())), msg__, iter__)))) {
        FatalError("Error deserializing 'headersGuard' (HeadersGuardEnum) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'headersGuard'
    if ((!((msg__)->ReadSentinel(iter__, 2295054805)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'headersGuard' (HeadersGuardEnum) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->referrer())), msg__, iter__)))) {
        FatalError("Error deserializing 'referrer' (nsString) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'referrer'
    if ((!((msg__)->ReadSentinel(iter__, 3770987113)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'referrer' (nsString) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->referrerPolicy())), msg__, iter__)))) {
        FatalError("Error deserializing 'referrerPolicy' (ReferrerPolicy) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'referrerPolicy'
    if ((!((msg__)->ReadSentinel(iter__, 2269890057)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'referrerPolicy' (ReferrerPolicy) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->mode())), msg__, iter__)))) {
        FatalError("Error deserializing 'mode' (RequestMode) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'mode'
    if ((!((msg__)->ReadSentinel(iter__, 3911367285)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'mode' (RequestMode) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->credentials())), msg__, iter__)))) {
        FatalError("Error deserializing 'credentials' (RequestCredentials) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'credentials'
    if ((!((msg__)->ReadSentinel(iter__, 3085848153)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'credentials' (RequestCredentials) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->body())), msg__, iter__)))) {
        FatalError("Error deserializing 'body' (CacheReadStreamOrVoid) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'body'
    if ((!((msg__)->ReadSentinel(iter__, 2829965504)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'body' (CacheReadStreamOrVoid) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->contentPolicyType())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentPolicyType' (uint32_t) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'contentPolicyType'
    if ((!((msg__)->ReadSentinel(iter__, 3089607692)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'contentPolicyType' (uint32_t) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->requestCache())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestCache' (RequestCache) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'requestCache'
    if ((!((msg__)->ReadSentinel(iter__, 397161175)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'requestCache' (RequestCache) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->requestRedirect())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestRedirect' (RequestRedirect) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'requestRedirect'
    if ((!((msg__)->ReadSentinel(iter__, 3935301184)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'requestRedirect' (RequestRedirect) member of 'CacheRequest'");
        return false;
    }
    if ((!(Read((&((v__)->integrity())), msg__, iter__)))) {
        FatalError("Error deserializing 'integrity' (nsString) member of 'CacheRequest'");
        return false;
    }
    // Sentinel = 'integrity'
    if ((!((msg__)->ReadSentinel(iter__, 3061850140)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'integrity' (nsString) member of 'CacheRequest'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const OptionalInputStreamParams& v__,
        Message* msg__) -> void
{
    typedef OptionalInputStreamParams type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'OptionalInputStreamParams'
    (msg__)->WriteSentinel(1355174443);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            // Sentinel = 'Tvoid_t'
            (msg__)->WriteSentinel(3041273328);
            return;
        }
    case type__::TInputStreamParams:
        {
            Write((v__).get_InputStreamParams(), msg__);
            // Sentinel = 'TInputStreamParams'
            (msg__)->WriteSentinel(55652096);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        OptionalInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef OptionalInputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("OptionalInputStreamParams");
        return false;
    }
    // Sentinel = 'OptionalInputStreamParams'
    if ((!((msg__)->ReadSentinel(iter__, 1355174443)))) {
        mozilla::ipc::SentinelReadError("OptionalInputStreamParams");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_void_t())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((msg__)->ReadSentinel(iter__, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_InputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 55652096)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const IPCRemoteStream& v__,
        Message* msg__) -> void
{
    Write((v__).delayedStart(), msg__);
    // Sentinel = 'delayedStart'
    (msg__)->WriteSentinel(1491822294);
    Write((v__).stream(), msg__);
    // Sentinel = 'stream'
    (msg__)->WriteSentinel(4152748422);
}

auto PCacheStorageParent::Read(
        IPCRemoteStream* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->delayedStart())), msg__, iter__)))) {
        FatalError("Error deserializing 'delayedStart' (bool) member of 'IPCRemoteStream'");
        return false;
    }
    // Sentinel = 'delayedStart'
    if ((!((msg__)->ReadSentinel(iter__, 1491822294)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'delayedStart' (bool) member of 'IPCRemoteStream'");
        return false;
    }
    if ((!(Read((&((v__)->stream())), msg__, iter__)))) {
        FatalError("Error deserializing 'stream' (IPCRemoteStreamType) member of 'IPCRemoteStream'");
        return false;
    }
    // Sentinel = 'stream'
    if ((!((msg__)->ReadSentinel(iter__, 4152748422)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'stream' (IPCRemoteStreamType) member of 'IPCRemoteStream'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheMatchAllArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestOrVoid(), msg__);
    // Sentinel = 'requestOrVoid'
    (msg__)->WriteSentinel(3100919755);
    Write((v__).params(), msg__);
    // Sentinel = 'params'
    (msg__)->WriteSentinel(1677790004);
}

auto PCacheStorageParent::Read(
        CacheMatchAllArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->requestOrVoid())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestOrVoid' (CacheRequestOrVoid) member of 'CacheMatchAllArgs'");
        return false;
    }
    // Sentinel = 'requestOrVoid'
    if ((!((msg__)->ReadSentinel(iter__, 3100919755)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'requestOrVoid' (CacheRequestOrVoid) member of 'CacheMatchAllArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheMatchAllArgs'");
        return false;
    }
    // Sentinel = 'params'
    if ((!((msg__)->ReadSentinel(iter__, 1677790004)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'params' (CacheQueryParams) member of 'CacheMatchAllArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheReadStreamOrVoid& v__,
        Message* msg__) -> void
{
    typedef CacheReadStreamOrVoid type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'CacheReadStreamOrVoid'
    (msg__)->WriteSentinel(2746523334);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            // Sentinel = 'Tvoid_t'
            (msg__)->WriteSentinel(3041273328);
            return;
        }
    case type__::TCacheReadStream:
        {
            Write((v__).get_CacheReadStream(), msg__);
            // Sentinel = 'TCacheReadStream'
            (msg__)->WriteSentinel(1898450890);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        CacheReadStreamOrVoid* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef CacheReadStreamOrVoid type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("CacheReadStreamOrVoid");
        return false;
    }
    // Sentinel = 'CacheReadStreamOrVoid'
    if ((!((msg__)->ReadSentinel(iter__, 2746523334)))) {
        mozilla::ipc::SentinelReadError("CacheReadStreamOrVoid");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_void_t())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((msg__)->ReadSentinel(iter__, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TCacheReadStream:
        {
            CacheReadStream tmp = CacheReadStream();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CacheReadStream())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCacheReadStream'
            if ((!((msg__)->ReadSentinel(iter__, 1898450890)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const FileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileDescriptorIndex(), msg__);
    // Sentinel = 'fileDescriptorIndex'
    (msg__)->WriteSentinel(587329112);
    Write((v__).behaviorFlags(), msg__);
    // Sentinel = 'behaviorFlags'
    (msg__)->WriteSentinel(2404401962);
    Write((v__).ioFlags(), msg__);
    // Sentinel = 'ioFlags'
    (msg__)->WriteSentinel(1483009730);
}

auto PCacheStorageParent::Read(
        FileInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->fileDescriptorIndex())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    // Sentinel = 'fileDescriptorIndex'
    if ((!((msg__)->ReadSentinel(iter__, 587329112)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->behaviorFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    // Sentinel = 'behaviorFlags'
    if ((!((msg__)->ReadSentinel(iter__, 2404401962)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->ioFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    // Sentinel = 'ioFlags'
    if ((!((msg__)->ReadSentinel(iter__, 1483009730)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StorageMatchArgs& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    // Sentinel = 'request'
    (msg__)->WriteSentinel(2366856172);
    Write((v__).params(), msg__);
    // Sentinel = 'params'
    (msg__)->WriteSentinel(1677790004);
}

auto PCacheStorageParent::Read(
        StorageMatchArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'StorageMatchArgs'");
        return false;
    }
    // Sentinel = 'request'
    if ((!((msg__)->ReadSentinel(iter__, 2366856172)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'request' (CacheRequest) member of 'StorageMatchArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'StorageMatchArgs'");
        return false;
    }
    // Sentinel = 'params'
    if ((!((msg__)->ReadSentinel(iter__, 1677790004)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'params' (CacheQueryParams) member of 'StorageMatchArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const IPCBlobInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).id(), msg__);
    // Sentinel = 'id'
    (msg__)->WriteSentinel(2794505629);
    Write((v__).start(), msg__);
    // Sentinel = 'start'
    (msg__)->WriteSentinel(2088644401);
    Write((v__).length(), msg__);
    // Sentinel = 'length'
    (msg__)->WriteSentinel(1726618354);
}

auto PCacheStorageParent::Read(
        IPCBlobInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->id())), msg__, iter__)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'IPCBlobInputStreamParams'");
        return false;
    }
    // Sentinel = 'id'
    if ((!((msg__)->ReadSentinel(iter__, 2794505629)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'id' (nsID) member of 'IPCBlobInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->start())), msg__, iter__)))) {
        FatalError("Error deserializing 'start' (uint64_t) member of 'IPCBlobInputStreamParams'");
        return false;
    }
    // Sentinel = 'start'
    if ((!((msg__)->ReadSentinel(iter__, 2088644401)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'start' (uint64_t) member of 'IPCBlobInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'IPCBlobInputStreamParams'");
        return false;
    }
    // Sentinel = 'length'
    if ((!((msg__)->ReadSentinel(iter__, 1726618354)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'length' (uint64_t) member of 'IPCBlobInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheRequestOrVoid& v__,
        Message* msg__) -> void
{
    typedef CacheRequestOrVoid type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'CacheRequestOrVoid'
    (msg__)->WriteSentinel(468526770);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            // Sentinel = 'Tvoid_t'
            (msg__)->WriteSentinel(3041273328);
            return;
        }
    case type__::TCacheRequest:
        {
            Write((v__).get_CacheRequest(), msg__);
            // Sentinel = 'TCacheRequest'
            (msg__)->WriteSentinel(3359498676);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        CacheRequestOrVoid* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef CacheRequestOrVoid type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("CacheRequestOrVoid");
        return false;
    }
    // Sentinel = 'CacheRequestOrVoid'
    if ((!((msg__)->ReadSentinel(iter__, 468526770)))) {
        mozilla::ipc::SentinelReadError("CacheRequestOrVoid");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_void_t())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((msg__)->ReadSentinel(iter__, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TCacheRequest:
        {
            CacheRequest tmp = CacheRequest();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CacheRequest())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCacheRequest'
            if ((!((msg__)->ReadSentinel(iter__, 3359498676)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheMatchArgs& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    // Sentinel = 'request'
    (msg__)->WriteSentinel(2366856172);
    Write((v__).params(), msg__);
    // Sentinel = 'params'
    (msg__)->WriteSentinel(1677790004);
}

auto PCacheStorageParent::Read(
        CacheMatchArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'CacheMatchArgs'");
        return false;
    }
    // Sentinel = 'request'
    if ((!((msg__)->ReadSentinel(iter__, 2366856172)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'request' (CacheRequest) member of 'CacheMatchArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheMatchArgs'");
        return false;
    }
    // Sentinel = 'params'
    if ((!((msg__)->ReadSentinel(iter__, 1677790004)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'params' (CacheQueryParams) member of 'CacheMatchArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheResponse& v__,
        Message* msg__) -> void
{
    Write((v__).type(), msg__);
    // Sentinel = 'type'
    (msg__)->WriteSentinel(2982068540);
    Write((v__).urlList(), msg__);
    // Sentinel = 'urlList'
    (msg__)->WriteSentinel(2130903160);
    Write((v__).status(), msg__);
    // Sentinel = 'status'
    (msg__)->WriteSentinel(3714608576);
    Write((v__).statusText(), msg__);
    // Sentinel = 'statusText'
    (msg__)->WriteSentinel(2492908073);
    Write((v__).headers(), msg__);
    // Sentinel = 'headers'
    (msg__)->WriteSentinel(4284175217);
    Write((v__).headersGuard(), msg__);
    // Sentinel = 'headersGuard'
    (msg__)->WriteSentinel(2295054805);
    Write((v__).body(), msg__);
    // Sentinel = 'body'
    (msg__)->WriteSentinel(2829965504);
    Write((v__).channelInfo(), msg__);
    // Sentinel = 'channelInfo'
    (msg__)->WriteSentinel(2311115806);
    Write((v__).principalInfo(), msg__);
    // Sentinel = 'principalInfo'
    (msg__)->WriteSentinel(3386633731);
    Write((v__).paddingInfo(), msg__);
    // Sentinel = 'paddingInfo'
    (msg__)->WriteSentinel(3993729868);
    Write((v__).paddingSize(), msg__);
    // Sentinel = 'paddingSize'
    (msg__)->WriteSentinel(2329262623);
}

auto PCacheStorageParent::Read(
        CacheResponse* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->type())), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (ResponseType) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'type'
    if ((!((msg__)->ReadSentinel(iter__, 2982068540)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'type' (ResponseType) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->urlList())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlList' (nsCString[]) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'urlList'
    if ((!((msg__)->ReadSentinel(iter__, 2130903160)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'urlList' (nsCString[]) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->status())), msg__, iter__)))) {
        FatalError("Error deserializing 'status' (uint32_t) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'status'
    if ((!((msg__)->ReadSentinel(iter__, 3714608576)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'status' (uint32_t) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->statusText())), msg__, iter__)))) {
        FatalError("Error deserializing 'statusText' (nsCString) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'statusText'
    if ((!((msg__)->ReadSentinel(iter__, 2492908073)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'statusText' (nsCString) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (HeadersEntry[]) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'headers'
    if ((!((msg__)->ReadSentinel(iter__, 4284175217)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'headers' (HeadersEntry[]) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->headersGuard())), msg__, iter__)))) {
        FatalError("Error deserializing 'headersGuard' (HeadersGuardEnum) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'headersGuard'
    if ((!((msg__)->ReadSentinel(iter__, 2295054805)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'headersGuard' (HeadersGuardEnum) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->body())), msg__, iter__)))) {
        FatalError("Error deserializing 'body' (CacheReadStreamOrVoid) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'body'
    if ((!((msg__)->ReadSentinel(iter__, 2829965504)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'body' (CacheReadStreamOrVoid) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->channelInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'channelInfo' (IPCChannelInfo) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'channelInfo'
    if ((!((msg__)->ReadSentinel(iter__, 2311115806)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'channelInfo' (IPCChannelInfo) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->principalInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'principalInfo' (OptionalPrincipalInfo) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'principalInfo'
    if ((!((msg__)->ReadSentinel(iter__, 3386633731)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'principalInfo' (OptionalPrincipalInfo) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->paddingInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'paddingInfo' (uint32_t) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'paddingInfo'
    if ((!((msg__)->ReadSentinel(iter__, 3993729868)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'paddingInfo' (uint32_t) member of 'CacheResponse'");
        return false;
    }
    if ((!(Read((&((v__)->paddingSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'paddingSize' (int64_t) member of 'CacheResponse'");
        return false;
    }
    // Sentinel = 'paddingSize'
    if ((!((msg__)->ReadSentinel(iter__, 2329262623)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'paddingSize' (int64_t) member of 'CacheResponse'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const ExpandedPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).attrs(), msg__);
    // Sentinel = 'attrs'
    (msg__)->WriteSentinel(3014987797);
    Write((v__).whitelist(), msg__);
    // Sentinel = 'whitelist'
    (msg__)->WriteSentinel(3731637258);
}

auto PCacheStorageParent::Read(
        ExpandedPrincipalInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->attrs())), msg__, iter__)))) {
        FatalError("Error deserializing 'attrs' (OriginAttributes) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    // Sentinel = 'attrs'
    if ((!((msg__)->ReadSentinel(iter__, 3014987797)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'attrs' (OriginAttributes) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->whitelist())), msg__, iter__)))) {
        FatalError("Error deserializing 'whitelist' (PrincipalInfo[]) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    // Sentinel = 'whitelist'
    if ((!((msg__)->ReadSentinel(iter__, 3731637258)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'whitelist' (PrincipalInfo[]) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CacheQueryParams& v__,
        Message* msg__) -> void
{
    Write((v__).ignoreSearch(), msg__);
    // Sentinel = 'ignoreSearch'
    (msg__)->WriteSentinel(1536835730);
    Write((v__).ignoreMethod(), msg__);
    // Sentinel = 'ignoreMethod'
    (msg__)->WriteSentinel(4070609801);
    Write((v__).ignoreVary(), msg__);
    // Sentinel = 'ignoreVary'
    (msg__)->WriteSentinel(712195836);
    Write((v__).cacheNameSet(), msg__);
    // Sentinel = 'cacheNameSet'
    (msg__)->WriteSentinel(2553624785);
    Write((v__).cacheName(), msg__);
    // Sentinel = 'cacheName'
    (msg__)->WriteSentinel(3398830226);
}

auto PCacheStorageParent::Read(
        CacheQueryParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->ignoreSearch())), msg__, iter__)))) {
        FatalError("Error deserializing 'ignoreSearch' (bool) member of 'CacheQueryParams'");
        return false;
    }
    // Sentinel = 'ignoreSearch'
    if ((!((msg__)->ReadSentinel(iter__, 1536835730)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'ignoreSearch' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->ignoreMethod())), msg__, iter__)))) {
        FatalError("Error deserializing 'ignoreMethod' (bool) member of 'CacheQueryParams'");
        return false;
    }
    // Sentinel = 'ignoreMethod'
    if ((!((msg__)->ReadSentinel(iter__, 4070609801)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'ignoreMethod' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->ignoreVary())), msg__, iter__)))) {
        FatalError("Error deserializing 'ignoreVary' (bool) member of 'CacheQueryParams'");
        return false;
    }
    // Sentinel = 'ignoreVary'
    if ((!((msg__)->ReadSentinel(iter__, 712195836)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'ignoreVary' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->cacheNameSet())), msg__, iter__)))) {
        FatalError("Error deserializing 'cacheNameSet' (bool) member of 'CacheQueryParams'");
        return false;
    }
    // Sentinel = 'cacheNameSet'
    if ((!((msg__)->ReadSentinel(iter__, 2553624785)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'cacheNameSet' (bool) member of 'CacheQueryParams'");
        return false;
    }
    if ((!(Read((&((v__)->cacheName())), msg__, iter__)))) {
        FatalError("Error deserializing 'cacheName' (nsString) member of 'CacheQueryParams'");
        return false;
    }
    // Sentinel = 'cacheName'
    if ((!((msg__)->ReadSentinel(iter__, 3398830226)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'cacheName' (nsString) member of 'CacheQueryParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const PCacheStorageParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->Id();
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCacheStorageParent** v__,
        const Message* msg__,
        PickleIterator* iter__,
        bool nullable__) -> bool
{
    Maybe<mozilla::ipc::IProtocol*> actor = ReadActor(msg__, iter__, nullable__, "PCacheStorage", PCacheStorageMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(v__)) = static_cast<PCacheStorageParent*>((actor).value());
    return true;
}

auto PCacheStorageParent::Write(
        const InputStreamParamsWithFds& v__,
        Message* msg__) -> void
{
    Write((v__).stream(), msg__);
    // Sentinel = 'stream'
    (msg__)->WriteSentinel(4152748422);
    Write((v__).optionalFds(), msg__);
    // Sentinel = 'optionalFds'
    (msg__)->WriteSentinel(1021803302);
}

auto PCacheStorageParent::Read(
        InputStreamParamsWithFds* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->stream())), msg__, iter__)))) {
        FatalError("Error deserializing 'stream' (InputStreamParams) member of 'InputStreamParamsWithFds'");
        return false;
    }
    // Sentinel = 'stream'
    if ((!((msg__)->ReadSentinel(iter__, 4152748422)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'stream' (InputStreamParams) member of 'InputStreamParamsWithFds'");
        return false;
    }
    if ((!(Read((&((v__)->optionalFds())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalFds' (OptionalFileDescriptorSet) member of 'InputStreamParamsWithFds'");
        return false;
    }
    // Sentinel = 'optionalFds'
    if ((!((msg__)->ReadSentinel(iter__, 1021803302)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'optionalFds' (OptionalFileDescriptorSet) member of 'InputStreamParamsWithFds'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<FileDescriptor>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);
    // Sentinel = ('length', 'FileDescriptor[]')
    (msg__)->WriteSentinel(1697726450);

    for (auto& elem : v__) {
        Write(elem, msg__);
        // Sentinel = 'FileDescriptor[]'
        (msg__)->WriteSentinel(1630221245);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<FileDescriptor>* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    nsTArray<FileDescriptor> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        mozilla::ipc::ArrayLengthReadError("FileDescriptor[]");
        return false;
    }
    // Sentinel = ('length', 'FileDescriptor[]')
    if ((!((msg__)->ReadSentinel(iter__, 1697726450)))) {
        mozilla::ipc::SentinelReadError("FileDescriptor[]");
        return false;
    }

    FileDescriptor* elems = (fa).AppendElements(length);
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(elems[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'FileDescriptor[i]'");
            return false;
        }
        // Sentinel = 'FileDescriptor[]'
        if ((!((msg__)->ReadSentinel(iter__, 1630221245)))) {
            mozilla::ipc::SentinelReadError("Error deserializing 'FileDescriptor[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const CacheOpArgs& v__,
        Message* msg__) -> void
{
    typedef CacheOpArgs type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'CacheOpArgs'
    (msg__)->WriteSentinel(1657801543);

    switch ((v__).type()) {
    case type__::TCacheMatchArgs:
        {
            Write((v__).get_CacheMatchArgs(), msg__);
            // Sentinel = 'TCacheMatchArgs'
            (msg__)->WriteSentinel(4104432449);
            return;
        }
    case type__::TCacheMatchAllArgs:
        {
            Write((v__).get_CacheMatchAllArgs(), msg__);
            // Sentinel = 'TCacheMatchAllArgs'
            (msg__)->WriteSentinel(3931345019);
            return;
        }
    case type__::TCachePutAllArgs:
        {
            Write((v__).get_CachePutAllArgs(), msg__);
            // Sentinel = 'TCachePutAllArgs'
            (msg__)->WriteSentinel(2522279573);
            return;
        }
    case type__::TCacheDeleteArgs:
        {
            Write((v__).get_CacheDeleteArgs(), msg__);
            // Sentinel = 'TCacheDeleteArgs'
            (msg__)->WriteSentinel(155480544);
            return;
        }
    case type__::TCacheKeysArgs:
        {
            Write((v__).get_CacheKeysArgs(), msg__);
            // Sentinel = 'TCacheKeysArgs'
            (msg__)->WriteSentinel(1697385223);
            return;
        }
    case type__::TStorageMatchArgs:
        {
            Write((v__).get_StorageMatchArgs(), msg__);
            // Sentinel = 'TStorageMatchArgs'
            (msg__)->WriteSentinel(2175250132);
            return;
        }
    case type__::TStorageHasArgs:
        {
            Write((v__).get_StorageHasArgs(), msg__);
            // Sentinel = 'TStorageHasArgs'
            (msg__)->WriteSentinel(3601488477);
            return;
        }
    case type__::TStorageOpenArgs:
        {
            Write((v__).get_StorageOpenArgs(), msg__);
            // Sentinel = 'TStorageOpenArgs'
            (msg__)->WriteSentinel(335380472);
            return;
        }
    case type__::TStorageDeleteArgs:
        {
            Write((v__).get_StorageDeleteArgs(), msg__);
            // Sentinel = 'TStorageDeleteArgs'
            (msg__)->WriteSentinel(1905964251);
            return;
        }
    case type__::TStorageKeysArgs:
        {
            Write((v__).get_StorageKeysArgs(), msg__);
            // Sentinel = 'TStorageKeysArgs'
            (msg__)->WriteSentinel(2159819388);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        CacheOpArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef CacheOpArgs type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("CacheOpArgs");
        return false;
    }
    // Sentinel = 'CacheOpArgs'
    if ((!((msg__)->ReadSentinel(iter__, 1657801543)))) {
        mozilla::ipc::SentinelReadError("CacheOpArgs");
        return false;
    }

    switch (type) {
    case type__::TCacheMatchArgs:
        {
            CacheMatchArgs tmp = CacheMatchArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CacheMatchArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCacheMatchArgs'
            if ((!((msg__)->ReadSentinel(iter__, 4104432449)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TCacheMatchAllArgs:
        {
            CacheMatchAllArgs tmp = CacheMatchAllArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CacheMatchAllArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCacheMatchAllArgs'
            if ((!((msg__)->ReadSentinel(iter__, 3931345019)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TCachePutAllArgs:
        {
            CachePutAllArgs tmp = CachePutAllArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CachePutAllArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCachePutAllArgs'
            if ((!((msg__)->ReadSentinel(iter__, 2522279573)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TCacheDeleteArgs:
        {
            CacheDeleteArgs tmp = CacheDeleteArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CacheDeleteArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCacheDeleteArgs'
            if ((!((msg__)->ReadSentinel(iter__, 155480544)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TCacheKeysArgs:
        {
            CacheKeysArgs tmp = CacheKeysArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_CacheKeysArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TCacheKeysArgs'
            if ((!((msg__)->ReadSentinel(iter__, 1697385223)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TStorageMatchArgs:
        {
            StorageMatchArgs tmp = StorageMatchArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_StorageMatchArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TStorageMatchArgs'
            if ((!((msg__)->ReadSentinel(iter__, 2175250132)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TStorageHasArgs:
        {
            StorageHasArgs tmp = StorageHasArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_StorageHasArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TStorageHasArgs'
            if ((!((msg__)->ReadSentinel(iter__, 3601488477)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TStorageOpenArgs:
        {
            StorageOpenArgs tmp = StorageOpenArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_StorageOpenArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TStorageOpenArgs'
            if ((!((msg__)->ReadSentinel(iter__, 335380472)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TStorageDeleteArgs:
        {
            StorageDeleteArgs tmp = StorageDeleteArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_StorageDeleteArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TStorageDeleteArgs'
            if ((!((msg__)->ReadSentinel(iter__, 1905964251)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TStorageKeysArgs:
        {
            StorageKeysArgs tmp = StorageKeysArgs();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_StorageKeysArgs())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TStorageKeysArgs'
            if ((!((msg__)->ReadSentinel(iter__, 2159819388)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const PrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef PrincipalInfo type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'PrincipalInfo'
    (msg__)->WriteSentinel(4194518819);

    switch ((v__).type()) {
    case type__::TContentPrincipalInfo:
        {
            Write((v__).get_ContentPrincipalInfo(), msg__);
            // Sentinel = 'TContentPrincipalInfo'
            (msg__)->WriteSentinel(3677342258);
            return;
        }
    case type__::TSystemPrincipalInfo:
        {
            Write((v__).get_SystemPrincipalInfo(), msg__);
            // Sentinel = 'TSystemPrincipalInfo'
            (msg__)->WriteSentinel(3590603679);
            return;
        }
    case type__::TNullPrincipalInfo:
        {
            Write((v__).get_NullPrincipalInfo(), msg__);
            // Sentinel = 'TNullPrincipalInfo'
            (msg__)->WriteSentinel(3477774965);
            return;
        }
    case type__::TExpandedPrincipalInfo:
        {
            Write((v__).get_ExpandedPrincipalInfo(), msg__);
            // Sentinel = 'TExpandedPrincipalInfo'
            (msg__)->WriteSentinel(589324917);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        PrincipalInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef PrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("PrincipalInfo");
        return false;
    }
    // Sentinel = 'PrincipalInfo'
    if ((!((msg__)->ReadSentinel(iter__, 4194518819)))) {
        mozilla::ipc::SentinelReadError("PrincipalInfo");
        return false;
    }

    switch (type) {
    case type__::TContentPrincipalInfo:
        {
            ContentPrincipalInfo tmp = ContentPrincipalInfo();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_ContentPrincipalInfo())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TContentPrincipalInfo'
            if ((!((msg__)->ReadSentinel(iter__, 3677342258)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TSystemPrincipalInfo:
        {
            SystemPrincipalInfo tmp = SystemPrincipalInfo();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_SystemPrincipalInfo())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TSystemPrincipalInfo'
            if ((!((msg__)->ReadSentinel(iter__, 3590603679)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TNullPrincipalInfo:
        {
            NullPrincipalInfo tmp = NullPrincipalInfo();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_NullPrincipalInfo())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TNullPrincipalInfo'
            if ((!((msg__)->ReadSentinel(iter__, 3477774965)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TExpandedPrincipalInfo:
        {
            ExpandedPrincipalInfo tmp = ExpandedPrincipalInfo();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_ExpandedPrincipalInfo())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TExpandedPrincipalInfo'
            if ((!((msg__)->ReadSentinel(iter__, 589324917)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const nsTArray<HeaderEntry>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);
    // Sentinel = ('length', 'HeaderEntry[]')
    (msg__)->WriteSentinel(2689457705);

    for (auto& elem : v__) {
        Write(elem, msg__);
        // Sentinel = 'HeaderEntry[]'
        (msg__)->WriteSentinel(454836120);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<HeaderEntry>* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    nsTArray<HeaderEntry> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        mozilla::ipc::ArrayLengthReadError("HeaderEntry[]");
        return false;
    }
    // Sentinel = ('length', 'HeaderEntry[]')
    if ((!((msg__)->ReadSentinel(iter__, 2689457705)))) {
        mozilla::ipc::SentinelReadError("HeaderEntry[]");
        return false;
    }

    HeaderEntry* elems = (fa).AppendElements(length);
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(elems[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'HeaderEntry[i]'");
            return false;
        }
        // Sentinel = 'HeaderEntry[]'
        if ((!((msg__)->ReadSentinel(iter__, 454836120)))) {
            mozilla::ipc::SentinelReadError("Error deserializing 'HeaderEntry[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const NullPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).attrs(), msg__);
    // Sentinel = 'attrs'
    (msg__)->WriteSentinel(3014987797);
    Write((v__).spec(), msg__);
    // Sentinel = 'spec'
    (msg__)->WriteSentinel(1630740541);
}

auto PCacheStorageParent::Read(
        NullPrincipalInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->attrs())), msg__, iter__)))) {
        FatalError("Error deserializing 'attrs' (OriginAttributes) member of 'NullPrincipalInfo'");
        return false;
    }
    // Sentinel = 'attrs'
    if ((!((msg__)->ReadSentinel(iter__, 3014987797)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'attrs' (OriginAttributes) member of 'NullPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'NullPrincipalInfo'");
        return false;
    }
    // Sentinel = 'spec'
    if ((!((msg__)->ReadSentinel(iter__, 1630740541)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'spec' (nsCString) member of 'NullPrincipalInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const SlicedInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).stream(), msg__);
    // Sentinel = 'stream'
    (msg__)->WriteSentinel(4152748422);
    Write((v__).start(), msg__);
    // Sentinel = 'start'
    (msg__)->WriteSentinel(2088644401);
    Write((v__).length(), msg__);
    // Sentinel = 'length'
    (msg__)->WriteSentinel(1726618354);
    Write((v__).curPos(), msg__);
    // Sentinel = 'curPos'
    (msg__)->WriteSentinel(4042140974);
    Write((v__).closed(), msg__);
    // Sentinel = 'closed'
    (msg__)->WriteSentinel(561249462);
}

auto PCacheStorageParent::Read(
        SlicedInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->stream())), msg__, iter__)))) {
        FatalError("Error deserializing 'stream' (InputStreamParams) member of 'SlicedInputStreamParams'");
        return false;
    }
    // Sentinel = 'stream'
    if ((!((msg__)->ReadSentinel(iter__, 4152748422)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'stream' (InputStreamParams) member of 'SlicedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->start())), msg__, iter__)))) {
        FatalError("Error deserializing 'start' (uint64_t) member of 'SlicedInputStreamParams'");
        return false;
    }
    // Sentinel = 'start'
    if ((!((msg__)->ReadSentinel(iter__, 2088644401)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'start' (uint64_t) member of 'SlicedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'SlicedInputStreamParams'");
        return false;
    }
    // Sentinel = 'length'
    if ((!((msg__)->ReadSentinel(iter__, 1726618354)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'length' (uint64_t) member of 'SlicedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->curPos())), msg__, iter__)))) {
        FatalError("Error deserializing 'curPos' (uint64_t) member of 'SlicedInputStreamParams'");
        return false;
    }
    // Sentinel = 'curPos'
    if ((!((msg__)->ReadSentinel(iter__, 4042140974)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'curPos' (uint64_t) member of 'SlicedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->closed())), msg__, iter__)))) {
        FatalError("Error deserializing 'closed' (bool) member of 'SlicedInputStreamParams'");
        return false;
    }
    // Sentinel = 'closed'
    if ((!((msg__)->ReadSentinel(iter__, 561249462)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'closed' (bool) member of 'SlicedInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StorageDeleteArgs& v__,
        Message* msg__) -> void
{
    Write((v__).key(), msg__);
    // Sentinel = 'key'
    (msg__)->WriteSentinel(35142870);
}

auto PCacheStorageParent::Read(
        StorageDeleteArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->key())), msg__, iter__)))) {
        FatalError("Error deserializing 'key' (nsString) member of 'StorageDeleteArgs'");
        return false;
    }
    // Sentinel = 'key'
    if ((!((msg__)->ReadSentinel(iter__, 35142870)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'key' (nsString) member of 'StorageDeleteArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const IPCRemoteStreamType& v__,
        Message* msg__) -> void
{
    typedef IPCRemoteStreamType type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'IPCRemoteStreamType'
    (msg__)->WriteSentinel(391674895);

    switch ((v__).type()) {
    case type__::TPChildToParentStreamParent:
        {
            Write((v__).get_PChildToParentStreamParent(), msg__, false);
            // Sentinel = 'TPChildToParentStreamParent'
            (msg__)->WriteSentinel(2724777622);
            return;
        }
    case type__::TPChildToParentStreamChild:
        {
            FatalError("wrong side!");
            return;
        }
    case type__::TPParentToChildStreamParent:
        {
            Write((v__).get_PParentToChildStreamParent(), msg__, false);
            // Sentinel = 'TPParentToChildStreamParent'
            (msg__)->WriteSentinel(3335986876);
            return;
        }
    case type__::TPParentToChildStreamChild:
        {
            FatalError("wrong side!");
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        IPCRemoteStreamType* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef IPCRemoteStreamType type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("IPCRemoteStreamType");
        return false;
    }
    // Sentinel = 'IPCRemoteStreamType'
    if ((!((msg__)->ReadSentinel(iter__, 391674895)))) {
        mozilla::ipc::SentinelReadError("IPCRemoteStreamType");
        return false;
    }

    switch (type) {
    case type__::TPChildToParentStreamParent:
        {
            return false;
        }
    case type__::TPChildToParentStreamChild:
        {
            PChildToParentStreamParent* tmp = nullptr;
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_PChildToParentStreamParent())), msg__, iter__, false)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TPChildToParentStreamChild'
            if ((!((msg__)->ReadSentinel(iter__, 1882094295)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TPParentToChildStreamParent:
        {
            return false;
        }
    case type__::TPParentToChildStreamChild:
        {
            PParentToChildStreamParent* tmp = nullptr;
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_PParentToChildStreamParent())), msg__, iter__, false)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TPParentToChildStreamChild'
            if ((!((msg__)->ReadSentinel(iter__, 190098493)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const TemporaryFileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileDescriptorIndex(), msg__);
    // Sentinel = 'fileDescriptorIndex'
    (msg__)->WriteSentinel(587329112);
    Write((v__).startPos(), msg__);
    // Sentinel = 'startPos'
    (msg__)->WriteSentinel(557207962);
    Write((v__).endPos(), msg__);
    // Sentinel = 'endPos'
    (msg__)->WriteSentinel(881536245);
}

auto PCacheStorageParent::Read(
        TemporaryFileInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->fileDescriptorIndex())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'TemporaryFileInputStreamParams'");
        return false;
    }
    // Sentinel = 'fileDescriptorIndex'
    if ((!((msg__)->ReadSentinel(iter__, 587329112)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'TemporaryFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startPos())), msg__, iter__)))) {
        FatalError("Error deserializing 'startPos' (uint64_t) member of 'TemporaryFileInputStreamParams'");
        return false;
    }
    // Sentinel = 'startPos'
    if ((!((msg__)->ReadSentinel(iter__, 557207962)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'startPos' (uint64_t) member of 'TemporaryFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->endPos())), msg__, iter__)))) {
        FatalError("Error deserializing 'endPos' (uint64_t) member of 'TemporaryFileInputStreamParams'");
        return false;
    }
    // Sentinel = 'endPos'
    if ((!((msg__)->ReadSentinel(iter__, 881536245)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'endPos' (uint64_t) member of 'TemporaryFileInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const MIMEInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    // Sentinel = 'optionalStream'
    (msg__)->WriteSentinel(1003718562);
    Write((v__).headers(), msg__);
    // Sentinel = 'headers'
    (msg__)->WriteSentinel(4284175217);
    Write((v__).startedReading(), msg__);
    // Sentinel = 'startedReading'
    (msg__)->WriteSentinel(1906875903);
}

auto PCacheStorageParent::Read(
        MIMEInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    // Sentinel = 'optionalStream'
    if ((!((msg__)->ReadSentinel(iter__, 1003718562)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (HeaderEntry[]) member of 'MIMEInputStreamParams'");
        return false;
    }
    // Sentinel = 'headers'
    if ((!((msg__)->ReadSentinel(iter__, 4284175217)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'headers' (HeaderEntry[]) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReading())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    // Sentinel = 'startedReading'
    if ((!((msg__)->ReadSentinel(iter__, 1906875903)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const PCacheOpParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->Id();
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCacheOpParent** v__,
        const Message* msg__,
        PickleIterator* iter__,
        bool nullable__) -> bool
{
    Maybe<mozilla::ipc::IProtocol*> actor = ReadActor(msg__, iter__, nullable__, "PCacheOp", PCacheOpMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(v__)) = static_cast<PCacheOpParent*>((actor).value());
    return true;
}

auto PCacheStorageParent::Write(
        const InputStreamParams& v__,
        Message* msg__) -> void
{
    typedef InputStreamParams type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'InputStreamParams'
    (msg__)->WriteSentinel(4114814015);

    switch ((v__).type()) {
    case type__::TStringInputStreamParams:
        {
            Write((v__).get_StringInputStreamParams(), msg__);
            // Sentinel = 'TStringInputStreamParams'
            (msg__)->WriteSentinel(3395831651);
            return;
        }
    case type__::TFileInputStreamParams:
        {
            Write((v__).get_FileInputStreamParams(), msg__);
            // Sentinel = 'TFileInputStreamParams'
            (msg__)->WriteSentinel(2543620282);
            return;
        }
    case type__::TTemporaryFileInputStreamParams:
        {
            Write((v__).get_TemporaryFileInputStreamParams(), msg__);
            // Sentinel = 'TTemporaryFileInputStreamParams'
            (msg__)->WriteSentinel(587771548);
            return;
        }
    case type__::TBufferedInputStreamParams:
        {
            Write((v__).get_BufferedInputStreamParams(), msg__);
            // Sentinel = 'TBufferedInputStreamParams'
            (msg__)->WriteSentinel(1698289307);
            return;
        }
    case type__::TMIMEInputStreamParams:
        {
            Write((v__).get_MIMEInputStreamParams(), msg__);
            // Sentinel = 'TMIMEInputStreamParams'
            (msg__)->WriteSentinel(1948001964);
            return;
        }
    case type__::TMultiplexInputStreamParams:
        {
            Write((v__).get_MultiplexInputStreamParams(), msg__);
            // Sentinel = 'TMultiplexInputStreamParams'
            (msg__)->WriteSentinel(3317853213);
            return;
        }
    case type__::TSlicedInputStreamParams:
        {
            Write((v__).get_SlicedInputStreamParams(), msg__);
            // Sentinel = 'TSlicedInputStreamParams'
            (msg__)->WriteSentinel(445810472);
            return;
        }
    case type__::TIPCBlobInputStreamParams:
        {
            Write((v__).get_IPCBlobInputStreamParams(), msg__);
            // Sentinel = 'TIPCBlobInputStreamParams'
            (msg__)->WriteSentinel(2436989998);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        InputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef InputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("InputStreamParams");
        return false;
    }
    // Sentinel = 'InputStreamParams'
    if ((!((msg__)->ReadSentinel(iter__, 4114814015)))) {
        mozilla::ipc::SentinelReadError("InputStreamParams");
        return false;
    }

    switch (type) {
    case type__::TStringInputStreamParams:
        {
            StringInputStreamParams tmp = StringInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_StringInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TStringInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 3395831651)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TFileInputStreamParams:
        {
            FileInputStreamParams tmp = FileInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_FileInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TFileInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 2543620282)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TTemporaryFileInputStreamParams:
        {
            TemporaryFileInputStreamParams tmp = TemporaryFileInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_TemporaryFileInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TTemporaryFileInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 587771548)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TBufferedInputStreamParams:
        {
            BufferedInputStreamParams tmp = BufferedInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_BufferedInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TBufferedInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 1698289307)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TMIMEInputStreamParams:
        {
            MIMEInputStreamParams tmp = MIMEInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_MIMEInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TMIMEInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 1948001964)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TMultiplexInputStreamParams:
        {
            MultiplexInputStreamParams tmp = MultiplexInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_MultiplexInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TMultiplexInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 3317853213)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TSlicedInputStreamParams:
        {
            SlicedInputStreamParams tmp = SlicedInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_SlicedInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TSlicedInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 445810472)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TIPCBlobInputStreamParams:
        {
            IPCBlobInputStreamParams tmp = IPCBlobInputStreamParams();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_IPCBlobInputStreamParams())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TIPCBlobInputStreamParams'
            if ((!((msg__)->ReadSentinel(iter__, 2436989998)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const PParentToChildStreamParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->Id();
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PParentToChildStreamParent** v__,
        const Message* msg__,
        PickleIterator* iter__,
        bool nullable__) -> bool
{
    Maybe<mozilla::ipc::IProtocol*> actor = ReadActor(msg__, iter__, nullable__, "PParentToChildStream", PParentToChildStreamMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(v__)) = static_cast<PParentToChildStreamParent*>((actor).value());
    return true;
}

auto PCacheStorageParent::Write(
        const CacheDeleteArgs& v__,
        Message* msg__) -> void
{
    Write((v__).request(), msg__);
    // Sentinel = 'request'
    (msg__)->WriteSentinel(2366856172);
    Write((v__).params(), msg__);
    // Sentinel = 'params'
    (msg__)->WriteSentinel(1677790004);
}

auto PCacheStorageParent::Read(
        CacheDeleteArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->request())), msg__, iter__)))) {
        FatalError("Error deserializing 'request' (CacheRequest) member of 'CacheDeleteArgs'");
        return false;
    }
    // Sentinel = 'request'
    if ((!((msg__)->ReadSentinel(iter__, 2366856172)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'request' (CacheRequest) member of 'CacheDeleteArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheDeleteArgs'");
        return false;
    }
    // Sentinel = 'params'
    if ((!((msg__)->ReadSentinel(iter__, 1677790004)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'params' (CacheQueryParams) member of 'CacheDeleteArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const IPCStream& v__,
        Message* msg__) -> void
{
    typedef IPCStream type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'IPCStream'
    (msg__)->WriteSentinel(442610715);

    switch ((v__).type()) {
    case type__::TInputStreamParamsWithFds:
        {
            Write((v__).get_InputStreamParamsWithFds(), msg__);
            // Sentinel = 'TInputStreamParamsWithFds'
            (msg__)->WriteSentinel(2170706066);
            return;
        }
    case type__::TIPCRemoteStream:
        {
            Write((v__).get_IPCRemoteStream(), msg__);
            // Sentinel = 'TIPCRemoteStream'
            (msg__)->WriteSentinel(2978132448);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        IPCStream* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef IPCStream type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("IPCStream");
        return false;
    }
    // Sentinel = 'IPCStream'
    if ((!((msg__)->ReadSentinel(iter__, 442610715)))) {
        mozilla::ipc::SentinelReadError("IPCStream");
        return false;
    }

    switch (type) {
    case type__::TInputStreamParamsWithFds:
        {
            InputStreamParamsWithFds tmp = InputStreamParamsWithFds();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_InputStreamParamsWithFds())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TInputStreamParamsWithFds'
            if ((!((msg__)->ReadSentinel(iter__, 2170706066)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TIPCRemoteStream:
        {
            IPCRemoteStream tmp = IPCRemoteStream();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_IPCRemoteStream())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TIPCRemoteStream'
            if ((!((msg__)->ReadSentinel(iter__, 2978132448)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const CacheReadStream& v__,
        Message* msg__) -> void
{
    Write((v__).id(), msg__);
    // Sentinel = 'id'
    (msg__)->WriteSentinel(2794505629);
    Write((v__).controlParent(), msg__, true);
    // Sentinel = 'control'
    (msg__)->WriteSentinel(2785524096);
    // skipping actor field that's meaningless on this side
    Write((v__).stream(), msg__);
    // Sentinel = 'stream'
    (msg__)->WriteSentinel(4152748422);
}

auto PCacheStorageParent::Read(
        CacheReadStream* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->id())), msg__, iter__)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'CacheReadStream'");
        return false;
    }
    // Sentinel = 'id'
    if ((!((msg__)->ReadSentinel(iter__, 2794505629)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'id' (nsID) member of 'CacheReadStream'");
        return false;
    }
    if ((!(Read((&((v__)->controlParent())), msg__, iter__, true)))) {
        FatalError("Error deserializing 'controlParent' (PCacheStreamControl) member of 'CacheReadStream'");
        return false;
    }
    // Sentinel = 'control'
    if ((!((msg__)->ReadSentinel(iter__, 2785524096)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'controlParent' (PCacheStreamControl) member of 'CacheReadStream'");
        return false;
    }
    // skipping actor field that's meaningless on this side
    if ((!(Read((&((v__)->stream())), msg__, iter__)))) {
        FatalError("Error deserializing 'stream' (IPCStream) member of 'CacheReadStream'");
        return false;
    }
    // Sentinel = 'stream'
    if ((!((msg__)->ReadSentinel(iter__, 4152748422)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'stream' (IPCStream) member of 'CacheReadStream'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const CachePutAllArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestResponseList(), msg__);
    // Sentinel = 'requestResponseList'
    (msg__)->WriteSentinel(4078539745);
}

auto PCacheStorageParent::Read(
        CachePutAllArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->requestResponseList())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestResponseList' (CacheRequestResponse[]) member of 'CachePutAllArgs'");
        return false;
    }
    // Sentinel = 'requestResponseList'
    if ((!((msg__)->ReadSentinel(iter__, 4078539745)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'requestResponseList' (CacheRequestResponse[]) member of 'CachePutAllArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StringInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).data(), msg__);
    // Sentinel = 'data'
    (msg__)->WriteSentinel(843352540);
}

auto PCacheStorageParent::Read(
        StringInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->data())), msg__, iter__)))) {
        FatalError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    // Sentinel = 'data'
    if ((!((msg__)->ReadSentinel(iter__, 843352540)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const HeadersEntry& v__,
        Message* msg__) -> void
{
    Write((v__).name(), msg__);
    // Sentinel = 'name'
    (msg__)->WriteSentinel(15034981);
    Write((v__).value(), msg__);
    // Sentinel = 'value'
    (msg__)->WriteSentinel(3456818542);
}

auto PCacheStorageParent::Read(
        HeadersEntry* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->name())), msg__, iter__)))) {
        FatalError("Error deserializing 'name' (nsCString) member of 'HeadersEntry'");
        return false;
    }
    // Sentinel = 'name'
    if ((!((msg__)->ReadSentinel(iter__, 15034981)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'name' (nsCString) member of 'HeadersEntry'");
        return false;
    }
    if ((!(Read((&((v__)->value())), msg__, iter__)))) {
        FatalError("Error deserializing 'value' (nsCString) member of 'HeadersEntry'");
        return false;
    }
    // Sentinel = 'value'
    if ((!((msg__)->ReadSentinel(iter__, 3456818542)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'value' (nsCString) member of 'HeadersEntry'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const MultiplexInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).streams(), msg__);
    // Sentinel = 'streams'
    (msg__)->WriteSentinel(4240383220);
    Write((v__).currentStream(), msg__);
    // Sentinel = 'currentStream'
    (msg__)->WriteSentinel(682778074);
    Write((v__).status(), msg__);
    // Sentinel = 'status'
    (msg__)->WriteSentinel(3714608576);
    Write((v__).startedReadingCurrent(), msg__);
    // Sentinel = 'startedReadingCurrent'
    (msg__)->WriteSentinel(970542033);
}

auto PCacheStorageParent::Read(
        MultiplexInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->streams())), msg__, iter__)))) {
        FatalError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    // Sentinel = 'streams'
    if ((!((msg__)->ReadSentinel(iter__, 4240383220)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->currentStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    // Sentinel = 'currentStream'
    if ((!((msg__)->ReadSentinel(iter__, 682778074)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->status())), msg__, iter__)))) {
        FatalError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    // Sentinel = 'status'
    if ((!((msg__)->ReadSentinel(iter__, 3714608576)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReadingCurrent())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    // Sentinel = 'startedReadingCurrent'
    if ((!((msg__)->ReadSentinel(iter__, 970542033)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const PFileDescriptorSetParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->Id();
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PFileDescriptorSetParent** v__,
        const Message* msg__,
        PickleIterator* iter__,
        bool nullable__) -> bool
{
    Maybe<mozilla::ipc::IProtocol*> actor = ReadActor(msg__, iter__, nullable__, "PFileDescriptorSet", PFileDescriptorSetMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(v__)) = static_cast<PFileDescriptorSetParent*>((actor).value());
    return true;
}

auto PCacheStorageParent::Write(
        const CacheKeysArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestOrVoid(), msg__);
    // Sentinel = 'requestOrVoid'
    (msg__)->WriteSentinel(3100919755);
    Write((v__).params(), msg__);
    // Sentinel = 'params'
    (msg__)->WriteSentinel(1677790004);
}

auto PCacheStorageParent::Read(
        CacheKeysArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->requestOrVoid())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestOrVoid' (CacheRequestOrVoid) member of 'CacheKeysArgs'");
        return false;
    }
    // Sentinel = 'requestOrVoid'
    if ((!((msg__)->ReadSentinel(iter__, 3100919755)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'requestOrVoid' (CacheRequestOrVoid) member of 'CacheKeysArgs'");
        return false;
    }
    if ((!(Read((&((v__)->params())), msg__, iter__)))) {
        FatalError("Error deserializing 'params' (CacheQueryParams) member of 'CacheKeysArgs'");
        return false;
    }
    // Sentinel = 'params'
    if ((!((msg__)->ReadSentinel(iter__, 1677790004)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'params' (CacheQueryParams) member of 'CacheKeysArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const OptionalFileDescriptorSet& v__,
        Message* msg__) -> void
{
    typedef OptionalFileDescriptorSet type__;
    Write(int((v__).type()), msg__);
    // Sentinel = 'OptionalFileDescriptorSet'
    (msg__)->WriteSentinel(955222862);

    switch ((v__).type()) {
    case type__::TPFileDescriptorSetParent:
        {
            Write((v__).get_PFileDescriptorSetParent(), msg__, false);
            // Sentinel = 'TPFileDescriptorSetParent'
            (msg__)->WriteSentinel(143041934);
            return;
        }
    case type__::TPFileDescriptorSetChild:
        {
            FatalError("wrong side!");
            return;
        }
    case type__::TArrayOfFileDescriptor:
        {
            Write((v__).get_ArrayOfFileDescriptor(), msg__);
            // Sentinel = 'TArrayOfFileDescriptor'
            (msg__)->WriteSentinel(2366096715);
            return;
        }
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            // Sentinel = 'Tvoid_t'
            (msg__)->WriteSentinel(3041273328);
            return;
        }
    default:
        {
            FatalError("unknown union type");
            return;
        }
    }
}

auto PCacheStorageParent::Read(
        OptionalFileDescriptorSet* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    typedef OptionalFileDescriptorSet type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        mozilla::ipc::UnionTypeReadError("OptionalFileDescriptorSet");
        return false;
    }
    // Sentinel = 'OptionalFileDescriptorSet'
    if ((!((msg__)->ReadSentinel(iter__, 955222862)))) {
        mozilla::ipc::SentinelReadError("OptionalFileDescriptorSet");
        return false;
    }

    switch (type) {
    case type__::TPFileDescriptorSetParent:
        {
            return false;
        }
    case type__::TPFileDescriptorSetChild:
        {
            PFileDescriptorSetParent* tmp = nullptr;
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_PFileDescriptorSetParent())), msg__, iter__, false)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TPFileDescriptorSetChild'
            if ((!((msg__)->ReadSentinel(iter__, 3477929935)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::TArrayOfFileDescriptor:
        {
            nsTArray<FileDescriptor> tmp;
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_ArrayOfFileDescriptor())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'TArrayOfFileDescriptor'
            if ((!((msg__)->ReadSentinel(iter__, 2366096715)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            if ((!(Read((&((v__)->get_void_t())), msg__, iter__)))) {
                FatalError("Error deserializing Union type");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((msg__)->ReadSentinel(iter__, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing Union type");
                return false;
            }
            return true;
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PCacheStorageParent::Write(
        const StorageKeysArgs& v__,
        Message* msg__) -> void
{
}

auto PCacheStorageParent::Read(
        StorageKeysArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<HeadersEntry>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);
    // Sentinel = ('length', 'HeadersEntry[]')
    (msg__)->WriteSentinel(2248834657);

    for (auto& elem : v__) {
        Write(elem, msg__);
        // Sentinel = 'HeadersEntry[]'
        (msg__)->WriteSentinel(732413696);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<HeadersEntry>* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    nsTArray<HeadersEntry> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        mozilla::ipc::ArrayLengthReadError("HeadersEntry[]");
        return false;
    }
    // Sentinel = ('length', 'HeadersEntry[]')
    if ((!((msg__)->ReadSentinel(iter__, 2248834657)))) {
        mozilla::ipc::SentinelReadError("HeadersEntry[]");
        return false;
    }

    HeadersEntry* elems = (fa).AppendElements(length);
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(elems[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'HeadersEntry[i]'");
            return false;
        }
        // Sentinel = 'HeadersEntry[]'
        if ((!((msg__)->ReadSentinel(iter__, 732413696)))) {
            mozilla::ipc::SentinelReadError("Error deserializing 'HeadersEntry[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const nsTArray<PrincipalInfo>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);
    // Sentinel = ('length', 'PrincipalInfo[]')
    (msg__)->WriteSentinel(1032188126);

    for (auto& elem : v__) {
        Write(elem, msg__);
        // Sentinel = 'PrincipalInfo[]'
        (msg__)->WriteSentinel(413380193);
    }
}

auto PCacheStorageParent::Read(
        nsTArray<PrincipalInfo>* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    nsTArray<PrincipalInfo> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        mozilla::ipc::ArrayLengthReadError("PrincipalInfo[]");
        return false;
    }
    // Sentinel = ('length', 'PrincipalInfo[]')
    if ((!((msg__)->ReadSentinel(iter__, 1032188126)))) {
        mozilla::ipc::SentinelReadError("PrincipalInfo[]");
        return false;
    }

    PrincipalInfo* elems = (fa).AppendElements(length);
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(elems[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'PrincipalInfo[i]'");
            return false;
        }
        // Sentinel = 'PrincipalInfo[]'
        if ((!((msg__)->ReadSentinel(iter__, 413380193)))) {
            mozilla::ipc::SentinelReadError("Error deserializing 'PrincipalInfo[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PCacheStorageParent::Write(
        const FileDescriptor& v__,
        Message* msg__) -> void
{
    FileDescriptor::PickleType pfd = (v__).ShareTo(FileDescriptor::IPDLPrivate(), OtherPid());
    IPC::WriteParam(msg__, pfd);
}

auto PCacheStorageParent::Read(
        FileDescriptor* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    FileDescriptor::PickleType pfd;
    if ((!(IPC::ReadParam(msg__, iter__, (&(pfd)))))) {
        return false;
    }

    FileDescriptor fd = FileDescriptor(FileDescriptor::IPDLPrivate(), pfd);
    if ((!((fd).IsValid()))) {
        mozilla::ipc::ProtocolErrorBreakpoint("[PCacheStorageParent] Received an invalid file descriptor!");
    }

    (*(v__)) = fd;
    return true;
}

auto PCacheStorageParent::Write(
        const BufferedInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    // Sentinel = 'optionalStream'
    (msg__)->WriteSentinel(1003718562);
    Write((v__).bufferSize(), msg__);
    // Sentinel = 'bufferSize'
    (msg__)->WriteSentinel(3444538779);
}

auto PCacheStorageParent::Read(
        BufferedInputStreamParams* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    // Sentinel = 'optionalStream'
    if ((!((msg__)->ReadSentinel(iter__, 1003718562)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->bufferSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    // Sentinel = 'bufferSize'
    if ((!((msg__)->ReadSentinel(iter__, 3444538779)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const HeaderEntry& v__,
        Message* msg__) -> void
{
    Write((v__).name(), msg__);
    // Sentinel = 'name'
    (msg__)->WriteSentinel(15034981);
    Write((v__).value(), msg__);
    // Sentinel = 'value'
    (msg__)->WriteSentinel(3456818542);
}

auto PCacheStorageParent::Read(
        HeaderEntry* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->name())), msg__, iter__)))) {
        FatalError("Error deserializing 'name' (nsCString) member of 'HeaderEntry'");
        return false;
    }
    // Sentinel = 'name'
    if ((!((msg__)->ReadSentinel(iter__, 15034981)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'name' (nsCString) member of 'HeaderEntry'");
        return false;
    }
    if ((!(Read((&((v__)->value())), msg__, iter__)))) {
        FatalError("Error deserializing 'value' (nsCString) member of 'HeaderEntry'");
        return false;
    }
    // Sentinel = 'value'
    if ((!((msg__)->ReadSentinel(iter__, 3456818542)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'value' (nsCString) member of 'HeaderEntry'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const IPCChannelInfo& v__,
        Message* msg__) -> void
{
    Write((v__).securityInfo(), msg__);
    // Sentinel = 'securityInfo'
    (msg__)->WriteSentinel(158838750);
}

auto PCacheStorageParent::Read(
        IPCChannelInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->securityInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'securityInfo' (nsCString) member of 'IPCChannelInfo'");
        return false;
    }
    // Sentinel = 'securityInfo'
    if ((!((msg__)->ReadSentinel(iter__, 158838750)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'securityInfo' (nsCString) member of 'IPCChannelInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const ContentPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).attrs(), msg__);
    // Sentinel = 'attrs'
    (msg__)->WriteSentinel(3014987797);
    Write((v__).originNoSuffix(), msg__);
    // Sentinel = 'originNoSuffix'
    (msg__)->WriteSentinel(2833071422);
    Write((v__).spec(), msg__);
    // Sentinel = 'spec'
    (msg__)->WriteSentinel(1630740541);
}

auto PCacheStorageParent::Read(
        ContentPrincipalInfo* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->attrs())), msg__, iter__)))) {
        FatalError("Error deserializing 'attrs' (OriginAttributes) member of 'ContentPrincipalInfo'");
        return false;
    }
    // Sentinel = 'attrs'
    if ((!((msg__)->ReadSentinel(iter__, 3014987797)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'attrs' (OriginAttributes) member of 'ContentPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->originNoSuffix())), msg__, iter__)))) {
        FatalError("Error deserializing 'originNoSuffix' (ContentPrincipalInfoOriginNoSuffix) member of 'ContentPrincipalInfo'");
        return false;
    }
    // Sentinel = 'originNoSuffix'
    if ((!((msg__)->ReadSentinel(iter__, 2833071422)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'originNoSuffix' (ContentPrincipalInfoOriginNoSuffix) member of 'ContentPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'ContentPrincipalInfo'");
        return false;
    }
    // Sentinel = 'spec'
    if ((!((msg__)->ReadSentinel(iter__, 1630740541)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'spec' (nsCString) member of 'ContentPrincipalInfo'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const StorageHasArgs& v__,
        Message* msg__) -> void
{
    Write((v__).key(), msg__);
    // Sentinel = 'key'
    (msg__)->WriteSentinel(35142870);
}

auto PCacheStorageParent::Read(
        StorageHasArgs* v__,
        const Message* msg__,
        PickleIterator* iter__) -> bool
{
    if ((!(Read((&((v__)->key())), msg__, iter__)))) {
        FatalError("Error deserializing 'key' (nsString) member of 'StorageHasArgs'");
        return false;
    }
    // Sentinel = 'key'
    if ((!((msg__)->ReadSentinel(iter__, 35142870)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'key' (nsString) member of 'StorageHasArgs'");
        return false;
    }
    return true;
}

auto PCacheStorageParent::Write(
        const PChildToParentStreamParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->Id();
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PChildToParentStreamParent** v__,
        const Message* msg__,
        PickleIterator* iter__,
        bool nullable__) -> bool
{
    Maybe<mozilla::ipc::IProtocol*> actor = ReadActor(msg__, iter__, nullable__, "PChildToParentStream", PChildToParentStreamMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(v__)) = static_cast<PChildToParentStreamParent*>((actor).value());
    return true;
}

auto PCacheStorageParent::Write(
        const PCacheStreamControlParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->Id();
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStorageParent::Read(
        PCacheStreamControlParent** v__,
        const Message* msg__,
        PickleIterator* iter__,
        bool nullable__) -> bool
{
    Maybe<mozilla::ipc::IProtocol*> actor = ReadActor(msg__, iter__, nullable__, "PCacheStreamControl", PCacheStreamControlMsgStart);
    if ((actor).isNothing()) {
        return false;
    }

    (*(v__)) = static_cast<PCacheStreamControlParent*>((actor).value());
    return true;
}



} // namespace cache
} // namespace dom
} // namespace mozilla
