//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PDNSRequestParams.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct DNSRecord|
//
namespace mozilla {
namespace net {
MOZ_IMPLICIT DNSRecord::DNSRecord() :
    canonicalName_(),
    addrs_()
{
    Init();
}

DNSRecord::~DNSRecord()
{
}

auto DNSRecord::operator==(const DNSRecord& _o) const -> bool
{
    if ((!((canonicalName()) == ((_o).canonicalName())))) {
        return false;
    }
    if ((!((addrs()) == ((_o).addrs())))) {
        return false;
    }
    return true;
}

auto DNSRecord::operator!=(const DNSRecord& _o) const -> bool
{
    return (!(operator==(_o)));
}

auto DNSRecord::Init() -> void
{
}

auto DNSRecord::Assign(
        const nsCString& _canonicalName,
        const NetAddrArray& _addrs) -> void
{
    canonicalName_ = _canonicalName;
    addrs_ = _addrs;
}

} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union DNSRequestResponse|
//
namespace mozilla {
namespace net {
auto DNSRequestResponse::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TDNSRecord:
        {
            (ptr_DNSRecord())->~DNSRecord__tdef();
            break;
        }
    case Tnsresult:
        {
            (ptr_nsresult())->~nsresult__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT DNSRequestResponse::DNSRequestResponse(const DNSRecord& aOther)
{
    new (mozilla::KnownNotNull, ptr_DNSRecord()) DNSRecord(aOther);
    mType = TDNSRecord;
}

MOZ_IMPLICIT DNSRequestResponse::DNSRequestResponse(const nsresult& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsresult()) nsresult(aOther);
    mType = Tnsresult;
}

MOZ_IMPLICIT DNSRequestResponse::DNSRequestResponse(const DNSRequestResponse& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TDNSRecord:
        {
            new (mozilla::KnownNotNull, ptr_DNSRecord()) DNSRecord((aOther).get_DNSRecord());
            break;
        }
    case Tnsresult:
        {
            new (mozilla::KnownNotNull, ptr_nsresult()) nsresult((aOther).get_nsresult());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

DNSRequestResponse::~DNSRequestResponse()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto DNSRequestResponse::operator=(const DNSRecord& aRhs) -> DNSRequestResponse&
{
    if (MaybeDestroy(TDNSRecord)) {
        new (mozilla::KnownNotNull, ptr_DNSRecord()) DNSRecord;
    }
    (*(ptr_DNSRecord())) = aRhs;
    mType = TDNSRecord;
    return (*(this));
}

auto DNSRequestResponse::operator=(const nsresult& aRhs) -> DNSRequestResponse&
{
    if (MaybeDestroy(Tnsresult)) {
        new (mozilla::KnownNotNull, ptr_nsresult()) nsresult;
    }
    (*(ptr_nsresult())) = aRhs;
    mType = Tnsresult;
    return (*(this));
}

auto DNSRequestResponse::operator=(const DNSRequestResponse& aRhs) -> DNSRequestResponse&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TDNSRecord:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_DNSRecord()) DNSRecord;
            }
            (*(ptr_DNSRecord())) = (aRhs).get_DNSRecord();
            break;
        }
    case Tnsresult:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsresult()) nsresult;
            }
            (*(ptr_nsresult())) = (aRhs).get_nsresult();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto DNSRequestResponse::operator==(const DNSRecord& aRhs) const -> bool
{
    return (get_DNSRecord()) == (aRhs);
}

auto DNSRequestResponse::operator==(const nsresult& aRhs) const -> bool
{
    return (get_nsresult()) == (aRhs);
}

auto DNSRequestResponse::operator==(const DNSRequestResponse& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TDNSRecord:
        {
            return (get_DNSRecord()) == ((aRhs).get_DNSRecord());
        }
    case Tnsresult:
        {
            return (get_nsresult()) == ((aRhs).get_nsresult());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto DNSRequestResponse::get(DNSRecord* aOutValue) const -> void
{
    (*(aOutValue)) = get_DNSRecord();
}

auto DNSRequestResponse::get(nsresult* aOutValue) const -> void
{
    (*(aOutValue)) = get_nsresult();
}

} // namespace net
} // namespace mozilla
