//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDocAccessibleParent_h
#define PDocAccessibleParent_h

#include "mozilla/a11y/PDocAccessible.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/gfx/Point.h"
#include "nsRect.h"

namespace mozilla {
namespace ipc {
class PFileDescriptorSetParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PFileDescriptorSetChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace a11y {


class PDocAccessibleParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PBrowserParent;
protected:
    typedef mozilla::a11y::AccessibleData AccessibleData;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::a11y::Attribute Attribute;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gfx::IntPoint IntPoint;
    typedef mozilla::gfx::IntSize IntSize;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::a11y::RelationTargets RelationTargets;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::a11y::ShowEventData ShowEventData;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PFileDescriptorSetParent PFileDescriptorSetParent;
    typedef mozilla::ipc::PFileDescriptorSetChild PFileDescriptorSetChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;

    typedef PDocAccessible::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvShutdown() = 0;
    virtual mozilla::ipc::IPCResult
    RecvEvent(
            const uint64_t& aID,
            const uint32_t& type) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShowEvent(
            const ShowEventData& data,
            const bool& aFromuser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvHideEvent(
            const uint64_t& aRootID,
            const bool& aFromUser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStateChangeEvent(
            const uint64_t& aID,
            const uint64_t& aState,
            const bool& aEnabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCaretMoveEvent(
            const uint64_t& aID,
            const int32_t& aOffset) = 0;
    virtual mozilla::ipc::IPCResult
    RecvTextChangeEvent(
            const uint64_t& aID,
            const nsString& aStr,
            const int32_t& aStart,
            const uint32_t& aLen,
            const bool& aIsInsert,
            const bool& aFromUser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSelectionEvent(
            const uint64_t& aID,
            const uint64_t& aWidgetID,
            const uint32_t& aType) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRoleChangedEvent(const uint32_t& aRole) = 0;
    virtual mozilla::ipc::IPCResult
    RecvBindChildDoc(
            PDocAccessibleParent* aChildDoc,
            const uint64_t& aID) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PDocAccessibleParent();

    virtual ~PDocAccessibleParent();

    PBrowserParent*
    Manager() const;

    MOZ_MUST_USE static bool
    Send__delete__(PDocAccessibleParent* actor);

    MOZ_MUST_USE bool
    SendRestoreFocus();

    MOZ_MUST_USE bool
    SendState(
            const uint64_t& aID,
            uint64_t* states);

    MOZ_MUST_USE bool
    SendNativeState(
            const uint64_t& aID,
            uint64_t* states);

    MOZ_MUST_USE bool
    SendName(
            const uint64_t& aID,
            nsString* name);

    MOZ_MUST_USE bool
    SendValue(
            const uint64_t& aID,
            nsString* value);

    MOZ_MUST_USE bool
    SendHelp(
            const uint64_t& aID,
            nsString* help);

    MOZ_MUST_USE bool
    SendDescription(
            const uint64_t& aID,
            nsString* desc);

    MOZ_MUST_USE bool
    SendAttributes(
            const uint64_t& aID,
            nsTArray<Attribute>* attributes);

    MOZ_MUST_USE bool
    SendRelationByType(
            const uint64_t& aID,
            const uint32_t& aRelationType,
            nsTArray<uint64_t>* targets);

    MOZ_MUST_USE bool
    SendRelations(
            const uint64_t& aID,
            nsTArray<RelationTargets>* relations);

    MOZ_MUST_USE bool
    SendIsSearchbox(
            const uint64_t& aID,
            bool* retval);

    MOZ_MUST_USE bool
    SendLandmarkRole(
            const uint64_t& aID,
            nsString* landmark);

    MOZ_MUST_USE bool
    SendARIARoleAtom(
            const uint64_t& aID,
            nsString* role);

    MOZ_MUST_USE bool
    SendGetLevelInternal(
            const uint64_t& aID,
            int32_t* aLevel);

    MOZ_MUST_USE bool
    SendScrollTo(
            const uint64_t& aID,
            const uint32_t& aScrollType);

    MOZ_MUST_USE bool
    SendScrollToPoint(
            const uint64_t& aID,
            const uint32_t& aScrollType,
            const int32_t& aX,
            const int32_t& aY);

    MOZ_MUST_USE bool
    SendCaretLineNumber(
            const uint64_t& aID,
            int32_t* aLineNumber);

    MOZ_MUST_USE bool
    SendCaretOffset(
            const uint64_t& aID,
            int32_t* aOffset);

    MOZ_MUST_USE bool
    SendSetCaretOffset(
            const uint64_t& aID,
            const int32_t& aOffset);

    MOZ_MUST_USE bool
    SendCharacterCount(
            const uint64_t& aID,
            int32_t* aCount);

    MOZ_MUST_USE bool
    SendSelectionCount(
            const uint64_t& aID,
            int32_t* aCount);

    MOZ_MUST_USE bool
    SendTextSubstring(
            const uint64_t& aID,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            nsString* aText,
            bool* aValid);

    MOZ_MUST_USE bool
    SendGetTextAfterOffset(
            const uint64_t& aID,
            const int32_t& aOffset,
            const int32_t& aBoundaryType,
            nsString* aText,
            int32_t* aStartOffset,
            int32_t* aEndOffset);

    MOZ_MUST_USE bool
    SendGetTextAtOffset(
            const uint64_t& aID,
            const int32_t& aOffset,
            const int32_t& aBoundaryType,
            nsString* aText,
            int32_t* aStartOffset,
            int32_t* aEndOffset);

    MOZ_MUST_USE bool
    SendGetTextBeforeOffset(
            const uint64_t& aID,
            const int32_t& aOffset,
            const int32_t& aBoundaryType,
            nsString* aText,
            int32_t* aStartOffset,
            int32_t* aEndOffset);

    MOZ_MUST_USE bool
    SendCharAt(
            const uint64_t& aID,
            const int32_t& aOffset,
            uint16_t* aChar);

    MOZ_MUST_USE bool
    SendTextAttributes(
            const uint64_t& aID,
            const bool& aIncludeDefAttrs,
            const int32_t& aOffset,
            nsTArray<Attribute>* aAttributes,
            int32_t* aStartOffset,
            int32_t* aEndOffset);

    MOZ_MUST_USE bool
    SendDefaultTextAttributes(
            const uint64_t& aID,
            nsTArray<Attribute>* aAttributes);

    MOZ_MUST_USE bool
    SendTextBounds(
            const uint64_t& aID,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            const uint32_t& aCoordType,
            nsIntRect* aRetVal);

    MOZ_MUST_USE bool
    SendCharBounds(
            const uint64_t& aID,
            const int32_t& aOffset,
            const uint32_t& aCoordType,
            nsIntRect* aRetVal);

    MOZ_MUST_USE bool
    SendOffsetAtPoint(
            const uint64_t& aID,
            const int32_t& aX,
            const int32_t& aY,
            const uint32_t& aCoordType,
            int32_t* aRetVal);

    MOZ_MUST_USE bool
    SendSelectionBoundsAt(
            const uint64_t& aID,
            const int32_t& aSelectionNum,
            bool* aSucceeded,
            nsString* aData,
            int32_t* aStartOffset,
            int32_t* aEndOffset);

    MOZ_MUST_USE bool
    SendSetSelectionBoundsAt(
            const uint64_t& aID,
            const int32_t& aSelectionNum,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            bool* aSucceeded);

    MOZ_MUST_USE bool
    SendAddToSelection(
            const uint64_t& aID,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            bool* aSucceeded);

    MOZ_MUST_USE bool
    SendRemoveFromSelection(
            const uint64_t& aID,
            const int32_t& aSelectionNum,
            bool* aSucceeded);

    MOZ_MUST_USE bool
    SendScrollSubstringTo(
            const uint64_t& aID,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            const uint32_t& aScrollType);

    MOZ_MUST_USE bool
    SendScrollSubstringToPoint(
            const uint64_t& aID,
            const int32_t& aStartOffset,
            const int32_t& aEndOffset,
            const uint32_t& aCoordinateType,
            const int32_t& aX,
            const int32_t& aY);

    MOZ_MUST_USE bool
    SendText(
            const uint64_t& aID,
            nsString* aText);

    MOZ_MUST_USE bool
    SendReplaceText(
            const uint64_t& aID,
            const nsString& aText);

    MOZ_MUST_USE bool
    SendInsertText(
            const uint64_t& aID,
            const nsString& aText,
            const int32_t& aPosition,
            bool* aValid);

    MOZ_MUST_USE bool
    SendCopyText(
            const uint64_t& aID,
            const int32_t& aStartPos,
            const int32_t& aEndPos,
            bool* aValid);

    MOZ_MUST_USE bool
    SendCutText(
            const uint64_t& aID,
            const int32_t& aStartPos,
            const int32_t& aEndPos,
            bool* aValid);

    MOZ_MUST_USE bool
    SendDeleteText(
            const uint64_t& aID,
            const int32_t& aStartPos,
            const int32_t& aEndPos,
            bool* aValid);

    MOZ_MUST_USE bool
    SendPasteText(
            const uint64_t& aID,
            const int32_t& aPosition,
            bool* aValid);

    MOZ_MUST_USE bool
    SendImagePosition(
            const uint64_t& aID,
            const uint32_t& aCoordType,
            IntPoint* aRetVal);

    MOZ_MUST_USE bool
    SendImageSize(
            const uint64_t& aID,
            IntSize* aRetVal);

    MOZ_MUST_USE bool
    SendStartOffset(
            const uint64_t& aID,
            uint32_t* aRetVal,
            bool* aOk);

    MOZ_MUST_USE bool
    SendEndOffset(
            const uint64_t& aID,
            uint32_t* aRetVal,
            bool* aOk);

    MOZ_MUST_USE bool
    SendIsLinkValid(
            const uint64_t& aID,
            bool* aRetVal);

    MOZ_MUST_USE bool
    SendAnchorCount(
            const uint64_t& aID,
            uint32_t* aRetVal,
            bool* aOk);

    MOZ_MUST_USE bool
    SendAnchorURIAt(
            const uint64_t& aID,
            const uint32_t& aIndex,
            nsCString* aURI,
            bool* aOk);

    MOZ_MUST_USE bool
    SendAnchorAt(
            const uint64_t& aID,
            const uint32_t& aIndex,
            uint64_t* aIDOfAnchor,
            bool* aOk);

    MOZ_MUST_USE bool
    SendLinkCount(
            const uint64_t& aID,
            uint32_t* aCount);

    MOZ_MUST_USE bool
    SendLinkAt(
            const uint64_t& aID,
            const uint32_t& aIndex,
            uint64_t* aIDOfLink,
            bool* aOk);

    MOZ_MUST_USE bool
    SendLinkIndexOf(
            const uint64_t& aID,
            const uint64_t& aLinkID,
            int32_t* aIndex);

    MOZ_MUST_USE bool
    SendLinkIndexAtOffset(
            const uint64_t& aID,
            const uint32_t& aOffset,
            int32_t* aIndex);

    MOZ_MUST_USE bool
    SendTableOfACell(
            const uint64_t& aID,
            uint64_t* aTableID,
            bool* aOk);

    MOZ_MUST_USE bool
    SendColIdx(
            const uint64_t& aID,
            uint32_t* aIndex);

    MOZ_MUST_USE bool
    SendRowIdx(
            const uint64_t& aID,
            uint32_t* aIndex);

    MOZ_MUST_USE bool
    SendGetPosition(
            const uint64_t& aID,
            uint32_t* aRow,
            uint32_t* aCol);

    MOZ_MUST_USE bool
    SendColExtent(
            const uint64_t& aID,
            uint32_t* aExtent);

    MOZ_MUST_USE bool
    SendRowExtent(
            const uint64_t& aID,
            uint32_t* aExtent);

    MOZ_MUST_USE bool
    SendGetColRowExtents(
            const uint64_t& aID,
            uint32_t* aCol,
            uint32_t* aRow,
            uint32_t* aColExtent,
            uint32_t* aRowExtent);

    MOZ_MUST_USE bool
    SendColHeaderCells(
            const uint64_t& aID,
            nsTArray<uint64_t>* aCells);

    MOZ_MUST_USE bool
    SendRowHeaderCells(
            const uint64_t& aID,
            nsTArray<uint64_t>* aCells);

    MOZ_MUST_USE bool
    SendIsCellSelected(
            const uint64_t& aID,
            bool* aSelected);

    MOZ_MUST_USE bool
    SendTableCaption(
            const uint64_t& aID,
            uint64_t* aCaptionID,
            bool* aOk);

    MOZ_MUST_USE bool
    SendTableSummary(
            const uint64_t& aID,
            nsString* aSummary);

    MOZ_MUST_USE bool
    SendTableColumnCount(
            const uint64_t& aID,
            uint32_t* aColCount);

    MOZ_MUST_USE bool
    SendTableRowCount(
            const uint64_t& aID,
            uint32_t* aRowCount);

    MOZ_MUST_USE bool
    SendTableCellAt(
            const uint64_t& aID,
            const uint32_t& aRow,
            const uint32_t& aCol,
            uint64_t* aCellID,
            bool* aOk);

    MOZ_MUST_USE bool
    SendTableCellIndexAt(
            const uint64_t& aID,
            const uint32_t& aRow,
            const uint32_t& aCol,
            int32_t* aIndex);

    MOZ_MUST_USE bool
    SendTableColumnIndexAt(
            const uint64_t& aID,
            const uint32_t& aCellIndex,
            int32_t* aCol);

    MOZ_MUST_USE bool
    SendTableRowIndexAt(
            const uint64_t& aID,
            const uint32_t& aCellIndex,
            int32_t* aRow);

    MOZ_MUST_USE bool
    SendTableRowAndColumnIndicesAt(
            const uint64_t& aID,
            const uint32_t& aCellIndex,
            int32_t* aRow,
            int32_t* aCol);

    MOZ_MUST_USE bool
    SendTableColumnExtentAt(
            const uint64_t& aID,
            const uint32_t& aRow,
            const uint32_t& aCol,
            uint32_t* aExtent);

    MOZ_MUST_USE bool
    SendTableRowExtentAt(
            const uint64_t& aID,
            const uint32_t& aRow,
            const uint32_t& aCol,
            uint32_t* aExtent);

    MOZ_MUST_USE bool
    SendTableColumnDescription(
            const uint64_t& aID,
            const uint32_t& aCol,
            nsString* aDescription);

    MOZ_MUST_USE bool
    SendTableRowDescription(
            const uint64_t& aID,
            const uint32_t& aRow,
            nsString* aDescription);

    MOZ_MUST_USE bool
    SendTableColumnSelected(
            const uint64_t& aID,
            const uint32_t& aCol,
            bool* aSelected);

    MOZ_MUST_USE bool
    SendTableRowSelected(
            const uint64_t& aID,
            const uint32_t& aRow,
            bool* aSelected);

    MOZ_MUST_USE bool
    SendTableCellSelected(
            const uint64_t& aID,
            const uint32_t& aRow,
            const uint32_t& aCol,
            bool* aSelected);

    MOZ_MUST_USE bool
    SendTableSelectedCellCount(
            const uint64_t& aID,
            uint32_t* aSelectedCells);

    MOZ_MUST_USE bool
    SendTableSelectedColumnCount(
            const uint64_t& aID,
            uint32_t* aSelectedColumns);

    MOZ_MUST_USE bool
    SendTableSelectedRowCount(
            const uint64_t& aID,
            uint32_t* aSelectedRows);

    MOZ_MUST_USE bool
    SendTableSelectedCells(
            const uint64_t& aID,
            nsTArray<uint64_t>* aCellIDs);

    MOZ_MUST_USE bool
    SendTableSelectedCellIndices(
            const uint64_t& aID,
            nsTArray<uint32_t>* aCellIndeces);

    MOZ_MUST_USE bool
    SendTableSelectedColumnIndices(
            const uint64_t& aID,
            nsTArray<uint32_t>* aColumnIndeces);

    MOZ_MUST_USE bool
    SendTableSelectedRowIndices(
            const uint64_t& aID,
            nsTArray<uint32_t>* aRowIndeces);

    MOZ_MUST_USE bool
    SendTableSelectColumn(
            const uint64_t& aID,
            const uint32_t& aCol);

    MOZ_MUST_USE bool
    SendTableSelectRow(
            const uint64_t& aID,
            const uint32_t& aRow);

    MOZ_MUST_USE bool
    SendTableUnselectColumn(
            const uint64_t& aID,
            const uint32_t& aCol);

    MOZ_MUST_USE bool
    SendTableUnselectRow(
            const uint64_t& aID,
            const uint32_t& aRow);

    MOZ_MUST_USE bool
    SendTableIsProbablyForLayout(
            const uint64_t& aID,
            bool* aForLayout);

    MOZ_MUST_USE bool
    SendAtkTableColumnHeader(
            const uint64_t& aID,
            const int32_t& aCol,
            uint64_t* aHeaderID,
            bool* aOk);

    MOZ_MUST_USE bool
    SendAtkTableRowHeader(
            const uint64_t& aID,
            const int32_t& aRow,
            uint64_t* aHeaderID,
            bool* aOk);

    MOZ_MUST_USE bool
    SendSelectedItems(
            const uint64_t& aID,
            nsTArray<uint64_t>* aSelectedItemIDs);

    MOZ_MUST_USE bool
    SendSelectedItemCount(
            const uint64_t& aID,
            uint32_t* aCount);

    MOZ_MUST_USE bool
    SendGetSelectedItem(
            const uint64_t& aID,
            const uint32_t& aIndex,
            uint64_t* aSelected,
            bool* aOk);

    MOZ_MUST_USE bool
    SendIsItemSelected(
            const uint64_t& aID,
            const uint32_t& aIndex,
            bool* aSelected);

    MOZ_MUST_USE bool
    SendAddItemToSelection(
            const uint64_t& aID,
            const uint32_t& aIndex,
            bool* aSuccess);

    MOZ_MUST_USE bool
    SendRemoveItemFromSelection(
            const uint64_t& aID,
            const uint32_t& aIndex,
            bool* aSuccess);

    MOZ_MUST_USE bool
    SendSelectAll(
            const uint64_t& aID,
            bool* aSuccess);

    MOZ_MUST_USE bool
    SendUnselectAll(
            const uint64_t& aID,
            bool* aSuccess);

    MOZ_MUST_USE bool
    SendTakeSelection(const uint64_t& aID);

    MOZ_MUST_USE bool
    SendSetSelected(
            const uint64_t& aID,
            const bool& aSelected);

    MOZ_MUST_USE bool
    SendDoAction(
            const uint64_t& aID,
            const uint8_t& aIndex,
            bool* aSuccess);

    MOZ_MUST_USE bool
    SendActionCount(
            const uint64_t& aID,
            uint8_t* aCount);

    MOZ_MUST_USE bool
    SendActionDescriptionAt(
            const uint64_t& aID,
            const uint8_t& aIndex,
            nsString* aDescription);

    MOZ_MUST_USE bool
    SendActionNameAt(
            const uint64_t& aID,
            const uint8_t& aIndex,
            nsString* aName);

    MOZ_MUST_USE bool
    SendAccessKey(
            const uint64_t& aID,
            uint32_t* aKey,
            uint32_t* aModifierMask);

    MOZ_MUST_USE bool
    SendKeyboardShortcut(
            const uint64_t& aID,
            uint32_t* aKey,
            uint32_t* aModifierMask);

    MOZ_MUST_USE bool
    SendAtkKeyBinding(
            const uint64_t& aID,
            nsString* aResult);

    MOZ_MUST_USE bool
    SendCurValue(
            const uint64_t& aID,
            double* aValue);

    MOZ_MUST_USE bool
    SendSetCurValue(
            const uint64_t& aID,
            const double& aValue,
            bool* aRetVal);

    MOZ_MUST_USE bool
    SendMinValue(
            const uint64_t& aID,
            double* aValue);

    MOZ_MUST_USE bool
    SendMaxValue(
            const uint64_t& aID,
            double* aValue);

    MOZ_MUST_USE bool
    SendStep(
            const uint64_t& aID,
            double* aStep);

    MOZ_MUST_USE bool
    SendTakeFocus(const uint64_t& aID);

    MOZ_MUST_USE bool
    SendFocusedChild(
            const uint64_t& aID,
            uint64_t* aChild,
            bool* aOk);

    MOZ_MUST_USE bool
    SendLanguage(
            const uint64_t& aID,
            nsString* aLocale);

    MOZ_MUST_USE bool
    SendDocType(
            const uint64_t& aID,
            nsString* aType);

    MOZ_MUST_USE bool
    SendTitle(
            const uint64_t& aID,
            nsString* aTitle);

    MOZ_MUST_USE bool
    SendURL(
            const uint64_t& aID,
            nsString* aURL);

    MOZ_MUST_USE bool
    SendMimeType(
            const uint64_t& aID,
            nsString* aMime);

    MOZ_MUST_USE bool
    SendURLDocTypeMimeType(
            const uint64_t& aID,
            nsString* aURL,
            nsString* aDocType,
            nsString* aMimeType);

    MOZ_MUST_USE bool
    SendAccessibleAtPoint(
            const uint64_t& aID,
            const int32_t& aX,
            const int32_t& aY,
            const bool& aNeedsScreenCoords,
            const uint32_t& aWhich,
            uint64_t* aResult,
            bool* aOk);

    MOZ_MUST_USE bool
    SendExtents(
            const uint64_t& aID,
            const bool& aNeedsScreenCoords,
            int32_t* aX,
            int32_t* aY,
            int32_t* aWidth,
            int32_t* aHeight);

    MOZ_MUST_USE bool
    SendDOMNodeID(
            const uint64_t& aID,
            nsString* aDOMNodeID);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PDocAccessibleParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PDocAccessibleParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const nsTArray<AccessibleData>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<AccessibleData>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<RelationTargets>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<RelationTargets>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const RelationTargets& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            RelationTargets* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ShowEventData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ShowEventData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<Attribute>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<Attribute>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const AccessibleData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            AccessibleData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const Attribute& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Attribute* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace a11y
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace a11y {
class DocAccessibleParent :
    public PDocAccessibleParent
{
    virtual mozilla::ipc::IPCResult
    RecvShutdown();

    virtual mozilla::ipc::IPCResult
    RecvEvent(
            const uint64_t& aID,
            const uint32_t& type);

    virtual mozilla::ipc::IPCResult
    RecvShowEvent(
            const ShowEventData& data,
            const bool& aFromuser);

    virtual mozilla::ipc::IPCResult
    RecvHideEvent(
            const uint64_t& aRootID,
            const bool& aFromUser);

    virtual mozilla::ipc::IPCResult
    RecvStateChangeEvent(
            const uint64_t& aID,
            const uint64_t& aState,
            const bool& aEnabled);

    virtual mozilla::ipc::IPCResult
    RecvCaretMoveEvent(
            const uint64_t& aID,
            const int32_t& aOffset);

    virtual mozilla::ipc::IPCResult
    RecvTextChangeEvent(
            const uint64_t& aID,
            const nsString& aStr,
            const int32_t& aStart,
            const uint32_t& aLen,
            const bool& aIsInsert,
            const bool& aFromUser);

    virtual mozilla::ipc::IPCResult
    RecvSelectionEvent(
            const uint64_t& aID,
            const uint64_t& aWidgetID,
            const uint32_t& aType);

    virtual mozilla::ipc::IPCResult
    RecvRoleChangedEvent(const uint32_t& aRole);

    virtual mozilla::ipc::IPCResult
    RecvBindChildDoc(
            PDocAccessibleParent* aChildDoc,
            const uint64_t& aID);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT DocAccessibleParent();
    virtual ~DocAccessibleParent();
};
} // namespace a11y
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace a11y {
mozilla::ipc::IPCResult
DocAccessibleParent::RecvShutdown()
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvEvent(
        const uint64_t& aID,
        const uint32_t& type)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvShowEvent(
        const ShowEventData& data,
        const bool& aFromuser)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvHideEvent(
        const uint64_t& aRootID,
        const bool& aFromUser)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvStateChangeEvent(
        const uint64_t& aID,
        const uint64_t& aState,
        const bool& aEnabled)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvCaretMoveEvent(
        const uint64_t& aID,
        const int32_t& aOffset)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvTextChangeEvent(
        const uint64_t& aID,
        const nsString& aStr,
        const int32_t& aStart,
        const uint32_t& aLen,
        const bool& aIsInsert,
        const bool& aFromUser)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvSelectionEvent(
        const uint64_t& aID,
        const uint64_t& aWidgetID,
        const uint32_t& aType)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvRoleChangedEvent(const uint32_t& aRole)
{
}

mozilla::ipc::IPCResult
DocAccessibleParent::RecvBindChildDoc(
        PDocAccessibleParent* aChildDoc,
        const uint64_t& aID)
{
}

void
DocAccessibleParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT DocAccessibleParent::DocAccessibleParent()
{
    MOZ_COUNT_CTOR(DocAccessibleParent);
}

MOZ_IMPLICIT DocAccessibleParent::~DocAccessibleParent()
{
    MOZ_COUNT_DTOR(DocAccessibleParent);
}

} // namespace a11y
} // namespace mozilla
#endif // if 0

#endif // ifndef PDocAccessibleParent_h
