//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCameras_h
#define PCameras_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct VideoCaptureCapability|
//
namespace mozilla {
namespace camera {
class VideoCaptureCapability final
{
private:

public:
    MOZ_IMPLICIT VideoCaptureCapability();

    MOZ_IMPLICIT VideoCaptureCapability(
            const int& _width,
            const int& _height,
            const int& _maxFPS,
            const int& _expectedCaptureDelay,
            const int& _rawType,
            const int& _codecType,
            const bool& _interlaced)
    {
        Init();
        Assign(_width, _height, _maxFPS, _expectedCaptureDelay, _rawType, _codecType, _interlaced);
    }

    MOZ_IMPLICIT VideoCaptureCapability(const VideoCaptureCapability& _o)
    {
        Init();
        Assign((_o).width(), (_o).height(), (_o).maxFPS(), (_o).expectedCaptureDelay(), (_o).rawType(), (_o).codecType(), (_o).interlaced());
    }

    ~VideoCaptureCapability();

    void
    operator=(const VideoCaptureCapability& _o)
    {
        Assign((_o).width(), (_o).height(), (_o).maxFPS(), (_o).expectedCaptureDelay(), (_o).rawType(), (_o).codecType(), (_o).interlaced());
    }

    bool
    operator==(const VideoCaptureCapability& _o) const;

    bool
    operator!=(const VideoCaptureCapability& _o) const;

    int&
    width()
    {
        return width_;
    }
    const int&
    width() const
    {
        return width_;
    }

    int&
    height()
    {
        return height_;
    }
    const int&
    height() const
    {
        return height_;
    }

    int&
    maxFPS()
    {
        return maxFPS_;
    }
    const int&
    maxFPS() const
    {
        return maxFPS_;
    }

    int&
    expectedCaptureDelay()
    {
        return expectedCaptureDelay_;
    }
    const int&
    expectedCaptureDelay() const
    {
        return expectedCaptureDelay_;
    }

    int&
    rawType()
    {
        return rawType_;
    }
    const int&
    rawType() const
    {
        return rawType_;
    }

    int&
    codecType()
    {
        return codecType_;
    }
    const int&
    codecType() const
    {
        return codecType_;
    }

    bool&
    interlaced()
    {
        return interlaced_;
    }
    const bool&
    interlaced() const
    {
        return interlaced_;
    }

private:
    void
    Init();

    void
    Assign(
            const int& _width,
            const int& _height,
            const int& _maxFPS,
            const int& _expectedCaptureDelay,
            const int& _rawType,
            const int& _codecType,
            const bool& _interlaced);

    int width_;
    int height_;
    int maxFPS_;
    int expectedCaptureDelay_;
    int rawType_;
    int codecType_;
    bool interlaced_;
};
} // namespace camera
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct VideoFrameProperties|
//
namespace mozilla {
namespace camera {
class VideoFrameProperties final
{
private:

public:
    MOZ_IMPLICIT VideoFrameProperties();

    MOZ_IMPLICIT VideoFrameProperties(
            const size_t& _bufferSize,
            const uint32_t& _timeStamp,
            const int64_t& _ntpTimeMs,
            const int64_t& _renderTimeMs,
            const int& _rotation,
            const int& _yAllocatedSize,
            const int& _uAllocatedSize,
            const int& _vAllocatedSize,
            const int& _width,
            const int& _height,
            const int& _yStride,
            const int& _uStride,
            const int& _vStride)
    {
        Init();
        Assign(_bufferSize, _timeStamp, _ntpTimeMs, _renderTimeMs, _rotation, _yAllocatedSize, _uAllocatedSize, _vAllocatedSize, _width, _height, _yStride, _uStride, _vStride);
    }

    MOZ_IMPLICIT VideoFrameProperties(const VideoFrameProperties& _o)
    {
        Init();
        Assign((_o).bufferSize(), (_o).timeStamp(), (_o).ntpTimeMs(), (_o).renderTimeMs(), (_o).rotation(), (_o).yAllocatedSize(), (_o).uAllocatedSize(), (_o).vAllocatedSize(), (_o).width(), (_o).height(), (_o).yStride(), (_o).uStride(), (_o).vStride());
    }

    ~VideoFrameProperties();

    void
    operator=(const VideoFrameProperties& _o)
    {
        Assign((_o).bufferSize(), (_o).timeStamp(), (_o).ntpTimeMs(), (_o).renderTimeMs(), (_o).rotation(), (_o).yAllocatedSize(), (_o).uAllocatedSize(), (_o).vAllocatedSize(), (_o).width(), (_o).height(), (_o).yStride(), (_o).uStride(), (_o).vStride());
    }

    bool
    operator==(const VideoFrameProperties& _o) const;

    bool
    operator!=(const VideoFrameProperties& _o) const;

    size_t&
    bufferSize()
    {
        return bufferSize_;
    }
    const size_t&
    bufferSize() const
    {
        return bufferSize_;
    }

    uint32_t&
    timeStamp()
    {
        return timeStamp_;
    }
    const uint32_t&
    timeStamp() const
    {
        return timeStamp_;
    }

    int64_t&
    ntpTimeMs()
    {
        return ntpTimeMs_;
    }
    const int64_t&
    ntpTimeMs() const
    {
        return ntpTimeMs_;
    }

    int64_t&
    renderTimeMs()
    {
        return renderTimeMs_;
    }
    const int64_t&
    renderTimeMs() const
    {
        return renderTimeMs_;
    }

    int&
    rotation()
    {
        return rotation_;
    }
    const int&
    rotation() const
    {
        return rotation_;
    }

    int&
    yAllocatedSize()
    {
        return yAllocatedSize_;
    }
    const int&
    yAllocatedSize() const
    {
        return yAllocatedSize_;
    }

    int&
    uAllocatedSize()
    {
        return uAllocatedSize_;
    }
    const int&
    uAllocatedSize() const
    {
        return uAllocatedSize_;
    }

    int&
    vAllocatedSize()
    {
        return vAllocatedSize_;
    }
    const int&
    vAllocatedSize() const
    {
        return vAllocatedSize_;
    }

    int&
    width()
    {
        return width_;
    }
    const int&
    width() const
    {
        return width_;
    }

    int&
    height()
    {
        return height_;
    }
    const int&
    height() const
    {
        return height_;
    }

    int&
    yStride()
    {
        return yStride_;
    }
    const int&
    yStride() const
    {
        return yStride_;
    }

    int&
    uStride()
    {
        return uStride_;
    }
    const int&
    uStride() const
    {
        return uStride_;
    }

    int&
    vStride()
    {
        return vStride_;
    }
    const int&
    vStride() const
    {
        return vStride_;
    }

private:
    void
    Init();

    void
    Assign(
            const size_t& _bufferSize,
            const uint32_t& _timeStamp,
            const int64_t& _ntpTimeMs,
            const int64_t& _renderTimeMs,
            const int& _rotation,
            const int& _yAllocatedSize,
            const int& _uAllocatedSize,
            const int& _vAllocatedSize,
            const int& _width,
            const int& _height,
            const int& _yStride,
            const int& _uStride,
            const int& _vStride);

    size_t bufferSize_;
    uint32_t timeStamp_;
    int64_t ntpTimeMs_;
    int64_t renderTimeMs_;
    int rotation_;
    int yAllocatedSize_;
    int uAllocatedSize_;
    int vAllocatedSize_;
    int width_;
    int height_;
    int yStride_;
    int uStride_;
    int vStride_;
};
} // namespace camera
} // namespace mozilla

namespace mozilla {
namespace camera {
class PCamerasParent;
} // namespace camera
} // namespace mozilla
namespace mozilla {
namespace camera {
class PCamerasChild;
} // namespace camera
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PCamerasChild and PCamerasParent
//
namespace mozilla {
namespace camera {
namespace PCameras {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::camera::PCamerasParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::camera::PCamerasChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PCamerasStart = PCamerasMsgStart << 16,
    Msg_FrameSizeChange__ID,
    Msg_DeliverFrame__ID,
    Msg_DeviceChange__ID,
    Msg_ReplyNumberOfCaptureDevices__ID,
    Msg_ReplyNumberOfCapabilities__ID,
    Msg_ReplyAllocateCaptureDevice__ID,
    Msg_ReplyGetCaptureCapability__ID,
    Msg_ReplyGetCaptureDevice__ID,
    Msg_ReplyFailure__ID,
    Msg_ReplySuccess__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_NumberOfCaptureDevices__ID,
    Msg_NumberOfCapabilities__ID,
    Msg_GetCaptureCapability__ID,
    Msg_GetCaptureDevice__ID,
    Msg_AllocateCaptureDevice__ID,
    Msg_ReleaseCaptureDevice__ID,
    Msg_StartCapture__ID,
    Msg_StopCapture__ID,
    Msg_ReleaseFrame__ID,
    Msg_AllDone__ID,
    Msg_EnsureInitialized__ID,
    PCamerasEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg_FrameSizeChange(int32_t routingId);

IPC::Message*
Msg_DeliverFrame(int32_t routingId);

IPC::Message*
Msg_DeviceChange(int32_t routingId);

IPC::Message*
Msg_ReplyNumberOfCaptureDevices(int32_t routingId);

IPC::Message*
Msg_ReplyNumberOfCapabilities(int32_t routingId);

IPC::Message*
Msg_ReplyAllocateCaptureDevice(int32_t routingId);

IPC::Message*
Msg_ReplyGetCaptureCapability(int32_t routingId);

IPC::Message*
Msg_ReplyGetCaptureDevice(int32_t routingId);

IPC::Message*
Msg_ReplyFailure(int32_t routingId);

IPC::Message*
Msg_ReplySuccess(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_NumberOfCaptureDevices(int32_t routingId);

IPC::Message*
Msg_NumberOfCapabilities(int32_t routingId);

IPC::Message*
Msg_GetCaptureCapability(int32_t routingId);

IPC::Message*
Msg_GetCaptureDevice(int32_t routingId);

IPC::Message*
Msg_AllocateCaptureDevice(int32_t routingId);

IPC::Message*
Msg_ReleaseCaptureDevice(int32_t routingId);

IPC::Message*
Msg_StartCapture(int32_t routingId);

IPC::Message*
Msg_StopCapture(int32_t routingId);

IPC::Message*
Msg_ReleaseFrame(int32_t routingId);

IPC::Message*
Msg_AllDone(int32_t routingId);

IPC::Message*
Msg_EnsureInitialized(int32_t routingId);



} // namespace PCameras
} // namespace camera
} // namespace mozilla

#endif // ifndef PCameras_h
