//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCamerasChild_h
#define PCamerasChild_h

#include "mozilla/camera/PCameras.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/media/CamerasTypes.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace camera {


class PCamerasChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::camera::CaptureEngine CaptureEngine;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::ContentPrincipalInfoOriginNoSuffix ContentPrincipalInfoOriginNoSuffix;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::camera::VideoCaptureCapability VideoCaptureCapability;
    typedef mozilla::camera::VideoFrameProperties VideoFrameProperties;
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;

    typedef PCameras::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvFrameSizeChange(
            const CaptureEngine& capEngine,
            const int& cap_id,
            const int& w,
            const int& h) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDeliverFrame(
            const CaptureEngine& capEngine,
            const int& streamId,
            Shmem&& buffer,
            const VideoFrameProperties& props) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDeviceChange() = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyNumberOfCaptureDevices(const int& numdev) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyNumberOfCapabilities(const int& numdev) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyAllocateCaptureDevice(const int& numdev) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyGetCaptureCapability(const VideoCaptureCapability& cap) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyGetCaptureDevice(
            const nsCString& device_name,
            const nsCString& device_id,
            const bool& scary) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplyFailure() = 0;
    virtual mozilla::ipc::IPCResult
    RecvReplySuccess() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PCamerasChild();

    virtual ~PCamerasChild();

    PBackgroundChild*
    Manager() const;

    bool
    SendNumberOfCaptureDevices(const CaptureEngine& engine);

    bool
    SendNumberOfCapabilities(
            const CaptureEngine& engine,
            const nsCString& deviceUniqueIdUTF8);

    bool
    SendGetCaptureCapability(
            const CaptureEngine& engine,
            const nsCString& unique_idUTF8,
            const int& capability_number);

    bool
    SendGetCaptureDevice(
            const CaptureEngine& engine,
            const int& num);

    bool
    SendAllocateCaptureDevice(
            const CaptureEngine& engine,
            const nsCString& unique_idUTF8,
            const PrincipalInfo& principal);

    bool
    SendReleaseCaptureDevice(
            const CaptureEngine& engine,
            const int& numdev);

    bool
    SendStartCapture(
            const CaptureEngine& engine,
            const int& numdev,
            const VideoCaptureCapability& capability);

    bool
    SendStopCapture(
            const CaptureEngine& engine,
            const int& numdev);

    bool
    SendReleaseFrame(Shmem& s);

    bool
    SendAllDone();

    bool
    SendEnsureInitialized(const CaptureEngine& engine);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SystemPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SystemPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<PrincipalInfo>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<PrincipalInfo>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const VideoFrameProperties& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            VideoFrameProperties* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Shmem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            PrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ContentPrincipalInfoOriginNoSuffix& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ContentPrincipalInfoOriginNoSuffix* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ContentPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ContentPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const NullPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            NullPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ExpandedPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ExpandedPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PCamerasChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PCamerasChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const VideoCaptureCapability& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            VideoCaptureCapability* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace camera
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace camera {
class CamerasChild :
    public PCamerasChild
{
    virtual mozilla::ipc::IPCResult
    RecvFrameSizeChange(
            const CaptureEngine& capEngine,
            const int& cap_id,
            const int& w,
            const int& h);

    virtual mozilla::ipc::IPCResult
    RecvDeliverFrame(
            const CaptureEngine& capEngine,
            const int& streamId,
            Shmem&& buffer,
            const VideoFrameProperties& props);

    virtual mozilla::ipc::IPCResult
    RecvDeviceChange();

    virtual mozilla::ipc::IPCResult
    RecvReplyNumberOfCaptureDevices(const int& numdev);

    virtual mozilla::ipc::IPCResult
    RecvReplyNumberOfCapabilities(const int& numdev);

    virtual mozilla::ipc::IPCResult
    RecvReplyAllocateCaptureDevice(const int& numdev);

    virtual mozilla::ipc::IPCResult
    RecvReplyGetCaptureCapability(const VideoCaptureCapability& cap);

    virtual mozilla::ipc::IPCResult
    RecvReplyGetCaptureDevice(
            const nsCString& device_name,
            const nsCString& device_id,
            const bool& scary);

    virtual mozilla::ipc::IPCResult
    RecvReplyFailure();

    virtual mozilla::ipc::IPCResult
    RecvReplySuccess();

    MOZ_IMPLICIT CamerasChild();
    virtual ~CamerasChild();
};
} // namespace camera
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace camera {
mozilla::ipc::IPCResult
CamerasChild::RecvFrameSizeChange(
        const CaptureEngine& capEngine,
        const int& cap_id,
        const int& w,
        const int& h)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvDeliverFrame(
        const CaptureEngine& capEngine,
        const int& streamId,
        Shmem&& buffer,
        const VideoFrameProperties& props)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvDeviceChange()
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplyNumberOfCaptureDevices(const int& numdev)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplyNumberOfCapabilities(const int& numdev)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplyAllocateCaptureDevice(const int& numdev)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplyGetCaptureCapability(const VideoCaptureCapability& cap)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplyGetCaptureDevice(
        const nsCString& device_name,
        const nsCString& device_id,
        const bool& scary)
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplyFailure()
{
}

mozilla::ipc::IPCResult
CamerasChild::RecvReplySuccess()
{
}

MOZ_IMPLICIT CamerasChild::CamerasChild()
{
    MOZ_COUNT_CTOR(CamerasChild);
}

MOZ_IMPLICIT CamerasChild::~CamerasChild()
{
    MOZ_COUNT_DTOR(CamerasChild);
}

} // namespace camera
} // namespace mozilla
#endif // if 0

#endif // ifndef PCamerasChild_h
