//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef DOMTypes_h
#define DOMTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "Units.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "mozilla/layers/CompositorOptions.h"
#include "mozilla/layers/CompositorTypes.h"
#include "mozilla/dom/IPCBlob.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MessagePortIdentifier|
//
namespace mozilla {
namespace dom {
class MessagePortIdentifier final
{
private:

public:
    MOZ_IMPLICIT MessagePortIdentifier();

    MOZ_IMPLICIT MessagePortIdentifier(
            const nsID& _uuid,
            const nsID& _destinationUuid,
            const uint32_t& _sequenceId,
            const bool& _neutered)
    {
        Init();
        Assign(_uuid, _destinationUuid, _sequenceId, _neutered);
    }

    MOZ_IMPLICIT MessagePortIdentifier(const MessagePortIdentifier& _o)
    {
        Init();
        Assign((_o).uuid(), (_o).destinationUuid(), (_o).sequenceId(), (_o).neutered());
    }

    ~MessagePortIdentifier();

    void
    operator=(const MessagePortIdentifier& _o)
    {
        Assign((_o).uuid(), (_o).destinationUuid(), (_o).sequenceId(), (_o).neutered());
    }

    bool
    operator==(const MessagePortIdentifier& _o) const;

    bool
    operator!=(const MessagePortIdentifier& _o) const;

    nsID&
    uuid()
    {
        return uuid_;
    }
    const nsID&
    uuid() const
    {
        return uuid_;
    }

    nsID&
    destinationUuid()
    {
        return destinationUuid_;
    }
    const nsID&
    destinationUuid() const
    {
        return destinationUuid_;
    }

    uint32_t&
    sequenceId()
    {
        return sequenceId_;
    }
    const uint32_t&
    sequenceId() const
    {
        return sequenceId_;
    }

    bool&
    neutered()
    {
        return neutered_;
    }
    const bool&
    neutered() const
    {
        return neutered_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _uuid,
            const nsID& _destinationUuid,
            const uint32_t& _sequenceId,
            const bool& _neutered);

    nsID uuid_;
    nsID destinationUuid_;
    uint32_t sequenceId_;
    bool neutered_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCBlob;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
class IPCStream;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace dom {
class MessagePortIdentifier;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
class ClonedMessageData final
{
private:
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;

public:
    MOZ_IMPLICIT ClonedMessageData();

    MOZ_IMPLICIT ClonedMessageData(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<IPCBlob>& _blobs,
            const nsTArray<IPCStream>& _inputStreams,
            const nsTArray<MessagePortIdentifier>& _identfiers)
    {
        Init();
        Assign(_data, _blobs, _inputStreams, _identfiers);
    }

    MOZ_IMPLICIT ClonedMessageData(const ClonedMessageData& _o)
    {
        Init();
        Assign((_o).data(), (_o).blobs(), (_o).inputStreams(), (_o).identfiers());
    }

    ~ClonedMessageData();

    void
    operator=(const ClonedMessageData& _o)
    {
        Assign((_o).data(), (_o).blobs(), (_o).inputStreams(), (_o).identfiers());
    }

    bool
    operator==(const ClonedMessageData& _o) const;

    bool
    operator!=(const ClonedMessageData& _o) const;

    SerializedStructuredCloneBuffer&
    data()
    {
        return data_;
    }
    const SerializedStructuredCloneBuffer&
    data() const
    {
        return data_;
    }

    nsTArray<IPCBlob>&
    blobs()
    {
        return blobs_;
    }
    const nsTArray<IPCBlob>&
    blobs() const
    {
        return blobs_;
    }

    nsTArray<IPCStream>&
    inputStreams()
    {
        return inputStreams_;
    }
    const nsTArray<IPCStream>&
    inputStreams() const
    {
        return inputStreams_;
    }

    nsTArray<MessagePortIdentifier>&
    identfiers()
    {
        return identfiers_;
    }
    const nsTArray<MessagePortIdentifier>&
    identfiers() const
    {
        return identfiers_;
    }

private:
    void
    Init();

    void
    Assign(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<IPCBlob>& _blobs,
            const nsTArray<IPCStream>& _inputStreams,
            const nsTArray<MessagePortIdentifier>& _identfiers);

    SerializedStructuredCloneBuffer data_;
    nsTArray<IPCBlob> blobs_;
    nsTArray<IPCStream> inputStreams_;
    nsTArray<MessagePortIdentifier> identfiers_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCBlob;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCDataTransferData|
//
namespace mozilla {
namespace dom {
class IPCDataTransferData final
{
public:
    enum Type {
        T__None,
        TnsString = 1,
        TShmem,
        TIPCBlob,
        T__Last = TIPCBlob
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::IPCBlob IPCBlob;
    typedef nsString nsString__tdef;
    typedef Shmem Shmem__tdef;
    typedef IPCBlob IPCBlob__tdef;

    union Value {
        mozilla::AlignedStorage2<nsString> VnsString;
        mozilla::AlignedStorage2<Shmem> VShmem;
        mozilla::AlignedStorage2<IPCBlob> VIPCBlob;
    };

    nsString*
    ptr_nsString()
    {
        return ((mValue).VnsString).addr();
    }
    const nsString*
    constptr_nsString() const
    {
        return ((mValue).VnsString).addr();
    }
    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }
    IPCBlob*
    ptr_IPCBlob()
    {
        return ((mValue).VIPCBlob).addr();
    }
    const IPCBlob*
    constptr_IPCBlob() const
    {
        return ((mValue).VIPCBlob).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCDataTransferData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCDataTransferData(const nsString& aOther);

    MOZ_IMPLICIT IPCDataTransferData(Shmem& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCBlob& aOther);

    MOZ_IMPLICIT IPCDataTransferData(const IPCDataTransferData& aOther);

    ~IPCDataTransferData();

    Type
    type() const
    {
        return mType;
    }

    IPCDataTransferData&
    operator=(const nsString& aRhs);

    IPCDataTransferData&
    operator=(Shmem& aRhs);

    IPCDataTransferData&
    operator=(const IPCBlob& aRhs);

    IPCDataTransferData&
    operator=(const IPCDataTransferData& aRhs);

    bool
    operator==(const nsString& aRhs) const;

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const IPCBlob& aRhs) const;

    bool
    operator==(const IPCDataTransferData& aRhs) const;

    nsString&
    get_nsString()
    {
        AssertSanity(TnsString);
        return (*(ptr_nsString()));
    }
    const nsString&
    get_nsString() const
    {
        AssertSanity(TnsString);
        return (*(constptr_nsString()));
    }
    void
    get(nsString* aOutValue) const;
    operator nsString&()
    {
        return get_nsString();
    }
    operator const nsString&() const
    {
        return get_nsString();
    }

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    void
    get(Shmem* aOutValue) const;
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    IPCBlob&
    get_IPCBlob()
    {
        AssertSanity(TIPCBlob);
        return (*(ptr_IPCBlob()));
    }
    const IPCBlob&
    get_IPCBlob() const
    {
        AssertSanity(TIPCBlob);
        return (*(constptr_IPCBlob()));
    }
    void
    get(IPCBlob* aOutValue) const;
    operator IPCBlob&()
    {
        return get_IPCBlob();
    }
    operator const IPCBlob&() const
    {
        return get_IPCBlob();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferImage|
//
namespace mozilla {
namespace dom {
class IPCDataTransferImage final
{
private:

public:
    MOZ_IMPLICIT IPCDataTransferImage();

    MOZ_IMPLICIT IPCDataTransferImage(
            const uint32_t& _width,
            const uint32_t& _height,
            const uint32_t& _stride,
            const uint8_t& _format)
    {
        Init();
        Assign(_width, _height, _stride, _format);
    }

    MOZ_IMPLICIT IPCDataTransferImage(const IPCDataTransferImage& _o)
    {
        Init();
        Assign((_o).width(), (_o).height(), (_o).stride(), (_o).format());
    }

    ~IPCDataTransferImage();

    void
    operator=(const IPCDataTransferImage& _o)
    {
        Assign((_o).width(), (_o).height(), (_o).stride(), (_o).format());
    }

    bool
    operator==(const IPCDataTransferImage& _o) const;

    bool
    operator!=(const IPCDataTransferImage& _o) const;

    uint32_t&
    width()
    {
        return width_;
    }
    const uint32_t&
    width() const
    {
        return width_;
    }

    uint32_t&
    height()
    {
        return height_;
    }
    const uint32_t&
    height() const
    {
        return height_;
    }

    uint32_t&
    stride()
    {
        return stride_;
    }
    const uint32_t&
    stride() const
    {
        return stride_;
    }

    uint8_t&
    format()
    {
        return format_;
    }
    const uint8_t&
    format() const
    {
        return format_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _width,
            const uint32_t& _height,
            const uint32_t& _stride,
            const uint8_t& _format);

    uint32_t width_;
    uint32_t height_;
    uint32_t stride_;
    uint8_t format_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCDataTransferImage;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCDataTransferData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransferItem|
//
namespace mozilla {
namespace dom {
class IPCDataTransferItem final
{
private:
    typedef mozilla::dom::IPCDataTransferImage IPCDataTransferImage;
    typedef mozilla::dom::IPCDataTransferData IPCDataTransferData;

public:
    MOZ_IMPLICIT IPCDataTransferItem();

    MOZ_IMPLICIT IPCDataTransferItem(
            const nsCString& _flavor,
            const IPCDataTransferImage& _imageDetails,
            const IPCDataTransferData& _data)
    {
        Init();
        Assign(_flavor, _imageDetails, _data);
    }

    MOZ_IMPLICIT IPCDataTransferItem(const IPCDataTransferItem& _o)
    {
        Init();
        Assign((_o).flavor(), (_o).imageDetails(), (_o).data());
    }

    ~IPCDataTransferItem();

    void
    operator=(const IPCDataTransferItem& _o)
    {
        Assign((_o).flavor(), (_o).imageDetails(), (_o).data());
    }

    bool
    operator==(const IPCDataTransferItem& _o) const;

    bool
    operator!=(const IPCDataTransferItem& _o) const;

    nsCString&
    flavor()
    {
        return flavor_;
    }
    const nsCString&
    flavor() const
    {
        return flavor_;
    }

    IPCDataTransferImage&
    imageDetails()
    {
        return imageDetails_;
    }
    const IPCDataTransferImage&
    imageDetails() const
    {
        return imageDetails_;
    }

    IPCDataTransferData&
    data()
    {
        return data_;
    }
    const IPCDataTransferData&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _flavor,
            const IPCDataTransferImage& _imageDetails,
            const IPCDataTransferData& _data);

    nsCString flavor_;
    IPCDataTransferImage imageDetails_;
    IPCDataTransferData data_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCDataTransferItem;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCDataTransfer|
//
namespace mozilla {
namespace dom {
class IPCDataTransfer final
{
private:
    typedef mozilla::dom::IPCDataTransferItem IPCDataTransferItem;

public:
    MOZ_IMPLICIT IPCDataTransfer();

    MOZ_IMPLICIT IPCDataTransfer(const nsTArray<IPCDataTransferItem>& _items)
    {
        Init();
        Assign(_items);
    }

    MOZ_IMPLICIT IPCDataTransfer(const IPCDataTransfer& _o)
    {
        Init();
        Assign((_o).items());
    }

    ~IPCDataTransfer();

    void
    operator=(const IPCDataTransfer& _o)
    {
        Assign((_o).items());
    }

    bool
    operator==(const IPCDataTransfer& _o) const;

    bool
    operator!=(const IPCDataTransfer& _o) const;

    nsTArray<IPCDataTransferItem>&
    items()
    {
        return items_;
    }
    const nsTArray<IPCDataTransferItem>&
    items() const
    {
        return items_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<IPCDataTransferItem>& _items);

    nsTArray<IPCDataTransferItem> items_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
class ScreenDetails final
{
private:

public:
    MOZ_IMPLICIT ScreenDetails();

    MOZ_IMPLICIT ScreenDetails(
            const LayoutDeviceIntRect& _rect,
            const DesktopIntRect& _rectDisplayPix,
            const LayoutDeviceIntRect& _availRect,
            const DesktopIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const DesktopToLayoutDeviceScale& _contentsScaleFactor,
            const CSSToLayoutDeviceScale& _defaultCSSScaleFactor,
            const float& _dpi)
    {
        Init();
        Assign(_rect, _rectDisplayPix, _availRect, _availRectDisplayPix, _pixelDepth, _colorDepth, _contentsScaleFactor, _defaultCSSScaleFactor, _dpi);
    }

    MOZ_IMPLICIT ScreenDetails(const ScreenDetails& _o)
    {
        Init();
        Assign((_o).rect(), (_o).rectDisplayPix(), (_o).availRect(), (_o).availRectDisplayPix(), (_o).pixelDepth(), (_o).colorDepth(), (_o).contentsScaleFactor(), (_o).defaultCSSScaleFactor(), (_o).dpi());
    }

    ~ScreenDetails();

    void
    operator=(const ScreenDetails& _o)
    {
        Assign((_o).rect(), (_o).rectDisplayPix(), (_o).availRect(), (_o).availRectDisplayPix(), (_o).pixelDepth(), (_o).colorDepth(), (_o).contentsScaleFactor(), (_o).defaultCSSScaleFactor(), (_o).dpi());
    }

    bool
    operator==(const ScreenDetails& _o) const;

    bool
    operator!=(const ScreenDetails& _o) const;

    LayoutDeviceIntRect&
    rect()
    {
        return rect_;
    }
    const LayoutDeviceIntRect&
    rect() const
    {
        return rect_;
    }

    DesktopIntRect&
    rectDisplayPix()
    {
        return rectDisplayPix_;
    }
    const DesktopIntRect&
    rectDisplayPix() const
    {
        return rectDisplayPix_;
    }

    LayoutDeviceIntRect&
    availRect()
    {
        return availRect_;
    }
    const LayoutDeviceIntRect&
    availRect() const
    {
        return availRect_;
    }

    DesktopIntRect&
    availRectDisplayPix()
    {
        return availRectDisplayPix_;
    }
    const DesktopIntRect&
    availRectDisplayPix() const
    {
        return availRectDisplayPix_;
    }

    int32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const int32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

    int32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const int32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    DesktopToLayoutDeviceScale&
    contentsScaleFactor()
    {
        return contentsScaleFactor_;
    }
    const DesktopToLayoutDeviceScale&
    contentsScaleFactor() const
    {
        return contentsScaleFactor_;
    }

    CSSToLayoutDeviceScale&
    defaultCSSScaleFactor()
    {
        return defaultCSSScaleFactor_;
    }
    const CSSToLayoutDeviceScale&
    defaultCSSScaleFactor() const
    {
        return defaultCSSScaleFactor_;
    }

    float&
    dpi()
    {
        return dpi_;
    }
    const float&
    dpi() const
    {
        return dpi_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayoutDeviceIntRect& _rect,
            const DesktopIntRect& _rectDisplayPix,
            const LayoutDeviceIntRect& _availRect,
            const DesktopIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const DesktopToLayoutDeviceScale& _contentsScaleFactor,
            const CSSToLayoutDeviceScale& _defaultCSSScaleFactor,
            const float& _dpi);

    LayoutDeviceIntRect rect_;
    DesktopIntRect rectDisplayPix_;
    LayoutDeviceIntRect availRect_;
    DesktopIntRect availRectDisplayPix_;
    int32_t pixelDepth_;
    int32_t colorDepth_;
    DesktopToLayoutDeviceScale contentsScaleFactor_;
    CSSToLayoutDeviceScale defaultCSSScaleFactor_;
    float dpi_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DimensionInfo|
//
namespace mozilla {
namespace dom {
class DimensionInfo final
{
private:
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::LayoutDeviceIntPoint LayoutDeviceIntPoint;

public:
    MOZ_IMPLICIT DimensionInfo();

    MOZ_IMPLICIT DimensionInfo(
            const CSSRect& _rect,
            const CSSSize& _size,
            const ScreenOrientationInternal& _orientation,
            const LayoutDeviceIntPoint& _clientOffset,
            const LayoutDeviceIntPoint& _chromeDisp)
    {
        Init();
        Assign(_rect, _size, _orientation, _clientOffset, _chromeDisp);
    }

    MOZ_IMPLICIT DimensionInfo(const DimensionInfo& _o)
    {
        Init();
        Assign((_o).rect(), (_o).size(), (_o).orientation(), (_o).clientOffset(), (_o).chromeDisp());
    }

    ~DimensionInfo();

    void
    operator=(const DimensionInfo& _o)
    {
        Assign((_o).rect(), (_o).size(), (_o).orientation(), (_o).clientOffset(), (_o).chromeDisp());
    }

    bool
    operator==(const DimensionInfo& _o) const;

    bool
    operator!=(const DimensionInfo& _o) const;

    CSSRect&
    rect()
    {
        return rect_;
    }
    const CSSRect&
    rect() const
    {
        return rect_;
    }

    CSSSize&
    size()
    {
        return size_;
    }
    const CSSSize&
    size() const
    {
        return size_;
    }

    ScreenOrientationInternal&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientationInternal&
    orientation() const
    {
        return orientation_;
    }

    LayoutDeviceIntPoint&
    clientOffset()
    {
        return clientOffset_;
    }
    const LayoutDeviceIntPoint&
    clientOffset() const
    {
        return clientOffset_;
    }

    LayoutDeviceIntPoint&
    chromeDisp()
    {
        return chromeDisp_;
    }
    const LayoutDeviceIntPoint&
    chromeDisp() const
    {
        return chromeDisp_;
    }

private:
    void
    Init();

    void
    Assign(
            const CSSRect& _rect,
            const CSSSize& _size,
            const ScreenOrientationInternal& _orientation,
            const LayoutDeviceIntPoint& _clientOffset,
            const LayoutDeviceIntPoint& _chromeDisp);

    CSSRect rect_;
    CSSSize size_;
    ScreenOrientationInternal orientation_;
    LayoutDeviceIntPoint clientOffset_;
    LayoutDeviceIntPoint chromeDisp_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FrameScriptInfo|
//
namespace mozilla {
namespace dom {
class FrameScriptInfo final
{
private:

public:
    MOZ_IMPLICIT FrameScriptInfo();

    MOZ_IMPLICIT FrameScriptInfo(
            const nsString& _url,
            const bool& _runInGlobalScope)
    {
        Init();
        Assign(_url, _runInGlobalScope);
    }

    MOZ_IMPLICIT FrameScriptInfo(const FrameScriptInfo& _o)
    {
        Init();
        Assign((_o).url(), (_o).runInGlobalScope());
    }

    ~FrameScriptInfo();

    void
    operator=(const FrameScriptInfo& _o)
    {
        Assign((_o).url(), (_o).runInGlobalScope());
    }

    bool
    operator==(const FrameScriptInfo& _o) const;

    bool
    operator!=(const FrameScriptInfo& _o) const;

    nsString&
    url()
    {
        return url_;
    }
    const nsString&
    url() const
    {
        return url_;
    }

    bool&
    runInGlobalScope()
    {
        return runInGlobalScope_;
    }
    const bool&
    runInGlobalScope() const
    {
        return runInGlobalScope_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _url,
            const bool& _runInGlobalScope);

    nsString url_;
    bool runInGlobalScope_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FrameScriptInfo;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class DimensionInfo;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CreatedWindowInfo|
//
namespace mozilla {
namespace dom {
class CreatedWindowInfo final
{
private:
    typedef mozilla::dom::FrameScriptInfo FrameScriptInfo;
    typedef mozilla::layers::TextureFactoryIdentifier TextureFactoryIdentifier;
    typedef mozilla::layers::CompositorOptions CompositorOptions;
    typedef mozilla::dom::DimensionInfo DimensionInfo;

public:
    MOZ_IMPLICIT CreatedWindowInfo();

    MOZ_IMPLICIT CreatedWindowInfo(
            const nsresult& _rv,
            const bool& _windowOpened,
            const nsTArray<FrameScriptInfo>& _frameScripts,
            const nsCString& _urlToLoad,
            const TextureFactoryIdentifier& _textureFactoryIdentifier,
            const uint64_t& _layersId,
            const CompositorOptions& _compositorOptions,
            const uint32_t& _maxTouchPoints,
            const DimensionInfo& _dimensions)
    {
        Init();
        Assign(_rv, _windowOpened, _frameScripts, _urlToLoad, _textureFactoryIdentifier, _layersId, _compositorOptions, _maxTouchPoints, _dimensions);
    }

    MOZ_IMPLICIT CreatedWindowInfo(const CreatedWindowInfo& _o)
    {
        Init();
        Assign((_o).rv(), (_o).windowOpened(), (_o).frameScripts(), (_o).urlToLoad(), (_o).textureFactoryIdentifier(), (_o).layersId(), (_o).compositorOptions(), (_o).maxTouchPoints(), (_o).dimensions());
    }

    ~CreatedWindowInfo();

    void
    operator=(const CreatedWindowInfo& _o)
    {
        Assign((_o).rv(), (_o).windowOpened(), (_o).frameScripts(), (_o).urlToLoad(), (_o).textureFactoryIdentifier(), (_o).layersId(), (_o).compositorOptions(), (_o).maxTouchPoints(), (_o).dimensions());
    }

    bool
    operator==(const CreatedWindowInfo& _o) const;

    bool
    operator!=(const CreatedWindowInfo& _o) const;

    nsresult&
    rv()
    {
        return rv_;
    }
    const nsresult&
    rv() const
    {
        return rv_;
    }

    bool&
    windowOpened()
    {
        return windowOpened_;
    }
    const bool&
    windowOpened() const
    {
        return windowOpened_;
    }

    nsTArray<FrameScriptInfo>&
    frameScripts()
    {
        return frameScripts_;
    }
    const nsTArray<FrameScriptInfo>&
    frameScripts() const
    {
        return frameScripts_;
    }

    nsCString&
    urlToLoad()
    {
        return urlToLoad_;
    }
    const nsCString&
    urlToLoad() const
    {
        return urlToLoad_;
    }

    TextureFactoryIdentifier&
    textureFactoryIdentifier()
    {
        return textureFactoryIdentifier_;
    }
    const TextureFactoryIdentifier&
    textureFactoryIdentifier() const
    {
        return textureFactoryIdentifier_;
    }

    uint64_t&
    layersId()
    {
        return layersId_;
    }
    const uint64_t&
    layersId() const
    {
        return layersId_;
    }

    CompositorOptions&
    compositorOptions()
    {
        return compositorOptions_;
    }
    const CompositorOptions&
    compositorOptions() const
    {
        return compositorOptions_;
    }

    uint32_t&
    maxTouchPoints()
    {
        return maxTouchPoints_;
    }
    const uint32_t&
    maxTouchPoints() const
    {
        return maxTouchPoints_;
    }

    DimensionInfo&
    dimensions()
    {
        return dimensions_;
    }
    const DimensionInfo&
    dimensions() const
    {
        return dimensions_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsresult& _rv,
            const bool& _windowOpened,
            const nsTArray<FrameScriptInfo>& _frameScripts,
            const nsCString& _urlToLoad,
            const TextureFactoryIdentifier& _textureFactoryIdentifier,
            const uint64_t& _layersId,
            const CompositorOptions& _compositorOptions,
            const uint32_t& _maxTouchPoints,
            const DimensionInfo& _dimensions);

    nsresult rv_;
    bool windowOpened_;
    nsTArray<FrameScriptInfo> frameScripts_;
    nsCString urlToLoad_;
    TextureFactoryIdentifier textureFactoryIdentifier_;
    uint64_t layersId_;
    CompositorOptions compositorOptions_;
    uint32_t maxTouchPoints_;
    DimensionInfo dimensions_;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef DOMTypes_h
