//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef FetchTypes_h
#define FetchTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/dom/FetchIPCTypes.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ChannelInfo.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HeadersEntry|
//
namespace mozilla {
namespace dom {
class HeadersEntry final
{
private:

public:
    MOZ_IMPLICIT HeadersEntry();

    MOZ_IMPLICIT HeadersEntry(
            const nsCString& _name,
            const nsCString& _value)
    {
        Init();
        Assign(_name, _value);
    }

    MOZ_IMPLICIT HeadersEntry(const HeadersEntry& _o)
    {
        Init();
        Assign((_o).name(), (_o).value());
    }

    ~HeadersEntry();

    void
    operator=(const HeadersEntry& _o)
    {
        Assign((_o).name(), (_o).value());
    }

    bool
    operator==(const HeadersEntry& _o) const;

    bool
    operator!=(const HeadersEntry& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _name,
            const nsCString& _value);

    nsCString name_;
    nsCString value_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class HeadersEntry;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalRequest|
//
namespace mozilla {
namespace dom {
class IPCInternalRequest final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;

public:
    MOZ_IMPLICIT IPCInternalRequest();

    MOZ_IMPLICIT IPCInternalRequest(
            const nsTArray<nsCString>& _urls,
            const nsCString& _method,
            const nsTArray<HeadersEntry>& _headers,
            const HeadersGuardEnum& _headersGuard,
            const nsString& _referrer,
            const ReferrerPolicy& _referrerPolicy,
            const RequestMode& _mode,
            const RequestCredentials& _credentials,
            const uint32_t& _contentPolicyType,
            const RequestCache& _requestCache,
            const RequestRedirect& _requestRedirect)
    {
        Init();
        Assign(_urls, _method, _headers, _headersGuard, _referrer, _referrerPolicy, _mode, _credentials, _contentPolicyType, _requestCache, _requestRedirect);
    }

    MOZ_IMPLICIT IPCInternalRequest(const IPCInternalRequest& _o)
    {
        Init();
        Assign((_o).urls(), (_o).method(), (_o).headers(), (_o).headersGuard(), (_o).referrer(), (_o).referrerPolicy(), (_o).mode(), (_o).credentials(), (_o).contentPolicyType(), (_o).requestCache(), (_o).requestRedirect());
    }

    ~IPCInternalRequest();

    void
    operator=(const IPCInternalRequest& _o)
    {
        Assign((_o).urls(), (_o).method(), (_o).headers(), (_o).headersGuard(), (_o).referrer(), (_o).referrerPolicy(), (_o).mode(), (_o).credentials(), (_o).contentPolicyType(), (_o).requestCache(), (_o).requestRedirect());
    }

    bool
    operator==(const IPCInternalRequest& _o) const;

    bool
    operator!=(const IPCInternalRequest& _o) const;

    nsTArray<nsCString>&
    urls()
    {
        return urls_;
    }
    const nsTArray<nsCString>&
    urls() const
    {
        return urls_;
    }

    nsCString&
    method()
    {
        return method_;
    }
    const nsCString&
    method() const
    {
        return method_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    nsString&
    referrer()
    {
        return referrer_;
    }
    const nsString&
    referrer() const
    {
        return referrer_;
    }

    ReferrerPolicy&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const ReferrerPolicy&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    RequestMode&
    mode()
    {
        return mode_;
    }
    const RequestMode&
    mode() const
    {
        return mode_;
    }

    RequestCredentials&
    credentials()
    {
        return credentials_;
    }
    const RequestCredentials&
    credentials() const
    {
        return credentials_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    RequestCache&
    requestCache()
    {
        return requestCache_;
    }
    const RequestCache&
    requestCache() const
    {
        return requestCache_;
    }

    RequestRedirect&
    requestRedirect()
    {
        return requestRedirect_;
    }
    const RequestRedirect&
    requestRedirect() const
    {
        return requestRedirect_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<nsCString>& _urls,
            const nsCString& _method,
            const nsTArray<HeadersEntry>& _headers,
            const HeadersGuardEnum& _headersGuard,
            const nsString& _referrer,
            const ReferrerPolicy& _referrerPolicy,
            const RequestMode& _mode,
            const RequestCredentials& _credentials,
            const uint32_t& _contentPolicyType,
            const RequestCache& _requestCache,
            const RequestRedirect& _requestRedirect);

    nsTArray<nsCString> urls_;
    nsCString method_;
    nsTArray<HeadersEntry> headers_;
    HeadersGuardEnum headersGuard_;
    nsString referrer_;
    ReferrerPolicy referrerPolicy_;
    RequestMode mode_;
    RequestCredentials credentials_;
    uint32_t contentPolicyType_;
    RequestCache requestCache_;
    RequestRedirect requestRedirect_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class HeadersEntry;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
class IPCChannelInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalPrincipalInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalIPCStream;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalResponse|
//
namespace mozilla {
namespace dom {
class IPCInternalResponse final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;
    typedef mozilla::ipc::IPCChannelInfo IPCChannelInfo;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;

public:
    MOZ_IMPLICIT IPCInternalResponse();

    MOZ_IMPLICIT IPCInternalResponse(
            const ResponseType& _type,
            const nsTArray<nsCString>& _urlList,
            const uint32_t& _status,
            const nsCString& _statusText,
            const nsTArray<HeadersEntry>& _headers,
            const HeadersGuardEnum& _headersGuard,
            const IPCChannelInfo& _channelInfo,
            const OptionalPrincipalInfo& _principalInfo,
            const OptionalIPCStream& _body,
            const int64_t& _bodySize,
            const nsresult& _errorCode)
    {
        Init();
        Assign(_type, _urlList, _status, _statusText, _headers, _headersGuard, _channelInfo, _principalInfo, _body, _bodySize, _errorCode);
    }

    MOZ_IMPLICIT IPCInternalResponse(const IPCInternalResponse& _o)
    {
        Init();
        Assign((_o).type(), (_o).urlList(), (_o).status(), (_o).statusText(), (_o).headers(), (_o).headersGuard(), (_o).channelInfo(), (_o).principalInfo(), (_o).body(), (_o).bodySize(), (_o).errorCode());
    }

    ~IPCInternalResponse();

    void
    operator=(const IPCInternalResponse& _o)
    {
        Assign((_o).type(), (_o).urlList(), (_o).status(), (_o).statusText(), (_o).headers(), (_o).headersGuard(), (_o).channelInfo(), (_o).principalInfo(), (_o).body(), (_o).bodySize(), (_o).errorCode());
    }

    bool
    operator==(const IPCInternalResponse& _o) const;

    bool
    operator!=(const IPCInternalResponse& _o) const;

    ResponseType&
    type()
    {
        return type_;
    }
    const ResponseType&
    type() const
    {
        return type_;
    }

    nsTArray<nsCString>&
    urlList()
    {
        return urlList_;
    }
    const nsTArray<nsCString>&
    urlList() const
    {
        return urlList_;
    }

    uint32_t&
    status()
    {
        return status_;
    }
    const uint32_t&
    status() const
    {
        return status_;
    }

    nsCString&
    statusText()
    {
        return statusText_;
    }
    const nsCString&
    statusText() const
    {
        return statusText_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    IPCChannelInfo&
    channelInfo()
    {
        return channelInfo_;
    }
    const IPCChannelInfo&
    channelInfo() const
    {
        return channelInfo_;
    }

    OptionalPrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const OptionalPrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    OptionalIPCStream&
    body()
    {
        return body_;
    }
    const OptionalIPCStream&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    nsresult&
    errorCode()
    {
        return errorCode_;
    }
    const nsresult&
    errorCode() const
    {
        return errorCode_;
    }

private:
    void
    Init();

    void
    Assign(
            const ResponseType& _type,
            const nsTArray<nsCString>& _urlList,
            const uint32_t& _status,
            const nsCString& _statusText,
            const nsTArray<HeadersEntry>& _headers,
            const HeadersGuardEnum& _headersGuard,
            const IPCChannelInfo& _channelInfo,
            const OptionalPrincipalInfo& _principalInfo,
            const OptionalIPCStream& _body,
            const int64_t& _bodySize,
            const nsresult& _errorCode);

    ResponseType type_;
    nsTArray<nsCString> urlList_;
    uint32_t status_;
    nsCString statusText_;
    nsTArray<HeadersEntry> headers_;
    HeadersGuardEnum headersGuard_;
    IPCChannelInfo channelInfo_;
    OptionalPrincipalInfo principalInfo_;
    OptionalIPCStream body_;
    int64_t bodySize_;
    nsresult errorCode_;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef FetchTypes_h
