//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef GamepadEventTypes_h
#define GamepadEventTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/dom/GamepadMessageUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadAdded|
//
namespace mozilla {
namespace dom {
class GamepadAdded final
{
private:
    typedef mozilla::dom::GamepadMappingType GamepadMappingType;
    typedef mozilla::dom::GamepadHand GamepadHand;

public:
    MOZ_IMPLICIT GamepadAdded();

    MOZ_IMPLICIT GamepadAdded(
            const nsString& _id,
            const GamepadMappingType& _mapping,
            const GamepadHand& _hand,
            const uint32_t& _display_id,
            const uint32_t& _num_buttons,
            const uint32_t& _num_axes,
            const uint32_t& _num_haptics)
    {
        Init();
        Assign(_id, _mapping, _hand, _display_id, _num_buttons, _num_axes, _num_haptics);
    }

    MOZ_IMPLICIT GamepadAdded(const GamepadAdded& _o)
    {
        Init();
        Assign((_o).id(), (_o).mapping(), (_o).hand(), (_o).display_id(), (_o).num_buttons(), (_o).num_axes(), (_o).num_haptics());
    }

    ~GamepadAdded();

    void
    operator=(const GamepadAdded& _o)
    {
        Assign((_o).id(), (_o).mapping(), (_o).hand(), (_o).display_id(), (_o).num_buttons(), (_o).num_axes(), (_o).num_haptics());
    }

    bool
    operator==(const GamepadAdded& _o) const;

    bool
    operator!=(const GamepadAdded& _o) const;

    nsString&
    id()
    {
        return id_;
    }
    const nsString&
    id() const
    {
        return id_;
    }

    GamepadMappingType&
    mapping()
    {
        return mapping_;
    }
    const GamepadMappingType&
    mapping() const
    {
        return mapping_;
    }

    GamepadHand&
    hand()
    {
        return hand_;
    }
    const GamepadHand&
    hand() const
    {
        return hand_;
    }

    uint32_t&
    display_id()
    {
        return display_id_;
    }
    const uint32_t&
    display_id() const
    {
        return display_id_;
    }

    uint32_t&
    num_buttons()
    {
        return num_buttons_;
    }
    const uint32_t&
    num_buttons() const
    {
        return num_buttons_;
    }

    uint32_t&
    num_axes()
    {
        return num_axes_;
    }
    const uint32_t&
    num_axes() const
    {
        return num_axes_;
    }

    uint32_t&
    num_haptics()
    {
        return num_haptics_;
    }
    const uint32_t&
    num_haptics() const
    {
        return num_haptics_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _id,
            const GamepadMappingType& _mapping,
            const GamepadHand& _hand,
            const uint32_t& _display_id,
            const uint32_t& _num_buttons,
            const uint32_t& _num_axes,
            const uint32_t& _num_haptics);

    nsString id_;
    GamepadMappingType mapping_;
    GamepadHand hand_;
    uint32_t display_id_;
    uint32_t num_buttons_;
    uint32_t num_axes_;
    uint32_t num_haptics_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadRemoved|
//
namespace mozilla {
namespace dom {
class GamepadRemoved final
{
private:

public:
    MOZ_IMPLICIT GamepadRemoved()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT GamepadRemoved(const GamepadRemoved& _o)
    {
        Init();
        Assign();
    }

    ~GamepadRemoved();

    void
    operator=(const GamepadRemoved& _o)
    {
        Assign();
    }

    bool
    operator==(const GamepadRemoved& _o) const;

    bool
    operator!=(const GamepadRemoved& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadAxisInformation|
//
namespace mozilla {
namespace dom {
class GamepadAxisInformation final
{
private:

public:
    MOZ_IMPLICIT GamepadAxisInformation();

    MOZ_IMPLICIT GamepadAxisInformation(
            const uint32_t& _axis,
            const double& _value)
    {
        Init();
        Assign(_axis, _value);
    }

    MOZ_IMPLICIT GamepadAxisInformation(const GamepadAxisInformation& _o)
    {
        Init();
        Assign((_o).axis(), (_o).value());
    }

    ~GamepadAxisInformation();

    void
    operator=(const GamepadAxisInformation& _o)
    {
        Assign((_o).axis(), (_o).value());
    }

    bool
    operator==(const GamepadAxisInformation& _o) const;

    bool
    operator!=(const GamepadAxisInformation& _o) const;

    uint32_t&
    axis()
    {
        return axis_;
    }
    const uint32_t&
    axis() const
    {
        return axis_;
    }

    double&
    value()
    {
        return value_;
    }
    const double&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _axis,
            const double& _value);

    uint32_t axis_;
    double value_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadButtonInformation|
//
namespace mozilla {
namespace dom {
class GamepadButtonInformation final
{
private:

public:
    MOZ_IMPLICIT GamepadButtonInformation();

    MOZ_IMPLICIT GamepadButtonInformation(
            const uint32_t& _button,
            const double& _value,
            const bool& _pressed,
            const bool& _touched)
    {
        Init();
        Assign(_button, _value, _pressed, _touched);
    }

    MOZ_IMPLICIT GamepadButtonInformation(const GamepadButtonInformation& _o)
    {
        Init();
        Assign((_o).button(), (_o).value(), (_o).pressed(), (_o).touched());
    }

    ~GamepadButtonInformation();

    void
    operator=(const GamepadButtonInformation& _o)
    {
        Assign((_o).button(), (_o).value(), (_o).pressed(), (_o).touched());
    }

    bool
    operator==(const GamepadButtonInformation& _o) const;

    bool
    operator!=(const GamepadButtonInformation& _o) const;

    uint32_t&
    button()
    {
        return button_;
    }
    const uint32_t&
    button() const
    {
        return button_;
    }

    double&
    value()
    {
        return value_;
    }
    const double&
    value() const
    {
        return value_;
    }

    bool&
    pressed()
    {
        return pressed_;
    }
    const bool&
    pressed() const
    {
        return pressed_;
    }

    bool&
    touched()
    {
        return touched_;
    }
    const bool&
    touched() const
    {
        return touched_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _button,
            const double& _value,
            const bool& _pressed,
            const bool& _touched);

    uint32_t button_;
    double value_;
    bool pressed_;
    bool touched_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadPoseInformation|
//
namespace mozilla {
namespace dom {
class GamepadPoseInformation final
{
private:
    typedef mozilla::dom::GamepadPoseState GamepadPoseState;

public:
    MOZ_IMPLICIT GamepadPoseInformation();

    MOZ_IMPLICIT GamepadPoseInformation(const GamepadPoseState& _pose_state)
    {
        Init();
        Assign(_pose_state);
    }

    MOZ_IMPLICIT GamepadPoseInformation(const GamepadPoseInformation& _o)
    {
        Init();
        Assign((_o).pose_state());
    }

    ~GamepadPoseInformation();

    void
    operator=(const GamepadPoseInformation& _o)
    {
        Assign((_o).pose_state());
    }

    bool
    operator==(const GamepadPoseInformation& _o) const;

    bool
    operator!=(const GamepadPoseInformation& _o) const;

    GamepadPoseState&
    pose_state()
    {
        return pose_state_;
    }
    const GamepadPoseState&
    pose_state() const
    {
        return pose_state_;
    }

private:
    void
    Init();

    void
    Assign(const GamepadPoseState& _pose_state);

    GamepadPoseState pose_state_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadHandInformation|
//
namespace mozilla {
namespace dom {
class GamepadHandInformation final
{
private:
    typedef mozilla::dom::GamepadHand GamepadHand;

public:
    MOZ_IMPLICIT GamepadHandInformation();

    MOZ_IMPLICIT GamepadHandInformation(const GamepadHand& _hand)
    {
        Init();
        Assign(_hand);
    }

    MOZ_IMPLICIT GamepadHandInformation(const GamepadHandInformation& _o)
    {
        Init();
        Assign((_o).hand());
    }

    ~GamepadHandInformation();

    void
    operator=(const GamepadHandInformation& _o)
    {
        Assign((_o).hand());
    }

    bool
    operator==(const GamepadHandInformation& _o) const;

    bool
    operator!=(const GamepadHandInformation& _o) const;

    GamepadHand&
    hand()
    {
        return hand_;
    }
    const GamepadHand&
    hand() const
    {
        return hand_;
    }

private:
    void
    Init();

    void
    Assign(const GamepadHand& _hand);

    GamepadHand hand_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class GamepadAdded;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class GamepadRemoved;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class GamepadAxisInformation;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class GamepadButtonInformation;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class GamepadPoseInformation;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class GamepadHandInformation;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union GamepadChangeEventBody|
//
namespace mozilla {
namespace dom {
class GamepadChangeEventBody final
{
public:
    enum Type {
        T__None,
        TGamepadAdded = 1,
        TGamepadRemoved,
        TGamepadAxisInformation,
        TGamepadButtonInformation,
        TGamepadPoseInformation,
        TGamepadHandInformation,
        T__Last = TGamepadHandInformation
    };

private:
    typedef mozilla::dom::GamepadAdded GamepadAdded;
    typedef mozilla::dom::GamepadRemoved GamepadRemoved;
    typedef mozilla::dom::GamepadAxisInformation GamepadAxisInformation;
    typedef mozilla::dom::GamepadButtonInformation GamepadButtonInformation;
    typedef mozilla::dom::GamepadPoseInformation GamepadPoseInformation;
    typedef mozilla::dom::GamepadHandInformation GamepadHandInformation;
    typedef GamepadAdded GamepadAdded__tdef;
    typedef GamepadRemoved GamepadRemoved__tdef;
    typedef GamepadAxisInformation GamepadAxisInformation__tdef;
    typedef GamepadButtonInformation GamepadButtonInformation__tdef;
    typedef GamepadPoseInformation GamepadPoseInformation__tdef;
    typedef GamepadHandInformation GamepadHandInformation__tdef;

    union Value {
        mozilla::AlignedStorage2<GamepadAdded> VGamepadAdded;
        mozilla::AlignedStorage2<GamepadRemoved> VGamepadRemoved;
        mozilla::AlignedStorage2<GamepadAxisInformation> VGamepadAxisInformation;
        mozilla::AlignedStorage2<GamepadButtonInformation> VGamepadButtonInformation;
        mozilla::AlignedStorage2<GamepadPoseInformation> VGamepadPoseInformation;
        mozilla::AlignedStorage2<GamepadHandInformation> VGamepadHandInformation;
    };

    GamepadAdded*
    ptr_GamepadAdded()
    {
        return ((mValue).VGamepadAdded).addr();
    }
    const GamepadAdded*
    constptr_GamepadAdded() const
    {
        return ((mValue).VGamepadAdded).addr();
    }
    GamepadRemoved*
    ptr_GamepadRemoved()
    {
        return ((mValue).VGamepadRemoved).addr();
    }
    const GamepadRemoved*
    constptr_GamepadRemoved() const
    {
        return ((mValue).VGamepadRemoved).addr();
    }
    GamepadAxisInformation*
    ptr_GamepadAxisInformation()
    {
        return ((mValue).VGamepadAxisInformation).addr();
    }
    const GamepadAxisInformation*
    constptr_GamepadAxisInformation() const
    {
        return ((mValue).VGamepadAxisInformation).addr();
    }
    GamepadButtonInformation*
    ptr_GamepadButtonInformation()
    {
        return ((mValue).VGamepadButtonInformation).addr();
    }
    const GamepadButtonInformation*
    constptr_GamepadButtonInformation() const
    {
        return ((mValue).VGamepadButtonInformation).addr();
    }
    GamepadPoseInformation*
    ptr_GamepadPoseInformation()
    {
        return ((mValue).VGamepadPoseInformation).addr();
    }
    const GamepadPoseInformation*
    constptr_GamepadPoseInformation() const
    {
        return ((mValue).VGamepadPoseInformation).addr();
    }
    GamepadHandInformation*
    ptr_GamepadHandInformation()
    {
        return ((mValue).VGamepadHandInformation).addr();
    }
    const GamepadHandInformation*
    constptr_GamepadHandInformation() const
    {
        return ((mValue).VGamepadHandInformation).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT GamepadChangeEventBody() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadAdded& aOther);

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadRemoved& aOther);

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadAxisInformation& aOther);

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadButtonInformation& aOther);

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadPoseInformation& aOther);

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadHandInformation& aOther);

    MOZ_IMPLICIT GamepadChangeEventBody(const GamepadChangeEventBody& aOther);

    ~GamepadChangeEventBody();

    Type
    type() const
    {
        return mType;
    }

    GamepadChangeEventBody&
    operator=(const GamepadAdded& aRhs);

    GamepadChangeEventBody&
    operator=(const GamepadRemoved& aRhs);

    GamepadChangeEventBody&
    operator=(const GamepadAxisInformation& aRhs);

    GamepadChangeEventBody&
    operator=(const GamepadButtonInformation& aRhs);

    GamepadChangeEventBody&
    operator=(const GamepadPoseInformation& aRhs);

    GamepadChangeEventBody&
    operator=(const GamepadHandInformation& aRhs);

    GamepadChangeEventBody&
    operator=(const GamepadChangeEventBody& aRhs);

    bool
    operator==(const GamepadAdded& aRhs) const;

    bool
    operator==(const GamepadRemoved& aRhs) const;

    bool
    operator==(const GamepadAxisInformation& aRhs) const;

    bool
    operator==(const GamepadButtonInformation& aRhs) const;

    bool
    operator==(const GamepadPoseInformation& aRhs) const;

    bool
    operator==(const GamepadHandInformation& aRhs) const;

    bool
    operator==(const GamepadChangeEventBody& aRhs) const;

    GamepadAdded&
    get_GamepadAdded()
    {
        AssertSanity(TGamepadAdded);
        return (*(ptr_GamepadAdded()));
    }
    const GamepadAdded&
    get_GamepadAdded() const
    {
        AssertSanity(TGamepadAdded);
        return (*(constptr_GamepadAdded()));
    }
    void
    get(GamepadAdded* aOutValue) const;
    operator GamepadAdded&()
    {
        return get_GamepadAdded();
    }
    operator const GamepadAdded&() const
    {
        return get_GamepadAdded();
    }

    GamepadRemoved&
    get_GamepadRemoved()
    {
        AssertSanity(TGamepadRemoved);
        return (*(ptr_GamepadRemoved()));
    }
    const GamepadRemoved&
    get_GamepadRemoved() const
    {
        AssertSanity(TGamepadRemoved);
        return (*(constptr_GamepadRemoved()));
    }
    void
    get(GamepadRemoved* aOutValue) const;
    operator GamepadRemoved&()
    {
        return get_GamepadRemoved();
    }
    operator const GamepadRemoved&() const
    {
        return get_GamepadRemoved();
    }

    GamepadAxisInformation&
    get_GamepadAxisInformation()
    {
        AssertSanity(TGamepadAxisInformation);
        return (*(ptr_GamepadAxisInformation()));
    }
    const GamepadAxisInformation&
    get_GamepadAxisInformation() const
    {
        AssertSanity(TGamepadAxisInformation);
        return (*(constptr_GamepadAxisInformation()));
    }
    void
    get(GamepadAxisInformation* aOutValue) const;
    operator GamepadAxisInformation&()
    {
        return get_GamepadAxisInformation();
    }
    operator const GamepadAxisInformation&() const
    {
        return get_GamepadAxisInformation();
    }

    GamepadButtonInformation&
    get_GamepadButtonInformation()
    {
        AssertSanity(TGamepadButtonInformation);
        return (*(ptr_GamepadButtonInformation()));
    }
    const GamepadButtonInformation&
    get_GamepadButtonInformation() const
    {
        AssertSanity(TGamepadButtonInformation);
        return (*(constptr_GamepadButtonInformation()));
    }
    void
    get(GamepadButtonInformation* aOutValue) const;
    operator GamepadButtonInformation&()
    {
        return get_GamepadButtonInformation();
    }
    operator const GamepadButtonInformation&() const
    {
        return get_GamepadButtonInformation();
    }

    GamepadPoseInformation&
    get_GamepadPoseInformation()
    {
        AssertSanity(TGamepadPoseInformation);
        return (*(ptr_GamepadPoseInformation()));
    }
    const GamepadPoseInformation&
    get_GamepadPoseInformation() const
    {
        AssertSanity(TGamepadPoseInformation);
        return (*(constptr_GamepadPoseInformation()));
    }
    void
    get(GamepadPoseInformation* aOutValue) const;
    operator GamepadPoseInformation&()
    {
        return get_GamepadPoseInformation();
    }
    operator const GamepadPoseInformation&() const
    {
        return get_GamepadPoseInformation();
    }

    GamepadHandInformation&
    get_GamepadHandInformation()
    {
        AssertSanity(TGamepadHandInformation);
        return (*(ptr_GamepadHandInformation()));
    }
    const GamepadHandInformation&
    get_GamepadHandInformation() const
    {
        AssertSanity(TGamepadHandInformation);
        return (*(constptr_GamepadHandInformation()));
    }
    void
    get(GamepadHandInformation* aOutValue) const;
    operator GamepadHandInformation&()
    {
        return get_GamepadHandInformation();
    }
    operator const GamepadHandInformation&() const
    {
        return get_GamepadHandInformation();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class GamepadChangeEventBody;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GamepadChangeEvent|
//
namespace mozilla {
namespace dom {
class GamepadChangeEvent final
{
private:
    typedef mozilla::dom::GamepadServiceType GamepadServiceType;
    typedef mozilla::dom::GamepadChangeEventBody GamepadChangeEventBody;

public:
    MOZ_IMPLICIT GamepadChangeEvent();

    MOZ_IMPLICIT GamepadChangeEvent(
            const uint32_t& _index,
            const GamepadServiceType& _service_type,
            const GamepadChangeEventBody& _body)
    {
        Init();
        Assign(_index, _service_type, _body);
    }

    MOZ_IMPLICIT GamepadChangeEvent(const GamepadChangeEvent& _o)
    {
        Init();
        Assign((_o).index(), (_o).service_type(), (_o).body());
    }

    ~GamepadChangeEvent();

    void
    operator=(const GamepadChangeEvent& _o)
    {
        Assign((_o).index(), (_o).service_type(), (_o).body());
    }

    bool
    operator==(const GamepadChangeEvent& _o) const;

    bool
    operator!=(const GamepadChangeEvent& _o) const;

    uint32_t&
    index()
    {
        return index_;
    }
    const uint32_t&
    index() const
    {
        return index_;
    }

    GamepadServiceType&
    service_type()
    {
        return service_type_;
    }
    const GamepadServiceType&
    service_type() const
    {
        return service_type_;
    }

    GamepadChangeEventBody&
    body()
    {
        return body_;
    }
    const GamepadChangeEventBody&
    body() const
    {
        return body_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _index,
            const GamepadServiceType& _service_type,
            const GamepadChangeEventBody& _body);

    uint32_t index_;
    GamepadServiceType service_type_;
    GamepadChangeEventBody body_;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef GamepadEventTypes_h
