//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef IPCBlob_h
#define IPCBlob_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCFile|
//
namespace mozilla {
namespace dom {
class IPCFile final
{
private:

public:
    MOZ_IMPLICIT IPCFile();

    MOZ_IMPLICIT IPCFile(
            const nsString& _name,
            const int64_t& _lastModified,
            const nsString& _DOMPath,
            const nsString& _fullPath,
            const bool& _isDirectory)
    {
        Init();
        Assign(_name, _lastModified, _DOMPath, _fullPath, _isDirectory);
    }

    MOZ_IMPLICIT IPCFile(const IPCFile& _o)
    {
        Init();
        Assign((_o).name(), (_o).lastModified(), (_o).DOMPath(), (_o).fullPath(), (_o).isDirectory());
    }

    ~IPCFile();

    void
    operator=(const IPCFile& _o)
    {
        Assign((_o).name(), (_o).lastModified(), (_o).DOMPath(), (_o).fullPath(), (_o).isDirectory());
    }

    bool
    operator==(const IPCFile& _o) const;

    bool
    operator!=(const IPCFile& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    int64_t&
    lastModified()
    {
        return lastModified_;
    }
    const int64_t&
    lastModified() const
    {
        return lastModified_;
    }

    nsString&
    DOMPath()
    {
        return DOMPath_;
    }
    const nsString&
    DOMPath() const
    {
        return DOMPath_;
    }

    nsString&
    fullPath()
    {
        return fullPath_;
    }
    const nsString&
    fullPath() const
    {
        return fullPath_;
    }

    bool&
    isDirectory()
    {
        return isDirectory_;
    }
    const bool&
    isDirectory() const
    {
        return isDirectory_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const int64_t& _lastModified,
            const nsString& _DOMPath,
            const nsString& _fullPath,
            const bool& _isDirectory);

    nsString name_;
    int64_t lastModified_;
    nsString DOMPath_;
    nsString fullPath_;
    bool isDirectory_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCFile;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCFileUnion|
//
namespace mozilla {
namespace dom {
class IPCFileUnion final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TIPCFile,
        T__Last = TIPCFile
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::IPCFile IPCFile;
    typedef void_t void_t__tdef;
    typedef IPCFile IPCFile__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<IPCFile> VIPCFile;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    IPCFile*
    ptr_IPCFile()
    {
        return ((mValue).VIPCFile).addr();
    }
    const IPCFile*
    constptr_IPCFile() const
    {
        return ((mValue).VIPCFile).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCFileUnion() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCFileUnion(const void_t& aOther);

    MOZ_IMPLICIT IPCFileUnion(const IPCFile& aOther);

    MOZ_IMPLICIT IPCFileUnion(const IPCFileUnion& aOther);

    ~IPCFileUnion();

    Type
    type() const
    {
        return mType;
    }

    IPCFileUnion&
    operator=(const void_t& aRhs);

    IPCFileUnion&
    operator=(const IPCFile& aRhs);

    IPCFileUnion&
    operator=(const IPCFileUnion& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const IPCFile& aRhs) const;

    bool
    operator==(const IPCFileUnion& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    IPCFile&
    get_IPCFile()
    {
        AssertSanity(TIPCFile);
        return (*(ptr_IPCFile()));
    }
    const IPCFile&
    get_IPCFile() const
    {
        AssertSanity(TIPCFile);
        return (*(constptr_IPCFile()));
    }
    void
    get(IPCFile* aOutValue) const;
    operator IPCFile&()
    {
        return get_IPCFile();
    }
    operator const IPCFile&() const
    {
        return get_IPCFile();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PIPCBlobInputStreamParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PIPCBlobInputStreamChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class IPCStream;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCBlobStream|
//
namespace mozilla {
namespace dom {
class IPCBlobStream final
{
public:
    enum Type {
        T__None,
        TPIPCBlobInputStreamParent = 1,
        TPIPCBlobInputStreamChild,
        TIPCStream,
        T__Last = TIPCStream
    };

private:
    typedef mozilla::ipc::PIPCBlobInputStreamParent PIPCBlobInputStreamParent;
    typedef mozilla::ipc::PIPCBlobInputStreamChild PIPCBlobInputStreamChild;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef PIPCBlobInputStreamParent* PIPCBlobInputStreamParent__tdef;
    typedef PIPCBlobInputStreamChild* PIPCBlobInputStreamChild__tdef;
    typedef IPCStream IPCStream__tdef;

    union Value {
        mozilla::AlignedStorage2<PIPCBlobInputStreamParent*> VPIPCBlobInputStreamParent;
        mozilla::AlignedStorage2<PIPCBlobInputStreamChild*> VPIPCBlobInputStreamChild;
        mozilla::AlignedStorage2<IPCStream> VIPCStream;
    };

    PIPCBlobInputStreamParent**
    ptr_PIPCBlobInputStreamParent()
    {
        return ((mValue).VPIPCBlobInputStreamParent).addr();
    }
    PIPCBlobInputStreamParent* const*
    constptr_PIPCBlobInputStreamParent() const
    {
        return ((mValue).VPIPCBlobInputStreamParent).addr();
    }
    PIPCBlobInputStreamChild**
    ptr_PIPCBlobInputStreamChild()
    {
        return ((mValue).VPIPCBlobInputStreamChild).addr();
    }
    PIPCBlobInputStreamChild* const*
    constptr_PIPCBlobInputStreamChild() const
    {
        return ((mValue).VPIPCBlobInputStreamChild).addr();
    }
    IPCStream*
    ptr_IPCStream()
    {
        return ((mValue).VIPCStream).addr();
    }
    const IPCStream*
    constptr_IPCStream() const
    {
        return ((mValue).VIPCStream).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCBlobStream() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCBlobStream(PIPCBlobInputStreamParent* aOther);

    MOZ_IMPLICIT IPCBlobStream(PIPCBlobInputStreamChild* aOther);

    MOZ_IMPLICIT IPCBlobStream(const IPCStream& aOther);

    MOZ_IMPLICIT IPCBlobStream(const IPCBlobStream& aOther);

    ~IPCBlobStream();

    Type
    type() const
    {
        return mType;
    }

    IPCBlobStream&
    operator=(PIPCBlobInputStreamParent* aRhs);

    IPCBlobStream&
    operator=(PIPCBlobInputStreamChild* aRhs);

    IPCBlobStream&
    operator=(const IPCStream& aRhs);

    IPCBlobStream&
    operator=(const IPCBlobStream& aRhs);

    bool
    operator==(PIPCBlobInputStreamParent* aRhs) const;

    bool
    operator==(PIPCBlobInputStreamChild* aRhs) const;

    bool
    operator==(const IPCStream& aRhs) const;

    bool
    operator==(const IPCBlobStream& aRhs) const;

    PIPCBlobInputStreamParent*&
    get_PIPCBlobInputStreamParent()
    {
        AssertSanity(TPIPCBlobInputStreamParent);
        return (*(ptr_PIPCBlobInputStreamParent()));
    }
    PIPCBlobInputStreamParent*
    get_PIPCBlobInputStreamParent() const
    {
        AssertSanity(TPIPCBlobInputStreamParent);
        return (*(constptr_PIPCBlobInputStreamParent()));
    }
    void
    get(PIPCBlobInputStreamParent** aOutValue) const;
    operator PIPCBlobInputStreamParent*&()
    {
        return get_PIPCBlobInputStreamParent();
    }
    operator PIPCBlobInputStreamParent*() const
    {
        return get_PIPCBlobInputStreamParent();
    }

    PIPCBlobInputStreamChild*&
    get_PIPCBlobInputStreamChild()
    {
        AssertSanity(TPIPCBlobInputStreamChild);
        return (*(ptr_PIPCBlobInputStreamChild()));
    }
    PIPCBlobInputStreamChild*
    get_PIPCBlobInputStreamChild() const
    {
        AssertSanity(TPIPCBlobInputStreamChild);
        return (*(constptr_PIPCBlobInputStreamChild()));
    }
    void
    get(PIPCBlobInputStreamChild** aOutValue) const;
    operator PIPCBlobInputStreamChild*&()
    {
        return get_PIPCBlobInputStreamChild();
    }
    operator PIPCBlobInputStreamChild*() const
    {
        return get_PIPCBlobInputStreamChild();
    }

    IPCStream&
    get_IPCStream()
    {
        AssertSanity(TIPCStream);
        return (*(ptr_IPCStream()));
    }
    const IPCStream&
    get_IPCStream() const
    {
        AssertSanity(TIPCStream);
        return (*(constptr_IPCStream()));
    }
    void
    get(IPCStream* aOutValue) const;
    operator IPCStream&()
    {
        return get_IPCStream();
    }
    operator const IPCStream&() const
    {
        return get_IPCStream();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCBlobStream;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCFileUnion;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCBlob|
//
namespace mozilla {
namespace dom {
class IPCBlob final
{
private:
    typedef mozilla::dom::IPCBlobStream IPCBlobStream;
    typedef mozilla::dom::IPCFileUnion IPCFileUnion;

public:
    MOZ_IMPLICIT IPCBlob();

    MOZ_IMPLICIT IPCBlob(
            const nsString& _type,
            const uint64_t& _size,
            const IPCBlobStream& _inputStream,
            const IPCFileUnion& _file,
            const int64_t& _fileId)
    {
        Init();
        Assign(_type, _size, _inputStream, _file, _fileId);
    }

    MOZ_IMPLICIT IPCBlob(const IPCBlob& _o)
    {
        Init();
        Assign((_o).type(), (_o).size(), (_o).inputStream(), (_o).file(), (_o).fileId());
    }

    ~IPCBlob();

    void
    operator=(const IPCBlob& _o)
    {
        Assign((_o).type(), (_o).size(), (_o).inputStream(), (_o).file(), (_o).fileId());
    }

    bool
    operator==(const IPCBlob& _o) const;

    bool
    operator!=(const IPCBlob& _o) const;

    nsString&
    type()
    {
        return type_;
    }
    const nsString&
    type() const
    {
        return type_;
    }

    uint64_t&
    size()
    {
        return size_;
    }
    const uint64_t&
    size() const
    {
        return size_;
    }

    IPCBlobStream&
    inputStream()
    {
        return inputStream_;
    }
    const IPCBlobStream&
    inputStream() const
    {
        return inputStream_;
    }

    IPCFileUnion&
    file()
    {
        return file_;
    }
    const IPCFileUnion&
    file() const
    {
        return file_;
    }

    int64_t&
    fileId()
    {
        return fileId_;
    }
    const int64_t&
    fileId() const
    {
        return fileId_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _type,
            const uint64_t& _size,
            const IPCBlobStream& _inputStream,
            const IPCFileUnion& _file,
            const int64_t& _fileId);

    nsString type_;
    uint64_t size_;
    IPCBlobStream inputStream_;
    IPCFileUnion file_;
    int64_t fileId_;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef IPCBlob_h
