//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundStorageParent_h
#define PBackgroundStorageParent_h

#include "mozilla/dom/PBackgroundStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/OriginAttributes.h"
#include "mozilla/dom/quota/SerializationHelpers.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PBackgroundStorageParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::OriginAttributesPattern OriginAttributesPattern;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PBackgroundStorage::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvDeleteMe() = 0;
    virtual mozilla::ipc::IPCResult
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncGetUsage(const nsCString& scope) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncFlush() = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartup() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearAll() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOrigin(const nsCString& originNoSuffix) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PBackgroundStorageParent();

    virtual ~PBackgroundStorageParent();

    PBackgroundParent*
    Manager() const;

    MOZ_MUST_USE static bool
    Send__delete__(PBackgroundStorageParent* actor);

    MOZ_MUST_USE bool
    SendObserve(
            const nsCString& topic,
            const nsString& originAttributesPattern,
            const nsCString& originScope);

    MOZ_MUST_USE bool
    SendOriginsHavingData(const nsTArray<nsCString>& origins);

    MOZ_MUST_USE bool
    SendLoadItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    MOZ_MUST_USE bool
    SendLoadDone(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsresult& rv);

    MOZ_MUST_USE bool
    SendLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    MOZ_MUST_USE bool
    SendError(const nsresult& rv);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PBackgroundStorageParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PBackgroundStorageParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class BackgroundStorageParent :
    public PBackgroundStorageParent
{
    virtual mozilla::ipc::IPCResult
    RecvDeleteMe();

    virtual mozilla::ipc::IPCResult
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv);

    virtual mozilla::ipc::IPCResult
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority);

    virtual mozilla::ipc::IPCResult
    RecvAsyncGetUsage(const nsCString& scope);

    virtual mozilla::ipc::IPCResult
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    virtual mozilla::ipc::IPCResult
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    virtual mozilla::ipc::IPCResult
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key);

    virtual mozilla::ipc::IPCResult
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix);

    virtual mozilla::ipc::IPCResult
    RecvAsyncFlush();

    virtual mozilla::ipc::IPCResult
    RecvStartup();

    virtual mozilla::ipc::IPCResult
    RecvClearAll();

    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOrigin(const nsCString& originNoSuffix);

    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT BackgroundStorageParent();
    virtual ~BackgroundStorageParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
BackgroundStorageParent::RecvDeleteMe()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvPreload(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const uint32_t& alreadyLoadedCount,
        nsTArray<nsString>* keys,
        nsTArray<nsString>* values,
        nsresult* rv)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncPreload(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const bool& priority)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncGetUsage(const nsCString& scope)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncAddItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncUpdateItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncRemoveItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncClear(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvAsyncFlush()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvStartup()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvClearAll()
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvClearMatchingOrigin(const nsCString& originNoSuffix)
{
}

mozilla::ipc::IPCResult
BackgroundStorageParent::RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern)
{
}

void
BackgroundStorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT BackgroundStorageParent::BackgroundStorageParent()
{
    MOZ_COUNT_CTOR(BackgroundStorageParent);
}

MOZ_IMPLICIT BackgroundStorageParent::~BackgroundStorageParent()
{
    MOZ_COUNT_DTOR(BackgroundStorageParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PBackgroundStorageParent_h
