//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFileSystemParams_h
#define PFileSystemParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetDirectoryListingParams|
//
namespace mozilla {
namespace dom {
class FileSystemGetDirectoryListingParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemGetDirectoryListingParams();

    MOZ_IMPLICIT FileSystemGetDirectoryListingParams(
            const nsString& _filesystem,
            const nsString& _realPath,
            const nsString& _domPath,
            const nsString& _filters)
    {
        Init();
        Assign(_filesystem, _realPath, _domPath, _filters);
    }

    MOZ_IMPLICIT FileSystemGetDirectoryListingParams(const FileSystemGetDirectoryListingParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath(), (_o).domPath(), (_o).filters());
    }

    ~FileSystemGetDirectoryListingParams();

    void
    operator=(const FileSystemGetDirectoryListingParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath(), (_o).domPath(), (_o).filters());
    }

    bool
    operator==(const FileSystemGetDirectoryListingParams& _o) const;

    bool
    operator!=(const FileSystemGetDirectoryListingParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

    nsString&
    domPath()
    {
        return domPath_;
    }
    const nsString&
    domPath() const
    {
        return domPath_;
    }

    nsString&
    filters()
    {
        return filters_;
    }
    const nsString&
    filters() const
    {
        return filters_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath,
            const nsString& _domPath,
            const nsString& _filters);

    nsString filesystem_;
    nsString realPath_;
    nsString domPath_;
    nsString filters_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetFilesParams|
//
namespace mozilla {
namespace dom {
class FileSystemGetFilesParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemGetFilesParams();

    MOZ_IMPLICIT FileSystemGetFilesParams(
            const nsString& _filesystem,
            const nsString& _realPath,
            const nsString& _domPath,
            const bool& _recursiveFlag)
    {
        Init();
        Assign(_filesystem, _realPath, _domPath, _recursiveFlag);
    }

    MOZ_IMPLICIT FileSystemGetFilesParams(const FileSystemGetFilesParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath(), (_o).domPath(), (_o).recursiveFlag());
    }

    ~FileSystemGetFilesParams();

    void
    operator=(const FileSystemGetFilesParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath(), (_o).domPath(), (_o).recursiveFlag());
    }

    bool
    operator==(const FileSystemGetFilesParams& _o) const;

    bool
    operator!=(const FileSystemGetFilesParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

    nsString&
    domPath()
    {
        return domPath_;
    }
    const nsString&
    domPath() const
    {
        return domPath_;
    }

    bool&
    recursiveFlag()
    {
        return recursiveFlag_;
    }
    const bool&
    recursiveFlag() const
    {
        return recursiveFlag_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath,
            const nsString& _domPath,
            const bool& _recursiveFlag);

    nsString filesystem_;
    nsString realPath_;
    nsString domPath_;
    bool recursiveFlag_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetFileOrDirectoryParams|
//
namespace mozilla {
namespace dom {
class FileSystemGetFileOrDirectoryParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemGetFileOrDirectoryParams();

    MOZ_IMPLICIT FileSystemGetFileOrDirectoryParams(
            const nsString& _filesystem,
            const nsString& _realPath)
    {
        Init();
        Assign(_filesystem, _realPath);
    }

    MOZ_IMPLICIT FileSystemGetFileOrDirectoryParams(const FileSystemGetFileOrDirectoryParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath());
    }

    ~FileSystemGetFileOrDirectoryParams();

    void
    operator=(const FileSystemGetFileOrDirectoryParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath());
    }

    bool
    operator==(const FileSystemGetFileOrDirectoryParams& _o) const;

    bool
    operator!=(const FileSystemGetFileOrDirectoryParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath);

    nsString filesystem_;
    nsString realPath_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemGetDirectoryListingParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemGetFilesParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemGetFileOrDirectoryParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemParams|
//
namespace mozilla {
namespace dom {
class FileSystemParams final
{
public:
    enum Type {
        T__None,
        TFileSystemGetDirectoryListingParams = 1,
        TFileSystemGetFilesParams,
        TFileSystemGetFileOrDirectoryParams,
        T__Last = TFileSystemGetFileOrDirectoryParams
    };

private:
    typedef mozilla::dom::FileSystemGetDirectoryListingParams FileSystemGetDirectoryListingParams;
    typedef mozilla::dom::FileSystemGetFilesParams FileSystemGetFilesParams;
    typedef mozilla::dom::FileSystemGetFileOrDirectoryParams FileSystemGetFileOrDirectoryParams;
    typedef FileSystemGetDirectoryListingParams FileSystemGetDirectoryListingParams__tdef;
    typedef FileSystemGetFilesParams FileSystemGetFilesParams__tdef;
    typedef FileSystemGetFileOrDirectoryParams FileSystemGetFileOrDirectoryParams__tdef;

    union Value {
        mozilla::AlignedStorage2<FileSystemGetDirectoryListingParams> VFileSystemGetDirectoryListingParams;
        mozilla::AlignedStorage2<FileSystemGetFilesParams> VFileSystemGetFilesParams;
        mozilla::AlignedStorage2<FileSystemGetFileOrDirectoryParams> VFileSystemGetFileOrDirectoryParams;
    };

    FileSystemGetDirectoryListingParams*
    ptr_FileSystemGetDirectoryListingParams()
    {
        return ((mValue).VFileSystemGetDirectoryListingParams).addr();
    }
    const FileSystemGetDirectoryListingParams*
    constptr_FileSystemGetDirectoryListingParams() const
    {
        return ((mValue).VFileSystemGetDirectoryListingParams).addr();
    }
    FileSystemGetFilesParams*
    ptr_FileSystemGetFilesParams()
    {
        return ((mValue).VFileSystemGetFilesParams).addr();
    }
    const FileSystemGetFilesParams*
    constptr_FileSystemGetFilesParams() const
    {
        return ((mValue).VFileSystemGetFilesParams).addr();
    }
    FileSystemGetFileOrDirectoryParams*
    ptr_FileSystemGetFileOrDirectoryParams()
    {
        return ((mValue).VFileSystemGetFileOrDirectoryParams).addr();
    }
    const FileSystemGetFileOrDirectoryParams*
    constptr_FileSystemGetFileOrDirectoryParams() const
    {
        return ((mValue).VFileSystemGetFileOrDirectoryParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemParams(const FileSystemGetDirectoryListingParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemGetFilesParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemGetFileOrDirectoryParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemParams& aOther);

    ~FileSystemParams();

    Type
    type() const
    {
        return mType;
    }

    FileSystemParams&
    operator=(const FileSystemGetDirectoryListingParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemGetFilesParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemGetFileOrDirectoryParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemParams& aRhs);

    bool
    operator==(const FileSystemGetDirectoryListingParams& aRhs) const;

    bool
    operator==(const FileSystemGetFilesParams& aRhs) const;

    bool
    operator==(const FileSystemGetFileOrDirectoryParams& aRhs) const;

    bool
    operator==(const FileSystemParams& aRhs) const;

    FileSystemGetDirectoryListingParams&
    get_FileSystemGetDirectoryListingParams()
    {
        AssertSanity(TFileSystemGetDirectoryListingParams);
        return (*(ptr_FileSystemGetDirectoryListingParams()));
    }
    const FileSystemGetDirectoryListingParams&
    get_FileSystemGetDirectoryListingParams() const
    {
        AssertSanity(TFileSystemGetDirectoryListingParams);
        return (*(constptr_FileSystemGetDirectoryListingParams()));
    }
    void
    get(FileSystemGetDirectoryListingParams* aOutValue) const;
    operator FileSystemGetDirectoryListingParams&()
    {
        return get_FileSystemGetDirectoryListingParams();
    }
    operator const FileSystemGetDirectoryListingParams&() const
    {
        return get_FileSystemGetDirectoryListingParams();
    }

    FileSystemGetFilesParams&
    get_FileSystemGetFilesParams()
    {
        AssertSanity(TFileSystemGetFilesParams);
        return (*(ptr_FileSystemGetFilesParams()));
    }
    const FileSystemGetFilesParams&
    get_FileSystemGetFilesParams() const
    {
        AssertSanity(TFileSystemGetFilesParams);
        return (*(constptr_FileSystemGetFilesParams()));
    }
    void
    get(FileSystemGetFilesParams* aOutValue) const;
    operator FileSystemGetFilesParams&()
    {
        return get_FileSystemGetFilesParams();
    }
    operator const FileSystemGetFilesParams&() const
    {
        return get_FileSystemGetFilesParams();
    }

    FileSystemGetFileOrDirectoryParams&
    get_FileSystemGetFileOrDirectoryParams()
    {
        AssertSanity(TFileSystemGetFileOrDirectoryParams);
        return (*(ptr_FileSystemGetFileOrDirectoryParams()));
    }
    const FileSystemGetFileOrDirectoryParams&
    get_FileSystemGetFileOrDirectoryParams() const
    {
        AssertSanity(TFileSystemGetFileOrDirectoryParams);
        return (*(constptr_FileSystemGetFileOrDirectoryParams()));
    }
    void
    get(FileSystemGetFileOrDirectoryParams* aOutValue) const;
    operator FileSystemGetFileOrDirectoryParams&()
    {
        return get_FileSystemGetFileOrDirectoryParams();
    }
    operator const FileSystemGetFileOrDirectoryParams&() const
    {
        return get_FileSystemGetFileOrDirectoryParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef PFileSystemParams_h
