//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHandlerService_h
#define PHandlerService_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HandlerApp|
//
namespace mozilla {
namespace dom {
class HandlerApp final
{
private:

public:
    MOZ_IMPLICIT HandlerApp();

    MOZ_IMPLICIT HandlerApp(
            const nsString& _name,
            const nsString& _detailedDescription)
    {
        Init();
        Assign(_name, _detailedDescription);
    }

    MOZ_IMPLICIT HandlerApp(const HandlerApp& _o)
    {
        Init();
        Assign((_o).name(), (_o).detailedDescription());
    }

    ~HandlerApp();

    void
    operator=(const HandlerApp& _o)
    {
        Assign((_o).name(), (_o).detailedDescription());
    }

    bool
    operator==(const HandlerApp& _o) const;

    bool
    operator!=(const HandlerApp& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    nsString&
    detailedDescription()
    {
        return detailedDescription_;
    }
    const nsString&
    detailedDescription() const
    {
        return detailedDescription_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const nsString& _detailedDescription);

    nsString name_;
    nsString detailedDescription_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class HandlerApp;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HandlerInfo|
//
namespace mozilla {
namespace dom {
class HandlerInfo final
{
private:
    typedef mozilla::dom::HandlerApp HandlerApp;

public:
    MOZ_IMPLICIT HandlerInfo();

    MOZ_IMPLICIT HandlerInfo(
            const nsCString& _type,
            const bool& _isMIMEInfo,
            const nsString& _description,
            const bool& _alwaysAskBeforeHandling,
            const HandlerApp& _preferredApplicationHandler,
            const nsTArray<HandlerApp>& _possibleApplicationHandlers,
            const long& _preferredAction)
    {
        Init();
        Assign(_type, _isMIMEInfo, _description, _alwaysAskBeforeHandling, _preferredApplicationHandler, _possibleApplicationHandlers, _preferredAction);
    }

    MOZ_IMPLICIT HandlerInfo(const HandlerInfo& _o)
    {
        Init();
        Assign((_o).type(), (_o).isMIMEInfo(), (_o).description(), (_o).alwaysAskBeforeHandling(), (_o).preferredApplicationHandler(), (_o).possibleApplicationHandlers(), (_o).preferredAction());
    }

    ~HandlerInfo();

    void
    operator=(const HandlerInfo& _o)
    {
        Assign((_o).type(), (_o).isMIMEInfo(), (_o).description(), (_o).alwaysAskBeforeHandling(), (_o).preferredApplicationHandler(), (_o).possibleApplicationHandlers(), (_o).preferredAction());
    }

    bool
    operator==(const HandlerInfo& _o) const;

    bool
    operator!=(const HandlerInfo& _o) const;

    nsCString&
    type()
    {
        return type_;
    }
    const nsCString&
    type() const
    {
        return type_;
    }

    bool&
    isMIMEInfo()
    {
        return isMIMEInfo_;
    }
    const bool&
    isMIMEInfo() const
    {
        return isMIMEInfo_;
    }

    nsString&
    description()
    {
        return description_;
    }
    const nsString&
    description() const
    {
        return description_;
    }

    bool&
    alwaysAskBeforeHandling()
    {
        return alwaysAskBeforeHandling_;
    }
    const bool&
    alwaysAskBeforeHandling() const
    {
        return alwaysAskBeforeHandling_;
    }

    HandlerApp&
    preferredApplicationHandler()
    {
        return preferredApplicationHandler_;
    }
    const HandlerApp&
    preferredApplicationHandler() const
    {
        return preferredApplicationHandler_;
    }

    nsTArray<HandlerApp>&
    possibleApplicationHandlers()
    {
        return possibleApplicationHandlers_;
    }
    const nsTArray<HandlerApp>&
    possibleApplicationHandlers() const
    {
        return possibleApplicationHandlers_;
    }

    long&
    preferredAction()
    {
        return preferredAction_;
    }
    const long&
    preferredAction() const
    {
        return preferredAction_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _type,
            const bool& _isMIMEInfo,
            const nsString& _description,
            const bool& _alwaysAskBeforeHandling,
            const HandlerApp& _preferredApplicationHandler,
            const nsTArray<HandlerApp>& _possibleApplicationHandlers,
            const long& _preferredAction);

    nsCString type_;
    bool isMIMEInfo_;
    nsString description_;
    bool alwaysAskBeforeHandling_;
    HandlerApp preferredApplicationHandler_;
    nsTArray<HandlerApp> possibleApplicationHandlers_;
    long preferredAction_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PHandlerServiceParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PHandlerServiceChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PHandlerServiceChild and PHandlerServiceParent
//
namespace mozilla {
namespace dom {
namespace PHandlerService {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PHandlerServiceParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PHandlerServiceChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PHandlerServiceStart = PHandlerServiceMsgStart << 16,
    Msg_FillHandlerInfo__ID,
    Reply_FillHandlerInfo__ID,
    Msg_Exists__ID,
    Reply_Exists__ID,
    Msg_GetTypeFromExtension__ID,
    Reply_GetTypeFromExtension__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PHandlerServiceEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg_FillHandlerInfo(int32_t routingId);
IPC::Message*
Reply_FillHandlerInfo(int32_t routingId);

IPC::Message*
Msg_Exists(int32_t routingId);
IPC::Message*
Reply_Exists(int32_t routingId);

IPC::Message*
Msg_GetTypeFromExtension(int32_t routingId);
IPC::Message*
Reply_GetTypeFromExtension(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PHandlerService
} // namespace dom
} // namespace mozilla

#endif // ifndef PHandlerService_h
