//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPaymentRequest_h
#define PPaymentRequest_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/dom/PermissionMessageUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentMethodData|
//
namespace mozilla {
namespace dom {
class IPCPaymentMethodData final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentMethodData();

    MOZ_IMPLICIT IPCPaymentMethodData(
            const nsString& _supportedMethods,
            const nsString& _data)
    {
        Init();
        Assign(_supportedMethods, _data);
    }

    MOZ_IMPLICIT IPCPaymentMethodData(const IPCPaymentMethodData& _o)
    {
        Init();
        Assign((_o).supportedMethods(), (_o).data());
    }

    ~IPCPaymentMethodData();

    void
    operator=(const IPCPaymentMethodData& _o)
    {
        Assign((_o).supportedMethods(), (_o).data());
    }

    bool
    operator==(const IPCPaymentMethodData& _o) const;

    bool
    operator!=(const IPCPaymentMethodData& _o) const;

    nsString&
    supportedMethods()
    {
        return supportedMethods_;
    }
    const nsString&
    supportedMethods() const
    {
        return supportedMethods_;
    }

    nsString&
    data()
    {
        return data_;
    }
    const nsString&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _supportedMethods,
            const nsString& _data);

    nsString supportedMethods_;
    nsString data_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentCurrencyAmount|
//
namespace mozilla {
namespace dom {
class IPCPaymentCurrencyAmount final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentCurrencyAmount();

    MOZ_IMPLICIT IPCPaymentCurrencyAmount(
            const nsString& _currency,
            const nsString& _value)
    {
        Init();
        Assign(_currency, _value);
    }

    MOZ_IMPLICIT IPCPaymentCurrencyAmount(const IPCPaymentCurrencyAmount& _o)
    {
        Init();
        Assign((_o).currency(), (_o).value());
    }

    ~IPCPaymentCurrencyAmount();

    void
    operator=(const IPCPaymentCurrencyAmount& _o)
    {
        Assign((_o).currency(), (_o).value());
    }

    bool
    operator==(const IPCPaymentCurrencyAmount& _o) const;

    bool
    operator!=(const IPCPaymentCurrencyAmount& _o) const;

    nsString&
    currency()
    {
        return currency_;
    }
    const nsString&
    currency() const
    {
        return currency_;
    }

    nsString&
    value()
    {
        return value_;
    }
    const nsString&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _currency,
            const nsString& _value);

    nsString currency_;
    nsString value_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentCurrencyAmount;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentItem|
//
namespace mozilla {
namespace dom {
class IPCPaymentItem final
{
private:
    typedef mozilla::dom::IPCPaymentCurrencyAmount IPCPaymentCurrencyAmount;

public:
    MOZ_IMPLICIT IPCPaymentItem();

    MOZ_IMPLICIT IPCPaymentItem(
            const nsString& _label,
            const IPCPaymentCurrencyAmount& _amount,
            const bool& _pending)
    {
        Init();
        Assign(_label, _amount, _pending);
    }

    MOZ_IMPLICIT IPCPaymentItem(const IPCPaymentItem& _o)
    {
        Init();
        Assign((_o).label(), (_o).amount(), (_o).pending());
    }

    ~IPCPaymentItem();

    void
    operator=(const IPCPaymentItem& _o)
    {
        Assign((_o).label(), (_o).amount(), (_o).pending());
    }

    bool
    operator==(const IPCPaymentItem& _o) const;

    bool
    operator!=(const IPCPaymentItem& _o) const;

    nsString&
    label()
    {
        return label_;
    }
    const nsString&
    label() const
    {
        return label_;
    }

    IPCPaymentCurrencyAmount&
    amount()
    {
        return amount_;
    }
    const IPCPaymentCurrencyAmount&
    amount() const
    {
        return amount_;
    }

    bool&
    pending()
    {
        return pending_;
    }
    const bool&
    pending() const
    {
        return pending_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _label,
            const IPCPaymentCurrencyAmount& _amount,
            const bool& _pending);

    nsString label_;
    IPCPaymentCurrencyAmount amount_;
    bool pending_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentItem;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentDetailsModifier|
//
namespace mozilla {
namespace dom {
class IPCPaymentDetailsModifier final
{
private:
    typedef mozilla::dom::IPCPaymentItem IPCPaymentItem;

public:
    MOZ_IMPLICIT IPCPaymentDetailsModifier();

    MOZ_IMPLICIT IPCPaymentDetailsModifier(
            const nsString& _supportedMethods,
            const IPCPaymentItem& _total,
            const nsTArray<IPCPaymentItem>& _additionalDisplayItems,
            const nsString& _data,
            const bool& _additionalDisplayItemsPassed)
    {
        Init();
        Assign(_supportedMethods, _total, _additionalDisplayItems, _data, _additionalDisplayItemsPassed);
    }

    MOZ_IMPLICIT IPCPaymentDetailsModifier(const IPCPaymentDetailsModifier& _o)
    {
        Init();
        Assign((_o).supportedMethods(), (_o).total(), (_o).additionalDisplayItems(), (_o).data(), (_o).additionalDisplayItemsPassed());
    }

    ~IPCPaymentDetailsModifier();

    void
    operator=(const IPCPaymentDetailsModifier& _o)
    {
        Assign((_o).supportedMethods(), (_o).total(), (_o).additionalDisplayItems(), (_o).data(), (_o).additionalDisplayItemsPassed());
    }

    bool
    operator==(const IPCPaymentDetailsModifier& _o) const;

    bool
    operator!=(const IPCPaymentDetailsModifier& _o) const;

    nsString&
    supportedMethods()
    {
        return supportedMethods_;
    }
    const nsString&
    supportedMethods() const
    {
        return supportedMethods_;
    }

    IPCPaymentItem&
    total()
    {
        return total_;
    }
    const IPCPaymentItem&
    total() const
    {
        return total_;
    }

    nsTArray<IPCPaymentItem>&
    additionalDisplayItems()
    {
        return additionalDisplayItems_;
    }
    const nsTArray<IPCPaymentItem>&
    additionalDisplayItems() const
    {
        return additionalDisplayItems_;
    }

    nsString&
    data()
    {
        return data_;
    }
    const nsString&
    data() const
    {
        return data_;
    }

    bool&
    additionalDisplayItemsPassed()
    {
        return additionalDisplayItemsPassed_;
    }
    const bool&
    additionalDisplayItemsPassed() const
    {
        return additionalDisplayItemsPassed_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _supportedMethods,
            const IPCPaymentItem& _total,
            const nsTArray<IPCPaymentItem>& _additionalDisplayItems,
            const nsString& _data,
            const bool& _additionalDisplayItemsPassed);

    nsString supportedMethods_;
    IPCPaymentItem total_;
    nsTArray<IPCPaymentItem> additionalDisplayItems_;
    nsString data_;
    bool additionalDisplayItemsPassed_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentCurrencyAmount;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentShippingOption|
//
namespace mozilla {
namespace dom {
class IPCPaymentShippingOption final
{
private:
    typedef mozilla::dom::IPCPaymentCurrencyAmount IPCPaymentCurrencyAmount;

public:
    MOZ_IMPLICIT IPCPaymentShippingOption();

    MOZ_IMPLICIT IPCPaymentShippingOption(
            const nsString& _id,
            const nsString& _label,
            const IPCPaymentCurrencyAmount& _amount,
            const bool& _selected)
    {
        Init();
        Assign(_id, _label, _amount, _selected);
    }

    MOZ_IMPLICIT IPCPaymentShippingOption(const IPCPaymentShippingOption& _o)
    {
        Init();
        Assign((_o).id(), (_o).label(), (_o).amount(), (_o).selected());
    }

    ~IPCPaymentShippingOption();

    void
    operator=(const IPCPaymentShippingOption& _o)
    {
        Assign((_o).id(), (_o).label(), (_o).amount(), (_o).selected());
    }

    bool
    operator==(const IPCPaymentShippingOption& _o) const;

    bool
    operator!=(const IPCPaymentShippingOption& _o) const;

    nsString&
    id()
    {
        return id_;
    }
    const nsString&
    id() const
    {
        return id_;
    }

    nsString&
    label()
    {
        return label_;
    }
    const nsString&
    label() const
    {
        return label_;
    }

    IPCPaymentCurrencyAmount&
    amount()
    {
        return amount_;
    }
    const IPCPaymentCurrencyAmount&
    amount() const
    {
        return amount_;
    }

    bool&
    selected()
    {
        return selected_;
    }
    const bool&
    selected() const
    {
        return selected_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _id,
            const nsString& _label,
            const IPCPaymentCurrencyAmount& _amount,
            const bool& _selected);

    nsString id_;
    nsString label_;
    IPCPaymentCurrencyAmount amount_;
    bool selected_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentItem;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentShippingOption;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentDetailsModifier;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentDetails|
//
namespace mozilla {
namespace dom {
class IPCPaymentDetails final
{
private:
    typedef mozilla::dom::IPCPaymentItem IPCPaymentItem;
    typedef mozilla::dom::IPCPaymentShippingOption IPCPaymentShippingOption;
    typedef mozilla::dom::IPCPaymentDetailsModifier IPCPaymentDetailsModifier;

public:
    MOZ_IMPLICIT IPCPaymentDetails();

    MOZ_IMPLICIT IPCPaymentDetails(
            const nsString& _id,
            const IPCPaymentItem& _total,
            const nsTArray<IPCPaymentItem>& _displayItems,
            const nsTArray<IPCPaymentShippingOption>& _shippingOptions,
            const nsTArray<IPCPaymentDetailsModifier>& _modifiers,
            const nsString& _error,
            const bool& _displayItemsPassed,
            const bool& _shippingOptionsPassed,
            const bool& _modifiersPassed)
    {
        Init();
        Assign(_id, _total, _displayItems, _shippingOptions, _modifiers, _error, _displayItemsPassed, _shippingOptionsPassed, _modifiersPassed);
    }

    MOZ_IMPLICIT IPCPaymentDetails(const IPCPaymentDetails& _o)
    {
        Init();
        Assign((_o).id(), (_o).total(), (_o).displayItems(), (_o).shippingOptions(), (_o).modifiers(), (_o).error(), (_o).displayItemsPassed(), (_o).shippingOptionsPassed(), (_o).modifiersPassed());
    }

    ~IPCPaymentDetails();

    void
    operator=(const IPCPaymentDetails& _o)
    {
        Assign((_o).id(), (_o).total(), (_o).displayItems(), (_o).shippingOptions(), (_o).modifiers(), (_o).error(), (_o).displayItemsPassed(), (_o).shippingOptionsPassed(), (_o).modifiersPassed());
    }

    bool
    operator==(const IPCPaymentDetails& _o) const;

    bool
    operator!=(const IPCPaymentDetails& _o) const;

    nsString&
    id()
    {
        return id_;
    }
    const nsString&
    id() const
    {
        return id_;
    }

    IPCPaymentItem&
    total()
    {
        return total_;
    }
    const IPCPaymentItem&
    total() const
    {
        return total_;
    }

    nsTArray<IPCPaymentItem>&
    displayItems()
    {
        return displayItems_;
    }
    const nsTArray<IPCPaymentItem>&
    displayItems() const
    {
        return displayItems_;
    }

    nsTArray<IPCPaymentShippingOption>&
    shippingOptions()
    {
        return shippingOptions_;
    }
    const nsTArray<IPCPaymentShippingOption>&
    shippingOptions() const
    {
        return shippingOptions_;
    }

    nsTArray<IPCPaymentDetailsModifier>&
    modifiers()
    {
        return modifiers_;
    }
    const nsTArray<IPCPaymentDetailsModifier>&
    modifiers() const
    {
        return modifiers_;
    }

    nsString&
    error()
    {
        return error_;
    }
    const nsString&
    error() const
    {
        return error_;
    }

    bool&
    displayItemsPassed()
    {
        return displayItemsPassed_;
    }
    const bool&
    displayItemsPassed() const
    {
        return displayItemsPassed_;
    }

    bool&
    shippingOptionsPassed()
    {
        return shippingOptionsPassed_;
    }
    const bool&
    shippingOptionsPassed() const
    {
        return shippingOptionsPassed_;
    }

    bool&
    modifiersPassed()
    {
        return modifiersPassed_;
    }
    const bool&
    modifiersPassed() const
    {
        return modifiersPassed_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _id,
            const IPCPaymentItem& _total,
            const nsTArray<IPCPaymentItem>& _displayItems,
            const nsTArray<IPCPaymentShippingOption>& _shippingOptions,
            const nsTArray<IPCPaymentDetailsModifier>& _modifiers,
            const nsString& _error,
            const bool& _displayItemsPassed,
            const bool& _shippingOptionsPassed,
            const bool& _modifiersPassed);

    nsString id_;
    IPCPaymentItem total_;
    nsTArray<IPCPaymentItem> displayItems_;
    nsTArray<IPCPaymentShippingOption> shippingOptions_;
    nsTArray<IPCPaymentDetailsModifier> modifiers_;
    nsString error_;
    bool displayItemsPassed_;
    bool shippingOptionsPassed_;
    bool modifiersPassed_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentOptions|
//
namespace mozilla {
namespace dom {
class IPCPaymentOptions final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentOptions();

    MOZ_IMPLICIT IPCPaymentOptions(
            const bool& _requestPayerName,
            const bool& _requestPayerEmail,
            const bool& _requestPayerPhone,
            const bool& _requestShipping,
            const nsString& _shippingType)
    {
        Init();
        Assign(_requestPayerName, _requestPayerEmail, _requestPayerPhone, _requestShipping, _shippingType);
    }

    MOZ_IMPLICIT IPCPaymentOptions(const IPCPaymentOptions& _o)
    {
        Init();
        Assign((_o).requestPayerName(), (_o).requestPayerEmail(), (_o).requestPayerPhone(), (_o).requestShipping(), (_o).shippingType());
    }

    ~IPCPaymentOptions();

    void
    operator=(const IPCPaymentOptions& _o)
    {
        Assign((_o).requestPayerName(), (_o).requestPayerEmail(), (_o).requestPayerPhone(), (_o).requestShipping(), (_o).shippingType());
    }

    bool
    operator==(const IPCPaymentOptions& _o) const;

    bool
    operator!=(const IPCPaymentOptions& _o) const;

    bool&
    requestPayerName()
    {
        return requestPayerName_;
    }
    const bool&
    requestPayerName() const
    {
        return requestPayerName_;
    }

    bool&
    requestPayerEmail()
    {
        return requestPayerEmail_;
    }
    const bool&
    requestPayerEmail() const
    {
        return requestPayerEmail_;
    }

    bool&
    requestPayerPhone()
    {
        return requestPayerPhone_;
    }
    const bool&
    requestPayerPhone() const
    {
        return requestPayerPhone_;
    }

    bool&
    requestShipping()
    {
        return requestShipping_;
    }
    const bool&
    requestShipping() const
    {
        return requestShipping_;
    }

    nsString&
    shippingType()
    {
        return shippingType_;
    }
    const nsString&
    shippingType() const
    {
        return shippingType_;
    }

private:
    void
    Init();

    void
    Assign(
            const bool& _requestPayerName,
            const bool& _requestPayerEmail,
            const bool& _requestPayerPhone,
            const bool& _requestShipping,
            const nsString& _shippingType);

    bool requestPayerName_;
    bool requestPayerEmail_;
    bool requestPayerPhone_;
    bool requestShipping_;
    nsString shippingType_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentMethodData;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentDetails;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentOptions;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentCreateActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentCreateActionRequest final
{
private:
    typedef IPC::Principal Principal;
    typedef mozilla::dom::IPCPaymentMethodData IPCPaymentMethodData;
    typedef mozilla::dom::IPCPaymentDetails IPCPaymentDetails;
    typedef mozilla::dom::IPCPaymentOptions IPCPaymentOptions;

public:
    MOZ_IMPLICIT IPCPaymentCreateActionRequest();

    MOZ_IMPLICIT IPCPaymentCreateActionRequest(
            const nsString& _requestId,
            const Principal& _topLevelPrincipal,
            const nsTArray<IPCPaymentMethodData>& _methodData,
            const IPCPaymentDetails& _details,
            const IPCPaymentOptions& _options)
    {
        Init();
        Assign(_requestId, _topLevelPrincipal, _methodData, _details, _options);
    }

    MOZ_IMPLICIT IPCPaymentCreateActionRequest(const IPCPaymentCreateActionRequest& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).topLevelPrincipal(), (_o).methodData(), (_o).details(), (_o).options());
    }

    ~IPCPaymentCreateActionRequest();

    void
    operator=(const IPCPaymentCreateActionRequest& _o)
    {
        Assign((_o).requestId(), (_o).topLevelPrincipal(), (_o).methodData(), (_o).details(), (_o).options());
    }

    bool
    operator==(const IPCPaymentCreateActionRequest& _o) const;

    bool
    operator!=(const IPCPaymentCreateActionRequest& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    Principal&
    topLevelPrincipal()
    {
        return topLevelPrincipal_;
    }
    const Principal&
    topLevelPrincipal() const
    {
        return topLevelPrincipal_;
    }

    nsTArray<IPCPaymentMethodData>&
    methodData()
    {
        return methodData_;
    }
    const nsTArray<IPCPaymentMethodData>&
    methodData() const
    {
        return methodData_;
    }

    IPCPaymentDetails&
    details()
    {
        return details_;
    }
    const IPCPaymentDetails&
    details() const
    {
        return details_;
    }

    IPCPaymentOptions&
    options()
    {
        return options_;
    }
    const IPCPaymentOptions&
    options() const
    {
        return options_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const Principal& _topLevelPrincipal,
            const nsTArray<IPCPaymentMethodData>& _methodData,
            const IPCPaymentDetails& _details,
            const IPCPaymentOptions& _options);

    nsString requestId_;
    Principal topLevelPrincipal_;
    nsTArray<IPCPaymentMethodData> methodData_;
    IPCPaymentDetails details_;
    IPCPaymentOptions options_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentCanMakeActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentCanMakeActionRequest final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentCanMakeActionRequest();

    MOZ_IMPLICIT IPCPaymentCanMakeActionRequest(const nsString& _requestId)
    {
        Init();
        Assign(_requestId);
    }

    MOZ_IMPLICIT IPCPaymentCanMakeActionRequest(const IPCPaymentCanMakeActionRequest& _o)
    {
        Init();
        Assign((_o).requestId());
    }

    ~IPCPaymentCanMakeActionRequest();

    void
    operator=(const IPCPaymentCanMakeActionRequest& _o)
    {
        Assign((_o).requestId());
    }

    bool
    operator==(const IPCPaymentCanMakeActionRequest& _o) const;

    bool
    operator!=(const IPCPaymentCanMakeActionRequest& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _requestId);

    nsString requestId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentShowActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentShowActionRequest final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentShowActionRequest();

    MOZ_IMPLICIT IPCPaymentShowActionRequest(const nsString& _requestId)
    {
        Init();
        Assign(_requestId);
    }

    MOZ_IMPLICIT IPCPaymentShowActionRequest(const IPCPaymentShowActionRequest& _o)
    {
        Init();
        Assign((_o).requestId());
    }

    ~IPCPaymentShowActionRequest();

    void
    operator=(const IPCPaymentShowActionRequest& _o)
    {
        Assign((_o).requestId());
    }

    bool
    operator==(const IPCPaymentShowActionRequest& _o) const;

    bool
    operator!=(const IPCPaymentShowActionRequest& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _requestId);

    nsString requestId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentAbortActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentAbortActionRequest final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentAbortActionRequest();

    MOZ_IMPLICIT IPCPaymentAbortActionRequest(const nsString& _requestId)
    {
        Init();
        Assign(_requestId);
    }

    MOZ_IMPLICIT IPCPaymentAbortActionRequest(const IPCPaymentAbortActionRequest& _o)
    {
        Init();
        Assign((_o).requestId());
    }

    ~IPCPaymentAbortActionRequest();

    void
    operator=(const IPCPaymentAbortActionRequest& _o)
    {
        Assign((_o).requestId());
    }

    bool
    operator==(const IPCPaymentAbortActionRequest& _o) const;

    bool
    operator!=(const IPCPaymentAbortActionRequest& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _requestId);

    nsString requestId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentCompleteActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentCompleteActionRequest final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentCompleteActionRequest();

    MOZ_IMPLICIT IPCPaymentCompleteActionRequest(
            const nsString& _requestId,
            const nsString& _completeStatus)
    {
        Init();
        Assign(_requestId, _completeStatus);
    }

    MOZ_IMPLICIT IPCPaymentCompleteActionRequest(const IPCPaymentCompleteActionRequest& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).completeStatus());
    }

    ~IPCPaymentCompleteActionRequest();

    void
    operator=(const IPCPaymentCompleteActionRequest& _o)
    {
        Assign((_o).requestId(), (_o).completeStatus());
    }

    bool
    operator==(const IPCPaymentCompleteActionRequest& _o) const;

    bool
    operator!=(const IPCPaymentCompleteActionRequest& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    nsString&
    completeStatus()
    {
        return completeStatus_;
    }
    const nsString&
    completeStatus() const
    {
        return completeStatus_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const nsString& _completeStatus);

    nsString requestId_;
    nsString completeStatus_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentDetails;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentUpdateActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentUpdateActionRequest final
{
private:
    typedef mozilla::dom::IPCPaymentDetails IPCPaymentDetails;

public:
    MOZ_IMPLICIT IPCPaymentUpdateActionRequest();

    MOZ_IMPLICIT IPCPaymentUpdateActionRequest(
            const nsString& _requestId,
            const IPCPaymentDetails& _details)
    {
        Init();
        Assign(_requestId, _details);
    }

    MOZ_IMPLICIT IPCPaymentUpdateActionRequest(const IPCPaymentUpdateActionRequest& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).details());
    }

    ~IPCPaymentUpdateActionRequest();

    void
    operator=(const IPCPaymentUpdateActionRequest& _o)
    {
        Assign((_o).requestId(), (_o).details());
    }

    bool
    operator==(const IPCPaymentUpdateActionRequest& _o) const;

    bool
    operator!=(const IPCPaymentUpdateActionRequest& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    IPCPaymentDetails&
    details()
    {
        return details_;
    }
    const IPCPaymentDetails&
    details() const
    {
        return details_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const IPCPaymentDetails& _details);

    nsString requestId_;
    IPCPaymentDetails details_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentCreateActionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentCanMakeActionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentShowActionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentAbortActionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentCompleteActionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentUpdateActionRequest;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCPaymentActionRequest|
//
namespace mozilla {
namespace dom {
class IPCPaymentActionRequest final
{
public:
    enum Type {
        T__None,
        TIPCPaymentCreateActionRequest = 1,
        TIPCPaymentCanMakeActionRequest,
        TIPCPaymentShowActionRequest,
        TIPCPaymentAbortActionRequest,
        TIPCPaymentCompleteActionRequest,
        TIPCPaymentUpdateActionRequest,
        T__Last = TIPCPaymentUpdateActionRequest
    };

private:
    typedef mozilla::dom::IPCPaymentCreateActionRequest IPCPaymentCreateActionRequest;
    typedef mozilla::dom::IPCPaymentCanMakeActionRequest IPCPaymentCanMakeActionRequest;
    typedef mozilla::dom::IPCPaymentShowActionRequest IPCPaymentShowActionRequest;
    typedef mozilla::dom::IPCPaymentAbortActionRequest IPCPaymentAbortActionRequest;
    typedef mozilla::dom::IPCPaymentCompleteActionRequest IPCPaymentCompleteActionRequest;
    typedef mozilla::dom::IPCPaymentUpdateActionRequest IPCPaymentUpdateActionRequest;
    typedef IPCPaymentCreateActionRequest IPCPaymentCreateActionRequest__tdef;
    typedef IPCPaymentCanMakeActionRequest IPCPaymentCanMakeActionRequest__tdef;
    typedef IPCPaymentShowActionRequest IPCPaymentShowActionRequest__tdef;
    typedef IPCPaymentAbortActionRequest IPCPaymentAbortActionRequest__tdef;
    typedef IPCPaymentCompleteActionRequest IPCPaymentCompleteActionRequest__tdef;
    typedef IPCPaymentUpdateActionRequest IPCPaymentUpdateActionRequest__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCPaymentCreateActionRequest> VIPCPaymentCreateActionRequest;
        mozilla::AlignedStorage2<IPCPaymentCanMakeActionRequest> VIPCPaymentCanMakeActionRequest;
        mozilla::AlignedStorage2<IPCPaymentShowActionRequest> VIPCPaymentShowActionRequest;
        mozilla::AlignedStorage2<IPCPaymentAbortActionRequest> VIPCPaymentAbortActionRequest;
        mozilla::AlignedStorage2<IPCPaymentCompleteActionRequest> VIPCPaymentCompleteActionRequest;
        mozilla::AlignedStorage2<IPCPaymentUpdateActionRequest> VIPCPaymentUpdateActionRequest;
    };

    IPCPaymentCreateActionRequest*
    ptr_IPCPaymentCreateActionRequest()
    {
        return ((mValue).VIPCPaymentCreateActionRequest).addr();
    }
    const IPCPaymentCreateActionRequest*
    constptr_IPCPaymentCreateActionRequest() const
    {
        return ((mValue).VIPCPaymentCreateActionRequest).addr();
    }
    IPCPaymentCanMakeActionRequest*
    ptr_IPCPaymentCanMakeActionRequest()
    {
        return ((mValue).VIPCPaymentCanMakeActionRequest).addr();
    }
    const IPCPaymentCanMakeActionRequest*
    constptr_IPCPaymentCanMakeActionRequest() const
    {
        return ((mValue).VIPCPaymentCanMakeActionRequest).addr();
    }
    IPCPaymentShowActionRequest*
    ptr_IPCPaymentShowActionRequest()
    {
        return ((mValue).VIPCPaymentShowActionRequest).addr();
    }
    const IPCPaymentShowActionRequest*
    constptr_IPCPaymentShowActionRequest() const
    {
        return ((mValue).VIPCPaymentShowActionRequest).addr();
    }
    IPCPaymentAbortActionRequest*
    ptr_IPCPaymentAbortActionRequest()
    {
        return ((mValue).VIPCPaymentAbortActionRequest).addr();
    }
    const IPCPaymentAbortActionRequest*
    constptr_IPCPaymentAbortActionRequest() const
    {
        return ((mValue).VIPCPaymentAbortActionRequest).addr();
    }
    IPCPaymentCompleteActionRequest*
    ptr_IPCPaymentCompleteActionRequest()
    {
        return ((mValue).VIPCPaymentCompleteActionRequest).addr();
    }
    const IPCPaymentCompleteActionRequest*
    constptr_IPCPaymentCompleteActionRequest() const
    {
        return ((mValue).VIPCPaymentCompleteActionRequest).addr();
    }
    IPCPaymentUpdateActionRequest*
    ptr_IPCPaymentUpdateActionRequest()
    {
        return ((mValue).VIPCPaymentUpdateActionRequest).addr();
    }
    const IPCPaymentUpdateActionRequest*
    constptr_IPCPaymentUpdateActionRequest() const
    {
        return ((mValue).VIPCPaymentUpdateActionRequest).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCPaymentActionRequest() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentCreateActionRequest& aOther);

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentCanMakeActionRequest& aOther);

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentShowActionRequest& aOther);

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentAbortActionRequest& aOther);

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentCompleteActionRequest& aOther);

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentUpdateActionRequest& aOther);

    MOZ_IMPLICIT IPCPaymentActionRequest(const IPCPaymentActionRequest& aOther);

    ~IPCPaymentActionRequest();

    Type
    type() const
    {
        return mType;
    }

    IPCPaymentActionRequest&
    operator=(const IPCPaymentCreateActionRequest& aRhs);

    IPCPaymentActionRequest&
    operator=(const IPCPaymentCanMakeActionRequest& aRhs);

    IPCPaymentActionRequest&
    operator=(const IPCPaymentShowActionRequest& aRhs);

    IPCPaymentActionRequest&
    operator=(const IPCPaymentAbortActionRequest& aRhs);

    IPCPaymentActionRequest&
    operator=(const IPCPaymentCompleteActionRequest& aRhs);

    IPCPaymentActionRequest&
    operator=(const IPCPaymentUpdateActionRequest& aRhs);

    IPCPaymentActionRequest&
    operator=(const IPCPaymentActionRequest& aRhs);

    bool
    operator==(const IPCPaymentCreateActionRequest& aRhs) const;

    bool
    operator==(const IPCPaymentCanMakeActionRequest& aRhs) const;

    bool
    operator==(const IPCPaymentShowActionRequest& aRhs) const;

    bool
    operator==(const IPCPaymentAbortActionRequest& aRhs) const;

    bool
    operator==(const IPCPaymentCompleteActionRequest& aRhs) const;

    bool
    operator==(const IPCPaymentUpdateActionRequest& aRhs) const;

    bool
    operator==(const IPCPaymentActionRequest& aRhs) const;

    IPCPaymentCreateActionRequest&
    get_IPCPaymentCreateActionRequest()
    {
        AssertSanity(TIPCPaymentCreateActionRequest);
        return (*(ptr_IPCPaymentCreateActionRequest()));
    }
    const IPCPaymentCreateActionRequest&
    get_IPCPaymentCreateActionRequest() const
    {
        AssertSanity(TIPCPaymentCreateActionRequest);
        return (*(constptr_IPCPaymentCreateActionRequest()));
    }
    void
    get(IPCPaymentCreateActionRequest* aOutValue) const;
    operator IPCPaymentCreateActionRequest&()
    {
        return get_IPCPaymentCreateActionRequest();
    }
    operator const IPCPaymentCreateActionRequest&() const
    {
        return get_IPCPaymentCreateActionRequest();
    }

    IPCPaymentCanMakeActionRequest&
    get_IPCPaymentCanMakeActionRequest()
    {
        AssertSanity(TIPCPaymentCanMakeActionRequest);
        return (*(ptr_IPCPaymentCanMakeActionRequest()));
    }
    const IPCPaymentCanMakeActionRequest&
    get_IPCPaymentCanMakeActionRequest() const
    {
        AssertSanity(TIPCPaymentCanMakeActionRequest);
        return (*(constptr_IPCPaymentCanMakeActionRequest()));
    }
    void
    get(IPCPaymentCanMakeActionRequest* aOutValue) const;
    operator IPCPaymentCanMakeActionRequest&()
    {
        return get_IPCPaymentCanMakeActionRequest();
    }
    operator const IPCPaymentCanMakeActionRequest&() const
    {
        return get_IPCPaymentCanMakeActionRequest();
    }

    IPCPaymentShowActionRequest&
    get_IPCPaymentShowActionRequest()
    {
        AssertSanity(TIPCPaymentShowActionRequest);
        return (*(ptr_IPCPaymentShowActionRequest()));
    }
    const IPCPaymentShowActionRequest&
    get_IPCPaymentShowActionRequest() const
    {
        AssertSanity(TIPCPaymentShowActionRequest);
        return (*(constptr_IPCPaymentShowActionRequest()));
    }
    void
    get(IPCPaymentShowActionRequest* aOutValue) const;
    operator IPCPaymentShowActionRequest&()
    {
        return get_IPCPaymentShowActionRequest();
    }
    operator const IPCPaymentShowActionRequest&() const
    {
        return get_IPCPaymentShowActionRequest();
    }

    IPCPaymentAbortActionRequest&
    get_IPCPaymentAbortActionRequest()
    {
        AssertSanity(TIPCPaymentAbortActionRequest);
        return (*(ptr_IPCPaymentAbortActionRequest()));
    }
    const IPCPaymentAbortActionRequest&
    get_IPCPaymentAbortActionRequest() const
    {
        AssertSanity(TIPCPaymentAbortActionRequest);
        return (*(constptr_IPCPaymentAbortActionRequest()));
    }
    void
    get(IPCPaymentAbortActionRequest* aOutValue) const;
    operator IPCPaymentAbortActionRequest&()
    {
        return get_IPCPaymentAbortActionRequest();
    }
    operator const IPCPaymentAbortActionRequest&() const
    {
        return get_IPCPaymentAbortActionRequest();
    }

    IPCPaymentCompleteActionRequest&
    get_IPCPaymentCompleteActionRequest()
    {
        AssertSanity(TIPCPaymentCompleteActionRequest);
        return (*(ptr_IPCPaymentCompleteActionRequest()));
    }
    const IPCPaymentCompleteActionRequest&
    get_IPCPaymentCompleteActionRequest() const
    {
        AssertSanity(TIPCPaymentCompleteActionRequest);
        return (*(constptr_IPCPaymentCompleteActionRequest()));
    }
    void
    get(IPCPaymentCompleteActionRequest* aOutValue) const;
    operator IPCPaymentCompleteActionRequest&()
    {
        return get_IPCPaymentCompleteActionRequest();
    }
    operator const IPCPaymentCompleteActionRequest&() const
    {
        return get_IPCPaymentCompleteActionRequest();
    }

    IPCPaymentUpdateActionRequest&
    get_IPCPaymentUpdateActionRequest()
    {
        AssertSanity(TIPCPaymentUpdateActionRequest);
        return (*(ptr_IPCPaymentUpdateActionRequest()));
    }
    const IPCPaymentUpdateActionRequest&
    get_IPCPaymentUpdateActionRequest() const
    {
        AssertSanity(TIPCPaymentUpdateActionRequest);
        return (*(constptr_IPCPaymentUpdateActionRequest()));
    }
    void
    get(IPCPaymentUpdateActionRequest* aOutValue) const;
    operator IPCPaymentUpdateActionRequest&()
    {
        return get_IPCPaymentUpdateActionRequest();
    }
    operator const IPCPaymentUpdateActionRequest&() const
    {
        return get_IPCPaymentUpdateActionRequest();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentCanMakeActionResponse|
//
namespace mozilla {
namespace dom {
class IPCPaymentCanMakeActionResponse final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentCanMakeActionResponse();

    MOZ_IMPLICIT IPCPaymentCanMakeActionResponse(
            const nsString& _requestId,
            const bool& _result)
    {
        Init();
        Assign(_requestId, _result);
    }

    MOZ_IMPLICIT IPCPaymentCanMakeActionResponse(const IPCPaymentCanMakeActionResponse& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).result());
    }

    ~IPCPaymentCanMakeActionResponse();

    void
    operator=(const IPCPaymentCanMakeActionResponse& _o)
    {
        Assign((_o).requestId(), (_o).result());
    }

    bool
    operator==(const IPCPaymentCanMakeActionResponse& _o) const;

    bool
    operator!=(const IPCPaymentCanMakeActionResponse& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    bool&
    result()
    {
        return result_;
    }
    const bool&
    result() const
    {
        return result_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const bool& _result);

    nsString requestId_;
    bool result_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentShowActionResponse|
//
namespace mozilla {
namespace dom {
class IPCPaymentShowActionResponse final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentShowActionResponse();

    MOZ_IMPLICIT IPCPaymentShowActionResponse(
            const nsString& _requestId,
            const bool& _isAccepted,
            const nsString& _methodName,
            const nsString& _data,
            const nsString& _payerName,
            const nsString& _payerEmail,
            const nsString& _payerPhone)
    {
        Init();
        Assign(_requestId, _isAccepted, _methodName, _data, _payerName, _payerEmail, _payerPhone);
    }

    MOZ_IMPLICIT IPCPaymentShowActionResponse(const IPCPaymentShowActionResponse& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).isAccepted(), (_o).methodName(), (_o).data(), (_o).payerName(), (_o).payerEmail(), (_o).payerPhone());
    }

    ~IPCPaymentShowActionResponse();

    void
    operator=(const IPCPaymentShowActionResponse& _o)
    {
        Assign((_o).requestId(), (_o).isAccepted(), (_o).methodName(), (_o).data(), (_o).payerName(), (_o).payerEmail(), (_o).payerPhone());
    }

    bool
    operator==(const IPCPaymentShowActionResponse& _o) const;

    bool
    operator!=(const IPCPaymentShowActionResponse& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    bool&
    isAccepted()
    {
        return isAccepted_;
    }
    const bool&
    isAccepted() const
    {
        return isAccepted_;
    }

    nsString&
    methodName()
    {
        return methodName_;
    }
    const nsString&
    methodName() const
    {
        return methodName_;
    }

    nsString&
    data()
    {
        return data_;
    }
    const nsString&
    data() const
    {
        return data_;
    }

    nsString&
    payerName()
    {
        return payerName_;
    }
    const nsString&
    payerName() const
    {
        return payerName_;
    }

    nsString&
    payerEmail()
    {
        return payerEmail_;
    }
    const nsString&
    payerEmail() const
    {
        return payerEmail_;
    }

    nsString&
    payerPhone()
    {
        return payerPhone_;
    }
    const nsString&
    payerPhone() const
    {
        return payerPhone_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const bool& _isAccepted,
            const nsString& _methodName,
            const nsString& _data,
            const nsString& _payerName,
            const nsString& _payerEmail,
            const nsString& _payerPhone);

    nsString requestId_;
    bool isAccepted_;
    nsString methodName_;
    nsString data_;
    nsString payerName_;
    nsString payerEmail_;
    nsString payerPhone_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentAbortActionResponse|
//
namespace mozilla {
namespace dom {
class IPCPaymentAbortActionResponse final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentAbortActionResponse();

    MOZ_IMPLICIT IPCPaymentAbortActionResponse(
            const nsString& _requestId,
            const bool& _isSucceeded)
    {
        Init();
        Assign(_requestId, _isSucceeded);
    }

    MOZ_IMPLICIT IPCPaymentAbortActionResponse(const IPCPaymentAbortActionResponse& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).isSucceeded());
    }

    ~IPCPaymentAbortActionResponse();

    void
    operator=(const IPCPaymentAbortActionResponse& _o)
    {
        Assign((_o).requestId(), (_o).isSucceeded());
    }

    bool
    operator==(const IPCPaymentAbortActionResponse& _o) const;

    bool
    operator!=(const IPCPaymentAbortActionResponse& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    bool&
    isSucceeded()
    {
        return isSucceeded_;
    }
    const bool&
    isSucceeded() const
    {
        return isSucceeded_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const bool& _isSucceeded);

    nsString requestId_;
    bool isSucceeded_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentCompleteActionResponse|
//
namespace mozilla {
namespace dom {
class IPCPaymentCompleteActionResponse final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentCompleteActionResponse();

    MOZ_IMPLICIT IPCPaymentCompleteActionResponse(
            const nsString& _requestId,
            const bool& _isCompleted)
    {
        Init();
        Assign(_requestId, _isCompleted);
    }

    MOZ_IMPLICIT IPCPaymentCompleteActionResponse(const IPCPaymentCompleteActionResponse& _o)
    {
        Init();
        Assign((_o).requestId(), (_o).isCompleted());
    }

    ~IPCPaymentCompleteActionResponse();

    void
    operator=(const IPCPaymentCompleteActionResponse& _o)
    {
        Assign((_o).requestId(), (_o).isCompleted());
    }

    bool
    operator==(const IPCPaymentCompleteActionResponse& _o) const;

    bool
    operator!=(const IPCPaymentCompleteActionResponse& _o) const;

    nsString&
    requestId()
    {
        return requestId_;
    }
    const nsString&
    requestId() const
    {
        return requestId_;
    }

    bool&
    isCompleted()
    {
        return isCompleted_;
    }
    const bool&
    isCompleted() const
    {
        return isCompleted_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _requestId,
            const bool& _isCompleted);

    nsString requestId_;
    bool isCompleted_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCPaymentCanMakeActionResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentShowActionResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentAbortActionResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class IPCPaymentCompleteActionResponse;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCPaymentActionResponse|
//
namespace mozilla {
namespace dom {
class IPCPaymentActionResponse final
{
public:
    enum Type {
        T__None,
        TIPCPaymentCanMakeActionResponse = 1,
        TIPCPaymentShowActionResponse,
        TIPCPaymentAbortActionResponse,
        TIPCPaymentCompleteActionResponse,
        T__Last = TIPCPaymentCompleteActionResponse
    };

private:
    typedef mozilla::dom::IPCPaymentCanMakeActionResponse IPCPaymentCanMakeActionResponse;
    typedef mozilla::dom::IPCPaymentShowActionResponse IPCPaymentShowActionResponse;
    typedef mozilla::dom::IPCPaymentAbortActionResponse IPCPaymentAbortActionResponse;
    typedef mozilla::dom::IPCPaymentCompleteActionResponse IPCPaymentCompleteActionResponse;
    typedef IPCPaymentCanMakeActionResponse IPCPaymentCanMakeActionResponse__tdef;
    typedef IPCPaymentShowActionResponse IPCPaymentShowActionResponse__tdef;
    typedef IPCPaymentAbortActionResponse IPCPaymentAbortActionResponse__tdef;
    typedef IPCPaymentCompleteActionResponse IPCPaymentCompleteActionResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCPaymentCanMakeActionResponse> VIPCPaymentCanMakeActionResponse;
        mozilla::AlignedStorage2<IPCPaymentShowActionResponse> VIPCPaymentShowActionResponse;
        mozilla::AlignedStorage2<IPCPaymentAbortActionResponse> VIPCPaymentAbortActionResponse;
        mozilla::AlignedStorage2<IPCPaymentCompleteActionResponse> VIPCPaymentCompleteActionResponse;
    };

    IPCPaymentCanMakeActionResponse*
    ptr_IPCPaymentCanMakeActionResponse()
    {
        return ((mValue).VIPCPaymentCanMakeActionResponse).addr();
    }
    const IPCPaymentCanMakeActionResponse*
    constptr_IPCPaymentCanMakeActionResponse() const
    {
        return ((mValue).VIPCPaymentCanMakeActionResponse).addr();
    }
    IPCPaymentShowActionResponse*
    ptr_IPCPaymentShowActionResponse()
    {
        return ((mValue).VIPCPaymentShowActionResponse).addr();
    }
    const IPCPaymentShowActionResponse*
    constptr_IPCPaymentShowActionResponse() const
    {
        return ((mValue).VIPCPaymentShowActionResponse).addr();
    }
    IPCPaymentAbortActionResponse*
    ptr_IPCPaymentAbortActionResponse()
    {
        return ((mValue).VIPCPaymentAbortActionResponse).addr();
    }
    const IPCPaymentAbortActionResponse*
    constptr_IPCPaymentAbortActionResponse() const
    {
        return ((mValue).VIPCPaymentAbortActionResponse).addr();
    }
    IPCPaymentCompleteActionResponse*
    ptr_IPCPaymentCompleteActionResponse()
    {
        return ((mValue).VIPCPaymentCompleteActionResponse).addr();
    }
    const IPCPaymentCompleteActionResponse*
    constptr_IPCPaymentCompleteActionResponse() const
    {
        return ((mValue).VIPCPaymentCompleteActionResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCPaymentActionResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCPaymentActionResponse(const IPCPaymentCanMakeActionResponse& aOther);

    MOZ_IMPLICIT IPCPaymentActionResponse(const IPCPaymentShowActionResponse& aOther);

    MOZ_IMPLICIT IPCPaymentActionResponse(const IPCPaymentAbortActionResponse& aOther);

    MOZ_IMPLICIT IPCPaymentActionResponse(const IPCPaymentCompleteActionResponse& aOther);

    MOZ_IMPLICIT IPCPaymentActionResponse(const IPCPaymentActionResponse& aOther);

    ~IPCPaymentActionResponse();

    Type
    type() const
    {
        return mType;
    }

    IPCPaymentActionResponse&
    operator=(const IPCPaymentCanMakeActionResponse& aRhs);

    IPCPaymentActionResponse&
    operator=(const IPCPaymentShowActionResponse& aRhs);

    IPCPaymentActionResponse&
    operator=(const IPCPaymentAbortActionResponse& aRhs);

    IPCPaymentActionResponse&
    operator=(const IPCPaymentCompleteActionResponse& aRhs);

    IPCPaymentActionResponse&
    operator=(const IPCPaymentActionResponse& aRhs);

    bool
    operator==(const IPCPaymentCanMakeActionResponse& aRhs) const;

    bool
    operator==(const IPCPaymentShowActionResponse& aRhs) const;

    bool
    operator==(const IPCPaymentAbortActionResponse& aRhs) const;

    bool
    operator==(const IPCPaymentCompleteActionResponse& aRhs) const;

    bool
    operator==(const IPCPaymentActionResponse& aRhs) const;

    IPCPaymentCanMakeActionResponse&
    get_IPCPaymentCanMakeActionResponse()
    {
        AssertSanity(TIPCPaymentCanMakeActionResponse);
        return (*(ptr_IPCPaymentCanMakeActionResponse()));
    }
    const IPCPaymentCanMakeActionResponse&
    get_IPCPaymentCanMakeActionResponse() const
    {
        AssertSanity(TIPCPaymentCanMakeActionResponse);
        return (*(constptr_IPCPaymentCanMakeActionResponse()));
    }
    void
    get(IPCPaymentCanMakeActionResponse* aOutValue) const;
    operator IPCPaymentCanMakeActionResponse&()
    {
        return get_IPCPaymentCanMakeActionResponse();
    }
    operator const IPCPaymentCanMakeActionResponse&() const
    {
        return get_IPCPaymentCanMakeActionResponse();
    }

    IPCPaymentShowActionResponse&
    get_IPCPaymentShowActionResponse()
    {
        AssertSanity(TIPCPaymentShowActionResponse);
        return (*(ptr_IPCPaymentShowActionResponse()));
    }
    const IPCPaymentShowActionResponse&
    get_IPCPaymentShowActionResponse() const
    {
        AssertSanity(TIPCPaymentShowActionResponse);
        return (*(constptr_IPCPaymentShowActionResponse()));
    }
    void
    get(IPCPaymentShowActionResponse* aOutValue) const;
    operator IPCPaymentShowActionResponse&()
    {
        return get_IPCPaymentShowActionResponse();
    }
    operator const IPCPaymentShowActionResponse&() const
    {
        return get_IPCPaymentShowActionResponse();
    }

    IPCPaymentAbortActionResponse&
    get_IPCPaymentAbortActionResponse()
    {
        AssertSanity(TIPCPaymentAbortActionResponse);
        return (*(ptr_IPCPaymentAbortActionResponse()));
    }
    const IPCPaymentAbortActionResponse&
    get_IPCPaymentAbortActionResponse() const
    {
        AssertSanity(TIPCPaymentAbortActionResponse);
        return (*(constptr_IPCPaymentAbortActionResponse()));
    }
    void
    get(IPCPaymentAbortActionResponse* aOutValue) const;
    operator IPCPaymentAbortActionResponse&()
    {
        return get_IPCPaymentAbortActionResponse();
    }
    operator const IPCPaymentAbortActionResponse&() const
    {
        return get_IPCPaymentAbortActionResponse();
    }

    IPCPaymentCompleteActionResponse&
    get_IPCPaymentCompleteActionResponse()
    {
        AssertSanity(TIPCPaymentCompleteActionResponse);
        return (*(ptr_IPCPaymentCompleteActionResponse()));
    }
    const IPCPaymentCompleteActionResponse&
    get_IPCPaymentCompleteActionResponse() const
    {
        AssertSanity(TIPCPaymentCompleteActionResponse);
        return (*(constptr_IPCPaymentCompleteActionResponse()));
    }
    void
    get(IPCPaymentCompleteActionResponse* aOutValue) const;
    operator IPCPaymentCompleteActionResponse&()
    {
        return get_IPCPaymentCompleteActionResponse();
    }
    operator const IPCPaymentCompleteActionResponse&() const
    {
        return get_IPCPaymentCompleteActionResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPaymentAddress|
//
namespace mozilla {
namespace dom {
class IPCPaymentAddress final
{
private:

public:
    MOZ_IMPLICIT IPCPaymentAddress();

    MOZ_IMPLICIT IPCPaymentAddress(
            const nsString& _country,
            const nsTArray<nsString>& _addressLine,
            const nsString& _region,
            const nsString& _city,
            const nsString& _dependentLocality,
            const nsString& _postalCode,
            const nsString& _sortingCode,
            const nsString& _languageCode,
            const nsString& _organization,
            const nsString& _recipient,
            const nsString& _phone)
    {
        Init();
        Assign(_country, _addressLine, _region, _city, _dependentLocality, _postalCode, _sortingCode, _languageCode, _organization, _recipient, _phone);
    }

    MOZ_IMPLICIT IPCPaymentAddress(const IPCPaymentAddress& _o)
    {
        Init();
        Assign((_o).country(), (_o).addressLine(), (_o).region(), (_o).city(), (_o).dependentLocality(), (_o).postalCode(), (_o).sortingCode(), (_o).languageCode(), (_o).organization(), (_o).recipient(), (_o).phone());
    }

    ~IPCPaymentAddress();

    void
    operator=(const IPCPaymentAddress& _o)
    {
        Assign((_o).country(), (_o).addressLine(), (_o).region(), (_o).city(), (_o).dependentLocality(), (_o).postalCode(), (_o).sortingCode(), (_o).languageCode(), (_o).organization(), (_o).recipient(), (_o).phone());
    }

    bool
    operator==(const IPCPaymentAddress& _o) const;

    bool
    operator!=(const IPCPaymentAddress& _o) const;

    nsString&
    country()
    {
        return country_;
    }
    const nsString&
    country() const
    {
        return country_;
    }

    nsTArray<nsString>&
    addressLine()
    {
        return addressLine_;
    }
    const nsTArray<nsString>&
    addressLine() const
    {
        return addressLine_;
    }

    nsString&
    region()
    {
        return region_;
    }
    const nsString&
    region() const
    {
        return region_;
    }

    nsString&
    city()
    {
        return city_;
    }
    const nsString&
    city() const
    {
        return city_;
    }

    nsString&
    dependentLocality()
    {
        return dependentLocality_;
    }
    const nsString&
    dependentLocality() const
    {
        return dependentLocality_;
    }

    nsString&
    postalCode()
    {
        return postalCode_;
    }
    const nsString&
    postalCode() const
    {
        return postalCode_;
    }

    nsString&
    sortingCode()
    {
        return sortingCode_;
    }
    const nsString&
    sortingCode() const
    {
        return sortingCode_;
    }

    nsString&
    languageCode()
    {
        return languageCode_;
    }
    const nsString&
    languageCode() const
    {
        return languageCode_;
    }

    nsString&
    organization()
    {
        return organization_;
    }
    const nsString&
    organization() const
    {
        return organization_;
    }

    nsString&
    recipient()
    {
        return recipient_;
    }
    const nsString&
    recipient() const
    {
        return recipient_;
    }

    nsString&
    phone()
    {
        return phone_;
    }
    const nsString&
    phone() const
    {
        return phone_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _country,
            const nsTArray<nsString>& _addressLine,
            const nsString& _region,
            const nsString& _city,
            const nsString& _dependentLocality,
            const nsString& _postalCode,
            const nsString& _sortingCode,
            const nsString& _languageCode,
            const nsString& _organization,
            const nsString& _recipient,
            const nsString& _phone);

    nsString country_;
    nsTArray<nsString> addressLine_;
    nsString region_;
    nsString city_;
    nsString dependentLocality_;
    nsString postalCode_;
    nsString sortingCode_;
    nsString languageCode_;
    nsString organization_;
    nsString recipient_;
    nsString phone_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPaymentRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PPaymentRequestChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PPaymentRequestChild and PPaymentRequestParent
//
namespace mozilla {
namespace dom {
namespace PPaymentRequest {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PPaymentRequestParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PPaymentRequestChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PPaymentRequestStart = PPaymentRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_RequestPayment__ID,
    Msg_RespondPayment__ID,
    Msg_ChangeShippingAddress__ID,
    Msg_ChangeShippingOption__ID,
    PPaymentRequestEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_RequestPayment(int32_t routingId);

IPC::Message*
Msg_RespondPayment(int32_t routingId);

IPC::Message*
Msg_ChangeShippingAddress(int32_t routingId);

IPC::Message*
Msg_ChangeShippingOption(int32_t routingId);



} // namespace PPaymentRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PPaymentRequest_h
