//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPaymentRequestParent_h
#define PPaymentRequestParent_h

#include "mozilla/dom/PPaymentRequest.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace IPC {
class Principal;
} // namespace IPC

namespace mozilla {
namespace dom {


class PPaymentRequestParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PBrowserParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::IPCPaymentAbortActionRequest IPCPaymentAbortActionRequest;
    typedef mozilla::dom::IPCPaymentAbortActionResponse IPCPaymentAbortActionResponse;
    typedef mozilla::dom::IPCPaymentActionRequest IPCPaymentActionRequest;
    typedef mozilla::dom::IPCPaymentActionResponse IPCPaymentActionResponse;
    typedef mozilla::dom::IPCPaymentAddress IPCPaymentAddress;
    typedef mozilla::dom::IPCPaymentCanMakeActionRequest IPCPaymentCanMakeActionRequest;
    typedef mozilla::dom::IPCPaymentCanMakeActionResponse IPCPaymentCanMakeActionResponse;
    typedef mozilla::dom::IPCPaymentCompleteActionRequest IPCPaymentCompleteActionRequest;
    typedef mozilla::dom::IPCPaymentCompleteActionResponse IPCPaymentCompleteActionResponse;
    typedef mozilla::dom::IPCPaymentCreateActionRequest IPCPaymentCreateActionRequest;
    typedef mozilla::dom::IPCPaymentCurrencyAmount IPCPaymentCurrencyAmount;
    typedef mozilla::dom::IPCPaymentDetails IPCPaymentDetails;
    typedef mozilla::dom::IPCPaymentDetailsModifier IPCPaymentDetailsModifier;
    typedef mozilla::dom::IPCPaymentItem IPCPaymentItem;
    typedef mozilla::dom::IPCPaymentMethodData IPCPaymentMethodData;
    typedef mozilla::dom::IPCPaymentOptions IPCPaymentOptions;
    typedef mozilla::dom::IPCPaymentShippingOption IPCPaymentShippingOption;
    typedef mozilla::dom::IPCPaymentShowActionRequest IPCPaymentShowActionRequest;
    typedef mozilla::dom::IPCPaymentShowActionResponse IPCPaymentShowActionResponse;
    typedef mozilla::dom::IPCPaymentUpdateActionRequest IPCPaymentUpdateActionRequest;
    typedef IPC::Principal Principal;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;

    typedef PPaymentRequest::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvRequestPayment(const IPCPaymentActionRequest& aAction) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PPaymentRequestParent();

    virtual ~PPaymentRequestParent();

    PBrowserParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendRespondPayment(const IPCPaymentActionResponse& aResponse);

    MOZ_MUST_USE bool
    SendChangeShippingAddress(
            const nsString& aRequestId,
            const IPCPaymentAddress& aAddress);

    MOZ_MUST_USE bool
    SendChangeShippingOption(
            const nsString& aRequestId,
            const nsString& aOption);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<IPCPaymentDetailsModifier>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<IPCPaymentDetailsModifier>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentDetails& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentDetails* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<IPCPaymentItem>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<IPCPaymentItem>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentItem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentItem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentAbortActionResponse& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentAbortActionResponse* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<IPCPaymentMethodData>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<IPCPaymentMethodData>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentCanMakeActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentCanMakeActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentUpdateActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentUpdateActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PPaymentRequestParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPaymentRequestParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const IPCPaymentShowActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentShowActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentAbortActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentAbortActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentCreateActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentCreateActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentCompleteActionRequest& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentCompleteActionRequest* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<IPCPaymentShippingOption>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<IPCPaymentShippingOption>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentShowActionResponse& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentShowActionResponse* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentDetailsModifier& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentDetailsModifier* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentAddress& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentAddress* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentCompleteActionResponse& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentCompleteActionResponse* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentMethodData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentMethodData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentShippingOption& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentShippingOption* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentOptions& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentOptions* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentCurrencyAmount& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentCurrencyAmount* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentActionResponse& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentActionResponse* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const IPCPaymentCanMakeActionResponse& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            IPCPaymentCanMakeActionResponse* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class PaymentRequestParent :
    public PPaymentRequestParent
{
    virtual mozilla::ipc::IPCResult
    RecvRequestPayment(const IPCPaymentActionRequest& aAction);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT PaymentRequestParent();
    virtual ~PaymentRequestParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
PaymentRequestParent::RecvRequestPayment(const IPCPaymentActionRequest& aAction)
{
}

void
PaymentRequestParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT PaymentRequestParent::PaymentRequestParent()
{
    MOZ_COUNT_CTOR(PaymentRequestParent);
}

MOZ_IMPLICIT PaymentRequestParent::~PaymentRequestParent()
{
    MOZ_COUNT_DTOR(PaymentRequestParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PPaymentRequestParent_h
