//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransaction_h
#define PWebAuthnTransaction_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnScopedCredentialDescriptor|
//
namespace mozilla {
namespace dom {
class WebAuthnScopedCredentialDescriptor final
{
private:

public:
    MOZ_IMPLICIT WebAuthnScopedCredentialDescriptor();

    MOZ_IMPLICIT WebAuthnScopedCredentialDescriptor(const nsTArray<uint8_t>& _id)
    {
        Init();
        Assign(_id);
    }

    MOZ_IMPLICIT WebAuthnScopedCredentialDescriptor(const WebAuthnScopedCredentialDescriptor& _o)
    {
        Init();
        Assign((_o).id());
    }

    ~WebAuthnScopedCredentialDescriptor();

    void
    operator=(const WebAuthnScopedCredentialDescriptor& _o)
    {
        Assign((_o).id());
    }

    bool
    operator==(const WebAuthnScopedCredentialDescriptor& _o) const;

    bool
    operator!=(const WebAuthnScopedCredentialDescriptor& _o) const;

    nsTArray<uint8_t>&
    id()
    {
        return id_;
    }
    const nsTArray<uint8_t>&
    id() const
    {
        return id_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<uint8_t>& _id);

    nsTArray<uint8_t> id_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnExtension|
//
namespace mozilla {
namespace dom {
class WebAuthnExtension final
{
private:

public:
    MOZ_IMPLICIT WebAuthnExtension()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT WebAuthnExtension(const WebAuthnExtension& _o)
    {
        Init();
        Assign();
    }

    ~WebAuthnExtension();

    void
    operator=(const WebAuthnExtension& _o)
    {
        Assign();
    }

    bool
    operator==(const WebAuthnExtension& _o) const;

    bool
    operator!=(const WebAuthnExtension& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class WebAuthnScopedCredentialDescriptor;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class WebAuthnExtension;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnTransactionInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnTransactionInfo final
{
private:
    typedef mozilla::dom::WebAuthnScopedCredentialDescriptor WebAuthnScopedCredentialDescriptor;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;

public:
    MOZ_IMPLICIT WebAuthnTransactionInfo();

    MOZ_IMPLICIT WebAuthnTransactionInfo(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _ClientDataHash,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredentialDescriptor>& _Descriptors,
            const nsTArray<WebAuthnExtension>& _Extensions)
    {
        Init();
        Assign(_RpIdHash, _ClientDataHash, _TimeoutMS, _Descriptors, _Extensions);
    }

    MOZ_IMPLICIT WebAuthnTransactionInfo(const WebAuthnTransactionInfo& _o)
    {
        Init();
        Assign((_o).RpIdHash(), (_o).ClientDataHash(), (_o).TimeoutMS(), (_o).Descriptors(), (_o).Extensions());
    }

    ~WebAuthnTransactionInfo();

    void
    operator=(const WebAuthnTransactionInfo& _o)
    {
        Assign((_o).RpIdHash(), (_o).ClientDataHash(), (_o).TimeoutMS(), (_o).Descriptors(), (_o).Extensions());
    }

    bool
    operator==(const WebAuthnTransactionInfo& _o) const;

    bool
    operator!=(const WebAuthnTransactionInfo& _o) const;

    nsTArray<uint8_t>&
    RpIdHash()
    {
        return RpIdHash_;
    }
    const nsTArray<uint8_t>&
    RpIdHash() const
    {
        return RpIdHash_;
    }

    nsTArray<uint8_t>&
    ClientDataHash()
    {
        return ClientDataHash_;
    }
    const nsTArray<uint8_t>&
    ClientDataHash() const
    {
        return ClientDataHash_;
    }

    uint32_t&
    TimeoutMS()
    {
        return TimeoutMS_;
    }
    const uint32_t&
    TimeoutMS() const
    {
        return TimeoutMS_;
    }

    nsTArray<WebAuthnScopedCredentialDescriptor>&
    Descriptors()
    {
        return Descriptors_;
    }
    const nsTArray<WebAuthnScopedCredentialDescriptor>&
    Descriptors() const
    {
        return Descriptors_;
    }

    nsTArray<WebAuthnExtension>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtension>&
    Extensions() const
    {
        return Extensions_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _RpIdHash,
            const nsTArray<uint8_t>& _ClientDataHash,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredentialDescriptor>& _Descriptors,
            const nsTArray<WebAuthnExtension>& _Extensions);

    nsTArray<uint8_t> RpIdHash_;
    nsTArray<uint8_t> ClientDataHash_;
    uint32_t TimeoutMS_;
    nsTArray<WebAuthnScopedCredentialDescriptor> Descriptors_;
    nsTArray<WebAuthnExtension> Extensions_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PWebAuthnTransactionParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PWebAuthnTransactionChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PWebAuthnTransactionChild and PWebAuthnTransactionParent
//
namespace mozilla {
namespace dom {
namespace PWebAuthnTransaction {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PWebAuthnTransactionParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PWebAuthnTransactionChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PWebAuthnTransactionStart = PWebAuthnTransactionMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_RequestRegister__ID,
    Msg_RequestSign__ID,
    Msg_RequestCancel__ID,
    Msg_ConfirmRegister__ID,
    Msg_ConfirmSign__ID,
    Msg_Cancel__ID,
    PWebAuthnTransactionEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_RequestRegister(int32_t routingId);

IPC::Message*
Msg_RequestSign(int32_t routingId);

IPC::Message*
Msg_RequestCancel(int32_t routingId);

IPC::Message*
Msg_ConfirmRegister(int32_t routingId);

IPC::Message*
Msg_ConfirmSign(int32_t routingId);

IPC::Message*
Msg_Cancel(int32_t routingId);



} // namespace PWebAuthnTransaction
} // namespace dom
} // namespace mozilla

#endif // ifndef PWebAuthnTransaction_h
