//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransactionChild_h
#define PWebAuthnTransactionChild_h

#include "mozilla/dom/PWebAuthnTransaction.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebAuthnTransactionChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef mozilla::dom::WebAuthnScopedCredentialDescriptor WebAuthnScopedCredentialDescriptor;
    typedef mozilla::dom::WebAuthnTransactionInfo WebAuthnTransactionInfo;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;

    typedef PWebAuthnTransaction::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvConfirmRegister(nsTArray<uint8_t>&& RegBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    RecvConfirmSign(
            nsTArray<uint8_t>&& CredentialID,
            nsTArray<uint8_t>&& ReplyBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCancel(const nsresult& Error) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebAuthnTransactionChild();

    virtual ~PWebAuthnTransactionChild();

    PBackgroundChild*
    Manager() const;

    static bool
    Send__delete__(PWebAuthnTransactionChild* actor);

    bool
    SendRequestRegister(const WebAuthnTransactionInfo& aTransactionInfo);

    bool
    SendRequestSign(const WebAuthnTransactionInfo& aTransactionInfo);

    bool
    SendRequestCancel();

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<WebAuthnExtension>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<WebAuthnExtension>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PWebAuthnTransactionChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PWebAuthnTransactionChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const WebAuthnExtension& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnExtension* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnScopedCredentialDescriptor& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnScopedCredentialDescriptor* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WebAuthnTransactionInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WebAuthnTransactionInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<WebAuthnScopedCredentialDescriptor>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<WebAuthnScopedCredentialDescriptor>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class WebAuthnTransactionChild :
    public PWebAuthnTransactionChild
{
    virtual mozilla::ipc::IPCResult
    RecvConfirmRegister(nsTArray<uint8_t>&& RegBuffer);

    virtual mozilla::ipc::IPCResult
    RecvConfirmSign(
            nsTArray<uint8_t>&& CredentialID,
            nsTArray<uint8_t>&& ReplyBuffer);

    virtual mozilla::ipc::IPCResult
    RecvCancel(const nsresult& Error);

    MOZ_IMPLICIT WebAuthnTransactionChild();
    virtual ~WebAuthnTransactionChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
WebAuthnTransactionChild::RecvConfirmRegister(nsTArray<uint8_t>&& RegBuffer)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionChild::RecvConfirmSign(
        nsTArray<uint8_t>&& CredentialID,
        nsTArray<uint8_t>&& ReplyBuffer)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionChild::RecvCancel(const nsresult& Error)
{
}

MOZ_IMPLICIT WebAuthnTransactionChild::WebAuthnTransactionChild()
{
    MOZ_COUNT_CTOR(WebAuthnTransactionChild);
}

MOZ_IMPLICIT WebAuthnTransactionChild::~WebAuthnTransactionChild()
{
    MOZ_COUNT_DTOR(WebAuthnTransactionChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebAuthnTransactionChild_h
