//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPrintingParent_h
#define PPrintingParent_h

#include "mozilla/embedding/PPrinting.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintProgressDialogParent;
} // namespace embedding
} // namespace mozilla
namespace mozilla {
namespace embedding {
class PPrintProgressDialogChild;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintSettingsDialogParent;
} // namespace embedding
} // namespace mozilla
namespace mozilla {
namespace embedding {
class PPrintSettingsDialogChild;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace layout {
class PRemotePrintJobParent;
} // namespace layout
} // namespace mozilla
namespace mozilla {
namespace layout {
class PRemotePrintJobChild;
} // namespace layout
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintSettingsDialogParent;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace layout {
class PRemotePrintJobParent;
} // namespace layout
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintProgressDialogParent;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace embedding {


class PPrintingParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentParent;
    friend class mozilla::embedding::PPrintSettingsDialogParent;
    friend class mozilla::layout::PRemotePrintJobParent;
    friend class mozilla::embedding::PPrintProgressDialogParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::embedding::CStringKeyValue CStringKeyValue;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::embedding::PrintData PrintData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::embedding::PPrintProgressDialogParent PPrintProgressDialogParent;
    typedef mozilla::embedding::PPrintProgressDialogChild PPrintProgressDialogChild;
    typedef mozilla::embedding::PPrintSettingsDialogParent PPrintSettingsDialogParent;
    typedef mozilla::embedding::PPrintSettingsDialogChild PPrintSettingsDialogChild;
    typedef mozilla::layout::PRemotePrintJobParent PRemotePrintJobParent;
    typedef mozilla::layout::PRemotePrintJobChild PRemotePrintJobChild;

    typedef PPrinting::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvShowProgress(
            PBrowserParent* browser,
            PPrintProgressDialogParent* printProgressDialog,
            PRemotePrintJobParent* remotePrintJob,
            const bool& isForPrinting) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShowPrintDialog(
            PPrintSettingsDialogParent* dialog,
            PBrowserParent* browser,
            const PrintData& settings) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPPrintProgressDialogConstructor(PPrintProgressDialogParent* actor);
    virtual mozilla::ipc::IPCResult
    RecvPPrintSettingsDialogConstructor(PPrintSettingsDialogParent* actor);
    virtual mozilla::ipc::IPCResult
    RecvSavePrintSettings(
            const PrintData& settings,
            const bool& usePrinterNamePrefix,
            const uint32_t& flags,
            nsresult* rv) = 0;
    virtual PPrintProgressDialogParent*
    AllocPPrintProgressDialogParent() = 0;
    virtual bool
    DeallocPPrintProgressDialogParent(PPrintProgressDialogParent* aActor) = 0;
    virtual PPrintSettingsDialogParent*
    AllocPPrintSettingsDialogParent() = 0;
    virtual bool
    DeallocPPrintSettingsDialogParent(PPrintSettingsDialogParent* aActor) = 0;
    virtual PRemotePrintJobParent*
    AllocPRemotePrintJobParent() = 0;
    virtual bool
    DeallocPRemotePrintJobParent(PRemotePrintJobParent* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PPrintingParent();

    virtual ~PPrintingParent();

    PContentParent*
    Manager() const;

    void
    ManagedPPrintProgressDialogParent(nsTArray<PPrintProgressDialogParent*>& aArr) const;
    const ManagedContainer<PPrintProgressDialogParent>&
    ManagedPPrintProgressDialogParent() const;

    void
    ManagedPPrintSettingsDialogParent(nsTArray<PPrintSettingsDialogParent*>& aArr) const;
    const ManagedContainer<PPrintSettingsDialogParent>&
    ManagedPPrintSettingsDialogParent() const;

    void
    ManagedPRemotePrintJobParent(nsTArray<PRemotePrintJobParent*>& aArr) const;
    const ManagedContainer<PRemotePrintJobParent>&
    ManagedPRemotePrintJobParent() const;

    MOZ_MUST_USE PRemotePrintJobParent*
    SendPRemotePrintJobConstructor();

    MOZ_MUST_USE PRemotePrintJobParent*
    SendPRemotePrintJobConstructor(PRemotePrintJobParent* actor);

    MOZ_MUST_USE static bool
    Send__delete__(PPrintingParent* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const CStringKeyValue& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            CStringKeyValue* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PrintData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            PrintData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PBrowserParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PBrowserParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const PPrintingParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPrintingParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const PPrintProgressDialogParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPrintProgressDialogParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const nsTArray<CStringKeyValue>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<CStringKeyValue>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PPrintSettingsDialogParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PPrintSettingsDialogParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const PRemotePrintJobParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PRemotePrintJobParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
    ManagedContainer<PPrintProgressDialogParent> mManagedPPrintProgressDialogParent;
    ManagedContainer<PPrintSettingsDialogParent> mManagedPPrintSettingsDialogParent;
    ManagedContainer<PRemotePrintJobParent> mManagedPRemotePrintJobParent;
};


} // namespace embedding
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace embedding {
class PrintingParent :
    public PPrintingParent
{
    virtual mozilla::ipc::IPCResult
    RecvShowProgress(
            PBrowserParent* browser,
            PPrintProgressDialogParent* printProgressDialog,
            PRemotePrintJobParent* remotePrintJob,
            const bool& isForPrinting);

    virtual mozilla::ipc::IPCResult
    RecvShowPrintDialog(
            PPrintSettingsDialogParent* dialog,
            PBrowserParent* browser,
            const PrintData& settings);

    virtual mozilla::ipc::IPCResult
    RecvSavePrintSettings(
            const PrintData& settings,
            const bool& usePrinterNamePrefix,
            const uint32_t& flags,
            nsresult* rv);

    virtual PPrintProgressDialogParent*
    AllocPPrintProgressDialogParent();

    virtual bool
    DeallocPPrintProgressDialogParent(PPrintProgressDialogParent* aActor);

    virtual PPrintSettingsDialogParent*
    AllocPPrintSettingsDialogParent();

    virtual bool
    DeallocPPrintSettingsDialogParent(PPrintSettingsDialogParent* aActor);

    virtual PRemotePrintJobParent*
    AllocPRemotePrintJobParent();

    virtual bool
    DeallocPRemotePrintJobParent(PRemotePrintJobParent* aActor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT PrintingParent();
    virtual ~PrintingParent();
};
} // namespace embedding
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace embedding {
mozilla::ipc::IPCResult
PrintingParent::RecvShowProgress(
        PBrowserParent* browser,
        PPrintProgressDialogParent* printProgressDialog,
        PRemotePrintJobParent* remotePrintJob,
        const bool& isForPrinting)
{
}

mozilla::ipc::IPCResult
PrintingParent::RecvShowPrintDialog(
        PPrintSettingsDialogParent* dialog,
        PBrowserParent* browser,
        const PrintData& settings)
{
}

mozilla::ipc::IPCResult
PrintingParent::RecvSavePrintSettings(
        const PrintData& settings,
        const bool& usePrinterNamePrefix,
        const uint32_t& flags,
        nsresult* rv)
{
}

PPrintProgressDialogParent*
PrintingParent::AllocPPrintProgressDialogParent()
{
    return 0;
}

bool
PrintingParent::DeallocPPrintProgressDialogParent(PPrintProgressDialogParent* aActor)
{
    return false;
}

PPrintSettingsDialogParent*
PrintingParent::AllocPPrintSettingsDialogParent()
{
    return 0;
}

bool
PrintingParent::DeallocPPrintSettingsDialogParent(PPrintSettingsDialogParent* aActor)
{
    return false;
}

PRemotePrintJobParent*
PrintingParent::AllocPRemotePrintJobParent()
{
    return 0;
}

bool
PrintingParent::DeallocPRemotePrintJobParent(PRemotePrintJobParent* aActor)
{
    return false;
}

void
PrintingParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT PrintingParent::PrintingParent()
{
    MOZ_COUNT_CTOR(PrintingParent);
}

MOZ_IMPLICIT PrintingParent::~PrintingParent()
{
    MOZ_COUNT_DTOR(PrintingParent);
}

} // namespace embedding
} // namespace mozilla
#endif // if 0

#endif // ifndef PPrintingParent_h
