//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef GraphicsMessages_h
#define GraphicsMessages_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "gfxTelemetry.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/D3DMessageUtils.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/gfx/Types.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct D3D11DeviceStatus|
//
namespace mozilla {
namespace gfx {
class D3D11DeviceStatus final
{
private:

public:
    MOZ_IMPLICIT D3D11DeviceStatus();

    MOZ_IMPLICIT D3D11DeviceStatus(
            const bool& _isWARP,
            const bool& _textureSharingWorks,
            const uint32_t& _featureLevel,
            const DxgiAdapterDesc& _adapter,
            const int32_t& _sequenceNumber,
            const bool& _useNV12)
    {
        Init();
        Assign(_isWARP, _textureSharingWorks, _featureLevel, _adapter, _sequenceNumber, _useNV12);
    }

    MOZ_IMPLICIT D3D11DeviceStatus(const D3D11DeviceStatus& _o)
    {
        Init();
        Assign((_o).isWARP(), (_o).textureSharingWorks(), (_o).featureLevel(), (_o).adapter(), (_o).sequenceNumber(), (_o).useNV12());
    }

    ~D3D11DeviceStatus();

    void
    operator=(const D3D11DeviceStatus& _o)
    {
        Assign((_o).isWARP(), (_o).textureSharingWorks(), (_o).featureLevel(), (_o).adapter(), (_o).sequenceNumber(), (_o).useNV12());
    }

    bool
    operator==(const D3D11DeviceStatus& _o) const;

    bool
    operator!=(const D3D11DeviceStatus& _o) const;

    bool&
    isWARP()
    {
        return isWARP_;
    }
    const bool&
    isWARP() const
    {
        return isWARP_;
    }

    bool&
    textureSharingWorks()
    {
        return textureSharingWorks_;
    }
    const bool&
    textureSharingWorks() const
    {
        return textureSharingWorks_;
    }

    uint32_t&
    featureLevel()
    {
        return featureLevel_;
    }
    const uint32_t&
    featureLevel() const
    {
        return featureLevel_;
    }

    DxgiAdapterDesc&
    adapter()
    {
        return adapter_;
    }
    const DxgiAdapterDesc&
    adapter() const
    {
        return adapter_;
    }

    int32_t&
    sequenceNumber()
    {
        return sequenceNumber_;
    }
    const int32_t&
    sequenceNumber() const
    {
        return sequenceNumber_;
    }

    bool&
    useNV12()
    {
        return useNV12_;
    }
    const bool&
    useNV12() const
    {
        return useNV12_;
    }

private:
    void
    Init();

    void
    Assign(
            const bool& _isWARP,
            const bool& _textureSharingWorks,
            const uint32_t& _featureLevel,
            const DxgiAdapterDesc& _adapter,
            const int32_t& _sequenceNumber,
            const bool& _useNV12);

    bool isWARP_;
    bool textureSharingWorks_;
    uint32_t featureLevel_;
    DxgiAdapterDesc adapter_;
    int32_t sequenceNumber_;
    bool useNV12_;
};
} // namespace gfx
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DevicePrefs|
//
namespace mozilla {
namespace gfx {
class DevicePrefs final
{
private:
    typedef mozilla::gfx::FeatureStatus FeatureStatus;

public:
    MOZ_IMPLICIT DevicePrefs();

    MOZ_IMPLICIT DevicePrefs(
            const FeatureStatus& _hwCompositing,
            const FeatureStatus& _d3d11Compositing,
            const FeatureStatus& _oglCompositing,
            const FeatureStatus& _advancedLayers,
            const FeatureStatus& _useD2D1)
    {
        Init();
        Assign(_hwCompositing, _d3d11Compositing, _oglCompositing, _advancedLayers, _useD2D1);
    }

    MOZ_IMPLICIT DevicePrefs(const DevicePrefs& _o)
    {
        Init();
        Assign((_o).hwCompositing(), (_o).d3d11Compositing(), (_o).oglCompositing(), (_o).advancedLayers(), (_o).useD2D1());
    }

    ~DevicePrefs();

    void
    operator=(const DevicePrefs& _o)
    {
        Assign((_o).hwCompositing(), (_o).d3d11Compositing(), (_o).oglCompositing(), (_o).advancedLayers(), (_o).useD2D1());
    }

    bool
    operator==(const DevicePrefs& _o) const;

    bool
    operator!=(const DevicePrefs& _o) const;

    FeatureStatus&
    hwCompositing()
    {
        return hwCompositing_;
    }
    const FeatureStatus&
    hwCompositing() const
    {
        return hwCompositing_;
    }

    FeatureStatus&
    d3d11Compositing()
    {
        return d3d11Compositing_;
    }
    const FeatureStatus&
    d3d11Compositing() const
    {
        return d3d11Compositing_;
    }

    FeatureStatus&
    oglCompositing()
    {
        return oglCompositing_;
    }
    const FeatureStatus&
    oglCompositing() const
    {
        return oglCompositing_;
    }

    FeatureStatus&
    advancedLayers()
    {
        return advancedLayers_;
    }
    const FeatureStatus&
    advancedLayers() const
    {
        return advancedLayers_;
    }

    FeatureStatus&
    useD2D1()
    {
        return useD2D1_;
    }
    const FeatureStatus&
    useD2D1() const
    {
        return useD2D1_;
    }

private:
    void
    Init();

    void
    Assign(
            const FeatureStatus& _hwCompositing,
            const FeatureStatus& _d3d11Compositing,
            const FeatureStatus& _oglCompositing,
            const FeatureStatus& _advancedLayers,
            const FeatureStatus& _useD2D1);

    FeatureStatus hwCompositing_;
    FeatureStatus d3d11Compositing_;
    FeatureStatus oglCompositing_;
    FeatureStatus advancedLayers_;
    FeatureStatus useD2D1_;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class DevicePrefs;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class D3D11DeviceStatus;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ContentDeviceData|
//
namespace mozilla {
namespace gfx {
class ContentDeviceData final
{
private:
    typedef mozilla::gfx::DevicePrefs DevicePrefs;
    typedef mozilla::gfx::D3D11DeviceStatus D3D11DeviceStatus;

public:
    MOZ_IMPLICIT ContentDeviceData();

    MOZ_IMPLICIT ContentDeviceData(
            const DevicePrefs& _prefs,
            const D3D11DeviceStatus& _d3d11)
    {
        Init();
        Assign(_prefs, _d3d11);
    }

    MOZ_IMPLICIT ContentDeviceData(const ContentDeviceData& _o)
    {
        Init();
        Assign((_o).prefs(), (_o).d3d11());
    }

    ~ContentDeviceData();

    void
    operator=(const ContentDeviceData& _o)
    {
        Assign((_o).prefs(), (_o).d3d11());
    }

    bool
    operator==(const ContentDeviceData& _o) const;

    bool
    operator!=(const ContentDeviceData& _o) const;

    DevicePrefs&
    prefs()
    {
        return prefs_;
    }
    const DevicePrefs&
    prefs() const
    {
        return prefs_;
    }

    D3D11DeviceStatus&
    d3d11()
    {
        return d3d11_;
    }
    const D3D11DeviceStatus&
    d3d11() const
    {
        return d3d11_;
    }

private:
    void
    Init();

    void
    Assign(
            const DevicePrefs& _prefs,
            const D3D11DeviceStatus& _d3d11);

    DevicePrefs prefs_;
    D3D11DeviceStatus d3d11_;
};
} // namespace gfx
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FeatureFailure|
//
namespace mozilla {
namespace gfx {
class FeatureFailure final
{
private:
    typedef mozilla::gfx::FeatureStatus FeatureStatus;

public:
    MOZ_IMPLICIT FeatureFailure();

    MOZ_IMPLICIT FeatureFailure(
            const FeatureStatus& _status,
            const nsCString& _message,
            const nsCString& _failureId)
    {
        Init();
        Assign(_status, _message, _failureId);
    }

    MOZ_IMPLICIT FeatureFailure(const FeatureFailure& _o)
    {
        Init();
        Assign((_o).status(), (_o).message(), (_o).failureId());
    }

    ~FeatureFailure();

    void
    operator=(const FeatureFailure& _o)
    {
        Assign((_o).status(), (_o).message(), (_o).failureId());
    }

    bool
    operator==(const FeatureFailure& _o) const;

    bool
    operator!=(const FeatureFailure& _o) const;

    FeatureStatus&
    status()
    {
        return status_;
    }
    const FeatureStatus&
    status() const
    {
        return status_;
    }

    nsCString&
    message()
    {
        return message_;
    }
    const nsCString&
    message() const
    {
        return message_;
    }

    nsCString&
    failureId()
    {
        return failureId_;
    }
    const nsCString&
    failureId() const
    {
        return failureId_;
    }

private:
    void
    Init();

    void
    Assign(
            const FeatureStatus& _status,
            const nsCString& _message,
            const nsCString& _failureId);

    FeatureStatus status_;
    nsCString message_;
    nsCString failureId_;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class FeatureFailure;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FeatureChange|
//
namespace mozilla {
namespace gfx {
class FeatureChange final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TFeatureFailure,
        T__Last = TFeatureFailure
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::gfx::FeatureFailure FeatureFailure;
    typedef null_t null_t__tdef;
    typedef FeatureFailure FeatureFailure__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<FeatureFailure> VFeatureFailure;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    FeatureFailure*
    ptr_FeatureFailure()
    {
        return ((mValue).VFeatureFailure).addr();
    }
    const FeatureFailure*
    constptr_FeatureFailure() const
    {
        return ((mValue).VFeatureFailure).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FeatureChange() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FeatureChange(const null_t& aOther);

    MOZ_IMPLICIT FeatureChange(const FeatureFailure& aOther);

    MOZ_IMPLICIT FeatureChange(const FeatureChange& aOther);

    ~FeatureChange();

    Type
    type() const
    {
        return mType;
    }

    FeatureChange&
    operator=(const null_t& aRhs);

    FeatureChange&
    operator=(const FeatureFailure& aRhs);

    FeatureChange&
    operator=(const FeatureChange& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const FeatureFailure& aRhs) const;

    bool
    operator==(const FeatureChange& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    FeatureFailure&
    get_FeatureFailure()
    {
        AssertSanity(TFeatureFailure);
        return (*(ptr_FeatureFailure()));
    }
    const FeatureFailure&
    get_FeatureFailure() const
    {
        AssertSanity(TFeatureFailure);
        return (*(constptr_FeatureFailure()));
    }
    void
    get(FeatureFailure* aOutValue) const;
    operator FeatureFailure&()
    {
        return get_FeatureFailure();
    }
    operator const FeatureFailure&() const
    {
        return get_FeatureFailure();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class D3D11DeviceStatus;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union GPUDeviceStatus|
//
namespace mozilla {
namespace gfx {
class GPUDeviceStatus final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TD3D11DeviceStatus,
        T__Last = TD3D11DeviceStatus
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::gfx::D3D11DeviceStatus D3D11DeviceStatus;
    typedef null_t null_t__tdef;
    typedef D3D11DeviceStatus D3D11DeviceStatus__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<D3D11DeviceStatus> VD3D11DeviceStatus;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    D3D11DeviceStatus*
    ptr_D3D11DeviceStatus()
    {
        return ((mValue).VD3D11DeviceStatus).addr();
    }
    const D3D11DeviceStatus*
    constptr_D3D11DeviceStatus() const
    {
        return ((mValue).VD3D11DeviceStatus).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT GPUDeviceStatus() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT GPUDeviceStatus(const null_t& aOther);

    MOZ_IMPLICIT GPUDeviceStatus(const D3D11DeviceStatus& aOther);

    MOZ_IMPLICIT GPUDeviceStatus(const GPUDeviceStatus& aOther);

    ~GPUDeviceStatus();

    Type
    type() const
    {
        return mType;
    }

    GPUDeviceStatus&
    operator=(const null_t& aRhs);

    GPUDeviceStatus&
    operator=(const D3D11DeviceStatus& aRhs);

    GPUDeviceStatus&
    operator=(const GPUDeviceStatus& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const D3D11DeviceStatus& aRhs) const;

    bool
    operator==(const GPUDeviceStatus& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    D3D11DeviceStatus&
    get_D3D11DeviceStatus()
    {
        AssertSanity(TD3D11DeviceStatus);
        return (*(ptr_D3D11DeviceStatus()));
    }
    const D3D11DeviceStatus&
    get_D3D11DeviceStatus() const
    {
        AssertSanity(TD3D11DeviceStatus);
        return (*(constptr_D3D11DeviceStatus()));
    }
    void
    get(D3D11DeviceStatus* aOutValue) const;
    operator D3D11DeviceStatus&()
    {
        return get_D3D11DeviceStatus();
    }
    operator const D3D11DeviceStatus&() const
    {
        return get_D3D11DeviceStatus();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class FeatureChange;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class GPUDeviceStatus;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GPUDeviceData|
//
namespace mozilla {
namespace gfx {
class GPUDeviceData final
{
private:
    typedef mozilla::gfx::FeatureChange FeatureChange;
    typedef mozilla::gfx::GPUDeviceStatus GPUDeviceStatus;

public:
    MOZ_IMPLICIT GPUDeviceData();

    MOZ_IMPLICIT GPUDeviceData(
            const FeatureChange& _d3d11Compositing,
            const FeatureChange& _oglCompositing,
            const FeatureChange& _advancedLayers,
            const GPUDeviceStatus& _gpuDevice)
    {
        Init();
        Assign(_d3d11Compositing, _oglCompositing, _advancedLayers, _gpuDevice);
    }

    MOZ_IMPLICIT GPUDeviceData(const GPUDeviceData& _o)
    {
        Init();
        Assign((_o).d3d11Compositing(), (_o).oglCompositing(), (_o).advancedLayers(), (_o).gpuDevice());
    }

    ~GPUDeviceData();

    void
    operator=(const GPUDeviceData& _o)
    {
        Assign((_o).d3d11Compositing(), (_o).oglCompositing(), (_o).advancedLayers(), (_o).gpuDevice());
    }

    bool
    operator==(const GPUDeviceData& _o) const;

    bool
    operator!=(const GPUDeviceData& _o) const;

    FeatureChange&
    d3d11Compositing()
    {
        return d3d11Compositing_;
    }
    const FeatureChange&
    d3d11Compositing() const
    {
        return d3d11Compositing_;
    }

    FeatureChange&
    oglCompositing()
    {
        return oglCompositing_;
    }
    const FeatureChange&
    oglCompositing() const
    {
        return oglCompositing_;
    }

    FeatureChange&
    advancedLayers()
    {
        return advancedLayers_;
    }
    const FeatureChange&
    advancedLayers() const
    {
        return advancedLayers_;
    }

    GPUDeviceStatus&
    gpuDevice()
    {
        return gpuDevice_;
    }
    const GPUDeviceStatus&
    gpuDevice() const
    {
        return gpuDevice_;
    }

private:
    void
    Init();

    void
    Assign(
            const FeatureChange& _d3d11Compositing,
            const FeatureChange& _oglCompositing,
            const FeatureChange& _advancedLayers,
            const GPUDeviceStatus& _gpuDevice);

    FeatureChange d3d11Compositing_;
    FeatureChange oglCompositing_;
    FeatureChange advancedLayers_;
    GPUDeviceStatus gpuDevice_;
};
} // namespace gfx
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union GfxVarValue|
//
namespace mozilla {
namespace gfx {
class GfxVarValue final
{
public:
    enum Type {
        T__None,
        TBackendType = 1,
        Tbool,
        TgfxImageFormat,
        TIntSize,
        TnsCString,
        Tint32_t,
        T__Last = Tint32_t
    };

private:
    typedef mozilla::gfx::BackendType BackendType;
    typedef mozilla::gfx::IntSize IntSize;
    typedef BackendType BackendType__tdef;
    typedef bool bool__tdef;
    typedef gfxImageFormat gfxImageFormat__tdef;
    typedef IntSize IntSize__tdef;
    typedef nsCString nsCString__tdef;
    typedef int32_t int32_t__tdef;

    union Value {
        mozilla::AlignedStorage2<BackendType> VBackendType;
        mozilla::AlignedStorage2<bool> Vbool;
        mozilla::AlignedStorage2<gfxImageFormat> VgfxImageFormat;
        mozilla::AlignedStorage2<IntSize> VIntSize;
        mozilla::AlignedStorage2<nsCString> VnsCString;
        mozilla::AlignedStorage2<int32_t> Vint32_t;
    };

    BackendType*
    ptr_BackendType()
    {
        return ((mValue).VBackendType).addr();
    }
    const BackendType*
    constptr_BackendType() const
    {
        return ((mValue).VBackendType).addr();
    }
    bool*
    ptr_bool()
    {
        return ((mValue).Vbool).addr();
    }
    const bool*
    constptr_bool() const
    {
        return ((mValue).Vbool).addr();
    }
    gfxImageFormat*
    ptr_gfxImageFormat()
    {
        return ((mValue).VgfxImageFormat).addr();
    }
    const gfxImageFormat*
    constptr_gfxImageFormat() const
    {
        return ((mValue).VgfxImageFormat).addr();
    }
    IntSize*
    ptr_IntSize()
    {
        return ((mValue).VIntSize).addr();
    }
    const IntSize*
    constptr_IntSize() const
    {
        return ((mValue).VIntSize).addr();
    }
    nsCString*
    ptr_nsCString()
    {
        return ((mValue).VnsCString).addr();
    }
    const nsCString*
    constptr_nsCString() const
    {
        return ((mValue).VnsCString).addr();
    }
    int32_t*
    ptr_int32_t()
    {
        return ((mValue).Vint32_t).addr();
    }
    const int32_t*
    constptr_int32_t() const
    {
        return ((mValue).Vint32_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT GfxVarValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT GfxVarValue(const BackendType& aOther);

    MOZ_IMPLICIT GfxVarValue(const bool& aOther);

    MOZ_IMPLICIT GfxVarValue(const gfxImageFormat& aOther);

    MOZ_IMPLICIT GfxVarValue(const IntSize& aOther);

    MOZ_IMPLICIT GfxVarValue(const nsCString& aOther);

    MOZ_IMPLICIT GfxVarValue(const int32_t& aOther);

    MOZ_IMPLICIT GfxVarValue(const GfxVarValue& aOther);

    ~GfxVarValue();

    Type
    type() const
    {
        return mType;
    }

    GfxVarValue&
    operator=(const BackendType& aRhs);

    GfxVarValue&
    operator=(const bool& aRhs);

    GfxVarValue&
    operator=(const gfxImageFormat& aRhs);

    GfxVarValue&
    operator=(const IntSize& aRhs);

    GfxVarValue&
    operator=(const nsCString& aRhs);

    GfxVarValue&
    operator=(const int32_t& aRhs);

    GfxVarValue&
    operator=(const GfxVarValue& aRhs);

    bool
    operator==(const BackendType& aRhs) const;

    bool
    operator==(const bool& aRhs) const;

    bool
    operator==(const gfxImageFormat& aRhs) const;

    bool
    operator==(const IntSize& aRhs) const;

    bool
    operator==(const nsCString& aRhs) const;

    bool
    operator==(const int32_t& aRhs) const;

    bool
    operator==(const GfxVarValue& aRhs) const;

    BackendType&
    get_BackendType()
    {
        AssertSanity(TBackendType);
        return (*(ptr_BackendType()));
    }
    const BackendType&
    get_BackendType() const
    {
        AssertSanity(TBackendType);
        return (*(constptr_BackendType()));
    }
    void
    get(BackendType* aOutValue) const;
    operator BackendType&()
    {
        return get_BackendType();
    }
    operator const BackendType&() const
    {
        return get_BackendType();
    }

    bool&
    get_bool()
    {
        AssertSanity(Tbool);
        return (*(ptr_bool()));
    }
    const bool&
    get_bool() const
    {
        AssertSanity(Tbool);
        return (*(constptr_bool()));
    }
    void
    get(bool* aOutValue) const;
    operator bool&()
    {
        return get_bool();
    }
    operator const bool&() const
    {
        return get_bool();
    }

    gfxImageFormat&
    get_gfxImageFormat()
    {
        AssertSanity(TgfxImageFormat);
        return (*(ptr_gfxImageFormat()));
    }
    const gfxImageFormat&
    get_gfxImageFormat() const
    {
        AssertSanity(TgfxImageFormat);
        return (*(constptr_gfxImageFormat()));
    }
    void
    get(gfxImageFormat* aOutValue) const;
    operator gfxImageFormat&()
    {
        return get_gfxImageFormat();
    }
    operator const gfxImageFormat&() const
    {
        return get_gfxImageFormat();
    }

    IntSize&
    get_IntSize()
    {
        AssertSanity(TIntSize);
        return (*(ptr_IntSize()));
    }
    const IntSize&
    get_IntSize() const
    {
        AssertSanity(TIntSize);
        return (*(constptr_IntSize()));
    }
    void
    get(IntSize* aOutValue) const;
    operator IntSize&()
    {
        return get_IntSize();
    }
    operator const IntSize&() const
    {
        return get_IntSize();
    }

    nsCString&
    get_nsCString()
    {
        AssertSanity(TnsCString);
        return (*(ptr_nsCString()));
    }
    const nsCString&
    get_nsCString() const
    {
        AssertSanity(TnsCString);
        return (*(constptr_nsCString()));
    }
    void
    get(nsCString* aOutValue) const;
    operator nsCString&()
    {
        return get_nsCString();
    }
    operator const nsCString&() const
    {
        return get_nsCString();
    }

    int32_t&
    get_int32_t()
    {
        AssertSanity(Tint32_t);
        return (*(ptr_int32_t()));
    }
    const int32_t&
    get_int32_t() const
    {
        AssertSanity(Tint32_t);
        return (*(constptr_int32_t()));
    }
    void
    get(int32_t* aOutValue) const;
    operator int32_t&()
    {
        return get_int32_t();
    }
    operator const int32_t&() const
    {
        return get_int32_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class GfxVarValue;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GfxVarUpdate|
//
namespace mozilla {
namespace gfx {
class GfxVarUpdate final
{
private:
    typedef mozilla::gfx::GfxVarValue GfxVarValue;

public:
    MOZ_IMPLICIT GfxVarUpdate();

    MOZ_IMPLICIT GfxVarUpdate(
            const size_t& _index,
            const GfxVarValue& _value)
    {
        Init();
        Assign(_index, _value);
    }

    MOZ_IMPLICIT GfxVarUpdate(const GfxVarUpdate& _o)
    {
        Init();
        Assign((_o).index(), (_o).value());
    }

    ~GfxVarUpdate();

    void
    operator=(const GfxVarUpdate& _o)
    {
        Assign((_o).index(), (_o).value());
    }

    bool
    operator==(const GfxVarUpdate& _o) const;

    bool
    operator!=(const GfxVarUpdate& _o) const;

    size_t&
    index()
    {
        return index_;
    }
    const size_t&
    index() const
    {
        return index_;
    }

    GfxVarValue&
    value()
    {
        return value_;
    }
    const GfxVarValue&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(
            const size_t& _index,
            const GfxVarValue& _value);

    size_t index_;
    GfxVarValue value_;
};
} // namespace gfx
} // namespace mozilla

#endif // ifndef GraphicsMessages_h
