//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef GMPTypes_h
#define GMPTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "gmp-video-codec.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NodeIdData|
//
namespace mozilla {
namespace gmp {
class NodeIdData final
{
private:

public:
    MOZ_IMPLICIT NodeIdData();

    MOZ_IMPLICIT NodeIdData(
            const nsString& _mOrigin,
            const nsString& _mTopLevelOrigin,
            const nsString& _mGMPName)
    {
        Init();
        Assign(_mOrigin, _mTopLevelOrigin, _mGMPName);
    }

    MOZ_IMPLICIT NodeIdData(const NodeIdData& _o)
    {
        Init();
        Assign((_o).mOrigin(), (_o).mTopLevelOrigin(), (_o).mGMPName());
    }

    ~NodeIdData();

    void
    operator=(const NodeIdData& _o)
    {
        Assign((_o).mOrigin(), (_o).mTopLevelOrigin(), (_o).mGMPName());
    }

    bool
    operator==(const NodeIdData& _o) const;

    bool
    operator!=(const NodeIdData& _o) const;

    nsString&
    mOrigin()
    {
        return mOrigin_;
    }
    const nsString&
    mOrigin() const
    {
        return mOrigin_;
    }

    nsString&
    mTopLevelOrigin()
    {
        return mTopLevelOrigin_;
    }
    const nsString&
    mTopLevelOrigin() const
    {
        return mTopLevelOrigin_;
    }

    nsString&
    mGMPName()
    {
        return mGMPName_;
    }
    const nsString&
    mGMPName() const
    {
        return mGMPName_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _mOrigin,
            const nsString& _mTopLevelOrigin,
            const nsString& _mGMPName);

    nsString mOrigin_;
    nsString mTopLevelOrigin_;
    nsString mGMPName_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPVideoEncodedFrameData|
//
namespace mozilla {
namespace gmp {
class GMPVideoEncodedFrameData final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT GMPVideoEncodedFrameData();

    MOZ_IMPLICIT GMPVideoEncodedFrameData(
            const uint32_t& _mEncodedWidth,
            const uint32_t& _mEncodedHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration,
            const uint32_t& _mFrameType,
            const uint32_t& _mSize,
            const GMPBufferType& _mBufferType,
            Shmem& _mBuffer,
            const bool& _mCompleteFrame)
    {
        Init();
        Assign(_mEncodedWidth, _mEncodedHeight, _mTimestamp, _mDuration, _mFrameType, _mSize, _mBufferType, _mBuffer, _mCompleteFrame);
    }

    MOZ_IMPLICIT GMPVideoEncodedFrameData(const GMPVideoEncodedFrameData& _o)
    {
        Init();
        Assign((_o).mEncodedWidth(), (_o).mEncodedHeight(), (_o).mTimestamp(), (_o).mDuration(), (_o).mFrameType(), (_o).mSize(), (_o).mBufferType(), (_o).mBuffer(), (_o).mCompleteFrame());
    }

    ~GMPVideoEncodedFrameData();

    void
    operator=(const GMPVideoEncodedFrameData& _o)
    {
        Assign((_o).mEncodedWidth(), (_o).mEncodedHeight(), (_o).mTimestamp(), (_o).mDuration(), (_o).mFrameType(), (_o).mSize(), (_o).mBufferType(), (_o).mBuffer(), (_o).mCompleteFrame());
    }

    bool
    operator==(const GMPVideoEncodedFrameData& _o) const;

    bool
    operator!=(const GMPVideoEncodedFrameData& _o) const;

    uint32_t&
    mEncodedWidth()
    {
        return mEncodedWidth_;
    }
    const uint32_t&
    mEncodedWidth() const
    {
        return mEncodedWidth_;
    }

    uint32_t&
    mEncodedHeight()
    {
        return mEncodedHeight_;
    }
    const uint32_t&
    mEncodedHeight() const
    {
        return mEncodedHeight_;
    }

    uint64_t&
    mTimestamp()
    {
        return mTimestamp_;
    }
    const uint64_t&
    mTimestamp() const
    {
        return mTimestamp_;
    }

    uint64_t&
    mDuration()
    {
        return mDuration_;
    }
    const uint64_t&
    mDuration() const
    {
        return mDuration_;
    }

    uint32_t&
    mFrameType()
    {
        return mFrameType_;
    }
    const uint32_t&
    mFrameType() const
    {
        return mFrameType_;
    }

    uint32_t&
    mSize()
    {
        return mSize_;
    }
    const uint32_t&
    mSize() const
    {
        return mSize_;
    }

    GMPBufferType&
    mBufferType()
    {
        return mBufferType_;
    }
    const GMPBufferType&
    mBufferType() const
    {
        return mBufferType_;
    }

    Shmem&
    mBuffer()
    {
        return mBuffer_;
    }
    Shmem&
    mBuffer() const
    {
        return const_cast<Shmem&>(mBuffer_);
    }

    bool&
    mCompleteFrame()
    {
        return mCompleteFrame_;
    }
    const bool&
    mCompleteFrame() const
    {
        return mCompleteFrame_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _mEncodedWidth,
            const uint32_t& _mEncodedHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration,
            const uint32_t& _mFrameType,
            const uint32_t& _mSize,
            const GMPBufferType& _mBufferType,
            Shmem& _mBuffer,
            const bool& _mCompleteFrame);

    uint32_t mEncodedWidth_;
    uint32_t mEncodedHeight_;
    uint64_t mTimestamp_;
    uint64_t mDuration_;
    uint32_t mFrameType_;
    uint32_t mSize_;
    GMPBufferType mBufferType_;
    Shmem mBuffer_;
    bool mCompleteFrame_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPPlaneData|
//
namespace mozilla {
namespace gmp {
class GMPPlaneData final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT GMPPlaneData();

    MOZ_IMPLICIT GMPPlaneData(
            const int32_t& _mSize,
            const int32_t& _mStride,
            Shmem& _mBuffer)
    {
        Init();
        Assign(_mSize, _mStride, _mBuffer);
    }

    MOZ_IMPLICIT GMPPlaneData(const GMPPlaneData& _o)
    {
        Init();
        Assign((_o).mSize(), (_o).mStride(), (_o).mBuffer());
    }

    ~GMPPlaneData();

    void
    operator=(const GMPPlaneData& _o)
    {
        Assign((_o).mSize(), (_o).mStride(), (_o).mBuffer());
    }

    bool
    operator==(const GMPPlaneData& _o) const;

    bool
    operator!=(const GMPPlaneData& _o) const;

    int32_t&
    mSize()
    {
        return mSize_;
    }
    const int32_t&
    mSize() const
    {
        return mSize_;
    }

    int32_t&
    mStride()
    {
        return mStride_;
    }
    const int32_t&
    mStride() const
    {
        return mStride_;
    }

    Shmem&
    mBuffer()
    {
        return mBuffer_;
    }
    Shmem&
    mBuffer() const
    {
        return const_cast<Shmem&>(mBuffer_);
    }

private:
    void
    Init();

    void
    Assign(
            const int32_t& _mSize,
            const int32_t& _mStride,
            Shmem& _mBuffer);

    int32_t mSize_;
    int32_t mStride_;
    Shmem mBuffer_;
};
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class GMPPlaneData;
} // namespace gmp
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GMPVideoi420FrameData|
//
namespace mozilla {
namespace gmp {
class GMPVideoi420FrameData final
{
private:
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;

public:
    MOZ_IMPLICIT GMPVideoi420FrameData();

    MOZ_IMPLICIT GMPVideoi420FrameData(
            const GMPPlaneData& _mYPlane,
            const GMPPlaneData& _mUPlane,
            const GMPPlaneData& _mVPlane,
            const int32_t& _mWidth,
            const int32_t& _mHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration)
    {
        Init();
        Assign(_mYPlane, _mUPlane, _mVPlane, _mWidth, _mHeight, _mTimestamp, _mDuration);
    }

    MOZ_IMPLICIT GMPVideoi420FrameData(const GMPVideoi420FrameData& _o)
    {
        Init();
        Assign((_o).mYPlane(), (_o).mUPlane(), (_o).mVPlane(), (_o).mWidth(), (_o).mHeight(), (_o).mTimestamp(), (_o).mDuration());
    }

    ~GMPVideoi420FrameData();

    void
    operator=(const GMPVideoi420FrameData& _o)
    {
        Assign((_o).mYPlane(), (_o).mUPlane(), (_o).mVPlane(), (_o).mWidth(), (_o).mHeight(), (_o).mTimestamp(), (_o).mDuration());
    }

    bool
    operator==(const GMPVideoi420FrameData& _o) const;

    bool
    operator!=(const GMPVideoi420FrameData& _o) const;

    GMPPlaneData&
    mYPlane()
    {
        return mYPlane_;
    }
    const GMPPlaneData&
    mYPlane() const
    {
        return mYPlane_;
    }

    GMPPlaneData&
    mUPlane()
    {
        return mUPlane_;
    }
    const GMPPlaneData&
    mUPlane() const
    {
        return mUPlane_;
    }

    GMPPlaneData&
    mVPlane()
    {
        return mVPlane_;
    }
    const GMPPlaneData&
    mVPlane() const
    {
        return mVPlane_;
    }

    int32_t&
    mWidth()
    {
        return mWidth_;
    }
    const int32_t&
    mWidth() const
    {
        return mWidth_;
    }

    int32_t&
    mHeight()
    {
        return mHeight_;
    }
    const int32_t&
    mHeight() const
    {
        return mHeight_;
    }

    uint64_t&
    mTimestamp()
    {
        return mTimestamp_;
    }
    const uint64_t&
    mTimestamp() const
    {
        return mTimestamp_;
    }

    uint64_t&
    mDuration()
    {
        return mDuration_;
    }
    const uint64_t&
    mDuration() const
    {
        return mDuration_;
    }

private:
    void
    Init();

    void
    Assign(
            const GMPPlaneData& _mYPlane,
            const GMPPlaneData& _mUPlane,
            const GMPPlaneData& _mVPlane,
            const int32_t& _mWidth,
            const int32_t& _mHeight,
            const uint64_t& _mTimestamp,
            const uint64_t& _mDuration);

    GMPPlaneData mYPlane_;
    GMPPlaneData mUPlane_;
    GMPPlaneData mVPlane_;
    int32_t mWidth_;
    int32_t mHeight_;
    uint64_t mTimestamp_;
    uint64_t mDuration_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CDMInputBuffer|
//
namespace mozilla {
namespace gmp {
class CDMInputBuffer final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT CDMInputBuffer();

    MOZ_IMPLICIT CDMInputBuffer(
            Shmem& _mData,
            const nsTArray<uint8_t>& _mKeyId,
            const nsTArray<uint8_t>& _mIV,
            const int64_t& _mTimestamp,
            const int64_t& _mDuration,
            const nsTArray<uint16_t>& _mClearBytes,
            const nsTArray<uint32_t>& _mCipherBytes,
            const bool& _mIsEncrypted)
    {
        Init();
        Assign(_mData, _mKeyId, _mIV, _mTimestamp, _mDuration, _mClearBytes, _mCipherBytes, _mIsEncrypted);
    }

    MOZ_IMPLICIT CDMInputBuffer(const CDMInputBuffer& _o)
    {
        Init();
        Assign((_o).mData(), (_o).mKeyId(), (_o).mIV(), (_o).mTimestamp(), (_o).mDuration(), (_o).mClearBytes(), (_o).mCipherBytes(), (_o).mIsEncrypted());
    }

    ~CDMInputBuffer();

    void
    operator=(const CDMInputBuffer& _o)
    {
        Assign((_o).mData(), (_o).mKeyId(), (_o).mIV(), (_o).mTimestamp(), (_o).mDuration(), (_o).mClearBytes(), (_o).mCipherBytes(), (_o).mIsEncrypted());
    }

    bool
    operator==(const CDMInputBuffer& _o) const;

    bool
    operator!=(const CDMInputBuffer& _o) const;

    Shmem&
    mData()
    {
        return mData_;
    }
    Shmem&
    mData() const
    {
        return const_cast<Shmem&>(mData_);
    }

    nsTArray<uint8_t>&
    mKeyId()
    {
        return mKeyId_;
    }
    const nsTArray<uint8_t>&
    mKeyId() const
    {
        return mKeyId_;
    }

    nsTArray<uint8_t>&
    mIV()
    {
        return mIV_;
    }
    const nsTArray<uint8_t>&
    mIV() const
    {
        return mIV_;
    }

    int64_t&
    mTimestamp()
    {
        return mTimestamp_;
    }
    const int64_t&
    mTimestamp() const
    {
        return mTimestamp_;
    }

    int64_t&
    mDuration()
    {
        return mDuration_;
    }
    const int64_t&
    mDuration() const
    {
        return mDuration_;
    }

    nsTArray<uint16_t>&
    mClearBytes()
    {
        return mClearBytes_;
    }
    const nsTArray<uint16_t>&
    mClearBytes() const
    {
        return mClearBytes_;
    }

    nsTArray<uint32_t>&
    mCipherBytes()
    {
        return mCipherBytes_;
    }
    const nsTArray<uint32_t>&
    mCipherBytes() const
    {
        return mCipherBytes_;
    }

    bool&
    mIsEncrypted()
    {
        return mIsEncrypted_;
    }
    const bool&
    mIsEncrypted() const
    {
        return mIsEncrypted_;
    }

private:
    void
    Init();

    void
    Assign(
            Shmem& _mData,
            const nsTArray<uint8_t>& _mKeyId,
            const nsTArray<uint8_t>& _mIV,
            const int64_t& _mTimestamp,
            const int64_t& _mDuration,
            const nsTArray<uint16_t>& _mClearBytes,
            const nsTArray<uint32_t>& _mCipherBytes,
            const bool& _mIsEncrypted);

    Shmem mData_;
    nsTArray<uint8_t> mKeyId_;
    nsTArray<uint8_t> mIV_;
    int64_t mTimestamp_;
    int64_t mDuration_;
    nsTArray<uint16_t> mClearBytes_;
    nsTArray<uint32_t> mCipherBytes_;
    bool mIsEncrypted_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CDMVideoDecoderConfig|
//
namespace mozilla {
namespace gmp {
class CDMVideoDecoderConfig final
{
private:

public:
    MOZ_IMPLICIT CDMVideoDecoderConfig();

    MOZ_IMPLICIT CDMVideoDecoderConfig(
            const uint32_t& _mCodec,
            const uint32_t& _mProfile,
            const uint32_t& _mFormat,
            const int32_t& _mImageWidth,
            const int32_t& _mImageHeight,
            const nsTArray<uint8_t>& _mExtraData)
    {
        Init();
        Assign(_mCodec, _mProfile, _mFormat, _mImageWidth, _mImageHeight, _mExtraData);
    }

    MOZ_IMPLICIT CDMVideoDecoderConfig(const CDMVideoDecoderConfig& _o)
    {
        Init();
        Assign((_o).mCodec(), (_o).mProfile(), (_o).mFormat(), (_o).mImageWidth(), (_o).mImageHeight(), (_o).mExtraData());
    }

    ~CDMVideoDecoderConfig();

    void
    operator=(const CDMVideoDecoderConfig& _o)
    {
        Assign((_o).mCodec(), (_o).mProfile(), (_o).mFormat(), (_o).mImageWidth(), (_o).mImageHeight(), (_o).mExtraData());
    }

    bool
    operator==(const CDMVideoDecoderConfig& _o) const;

    bool
    operator!=(const CDMVideoDecoderConfig& _o) const;

    uint32_t&
    mCodec()
    {
        return mCodec_;
    }
    const uint32_t&
    mCodec() const
    {
        return mCodec_;
    }

    uint32_t&
    mProfile()
    {
        return mProfile_;
    }
    const uint32_t&
    mProfile() const
    {
        return mProfile_;
    }

    uint32_t&
    mFormat()
    {
        return mFormat_;
    }
    const uint32_t&
    mFormat() const
    {
        return mFormat_;
    }

    int32_t&
    mImageWidth()
    {
        return mImageWidth_;
    }
    const int32_t&
    mImageWidth() const
    {
        return mImageWidth_;
    }

    int32_t&
    mImageHeight()
    {
        return mImageHeight_;
    }
    const int32_t&
    mImageHeight() const
    {
        return mImageHeight_;
    }

    nsTArray<uint8_t>&
    mExtraData()
    {
        return mExtraData_;
    }
    const nsTArray<uint8_t>&
    mExtraData() const
    {
        return mExtraData_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _mCodec,
            const uint32_t& _mProfile,
            const uint32_t& _mFormat,
            const int32_t& _mImageWidth,
            const int32_t& _mImageHeight,
            const nsTArray<uint8_t>& _mExtraData);

    uint32_t mCodec_;
    uint32_t mProfile_;
    uint32_t mFormat_;
    int32_t mImageWidth_;
    int32_t mImageHeight_;
    nsTArray<uint8_t> mExtraData_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CDMKeyInformation|
//
namespace mozilla {
namespace gmp {
class CDMKeyInformation final
{
private:

public:
    MOZ_IMPLICIT CDMKeyInformation();

    MOZ_IMPLICIT CDMKeyInformation(
            const nsTArray<uint8_t>& _mKeyId,
            const uint32_t& _mStatus,
            const uint32_t& _mSystemCode)
    {
        Init();
        Assign(_mKeyId, _mStatus, _mSystemCode);
    }

    MOZ_IMPLICIT CDMKeyInformation(const CDMKeyInformation& _o)
    {
        Init();
        Assign((_o).mKeyId(), (_o).mStatus(), (_o).mSystemCode());
    }

    ~CDMKeyInformation();

    void
    operator=(const CDMKeyInformation& _o)
    {
        Assign((_o).mKeyId(), (_o).mStatus(), (_o).mSystemCode());
    }

    bool
    operator==(const CDMKeyInformation& _o) const;

    bool
    operator!=(const CDMKeyInformation& _o) const;

    nsTArray<uint8_t>&
    mKeyId()
    {
        return mKeyId_;
    }
    const nsTArray<uint8_t>&
    mKeyId() const
    {
        return mKeyId_;
    }

    uint32_t&
    mStatus()
    {
        return mStatus_;
    }
    const uint32_t&
    mStatus() const
    {
        return mStatus_;
    }

    uint32_t&
    mSystemCode()
    {
        return mSystemCode_;
    }
    const uint32_t&
    mSystemCode() const
    {
        return mSystemCode_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _mKeyId,
            const uint32_t& _mStatus,
            const uint32_t& _mSystemCode);

    nsTArray<uint8_t> mKeyId_;
    uint32_t mStatus_;
    uint32_t mSystemCode_;
};
} // namespace gmp
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CDMVideoPlane|
//
namespace mozilla {
namespace gmp {
class CDMVideoPlane final
{
private:

public:
    MOZ_IMPLICIT CDMVideoPlane();

    MOZ_IMPLICIT CDMVideoPlane(
            const uint32_t& _mPlaneOffset,
            const uint32_t& _mStride)
    {
        Init();
        Assign(_mPlaneOffset, _mStride);
    }

    MOZ_IMPLICIT CDMVideoPlane(const CDMVideoPlane& _o)
    {
        Init();
        Assign((_o).mPlaneOffset(), (_o).mStride());
    }

    ~CDMVideoPlane();

    void
    operator=(const CDMVideoPlane& _o)
    {
        Assign((_o).mPlaneOffset(), (_o).mStride());
    }

    bool
    operator==(const CDMVideoPlane& _o) const;

    bool
    operator!=(const CDMVideoPlane& _o) const;

    uint32_t&
    mPlaneOffset()
    {
        return mPlaneOffset_;
    }
    const uint32_t&
    mPlaneOffset() const
    {
        return mPlaneOffset_;
    }

    uint32_t&
    mStride()
    {
        return mStride_;
    }
    const uint32_t&
    mStride() const
    {
        return mStride_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _mPlaneOffset,
            const uint32_t& _mStride);

    uint32_t mPlaneOffset_;
    uint32_t mStride_;
};
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class CDMVideoPlane;
} // namespace gmp
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CDMVideoFrame|
//
namespace mozilla {
namespace gmp {
class CDMVideoFrame final
{
private:
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;

public:
    MOZ_IMPLICIT CDMVideoFrame();

    MOZ_IMPLICIT CDMVideoFrame(
            const uint32_t& _mFormat,
            const int32_t& _mImageWidth,
            const int32_t& _mImageHeight,
            const CDMVideoPlane& _mYPlane,
            const CDMVideoPlane& _mUPlane,
            const CDMVideoPlane& _mVPlane,
            const int64_t& _mTimestamp,
            const int64_t& _mDuration)
    {
        Init();
        Assign(_mFormat, _mImageWidth, _mImageHeight, _mYPlane, _mUPlane, _mVPlane, _mTimestamp, _mDuration);
    }

    MOZ_IMPLICIT CDMVideoFrame(const CDMVideoFrame& _o)
    {
        Init();
        Assign((_o).mFormat(), (_o).mImageWidth(), (_o).mImageHeight(), (_o).mYPlane(), (_o).mUPlane(), (_o).mVPlane(), (_o).mTimestamp(), (_o).mDuration());
    }

    ~CDMVideoFrame();

    void
    operator=(const CDMVideoFrame& _o)
    {
        Assign((_o).mFormat(), (_o).mImageWidth(), (_o).mImageHeight(), (_o).mYPlane(), (_o).mUPlane(), (_o).mVPlane(), (_o).mTimestamp(), (_o).mDuration());
    }

    bool
    operator==(const CDMVideoFrame& _o) const;

    bool
    operator!=(const CDMVideoFrame& _o) const;

    uint32_t&
    mFormat()
    {
        return mFormat_;
    }
    const uint32_t&
    mFormat() const
    {
        return mFormat_;
    }

    int32_t&
    mImageWidth()
    {
        return mImageWidth_;
    }
    const int32_t&
    mImageWidth() const
    {
        return mImageWidth_;
    }

    int32_t&
    mImageHeight()
    {
        return mImageHeight_;
    }
    const int32_t&
    mImageHeight() const
    {
        return mImageHeight_;
    }

    CDMVideoPlane&
    mYPlane()
    {
        return mYPlane_;
    }
    const CDMVideoPlane&
    mYPlane() const
    {
        return mYPlane_;
    }

    CDMVideoPlane&
    mUPlane()
    {
        return mUPlane_;
    }
    const CDMVideoPlane&
    mUPlane() const
    {
        return mUPlane_;
    }

    CDMVideoPlane&
    mVPlane()
    {
        return mVPlane_;
    }
    const CDMVideoPlane&
    mVPlane() const
    {
        return mVPlane_;
    }

    int64_t&
    mTimestamp()
    {
        return mTimestamp_;
    }
    const int64_t&
    mTimestamp() const
    {
        return mTimestamp_;
    }

    int64_t&
    mDuration()
    {
        return mDuration_;
    }
    const int64_t&
    mDuration() const
    {
        return mDuration_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _mFormat,
            const int32_t& _mImageWidth,
            const int32_t& _mImageHeight,
            const CDMVideoPlane& _mYPlane,
            const CDMVideoPlane& _mUPlane,
            const CDMVideoPlane& _mVPlane,
            const int64_t& _mTimestamp,
            const int64_t& _mDuration);

    uint32_t mFormat_;
    int32_t mImageWidth_;
    int32_t mImageHeight_;
    CDMVideoPlane mYPlane_;
    CDMVideoPlane mUPlane_;
    CDMVideoPlane mVPlane_;
    int64_t mTimestamp_;
    int64_t mDuration_;
};
} // namespace gmp
} // namespace mozilla

#endif // ifndef GMPTypes_h
