//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPParent_h
#define PGMPParent_h

#include "mozilla/gmp/PGMP.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "mozilla/dom/TabMessageUtils.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPTimerParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPTimerChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPStorageParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPStorageChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPTimerParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPStorageParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
    friend class mozilla::gmp::PGMPTimerParent;
    friend class mozilla::gmp::PGMPStorageParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::NativeThreadId NativeThreadId;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPTimerParent PGMPTimerParent;
    typedef mozilla::gmp::PGMPTimerChild PGMPTimerChild;
    typedef mozilla::gmp::PGMPStorageParent PGMPStorageParent;
    typedef mozilla::gmp::PGMPStorageChild PGMPStorageChild;

    typedef PGMP::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvInitCrashReporter(
            Shmem&& shmem,
            const NativeThreadId& threadId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPGMPTimerConstructor(PGMPTimerParent* actor);
    virtual mozilla::ipc::IPCResult
    RecvPGMPStorageConstructor(PGMPStorageParent* actor);
    virtual mozilla::ipc::IPCResult
    RecvPGMPContentChildDestroyed() = 0;
    virtual PGMPTimerParent*
    AllocPGMPTimerParent() = 0;
    virtual bool
    DeallocPGMPTimerParent(PGMPTimerParent* aActor) = 0;
    virtual PGMPStorageParent*
    AllocPGMPStorageParent() = 0;
    virtual bool
    DeallocPGMPStorageParent(PGMPStorageParent* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPParent();

    virtual ~PGMPParent();

    void
    ManagedPGMPTimerParent(nsTArray<PGMPTimerParent*>& aArr) const;
    const ManagedContainer<PGMPTimerParent>&
    ManagedPGMPTimerParent() const;

    void
    ManagedPGMPStorageParent(nsTArray<PGMPStorageParent*>& aArr) const;
    const ManagedContainer<PGMPStorageParent>&
    ManagedPGMPStorageParent() const;

    MOZ_MUST_USE bool
    SendCrashPluginNow();

    MOZ_MUST_USE bool
    CallStartPlugin(const nsString& adapter);

    MOZ_MUST_USE bool
    SendProvideStorageId(const nsCString& storageId);

    MOZ_MUST_USE bool
    SendPreloadLibs(const nsCString& libs);

    MOZ_MUST_USE bool
    SendCloseActive();

    MOZ_MUST_USE bool
    SendInitGMPContentChild(const Endpoint<mozilla::gmp::PGMPContentChild>& endpoint);

    virtual MessageChannel*
    GetIPCChannel();
    virtual const MessageChannel*
    GetIPCChannel() const;
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    ProcessNativeEventsInInterruptCall();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPGMPParent();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PGMPTimerParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPTimerParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Shmem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PGMPStorageParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPStorageParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    Channel mChannel;
    State mState;
    ManagedContainer<PGMPTimerParent> mManagedPGMPTimerParent;
    ManagedContainer<PGMPStorageParent> mManagedPGMPStorageParent;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPParent :
    public PGMPParent
{
    virtual mozilla::ipc::IPCResult
    RecvInitCrashReporter(
            Shmem&& shmem,
            const NativeThreadId& threadId);

    virtual mozilla::ipc::IPCResult
    RecvPGMPContentChildDestroyed();

    virtual PGMPTimerParent*
    AllocPGMPTimerParent();

    virtual bool
    DeallocPGMPTimerParent(PGMPTimerParent* aActor);

    virtual PGMPStorageParent*
    AllocPGMPStorageParent();

    virtual bool
    DeallocPGMPStorageParent(PGMPStorageParent* aActor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPParent();
    virtual ~GMPParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPParent::RecvInitCrashReporter(
        Shmem&& shmem,
        const NativeThreadId& threadId)
{
}

mozilla::ipc::IPCResult
GMPParent::RecvPGMPContentChildDestroyed()
{
}

PGMPTimerParent*
GMPParent::AllocPGMPTimerParent()
{
    return 0;
}

bool
GMPParent::DeallocPGMPTimerParent(PGMPTimerParent* aActor)
{
    return false;
}

PGMPStorageParent*
GMPParent::AllocPGMPStorageParent()
{
    return 0;
}

bool
GMPParent::DeallocPGMPStorageParent(PGMPStorageParent* aActor)
{
    return false;
}

void
GMPParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPParent::GMPParent()
{
    MOZ_COUNT_CTOR(GMPParent);
}

MOZ_IMPLICIT GMPParent::~GMPParent()
{
    MOZ_COUNT_DTOR(GMPParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPParent_h
