//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPServiceChild_h
#define PGMPServiceChild_h

#include "mozilla/gmp/PGMPService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "base/process.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPServiceChild :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

    typedef PGMPService::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvBeginShutdown() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPServiceChild();

    virtual ~PGMPServiceChild();

    bool
    SendLaunchGMP(
            const nsCString& nodeId,
            const nsCString& api,
            const nsTArray<nsCString>& tags,
            const nsTArray<ProcessId>& alreadyBridgedTo,
            uint32_t* pluginId,
            ProcessId* id,
            nsCString* displayName,
            Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
            nsresult* aResult,
            nsCString* aErrorDescription);

    bool
    SendLaunchGMPForNodeId(
            const NodeIdData& nodeId,
            const nsCString& api,
            const nsTArray<nsCString>& tags,
            const nsTArray<ProcessId>& alreadyBridgedTo,
            uint32_t* pluginId,
            ProcessId* id,
            nsCString* displayName,
            Endpoint<mozilla::gmp::PGMPContentParent>* endpoint,
            nsresult* aResult,
            nsCString* aErrorDescription);

    bool
    SendGetGMPNodeId(
            const nsString& origin,
            const nsString& topLevelOrigin,
            const nsString& gmpName,
            nsCString* id);

    virtual MessageChannel*
    GetIPCChannel();
    virtual const MessageChannel*
    GetIPCChannel() const;
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

    void
    OnChannelClose();

    void
    OnChannelError();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPGMPServiceChild();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const NodeIdData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            NodeIdData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    Channel mChannel;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPServiceChild :
    public PGMPServiceChild
{
    virtual mozilla::ipc::IPCResult
    RecvBeginShutdown();

    MOZ_IMPLICIT GMPServiceChild();
    virtual ~GMPServiceChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPServiceChild::RecvBeginShutdown()
{
}

MOZ_IMPLICIT GMPServiceChild::GMPServiceChild()
{
    MOZ_COUNT_CTOR(GMPServiceChild);
}

MOZ_IMPLICIT GMPServiceChild::~GMPServiceChild()
{
    MOZ_COUNT_DTOR(GMPServiceChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPServiceChild_h
