//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPStorageParent_h
#define PGMPStorageParent_h

#include "mozilla/gmp/PGMPStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPStorageParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPParent PGMPParent;
    typedef mozilla::gmp::PGMPChild PGMPChild;

    typedef PGMPStorage::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpen(const nsCString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRead(const nsCString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    RecvWrite(
            const nsCString& aRecordName,
            nsTArray<uint8_t>&& aBytes) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClose(const nsCString& aRecordName) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPStorageParent();

    virtual ~PGMPStorageParent();

    PGMPParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    MOZ_MUST_USE bool
    SendReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            const nsTArray<uint8_t>& aBytes);

    MOZ_MUST_USE bool
    SendWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    MOZ_MUST_USE bool
    SendShutdown();

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PGMPStorageParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPStorageParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPStorageParent :
    public PGMPStorageParent
{
    virtual mozilla::ipc::IPCResult
    RecvOpen(const nsCString& aRecordName);

    virtual mozilla::ipc::IPCResult
    RecvRead(const nsCString& aRecordName);

    virtual mozilla::ipc::IPCResult
    RecvWrite(
            const nsCString& aRecordName,
            nsTArray<uint8_t>&& aBytes);

    virtual mozilla::ipc::IPCResult
    RecvClose(const nsCString& aRecordName);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPStorageParent();
    virtual ~GMPStorageParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPStorageParent::RecvOpen(const nsCString& aRecordName)
{
}

mozilla::ipc::IPCResult
GMPStorageParent::RecvRead(const nsCString& aRecordName)
{
}

mozilla::ipc::IPCResult
GMPStorageParent::RecvWrite(
        const nsCString& aRecordName,
        nsTArray<uint8_t>&& aBytes)
{
}

mozilla::ipc::IPCResult
GMPStorageParent::RecvClose(const nsCString& aRecordName)
{
}

void
GMPStorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPStorageParent::GMPStorageParent()
{
    MOZ_COUNT_CTOR(GMPStorageParent);
}

MOZ_IMPLICIT GMPStorageParent::~GMPStorageParent()
{
    MOZ_COUNT_DTOR(GMPStorageParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPStorageParent_h
