//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoDecoderParent_h
#define PGMPVideoDecoderParent_h

#include "mozilla/gmp/PGMPVideoDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoDecoderParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::gmp::NodeIdData NodeIdData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

    typedef PGMPVideoDecoder::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedFrame(const uint64_t& aPictureId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInputDataExhausted() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDrainComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvResetComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvError(const GMPErr& aErr) = 0;
    virtual mozilla::ipc::IPCResult
    RecvShutdown() = 0;
    virtual mozilla::ipc::IPCResult
    RecvParentShmemForPool(Shmem&& aEncodedBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    AnswerNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PGMPVideoDecoderParent();

    virtual ~PGMPVideoDecoderParent();

    PGMPContentParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendInitDecode(
            const GMPVideoCodec& aCodecSettings,
            const nsTArray<uint8_t>& aCodecSpecific,
            const int32_t& aCoreCount);

    MOZ_MUST_USE bool
    SendDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            const nsTArray<uint8_t>& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs);

    MOZ_MUST_USE bool
    SendReset();

    MOZ_MUST_USE bool
    SendDrain();

    MOZ_MUST_USE bool
    SendDecodingComplete();

    MOZ_MUST_USE bool
    SendChildShmemForPool(Shmem& aFrameBuffer);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPPlaneData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPPlaneData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPVideoi420FrameData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPVideoi420FrameData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Shmem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPVideoEncodedFrameData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPVideoEncodedFrameData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PGMPVideoDecoderParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPVideoDecoderParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoDecoderParent :
    public PGMPVideoDecoderParent
{
    virtual mozilla::ipc::IPCResult
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame);

    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId);

    virtual mozilla::ipc::IPCResult
    RecvReceivedDecodedFrame(const uint64_t& aPictureId);

    virtual mozilla::ipc::IPCResult
    RecvInputDataExhausted();

    virtual mozilla::ipc::IPCResult
    RecvDrainComplete();

    virtual mozilla::ipc::IPCResult
    RecvResetComplete();

    virtual mozilla::ipc::IPCResult
    RecvError(const GMPErr& aErr);

    virtual mozilla::ipc::IPCResult
    RecvShutdown();

    virtual mozilla::ipc::IPCResult
    RecvParentShmemForPool(Shmem&& aEncodedBuffer);

    virtual mozilla::ipc::IPCResult
    AnswerNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPVideoDecoderParent();
    virtual ~GMPVideoDecoderParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvReceivedDecodedFrame(const uint64_t& aPictureId)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvInputDataExhausted()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvDrainComplete()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvResetComplete()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvError(const GMPErr& aErr)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvShutdown()
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::RecvParentShmemForPool(Shmem&& aEncodedBuffer)
{
}

mozilla::ipc::IPCResult
GMPVideoDecoderParent::AnswerNeedShmem(
        const uint32_t& aFrameBufferSize,
        Shmem* aMem)
{
}

void
GMPVideoDecoderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPVideoDecoderParent::GMPVideoDecoderParent()
{
    MOZ_COUNT_CTOR(GMPVideoDecoderParent);
}

MOZ_IMPLICIT GMPVideoDecoderParent::~GMPVideoDecoderParent()
{
    MOZ_COUNT_DTOR(GMPVideoDecoderParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoDecoderParent_h
