//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalParent_h
#define PHalParent_h

#include "mozilla/hal_sandbox/PHal.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class PHalParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef base::ProcessId ProcessId;
    typedef mozilla::hal::ProcessPriority ProcessPriority;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::hal::ScreenConfiguration ScreenConfiguration;
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;

    typedef PHal::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvVibrate(
            nsTArray<uint32_t>&& pattern,
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCancelVibrate(
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableNetworkNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableNetworkNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableWakeLockNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableWakeLockNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableScreenConfigurationNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableScreenConfigurationNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUnlockScreenOrientation() = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableSensorNotifications(const SensorType& aSensor) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableSensorNotifications(const SensorType& aSensor) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PHalParent();

    virtual ~PHalParent();

    PContentParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendNotifyNetworkChange(const NetworkInformation& aNetworkInfo);

    MOZ_MUST_USE bool
    SendNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo);

    MOZ_MUST_USE bool
    SendNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation);

    MOZ_MUST_USE bool
    SendNotifySensorChange(const SensorData& aSensorData);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PBrowserParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PBrowserParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const ScreenConfiguration& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ScreenConfiguration* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WakeLockInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WakeLockInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const NetworkInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            NetworkInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const SensorData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SensorData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PHalParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PHalParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalParent :
    public PHalParent
{
    virtual mozilla::ipc::IPCResult
    RecvVibrate(
            nsTArray<uint32_t>&& pattern,
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser);

    virtual mozilla::ipc::IPCResult
    RecvCancelVibrate(
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser);

    virtual mozilla::ipc::IPCResult
    RecvEnableNetworkNotifications();

    virtual mozilla::ipc::IPCResult
    RecvDisableNetworkNotifications();

    virtual mozilla::ipc::IPCResult
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    virtual mozilla::ipc::IPCResult
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID);

    virtual mozilla::ipc::IPCResult
    RecvEnableWakeLockNotifications();

    virtual mozilla::ipc::IPCResult
    RecvDisableWakeLockNotifications();

    virtual mozilla::ipc::IPCResult
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    virtual mozilla::ipc::IPCResult
    RecvEnableScreenConfigurationNotifications();

    virtual mozilla::ipc::IPCResult
    RecvDisableScreenConfigurationNotifications();

    virtual mozilla::ipc::IPCResult
    RecvLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed);

    virtual mozilla::ipc::IPCResult
    RecvUnlockScreenOrientation();

    virtual mozilla::ipc::IPCResult
    RecvEnableSensorNotifications(const SensorType& aSensor);

    virtual mozilla::ipc::IPCResult
    RecvDisableSensorNotifications(const SensorType& aSensor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT HalParent();
    virtual ~HalParent();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
mozilla::ipc::IPCResult
HalParent::RecvVibrate(
        nsTArray<uint32_t>&& pattern,
        nsTArray<uint64_t>&& id,
        PBrowserParent* browser)
{
}

mozilla::ipc::IPCResult
HalParent::RecvCancelVibrate(
        nsTArray<uint64_t>&& id,
        PBrowserParent* browser)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableNetworkNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableNetworkNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo)
{
}

mozilla::ipc::IPCResult
HalParent::RecvModifyWakeLock(
        const nsString& aTopic,
        const WakeLockControl& aLockAdjust,
        const WakeLockControl& aHiddenAdjust,
        const uint64_t& aProcessID)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableWakeLockNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableWakeLockNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetWakeLockInfo(
        const nsString& aTopic,
        WakeLockInformation* aWakeLockInfo)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableScreenConfigurationNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableScreenConfigurationNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvLockScreenOrientation(
        const ScreenOrientationInternal& aOrientation,
        bool* allowed)
{
}

mozilla::ipc::IPCResult
HalParent::RecvUnlockScreenOrientation()
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableSensorNotifications(const SensorType& aSensor)
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableSensorNotifications(const SensorType& aSensor)
{
}

void
HalParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT HalParent::HalParent()
{
    MOZ_COUNT_CTOR(HalParent);
}

MOZ_IMPLICIT HalParent::~HalParent()
{
    MOZ_COUNT_DTOR(HalParent);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalParent_h
