//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef IPCStream_h
#define IPCStream_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/dom/BlobTypes.h"
#include "mozilla/ipc/InputStreamParams.h"
#include "mozilla/ipc/ProtocolTypes.h"

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace dom {
class OptionalFileDescriptorSet;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct InputStreamParamsWithFds|
//
namespace mozilla {
namespace ipc {
class InputStreamParamsWithFds final
{
private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::dom::OptionalFileDescriptorSet OptionalFileDescriptorSet;

public:
    MOZ_IMPLICIT InputStreamParamsWithFds();

    MOZ_IMPLICIT InputStreamParamsWithFds(
            const InputStreamParams& _stream,
            const OptionalFileDescriptorSet& _optionalFds)
    {
        Init();
        Assign(_stream, _optionalFds);
    }

    MOZ_IMPLICIT InputStreamParamsWithFds(const InputStreamParamsWithFds& _o)
    {
        Init();
        Assign((_o).stream(), (_o).optionalFds());
    }

    ~InputStreamParamsWithFds();

    void
    operator=(const InputStreamParamsWithFds& _o)
    {
        Assign((_o).stream(), (_o).optionalFds());
    }

    bool
    operator==(const InputStreamParamsWithFds& _o) const;

    bool
    operator!=(const InputStreamParamsWithFds& _o) const;

    InputStreamParams&
    stream()
    {
        return stream_;
    }
    const InputStreamParams&
    stream() const
    {
        return stream_;
    }

    OptionalFileDescriptorSet&
    optionalFds()
    {
        return optionalFds_;
    }
    const OptionalFileDescriptorSet&
    optionalFds() const
    {
        return optionalFds_;
    }

private:
    void
    Init();

    void
    Assign(
            const InputStreamParams& _stream,
            const OptionalFileDescriptorSet& _optionalFds);

    InputStreamParams stream_;
    OptionalFileDescriptorSet optionalFds_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PChildToParentStreamParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PChildToParentStreamChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PParentToChildStreamParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PParentToChildStreamChild;
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCRemoteStreamType|
//
namespace mozilla {
namespace ipc {
class IPCRemoteStreamType final
{
public:
    enum Type {
        T__None,
        TPChildToParentStreamParent = 1,
        TPChildToParentStreamChild,
        TPParentToChildStreamParent,
        TPParentToChildStreamChild,
        T__Last = TPParentToChildStreamChild
    };

private:
    typedef mozilla::ipc::PChildToParentStreamParent PChildToParentStreamParent;
    typedef mozilla::ipc::PChildToParentStreamChild PChildToParentStreamChild;
    typedef mozilla::ipc::PParentToChildStreamParent PParentToChildStreamParent;
    typedef mozilla::ipc::PParentToChildStreamChild PParentToChildStreamChild;
    typedef PChildToParentStreamParent* PChildToParentStreamParent__tdef;
    typedef PChildToParentStreamChild* PChildToParentStreamChild__tdef;
    typedef PParentToChildStreamParent* PParentToChildStreamParent__tdef;
    typedef PParentToChildStreamChild* PParentToChildStreamChild__tdef;

    union Value {
        mozilla::AlignedStorage2<PChildToParentStreamParent*> VPChildToParentStreamParent;
        mozilla::AlignedStorage2<PChildToParentStreamChild*> VPChildToParentStreamChild;
        mozilla::AlignedStorage2<PParentToChildStreamParent*> VPParentToChildStreamParent;
        mozilla::AlignedStorage2<PParentToChildStreamChild*> VPParentToChildStreamChild;
    };

    PChildToParentStreamParent**
    ptr_PChildToParentStreamParent()
    {
        return ((mValue).VPChildToParentStreamParent).addr();
    }
    PChildToParentStreamParent* const*
    constptr_PChildToParentStreamParent() const
    {
        return ((mValue).VPChildToParentStreamParent).addr();
    }
    PChildToParentStreamChild**
    ptr_PChildToParentStreamChild()
    {
        return ((mValue).VPChildToParentStreamChild).addr();
    }
    PChildToParentStreamChild* const*
    constptr_PChildToParentStreamChild() const
    {
        return ((mValue).VPChildToParentStreamChild).addr();
    }
    PParentToChildStreamParent**
    ptr_PParentToChildStreamParent()
    {
        return ((mValue).VPParentToChildStreamParent).addr();
    }
    PParentToChildStreamParent* const*
    constptr_PParentToChildStreamParent() const
    {
        return ((mValue).VPParentToChildStreamParent).addr();
    }
    PParentToChildStreamChild**
    ptr_PParentToChildStreamChild()
    {
        return ((mValue).VPParentToChildStreamChild).addr();
    }
    PParentToChildStreamChild* const*
    constptr_PParentToChildStreamChild() const
    {
        return ((mValue).VPParentToChildStreamChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCRemoteStreamType() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCRemoteStreamType(PChildToParentStreamParent* aOther);

    MOZ_IMPLICIT IPCRemoteStreamType(PChildToParentStreamChild* aOther);

    MOZ_IMPLICIT IPCRemoteStreamType(PParentToChildStreamParent* aOther);

    MOZ_IMPLICIT IPCRemoteStreamType(PParentToChildStreamChild* aOther);

    MOZ_IMPLICIT IPCRemoteStreamType(const IPCRemoteStreamType& aOther);

    ~IPCRemoteStreamType();

    Type
    type() const
    {
        return mType;
    }

    IPCRemoteStreamType&
    operator=(PChildToParentStreamParent* aRhs);

    IPCRemoteStreamType&
    operator=(PChildToParentStreamChild* aRhs);

    IPCRemoteStreamType&
    operator=(PParentToChildStreamParent* aRhs);

    IPCRemoteStreamType&
    operator=(PParentToChildStreamChild* aRhs);

    IPCRemoteStreamType&
    operator=(const IPCRemoteStreamType& aRhs);

    bool
    operator==(PChildToParentStreamParent* aRhs) const;

    bool
    operator==(PChildToParentStreamChild* aRhs) const;

    bool
    operator==(PParentToChildStreamParent* aRhs) const;

    bool
    operator==(PParentToChildStreamChild* aRhs) const;

    bool
    operator==(const IPCRemoteStreamType& aRhs) const;

    PChildToParentStreamParent*&
    get_PChildToParentStreamParent()
    {
        AssertSanity(TPChildToParentStreamParent);
        return (*(ptr_PChildToParentStreamParent()));
    }
    PChildToParentStreamParent*
    get_PChildToParentStreamParent() const
    {
        AssertSanity(TPChildToParentStreamParent);
        return (*(constptr_PChildToParentStreamParent()));
    }
    void
    get(PChildToParentStreamParent** aOutValue) const;
    operator PChildToParentStreamParent*&()
    {
        return get_PChildToParentStreamParent();
    }
    operator PChildToParentStreamParent*() const
    {
        return get_PChildToParentStreamParent();
    }

    PChildToParentStreamChild*&
    get_PChildToParentStreamChild()
    {
        AssertSanity(TPChildToParentStreamChild);
        return (*(ptr_PChildToParentStreamChild()));
    }
    PChildToParentStreamChild*
    get_PChildToParentStreamChild() const
    {
        AssertSanity(TPChildToParentStreamChild);
        return (*(constptr_PChildToParentStreamChild()));
    }
    void
    get(PChildToParentStreamChild** aOutValue) const;
    operator PChildToParentStreamChild*&()
    {
        return get_PChildToParentStreamChild();
    }
    operator PChildToParentStreamChild*() const
    {
        return get_PChildToParentStreamChild();
    }

    PParentToChildStreamParent*&
    get_PParentToChildStreamParent()
    {
        AssertSanity(TPParentToChildStreamParent);
        return (*(ptr_PParentToChildStreamParent()));
    }
    PParentToChildStreamParent*
    get_PParentToChildStreamParent() const
    {
        AssertSanity(TPParentToChildStreamParent);
        return (*(constptr_PParentToChildStreamParent()));
    }
    void
    get(PParentToChildStreamParent** aOutValue) const;
    operator PParentToChildStreamParent*&()
    {
        return get_PParentToChildStreamParent();
    }
    operator PParentToChildStreamParent*() const
    {
        return get_PParentToChildStreamParent();
    }

    PParentToChildStreamChild*&
    get_PParentToChildStreamChild()
    {
        AssertSanity(TPParentToChildStreamChild);
        return (*(ptr_PParentToChildStreamChild()));
    }
    PParentToChildStreamChild*
    get_PParentToChildStreamChild() const
    {
        AssertSanity(TPParentToChildStreamChild);
        return (*(constptr_PParentToChildStreamChild()));
    }
    void
    get(PParentToChildStreamChild** aOutValue) const;
    operator PParentToChildStreamChild*&()
    {
        return get_PParentToChildStreamChild();
    }
    operator PParentToChildStreamChild*() const
    {
        return get_PParentToChildStreamChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class IPCRemoteStreamType;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCRemoteStream|
//
namespace mozilla {
namespace ipc {
class IPCRemoteStream final
{
private:
    typedef mozilla::ipc::IPCRemoteStreamType IPCRemoteStreamType;

public:
    MOZ_IMPLICIT IPCRemoteStream();

    MOZ_IMPLICIT IPCRemoteStream(
            const bool& _delayedStart,
            const IPCRemoteStreamType& _stream)
    {
        Init();
        Assign(_delayedStart, _stream);
    }

    MOZ_IMPLICIT IPCRemoteStream(const IPCRemoteStream& _o)
    {
        Init();
        Assign((_o).delayedStart(), (_o).stream());
    }

    ~IPCRemoteStream();

    void
    operator=(const IPCRemoteStream& _o)
    {
        Assign((_o).delayedStart(), (_o).stream());
    }

    bool
    operator==(const IPCRemoteStream& _o) const;

    bool
    operator!=(const IPCRemoteStream& _o) const;

    bool&
    delayedStart()
    {
        return delayedStart_;
    }
    const bool&
    delayedStart() const
    {
        return delayedStart_;
    }

    IPCRemoteStreamType&
    stream()
    {
        return stream_;
    }
    const IPCRemoteStreamType&
    stream() const
    {
        return stream_;
    }

private:
    void
    Init();

    void
    Assign(
            const bool& _delayedStart,
            const IPCRemoteStreamType& _stream);

    bool delayedStart_;
    IPCRemoteStreamType stream_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class InputStreamParamsWithFds;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class IPCRemoteStream;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCStream|
//
namespace mozilla {
namespace ipc {
class IPCStream final
{
public:
    enum Type {
        T__None,
        TInputStreamParamsWithFds = 1,
        TIPCRemoteStream,
        T__Last = TIPCRemoteStream
    };

private:
    typedef mozilla::ipc::InputStreamParamsWithFds InputStreamParamsWithFds;
    typedef mozilla::ipc::IPCRemoteStream IPCRemoteStream;
    typedef InputStreamParamsWithFds InputStreamParamsWithFds__tdef;
    typedef IPCRemoteStream IPCRemoteStream__tdef;

    union Value {
        mozilla::AlignedStorage2<InputStreamParamsWithFds> VInputStreamParamsWithFds;
        mozilla::AlignedStorage2<IPCRemoteStream> VIPCRemoteStream;
    };

    InputStreamParamsWithFds*
    ptr_InputStreamParamsWithFds()
    {
        return ((mValue).VInputStreamParamsWithFds).addr();
    }
    const InputStreamParamsWithFds*
    constptr_InputStreamParamsWithFds() const
    {
        return ((mValue).VInputStreamParamsWithFds).addr();
    }
    IPCRemoteStream*
    ptr_IPCRemoteStream()
    {
        return ((mValue).VIPCRemoteStream).addr();
    }
    const IPCRemoteStream*
    constptr_IPCRemoteStream() const
    {
        return ((mValue).VIPCRemoteStream).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCStream() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCStream(const InputStreamParamsWithFds& aOther);

    MOZ_IMPLICIT IPCStream(const IPCRemoteStream& aOther);

    MOZ_IMPLICIT IPCStream(const IPCStream& aOther);

    ~IPCStream();

    Type
    type() const
    {
        return mType;
    }

    IPCStream&
    operator=(const InputStreamParamsWithFds& aRhs);

    IPCStream&
    operator=(const IPCRemoteStream& aRhs);

    IPCStream&
    operator=(const IPCStream& aRhs);

    bool
    operator==(const InputStreamParamsWithFds& aRhs) const;

    bool
    operator==(const IPCRemoteStream& aRhs) const;

    bool
    operator==(const IPCStream& aRhs) const;

    InputStreamParamsWithFds&
    get_InputStreamParamsWithFds()
    {
        AssertSanity(TInputStreamParamsWithFds);
        return (*(ptr_InputStreamParamsWithFds()));
    }
    const InputStreamParamsWithFds&
    get_InputStreamParamsWithFds() const
    {
        AssertSanity(TInputStreamParamsWithFds);
        return (*(constptr_InputStreamParamsWithFds()));
    }
    void
    get(InputStreamParamsWithFds* aOutValue) const;
    operator InputStreamParamsWithFds&()
    {
        return get_InputStreamParamsWithFds();
    }
    operator const InputStreamParamsWithFds&() const
    {
        return get_InputStreamParamsWithFds();
    }

    IPCRemoteStream&
    get_IPCRemoteStream()
    {
        AssertSanity(TIPCRemoteStream);
        return (*(ptr_IPCRemoteStream()));
    }
    const IPCRemoteStream&
    get_IPCRemoteStream() const
    {
        AssertSanity(TIPCRemoteStream);
        return (*(constptr_IPCRemoteStream()));
    }
    void
    get(IPCRemoteStream* aOutValue) const;
    operator IPCRemoteStream&()
    {
        return get_IPCRemoteStream();
    }
    operator const IPCRemoteStream&() const
    {
        return get_IPCRemoteStream();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class IPCStream;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalIPCStream|
//
namespace mozilla {
namespace ipc {
class OptionalIPCStream final
{
public:
    enum Type {
        T__None,
        TIPCStream = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::void_t void_t;
    typedef IPCStream IPCStream__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<IPCStream> VIPCStream;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    IPCStream*
    ptr_IPCStream()
    {
        return ((mValue).VIPCStream).addr();
    }
    const IPCStream*
    constptr_IPCStream() const
    {
        return ((mValue).VIPCStream).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalIPCStream() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalIPCStream(const IPCStream& aOther);

    MOZ_IMPLICIT OptionalIPCStream(const void_t& aOther);

    MOZ_IMPLICIT OptionalIPCStream(const OptionalIPCStream& aOther);

    ~OptionalIPCStream();

    Type
    type() const
    {
        return mType;
    }

    OptionalIPCStream&
    operator=(const IPCStream& aRhs);

    OptionalIPCStream&
    operator=(const void_t& aRhs);

    OptionalIPCStream&
    operator=(const OptionalIPCStream& aRhs);

    bool
    operator==(const IPCStream& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalIPCStream& aRhs) const;

    IPCStream&
    get_IPCStream()
    {
        AssertSanity(TIPCStream);
        return (*(ptr_IPCStream()));
    }
    const IPCStream&
    get_IPCStream() const
    {
        AssertSanity(TIPCStream);
        return (*(constptr_IPCStream()));
    }
    void
    get(IPCStream* aOutValue) const;
    operator IPCStream&()
    {
        return get_IPCStream();
    }
    operator const IPCStream&() const
    {
        return get_IPCStream();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef IPCStream_h
