//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LayersSurfaces_h
#define LayersSurfaces_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ImageTypes.h"
#include "gfxipc/ShadowLayerUtils.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/gfx/Types.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OverlayHandle|
//
namespace mozilla {
namespace layers {
class OverlayHandle final
{
public:
    enum Type {
        T__None,
        Tint32_t = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::null_t null_t;
    typedef int32_t int32_t__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<int32_t> Vint32_t;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    int32_t*
    ptr_int32_t()
    {
        return ((mValue).Vint32_t).addr();
    }
    const int32_t*
    constptr_int32_t() const
    {
        return ((mValue).Vint32_t).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OverlayHandle() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OverlayHandle(const int32_t& aOther);

    MOZ_IMPLICIT OverlayHandle(const null_t& aOther);

    MOZ_IMPLICIT OverlayHandle(const OverlayHandle& aOther);

    ~OverlayHandle();

    Type
    type() const
    {
        return mType;
    }

    OverlayHandle&
    operator=(const int32_t& aRhs);

    OverlayHandle&
    operator=(const null_t& aRhs);

    OverlayHandle&
    operator=(const OverlayHandle& aRhs);

    bool
    operator==(const int32_t& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const OverlayHandle& aRhs) const;

    int32_t&
    get_int32_t()
    {
        AssertSanity(Tint32_t);
        return (*(ptr_int32_t()));
    }
    const int32_t&
    get_int32_t() const
    {
        AssertSanity(Tint32_t);
        return (*(constptr_int32_t()));
    }
    void
    get(int32_t* aOutValue) const;
    operator int32_t&()
    {
        return get_int32_t();
    }
    operator const int32_t&() const
    {
        return get_int32_t();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OverlayHandle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OverlaySource|
//
namespace mozilla {
namespace layers {
class OverlaySource final
{
private:
    typedef mozilla::layers::OverlayHandle OverlayHandle;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT OverlaySource();

    MOZ_IMPLICIT OverlaySource(
            const OverlayHandle& _handle,
            const IntSize& _size)
    {
        Init();
        Assign(_handle, _size);
    }

    MOZ_IMPLICIT OverlaySource(const OverlaySource& _o)
    {
        Init();
        Assign((_o).handle(), (_o).size());
    }

    ~OverlaySource();

    void
    operator=(const OverlaySource& _o)
    {
        Assign((_o).handle(), (_o).size());
    }

    bool
    operator==(const OverlaySource& _o) const;

    bool
    operator!=(const OverlaySource& _o) const;

    OverlayHandle&
    handle()
    {
        return handle_;
    }
    const OverlayHandle&
    handle() const
    {
        return handle_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const OverlayHandle& _handle,
            const IntSize& _size);

    OverlayHandle handle_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorFileMapping|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorFileMapping final
{
private:
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorFileMapping();

    MOZ_IMPLICIT SurfaceDescriptorFileMapping(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size)
    {
        Init();
        Assign(_handle, _format, _size);
    }

    MOZ_IMPLICIT SurfaceDescriptorFileMapping(const SurfaceDescriptorFileMapping& _o)
    {
        Init();
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    ~SurfaceDescriptorFileMapping();

    void
    operator=(const SurfaceDescriptorFileMapping& _o)
    {
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    bool
    operator==(const SurfaceDescriptorFileMapping& _o) const;

    bool
    operator!=(const SurfaceDescriptorFileMapping& _o) const;

    WindowsHandle&
    handle()
    {
        return handle_;
    }
    const WindowsHandle&
    handle() const
    {
        return handle_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size);

    WindowsHandle handle_;
    SurfaceFormat format_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorDIB|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorDIB final
{
private:

public:
    MOZ_IMPLICIT SurfaceDescriptorDIB();

    MOZ_IMPLICIT SurfaceDescriptorDIB(const uintptr_t& _surface)
    {
        Init();
        Assign(_surface);
    }

    MOZ_IMPLICIT SurfaceDescriptorDIB(const SurfaceDescriptorDIB& _o)
    {
        Init();
        Assign((_o).surface());
    }

    ~SurfaceDescriptorDIB();

    void
    operator=(const SurfaceDescriptorDIB& _o)
    {
        Assign((_o).surface());
    }

    bool
    operator==(const SurfaceDescriptorDIB& _o) const;

    bool
    operator!=(const SurfaceDescriptorDIB& _o) const;

    uintptr_t&
    surface()
    {
        return surface_;
    }
    const uintptr_t&
    surface() const
    {
        return surface_;
    }

private:
    void
    Init();

    void
    Assign(const uintptr_t& _surface);

    uintptr_t surface_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorD3D10|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D10 final
{
private:
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorD3D10();

    MOZ_IMPLICIT SurfaceDescriptorD3D10(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size)
    {
        Init();
        Assign(_handle, _format, _size);
    }

    MOZ_IMPLICIT SurfaceDescriptorD3D10(const SurfaceDescriptorD3D10& _o)
    {
        Init();
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    ~SurfaceDescriptorD3D10();

    void
    operator=(const SurfaceDescriptorD3D10& _o)
    {
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    bool
    operator==(const SurfaceDescriptorD3D10& _o) const;

    bool
    operator!=(const SurfaceDescriptorD3D10& _o) const;

    WindowsHandle&
    handle()
    {
        return handle_;
    }
    const WindowsHandle&
    handle() const
    {
        return handle_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size);

    WindowsHandle handle_;
    SurfaceFormat format_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorDXGIYCbCr|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorDXGIYCbCr final
{
private:
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr();

    MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr(
            const WindowsHandle& _handleY,
            const WindowsHandle& _handleCb,
            const WindowsHandle& _handleCr,
            const IntSize& _size,
            const IntSize& _sizeY,
            const IntSize& _sizeCbCr)
    {
        Init();
        Assign(_handleY, _handleCb, _handleCr, _size, _sizeY, _sizeCbCr);
    }

    MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr(const SurfaceDescriptorDXGIYCbCr& _o)
    {
        Init();
        Assign((_o).handleY(), (_o).handleCb(), (_o).handleCr(), (_o).size(), (_o).sizeY(), (_o).sizeCbCr());
    }

    ~SurfaceDescriptorDXGIYCbCr();

    void
    operator=(const SurfaceDescriptorDXGIYCbCr& _o)
    {
        Assign((_o).handleY(), (_o).handleCb(), (_o).handleCr(), (_o).size(), (_o).sizeY(), (_o).sizeCbCr());
    }

    bool
    operator==(const SurfaceDescriptorDXGIYCbCr& _o) const;

    bool
    operator!=(const SurfaceDescriptorDXGIYCbCr& _o) const;

    WindowsHandle&
    handleY()
    {
        return handleY_;
    }
    const WindowsHandle&
    handleY() const
    {
        return handleY_;
    }

    WindowsHandle&
    handleCb()
    {
        return handleCb_;
    }
    const WindowsHandle&
    handleCb() const
    {
        return handleCb_;
    }

    WindowsHandle&
    handleCr()
    {
        return handleCr_;
    }
    const WindowsHandle&
    handleCr() const
    {
        return handleCr_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    IntSize&
    sizeY()
    {
        return sizeY_;
    }
    const IntSize&
    sizeY() const
    {
        return sizeY_;
    }

    IntSize&
    sizeCbCr()
    {
        return sizeCbCr_;
    }
    const IntSize&
    sizeCbCr() const
    {
        return sizeCbCr_;
    }

private:
    void
    Init();

    void
    Assign(
            const WindowsHandle& _handleY,
            const WindowsHandle& _handleCb,
            const WindowsHandle& _handleCr,
            const IntSize& _size,
            const IntSize& _sizeY,
            const IntSize& _sizeCbCr);

    WindowsHandle handleY_;
    WindowsHandle handleCb_;
    WindowsHandle handleCr_;
    IntSize size_;
    IntSize sizeY_;
    IntSize sizeCbCr_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorMacIOSurface|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorMacIOSurface final
{
private:

public:
    MOZ_IMPLICIT SurfaceDescriptorMacIOSurface();

    MOZ_IMPLICIT SurfaceDescriptorMacIOSurface(
            const uint32_t& _surfaceId,
            const double& _scaleFactor,
            const bool& _isOpaque)
    {
        Init();
        Assign(_surfaceId, _scaleFactor, _isOpaque);
    }

    MOZ_IMPLICIT SurfaceDescriptorMacIOSurface(const SurfaceDescriptorMacIOSurface& _o)
    {
        Init();
        Assign((_o).surfaceId(), (_o).scaleFactor(), (_o).isOpaque());
    }

    ~SurfaceDescriptorMacIOSurface();

    void
    operator=(const SurfaceDescriptorMacIOSurface& _o)
    {
        Assign((_o).surfaceId(), (_o).scaleFactor(), (_o).isOpaque());
    }

    bool
    operator==(const SurfaceDescriptorMacIOSurface& _o) const;

    bool
    operator!=(const SurfaceDescriptorMacIOSurface& _o) const;

    uint32_t&
    surfaceId()
    {
        return surfaceId_;
    }
    const uint32_t&
    surfaceId() const
    {
        return surfaceId_;
    }

    double&
    scaleFactor()
    {
        return scaleFactor_;
    }
    const double&
    scaleFactor() const
    {
        return scaleFactor_;
    }

    bool&
    isOpaque()
    {
        return isOpaque_;
    }
    const bool&
    isOpaque() const
    {
        return isOpaque_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _surfaceId,
            const double& _scaleFactor,
            const bool& _isOpaque);

    uint32_t surfaceId_;
    double scaleFactor_;
    bool isOpaque_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceTextureDescriptor|
//
namespace mozilla {
namespace layers {
class SurfaceTextureDescriptor final
{
private:
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceTextureDescriptor();

    MOZ_IMPLICIT SurfaceTextureDescriptor(
            const uint64_t& _handle,
            const IntSize& _size,
            const bool& _continuous)
    {
        Init();
        Assign(_handle, _size, _continuous);
    }

    MOZ_IMPLICIT SurfaceTextureDescriptor(const SurfaceTextureDescriptor& _o)
    {
        Init();
        Assign((_o).handle(), (_o).size(), (_o).continuous());
    }

    ~SurfaceTextureDescriptor();

    void
    operator=(const SurfaceTextureDescriptor& _o)
    {
        Assign((_o).handle(), (_o).size(), (_o).continuous());
    }

    bool
    operator==(const SurfaceTextureDescriptor& _o) const;

    bool
    operator!=(const SurfaceTextureDescriptor& _o) const;

    uint64_t&
    handle()
    {
        return handle_;
    }
    const uint64_t&
    handle() const
    {
        return handle_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    bool&
    continuous()
    {
        return continuous_;
    }
    const bool&
    continuous() const
    {
        return continuous_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _handle,
            const IntSize& _size,
            const bool& _continuous);

    uint64_t handle_;
    IntSize size_;
    bool continuous_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct EGLImageDescriptor|
//
namespace mozilla {
namespace layers {
class EGLImageDescriptor final
{
private:
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT EGLImageDescriptor();

    MOZ_IMPLICIT EGLImageDescriptor(
            const uintptr_t& _image,
            const uintptr_t& _fence,
            const IntSize& _size,
            const bool& _hasAlpha)
    {
        Init();
        Assign(_image, _fence, _size, _hasAlpha);
    }

    MOZ_IMPLICIT EGLImageDescriptor(const EGLImageDescriptor& _o)
    {
        Init();
        Assign((_o).image(), (_o).fence(), (_o).size(), (_o).hasAlpha());
    }

    ~EGLImageDescriptor();

    void
    operator=(const EGLImageDescriptor& _o)
    {
        Assign((_o).image(), (_o).fence(), (_o).size(), (_o).hasAlpha());
    }

    bool
    operator==(const EGLImageDescriptor& _o) const;

    bool
    operator!=(const EGLImageDescriptor& _o) const;

    uintptr_t&
    image()
    {
        return image_;
    }
    const uintptr_t&
    image() const
    {
        return image_;
    }

    uintptr_t&
    fence()
    {
        return fence_;
    }
    const uintptr_t&
    fence() const
    {
        return fence_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    bool&
    hasAlpha()
    {
        return hasAlpha_;
    }
    const bool&
    hasAlpha() const
    {
        return hasAlpha_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _image,
            const uintptr_t& _fence,
            const IntSize& _size,
            const bool& _hasAlpha);

    uintptr_t image_;
    uintptr_t fence_;
    IntSize size_;
    bool hasAlpha_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorSharedGLTexture|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorSharedGLTexture final
{
private:
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorSharedGLTexture();

    MOZ_IMPLICIT SurfaceDescriptorSharedGLTexture(
            const uint32_t& _texture,
            const uint32_t& _target,
            const uintptr_t& _fence,
            const IntSize& _size,
            const bool& _hasAlpha)
    {
        Init();
        Assign(_texture, _target, _fence, _size, _hasAlpha);
    }

    MOZ_IMPLICIT SurfaceDescriptorSharedGLTexture(const SurfaceDescriptorSharedGLTexture& _o)
    {
        Init();
        Assign((_o).texture(), (_o).target(), (_o).fence(), (_o).size(), (_o).hasAlpha());
    }

    ~SurfaceDescriptorSharedGLTexture();

    void
    operator=(const SurfaceDescriptorSharedGLTexture& _o)
    {
        Assign((_o).texture(), (_o).target(), (_o).fence(), (_o).size(), (_o).hasAlpha());
    }

    bool
    operator==(const SurfaceDescriptorSharedGLTexture& _o) const;

    bool
    operator!=(const SurfaceDescriptorSharedGLTexture& _o) const;

    uint32_t&
    texture()
    {
        return texture_;
    }
    const uint32_t&
    texture() const
    {
        return texture_;
    }

    uint32_t&
    target()
    {
        return target_;
    }
    const uint32_t&
    target() const
    {
        return target_;
    }

    uintptr_t&
    fence()
    {
        return fence_;
    }
    const uintptr_t&
    fence() const
    {
        return fence_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    bool&
    hasAlpha()
    {
        return hasAlpha_;
    }
    const bool&
    hasAlpha() const
    {
        return hasAlpha_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _texture,
            const uint32_t& _target,
            const uintptr_t& _fence,
            const IntSize& _size,
            const bool& _hasAlpha);

    uint32_t texture_;
    uint32_t target_;
    uintptr_t fence_;
    IntSize size_;
    bool hasAlpha_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D10;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorDXGIYCbCr;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union GPUVideoSubDescriptor|
//
namespace mozilla {
namespace layers {
class GPUVideoSubDescriptor final
{
public:
    enum Type {
        T__None,
        TSurfaceDescriptorD3D10 = 1,
        TSurfaceDescriptorDXGIYCbCr,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::SurfaceDescriptorD3D10 SurfaceDescriptorD3D10;
    typedef mozilla::layers::SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr;
    typedef mozilla::null_t null_t;
    typedef SurfaceDescriptorD3D10 SurfaceDescriptorD3D10__tdef;
    typedef SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<SurfaceDescriptorD3D10> VSurfaceDescriptorD3D10;
        mozilla::AlignedStorage2<SurfaceDescriptorDXGIYCbCr> VSurfaceDescriptorDXGIYCbCr;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    SurfaceDescriptorD3D10*
    ptr_SurfaceDescriptorD3D10()
    {
        return ((mValue).VSurfaceDescriptorD3D10).addr();
    }
    const SurfaceDescriptorD3D10*
    constptr_SurfaceDescriptorD3D10() const
    {
        return ((mValue).VSurfaceDescriptorD3D10).addr();
    }
    SurfaceDescriptorDXGIYCbCr*
    ptr_SurfaceDescriptorDXGIYCbCr()
    {
        return ((mValue).VSurfaceDescriptorDXGIYCbCr).addr();
    }
    const SurfaceDescriptorDXGIYCbCr*
    constptr_SurfaceDescriptorDXGIYCbCr() const
    {
        return ((mValue).VSurfaceDescriptorDXGIYCbCr).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT GPUVideoSubDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT GPUVideoSubDescriptor(const SurfaceDescriptorD3D10& aOther);

    MOZ_IMPLICIT GPUVideoSubDescriptor(const SurfaceDescriptorDXGIYCbCr& aOther);

    MOZ_IMPLICIT GPUVideoSubDescriptor(const null_t& aOther);

    MOZ_IMPLICIT GPUVideoSubDescriptor(const GPUVideoSubDescriptor& aOther);

    ~GPUVideoSubDescriptor();

    Type
    type() const
    {
        return mType;
    }

    GPUVideoSubDescriptor&
    operator=(const SurfaceDescriptorD3D10& aRhs);

    GPUVideoSubDescriptor&
    operator=(const SurfaceDescriptorDXGIYCbCr& aRhs);

    GPUVideoSubDescriptor&
    operator=(const null_t& aRhs);

    GPUVideoSubDescriptor&
    operator=(const GPUVideoSubDescriptor& aRhs);

    bool
    operator==(const SurfaceDescriptorD3D10& aRhs) const;

    bool
    operator==(const SurfaceDescriptorDXGIYCbCr& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const GPUVideoSubDescriptor& aRhs) const;

    SurfaceDescriptorD3D10&
    get_SurfaceDescriptorD3D10()
    {
        AssertSanity(TSurfaceDescriptorD3D10);
        return (*(ptr_SurfaceDescriptorD3D10()));
    }
    const SurfaceDescriptorD3D10&
    get_SurfaceDescriptorD3D10() const
    {
        AssertSanity(TSurfaceDescriptorD3D10);
        return (*(constptr_SurfaceDescriptorD3D10()));
    }
    void
    get(SurfaceDescriptorD3D10* aOutValue) const;
    operator SurfaceDescriptorD3D10&()
    {
        return get_SurfaceDescriptorD3D10();
    }
    operator const SurfaceDescriptorD3D10&() const
    {
        return get_SurfaceDescriptorD3D10();
    }

    SurfaceDescriptorDXGIYCbCr&
    get_SurfaceDescriptorDXGIYCbCr()
    {
        AssertSanity(TSurfaceDescriptorDXGIYCbCr);
        return (*(ptr_SurfaceDescriptorDXGIYCbCr()));
    }
    const SurfaceDescriptorDXGIYCbCr&
    get_SurfaceDescriptorDXGIYCbCr() const
    {
        AssertSanity(TSurfaceDescriptorDXGIYCbCr);
        return (*(constptr_SurfaceDescriptorDXGIYCbCr()));
    }
    void
    get(SurfaceDescriptorDXGIYCbCr* aOutValue) const;
    operator SurfaceDescriptorDXGIYCbCr&()
    {
        return get_SurfaceDescriptorDXGIYCbCr();
    }
    operator const SurfaceDescriptorDXGIYCbCr&() const
    {
        return get_SurfaceDescriptorDXGIYCbCr();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class GPUVideoSubDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorGPUVideo|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorGPUVideo final
{
private:
    typedef mozilla::layers::GPUVideoSubDescriptor GPUVideoSubDescriptor;

public:
    MOZ_IMPLICIT SurfaceDescriptorGPUVideo();

    MOZ_IMPLICIT SurfaceDescriptorGPUVideo(
            const uint64_t& _handle,
            const GPUVideoSubDescriptor& _subdesc)
    {
        Init();
        Assign(_handle, _subdesc);
    }

    MOZ_IMPLICIT SurfaceDescriptorGPUVideo(const SurfaceDescriptorGPUVideo& _o)
    {
        Init();
        Assign((_o).handle(), (_o).subdesc());
    }

    ~SurfaceDescriptorGPUVideo();

    void
    operator=(const SurfaceDescriptorGPUVideo& _o)
    {
        Assign((_o).handle(), (_o).subdesc());
    }

    bool
    operator==(const SurfaceDescriptorGPUVideo& _o) const;

    bool
    operator!=(const SurfaceDescriptorGPUVideo& _o) const;

    uint64_t&
    handle()
    {
        return handle_;
    }
    const uint64_t&
    handle() const
    {
        return handle_;
    }

    GPUVideoSubDescriptor&
    subdesc()
    {
        return subdesc_;
    }
    const GPUVideoSubDescriptor&
    subdesc() const
    {
        return subdesc_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _handle,
            const GPUVideoSubDescriptor& _subdesc);

    uint64_t handle_;
    GPUVideoSubDescriptor subdesc_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RGBDescriptor|
//
namespace mozilla {
namespace layers {
class RGBDescriptor final
{
private:
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;

public:
    MOZ_IMPLICIT RGBDescriptor();

    MOZ_IMPLICIT RGBDescriptor(
            const IntSize& _size,
            const SurfaceFormat& _format,
            const bool& _hasIntermediateBuffer)
    {
        Init();
        Assign(_size, _format, _hasIntermediateBuffer);
    }

    MOZ_IMPLICIT RGBDescriptor(const RGBDescriptor& _o)
    {
        Init();
        Assign((_o).size(), (_o).format(), (_o).hasIntermediateBuffer());
    }

    ~RGBDescriptor();

    void
    operator=(const RGBDescriptor& _o)
    {
        Assign((_o).size(), (_o).format(), (_o).hasIntermediateBuffer());
    }

    bool
    operator==(const RGBDescriptor& _o) const;

    bool
    operator!=(const RGBDescriptor& _o) const;

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

    bool&
    hasIntermediateBuffer()
    {
        return hasIntermediateBuffer_;
    }
    const bool&
    hasIntermediateBuffer() const
    {
        return hasIntermediateBuffer_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntSize& _size,
            const SurfaceFormat& _format,
            const bool& _hasIntermediateBuffer);

    IntSize size_;
    SurfaceFormat format_;
    bool hasIntermediateBuffer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct YCbCrDescriptor|
//
namespace mozilla {
namespace layers {
class YCbCrDescriptor final
{
private:
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::StereoMode StereoMode;
    typedef mozilla::YUVColorSpace YUVColorSpace;

public:
    MOZ_IMPLICIT YCbCrDescriptor();

    MOZ_IMPLICIT YCbCrDescriptor(
            const IntSize& _ySize,
            const uint32_t& _yStride,
            const IntSize& _cbCrSize,
            const uint32_t& _cbCrStride,
            const uint32_t& _yOffset,
            const uint32_t& _cbOffset,
            const uint32_t& _crOffset,
            const StereoMode& _stereoMode,
            const YUVColorSpace& _yUVColorSpace,
            const uint32_t& _bitDepth,
            const bool& _hasIntermediateBuffer)
    {
        Init();
        Assign(_ySize, _yStride, _cbCrSize, _cbCrStride, _yOffset, _cbOffset, _crOffset, _stereoMode, _yUVColorSpace, _bitDepth, _hasIntermediateBuffer);
    }

    MOZ_IMPLICIT YCbCrDescriptor(const YCbCrDescriptor& _o)
    {
        Init();
        Assign((_o).ySize(), (_o).yStride(), (_o).cbCrSize(), (_o).cbCrStride(), (_o).yOffset(), (_o).cbOffset(), (_o).crOffset(), (_o).stereoMode(), (_o).yUVColorSpace(), (_o).bitDepth(), (_o).hasIntermediateBuffer());
    }

    ~YCbCrDescriptor();

    void
    operator=(const YCbCrDescriptor& _o)
    {
        Assign((_o).ySize(), (_o).yStride(), (_o).cbCrSize(), (_o).cbCrStride(), (_o).yOffset(), (_o).cbOffset(), (_o).crOffset(), (_o).stereoMode(), (_o).yUVColorSpace(), (_o).bitDepth(), (_o).hasIntermediateBuffer());
    }

    bool
    operator==(const YCbCrDescriptor& _o) const;

    bool
    operator!=(const YCbCrDescriptor& _o) const;

    IntSize&
    ySize()
    {
        return ySize_;
    }
    const IntSize&
    ySize() const
    {
        return ySize_;
    }

    uint32_t&
    yStride()
    {
        return yStride_;
    }
    const uint32_t&
    yStride() const
    {
        return yStride_;
    }

    IntSize&
    cbCrSize()
    {
        return cbCrSize_;
    }
    const IntSize&
    cbCrSize() const
    {
        return cbCrSize_;
    }

    uint32_t&
    cbCrStride()
    {
        return cbCrStride_;
    }
    const uint32_t&
    cbCrStride() const
    {
        return cbCrStride_;
    }

    uint32_t&
    yOffset()
    {
        return yOffset_;
    }
    const uint32_t&
    yOffset() const
    {
        return yOffset_;
    }

    uint32_t&
    cbOffset()
    {
        return cbOffset_;
    }
    const uint32_t&
    cbOffset() const
    {
        return cbOffset_;
    }

    uint32_t&
    crOffset()
    {
        return crOffset_;
    }
    const uint32_t&
    crOffset() const
    {
        return crOffset_;
    }

    StereoMode&
    stereoMode()
    {
        return stereoMode_;
    }
    const StereoMode&
    stereoMode() const
    {
        return stereoMode_;
    }

    YUVColorSpace&
    yUVColorSpace()
    {
        return yUVColorSpace_;
    }
    const YUVColorSpace&
    yUVColorSpace() const
    {
        return yUVColorSpace_;
    }

    uint32_t&
    bitDepth()
    {
        return bitDepth_;
    }
    const uint32_t&
    bitDepth() const
    {
        return bitDepth_;
    }

    bool&
    hasIntermediateBuffer()
    {
        return hasIntermediateBuffer_;
    }
    const bool&
    hasIntermediateBuffer() const
    {
        return hasIntermediateBuffer_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntSize& _ySize,
            const uint32_t& _yStride,
            const IntSize& _cbCrSize,
            const uint32_t& _cbCrStride,
            const uint32_t& _yOffset,
            const uint32_t& _cbOffset,
            const uint32_t& _crOffset,
            const StereoMode& _stereoMode,
            const YUVColorSpace& _yUVColorSpace,
            const uint32_t& _bitDepth,
            const bool& _hasIntermediateBuffer);

    IntSize ySize_;
    uint32_t yStride_;
    IntSize cbCrSize_;
    uint32_t cbCrStride_;
    uint32_t yOffset_;
    uint32_t cbOffset_;
    uint32_t crOffset_;
    StereoMode stereoMode_;
    YUVColorSpace yUVColorSpace_;
    uint32_t bitDepth_;
    bool hasIntermediateBuffer_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class RGBDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class YCbCrDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BufferDescriptor|
//
namespace mozilla {
namespace layers {
class BufferDescriptor final
{
public:
    enum Type {
        T__None,
        TRGBDescriptor = 1,
        TYCbCrDescriptor,
        T__Last = TYCbCrDescriptor
    };

private:
    typedef mozilla::layers::RGBDescriptor RGBDescriptor;
    typedef mozilla::layers::YCbCrDescriptor YCbCrDescriptor;
    typedef RGBDescriptor RGBDescriptor__tdef;
    typedef YCbCrDescriptor YCbCrDescriptor__tdef;

    union Value {
        mozilla::AlignedStorage2<RGBDescriptor> VRGBDescriptor;
        mozilla::AlignedStorage2<YCbCrDescriptor> VYCbCrDescriptor;
    };

    RGBDescriptor*
    ptr_RGBDescriptor()
    {
        return ((mValue).VRGBDescriptor).addr();
    }
    const RGBDescriptor*
    constptr_RGBDescriptor() const
    {
        return ((mValue).VRGBDescriptor).addr();
    }
    YCbCrDescriptor*
    ptr_YCbCrDescriptor()
    {
        return ((mValue).VYCbCrDescriptor).addr();
    }
    const YCbCrDescriptor*
    constptr_YCbCrDescriptor() const
    {
        return ((mValue).VYCbCrDescriptor).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BufferDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BufferDescriptor(const RGBDescriptor& aOther);

    MOZ_IMPLICIT BufferDescriptor(const YCbCrDescriptor& aOther);

    MOZ_IMPLICIT BufferDescriptor(const BufferDescriptor& aOther);

    ~BufferDescriptor();

    Type
    type() const
    {
        return mType;
    }

    BufferDescriptor&
    operator=(const RGBDescriptor& aRhs);

    BufferDescriptor&
    operator=(const YCbCrDescriptor& aRhs);

    BufferDescriptor&
    operator=(const BufferDescriptor& aRhs);

    bool
    operator==(const RGBDescriptor& aRhs) const;

    bool
    operator==(const YCbCrDescriptor& aRhs) const;

    bool
    operator==(const BufferDescriptor& aRhs) const;

    RGBDescriptor&
    get_RGBDescriptor()
    {
        AssertSanity(TRGBDescriptor);
        return (*(ptr_RGBDescriptor()));
    }
    const RGBDescriptor&
    get_RGBDescriptor() const
    {
        AssertSanity(TRGBDescriptor);
        return (*(constptr_RGBDescriptor()));
    }
    void
    get(RGBDescriptor* aOutValue) const;
    operator RGBDescriptor&()
    {
        return get_RGBDescriptor();
    }
    operator const RGBDescriptor&() const
    {
        return get_RGBDescriptor();
    }

    YCbCrDescriptor&
    get_YCbCrDescriptor()
    {
        AssertSanity(TYCbCrDescriptor);
        return (*(ptr_YCbCrDescriptor()));
    }
    const YCbCrDescriptor&
    get_YCbCrDescriptor() const
    {
        AssertSanity(TYCbCrDescriptor);
        return (*(constptr_YCbCrDescriptor()));
    }
    void
    get(YCbCrDescriptor* aOutValue) const;
    operator YCbCrDescriptor&()
    {
        return get_YCbCrDescriptor();
    }
    operator const YCbCrDescriptor&() const
    {
        return get_YCbCrDescriptor();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MemoryOrShmem|
//
namespace mozilla {
namespace layers {
class MemoryOrShmem final
{
public:
    enum Type {
        T__None,
        Tuintptr_t = 1,
        TShmem,
        T__Last = TShmem
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef uintptr_t uintptr_t__tdef;
    typedef Shmem Shmem__tdef;

    union Value {
        mozilla::AlignedStorage2<uintptr_t> Vuintptr_t;
        mozilla::AlignedStorage2<Shmem> VShmem;
    };

    uintptr_t*
    ptr_uintptr_t()
    {
        return ((mValue).Vuintptr_t).addr();
    }
    const uintptr_t*
    constptr_uintptr_t() const
    {
        return ((mValue).Vuintptr_t).addr();
    }
    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MemoryOrShmem() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MemoryOrShmem(const uintptr_t& aOther);

    MOZ_IMPLICIT MemoryOrShmem(Shmem& aOther);

    MOZ_IMPLICIT MemoryOrShmem(const MemoryOrShmem& aOther);

    ~MemoryOrShmem();

    Type
    type() const
    {
        return mType;
    }

    MemoryOrShmem&
    operator=(const uintptr_t& aRhs);

    MemoryOrShmem&
    operator=(Shmem& aRhs);

    MemoryOrShmem&
    operator=(const MemoryOrShmem& aRhs);

    bool
    operator==(const uintptr_t& aRhs) const;

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const MemoryOrShmem& aRhs) const;

    uintptr_t&
    get_uintptr_t()
    {
        AssertSanity(Tuintptr_t);
        return (*(ptr_uintptr_t()));
    }
    const uintptr_t&
    get_uintptr_t() const
    {
        AssertSanity(Tuintptr_t);
        return (*(constptr_uintptr_t()));
    }
    void
    get(uintptr_t* aOutValue) const;
    operator uintptr_t&()
    {
        return get_uintptr_t();
    }
    operator const uintptr_t&() const
    {
        return get_uintptr_t();
    }

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    void
    get(Shmem* aOutValue) const;
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class BufferDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class MemoryOrShmem;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorBuffer|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorBuffer final
{
private:
    typedef mozilla::layers::BufferDescriptor BufferDescriptor;
    typedef mozilla::layers::MemoryOrShmem MemoryOrShmem;

public:
    MOZ_IMPLICIT SurfaceDescriptorBuffer();

    MOZ_IMPLICIT SurfaceDescriptorBuffer(
            const BufferDescriptor& _desc,
            const MemoryOrShmem& _data)
    {
        Init();
        Assign(_desc, _data);
    }

    MOZ_IMPLICIT SurfaceDescriptorBuffer(const SurfaceDescriptorBuffer& _o)
    {
        Init();
        Assign((_o).desc(), (_o).data());
    }

    ~SurfaceDescriptorBuffer();

    void
    operator=(const SurfaceDescriptorBuffer& _o)
    {
        Assign((_o).desc(), (_o).data());
    }

    bool
    operator==(const SurfaceDescriptorBuffer& _o) const;

    bool
    operator!=(const SurfaceDescriptorBuffer& _o) const;

    BufferDescriptor&
    desc()
    {
        return desc_;
    }
    const BufferDescriptor&
    desc() const
    {
        return desc_;
    }

    MemoryOrShmem&
    data()
    {
        return data_;
    }
    const MemoryOrShmem&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(
            const BufferDescriptor& _desc,
            const MemoryOrShmem& _data);

    BufferDescriptor desc_;
    MemoryOrShmem data_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class SurfaceDescriptorBuffer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorDIB;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D10;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorFileMapping;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorDXGIYCbCr;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceTextureDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class EGLImageDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorMacIOSurface;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorSharedGLTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorGPUVideo;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union SurfaceDescriptor|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptor final
{
public:
    enum Type {
        T__None,
        TSurfaceDescriptorBuffer = 1,
        TSurfaceDescriptorDIB,
        TSurfaceDescriptorD3D10,
        TSurfaceDescriptorFileMapping,
        TSurfaceDescriptorDXGIYCbCr,
        TSurfaceDescriptorX11,
        TSurfaceTextureDescriptor,
        TEGLImageDescriptor,
        TSurfaceDescriptorMacIOSurface,
        TSurfaceDescriptorSharedGLTexture,
        TSurfaceDescriptorGPUVideo,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::SurfaceDescriptorBuffer SurfaceDescriptorBuffer;
    typedef mozilla::layers::SurfaceDescriptorDIB SurfaceDescriptorDIB;
    typedef mozilla::layers::SurfaceDescriptorD3D10 SurfaceDescriptorD3D10;
    typedef mozilla::layers::SurfaceDescriptorFileMapping SurfaceDescriptorFileMapping;
    typedef mozilla::layers::SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr;
    typedef mozilla::layers::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::layers::SurfaceTextureDescriptor SurfaceTextureDescriptor;
    typedef mozilla::layers::EGLImageDescriptor EGLImageDescriptor;
    typedef mozilla::layers::SurfaceDescriptorMacIOSurface SurfaceDescriptorMacIOSurface;
    typedef mozilla::layers::SurfaceDescriptorSharedGLTexture SurfaceDescriptorSharedGLTexture;
    typedef mozilla::layers::SurfaceDescriptorGPUVideo SurfaceDescriptorGPUVideo;
    typedef mozilla::null_t null_t;
    typedef SurfaceDescriptorBuffer SurfaceDescriptorBuffer__tdef;
    typedef SurfaceDescriptorDIB SurfaceDescriptorDIB__tdef;
    typedef SurfaceDescriptorD3D10 SurfaceDescriptorD3D10__tdef;
    typedef SurfaceDescriptorFileMapping SurfaceDescriptorFileMapping__tdef;
    typedef SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr__tdef;
    typedef SurfaceDescriptorX11 SurfaceDescriptorX11__tdef;
    typedef SurfaceTextureDescriptor SurfaceTextureDescriptor__tdef;
    typedef EGLImageDescriptor EGLImageDescriptor__tdef;
    typedef SurfaceDescriptorMacIOSurface SurfaceDescriptorMacIOSurface__tdef;
    typedef SurfaceDescriptorSharedGLTexture SurfaceDescriptorSharedGLTexture__tdef;
    typedef SurfaceDescriptorGPUVideo SurfaceDescriptorGPUVideo__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<SurfaceDescriptorBuffer> VSurfaceDescriptorBuffer;
        mozilla::AlignedStorage2<SurfaceDescriptorDIB> VSurfaceDescriptorDIB;
        mozilla::AlignedStorage2<SurfaceDescriptorD3D10> VSurfaceDescriptorD3D10;
        mozilla::AlignedStorage2<SurfaceDescriptorFileMapping> VSurfaceDescriptorFileMapping;
        mozilla::AlignedStorage2<SurfaceDescriptorDXGIYCbCr> VSurfaceDescriptorDXGIYCbCr;
        mozilla::AlignedStorage2<SurfaceDescriptorX11> VSurfaceDescriptorX11;
        mozilla::AlignedStorage2<SurfaceTextureDescriptor> VSurfaceTextureDescriptor;
        mozilla::AlignedStorage2<EGLImageDescriptor> VEGLImageDescriptor;
        mozilla::AlignedStorage2<SurfaceDescriptorMacIOSurface> VSurfaceDescriptorMacIOSurface;
        mozilla::AlignedStorage2<SurfaceDescriptorSharedGLTexture> VSurfaceDescriptorSharedGLTexture;
        mozilla::AlignedStorage2<SurfaceDescriptorGPUVideo> VSurfaceDescriptorGPUVideo;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    SurfaceDescriptorBuffer*
    ptr_SurfaceDescriptorBuffer()
    {
        return ((mValue).VSurfaceDescriptorBuffer).addr();
    }
    const SurfaceDescriptorBuffer*
    constptr_SurfaceDescriptorBuffer() const
    {
        return ((mValue).VSurfaceDescriptorBuffer).addr();
    }
    SurfaceDescriptorDIB*
    ptr_SurfaceDescriptorDIB()
    {
        return ((mValue).VSurfaceDescriptorDIB).addr();
    }
    const SurfaceDescriptorDIB*
    constptr_SurfaceDescriptorDIB() const
    {
        return ((mValue).VSurfaceDescriptorDIB).addr();
    }
    SurfaceDescriptorD3D10*
    ptr_SurfaceDescriptorD3D10()
    {
        return ((mValue).VSurfaceDescriptorD3D10).addr();
    }
    const SurfaceDescriptorD3D10*
    constptr_SurfaceDescriptorD3D10() const
    {
        return ((mValue).VSurfaceDescriptorD3D10).addr();
    }
    SurfaceDescriptorFileMapping*
    ptr_SurfaceDescriptorFileMapping()
    {
        return ((mValue).VSurfaceDescriptorFileMapping).addr();
    }
    const SurfaceDescriptorFileMapping*
    constptr_SurfaceDescriptorFileMapping() const
    {
        return ((mValue).VSurfaceDescriptorFileMapping).addr();
    }
    SurfaceDescriptorDXGIYCbCr*
    ptr_SurfaceDescriptorDXGIYCbCr()
    {
        return ((mValue).VSurfaceDescriptorDXGIYCbCr).addr();
    }
    const SurfaceDescriptorDXGIYCbCr*
    constptr_SurfaceDescriptorDXGIYCbCr() const
    {
        return ((mValue).VSurfaceDescriptorDXGIYCbCr).addr();
    }
    SurfaceDescriptorX11*
    ptr_SurfaceDescriptorX11()
    {
        return ((mValue).VSurfaceDescriptorX11).addr();
    }
    const SurfaceDescriptorX11*
    constptr_SurfaceDescriptorX11() const
    {
        return ((mValue).VSurfaceDescriptorX11).addr();
    }
    SurfaceTextureDescriptor*
    ptr_SurfaceTextureDescriptor()
    {
        return ((mValue).VSurfaceTextureDescriptor).addr();
    }
    const SurfaceTextureDescriptor*
    constptr_SurfaceTextureDescriptor() const
    {
        return ((mValue).VSurfaceTextureDescriptor).addr();
    }
    EGLImageDescriptor*
    ptr_EGLImageDescriptor()
    {
        return ((mValue).VEGLImageDescriptor).addr();
    }
    const EGLImageDescriptor*
    constptr_EGLImageDescriptor() const
    {
        return ((mValue).VEGLImageDescriptor).addr();
    }
    SurfaceDescriptorMacIOSurface*
    ptr_SurfaceDescriptorMacIOSurface()
    {
        return ((mValue).VSurfaceDescriptorMacIOSurface).addr();
    }
    const SurfaceDescriptorMacIOSurface*
    constptr_SurfaceDescriptorMacIOSurface() const
    {
        return ((mValue).VSurfaceDescriptorMacIOSurface).addr();
    }
    SurfaceDescriptorSharedGLTexture*
    ptr_SurfaceDescriptorSharedGLTexture()
    {
        return ((mValue).VSurfaceDescriptorSharedGLTexture).addr();
    }
    const SurfaceDescriptorSharedGLTexture*
    constptr_SurfaceDescriptorSharedGLTexture() const
    {
        return ((mValue).VSurfaceDescriptorSharedGLTexture).addr();
    }
    SurfaceDescriptorGPUVideo*
    ptr_SurfaceDescriptorGPUVideo()
    {
        return ((mValue).VSurfaceDescriptorGPUVideo).addr();
    }
    const SurfaceDescriptorGPUVideo*
    constptr_SurfaceDescriptorGPUVideo() const
    {
        return ((mValue).VSurfaceDescriptorGPUVideo).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT SurfaceDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorBuffer& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorDIB& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorD3D10& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorFileMapping& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorDXGIYCbCr& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorX11& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceTextureDescriptor& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const EGLImageDescriptor& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorMacIOSurface& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorSharedGLTexture& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorGPUVideo& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const null_t& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptor& aOther);

    ~SurfaceDescriptor();

    Type
    type() const
    {
        return mType;
    }

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorBuffer& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorDIB& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorD3D10& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorFileMapping& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorDXGIYCbCr& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorX11& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceTextureDescriptor& aRhs);

    SurfaceDescriptor&
    operator=(const EGLImageDescriptor& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorMacIOSurface& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorSharedGLTexture& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorGPUVideo& aRhs);

    SurfaceDescriptor&
    operator=(const null_t& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptor& aRhs);

    bool
    operator==(const SurfaceDescriptorBuffer& aRhs) const;

    bool
    operator==(const SurfaceDescriptorDIB& aRhs) const;

    bool
    operator==(const SurfaceDescriptorD3D10& aRhs) const;

    bool
    operator==(const SurfaceDescriptorFileMapping& aRhs) const;

    bool
    operator==(const SurfaceDescriptorDXGIYCbCr& aRhs) const;

    bool
    operator==(const SurfaceDescriptorX11& aRhs) const;

    bool
    operator==(const SurfaceTextureDescriptor& aRhs) const;

    bool
    operator==(const EGLImageDescriptor& aRhs) const;

    bool
    operator==(const SurfaceDescriptorMacIOSurface& aRhs) const;

    bool
    operator==(const SurfaceDescriptorSharedGLTexture& aRhs) const;

    bool
    operator==(const SurfaceDescriptorGPUVideo& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const SurfaceDescriptor& aRhs) const;

    SurfaceDescriptorBuffer&
    get_SurfaceDescriptorBuffer()
    {
        AssertSanity(TSurfaceDescriptorBuffer);
        return (*(ptr_SurfaceDescriptorBuffer()));
    }
    const SurfaceDescriptorBuffer&
    get_SurfaceDescriptorBuffer() const
    {
        AssertSanity(TSurfaceDescriptorBuffer);
        return (*(constptr_SurfaceDescriptorBuffer()));
    }
    void
    get(SurfaceDescriptorBuffer* aOutValue) const;
    operator SurfaceDescriptorBuffer&()
    {
        return get_SurfaceDescriptorBuffer();
    }
    operator const SurfaceDescriptorBuffer&() const
    {
        return get_SurfaceDescriptorBuffer();
    }

    SurfaceDescriptorDIB&
    get_SurfaceDescriptorDIB()
    {
        AssertSanity(TSurfaceDescriptorDIB);
        return (*(ptr_SurfaceDescriptorDIB()));
    }
    const SurfaceDescriptorDIB&
    get_SurfaceDescriptorDIB() const
    {
        AssertSanity(TSurfaceDescriptorDIB);
        return (*(constptr_SurfaceDescriptorDIB()));
    }
    void
    get(SurfaceDescriptorDIB* aOutValue) const;
    operator SurfaceDescriptorDIB&()
    {
        return get_SurfaceDescriptorDIB();
    }
    operator const SurfaceDescriptorDIB&() const
    {
        return get_SurfaceDescriptorDIB();
    }

    SurfaceDescriptorD3D10&
    get_SurfaceDescriptorD3D10()
    {
        AssertSanity(TSurfaceDescriptorD3D10);
        return (*(ptr_SurfaceDescriptorD3D10()));
    }
    const SurfaceDescriptorD3D10&
    get_SurfaceDescriptorD3D10() const
    {
        AssertSanity(TSurfaceDescriptorD3D10);
        return (*(constptr_SurfaceDescriptorD3D10()));
    }
    void
    get(SurfaceDescriptorD3D10* aOutValue) const;
    operator SurfaceDescriptorD3D10&()
    {
        return get_SurfaceDescriptorD3D10();
    }
    operator const SurfaceDescriptorD3D10&() const
    {
        return get_SurfaceDescriptorD3D10();
    }

    SurfaceDescriptorFileMapping&
    get_SurfaceDescriptorFileMapping()
    {
        AssertSanity(TSurfaceDescriptorFileMapping);
        return (*(ptr_SurfaceDescriptorFileMapping()));
    }
    const SurfaceDescriptorFileMapping&
    get_SurfaceDescriptorFileMapping() const
    {
        AssertSanity(TSurfaceDescriptorFileMapping);
        return (*(constptr_SurfaceDescriptorFileMapping()));
    }
    void
    get(SurfaceDescriptorFileMapping* aOutValue) const;
    operator SurfaceDescriptorFileMapping&()
    {
        return get_SurfaceDescriptorFileMapping();
    }
    operator const SurfaceDescriptorFileMapping&() const
    {
        return get_SurfaceDescriptorFileMapping();
    }

    SurfaceDescriptorDXGIYCbCr&
    get_SurfaceDescriptorDXGIYCbCr()
    {
        AssertSanity(TSurfaceDescriptorDXGIYCbCr);
        return (*(ptr_SurfaceDescriptorDXGIYCbCr()));
    }
    const SurfaceDescriptorDXGIYCbCr&
    get_SurfaceDescriptorDXGIYCbCr() const
    {
        AssertSanity(TSurfaceDescriptorDXGIYCbCr);
        return (*(constptr_SurfaceDescriptorDXGIYCbCr()));
    }
    void
    get(SurfaceDescriptorDXGIYCbCr* aOutValue) const;
    operator SurfaceDescriptorDXGIYCbCr&()
    {
        return get_SurfaceDescriptorDXGIYCbCr();
    }
    operator const SurfaceDescriptorDXGIYCbCr&() const
    {
        return get_SurfaceDescriptorDXGIYCbCr();
    }

    SurfaceDescriptorX11&
    get_SurfaceDescriptorX11()
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(ptr_SurfaceDescriptorX11()));
    }
    const SurfaceDescriptorX11&
    get_SurfaceDescriptorX11() const
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(constptr_SurfaceDescriptorX11()));
    }
    void
    get(SurfaceDescriptorX11* aOutValue) const;
    operator SurfaceDescriptorX11&()
    {
        return get_SurfaceDescriptorX11();
    }
    operator const SurfaceDescriptorX11&() const
    {
        return get_SurfaceDescriptorX11();
    }

    SurfaceTextureDescriptor&
    get_SurfaceTextureDescriptor()
    {
        AssertSanity(TSurfaceTextureDescriptor);
        return (*(ptr_SurfaceTextureDescriptor()));
    }
    const SurfaceTextureDescriptor&
    get_SurfaceTextureDescriptor() const
    {
        AssertSanity(TSurfaceTextureDescriptor);
        return (*(constptr_SurfaceTextureDescriptor()));
    }
    void
    get(SurfaceTextureDescriptor* aOutValue) const;
    operator SurfaceTextureDescriptor&()
    {
        return get_SurfaceTextureDescriptor();
    }
    operator const SurfaceTextureDescriptor&() const
    {
        return get_SurfaceTextureDescriptor();
    }

    EGLImageDescriptor&
    get_EGLImageDescriptor()
    {
        AssertSanity(TEGLImageDescriptor);
        return (*(ptr_EGLImageDescriptor()));
    }
    const EGLImageDescriptor&
    get_EGLImageDescriptor() const
    {
        AssertSanity(TEGLImageDescriptor);
        return (*(constptr_EGLImageDescriptor()));
    }
    void
    get(EGLImageDescriptor* aOutValue) const;
    operator EGLImageDescriptor&()
    {
        return get_EGLImageDescriptor();
    }
    operator const EGLImageDescriptor&() const
    {
        return get_EGLImageDescriptor();
    }

    SurfaceDescriptorMacIOSurface&
    get_SurfaceDescriptorMacIOSurface()
    {
        AssertSanity(TSurfaceDescriptorMacIOSurface);
        return (*(ptr_SurfaceDescriptorMacIOSurface()));
    }
    const SurfaceDescriptorMacIOSurface&
    get_SurfaceDescriptorMacIOSurface() const
    {
        AssertSanity(TSurfaceDescriptorMacIOSurface);
        return (*(constptr_SurfaceDescriptorMacIOSurface()));
    }
    void
    get(SurfaceDescriptorMacIOSurface* aOutValue) const;
    operator SurfaceDescriptorMacIOSurface&()
    {
        return get_SurfaceDescriptorMacIOSurface();
    }
    operator const SurfaceDescriptorMacIOSurface&() const
    {
        return get_SurfaceDescriptorMacIOSurface();
    }

    SurfaceDescriptorSharedGLTexture&
    get_SurfaceDescriptorSharedGLTexture()
    {
        AssertSanity(TSurfaceDescriptorSharedGLTexture);
        return (*(ptr_SurfaceDescriptorSharedGLTexture()));
    }
    const SurfaceDescriptorSharedGLTexture&
    get_SurfaceDescriptorSharedGLTexture() const
    {
        AssertSanity(TSurfaceDescriptorSharedGLTexture);
        return (*(constptr_SurfaceDescriptorSharedGLTexture()));
    }
    void
    get(SurfaceDescriptorSharedGLTexture* aOutValue) const;
    operator SurfaceDescriptorSharedGLTexture&()
    {
        return get_SurfaceDescriptorSharedGLTexture();
    }
    operator const SurfaceDescriptorSharedGLTexture&() const
    {
        return get_SurfaceDescriptorSharedGLTexture();
    }

    SurfaceDescriptorGPUVideo&
    get_SurfaceDescriptorGPUVideo()
    {
        AssertSanity(TSurfaceDescriptorGPUVideo);
        return (*(ptr_SurfaceDescriptorGPUVideo()));
    }
    const SurfaceDescriptorGPUVideo&
    get_SurfaceDescriptorGPUVideo() const
    {
        AssertSanity(TSurfaceDescriptorGPUVideo);
        return (*(constptr_SurfaceDescriptorGPUVideo()));
    }
    void
    get(SurfaceDescriptorGPUVideo* aOutValue) const;
    operator SurfaceDescriptorGPUVideo&()
    {
        return get_SurfaceDescriptorGPUVideo();
    }
    operator const SurfaceDescriptorGPUVideo&() const
    {
        return get_SurfaceDescriptorGPUVideo();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

#endif // ifndef LayersSurfaces_h
