//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZCTreeManagerChild_h
#define PAPZCTreeManagerChild_h

#include "mozilla/layers/PAPZCTreeManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "InputData.h"
#include "Units.h"
#include "ipc/nsGUIEventIPC.h"
#include "mozilla/EventForwards.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/MouseEvents.h"
#include "mozilla/dom/TabMessageUtils.h"
#include "mozilla/layers/APZUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"
#include "mozilla/layers/LayersMessageUtils.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class KeyboardMap;
} // namespace layers
} // namespace mozilla

namespace mozilla {
class WidgetInputEvent;
} // namespace mozilla

namespace mozilla {
class WidgetMouseEventBase;
} // namespace mozilla

namespace mozilla {
class WidgetTouchEvent;
} // namespace mozilla

namespace mozilla {
class WidgetWheelEvent;
} // namespace mozilla

namespace mozilla {
class InputData;
} // namespace mozilla

namespace mozilla {
class MultiTouchInput;
} // namespace mozilla

namespace mozilla {
class MouseInput;
} // namespace mozilla

namespace mozilla {
class PanGestureInput;
} // namespace mozilla

namespace mozilla {
class PinchGestureInput;
} // namespace mozilla

namespace mozilla {
class TapGestureInput;
} // namespace mozilla

namespace mozilla {
class ScrollWheelInput;
} // namespace mozilla

namespace mozilla {
class KeyboardInput;
} // namespace mozilla

namespace mozilla {
namespace layers {


class PAPZCTreeManagerChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PCompositorBridgeChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::InputData InputData;
    typedef mozilla::KeyboardInput KeyboardInput;
    typedef mozilla::layers::KeyboardMap KeyboardMap;
    typedef mozilla::LayoutDevicePoint LayoutDevicePoint;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef mozilla::Modifiers Modifiers;
    typedef mozilla::MouseInput MouseInput;
    typedef mozilla::MultiTouchInput MultiTouchInput;
    typedef mozilla::PanGestureInput PanGestureInput;
    typedef mozilla::PinchGestureInput PinchGestureInput;
    typedef mozilla::PinchGestureInput::PinchGestureType PinchGestureType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::WidgetMouseEvent::Reason Reason;
    typedef mozilla::ScrollWheelInput ScrollWheelInput;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::TapGestureInput TapGestureInput;
    typedef mozilla::layers::GeckoContentController::TapType TapType;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::WidgetInputEvent WidgetInputEvent;
    typedef mozilla::WidgetMouseEventBase WidgetMouseEventBase;
    typedef mozilla::WidgetTouchEvent WidgetTouchEvent;
    typedef mozilla::WidgetWheelEvent WidgetWheelEvent;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;

    typedef PAPZCTreeManager::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvHandleTap(
            const TapType& aType,
            const LayoutDevicePoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyPinchGesture(
            const PinchGestureType& aType,
            const ScrollableLayerGuid& aGuid,
            const LayoutDeviceCoord& aSpanChange,
            const Modifiers& aModifiers) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCancelAutoscroll(const ViewID& aScrollId) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZCTreeManagerChild();

    virtual ~PAPZCTreeManagerChild();

    PCompositorBridgeChild*
    Manager() const;

    bool
    SendZoomToRect(
            const ScrollableLayerGuid& aGuid,
            const CSSRect& aRect,
            const uint32_t& Flags);

    bool
    SendContentReceivedInputBlock(
            const uint64_t& aInputBlockId,
            const bool& PreventDefault);

    bool
    SendSetTargetAPZC(
            const uint64_t& aInputBlockId,
            const nsTArray<ScrollableLayerGuid>& Targets);

    bool
    SendUpdateZoomConstraints(
            const ScrollableLayerGuid& aGuid,
            const MaybeZoomConstraints& aConstraints);

    bool
    SendSetKeyboardMap(const KeyboardMap& aKeyboardMap);

    bool
    SendSetDPI(const float& aDpiValue);

    bool
    SendSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            const nsTArray<TouchBehaviorFlags>& aValues);

    bool
    SendStartScrollbarDrag(
            const ScrollableLayerGuid& aGuid,
            const AsyncDragMetrics& aDragMetrics);

    bool
    SendStartAutoscroll(
            const ScrollableLayerGuid& aGuid,
            const ScreenPoint& aAnchorLocation);

    bool
    SendStopAutoscroll(const ScrollableLayerGuid& aGuid);

    bool
    SendSetLongTapEnabled(const bool& aTapGestureEnabled);

    bool
    SendProcessTouchVelocity(
            const uint32_t& aTimestampMs,
            const float& aSpeedY);

    bool
    SendReceiveMultiTouchInputEvent(
            const MultiTouchInput& aEvent,
            nsEventStatus* aOutStatus,
            MultiTouchInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendReceiveMouseInputEvent(
            const MouseInput& aEvent,
            nsEventStatus* aOutStatus,
            MouseInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendReceivePanGestureInputEvent(
            const PanGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PanGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendReceivePinchGestureInputEvent(
            const PinchGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PinchGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendReceiveTapGestureInputEvent(
            const TapGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            TapGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendReceiveScrollWheelInputEvent(
            const ScrollWheelInput& aEvent,
            nsEventStatus* aOutStatus,
            ScrollWheelInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendReceiveKeyboardInputEvent(
            const KeyboardInput& aEvent,
            nsEventStatus* aOutStatus,
            KeyboardInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    bool
    SendUpdateWheelTransaction(
            const LayoutDeviceIntPoint& aRefPoint,
            const EventMessage& aEventMessage);

    bool
    SendProcessUnhandledEvent(
            const LayoutDeviceIntPoint& aRefPoint,
            LayoutDeviceIntPoint* aOutRefPoint,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutFocusSequenceNumber);

    static bool
    Send__delete__(PAPZCTreeManagerChild* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PAPZCTreeManagerChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PAPZCTreeManagerChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace layers
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZCTreeManagerChild :
    public PAPZCTreeManagerChild
{
    virtual mozilla::ipc::IPCResult
    RecvHandleTap(
            const TapType& aType,
            const LayoutDevicePoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId);

    virtual mozilla::ipc::IPCResult
    RecvNotifyPinchGesture(
            const PinchGestureType& aType,
            const ScrollableLayerGuid& aGuid,
            const LayoutDeviceCoord& aSpanChange,
            const Modifiers& aModifiers);

    virtual mozilla::ipc::IPCResult
    RecvCancelAutoscroll(const ViewID& aScrollId);

    MOZ_IMPLICIT APZCTreeManagerChild();
    virtual ~APZCTreeManagerChild();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
mozilla::ipc::IPCResult
APZCTreeManagerChild::RecvHandleTap(
        const TapType& aType,
        const LayoutDevicePoint& point,
        const Modifiers& aModifiers,
        const ScrollableLayerGuid& aGuid,
        const uint64_t& aInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerChild::RecvNotifyPinchGesture(
        const PinchGestureType& aType,
        const ScrollableLayerGuid& aGuid,
        const LayoutDeviceCoord& aSpanChange,
        const Modifiers& aModifiers)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerChild::RecvCancelAutoscroll(const ViewID& aScrollId)
{
}

MOZ_IMPLICIT APZCTreeManagerChild::APZCTreeManagerChild()
{
    MOZ_COUNT_CTOR(APZCTreeManagerChild);
}

MOZ_IMPLICIT APZCTreeManagerChild::~APZCTreeManagerChild()
{
    MOZ_COUNT_DTOR(APZCTreeManagerChild);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZCTreeManagerChild_h
