//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZChild_h
#define PAPZChild_h

#include "mozilla/layers/PAPZ.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "Units.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/layers/APZUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"
#include "mozilla/layers/LayersMessageUtils.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct FrameMetrics;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

class nsRegion;

namespace mozilla {
namespace layers {


class PAPZChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PCompositorBridgeChild;
protected:
    typedef mozilla::layers::GeckoContentController::APZStateChange APZStateChange;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::dom::ContentParentId ContentParentId;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::FrameMetrics FrameMetrics;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;

    typedef PAPZ::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvRequestContentRepaint(const FrameMetrics& frame) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateOverscrollVelocity(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateOverscrollOffset(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyMozMouseScrollEvent(
            const ViewID& aScrollId,
            const nsString& aEvent) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyAPZStateChange(
            const ScrollableLayerGuid& aGuid,
            const APZStateChange& aChange,
            const int& aArg) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyFlushComplete() = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyAutoscrollHandledByAPZ(const ViewID& aScrollId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDestroy() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZChild();

    virtual ~PAPZChild();

    PCompositorBridgeChild*
    Manager() const;

    static bool
    Send__delete__(PAPZChild* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PAPZChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PAPZChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace layers
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZChild :
    public PAPZChild
{
    virtual mozilla::ipc::IPCResult
    RecvRequestContentRepaint(const FrameMetrics& frame);

    virtual mozilla::ipc::IPCResult
    RecvUpdateOverscrollVelocity(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent);

    virtual mozilla::ipc::IPCResult
    RecvUpdateOverscrollOffset(
            const float& aX,
            const float& aY,
            const bool& aIsRootContent);

    virtual mozilla::ipc::IPCResult
    RecvNotifyMozMouseScrollEvent(
            const ViewID& aScrollId,
            const nsString& aEvent);

    virtual mozilla::ipc::IPCResult
    RecvNotifyAPZStateChange(
            const ScrollableLayerGuid& aGuid,
            const APZStateChange& aChange,
            const int& aArg);

    virtual mozilla::ipc::IPCResult
    RecvNotifyFlushComplete();

    virtual mozilla::ipc::IPCResult
    RecvNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId);

    virtual mozilla::ipc::IPCResult
    RecvNotifyAutoscrollHandledByAPZ(const ViewID& aScrollId);

    virtual mozilla::ipc::IPCResult
    RecvDestroy();

    MOZ_IMPLICIT APZChild();
    virtual ~APZChild();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
mozilla::ipc::IPCResult
APZChild::RecvRequestContentRepaint(const FrameMetrics& frame)
{
}

mozilla::ipc::IPCResult
APZChild::RecvUpdateOverscrollVelocity(
        const float& aX,
        const float& aY,
        const bool& aIsRootContent)
{
}

mozilla::ipc::IPCResult
APZChild::RecvUpdateOverscrollOffset(
        const float& aX,
        const float& aY,
        const bool& aIsRootContent)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyMozMouseScrollEvent(
        const ViewID& aScrollId,
        const nsString& aEvent)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyAPZStateChange(
        const ScrollableLayerGuid& aGuid,
        const APZStateChange& aChange,
        const int& aArg)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyFlushComplete()
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyAsyncScrollbarDragRejected(const ViewID& aScrollId)
{
}

mozilla::ipc::IPCResult
APZChild::RecvNotifyAutoscrollHandledByAPZ(const ViewID& aScrollId)
{
}

mozilla::ipc::IPCResult
APZChild::RecvDestroy()
{
}

MOZ_IMPLICIT APZChild::APZChild()
{
    MOZ_COUNT_CTOR(APZChild);
}

MOZ_IMPLICIT APZChild::~APZChild()
{
    MOZ_COUNT_DTOR(APZChild);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZChild_h
