//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef WebRenderMessages_h
#define WebRenderMessages_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/gfx/Matrix.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/webrender/WebRenderTypes.h"
#include "mozilla/webrender/webrender_ffi.h"
#include "mozilla/layers/LayersSurfaces.h"
#include "mozilla/layers/LayersMessages.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalTransform|
//
namespace mozilla {
namespace layers {
class OptionalTransform final
{
public:
    enum Type {
        T__None,
        TMatrix4x4 = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::void_t void_t;
    typedef Matrix4x4 Matrix4x4__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Matrix4x4> VMatrix4x4;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    Matrix4x4*
    ptr_Matrix4x4()
    {
        return ((mValue).VMatrix4x4).addr();
    }
    const Matrix4x4*
    constptr_Matrix4x4() const
    {
        return ((mValue).VMatrix4x4).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalTransform() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalTransform(const Matrix4x4& aOther);

    MOZ_IMPLICIT OptionalTransform(const void_t& aOther);

    MOZ_IMPLICIT OptionalTransform(const OptionalTransform& aOther);

    ~OptionalTransform();

    Type
    type() const
    {
        return mType;
    }

    OptionalTransform&
    operator=(const Matrix4x4& aRhs);

    OptionalTransform&
    operator=(const void_t& aRhs);

    OptionalTransform&
    operator=(const OptionalTransform& aRhs);

    bool
    operator==(const Matrix4x4& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalTransform& aRhs) const;

    Matrix4x4&
    get_Matrix4x4()
    {
        AssertSanity(TMatrix4x4);
        return (*(ptr_Matrix4x4()));
    }
    const Matrix4x4&
    get_Matrix4x4() const
    {
        AssertSanity(TMatrix4x4);
        return (*(constptr_Matrix4x4()));
    }
    void
    get(Matrix4x4* aOutValue) const;
    operator Matrix4x4&()
    {
        return get_Matrix4x4();
    }
    operator const Matrix4x4&() const
    {
        return get_Matrix4x4();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalOpacity|
//
namespace mozilla {
namespace layers {
class OptionalOpacity final
{
public:
    enum Type {
        T__None,
        Tfloat = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::void_t void_t;
    typedef float float__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<float> Vfloat;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    float*
    ptr_float()
    {
        return ((mValue).Vfloat).addr();
    }
    const float*
    constptr_float() const
    {
        return ((mValue).Vfloat).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalOpacity() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalOpacity(const float& aOther);

    MOZ_IMPLICIT OptionalOpacity(const void_t& aOther);

    MOZ_IMPLICIT OptionalOpacity(const OptionalOpacity& aOther);

    ~OptionalOpacity();

    Type
    type() const
    {
        return mType;
    }

    OptionalOpacity&
    operator=(const float& aRhs);

    OptionalOpacity&
    operator=(const void_t& aRhs);

    OptionalOpacity&
    operator=(const OptionalOpacity& aRhs);

    bool
    operator==(const float& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalOpacity& aRhs) const;

    float&
    get_float()
    {
        AssertSanity(Tfloat);
        return (*(ptr_float()));
    }
    const float&
    get_float() const
    {
        AssertSanity(Tfloat);
        return (*(constptr_float()));
    }
    void
    get(float* aOutValue) const;
    operator float&()
    {
        return get_float();
    }
    operator const float&() const
    {
        return get_float();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddExternalImage|
//
namespace mozilla {
namespace layers {
class OpAddExternalImage final
{
private:
    typedef mozilla::wr::ExternalImageId ExternalImageId;
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpAddExternalImage();

    MOZ_IMPLICIT OpAddExternalImage(
            const ExternalImageId& _externalImageId,
            const ImageKey& _key)
    {
        Init();
        Assign(_externalImageId, _key);
    }

    MOZ_IMPLICIT OpAddExternalImage(const OpAddExternalImage& _o)
    {
        Init();
        Assign((_o).externalImageId(), (_o).key());
    }

    ~OpAddExternalImage();

    void
    operator=(const OpAddExternalImage& _o)
    {
        Assign((_o).externalImageId(), (_o).key());
    }

    bool
    operator==(const OpAddExternalImage& _o) const;

    bool
    operator!=(const OpAddExternalImage& _o) const;

    ExternalImageId&
    externalImageId()
    {
        return externalImageId_;
    }
    const ExternalImageId&
    externalImageId() const
    {
        return externalImageId_;
    }

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(
            const ExternalImageId& _externalImageId,
            const ImageKey& _key);

    ExternalImageId externalImageId_;
    ImageKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CompositorAnimations;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OptionalTransform;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OptionalOpacity;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddCompositorAnimations|
//
namespace mozilla {
namespace layers {
class OpAddCompositorAnimations final
{
private:
    typedef mozilla::layers::CompositorAnimations CompositorAnimations;
    typedef mozilla::layers::OptionalTransform OptionalTransform;
    typedef mozilla::layers::OptionalOpacity OptionalOpacity;

public:
    MOZ_IMPLICIT OpAddCompositorAnimations();

    MOZ_IMPLICIT OpAddCompositorAnimations(
            const CompositorAnimations& _data,
            const OptionalTransform& _transform,
            const OptionalOpacity& _opacity)
    {
        Init();
        Assign(_data, _transform, _opacity);
    }

    MOZ_IMPLICIT OpAddCompositorAnimations(const OpAddCompositorAnimations& _o)
    {
        Init();
        Assign((_o).data(), (_o).transform(), (_o).opacity());
    }

    ~OpAddCompositorAnimations();

    void
    operator=(const OpAddCompositorAnimations& _o)
    {
        Assign((_o).data(), (_o).transform(), (_o).opacity());
    }

    bool
    operator==(const OpAddCompositorAnimations& _o) const;

    bool
    operator!=(const OpAddCompositorAnimations& _o) const;

    CompositorAnimations&
    data()
    {
        return data_;
    }
    const CompositorAnimations&
    data() const
    {
        return data_;
    }

    OptionalTransform&
    transform()
    {
        return transform_;
    }
    const OptionalTransform&
    transform() const
    {
        return transform_;
    }

    OptionalOpacity&
    opacity()
    {
        return opacity_;
    }
    const OptionalOpacity&
    opacity() const
    {
        return opacity_;
    }

private:
    void
    Init();

    void
    Assign(
            const CompositorAnimations& _data,
            const OptionalTransform& _transform,
            const OptionalOpacity& _opacity);

    CompositorAnimations data_;
    OptionalTransform transform_;
    OptionalOpacity opacity_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUpdateAsyncImagePipeline|
//
namespace mozilla {
namespace layers {
class OpUpdateAsyncImagePipeline final
{
private:
    typedef mozilla::wr::PipelineId PipelineId;
    typedef mozilla::LayerRect LayerRect;
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::gfx::MaybeIntSize MaybeIntSize;
    typedef mozilla::wr::ImageRendering ImageRendering;
    typedef mozilla::wr::MixBlendMode MixBlendMode;

public:
    MOZ_IMPLICIT OpUpdateAsyncImagePipeline();

    MOZ_IMPLICIT OpUpdateAsyncImagePipeline(
            const PipelineId& _pipelineId,
            const LayerRect& _scBounds,
            const Matrix4x4& _scTransform,
            const MaybeIntSize& _scaleToSize,
            const ImageRendering& _filter,
            const MixBlendMode& _mixBlendMode)
    {
        Init();
        Assign(_pipelineId, _scBounds, _scTransform, _scaleToSize, _filter, _mixBlendMode);
    }

    MOZ_IMPLICIT OpUpdateAsyncImagePipeline(const OpUpdateAsyncImagePipeline& _o)
    {
        Init();
        Assign((_o).pipelineId(), (_o).scBounds(), (_o).scTransform(), (_o).scaleToSize(), (_o).filter(), (_o).mixBlendMode());
    }

    ~OpUpdateAsyncImagePipeline();

    void
    operator=(const OpUpdateAsyncImagePipeline& _o)
    {
        Assign((_o).pipelineId(), (_o).scBounds(), (_o).scTransform(), (_o).scaleToSize(), (_o).filter(), (_o).mixBlendMode());
    }

    bool
    operator==(const OpUpdateAsyncImagePipeline& _o) const;

    bool
    operator!=(const OpUpdateAsyncImagePipeline& _o) const;

    PipelineId&
    pipelineId()
    {
        return pipelineId_;
    }
    const PipelineId&
    pipelineId() const
    {
        return pipelineId_;
    }

    LayerRect&
    scBounds()
    {
        return scBounds_;
    }
    const LayerRect&
    scBounds() const
    {
        return scBounds_;
    }

    Matrix4x4&
    scTransform()
    {
        return scTransform_;
    }
    const Matrix4x4&
    scTransform() const
    {
        return scTransform_;
    }

    MaybeIntSize&
    scaleToSize()
    {
        return scaleToSize_;
    }
    const MaybeIntSize&
    scaleToSize() const
    {
        return scaleToSize_;
    }

    ImageRendering&
    filter()
    {
        return filter_;
    }
    const ImageRendering&
    filter() const
    {
        return filter_;
    }

    MixBlendMode&
    mixBlendMode()
    {
        return mixBlendMode_;
    }
    const MixBlendMode&
    mixBlendMode() const
    {
        return mixBlendMode_;
    }

private:
    void
    Init();

    void
    Assign(
            const PipelineId& _pipelineId,
            const LayerRect& _scBounds,
            const Matrix4x4& _scTransform,
            const MaybeIntSize& _scaleToSize,
            const ImageRendering& _filter,
            const MixBlendMode& _mixBlendMode);

    PipelineId pipelineId_;
    LayerRect scBounds_;
    Matrix4x4 scTransform_;
    MaybeIntSize scaleToSize_;
    ImageRendering filter_;
    MixBlendMode mixBlendMode_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpUpdateAsyncImagePipeline;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CompositableOperation;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAddCompositorAnimations;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebRenderParentCommand|
//
namespace mozilla {
namespace layers {
class WebRenderParentCommand final
{
public:
    enum Type {
        T__None,
        TOpUpdateAsyncImagePipeline = 1,
        TCompositableOperation,
        TOpAddCompositorAnimations,
        T__Last = TOpAddCompositorAnimations
    };

private:
    typedef mozilla::layers::OpUpdateAsyncImagePipeline OpUpdateAsyncImagePipeline;
    typedef mozilla::layers::CompositableOperation CompositableOperation;
    typedef mozilla::layers::OpAddCompositorAnimations OpAddCompositorAnimations;
    typedef OpUpdateAsyncImagePipeline OpUpdateAsyncImagePipeline__tdef;
    typedef CompositableOperation CompositableOperation__tdef;
    typedef OpAddCompositorAnimations OpAddCompositorAnimations__tdef;

    union Value {
        mozilla::AlignedStorage2<OpUpdateAsyncImagePipeline> VOpUpdateAsyncImagePipeline;
        mozilla::AlignedStorage2<CompositableOperation> VCompositableOperation;
        mozilla::AlignedStorage2<OpAddCompositorAnimations> VOpAddCompositorAnimations;
    };

    OpUpdateAsyncImagePipeline*
    ptr_OpUpdateAsyncImagePipeline()
    {
        return ((mValue).VOpUpdateAsyncImagePipeline).addr();
    }
    const OpUpdateAsyncImagePipeline*
    constptr_OpUpdateAsyncImagePipeline() const
    {
        return ((mValue).VOpUpdateAsyncImagePipeline).addr();
    }
    CompositableOperation*
    ptr_CompositableOperation()
    {
        return ((mValue).VCompositableOperation).addr();
    }
    const CompositableOperation*
    constptr_CompositableOperation() const
    {
        return ((mValue).VCompositableOperation).addr();
    }
    OpAddCompositorAnimations*
    ptr_OpAddCompositorAnimations()
    {
        return ((mValue).VOpAddCompositorAnimations).addr();
    }
    const OpAddCompositorAnimations*
    constptr_OpAddCompositorAnimations() const
    {
        return ((mValue).VOpAddCompositorAnimations).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebRenderParentCommand() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebRenderParentCommand(const OpUpdateAsyncImagePipeline& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const CompositableOperation& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const OpAddCompositorAnimations& aOther);

    MOZ_IMPLICIT WebRenderParentCommand(const WebRenderParentCommand& aOther);

    ~WebRenderParentCommand();

    Type
    type() const
    {
        return mType;
    }

    WebRenderParentCommand&
    operator=(const OpUpdateAsyncImagePipeline& aRhs);

    WebRenderParentCommand&
    operator=(const CompositableOperation& aRhs);

    WebRenderParentCommand&
    operator=(const OpAddCompositorAnimations& aRhs);

    WebRenderParentCommand&
    operator=(const WebRenderParentCommand& aRhs);

    bool
    operator==(const OpUpdateAsyncImagePipeline& aRhs) const;

    bool
    operator==(const CompositableOperation& aRhs) const;

    bool
    operator==(const OpAddCompositorAnimations& aRhs) const;

    bool
    operator==(const WebRenderParentCommand& aRhs) const;

    OpUpdateAsyncImagePipeline&
    get_OpUpdateAsyncImagePipeline()
    {
        AssertSanity(TOpUpdateAsyncImagePipeline);
        return (*(ptr_OpUpdateAsyncImagePipeline()));
    }
    const OpUpdateAsyncImagePipeline&
    get_OpUpdateAsyncImagePipeline() const
    {
        AssertSanity(TOpUpdateAsyncImagePipeline);
        return (*(constptr_OpUpdateAsyncImagePipeline()));
    }
    void
    get(OpUpdateAsyncImagePipeline* aOutValue) const;
    operator OpUpdateAsyncImagePipeline&()
    {
        return get_OpUpdateAsyncImagePipeline();
    }
    operator const OpUpdateAsyncImagePipeline&() const
    {
        return get_OpUpdateAsyncImagePipeline();
    }

    CompositableOperation&
    get_CompositableOperation()
    {
        AssertSanity(TCompositableOperation);
        return (*(ptr_CompositableOperation()));
    }
    const CompositableOperation&
    get_CompositableOperation() const
    {
        AssertSanity(TCompositableOperation);
        return (*(constptr_CompositableOperation()));
    }
    void
    get(CompositableOperation* aOutValue) const;
    operator CompositableOperation&()
    {
        return get_CompositableOperation();
    }
    operator const CompositableOperation&() const
    {
        return get_CompositableOperation();
    }

    OpAddCompositorAnimations&
    get_OpAddCompositorAnimations()
    {
        AssertSanity(TOpAddCompositorAnimations);
        return (*(ptr_OpAddCompositorAnimations()));
    }
    const OpAddCompositorAnimations&
    get_OpAddCompositorAnimations() const
    {
        AssertSanity(TOpAddCompositorAnimations);
        return (*(constptr_OpAddCompositorAnimations()));
    }
    void
    get(OpAddCompositorAnimations* aOutValue) const;
    operator OpAddCompositorAnimations&()
    {
        return get_OpAddCompositorAnimations();
    }
    operator const OpAddCompositorAnimations&() const
    {
        return get_OpAddCompositorAnimations();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OffsetRange|
//
namespace mozilla {
namespace layers {
class OffsetRange final
{
private:

public:
    MOZ_IMPLICIT OffsetRange();

    MOZ_IMPLICIT OffsetRange(
            const uint32_t& _source,
            const uint32_t& _start,
            const uint32_t& _length)
    {
        Init();
        Assign(_source, _start, _length);
    }

    MOZ_IMPLICIT OffsetRange(const OffsetRange& _o)
    {
        Init();
        Assign((_o).source(), (_o).start(), (_o).length());
    }

    ~OffsetRange();

    void
    operator=(const OffsetRange& _o)
    {
        Assign((_o).source(), (_o).start(), (_o).length());
    }

    bool
    operator==(const OffsetRange& _o) const;

    bool
    operator!=(const OffsetRange& _o) const;

    uint32_t&
    source()
    {
        return source_;
    }
    const uint32_t&
    source() const
    {
        return source_;
    }

    uint32_t&
    start()
    {
        return start_;
    }
    const uint32_t&
    start() const
    {
        return start_;
    }

    uint32_t&
    length()
    {
        return length_;
    }
    const uint32_t&
    length() const
    {
        return length_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _source,
            const uint32_t& _start,
            const uint32_t& _length);

    uint32_t source_;
    uint32_t start_;
    uint32_t length_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OffsetRange;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddImage|
//
namespace mozilla {
namespace layers {
class OpAddImage final
{
private:
    typedef mozilla::wr::ImageDescriptor ImageDescriptor;
    typedef mozilla::layers::OffsetRange OffsetRange;
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpAddImage();

    MOZ_IMPLICIT OpAddImage(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const uint16_t& _tiling,
            const ImageKey& _key)
    {
        Init();
        Assign(_descriptor, _bytes, _tiling, _key);
    }

    MOZ_IMPLICIT OpAddImage(const OpAddImage& _o)
    {
        Init();
        Assign((_o).descriptor(), (_o).bytes(), (_o).tiling(), (_o).key());
    }

    ~OpAddImage();

    void
    operator=(const OpAddImage& _o)
    {
        Assign((_o).descriptor(), (_o).bytes(), (_o).tiling(), (_o).key());
    }

    bool
    operator==(const OpAddImage& _o) const;

    bool
    operator!=(const OpAddImage& _o) const;

    ImageDescriptor&
    descriptor()
    {
        return descriptor_;
    }
    const ImageDescriptor&
    descriptor() const
    {
        return descriptor_;
    }

    OffsetRange&
    bytes()
    {
        return bytes_;
    }
    const OffsetRange&
    bytes() const
    {
        return bytes_;
    }

    uint16_t&
    tiling()
    {
        return tiling_;
    }
    const uint16_t&
    tiling() const
    {
        return tiling_;
    }

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const uint16_t& _tiling,
            const ImageKey& _key);

    ImageDescriptor descriptor_;
    OffsetRange bytes_;
    uint16_t tiling_;
    ImageKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OffsetRange;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddBlobImage|
//
namespace mozilla {
namespace layers {
class OpAddBlobImage final
{
private:
    typedef mozilla::wr::ImageDescriptor ImageDescriptor;
    typedef mozilla::layers::OffsetRange OffsetRange;
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpAddBlobImage();

    MOZ_IMPLICIT OpAddBlobImage(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const uint16_t& _tiling,
            const ImageKey& _key)
    {
        Init();
        Assign(_descriptor, _bytes, _tiling, _key);
    }

    MOZ_IMPLICIT OpAddBlobImage(const OpAddBlobImage& _o)
    {
        Init();
        Assign((_o).descriptor(), (_o).bytes(), (_o).tiling(), (_o).key());
    }

    ~OpAddBlobImage();

    void
    operator=(const OpAddBlobImage& _o)
    {
        Assign((_o).descriptor(), (_o).bytes(), (_o).tiling(), (_o).key());
    }

    bool
    operator==(const OpAddBlobImage& _o) const;

    bool
    operator!=(const OpAddBlobImage& _o) const;

    ImageDescriptor&
    descriptor()
    {
        return descriptor_;
    }
    const ImageDescriptor&
    descriptor() const
    {
        return descriptor_;
    }

    OffsetRange&
    bytes()
    {
        return bytes_;
    }
    const OffsetRange&
    bytes() const
    {
        return bytes_;
    }

    uint16_t&
    tiling()
    {
        return tiling_;
    }
    const uint16_t&
    tiling() const
    {
        return tiling_;
    }

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const uint16_t& _tiling,
            const ImageKey& _key);

    ImageDescriptor descriptor_;
    OffsetRange bytes_;
    uint16_t tiling_;
    ImageKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OffsetRange;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUpdateImage|
//
namespace mozilla {
namespace layers {
class OpUpdateImage final
{
private:
    typedef mozilla::wr::ImageDescriptor ImageDescriptor;
    typedef mozilla::layers::OffsetRange OffsetRange;
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpUpdateImage();

    MOZ_IMPLICIT OpUpdateImage(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const ImageKey& _key)
    {
        Init();
        Assign(_descriptor, _bytes, _key);
    }

    MOZ_IMPLICIT OpUpdateImage(const OpUpdateImage& _o)
    {
        Init();
        Assign((_o).descriptor(), (_o).bytes(), (_o).key());
    }

    ~OpUpdateImage();

    void
    operator=(const OpUpdateImage& _o)
    {
        Assign((_o).descriptor(), (_o).bytes(), (_o).key());
    }

    bool
    operator==(const OpUpdateImage& _o) const;

    bool
    operator!=(const OpUpdateImage& _o) const;

    ImageDescriptor&
    descriptor()
    {
        return descriptor_;
    }
    const ImageDescriptor&
    descriptor() const
    {
        return descriptor_;
    }

    OffsetRange&
    bytes()
    {
        return bytes_;
    }
    const OffsetRange&
    bytes() const
    {
        return bytes_;
    }

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const ImageKey& _key);

    ImageDescriptor descriptor_;
    OffsetRange bytes_;
    ImageKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OffsetRange;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUpdateBlobImage|
//
namespace mozilla {
namespace layers {
class OpUpdateBlobImage final
{
private:
    typedef mozilla::wr::ImageDescriptor ImageDescriptor;
    typedef mozilla::layers::OffsetRange OffsetRange;
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpUpdateBlobImage();

    MOZ_IMPLICIT OpUpdateBlobImage(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const ImageKey& _key)
    {
        Init();
        Assign(_descriptor, _bytes, _key);
    }

    MOZ_IMPLICIT OpUpdateBlobImage(const OpUpdateBlobImage& _o)
    {
        Init();
        Assign((_o).descriptor(), (_o).bytes(), (_o).key());
    }

    ~OpUpdateBlobImage();

    void
    operator=(const OpUpdateBlobImage& _o)
    {
        Assign((_o).descriptor(), (_o).bytes(), (_o).key());
    }

    bool
    operator==(const OpUpdateBlobImage& _o) const;

    bool
    operator!=(const OpUpdateBlobImage& _o) const;

    ImageDescriptor&
    descriptor()
    {
        return descriptor_;
    }
    const ImageDescriptor&
    descriptor() const
    {
        return descriptor_;
    }

    OffsetRange&
    bytes()
    {
        return bytes_;
    }
    const OffsetRange&
    bytes() const
    {
        return bytes_;
    }

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(
            const ImageDescriptor& _descriptor,
            const OffsetRange& _bytes,
            const ImageKey& _key);

    ImageDescriptor descriptor_;
    OffsetRange bytes_;
    ImageKey key_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeleteImage|
//
namespace mozilla {
namespace layers {
class OpDeleteImage final
{
private:
    typedef mozilla::wr::ImageKey ImageKey;

public:
    MOZ_IMPLICIT OpDeleteImage();

    MOZ_IMPLICIT OpDeleteImage(const ImageKey& _key)
    {
        Init();
        Assign(_key);
    }

    MOZ_IMPLICIT OpDeleteImage(const OpDeleteImage& _o)
    {
        Init();
        Assign((_o).key());
    }

    ~OpDeleteImage();

    void
    operator=(const OpDeleteImage& _o)
    {
        Assign((_o).key());
    }

    bool
    operator==(const OpDeleteImage& _o) const;

    bool
    operator!=(const OpDeleteImage& _o) const;

    ImageKey&
    key()
    {
        return key_;
    }
    const ImageKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(const ImageKey& _key);

    ImageKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OffsetRange;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddRawFont|
//
namespace mozilla {
namespace layers {
class OpAddRawFont final
{
private:
    typedef mozilla::layers::OffsetRange OffsetRange;
    typedef mozilla::wr::FontKey FontKey;

public:
    MOZ_IMPLICIT OpAddRawFont();

    MOZ_IMPLICIT OpAddRawFont(
            const OffsetRange& _bytes,
            const uint32_t& _fontIndex,
            const FontKey& _key)
    {
        Init();
        Assign(_bytes, _fontIndex, _key);
    }

    MOZ_IMPLICIT OpAddRawFont(const OpAddRawFont& _o)
    {
        Init();
        Assign((_o).bytes(), (_o).fontIndex(), (_o).key());
    }

    ~OpAddRawFont();

    void
    operator=(const OpAddRawFont& _o)
    {
        Assign((_o).bytes(), (_o).fontIndex(), (_o).key());
    }

    bool
    operator==(const OpAddRawFont& _o) const;

    bool
    operator!=(const OpAddRawFont& _o) const;

    OffsetRange&
    bytes()
    {
        return bytes_;
    }
    const OffsetRange&
    bytes() const
    {
        return bytes_;
    }

    uint32_t&
    fontIndex()
    {
        return fontIndex_;
    }
    const uint32_t&
    fontIndex() const
    {
        return fontIndex_;
    }

    FontKey&
    key()
    {
        return key_;
    }
    const FontKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(
            const OffsetRange& _bytes,
            const uint32_t& _fontIndex,
            const FontKey& _key);

    OffsetRange bytes_;
    uint32_t fontIndex_;
    FontKey key_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeleteFont|
//
namespace mozilla {
namespace layers {
class OpDeleteFont final
{
private:
    typedef mozilla::wr::FontKey FontKey;

public:
    MOZ_IMPLICIT OpDeleteFont();

    MOZ_IMPLICIT OpDeleteFont(const FontKey& _key)
    {
        Init();
        Assign(_key);
    }

    MOZ_IMPLICIT OpDeleteFont(const OpDeleteFont& _o)
    {
        Init();
        Assign((_o).key());
    }

    ~OpDeleteFont();

    void
    operator=(const OpDeleteFont& _o)
    {
        Assign((_o).key());
    }

    bool
    operator==(const OpDeleteFont& _o) const;

    bool
    operator!=(const OpDeleteFont& _o) const;

    FontKey&
    key()
    {
        return key_;
    }
    const FontKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(const FontKey& _key);

    FontKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OffsetRange;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAddFontInstance|
//
namespace mozilla {
namespace layers {
class OpAddFontInstance final
{
private:
    typedef mozilla::wr::MaybeFontInstanceOptions MaybeFontInstanceOptions;
    typedef mozilla::wr::MaybeFontInstancePlatformOptions MaybeFontInstancePlatformOptions;
    typedef mozilla::layers::OffsetRange OffsetRange;
    typedef mozilla::wr::FontInstanceKey FontInstanceKey;
    typedef mozilla::wr::FontKey FontKey;

public:
    MOZ_IMPLICIT OpAddFontInstance();

    MOZ_IMPLICIT OpAddFontInstance(
            const MaybeFontInstanceOptions& _options,
            const MaybeFontInstancePlatformOptions& _platformOptions,
            const OffsetRange& _variations,
            const FontInstanceKey& _instanceKey,
            const FontKey& _fontKey,
            const float& _glyphSize)
    {
        Init();
        Assign(_options, _platformOptions, _variations, _instanceKey, _fontKey, _glyphSize);
    }

    MOZ_IMPLICIT OpAddFontInstance(const OpAddFontInstance& _o)
    {
        Init();
        Assign((_o).options(), (_o).platformOptions(), (_o).variations(), (_o).instanceKey(), (_o).fontKey(), (_o).glyphSize());
    }

    ~OpAddFontInstance();

    void
    operator=(const OpAddFontInstance& _o)
    {
        Assign((_o).options(), (_o).platformOptions(), (_o).variations(), (_o).instanceKey(), (_o).fontKey(), (_o).glyphSize());
    }

    bool
    operator==(const OpAddFontInstance& _o) const;

    bool
    operator!=(const OpAddFontInstance& _o) const;

    MaybeFontInstanceOptions&
    options()
    {
        return options_;
    }
    const MaybeFontInstanceOptions&
    options() const
    {
        return options_;
    }

    MaybeFontInstancePlatformOptions&
    platformOptions()
    {
        return platformOptions_;
    }
    const MaybeFontInstancePlatformOptions&
    platformOptions() const
    {
        return platformOptions_;
    }

    OffsetRange&
    variations()
    {
        return variations_;
    }
    const OffsetRange&
    variations() const
    {
        return variations_;
    }

    FontInstanceKey&
    instanceKey()
    {
        return instanceKey_;
    }
    const FontInstanceKey&
    instanceKey() const
    {
        return instanceKey_;
    }

    FontKey&
    fontKey()
    {
        return fontKey_;
    }
    const FontKey&
    fontKey() const
    {
        return fontKey_;
    }

    float&
    glyphSize()
    {
        return glyphSize_;
    }
    const float&
    glyphSize() const
    {
        return glyphSize_;
    }

private:
    void
    Init();

    void
    Assign(
            const MaybeFontInstanceOptions& _options,
            const MaybeFontInstancePlatformOptions& _platformOptions,
            const OffsetRange& _variations,
            const FontInstanceKey& _instanceKey,
            const FontKey& _fontKey,
            const float& _glyphSize);

    MaybeFontInstanceOptions options_;
    MaybeFontInstancePlatformOptions platformOptions_;
    OffsetRange variations_;
    FontInstanceKey instanceKey_;
    FontKey fontKey_;
    float glyphSize_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeleteFontInstance|
//
namespace mozilla {
namespace layers {
class OpDeleteFontInstance final
{
private:
    typedef mozilla::wr::FontInstanceKey FontInstanceKey;

public:
    MOZ_IMPLICIT OpDeleteFontInstance();

    MOZ_IMPLICIT OpDeleteFontInstance(const FontInstanceKey& _key)
    {
        Init();
        Assign(_key);
    }

    MOZ_IMPLICIT OpDeleteFontInstance(const OpDeleteFontInstance& _o)
    {
        Init();
        Assign((_o).key());
    }

    ~OpDeleteFontInstance();

    void
    operator=(const OpDeleteFontInstance& _o)
    {
        Assign((_o).key());
    }

    bool
    operator==(const OpDeleteFontInstance& _o) const;

    bool
    operator!=(const OpDeleteFontInstance& _o) const;

    FontInstanceKey&
    key()
    {
        return key_;
    }
    const FontInstanceKey&
    key() const
    {
        return key_;
    }

private:
    void
    Init();

    void
    Assign(const FontInstanceKey& _key);

    FontInstanceKey key_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpAddImage;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAddBlobImage;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUpdateImage;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUpdateBlobImage;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpDeleteImage;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAddRawFont;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpDeleteFont;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAddFontInstance;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpDeleteFontInstance;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAddExternalImage;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OpUpdateResource|
//
namespace mozilla {
namespace layers {
class OpUpdateResource final
{
public:
    enum Type {
        T__None,
        TOpAddImage = 1,
        TOpAddBlobImage,
        TOpUpdateImage,
        TOpUpdateBlobImage,
        TOpDeleteImage,
        TOpAddRawFont,
        TOpDeleteFont,
        TOpAddFontInstance,
        TOpDeleteFontInstance,
        TOpAddExternalImage,
        T__Last = TOpAddExternalImage
    };

private:
    typedef mozilla::layers::OpAddImage OpAddImage;
    typedef mozilla::layers::OpAddBlobImage OpAddBlobImage;
    typedef mozilla::layers::OpUpdateImage OpUpdateImage;
    typedef mozilla::layers::OpUpdateBlobImage OpUpdateBlobImage;
    typedef mozilla::layers::OpDeleteImage OpDeleteImage;
    typedef mozilla::layers::OpAddRawFont OpAddRawFont;
    typedef mozilla::layers::OpDeleteFont OpDeleteFont;
    typedef mozilla::layers::OpAddFontInstance OpAddFontInstance;
    typedef mozilla::layers::OpDeleteFontInstance OpDeleteFontInstance;
    typedef mozilla::layers::OpAddExternalImage OpAddExternalImage;
    typedef OpAddImage OpAddImage__tdef;
    typedef OpAddBlobImage OpAddBlobImage__tdef;
    typedef OpUpdateImage OpUpdateImage__tdef;
    typedef OpUpdateBlobImage OpUpdateBlobImage__tdef;
    typedef OpDeleteImage OpDeleteImage__tdef;
    typedef OpAddRawFont OpAddRawFont__tdef;
    typedef OpDeleteFont OpDeleteFont__tdef;
    typedef OpAddFontInstance OpAddFontInstance__tdef;
    typedef OpDeleteFontInstance OpDeleteFontInstance__tdef;
    typedef OpAddExternalImage OpAddExternalImage__tdef;

    union Value {
        mozilla::AlignedStorage2<OpAddImage> VOpAddImage;
        mozilla::AlignedStorage2<OpAddBlobImage> VOpAddBlobImage;
        mozilla::AlignedStorage2<OpUpdateImage> VOpUpdateImage;
        mozilla::AlignedStorage2<OpUpdateBlobImage> VOpUpdateBlobImage;
        mozilla::AlignedStorage2<OpDeleteImage> VOpDeleteImage;
        mozilla::AlignedStorage2<OpAddRawFont> VOpAddRawFont;
        mozilla::AlignedStorage2<OpDeleteFont> VOpDeleteFont;
        mozilla::AlignedStorage2<OpAddFontInstance> VOpAddFontInstance;
        mozilla::AlignedStorage2<OpDeleteFontInstance> VOpDeleteFontInstance;
        mozilla::AlignedStorage2<OpAddExternalImage> VOpAddExternalImage;
    };

    OpAddImage*
    ptr_OpAddImage()
    {
        return ((mValue).VOpAddImage).addr();
    }
    const OpAddImage*
    constptr_OpAddImage() const
    {
        return ((mValue).VOpAddImage).addr();
    }
    OpAddBlobImage*
    ptr_OpAddBlobImage()
    {
        return ((mValue).VOpAddBlobImage).addr();
    }
    const OpAddBlobImage*
    constptr_OpAddBlobImage() const
    {
        return ((mValue).VOpAddBlobImage).addr();
    }
    OpUpdateImage*
    ptr_OpUpdateImage()
    {
        return ((mValue).VOpUpdateImage).addr();
    }
    const OpUpdateImage*
    constptr_OpUpdateImage() const
    {
        return ((mValue).VOpUpdateImage).addr();
    }
    OpUpdateBlobImage*
    ptr_OpUpdateBlobImage()
    {
        return ((mValue).VOpUpdateBlobImage).addr();
    }
    const OpUpdateBlobImage*
    constptr_OpUpdateBlobImage() const
    {
        return ((mValue).VOpUpdateBlobImage).addr();
    }
    OpDeleteImage*
    ptr_OpDeleteImage()
    {
        return ((mValue).VOpDeleteImage).addr();
    }
    const OpDeleteImage*
    constptr_OpDeleteImage() const
    {
        return ((mValue).VOpDeleteImage).addr();
    }
    OpAddRawFont*
    ptr_OpAddRawFont()
    {
        return ((mValue).VOpAddRawFont).addr();
    }
    const OpAddRawFont*
    constptr_OpAddRawFont() const
    {
        return ((mValue).VOpAddRawFont).addr();
    }
    OpDeleteFont*
    ptr_OpDeleteFont()
    {
        return ((mValue).VOpDeleteFont).addr();
    }
    const OpDeleteFont*
    constptr_OpDeleteFont() const
    {
        return ((mValue).VOpDeleteFont).addr();
    }
    OpAddFontInstance*
    ptr_OpAddFontInstance()
    {
        return ((mValue).VOpAddFontInstance).addr();
    }
    const OpAddFontInstance*
    constptr_OpAddFontInstance() const
    {
        return ((mValue).VOpAddFontInstance).addr();
    }
    OpDeleteFontInstance*
    ptr_OpDeleteFontInstance()
    {
        return ((mValue).VOpDeleteFontInstance).addr();
    }
    const OpDeleteFontInstance*
    constptr_OpDeleteFontInstance() const
    {
        return ((mValue).VOpDeleteFontInstance).addr();
    }
    OpAddExternalImage*
    ptr_OpAddExternalImage()
    {
        return ((mValue).VOpAddExternalImage).addr();
    }
    const OpAddExternalImage*
    constptr_OpAddExternalImage() const
    {
        return ((mValue).VOpAddExternalImage).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OpUpdateResource() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OpUpdateResource(const OpAddImage& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpAddBlobImage& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpUpdateImage& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpUpdateBlobImage& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpDeleteImage& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpAddRawFont& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpDeleteFont& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpAddFontInstance& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpDeleteFontInstance& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpAddExternalImage& aOther);

    MOZ_IMPLICIT OpUpdateResource(const OpUpdateResource& aOther);

    ~OpUpdateResource();

    Type
    type() const
    {
        return mType;
    }

    OpUpdateResource&
    operator=(const OpAddImage& aRhs);

    OpUpdateResource&
    operator=(const OpAddBlobImage& aRhs);

    OpUpdateResource&
    operator=(const OpUpdateImage& aRhs);

    OpUpdateResource&
    operator=(const OpUpdateBlobImage& aRhs);

    OpUpdateResource&
    operator=(const OpDeleteImage& aRhs);

    OpUpdateResource&
    operator=(const OpAddRawFont& aRhs);

    OpUpdateResource&
    operator=(const OpDeleteFont& aRhs);

    OpUpdateResource&
    operator=(const OpAddFontInstance& aRhs);

    OpUpdateResource&
    operator=(const OpDeleteFontInstance& aRhs);

    OpUpdateResource&
    operator=(const OpAddExternalImage& aRhs);

    OpUpdateResource&
    operator=(const OpUpdateResource& aRhs);

    bool
    operator==(const OpAddImage& aRhs) const;

    bool
    operator==(const OpAddBlobImage& aRhs) const;

    bool
    operator==(const OpUpdateImage& aRhs) const;

    bool
    operator==(const OpUpdateBlobImage& aRhs) const;

    bool
    operator==(const OpDeleteImage& aRhs) const;

    bool
    operator==(const OpAddRawFont& aRhs) const;

    bool
    operator==(const OpDeleteFont& aRhs) const;

    bool
    operator==(const OpAddFontInstance& aRhs) const;

    bool
    operator==(const OpDeleteFontInstance& aRhs) const;

    bool
    operator==(const OpAddExternalImage& aRhs) const;

    bool
    operator==(const OpUpdateResource& aRhs) const;

    OpAddImage&
    get_OpAddImage()
    {
        AssertSanity(TOpAddImage);
        return (*(ptr_OpAddImage()));
    }
    const OpAddImage&
    get_OpAddImage() const
    {
        AssertSanity(TOpAddImage);
        return (*(constptr_OpAddImage()));
    }
    void
    get(OpAddImage* aOutValue) const;
    operator OpAddImage&()
    {
        return get_OpAddImage();
    }
    operator const OpAddImage&() const
    {
        return get_OpAddImage();
    }

    OpAddBlobImage&
    get_OpAddBlobImage()
    {
        AssertSanity(TOpAddBlobImage);
        return (*(ptr_OpAddBlobImage()));
    }
    const OpAddBlobImage&
    get_OpAddBlobImage() const
    {
        AssertSanity(TOpAddBlobImage);
        return (*(constptr_OpAddBlobImage()));
    }
    void
    get(OpAddBlobImage* aOutValue) const;
    operator OpAddBlobImage&()
    {
        return get_OpAddBlobImage();
    }
    operator const OpAddBlobImage&() const
    {
        return get_OpAddBlobImage();
    }

    OpUpdateImage&
    get_OpUpdateImage()
    {
        AssertSanity(TOpUpdateImage);
        return (*(ptr_OpUpdateImage()));
    }
    const OpUpdateImage&
    get_OpUpdateImage() const
    {
        AssertSanity(TOpUpdateImage);
        return (*(constptr_OpUpdateImage()));
    }
    void
    get(OpUpdateImage* aOutValue) const;
    operator OpUpdateImage&()
    {
        return get_OpUpdateImage();
    }
    operator const OpUpdateImage&() const
    {
        return get_OpUpdateImage();
    }

    OpUpdateBlobImage&
    get_OpUpdateBlobImage()
    {
        AssertSanity(TOpUpdateBlobImage);
        return (*(ptr_OpUpdateBlobImage()));
    }
    const OpUpdateBlobImage&
    get_OpUpdateBlobImage() const
    {
        AssertSanity(TOpUpdateBlobImage);
        return (*(constptr_OpUpdateBlobImage()));
    }
    void
    get(OpUpdateBlobImage* aOutValue) const;
    operator OpUpdateBlobImage&()
    {
        return get_OpUpdateBlobImage();
    }
    operator const OpUpdateBlobImage&() const
    {
        return get_OpUpdateBlobImage();
    }

    OpDeleteImage&
    get_OpDeleteImage()
    {
        AssertSanity(TOpDeleteImage);
        return (*(ptr_OpDeleteImage()));
    }
    const OpDeleteImage&
    get_OpDeleteImage() const
    {
        AssertSanity(TOpDeleteImage);
        return (*(constptr_OpDeleteImage()));
    }
    void
    get(OpDeleteImage* aOutValue) const;
    operator OpDeleteImage&()
    {
        return get_OpDeleteImage();
    }
    operator const OpDeleteImage&() const
    {
        return get_OpDeleteImage();
    }

    OpAddRawFont&
    get_OpAddRawFont()
    {
        AssertSanity(TOpAddRawFont);
        return (*(ptr_OpAddRawFont()));
    }
    const OpAddRawFont&
    get_OpAddRawFont() const
    {
        AssertSanity(TOpAddRawFont);
        return (*(constptr_OpAddRawFont()));
    }
    void
    get(OpAddRawFont* aOutValue) const;
    operator OpAddRawFont&()
    {
        return get_OpAddRawFont();
    }
    operator const OpAddRawFont&() const
    {
        return get_OpAddRawFont();
    }

    OpDeleteFont&
    get_OpDeleteFont()
    {
        AssertSanity(TOpDeleteFont);
        return (*(ptr_OpDeleteFont()));
    }
    const OpDeleteFont&
    get_OpDeleteFont() const
    {
        AssertSanity(TOpDeleteFont);
        return (*(constptr_OpDeleteFont()));
    }
    void
    get(OpDeleteFont* aOutValue) const;
    operator OpDeleteFont&()
    {
        return get_OpDeleteFont();
    }
    operator const OpDeleteFont&() const
    {
        return get_OpDeleteFont();
    }

    OpAddFontInstance&
    get_OpAddFontInstance()
    {
        AssertSanity(TOpAddFontInstance);
        return (*(ptr_OpAddFontInstance()));
    }
    const OpAddFontInstance&
    get_OpAddFontInstance() const
    {
        AssertSanity(TOpAddFontInstance);
        return (*(constptr_OpAddFontInstance()));
    }
    void
    get(OpAddFontInstance* aOutValue) const;
    operator OpAddFontInstance&()
    {
        return get_OpAddFontInstance();
    }
    operator const OpAddFontInstance&() const
    {
        return get_OpAddFontInstance();
    }

    OpDeleteFontInstance&
    get_OpDeleteFontInstance()
    {
        AssertSanity(TOpDeleteFontInstance);
        return (*(ptr_OpDeleteFontInstance()));
    }
    const OpDeleteFontInstance&
    get_OpDeleteFontInstance() const
    {
        AssertSanity(TOpDeleteFontInstance);
        return (*(constptr_OpDeleteFontInstance()));
    }
    void
    get(OpDeleteFontInstance* aOutValue) const;
    operator OpDeleteFontInstance&()
    {
        return get_OpDeleteFontInstance();
    }
    operator const OpDeleteFontInstance&() const
    {
        return get_OpDeleteFontInstance();
    }

    OpAddExternalImage&
    get_OpAddExternalImage()
    {
        AssertSanity(TOpAddExternalImage);
        return (*(ptr_OpAddExternalImage()));
    }
    const OpAddExternalImage&
    get_OpAddExternalImage() const
    {
        AssertSanity(TOpAddExternalImage);
        return (*(constptr_OpAddExternalImage()));
    }
    void
    get(OpAddExternalImage* aOutValue) const;
    operator OpAddExternalImage&()
    {
        return get_OpAddExternalImage();
    }
    operator const OpAddExternalImage&() const
    {
        return get_OpAddExternalImage();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

#endif // ifndef WebRenderMessages_h
