//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PScriptCache_h
#define PScriptCache_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/TimeStamp.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScriptData|
//
namespace mozilla {
namespace loader {
class ScriptData final
{
private:
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ScriptData();

    MOZ_IMPLICIT ScriptData(
            const nsCString& _url,
            const nsCString& _cachePath,
            const TimeStamp& _loadTime,
            const nsTArray<uint8_t>& _xdrData)
    {
        Init();
        Assign(_url, _cachePath, _loadTime, _xdrData);
    }

    MOZ_IMPLICIT ScriptData(const ScriptData& _o)
    {
        Init();
        Assign((_o).url(), (_o).cachePath(), (_o).loadTime(), (_o).xdrData());
    }

    ~ScriptData();

    void
    operator=(const ScriptData& _o)
    {
        Assign((_o).url(), (_o).cachePath(), (_o).loadTime(), (_o).xdrData());
    }

    bool
    operator==(const ScriptData& _o) const;

    bool
    operator!=(const ScriptData& _o) const;

    nsCString&
    url()
    {
        return url_;
    }
    const nsCString&
    url() const
    {
        return url_;
    }

    nsCString&
    cachePath()
    {
        return cachePath_;
    }
    const nsCString&
    cachePath() const
    {
        return cachePath_;
    }

    TimeStamp&
    loadTime()
    {
        return loadTime_;
    }
    const TimeStamp&
    loadTime() const
    {
        return loadTime_;
    }

    nsTArray<uint8_t>&
    xdrData()
    {
        return xdrData_;
    }
    const nsTArray<uint8_t>&
    xdrData() const
    {
        return xdrData_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _url,
            const nsCString& _cachePath,
            const TimeStamp& _loadTime,
            const nsTArray<uint8_t>& _xdrData);

    nsCString url_;
    nsCString cachePath_;
    TimeStamp loadTime_;
    nsTArray<uint8_t> xdrData_;
};
} // namespace loader
} // namespace mozilla

namespace mozilla {
namespace loader {
class PScriptCacheParent;
} // namespace loader
} // namespace mozilla
namespace mozilla {
namespace loader {
class PScriptCacheChild;
} // namespace loader
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PScriptCacheChild and PScriptCacheParent
//
namespace mozilla {
namespace loader {
namespace PScriptCache {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::loader::PScriptCacheParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::loader::PScriptCacheChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Start = __Null
};

enum MessageType {
    PScriptCacheStart = PScriptCacheMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    PScriptCacheEnd
};

void
Transition(
        MessageType msg,
        State* next);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PScriptCache
} // namespace loader
} // namespace mozilla

#endif // ifndef PScriptCache_h
