//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMediaSystemResourceManagerParent_h
#define PMediaSystemResourceManagerParent_h

#include "mozilla/media/PMediaSystemResourceManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/media/MediaSystemResourceMessageUtils.h"
#include "mozilla/media/MediaSystemResourceTypes.h"

namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PImageBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace media {


class PMediaSystemResourceManagerParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PImageBridgeParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::MediaSystemResourceType MediaSystemResourceType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::PImageBridgeParent PImageBridgeParent;
    typedef mozilla::layers::PImageBridgeChild PImageBridgeChild;

    typedef PMediaSystemResourceManager::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvAcquire(
            const uint32_t& aId,
            const MediaSystemResourceType& aResourceType,
            const bool& aWillWait) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRelease(const uint32_t& aId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRemoveResourceManager() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PMediaSystemResourceManagerParent();

    virtual ~PMediaSystemResourceManagerParent();

    PImageBridgeParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendResponse(
            const uint32_t& aId,
            const bool& aSuccess);

    MOZ_MUST_USE static bool
    Send__delete__(PMediaSystemResourceManagerParent* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PMediaSystemResourceManagerParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PMediaSystemResourceManagerParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace media
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace media {
class MediaSystemResourceManagerParent :
    public PMediaSystemResourceManagerParent
{
    virtual mozilla::ipc::IPCResult
    RecvAcquire(
            const uint32_t& aId,
            const MediaSystemResourceType& aResourceType,
            const bool& aWillWait);

    virtual mozilla::ipc::IPCResult
    RecvRelease(const uint32_t& aId);

    virtual mozilla::ipc::IPCResult
    RecvRemoveResourceManager();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT MediaSystemResourceManagerParent();
    virtual ~MediaSystemResourceManagerParent();
};
} // namespace media
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace media {
mozilla::ipc::IPCResult
MediaSystemResourceManagerParent::RecvAcquire(
        const uint32_t& aId,
        const MediaSystemResourceType& aResourceType,
        const bool& aWillWait)
{
}

mozilla::ipc::IPCResult
MediaSystemResourceManagerParent::RecvRelease(const uint32_t& aId)
{
}

mozilla::ipc::IPCResult
MediaSystemResourceManagerParent::RecvRemoveResourceManager()
{
}

void
MediaSystemResourceManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT MediaSystemResourceManagerParent::MediaSystemResourceManagerParent()
{
    MOZ_COUNT_CTOR(MediaSystemResourceManagerParent);
}

MOZ_IMPLICIT MediaSystemResourceManagerParent::~MediaSystemResourceManagerParent()
{
    MOZ_COUNT_DTOR(MediaSystemResourceManagerParent);
}

} // namespace media
} // namespace mozilla
#endif // if 0

#endif // ifndef PMediaSystemResourceManagerParent_h
