//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef NeckoChannelParams_h
#define NeckoChannelParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/net/PHttpChannelParams.h"
#include "nsHttpResponseHead.h"
#include "mozilla/dom/BlobTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalURIParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RedirectHistoryEntryInfo|
//
namespace mozilla {
namespace net {
class RedirectHistoryEntryInfo final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;

public:
    MOZ_IMPLICIT RedirectHistoryEntryInfo();

    MOZ_IMPLICIT RedirectHistoryEntryInfo(
            const PrincipalInfo& _principalInfo,
            const OptionalURIParams& _referrerUri,
            const nsCString& _remoteAddress)
    {
        Init();
        Assign(_principalInfo, _referrerUri, _remoteAddress);
    }

    MOZ_IMPLICIT RedirectHistoryEntryInfo(const RedirectHistoryEntryInfo& _o)
    {
        Init();
        Assign((_o).principalInfo(), (_o).referrerUri(), (_o).remoteAddress());
    }

    ~RedirectHistoryEntryInfo();

    void
    operator=(const RedirectHistoryEntryInfo& _o)
    {
        Assign((_o).principalInfo(), (_o).referrerUri(), (_o).remoteAddress());
    }

    bool
    operator==(const RedirectHistoryEntryInfo& _o) const;

    bool
    operator!=(const RedirectHistoryEntryInfo& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    OptionalURIParams&
    referrerUri()
    {
        return referrerUri_;
    }
    const OptionalURIParams&
    referrerUri() const
    {
        return referrerUri_;
    }

    nsCString&
    remoteAddress()
    {
        return remoteAddress_;
    }
    const nsCString&
    remoteAddress() const
    {
        return remoteAddress_;
    }

private:
    void
    Init();

    void
    Assign(
            const PrincipalInfo& _principalInfo,
            const OptionalURIParams& _referrerUri,
            const nsCString& _remoteAddress);

    PrincipalInfo principalInfo_;
    OptionalURIParams referrerUri_;
    nsCString remoteAddress_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class OptionalPrincipalInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalURIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace net {
class RedirectHistoryEntryInfo;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoadInfoArgs|
//
namespace mozilla {
namespace net {
class LoadInfoArgs final
{
private:
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::net::RedirectHistoryEntryInfo RedirectHistoryEntryInfo;

public:
    MOZ_IMPLICIT LoadInfoArgs();

    MOZ_IMPLICIT LoadInfoArgs(
            const OptionalPrincipalInfo& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const OptionalPrincipalInfo& _principalToInheritInfo,
            const OptionalPrincipalInfo& _sandboxedLoadingPrincipalInfo,
            const OptionalURIParams& _resultPrincipalURI,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType,
            const uint32_t& _tainting,
            const bool& _upgradeInsecureRequests,
            const bool& _verifySignedContent,
            const bool& _enforceSRI,
            const bool& _forceInheritPrincipalDropped,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const uint64_t& _topOuterWindowID,
            const uint64_t& _frameOuterWindowID,
            const bool& _enforceSecurity,
            const bool& _initialSecurityCheckDone,
            const bool& _isInThirdPartyContext,
            const OriginAttributes& _originAttributes,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChainIncludingInternalRedirects,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChain,
            const nsTArray<nsCString>& _corsUnsafeHeaders,
            const bool& _forcePreflight,
            const bool& _isPreflight)
    {
        Init();
        Assign(_requestingPrincipalInfo, _triggeringPrincipalInfo, _principalToInheritInfo, _sandboxedLoadingPrincipalInfo, _resultPrincipalURI, _securityFlags, _contentPolicyType, _tainting, _upgradeInsecureRequests, _verifySignedContent, _enforceSRI, _forceInheritPrincipalDropped, _innerWindowID, _outerWindowID, _parentOuterWindowID, _topOuterWindowID, _frameOuterWindowID, _enforceSecurity, _initialSecurityCheckDone, _isInThirdPartyContext, _originAttributes, _redirectChainIncludingInternalRedirects, _redirectChain, _corsUnsafeHeaders, _forcePreflight, _isPreflight);
    }

    MOZ_IMPLICIT LoadInfoArgs(const LoadInfoArgs& _o)
    {
        Init();
        Assign((_o).requestingPrincipalInfo(), (_o).triggeringPrincipalInfo(), (_o).principalToInheritInfo(), (_o).sandboxedLoadingPrincipalInfo(), (_o).resultPrincipalURI(), (_o).securityFlags(), (_o).contentPolicyType(), (_o).tainting(), (_o).upgradeInsecureRequests(), (_o).verifySignedContent(), (_o).enforceSRI(), (_o).forceInheritPrincipalDropped(), (_o).innerWindowID(), (_o).outerWindowID(), (_o).parentOuterWindowID(), (_o).topOuterWindowID(), (_o).frameOuterWindowID(), (_o).enforceSecurity(), (_o).initialSecurityCheckDone(), (_o).isInThirdPartyContext(), (_o).originAttributes(), (_o).redirectChainIncludingInternalRedirects(), (_o).redirectChain(), (_o).corsUnsafeHeaders(), (_o).forcePreflight(), (_o).isPreflight());
    }

    ~LoadInfoArgs();

    void
    operator=(const LoadInfoArgs& _o)
    {
        Assign((_o).requestingPrincipalInfo(), (_o).triggeringPrincipalInfo(), (_o).principalToInheritInfo(), (_o).sandboxedLoadingPrincipalInfo(), (_o).resultPrincipalURI(), (_o).securityFlags(), (_o).contentPolicyType(), (_o).tainting(), (_o).upgradeInsecureRequests(), (_o).verifySignedContent(), (_o).enforceSRI(), (_o).forceInheritPrincipalDropped(), (_o).innerWindowID(), (_o).outerWindowID(), (_o).parentOuterWindowID(), (_o).topOuterWindowID(), (_o).frameOuterWindowID(), (_o).enforceSecurity(), (_o).initialSecurityCheckDone(), (_o).isInThirdPartyContext(), (_o).originAttributes(), (_o).redirectChainIncludingInternalRedirects(), (_o).redirectChain(), (_o).corsUnsafeHeaders(), (_o).forcePreflight(), (_o).isPreflight());
    }

    bool
    operator==(const LoadInfoArgs& _o) const;

    bool
    operator!=(const LoadInfoArgs& _o) const;

    OptionalPrincipalInfo&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const OptionalPrincipalInfo&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    PrincipalInfo&
    triggeringPrincipalInfo()
    {
        return triggeringPrincipalInfo_;
    }
    const PrincipalInfo&
    triggeringPrincipalInfo() const
    {
        return triggeringPrincipalInfo_;
    }

    OptionalPrincipalInfo&
    principalToInheritInfo()
    {
        return principalToInheritInfo_;
    }
    const OptionalPrincipalInfo&
    principalToInheritInfo() const
    {
        return principalToInheritInfo_;
    }

    OptionalPrincipalInfo&
    sandboxedLoadingPrincipalInfo()
    {
        return sandboxedLoadingPrincipalInfo_;
    }
    const OptionalPrincipalInfo&
    sandboxedLoadingPrincipalInfo() const
    {
        return sandboxedLoadingPrincipalInfo_;
    }

    OptionalURIParams&
    resultPrincipalURI()
    {
        return resultPrincipalURI_;
    }
    const OptionalURIParams&
    resultPrincipalURI() const
    {
        return resultPrincipalURI_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    uint32_t&
    tainting()
    {
        return tainting_;
    }
    const uint32_t&
    tainting() const
    {
        return tainting_;
    }

    bool&
    upgradeInsecureRequests()
    {
        return upgradeInsecureRequests_;
    }
    const bool&
    upgradeInsecureRequests() const
    {
        return upgradeInsecureRequests_;
    }

    bool&
    verifySignedContent()
    {
        return verifySignedContent_;
    }
    const bool&
    verifySignedContent() const
    {
        return verifySignedContent_;
    }

    bool&
    enforceSRI()
    {
        return enforceSRI_;
    }
    const bool&
    enforceSRI() const
    {
        return enforceSRI_;
    }

    bool&
    forceInheritPrincipalDropped()
    {
        return forceInheritPrincipalDropped_;
    }
    const bool&
    forceInheritPrincipalDropped() const
    {
        return forceInheritPrincipalDropped_;
    }

    uint64_t&
    innerWindowID()
    {
        return innerWindowID_;
    }
    const uint64_t&
    innerWindowID() const
    {
        return innerWindowID_;
    }

    uint64_t&
    outerWindowID()
    {
        return outerWindowID_;
    }
    const uint64_t&
    outerWindowID() const
    {
        return outerWindowID_;
    }

    uint64_t&
    parentOuterWindowID()
    {
        return parentOuterWindowID_;
    }
    const uint64_t&
    parentOuterWindowID() const
    {
        return parentOuterWindowID_;
    }

    uint64_t&
    topOuterWindowID()
    {
        return topOuterWindowID_;
    }
    const uint64_t&
    topOuterWindowID() const
    {
        return topOuterWindowID_;
    }

    uint64_t&
    frameOuterWindowID()
    {
        return frameOuterWindowID_;
    }
    const uint64_t&
    frameOuterWindowID() const
    {
        return frameOuterWindowID_;
    }

    bool&
    enforceSecurity()
    {
        return enforceSecurity_;
    }
    const bool&
    enforceSecurity() const
    {
        return enforceSecurity_;
    }

    bool&
    initialSecurityCheckDone()
    {
        return initialSecurityCheckDone_;
    }
    const bool&
    initialSecurityCheckDone() const
    {
        return initialSecurityCheckDone_;
    }

    bool&
    isInThirdPartyContext()
    {
        return isInThirdPartyContext_;
    }
    const bool&
    isInThirdPartyContext() const
    {
        return isInThirdPartyContext_;
    }

    OriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const OriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects()
    {
        return redirectChainIncludingInternalRedirects_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects() const
    {
        return redirectChainIncludingInternalRedirects_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChain()
    {
        return redirectChain_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChain() const
    {
        return redirectChain_;
    }

    nsTArray<nsCString>&
    corsUnsafeHeaders()
    {
        return corsUnsafeHeaders_;
    }
    const nsTArray<nsCString>&
    corsUnsafeHeaders() const
    {
        return corsUnsafeHeaders_;
    }

    bool&
    forcePreflight()
    {
        return forcePreflight_;
    }
    const bool&
    forcePreflight() const
    {
        return forcePreflight_;
    }

    bool&
    isPreflight()
    {
        return isPreflight_;
    }
    const bool&
    isPreflight() const
    {
        return isPreflight_;
    }

private:
    void
    Init();

    void
    Assign(
            const OptionalPrincipalInfo& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const OptionalPrincipalInfo& _principalToInheritInfo,
            const OptionalPrincipalInfo& _sandboxedLoadingPrincipalInfo,
            const OptionalURIParams& _resultPrincipalURI,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType,
            const uint32_t& _tainting,
            const bool& _upgradeInsecureRequests,
            const bool& _verifySignedContent,
            const bool& _enforceSRI,
            const bool& _forceInheritPrincipalDropped,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const uint64_t& _topOuterWindowID,
            const uint64_t& _frameOuterWindowID,
            const bool& _enforceSecurity,
            const bool& _initialSecurityCheckDone,
            const bool& _isInThirdPartyContext,
            const OriginAttributes& _originAttributes,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChainIncludingInternalRedirects,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChain,
            const nsTArray<nsCString>& _corsUnsafeHeaders,
            const bool& _forcePreflight,
            const bool& _isPreflight);

    OptionalPrincipalInfo requestingPrincipalInfo_;
    PrincipalInfo triggeringPrincipalInfo_;
    OptionalPrincipalInfo principalToInheritInfo_;
    OptionalPrincipalInfo sandboxedLoadingPrincipalInfo_;
    OptionalURIParams resultPrincipalURI_;
    uint32_t securityFlags_;
    uint32_t contentPolicyType_;
    uint32_t tainting_;
    bool upgradeInsecureRequests_;
    bool verifySignedContent_;
    bool enforceSRI_;
    bool forceInheritPrincipalDropped_;
    uint64_t innerWindowID_;
    uint64_t outerWindowID_;
    uint64_t parentOuterWindowID_;
    uint64_t topOuterWindowID_;
    uint64_t frameOuterWindowID_;
    bool enforceSecurity_;
    bool initialSecurityCheckDone_;
    bool isInThirdPartyContext_;
    OriginAttributes originAttributes_;
    nsTArray<RedirectHistoryEntryInfo> redirectChainIncludingInternalRedirects_;
    nsTArray<RedirectHistoryEntryInfo> redirectChain_;
    nsTArray<nsCString> corsUnsafeHeaders_;
    bool forcePreflight_;
    bool isPreflight_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class LoadInfoArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalLoadInfoArgs|
//
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TLoadInfoArgs,
        T__Last = TLoadInfoArgs
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef void_t void_t__tdef;
    typedef LoadInfoArgs LoadInfoArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<LoadInfoArgs> VLoadInfoArgs;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    LoadInfoArgs*
    ptr_LoadInfoArgs()
    {
        return ((mValue).VLoadInfoArgs).addr();
    }
    const LoadInfoArgs*
    constptr_LoadInfoArgs() const
    {
        return ((mValue).VLoadInfoArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalLoadInfoArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalLoadInfoArgs(const void_t& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(const LoadInfoArgs& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(const OptionalLoadInfoArgs& aOther);

    ~OptionalLoadInfoArgs();

    Type
    type() const
    {
        return mType;
    }

    OptionalLoadInfoArgs&
    operator=(const void_t& aRhs);

    OptionalLoadInfoArgs&
    operator=(const LoadInfoArgs& aRhs);

    OptionalLoadInfoArgs&
    operator=(const OptionalLoadInfoArgs& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const LoadInfoArgs& aRhs) const;

    bool
    operator==(const OptionalLoadInfoArgs& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    LoadInfoArgs&
    get_LoadInfoArgs()
    {
        AssertSanity(TLoadInfoArgs);
        return (*(ptr_LoadInfoArgs()));
    }
    const LoadInfoArgs&
    get_LoadInfoArgs() const
    {
        AssertSanity(TLoadInfoArgs);
        return (*(constptr_LoadInfoArgs()));
    }
    void
    get(LoadInfoArgs* aOutValue) const;
    operator LoadInfoArgs&()
    {
        return get_LoadInfoArgs();
    }
    operator const LoadInfoArgs&() const
    {
        return get_LoadInfoArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalHttpResponseHead|
//
namespace mozilla {
namespace net {
class OptionalHttpResponseHead final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TnsHttpResponseHead,
        T__Last = TnsHttpResponseHead
    };

private:
    typedef mozilla::void_t void_t;
    typedef void_t void_t__tdef;
    typedef nsHttpResponseHead nsHttpResponseHead__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<nsHttpResponseHead> VnsHttpResponseHead;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    nsHttpResponseHead*
    ptr_nsHttpResponseHead()
    {
        return ((mValue).VnsHttpResponseHead).addr();
    }
    const nsHttpResponseHead*
    constptr_nsHttpResponseHead() const
    {
        return ((mValue).VnsHttpResponseHead).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalHttpResponseHead() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalHttpResponseHead(const void_t& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(const nsHttpResponseHead& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(const OptionalHttpResponseHead& aOther);

    ~OptionalHttpResponseHead();

    Type
    type() const
    {
        return mType;
    }

    OptionalHttpResponseHead&
    operator=(const void_t& aRhs);

    OptionalHttpResponseHead&
    operator=(const nsHttpResponseHead& aRhs);

    OptionalHttpResponseHead&
    operator=(const OptionalHttpResponseHead& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const nsHttpResponseHead& aRhs) const;

    bool
    operator==(const OptionalHttpResponseHead& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    nsHttpResponseHead&
    get_nsHttpResponseHead()
    {
        AssertSanity(TnsHttpResponseHead);
        return (*(ptr_nsHttpResponseHead()));
    }
    const nsHttpResponseHead&
    get_nsHttpResponseHead() const
    {
        AssertSanity(TnsHttpResponseHead);
        return (*(constptr_nsHttpResponseHead()));
    }
    void
    get(nsHttpResponseHead* aOutValue) const;
    operator nsHttpResponseHead&()
    {
        return get_nsHttpResponseHead();
    }
    operator const nsHttpResponseHead&() const
    {
        return get_nsHttpResponseHead();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CorsPreflightArgs|
//
namespace mozilla {
namespace net {
class CorsPreflightArgs final
{
private:

public:
    MOZ_IMPLICIT CorsPreflightArgs();

    MOZ_IMPLICIT CorsPreflightArgs(const nsTArray<nsCString>& _unsafeHeaders)
    {
        Init();
        Assign(_unsafeHeaders);
    }

    MOZ_IMPLICIT CorsPreflightArgs(const CorsPreflightArgs& _o)
    {
        Init();
        Assign((_o).unsafeHeaders());
    }

    ~CorsPreflightArgs();

    void
    operator=(const CorsPreflightArgs& _o)
    {
        Assign((_o).unsafeHeaders());
    }

    bool
    operator==(const CorsPreflightArgs& _o) const;

    bool
    operator!=(const CorsPreflightArgs& _o) const;

    nsTArray<nsCString>&
    unsafeHeaders()
    {
        return unsafeHeaders_;
    }
    const nsTArray<nsCString>&
    unsafeHeaders() const
    {
        return unsafeHeaders_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<nsCString>& _unsafeHeaders);

    nsTArray<nsCString> unsafeHeaders_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class CorsPreflightArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalCorsPreflightArgs|
//
namespace mozilla {
namespace net {
class OptionalCorsPreflightArgs final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TCorsPreflightArgs,
        T__Last = TCorsPreflightArgs
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::net::CorsPreflightArgs CorsPreflightArgs;
    typedef void_t void_t__tdef;
    typedef CorsPreflightArgs CorsPreflightArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<CorsPreflightArgs> VCorsPreflightArgs;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    CorsPreflightArgs*
    ptr_CorsPreflightArgs()
    {
        return ((mValue).VCorsPreflightArgs).addr();
    }
    const CorsPreflightArgs*
    constptr_CorsPreflightArgs() const
    {
        return ((mValue).VCorsPreflightArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalCorsPreflightArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalCorsPreflightArgs(const void_t& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(const CorsPreflightArgs& aOther);

    MOZ_IMPLICIT OptionalCorsPreflightArgs(const OptionalCorsPreflightArgs& aOther);

    ~OptionalCorsPreflightArgs();

    Type
    type() const
    {
        return mType;
    }

    OptionalCorsPreflightArgs&
    operator=(const void_t& aRhs);

    OptionalCorsPreflightArgs&
    operator=(const CorsPreflightArgs& aRhs);

    OptionalCorsPreflightArgs&
    operator=(const OptionalCorsPreflightArgs& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const CorsPreflightArgs& aRhs) const;

    bool
    operator==(const OptionalCorsPreflightArgs& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    CorsPreflightArgs&
    get_CorsPreflightArgs()
    {
        AssertSanity(TCorsPreflightArgs);
        return (*(ptr_CorsPreflightArgs()));
    }
    const CorsPreflightArgs&
    get_CorsPreflightArgs() const
    {
        AssertSanity(TCorsPreflightArgs);
        return (*(constptr_CorsPreflightArgs()));
    }
    void
    get(CorsPreflightArgs* aOutValue) const;
    operator CorsPreflightArgs&()
    {
        return get_CorsPreflightArgs();
    }
    operator const CorsPreflightArgs&() const
    {
        return get_CorsPreflightArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalURIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalIPCStream;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalHttpResponseHead;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalCorsPreflightArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOpenArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;
    typedef mozilla::net::OptionalHttpResponseHead OptionalHttpResponseHead;
    typedef mozilla::net::OptionalCorsPreflightArgs OptionalCorsPreflightArgs;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT HttpChannelOpenArgs();

    MOZ_IMPLICIT HttpChannelOpenArgs(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const uint32_t& _referrerPolicy,
            const OptionalURIParams& _apiRedirectTo,
            const OptionalURIParams& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalIPCStream& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const int16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const bool& _beConservative,
            const uint32_t& _tlsFlags,
            const OptionalLoadInfoArgs& _loadInfo,
            const OptionalHttpResponseHead& _synthesizedResponseHead,
            const nsCString& _synthesizedSecurityInfoSerialization,
            const uint32_t& _cacheKey,
            const uint64_t& _requestContextID,
            const OptionalCorsPreflightArgs& _preflightArgs,
            const uint32_t& _initialRwin,
            const bool& _blockAuthPrompt,
            const bool& _suspendAfterSynthesizeResponse,
            const bool& _allowStaleCacheContent,
            const nsCString& _contentTypeHint,
            const uint64_t& _channelId,
            const uint64_t& _contentWindowId,
            const nsCString& _preferredAlternativeType,
            const uint64_t& _topLevelOuterContentWindowId,
            const TimeStamp& _launchServiceWorkerStart,
            const TimeStamp& _launchServiceWorkerEnd,
            const TimeStamp& _dispatchFetchEventStart,
            const TimeStamp& _dispatchFetchEventEnd,
            const TimeStamp& _handleFetchEventStart,
            const TimeStamp& _handleFetchEventEnd,
            const bool& _forceMainDocumentChannel)
    {
        Init();
        Assign(_uri, _original, _doc, _referrer, _referrerPolicy, _apiRedirectTo, _topWindowURI, _loadFlags, _requestHeaders, _requestMethod, _uploadStream, _uploadStreamHasHeaders, _priority, _classOfService, _redirectionLimit, _allowSTS, _thirdPartyFlags, _resumeAt, _startPos, _entityID, _chooseApplicationCache, _appCacheClientID, _allowSpdy, _allowAltSvc, _beConservative, _tlsFlags, _loadInfo, _synthesizedResponseHead, _synthesizedSecurityInfoSerialization, _cacheKey, _requestContextID, _preflightArgs, _initialRwin, _blockAuthPrompt, _suspendAfterSynthesizeResponse, _allowStaleCacheContent, _contentTypeHint, _channelId, _contentWindowId, _preferredAlternativeType, _topLevelOuterContentWindowId, _launchServiceWorkerStart, _launchServiceWorkerEnd, _dispatchFetchEventStart, _dispatchFetchEventEnd, _handleFetchEventStart, _handleFetchEventEnd, _forceMainDocumentChannel);
    }

    MOZ_IMPLICIT HttpChannelOpenArgs(const HttpChannelOpenArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).original(), (_o).doc(), (_o).referrer(), (_o).referrerPolicy(), (_o).apiRedirectTo(), (_o).topWindowURI(), (_o).loadFlags(), (_o).requestHeaders(), (_o).requestMethod(), (_o).uploadStream(), (_o).uploadStreamHasHeaders(), (_o).priority(), (_o).classOfService(), (_o).redirectionLimit(), (_o).allowSTS(), (_o).thirdPartyFlags(), (_o).resumeAt(), (_o).startPos(), (_o).entityID(), (_o).chooseApplicationCache(), (_o).appCacheClientID(), (_o).allowSpdy(), (_o).allowAltSvc(), (_o).beConservative(), (_o).tlsFlags(), (_o).loadInfo(), (_o).synthesizedResponseHead(), (_o).synthesizedSecurityInfoSerialization(), (_o).cacheKey(), (_o).requestContextID(), (_o).preflightArgs(), (_o).initialRwin(), (_o).blockAuthPrompt(), (_o).suspendAfterSynthesizeResponse(), (_o).allowStaleCacheContent(), (_o).contentTypeHint(), (_o).channelId(), (_o).contentWindowId(), (_o).preferredAlternativeType(), (_o).topLevelOuterContentWindowId(), (_o).launchServiceWorkerStart(), (_o).launchServiceWorkerEnd(), (_o).dispatchFetchEventStart(), (_o).dispatchFetchEventEnd(), (_o).handleFetchEventStart(), (_o).handleFetchEventEnd(), (_o).forceMainDocumentChannel());
    }

    ~HttpChannelOpenArgs();

    void
    operator=(const HttpChannelOpenArgs& _o)
    {
        Assign((_o).uri(), (_o).original(), (_o).doc(), (_o).referrer(), (_o).referrerPolicy(), (_o).apiRedirectTo(), (_o).topWindowURI(), (_o).loadFlags(), (_o).requestHeaders(), (_o).requestMethod(), (_o).uploadStream(), (_o).uploadStreamHasHeaders(), (_o).priority(), (_o).classOfService(), (_o).redirectionLimit(), (_o).allowSTS(), (_o).thirdPartyFlags(), (_o).resumeAt(), (_o).startPos(), (_o).entityID(), (_o).chooseApplicationCache(), (_o).appCacheClientID(), (_o).allowSpdy(), (_o).allowAltSvc(), (_o).beConservative(), (_o).tlsFlags(), (_o).loadInfo(), (_o).synthesizedResponseHead(), (_o).synthesizedSecurityInfoSerialization(), (_o).cacheKey(), (_o).requestContextID(), (_o).preflightArgs(), (_o).initialRwin(), (_o).blockAuthPrompt(), (_o).suspendAfterSynthesizeResponse(), (_o).allowStaleCacheContent(), (_o).contentTypeHint(), (_o).channelId(), (_o).contentWindowId(), (_o).preferredAlternativeType(), (_o).topLevelOuterContentWindowId(), (_o).launchServiceWorkerStart(), (_o).launchServiceWorkerEnd(), (_o).dispatchFetchEventStart(), (_o).dispatchFetchEventEnd(), (_o).handleFetchEventStart(), (_o).handleFetchEventEnd(), (_o).forceMainDocumentChannel());
    }

    bool
    operator==(const HttpChannelOpenArgs& _o) const;

    bool
    operator!=(const HttpChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    OptionalURIParams&
    original()
    {
        return original_;
    }
    const OptionalURIParams&
    original() const
    {
        return original_;
    }

    OptionalURIParams&
    doc()
    {
        return doc_;
    }
    const OptionalURIParams&
    doc() const
    {
        return doc_;
    }

    OptionalURIParams&
    referrer()
    {
        return referrer_;
    }
    const OptionalURIParams&
    referrer() const
    {
        return referrer_;
    }

    uint32_t&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const uint32_t&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    OptionalURIParams&
    apiRedirectTo()
    {
        return apiRedirectTo_;
    }
    const OptionalURIParams&
    apiRedirectTo() const
    {
        return apiRedirectTo_;
    }

    OptionalURIParams&
    topWindowURI()
    {
        return topWindowURI_;
    }
    const OptionalURIParams&
    topWindowURI() const
    {
        return topWindowURI_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

    RequestHeaderTuples&
    requestHeaders()
    {
        return requestHeaders_;
    }
    const RequestHeaderTuples&
    requestHeaders() const
    {
        return requestHeaders_;
    }

    nsCString&
    requestMethod()
    {
        return requestMethod_;
    }
    const nsCString&
    requestMethod() const
    {
        return requestMethod_;
    }

    OptionalIPCStream&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalIPCStream&
    uploadStream() const
    {
        return uploadStream_;
    }

    bool&
    uploadStreamHasHeaders()
    {
        return uploadStreamHasHeaders_;
    }
    const bool&
    uploadStreamHasHeaders() const
    {
        return uploadStreamHasHeaders_;
    }

    int16_t&
    priority()
    {
        return priority_;
    }
    const int16_t&
    priority() const
    {
        return priority_;
    }

    uint32_t&
    classOfService()
    {
        return classOfService_;
    }
    const uint32_t&
    classOfService() const
    {
        return classOfService_;
    }

    uint8_t&
    redirectionLimit()
    {
        return redirectionLimit_;
    }
    const uint8_t&
    redirectionLimit() const
    {
        return redirectionLimit_;
    }

    bool&
    allowSTS()
    {
        return allowSTS_;
    }
    const bool&
    allowSTS() const
    {
        return allowSTS_;
    }

    uint32_t&
    thirdPartyFlags()
    {
        return thirdPartyFlags_;
    }
    const uint32_t&
    thirdPartyFlags() const
    {
        return thirdPartyFlags_;
    }

    bool&
    resumeAt()
    {
        return resumeAt_;
    }
    const bool&
    resumeAt() const
    {
        return resumeAt_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    bool&
    chooseApplicationCache()
    {
        return chooseApplicationCache_;
    }
    const bool&
    chooseApplicationCache() const
    {
        return chooseApplicationCache_;
    }

    nsCString&
    appCacheClientID()
    {
        return appCacheClientID_;
    }
    const nsCString&
    appCacheClientID() const
    {
        return appCacheClientID_;
    }

    bool&
    allowSpdy()
    {
        return allowSpdy_;
    }
    const bool&
    allowSpdy() const
    {
        return allowSpdy_;
    }

    bool&
    allowAltSvc()
    {
        return allowAltSvc_;
    }
    const bool&
    allowAltSvc() const
    {
        return allowAltSvc_;
    }

    bool&
    beConservative()
    {
        return beConservative_;
    }
    const bool&
    beConservative() const
    {
        return beConservative_;
    }

    uint32_t&
    tlsFlags()
    {
        return tlsFlags_;
    }
    const uint32_t&
    tlsFlags() const
    {
        return tlsFlags_;
    }

    OptionalLoadInfoArgs&
    loadInfo()
    {
        return loadInfo_;
    }
    const OptionalLoadInfoArgs&
    loadInfo() const
    {
        return loadInfo_;
    }

    OptionalHttpResponseHead&
    synthesizedResponseHead()
    {
        return synthesizedResponseHead_;
    }
    const OptionalHttpResponseHead&
    synthesizedResponseHead() const
    {
        return synthesizedResponseHead_;
    }

    nsCString&
    synthesizedSecurityInfoSerialization()
    {
        return synthesizedSecurityInfoSerialization_;
    }
    const nsCString&
    synthesizedSecurityInfoSerialization() const
    {
        return synthesizedSecurityInfoSerialization_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    uint64_t&
    requestContextID()
    {
        return requestContextID_;
    }
    const uint64_t&
    requestContextID() const
    {
        return requestContextID_;
    }

    OptionalCorsPreflightArgs&
    preflightArgs()
    {
        return preflightArgs_;
    }
    const OptionalCorsPreflightArgs&
    preflightArgs() const
    {
        return preflightArgs_;
    }

    uint32_t&
    initialRwin()
    {
        return initialRwin_;
    }
    const uint32_t&
    initialRwin() const
    {
        return initialRwin_;
    }

    bool&
    blockAuthPrompt()
    {
        return blockAuthPrompt_;
    }
    const bool&
    blockAuthPrompt() const
    {
        return blockAuthPrompt_;
    }

    bool&
    suspendAfterSynthesizeResponse()
    {
        return suspendAfterSynthesizeResponse_;
    }
    const bool&
    suspendAfterSynthesizeResponse() const
    {
        return suspendAfterSynthesizeResponse_;
    }

    bool&
    allowStaleCacheContent()
    {
        return allowStaleCacheContent_;
    }
    const bool&
    allowStaleCacheContent() const
    {
        return allowStaleCacheContent_;
    }

    nsCString&
    contentTypeHint()
    {
        return contentTypeHint_;
    }
    const nsCString&
    contentTypeHint() const
    {
        return contentTypeHint_;
    }

    uint64_t&
    channelId()
    {
        return channelId_;
    }
    const uint64_t&
    channelId() const
    {
        return channelId_;
    }

    uint64_t&
    contentWindowId()
    {
        return contentWindowId_;
    }
    const uint64_t&
    contentWindowId() const
    {
        return contentWindowId_;
    }

    nsCString&
    preferredAlternativeType()
    {
        return preferredAlternativeType_;
    }
    const nsCString&
    preferredAlternativeType() const
    {
        return preferredAlternativeType_;
    }

    uint64_t&
    topLevelOuterContentWindowId()
    {
        return topLevelOuterContentWindowId_;
    }
    const uint64_t&
    topLevelOuterContentWindowId() const
    {
        return topLevelOuterContentWindowId_;
    }

    TimeStamp&
    launchServiceWorkerStart()
    {
        return launchServiceWorkerStart_;
    }
    const TimeStamp&
    launchServiceWorkerStart() const
    {
        return launchServiceWorkerStart_;
    }

    TimeStamp&
    launchServiceWorkerEnd()
    {
        return launchServiceWorkerEnd_;
    }
    const TimeStamp&
    launchServiceWorkerEnd() const
    {
        return launchServiceWorkerEnd_;
    }

    TimeStamp&
    dispatchFetchEventStart()
    {
        return dispatchFetchEventStart_;
    }
    const TimeStamp&
    dispatchFetchEventStart() const
    {
        return dispatchFetchEventStart_;
    }

    TimeStamp&
    dispatchFetchEventEnd()
    {
        return dispatchFetchEventEnd_;
    }
    const TimeStamp&
    dispatchFetchEventEnd() const
    {
        return dispatchFetchEventEnd_;
    }

    TimeStamp&
    handleFetchEventStart()
    {
        return handleFetchEventStart_;
    }
    const TimeStamp&
    handleFetchEventStart() const
    {
        return handleFetchEventStart_;
    }

    TimeStamp&
    handleFetchEventEnd()
    {
        return handleFetchEventEnd_;
    }
    const TimeStamp&
    handleFetchEventEnd() const
    {
        return handleFetchEventEnd_;
    }

    bool&
    forceMainDocumentChannel()
    {
        return forceMainDocumentChannel_;
    }
    const bool&
    forceMainDocumentChannel() const
    {
        return forceMainDocumentChannel_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const uint32_t& _referrerPolicy,
            const OptionalURIParams& _apiRedirectTo,
            const OptionalURIParams& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalIPCStream& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const int16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const bool& _beConservative,
            const uint32_t& _tlsFlags,
            const OptionalLoadInfoArgs& _loadInfo,
            const OptionalHttpResponseHead& _synthesizedResponseHead,
            const nsCString& _synthesizedSecurityInfoSerialization,
            const uint32_t& _cacheKey,
            const uint64_t& _requestContextID,
            const OptionalCorsPreflightArgs& _preflightArgs,
            const uint32_t& _initialRwin,
            const bool& _blockAuthPrompt,
            const bool& _suspendAfterSynthesizeResponse,
            const bool& _allowStaleCacheContent,
            const nsCString& _contentTypeHint,
            const uint64_t& _channelId,
            const uint64_t& _contentWindowId,
            const nsCString& _preferredAlternativeType,
            const uint64_t& _topLevelOuterContentWindowId,
            const TimeStamp& _launchServiceWorkerStart,
            const TimeStamp& _launchServiceWorkerEnd,
            const TimeStamp& _dispatchFetchEventStart,
            const TimeStamp& _dispatchFetchEventEnd,
            const TimeStamp& _handleFetchEventStart,
            const TimeStamp& _handleFetchEventEnd,
            const bool& _forceMainDocumentChannel);

    URIParams uri_;
    OptionalURIParams original_;
    OptionalURIParams doc_;
    OptionalURIParams referrer_;
    uint32_t referrerPolicy_;
    OptionalURIParams apiRedirectTo_;
    OptionalURIParams topWindowURI_;
    uint32_t loadFlags_;
    RequestHeaderTuples requestHeaders_;
    nsCString requestMethod_;
    OptionalIPCStream uploadStream_;
    bool uploadStreamHasHeaders_;
    int16_t priority_;
    uint32_t classOfService_;
    uint8_t redirectionLimit_;
    bool allowSTS_;
    uint32_t thirdPartyFlags_;
    bool resumeAt_;
    uint64_t startPos_;
    nsCString entityID_;
    bool chooseApplicationCache_;
    nsCString appCacheClientID_;
    bool allowSpdy_;
    bool allowAltSvc_;
    bool beConservative_;
    uint32_t tlsFlags_;
    OptionalLoadInfoArgs loadInfo_;
    OptionalHttpResponseHead synthesizedResponseHead_;
    nsCString synthesizedSecurityInfoSerialization_;
    uint32_t cacheKey_;
    uint64_t requestContextID_;
    OptionalCorsPreflightArgs preflightArgs_;
    uint32_t initialRwin_;
    bool blockAuthPrompt_;
    bool suspendAfterSynthesizeResponse_;
    bool allowStaleCacheContent_;
    nsCString contentTypeHint_;
    uint64_t channelId_;
    uint64_t contentWindowId_;
    nsCString preferredAlternativeType_;
    uint64_t topLevelOuterContentWindowId_;
    TimeStamp launchServiceWorkerStart_;
    TimeStamp launchServiceWorkerEnd_;
    TimeStamp dispatchFetchEventStart_;
    TimeStamp dispatchFetchEventEnd_;
    TimeStamp handleFetchEventStart_;
    TimeStamp handleFetchEventEnd_;
    bool forceMainDocumentChannel_;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelConnectArgs|
//
namespace mozilla {
namespace net {
class HttpChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT HttpChannelConnectArgs();

    MOZ_IMPLICIT HttpChannelConnectArgs(
            const uint32_t& _registrarId,
            const bool& _shouldIntercept)
    {
        Init();
        Assign(_registrarId, _shouldIntercept);
    }

    MOZ_IMPLICIT HttpChannelConnectArgs(const HttpChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).registrarId(), (_o).shouldIntercept());
    }

    ~HttpChannelConnectArgs();

    void
    operator=(const HttpChannelConnectArgs& _o)
    {
        Assign((_o).registrarId(), (_o).shouldIntercept());
    }

    bool
    operator==(const HttpChannelConnectArgs& _o) const;

    bool
    operator!=(const HttpChannelConnectArgs& _o) const;

    uint32_t&
    registrarId()
    {
        return registrarId_;
    }
    const uint32_t&
    registrarId() const
    {
        return registrarId_;
    }

    bool&
    shouldIntercept()
    {
        return shouldIntercept_;
    }
    const bool&
    shouldIntercept() const
    {
        return shouldIntercept_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _registrarId,
            const bool& _shouldIntercept);

    uint32_t registrarId_;
    bool shouldIntercept_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class HttpChannelOpenArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class HttpChannelConnectArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpChannelCreationArgs|
//
namespace mozilla {
namespace net {
class HttpChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelOpenArgs = 1,
        THttpChannelConnectArgs,
        T__Last = THttpChannelConnectArgs
    };

private:
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef HttpChannelOpenArgs HttpChannelOpenArgs__tdef;
    typedef HttpChannelConnectArgs HttpChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelOpenArgs> VHttpChannelOpenArgs;
        mozilla::AlignedStorage2<HttpChannelConnectArgs> VHttpChannelConnectArgs;
    };

    HttpChannelOpenArgs*
    ptr_HttpChannelOpenArgs()
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    const HttpChannelOpenArgs*
    constptr_HttpChannelOpenArgs() const
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    HttpChannelConnectArgs*
    ptr_HttpChannelConnectArgs()
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }
    const HttpChannelConnectArgs*
    constptr_HttpChannelConnectArgs() const
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelOpenArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelConnectArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelCreationArgs& aOther);

    ~HttpChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpChannelCreationArgs&
    operator=(const HttpChannelOpenArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelConnectArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelCreationArgs& aRhs);

    bool
    operator==(const HttpChannelOpenArgs& aRhs) const;

    bool
    operator==(const HttpChannelConnectArgs& aRhs) const;

    bool
    operator==(const HttpChannelCreationArgs& aRhs) const;

    HttpChannelOpenArgs&
    get_HttpChannelOpenArgs()
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(ptr_HttpChannelOpenArgs()));
    }
    const HttpChannelOpenArgs&
    get_HttpChannelOpenArgs() const
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(constptr_HttpChannelOpenArgs()));
    }
    void
    get(HttpChannelOpenArgs* aOutValue) const;
    operator HttpChannelOpenArgs&()
    {
        return get_HttpChannelOpenArgs();
    }
    operator const HttpChannelOpenArgs&() const
    {
        return get_HttpChannelOpenArgs();
    }

    HttpChannelConnectArgs&
    get_HttpChannelConnectArgs()
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(ptr_HttpChannelConnectArgs()));
    }
    const HttpChannelConnectArgs&
    get_HttpChannelConnectArgs() const
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(constptr_HttpChannelConnectArgs()));
    }
    void
    get(HttpChannelConnectArgs* aOutValue) const;
    operator HttpChannelConnectArgs&()
    {
        return get_HttpChannelConnectArgs();
    }
    operator const HttpChannelConnectArgs&() const
    {
        return get_HttpChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalIPCStream;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelOpenArgs|
//
namespace mozilla {
namespace net {
class FTPChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;

public:
    MOZ_IMPLICIT FTPChannelOpenArgs();

    MOZ_IMPLICIT FTPChannelOpenArgs(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalIPCStream& _uploadStream,
            const OptionalLoadInfoArgs& _loadInfo)
    {
        Init();
        Assign(_uri, _startPos, _entityID, _uploadStream, _loadInfo);
    }

    MOZ_IMPLICIT FTPChannelOpenArgs(const FTPChannelOpenArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).startPos(), (_o).entityID(), (_o).uploadStream(), (_o).loadInfo());
    }

    ~FTPChannelOpenArgs();

    void
    operator=(const FTPChannelOpenArgs& _o)
    {
        Assign((_o).uri(), (_o).startPos(), (_o).entityID(), (_o).uploadStream(), (_o).loadInfo());
    }

    bool
    operator==(const FTPChannelOpenArgs& _o) const;

    bool
    operator!=(const FTPChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    OptionalIPCStream&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalIPCStream&
    uploadStream() const
    {
        return uploadStream_;
    }

    OptionalLoadInfoArgs&
    loadInfo()
    {
        return loadInfo_;
    }
    const OptionalLoadInfoArgs&
    loadInfo() const
    {
        return loadInfo_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalIPCStream& _uploadStream,
            const OptionalLoadInfoArgs& _loadInfo);

    URIParams uri_;
    uint64_t startPos_;
    nsCString entityID_;
    OptionalIPCStream uploadStream_;
    OptionalLoadInfoArgs loadInfo_;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelConnectArgs|
//
namespace mozilla {
namespace net {
class FTPChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT FTPChannelConnectArgs();

    MOZ_IMPLICIT FTPChannelConnectArgs(const uint32_t& _channelId)
    {
        Init();
        Assign(_channelId);
    }

    MOZ_IMPLICIT FTPChannelConnectArgs(const FTPChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).channelId());
    }

    ~FTPChannelConnectArgs();

    void
    operator=(const FTPChannelConnectArgs& _o)
    {
        Assign((_o).channelId());
    }

    bool
    operator==(const FTPChannelConnectArgs& _o) const;

    bool
    operator!=(const FTPChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    void
    Init();

    void
    Assign(const uint32_t& _channelId);

    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class FTPChannelOpenArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class FTPChannelConnectArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FTPChannelCreationArgs|
//
namespace mozilla {
namespace net {
class FTPChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        TFTPChannelOpenArgs = 1,
        TFTPChannelConnectArgs,
        T__Last = TFTPChannelConnectArgs
    };

private:
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef FTPChannelOpenArgs FTPChannelOpenArgs__tdef;
    typedef FTPChannelConnectArgs FTPChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<FTPChannelOpenArgs> VFTPChannelOpenArgs;
        mozilla::AlignedStorage2<FTPChannelConnectArgs> VFTPChannelConnectArgs;
    };

    FTPChannelOpenArgs*
    ptr_FTPChannelOpenArgs()
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    const FTPChannelOpenArgs*
    constptr_FTPChannelOpenArgs() const
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    FTPChannelConnectArgs*
    ptr_FTPChannelConnectArgs()
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }
    const FTPChannelConnectArgs*
    constptr_FTPChannelConnectArgs() const
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FTPChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelOpenArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelConnectArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelCreationArgs& aOther);

    ~FTPChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    FTPChannelCreationArgs&
    operator=(const FTPChannelOpenArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelConnectArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelCreationArgs& aRhs);

    bool
    operator==(const FTPChannelOpenArgs& aRhs) const;

    bool
    operator==(const FTPChannelConnectArgs& aRhs) const;

    bool
    operator==(const FTPChannelCreationArgs& aRhs) const;

    FTPChannelOpenArgs&
    get_FTPChannelOpenArgs()
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(ptr_FTPChannelOpenArgs()));
    }
    const FTPChannelOpenArgs&
    get_FTPChannelOpenArgs() const
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(constptr_FTPChannelOpenArgs()));
    }
    void
    get(FTPChannelOpenArgs* aOutValue) const;
    operator FTPChannelOpenArgs&()
    {
        return get_FTPChannelOpenArgs();
    }
    operator const FTPChannelOpenArgs&() const
    {
        return get_FTPChannelOpenArgs();
    }

    FTPChannelConnectArgs&
    get_FTPChannelConnectArgs()
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(ptr_FTPChannelConnectArgs()));
    }
    const FTPChannelConnectArgs&
    get_FTPChannelConnectArgs() const
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(constptr_FTPChannelConnectArgs()));
    }
    void
    get(FTPChannelConnectArgs* aOutValue) const;
    operator FTPChannelConnectArgs&()
    {
        return get_FTPChannelConnectArgs();
    }
    operator const FTPChannelConnectArgs&() const
    {
        return get_FTPChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class HttpChannelDiverterArgs final
{
private:
    typedef mozilla::net::PHttpChannelParent PHttpChannelParent;
    typedef mozilla::net::PHttpChannelChild PHttpChannelChild;

public:
    MOZ_IMPLICIT HttpChannelDiverterArgs();

    MOZ_IMPLICIT HttpChannelDiverterArgs(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion)
    {
        Init();
        Assign(_mChannelParent, _mChannelChild, _mApplyConversion);
    }

    MOZ_IMPLICIT HttpChannelDiverterArgs(const HttpChannelDiverterArgs& _o)
    {
        Init();
        Assign(const_cast<PHttpChannelParent*>((_o).mChannelParent()), const_cast<PHttpChannelChild*>((_o).mChannelChild()), (_o).mApplyConversion());
    }

    ~HttpChannelDiverterArgs();

    void
    operator=(const HttpChannelDiverterArgs& _o)
    {
        Assign(const_cast<PHttpChannelParent*>((_o).mChannelParent()), const_cast<PHttpChannelChild*>((_o).mChannelChild()), (_o).mApplyConversion());
    }

    bool
    operator==(const HttpChannelDiverterArgs& _o) const;

    bool
    operator!=(const HttpChannelDiverterArgs& _o) const;

    PHttpChannelParent*&
    mChannelParent()
    {
        return mChannelParent_;
    }
    PHttpChannelParent*
    mChannelParent() const
    {
        return mChannelParent_;
    }

    PHttpChannelChild*&
    mChannelChild()
    {
        return mChannelChild_;
    }
    PHttpChannelChild*
    mChannelChild() const
    {
        return mChannelChild_;
    }

    bool&
    mApplyConversion()
    {
        return mApplyConversion_;
    }
    const bool&
    mApplyConversion() const
    {
        return mApplyConversion_;
    }

private:
    void
    Init();

    void
    Assign(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion);

    PHttpChannelParent* mChannelParent_;
    PHttpChannelChild* mChannelChild_;
    bool mApplyConversion_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class HttpChannelDiverterArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PFTPChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class ChannelDiverterArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelDiverterArgs = 1,
        TPFTPChannelParent,
        TPFTPChannelChild,
        T__Last = TPFTPChannelChild
    };

private:
    typedef mozilla::net::HttpChannelDiverterArgs HttpChannelDiverterArgs;
    typedef mozilla::net::PFTPChannelParent PFTPChannelParent;
    typedef mozilla::net::PFTPChannelChild PFTPChannelChild;
    typedef HttpChannelDiverterArgs HttpChannelDiverterArgs__tdef;
    typedef PFTPChannelParent* PFTPChannelParent__tdef;
    typedef PFTPChannelChild* PFTPChannelChild__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelDiverterArgs> VHttpChannelDiverterArgs;
        mozilla::AlignedStorage2<PFTPChannelParent*> VPFTPChannelParent;
        mozilla::AlignedStorage2<PFTPChannelChild*> VPFTPChannelChild;
    };

    HttpChannelDiverterArgs*
    ptr_HttpChannelDiverterArgs()
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    const HttpChannelDiverterArgs*
    constptr_HttpChannelDiverterArgs() const
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    PFTPChannelParent**
    ptr_PFTPChannelParent()
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelParent* const*
    constptr_PFTPChannelParent() const
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelChild**
    ptr_PFTPChannelChild()
    {
        return ((mValue).VPFTPChannelChild).addr();
    }
    PFTPChannelChild* const*
    constptr_PFTPChannelChild() const
    {
        return ((mValue).VPFTPChannelChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ChannelDiverterArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ChannelDiverterArgs(const HttpChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(const ChannelDiverterArgs& aOther);

    ~ChannelDiverterArgs();

    Type
    type() const
    {
        return mType;
    }

    ChannelDiverterArgs&
    operator=(const HttpChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(const ChannelDiverterArgs& aRhs);

    bool
    operator==(const HttpChannelDiverterArgs& aRhs) const;

    bool
    operator==(PFTPChannelParent* aRhs) const;

    bool
    operator==(PFTPChannelChild* aRhs) const;

    bool
    operator==(const ChannelDiverterArgs& aRhs) const;

    HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs()
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(ptr_HttpChannelDiverterArgs()));
    }
    const HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs() const
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(constptr_HttpChannelDiverterArgs()));
    }
    void
    get(HttpChannelDiverterArgs* aOutValue) const;
    operator HttpChannelDiverterArgs&()
    {
        return get_HttpChannelDiverterArgs();
    }
    operator const HttpChannelDiverterArgs&() const
    {
        return get_HttpChannelDiverterArgs();
    }

    PFTPChannelParent*&
    get_PFTPChannelParent()
    {
        AssertSanity(TPFTPChannelParent);
        return (*(ptr_PFTPChannelParent()));
    }
    PFTPChannelParent*
    get_PFTPChannelParent() const
    {
        AssertSanity(TPFTPChannelParent);
        return (*(constptr_PFTPChannelParent()));
    }
    void
    get(PFTPChannelParent** aOutValue) const;
    operator PFTPChannelParent*&()
    {
        return get_PFTPChannelParent();
    }
    operator PFTPChannelParent*() const
    {
        return get_PFTPChannelParent();
    }

    PFTPChannelChild*&
    get_PFTPChannelChild()
    {
        AssertSanity(TPFTPChannelChild);
        return (*(ptr_PFTPChannelChild()));
    }
    PFTPChannelChild*
    get_PFTPChannelChild() const
    {
        AssertSanity(TPFTPChannelChild);
        return (*(constptr_PFTPChannelChild()));
    }
    void
    get(PFTPChannelChild** aOutValue) const;
    operator PFTPChannelChild*&()
    {
        return get_PFTPChannelChild();
    }
    operator PFTPChannelChild*() const
    {
        return get_PFTPChannelChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookieStruct|
//
namespace mozilla {
namespace net {
class CookieStruct final
{
private:

public:
    MOZ_IMPLICIT CookieStruct();

    MOZ_IMPLICIT CookieStruct(
            const nsCString& _name,
            const nsCString& _value,
            const nsCString& _host,
            const nsCString& _path,
            const int64_t& _expiry,
            const int64_t& _lastAccessed,
            const int64_t& _creationTime,
            const bool& _isHttpOnly,
            const bool& _isSession,
            const bool& _isSecure)
    {
        Init();
        Assign(_name, _value, _host, _path, _expiry, _lastAccessed, _creationTime, _isHttpOnly, _isSession, _isSecure);
    }

    MOZ_IMPLICIT CookieStruct(const CookieStruct& _o)
    {
        Init();
        Assign((_o).name(), (_o).value(), (_o).host(), (_o).path(), (_o).expiry(), (_o).lastAccessed(), (_o).creationTime(), (_o).isHttpOnly(), (_o).isSession(), (_o).isSecure());
    }

    ~CookieStruct();

    void
    operator=(const CookieStruct& _o)
    {
        Assign((_o).name(), (_o).value(), (_o).host(), (_o).path(), (_o).expiry(), (_o).lastAccessed(), (_o).creationTime(), (_o).isHttpOnly(), (_o).isSession(), (_o).isSecure());
    }

    bool
    operator==(const CookieStruct& _o) const;

    bool
    operator!=(const CookieStruct& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    int64_t&
    expiry()
    {
        return expiry_;
    }
    const int64_t&
    expiry() const
    {
        return expiry_;
    }

    int64_t&
    lastAccessed()
    {
        return lastAccessed_;
    }
    const int64_t&
    lastAccessed() const
    {
        return lastAccessed_;
    }

    int64_t&
    creationTime()
    {
        return creationTime_;
    }
    const int64_t&
    creationTime() const
    {
        return creationTime_;
    }

    bool&
    isHttpOnly()
    {
        return isHttpOnly_;
    }
    const bool&
    isHttpOnly() const
    {
        return isHttpOnly_;
    }

    bool&
    isSession()
    {
        return isSession_;
    }
    const bool&
    isSession() const
    {
        return isSession_;
    }

    bool&
    isSecure()
    {
        return isSecure_;
    }
    const bool&
    isSecure() const
    {
        return isSecure_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _name,
            const nsCString& _value,
            const nsCString& _host,
            const nsCString& _path,
            const int64_t& _expiry,
            const int64_t& _lastAccessed,
            const int64_t& _creationTime,
            const bool& _isHttpOnly,
            const bool& _isSession,
            const bool& _isSecure);

    nsCString name_;
    nsCString value_;
    nsCString host_;
    nsCString path_;
    int64_t expiry_;
    int64_t lastAccessed_;
    int64_t creationTime_;
    bool isHttpOnly_;
    bool isSession_;
    bool isSecure_;
};
} // namespace net
} // namespace mozilla

#endif // ifndef NeckoChannelParams_h
