//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDNSRequestParams_h
#define PDNSRequestParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "mozilla/net/PDNSParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DNSRecord|
//
namespace mozilla {
namespace net {
class DNSRecord final
{
private:

public:
    MOZ_IMPLICIT DNSRecord();

    MOZ_IMPLICIT DNSRecord(
            const nsCString& _canonicalName,
            const NetAddrArray& _addrs)
    {
        Init();
        Assign(_canonicalName, _addrs);
    }

    MOZ_IMPLICIT DNSRecord(const DNSRecord& _o)
    {
        Init();
        Assign((_o).canonicalName(), (_o).addrs());
    }

    ~DNSRecord();

    void
    operator=(const DNSRecord& _o)
    {
        Assign((_o).canonicalName(), (_o).addrs());
    }

    bool
    operator==(const DNSRecord& _o) const;

    bool
    operator!=(const DNSRecord& _o) const;

    nsCString&
    canonicalName()
    {
        return canonicalName_;
    }
    const nsCString&
    canonicalName() const
    {
        return canonicalName_;
    }

    NetAddrArray&
    addrs()
    {
        return addrs_;
    }
    const NetAddrArray&
    addrs() const
    {
        return addrs_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsCString& _canonicalName,
            const NetAddrArray& _addrs);

    nsCString canonicalName_;
    NetAddrArray addrs_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class DNSRecord;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union DNSRequestResponse|
//
namespace mozilla {
namespace net {
class DNSRequestResponse final
{
public:
    enum Type {
        T__None,
        TDNSRecord = 1,
        Tnsresult,
        T__Last = Tnsresult
    };

private:
    typedef mozilla::net::DNSRecord DNSRecord;
    typedef DNSRecord DNSRecord__tdef;
    typedef nsresult nsresult__tdef;

    union Value {
        mozilla::AlignedStorage2<DNSRecord> VDNSRecord;
        mozilla::AlignedStorage2<nsresult> Vnsresult;
    };

    DNSRecord*
    ptr_DNSRecord()
    {
        return ((mValue).VDNSRecord).addr();
    }
    const DNSRecord*
    constptr_DNSRecord() const
    {
        return ((mValue).VDNSRecord).addr();
    }
    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT DNSRequestResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT DNSRequestResponse(const DNSRecord& aOther);

    MOZ_IMPLICIT DNSRequestResponse(const nsresult& aOther);

    MOZ_IMPLICIT DNSRequestResponse(const DNSRequestResponse& aOther);

    ~DNSRequestResponse();

    Type
    type() const
    {
        return mType;
    }

    DNSRequestResponse&
    operator=(const DNSRecord& aRhs);

    DNSRequestResponse&
    operator=(const nsresult& aRhs);

    DNSRequestResponse&
    operator=(const DNSRequestResponse& aRhs);

    bool
    operator==(const DNSRecord& aRhs) const;

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const DNSRequestResponse& aRhs) const;

    DNSRecord&
    get_DNSRecord()
    {
        AssertSanity(TDNSRecord);
        return (*(ptr_DNSRecord()));
    }
    const DNSRecord&
    get_DNSRecord() const
    {
        AssertSanity(TDNSRecord);
        return (*(constptr_DNSRecord()));
    }
    void
    get(DNSRecord* aOutValue) const;
    operator DNSRecord&()
    {
        return get_DNSRecord();
    }
    operator const DNSRecord&() const
    {
        return get_DNSRecord();
    }

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    void
    get(nsresult* aOutValue) const;
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

#endif // ifndef PDNSRequestParams_h
