//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDNSRequestParent_h
#define PDNSRequestParent_h

#include "mozilla/net/PDNSRequest.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class PDNSRequestParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PNeckoParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::net::DNSRecord DNSRecord;
    typedef mozilla::net::DNSRequestResponse DNSRequestResponse;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PDNSRequest::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvCancelDNSRequest(
            const nsCString& hostName,
            const OriginAttributes& originAttributes,
            const uint32_t& flags,
            const nsCString& networkInterface,
            const nsresult& reason) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PDNSRequestParent();

    virtual ~PDNSRequestParent();

    PNeckoParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendLookupCompleted(const DNSRequestResponse& reply);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const DNSRequestResponse& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            DNSRequestResponse* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PDNSRequestParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PDNSRequestParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const DNSRecord& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            DNSRecord* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class DNSRequestParent :
    public PDNSRequestParent
{
    virtual mozilla::ipc::IPCResult
    RecvCancelDNSRequest(
            const nsCString& hostName,
            const OriginAttributes& originAttributes,
            const uint32_t& flags,
            const nsCString& networkInterface,
            const nsresult& reason);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT DNSRequestParent();
    virtual ~DNSRequestParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
DNSRequestParent::RecvCancelDNSRequest(
        const nsCString& hostName,
        const OriginAttributes& originAttributes,
        const uint32_t& flags,
        const nsCString& networkInterface,
        const nsresult& reason)
{
}

void
DNSRequestParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT DNSRequestParent::DNSRequestParent()
{
    MOZ_COUNT_CTOR(DNSRequestParent);
}

MOZ_IMPLICIT DNSRequestParent::~DNSRequestParent()
{
    MOZ_COUNT_DTOR(DNSRequestParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PDNSRequestParent_h
