//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTCPSocketChild_h
#define PTCPSocketChild_h

#include "mozilla/net/PTCPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PTCPServerSocketChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PTCPSocketChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PTCPServerSocketChild;
    friend class mozilla::net::PNeckoChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::net::PNeckoParent PNeckoParent;

    typedef PTCPSocket::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestDelete() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PTCPSocketChild();

    virtual ~PTCPSocketChild();

    PNeckoChild*
    Manager() const;

    bool
    SendOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers);

    bool
    SendOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& reuseAddrPort,
            const bool& aUseArrayBuffers,
            const nsCString& aFilter);

    bool
    SendData(
            const SendableData& data,
            const uint32_t& trackingNumber);

    bool
    SendStartTLS();

    bool
    SendSuspend();

    bool
    SendResume();

    bool
    SendClose();

    bool
    SendRequestDelete();

    static bool
    Send__delete__(PTCPSocketChild* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SendableData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SendableData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PTCPSocketChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PTCPSocketChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const CallbackData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            CallbackData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const TCPError& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            TCPError* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class TCPSocketChild :
    public PTCPSocketChild
{
    virtual mozilla::ipc::IPCResult
    RecvCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState);

    virtual mozilla::ipc::IPCResult
    RecvUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber);

    virtual mozilla::ipc::IPCResult
    RecvRequestDelete();

    MOZ_IMPLICIT TCPSocketChild();
    virtual ~TCPSocketChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
TCPSocketChild::RecvCallback(
        const nsString& type,
        const CallbackData& data,
        const uint32_t& readyState)
{
}

mozilla::ipc::IPCResult
TCPSocketChild::RecvUpdateBufferedAmount(
        const uint32_t& bufferedAmount,
        const uint32_t& trackingNumber)
{
}

mozilla::ipc::IPCResult
TCPSocketChild::RecvRequestDelete()
{
}

MOZ_IMPLICIT TCPSocketChild::TCPSocketChild()
{
    MOZ_COUNT_CTOR(TCPSocketChild);
}

MOZ_IMPLICIT TCPSocketChild::~TCPSocketChild()
{
    MOZ_COUNT_DTOR(TCPSocketChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PTCPSocketChild_h
