//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTCPSocketParent_h
#define PTCPSocketParent_h

#include "mozilla/net/PTCPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PTCPServerSocketParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PTCPSocketParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PTCPServerSocketParent;
    friend class mozilla::net::PNeckoParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PTCPSocket::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers) = 0;
    virtual mozilla::ipc::IPCResult
    RecvOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& reuseAddrPort,
            const bool& aUseArrayBuffers,
            const nsCString& aFilter) = 0;
    virtual mozilla::ipc::IPCResult
    RecvData(
            const SendableData& data,
            const uint32_t& trackingNumber) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartTLS() = 0;
    virtual mozilla::ipc::IPCResult
    RecvSuspend() = 0;
    virtual mozilla::ipc::IPCResult
    RecvResume() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClose() = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestDelete() = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PTCPSocketParent();

    virtual ~PTCPSocketParent();

    PNeckoParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendCallback(
            const nsString& type,
            const CallbackData& data,
            const uint32_t& readyState);

    MOZ_MUST_USE bool
    SendUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber);

    MOZ_MUST_USE bool
    SendRequestDelete();

    MOZ_MUST_USE static bool
    Send__delete__(PTCPSocketParent* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SendableData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SendableData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PTCPSocketParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PTCPSocketParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const CallbackData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            CallbackData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const TCPError& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            TCPError* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class TCPSocketParent :
    public PTCPSocketParent
{
    virtual mozilla::ipc::IPCResult
    RecvOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const bool& useArrayBuffers);

    virtual mozilla::ipc::IPCResult
    RecvOpenBind(
            const nsCString& host,
            const uint16_t& port,
            const nsCString& localAddr,
            const uint16_t& localPort,
            const bool& useSSL,
            const bool& reuseAddrPort,
            const bool& aUseArrayBuffers,
            const nsCString& aFilter);

    virtual mozilla::ipc::IPCResult
    RecvData(
            const SendableData& data,
            const uint32_t& trackingNumber);

    virtual mozilla::ipc::IPCResult
    RecvStartTLS();

    virtual mozilla::ipc::IPCResult
    RecvSuspend();

    virtual mozilla::ipc::IPCResult
    RecvResume();

    virtual mozilla::ipc::IPCResult
    RecvClose();

    virtual mozilla::ipc::IPCResult
    RecvRequestDelete();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT TCPSocketParent();
    virtual ~TCPSocketParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
TCPSocketParent::RecvOpen(
        const nsString& host,
        const uint16_t& port,
        const bool& useSSL,
        const bool& useArrayBuffers)
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvOpenBind(
        const nsCString& host,
        const uint16_t& port,
        const nsCString& localAddr,
        const uint16_t& localPort,
        const bool& useSSL,
        const bool& reuseAddrPort,
        const bool& aUseArrayBuffers,
        const nsCString& aFilter)
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvData(
        const SendableData& data,
        const uint32_t& trackingNumber)
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvStartTLS()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvSuspend()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvResume()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvClose()
{
}

mozilla::ipc::IPCResult
TCPSocketParent::RecvRequestDelete()
{
}

void
TCPSocketParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT TCPSocketParent::TCPSocketParent()
{
    MOZ_COUNT_CTOR(TCPSocketParent);
}

MOZ_IMPLICIT TCPSocketParent::~TCPSocketParent()
{
    MOZ_COUNT_DTOR(TCPSocketParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PTCPSocketParent_h
