//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PlatformWidgetTypes_h
#define PlatformWidgetTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "Units.h"
#include "mozilla/widget/HeadlessWidgetTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct X11CompositorWidgetInitData|
//
namespace mozilla {
namespace widget {
class X11CompositorWidgetInitData final
{
private:
    typedef mozilla::LayoutDeviceIntSize LayoutDeviceIntSize;

public:
    MOZ_IMPLICIT X11CompositorWidgetInitData();

    MOZ_IMPLICIT X11CompositorWidgetInitData(
            const uintptr_t& _XWindow,
            const nsCString& _XDisplayString,
            const LayoutDeviceIntSize& _InitialClientSize)
    {
        Init();
        Assign(_XWindow, _XDisplayString, _InitialClientSize);
    }

    MOZ_IMPLICIT X11CompositorWidgetInitData(const X11CompositorWidgetInitData& _o)
    {
        Init();
        Assign((_o).XWindow(), (_o).XDisplayString(), (_o).InitialClientSize());
    }

    ~X11CompositorWidgetInitData();

    void
    operator=(const X11CompositorWidgetInitData& _o)
    {
        Assign((_o).XWindow(), (_o).XDisplayString(), (_o).InitialClientSize());
    }

    bool
    operator==(const X11CompositorWidgetInitData& _o) const;

    bool
    operator!=(const X11CompositorWidgetInitData& _o) const;

    uintptr_t&
    XWindow()
    {
        return XWindow_;
    }
    const uintptr_t&
    XWindow() const
    {
        return XWindow_;
    }

    nsCString&
    XDisplayString()
    {
        return XDisplayString_;
    }
    const nsCString&
    XDisplayString() const
    {
        return XDisplayString_;
    }

    LayoutDeviceIntSize&
    InitialClientSize()
    {
        return InitialClientSize_;
    }
    const LayoutDeviceIntSize&
    InitialClientSize() const
    {
        return InitialClientSize_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _XWindow,
            const nsCString& _XDisplayString,
            const LayoutDeviceIntSize& _InitialClientSize);

    uintptr_t XWindow_;
    nsCString XDisplayString_;
    LayoutDeviceIntSize InitialClientSize_;
};
} // namespace widget
} // namespace mozilla

namespace mozilla {
namespace widget {
class X11CompositorWidgetInitData;
} // namespace widget
} // namespace mozilla
namespace mozilla {
namespace widget {
class HeadlessCompositorWidgetInitData;
} // namespace widget
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union CompositorWidgetInitData|
//
namespace mozilla {
namespace widget {
class CompositorWidgetInitData final
{
public:
    enum Type {
        T__None,
        TX11CompositorWidgetInitData = 1,
        THeadlessCompositorWidgetInitData,
        T__Last = THeadlessCompositorWidgetInitData
    };

private:
    typedef mozilla::widget::X11CompositorWidgetInitData X11CompositorWidgetInitData;
    typedef mozilla::widget::HeadlessCompositorWidgetInitData HeadlessCompositorWidgetInitData;
    typedef X11CompositorWidgetInitData X11CompositorWidgetInitData__tdef;
    typedef HeadlessCompositorWidgetInitData HeadlessCompositorWidgetInitData__tdef;

    union Value {
        mozilla::AlignedStorage2<X11CompositorWidgetInitData> VX11CompositorWidgetInitData;
        mozilla::AlignedStorage2<HeadlessCompositorWidgetInitData> VHeadlessCompositorWidgetInitData;
    };

    X11CompositorWidgetInitData*
    ptr_X11CompositorWidgetInitData()
    {
        return ((mValue).VX11CompositorWidgetInitData).addr();
    }
    const X11CompositorWidgetInitData*
    constptr_X11CompositorWidgetInitData() const
    {
        return ((mValue).VX11CompositorWidgetInitData).addr();
    }
    HeadlessCompositorWidgetInitData*
    ptr_HeadlessCompositorWidgetInitData()
    {
        return ((mValue).VHeadlessCompositorWidgetInitData).addr();
    }
    const HeadlessCompositorWidgetInitData*
    constptr_HeadlessCompositorWidgetInitData() const
    {
        return ((mValue).VHeadlessCompositorWidgetInitData).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT CompositorWidgetInitData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT CompositorWidgetInitData(const X11CompositorWidgetInitData& aOther);

    MOZ_IMPLICIT CompositorWidgetInitData(const HeadlessCompositorWidgetInitData& aOther);

    MOZ_IMPLICIT CompositorWidgetInitData(const CompositorWidgetInitData& aOther);

    ~CompositorWidgetInitData();

    Type
    type() const
    {
        return mType;
    }

    CompositorWidgetInitData&
    operator=(const X11CompositorWidgetInitData& aRhs);

    CompositorWidgetInitData&
    operator=(const HeadlessCompositorWidgetInitData& aRhs);

    CompositorWidgetInitData&
    operator=(const CompositorWidgetInitData& aRhs);

    bool
    operator==(const X11CompositorWidgetInitData& aRhs) const;

    bool
    operator==(const HeadlessCompositorWidgetInitData& aRhs) const;

    bool
    operator==(const CompositorWidgetInitData& aRhs) const;

    X11CompositorWidgetInitData&
    get_X11CompositorWidgetInitData()
    {
        AssertSanity(TX11CompositorWidgetInitData);
        return (*(ptr_X11CompositorWidgetInitData()));
    }
    const X11CompositorWidgetInitData&
    get_X11CompositorWidgetInitData() const
    {
        AssertSanity(TX11CompositorWidgetInitData);
        return (*(constptr_X11CompositorWidgetInitData()));
    }
    void
    get(X11CompositorWidgetInitData* aOutValue) const;
    operator X11CompositorWidgetInitData&()
    {
        return get_X11CompositorWidgetInitData();
    }
    operator const X11CompositorWidgetInitData&() const
    {
        return get_X11CompositorWidgetInitData();
    }

    HeadlessCompositorWidgetInitData&
    get_HeadlessCompositorWidgetInitData()
    {
        AssertSanity(THeadlessCompositorWidgetInitData);
        return (*(ptr_HeadlessCompositorWidgetInitData()));
    }
    const HeadlessCompositorWidgetInitData&
    get_HeadlessCompositorWidgetInitData() const
    {
        AssertSanity(THeadlessCompositorWidgetInitData);
        return (*(constptr_HeadlessCompositorWidgetInitData()));
    }
    void
    get(HeadlessCompositorWidgetInitData* aOutValue) const;
    operator HeadlessCompositorWidgetInitData&()
    {
        return get_HeadlessCompositorWidgetInitData();
    }
    operator const HeadlessCompositorWidgetInitData&() const
    {
        return get_HeadlessCompositorWidgetInitData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace widget
} // namespace mozilla

#endif // ifndef PlatformWidgetTypes_h
