/* This file is auto-generated, only for internal use in TelemetryEvent.h,
   see gen-event-data.py. */

#ifndef mozilla_TelemetryEventData_h
#define mozilla_TelemetryEventData_h
#include "EventInfo.h"
namespace {

const uint32_t gExtraKeysTable[] = {
  // navigation, [search], [about_home, about_newtab, contextmenu, oneoff, suggestion, alias, enter, searchbar, urlbar]
  // extra_keys: engine
  0,
  // telemetry.test, [optout], [object1, object2]
  // extra_keys: key1
  7,
  // telemetry.test, [content_only], [object1]
  // extra_keys: foo, bar
  12, 16,
  // telemetry.test, [test1, test2], [object1, object2]
  // extra_keys: key2, key1
  20, 7,
  // telemetry.test.second, [test], [object1, object2, object3]
  // extra_keys: key1
  7,
};
static_assert(sizeof(gExtraKeysTable) <= UINT32_MAX, "index overflow");

const CommonEventInfo gCommonEventInfo[] = {
  // category: navigation
  // methods: [search]
  // objects: [about_home, about_newtab, contextmenu, oneoff, suggestion, alias, enter, searchbar, urlbar]
  {25, 36, 0, 1, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTOUT, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test
  // methods: [optout]
  // objects: [object1, object2]
  {43, 58, 1, 1, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTOUT, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test
  // methods: [main_only]
  // objects: [object1]
  {43, 58, 0, 0, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test
  // methods: [main_and_content]
  // objects: [object1]
  {43, 58, 0, 0, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Main | mozilla::Telemetry::Common::RecordedProcessType::Content},
  // category: telemetry.test
  // methods: [expired_version]
  // objects: [object1, object2]
  {43, 64, 0, 0, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test
  // methods: [content_only]
  // objects: [object1]
  {43, 58, 2, 2, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Content},
  // category: telemetry.test
  // methods: [expired_date]
  // objects: [object1, object2]
  {43, 58, 0, 0, 16098, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test
  // methods: [test1, test2]
  // objects: [object1, object2]
  {43, 58, 4, 2, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test
  // methods: [not_expired_optout]
  // objects: [object1]
  {43, 68, 0, 0, 47117, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTOUT, mozilla::Telemetry::Common::RecordedProcessType::Main},
  // category: telemetry.test.second
  // methods: [test]
  // objects: [object1, object2, object3]
  {76, 58, 6, 1, 0, nsITelemetry::DATASET_RELEASE_CHANNEL_OPTIN, mozilla::Telemetry::Common::RecordedProcessType::Main},
};
static_assert(sizeof(gCommonEventInfo) <= UINT32_MAX, "index overflow");

const EventInfo gEventInfo[] = {
  // category: navigation, method: search, object: about_home
  {gCommonEventInfo[0], 98, 105},
  // category: navigation, method: search, object: about_newtab
  {gCommonEventInfo[0], 98, 116},
  // category: navigation, method: search, object: contextmenu
  {gCommonEventInfo[0], 98, 129},
  // category: navigation, method: search, object: oneoff
  {gCommonEventInfo[0], 98, 141},
  // category: navigation, method: search, object: suggestion
  {gCommonEventInfo[0], 98, 148},
  // category: navigation, method: search, object: alias
  {gCommonEventInfo[0], 98, 159},
  // category: navigation, method: search, object: enter
  {gCommonEventInfo[0], 98, 165},
  // category: navigation, method: search, object: searchbar
  {gCommonEventInfo[0], 98, 171},
  // category: navigation, method: search, object: urlbar
  {gCommonEventInfo[0], 98, 181},
  // category: telemetry.test, method: optout, object: object1
  {gCommonEventInfo[1], 188, 195},
  // category: telemetry.test, method: optout, object: object2
  {gCommonEventInfo[1], 188, 203},
  // category: telemetry.test, method: main_only, object: object1
  {gCommonEventInfo[2], 211, 195},
  // category: telemetry.test, method: main_and_content, object: object1
  {gCommonEventInfo[3], 221, 195},
  // category: telemetry.test, method: expired_version, object: object1
  {gCommonEventInfo[4], 238, 195},
  // category: telemetry.test, method: expired_version, object: object2
  {gCommonEventInfo[4], 238, 203},
  // category: telemetry.test, method: content_only, object: object1
  {gCommonEventInfo[5], 254, 195},
  // category: telemetry.test, method: expired_date, object: object1
  {gCommonEventInfo[6], 267, 195},
  // category: telemetry.test, method: expired_date, object: object2
  {gCommonEventInfo[6], 267, 203},
  // category: telemetry.test, method: test1, object: object1
  {gCommonEventInfo[7], 280, 195},
  // category: telemetry.test, method: test1, object: object2
  {gCommonEventInfo[7], 280, 203},
  // category: telemetry.test, method: test2, object: object1
  {gCommonEventInfo[7], 286, 195},
  // category: telemetry.test, method: test2, object: object2
  {gCommonEventInfo[7], 286, 203},
  // category: telemetry.test, method: not_expired_optout, object: object1
  {gCommonEventInfo[8], 292, 195},
  // category: telemetry.test.second, method: test, object: object1
  {gCommonEventInfo[9], 311, 195},
  // category: telemetry.test.second, method: test, object: object2
  {gCommonEventInfo[9], 311, 203},
  // category: telemetry.test.second, method: test, object: object3
  {gCommonEventInfo[9], 311, 316},
};
static_assert(sizeof(gEventInfo) <= UINT32_MAX, "index overflow");

const char gEventsStringTable[] = {
  /*     0 - "engine" */ 'e', 'n', 'g', 'i', 'n', 'e', '\0',
  /*     7 - "key1" */ 'k', 'e', 'y', '1', '\0',
  /*    12 - "foo" */ 'f', 'o', 'o', '\0',
  /*    16 - "bar" */ 'b', 'a', 'r', '\0',
  /*    20 - "key2" */ 'k', 'e', 'y', '2', '\0',
  /*    25 - "navigation" */ 'n', 'a', 'v', 'i', 'g', 'a', 't', 'i', 'o', 'n', '\0',
  /*    36 - "58.0a1" */ '5', '8', '.', '0', 'a', '1', '\0',
  /*    43 - "telemetry.test" */ 't', 'e', 'l', 'e', 'm', 'e', 't', 'r', 'y', '.', 't', 'e', 's', 't', '\0',
  /*    58 - "never" */ 'n', 'e', 'v', 'e', 'r', '\0',
  /*    64 - "3.6" */ '3', '.', '6', '\0',
  /*    68 - "999.0a1" */ '9', '9', '9', '.', '0', 'a', '1', '\0',
  /*    76 - "telemetry.test.second" */ 't', 'e', 'l', 'e', 'm', 'e', 't', 'r', 'y', '.', 't', 'e', 's', 't', '.', 's', 'e', 'c', 'o', 'n', 'd', '\0',
  /*    98 - "search" */ 's', 'e', 'a', 'r', 'c', 'h', '\0',
  /*   105 - "about_home" */ 'a', 'b', 'o', 'u', 't', '_', 'h', 'o', 'm', 'e', '\0',
  /*   116 - "about_newtab" */ 'a', 'b', 'o', 'u', 't', '_', 'n', 'e', 'w', 't', 'a', 'b', '\0',
  /*   129 - "contextmenu" */ 'c', 'o', 'n', 't', 'e', 'x', 't', 'm', 'e', 'n', 'u', '\0',
  /*   141 - "oneoff" */ 'o', 'n', 'e', 'o', 'f', 'f', '\0',
  /*   148 - "suggestion" */ 's', 'u', 'g', 'g', 'e', 's', 't', 'i', 'o', 'n', '\0',
  /*   159 - "alias" */ 'a', 'l', 'i', 'a', 's', '\0',
  /*   165 - "enter" */ 'e', 'n', 't', 'e', 'r', '\0',
  /*   171 - "searchbar" */ 's', 'e', 'a', 'r', 'c', 'h', 'b', 'a', 'r', '\0',
  /*   181 - "urlbar" */ 'u', 'r', 'l', 'b', 'a', 'r', '\0',
  /*   188 - "optout" */ 'o', 'p', 't', 'o', 'u', 't', '\0',
  /*   195 - "object1" */ 'o', 'b', 'j', 'e', 'c', 't', '1', '\0',
  /*   203 - "object2" */ 'o', 'b', 'j', 'e', 'c', 't', '2', '\0',
  /*   211 - "main_only" */ 'm', 'a', 'i', 'n', '_', 'o', 'n', 'l', 'y', '\0',
  /*   221 - "main_and_content" */ 'm', 'a', 'i', 'n', '_', 'a', 'n', 'd', '_', 'c', 'o', 'n', 't', 'e', 'n', 't', '\0',
  /*   238 - "expired_version" */ 'e', 'x', 'p', 'i', 'r', 'e', 'd', '_', 'v', 'e', 'r', 's', 'i', 'o', 'n', '\0',
  /*   254 - "content_only" */ 'c', 'o', 'n', 't', 'e', 'n', 't', '_', 'o', 'n', 'l', 'y', '\0',
  /*   267 - "expired_date" */ 'e', 'x', 'p', 'i', 'r', 'e', 'd', '_', 'd', 'a', 't', 'e', '\0',
  /*   280 - "test1" */ 't', 'e', 's', 't', '1', '\0',
  /*   286 - "test2" */ 't', 'e', 's', 't', '2', '\0',
  /*   292 - "not_expired_optout" */ 'n', 'o', 't', '_', 'e', 'x', 'p', 'i', 'r', 'e', 'd', '_', 'o', 'p', 't', 'o', 'u', 't', '\0',
  /*   311 - "test" */ 't', 'e', 's', 't', '\0',
  /*   316 - "object3" */ 'o', 'b', 'j', 'e', 'c', 't', '3', '\0',
};

static_assert(sizeof(gEventsStringTable) <= UINT32_MAX, "index overflow");

} // namespace
#endif // mozilla_TelemetryEventData_h

