//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LayersMessages_h
#define LayersMessages_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "FrameMetrics.h"
#include "Layers.h"
#include "Units.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/WidgetUtils.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "mozilla/gfx/2D.h"
#include "mozilla/gfx/Matrix.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/ipc/CrossProcessSemaphore.h"
#include "mozilla/layers/CompositorTypes.h"
#include "mozilla/layers/FocusTarget.h"
#include "mozilla/layers/LayerAttributes.h"
#include "mozilla/layers/LayersTypes.h"
#include "nsCSSPropertyID.h"
#include "nsPoint.h"
#include "nsRect.h"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TargetConfig|
//
namespace mozilla {
namespace layers {
class TargetConfig final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::ScreenRotation ScreenRotation;
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;

public:
    MOZ_IMPLICIT TargetConfig();

    MOZ_IMPLICIT TargetConfig(
            const IntRect& _naturalBounds,
            const ScreenRotation& _rotation,
            const ScreenOrientationInternal& _orientation,
            const nsIntRegion& _clearRegion)
    {
        Init();
        Assign(_naturalBounds, _rotation, _orientation, _clearRegion);
    }

    MOZ_IMPLICIT TargetConfig(const TargetConfig& _o)
    {
        Init();
        Assign((_o).naturalBounds(), (_o).rotation(), (_o).orientation(), (_o).clearRegion());
    }

    ~TargetConfig();

    void
    operator=(const TargetConfig& _o)
    {
        Assign((_o).naturalBounds(), (_o).rotation(), (_o).orientation(), (_o).clearRegion());
    }

    bool
    operator==(const TargetConfig& _o) const;

    bool
    operator!=(const TargetConfig& _o) const;

    IntRect&
    naturalBounds()
    {
        return naturalBounds_;
    }
    const IntRect&
    naturalBounds() const
    {
        return naturalBounds_;
    }

    ScreenRotation&
    rotation()
    {
        return rotation_;
    }
    const ScreenRotation&
    rotation() const
    {
        return rotation_;
    }

    ScreenOrientationInternal&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientationInternal&
    orientation() const
    {
        return orientation_;
    }

    nsIntRegion&
    clearRegion()
    {
        return clearRegion_;
    }
    const nsIntRegion&
    clearRegion() const
    {
        return clearRegion_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntRect& _naturalBounds,
            const ScreenRotation& _rotation,
            const ScreenOrientationInternal& _orientation,
            const nsIntRegion& _clearRegion);

    IntRect naturalBounds_;
    ScreenRotation rotation_;
    ScreenOrientationInternal orientation_;
    nsIntRegion clearRegion_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreatePaintedLayer|
//
namespace mozilla {
namespace layers {
class OpCreatePaintedLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreatePaintedLayer();

    MOZ_IMPLICIT OpCreatePaintedLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreatePaintedLayer(const OpCreatePaintedLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreatePaintedLayer();

    void
    operator=(const OpCreatePaintedLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreatePaintedLayer& _o) const;

    bool
    operator!=(const OpCreatePaintedLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateContainerLayer|
//
namespace mozilla {
namespace layers {
class OpCreateContainerLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateContainerLayer();

    MOZ_IMPLICIT OpCreateContainerLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateContainerLayer(const OpCreateContainerLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateContainerLayer();

    void
    operator=(const OpCreateContainerLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateContainerLayer& _o) const;

    bool
    operator!=(const OpCreateContainerLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateImageLayer|
//
namespace mozilla {
namespace layers {
class OpCreateImageLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateImageLayer();

    MOZ_IMPLICIT OpCreateImageLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateImageLayer(const OpCreateImageLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateImageLayer();

    void
    operator=(const OpCreateImageLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateImageLayer& _o) const;

    bool
    operator!=(const OpCreateImageLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateColorLayer|
//
namespace mozilla {
namespace layers {
class OpCreateColorLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateColorLayer();

    MOZ_IMPLICIT OpCreateColorLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateColorLayer(const OpCreateColorLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateColorLayer();

    void
    operator=(const OpCreateColorLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateColorLayer& _o) const;

    bool
    operator!=(const OpCreateColorLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateTextLayer|
//
namespace mozilla {
namespace layers {
class OpCreateTextLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateTextLayer();

    MOZ_IMPLICIT OpCreateTextLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateTextLayer(const OpCreateTextLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateTextLayer();

    void
    operator=(const OpCreateTextLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateTextLayer& _o) const;

    bool
    operator!=(const OpCreateTextLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateBorderLayer|
//
namespace mozilla {
namespace layers {
class OpCreateBorderLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateBorderLayer();

    MOZ_IMPLICIT OpCreateBorderLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateBorderLayer(const OpCreateBorderLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateBorderLayer();

    void
    operator=(const OpCreateBorderLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateBorderLayer& _o) const;

    bool
    operator!=(const OpCreateBorderLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateCanvasLayer|
//
namespace mozilla {
namespace layers {
class OpCreateCanvasLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateCanvasLayer();

    MOZ_IMPLICIT OpCreateCanvasLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateCanvasLayer(const OpCreateCanvasLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateCanvasLayer();

    void
    operator=(const OpCreateCanvasLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateCanvasLayer& _o) const;

    bool
    operator!=(const OpCreateCanvasLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateRefLayer|
//
namespace mozilla {
namespace layers {
class OpCreateRefLayer final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpCreateRefLayer();

    MOZ_IMPLICIT OpCreateRefLayer(const LayerHandle& _layer)
    {
        Init();
        Assign(_layer);
    }

    MOZ_IMPLICIT OpCreateRefLayer(const OpCreateRefLayer& _o)
    {
        Init();
        Assign((_o).layer());
    }

    ~OpCreateRefLayer();

    void
    operator=(const OpCreateRefLayer& _o)
    {
        Assign((_o).layer());
    }

    bool
    operator==(const OpCreateRefLayer& _o) const;

    bool
    operator!=(const OpCreateRefLayer& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _layer);

    LayerHandle layer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAttachCompositable|
//
namespace mozilla {
namespace layers {
class OpAttachCompositable final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::CompositableHandle CompositableHandle;

public:
    MOZ_IMPLICIT OpAttachCompositable();

    MOZ_IMPLICIT OpAttachCompositable(
            const LayerHandle& _layer,
            const CompositableHandle& _compositable)
    {
        Init();
        Assign(_layer, _compositable);
    }

    MOZ_IMPLICIT OpAttachCompositable(const OpAttachCompositable& _o)
    {
        Init();
        Assign((_o).layer(), (_o).compositable());
    }

    ~OpAttachCompositable();

    void
    operator=(const OpAttachCompositable& _o)
    {
        Assign((_o).layer(), (_o).compositable());
    }

    bool
    operator==(const OpAttachCompositable& _o) const;

    bool
    operator!=(const OpAttachCompositable& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _layer,
            const CompositableHandle& _compositable);

    LayerHandle layer_;
    CompositableHandle compositable_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAttachAsyncCompositable|
//
namespace mozilla {
namespace layers {
class OpAttachAsyncCompositable final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::CompositableHandle CompositableHandle;

public:
    MOZ_IMPLICIT OpAttachAsyncCompositable();

    MOZ_IMPLICIT OpAttachAsyncCompositable(
            const LayerHandle& _layer,
            const CompositableHandle& _compositable)
    {
        Init();
        Assign(_layer, _compositable);
    }

    MOZ_IMPLICIT OpAttachAsyncCompositable(const OpAttachAsyncCompositable& _o)
    {
        Init();
        Assign((_o).layer(), (_o).compositable());
    }

    ~OpAttachAsyncCompositable();

    void
    operator=(const OpAttachAsyncCompositable& _o)
    {
        Assign((_o).layer(), (_o).compositable());
    }

    bool
    operator==(const OpAttachAsyncCompositable& _o) const;

    bool
    operator!=(const OpAttachAsyncCompositable& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _layer,
            const CompositableHandle& _compositable);

    LayerHandle layer_;
    CompositableHandle compositable_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ThebesBufferData|
//
namespace mozilla {
namespace layers {
class ThebesBufferData final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::gfx::IntPoint IntPoint;

public:
    MOZ_IMPLICIT ThebesBufferData();

    MOZ_IMPLICIT ThebesBufferData(
            const IntRect& _rect,
            const IntPoint& _rotation)
    {
        Init();
        Assign(_rect, _rotation);
    }

    MOZ_IMPLICIT ThebesBufferData(const ThebesBufferData& _o)
    {
        Init();
        Assign((_o).rect(), (_o).rotation());
    }

    ~ThebesBufferData();

    void
    operator=(const ThebesBufferData& _o)
    {
        Assign((_o).rect(), (_o).rotation());
    }

    bool
    operator==(const ThebesBufferData& _o) const;

    bool
    operator!=(const ThebesBufferData& _o) const;

    IntRect&
    rect()
    {
        return rect_;
    }
    const IntRect&
    rect() const
    {
        return rect_;
    }

    IntPoint&
    rotation()
    {
        return rotation_;
    }
    const IntPoint&
    rotation() const
    {
        return rotation_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntRect& _rect,
            const IntPoint& _rotation);

    IntRect rect_;
    IntPoint rotation_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CubicBezierFunction|
//
namespace mozilla {
namespace layers {
class CubicBezierFunction final
{
private:

public:
    MOZ_IMPLICIT CubicBezierFunction();

    MOZ_IMPLICIT CubicBezierFunction(
            const float& _x1,
            const float& _y1,
            const float& _x2,
            const float& _y2)
    {
        Init();
        Assign(_x1, _y1, _x2, _y2);
    }

    MOZ_IMPLICIT CubicBezierFunction(const CubicBezierFunction& _o)
    {
        Init();
        Assign((_o).x1(), (_o).y1(), (_o).x2(), (_o).y2());
    }

    ~CubicBezierFunction();

    void
    operator=(const CubicBezierFunction& _o)
    {
        Assign((_o).x1(), (_o).y1(), (_o).x2(), (_o).y2());
    }

    bool
    operator==(const CubicBezierFunction& _o) const;

    bool
    operator!=(const CubicBezierFunction& _o) const;

    float&
    x1()
    {
        return x1_;
    }
    const float&
    x1() const
    {
        return x1_;
    }

    float&
    y1()
    {
        return y1_;
    }
    const float&
    y1() const
    {
        return y1_;
    }

    float&
    x2()
    {
        return x2_;
    }
    const float&
    x2() const
    {
        return x2_;
    }

    float&
    y2()
    {
        return y2_;
    }
    const float&
    y2() const
    {
        return y2_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x1,
            const float& _y1,
            const float& _x2,
            const float& _y2);

    float x1_;
    float y1_;
    float x2_;
    float y2_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StepFunction|
//
namespace mozilla {
namespace layers {
class StepFunction final
{
private:

public:
    MOZ_IMPLICIT StepFunction();

    MOZ_IMPLICIT StepFunction(
            const int& _steps,
            const int& _type)
    {
        Init();
        Assign(_steps, _type);
    }

    MOZ_IMPLICIT StepFunction(const StepFunction& _o)
    {
        Init();
        Assign((_o).steps(), (_o).type());
    }

    ~StepFunction();

    void
    operator=(const StepFunction& _o)
    {
        Assign((_o).steps(), (_o).type());
    }

    bool
    operator==(const StepFunction& _o) const;

    bool
    operator!=(const StepFunction& _o) const;

    int&
    steps()
    {
        return steps_;
    }
    const int&
    steps() const
    {
        return steps_;
    }

    int&
    type()
    {
        return type_;
    }
    const int&
    type() const
    {
        return type_;
    }

private:
    void
    Init();

    void
    Assign(
            const int& _steps,
            const int& _type);

    int steps_;
    int type_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FramesFunction|
//
namespace mozilla {
namespace layers {
class FramesFunction final
{
private:

public:
    MOZ_IMPLICIT FramesFunction();

    MOZ_IMPLICIT FramesFunction(const int& _frames)
    {
        Init();
        Assign(_frames);
    }

    MOZ_IMPLICIT FramesFunction(const FramesFunction& _o)
    {
        Init();
        Assign((_o).frames());
    }

    ~FramesFunction();

    void
    operator=(const FramesFunction& _o)
    {
        Assign((_o).frames());
    }

    bool
    operator==(const FramesFunction& _o) const;

    bool
    operator!=(const FramesFunction& _o) const;

    int&
    frames()
    {
        return frames_;
    }
    const int&
    frames() const
    {
        return frames_;
    }

private:
    void
    Init();

    void
    Assign(const int& _frames);

    int frames_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CubicBezierFunction;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class StepFunction;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class FramesFunction;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TimingFunction|
//
namespace mozilla {
namespace layers {
class TimingFunction final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TCubicBezierFunction,
        TStepFunction,
        TFramesFunction,
        T__Last = TFramesFunction
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::CubicBezierFunction CubicBezierFunction;
    typedef mozilla::layers::StepFunction StepFunction;
    typedef mozilla::layers::FramesFunction FramesFunction;
    typedef null_t null_t__tdef;
    typedef CubicBezierFunction CubicBezierFunction__tdef;
    typedef StepFunction StepFunction__tdef;
    typedef FramesFunction FramesFunction__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<CubicBezierFunction> VCubicBezierFunction;
        mozilla::AlignedStorage2<StepFunction> VStepFunction;
        mozilla::AlignedStorage2<FramesFunction> VFramesFunction;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    CubicBezierFunction*
    ptr_CubicBezierFunction()
    {
        return ((mValue).VCubicBezierFunction).addr();
    }
    const CubicBezierFunction*
    constptr_CubicBezierFunction() const
    {
        return ((mValue).VCubicBezierFunction).addr();
    }
    StepFunction*
    ptr_StepFunction()
    {
        return ((mValue).VStepFunction).addr();
    }
    const StepFunction*
    constptr_StepFunction() const
    {
        return ((mValue).VStepFunction).addr();
    }
    FramesFunction*
    ptr_FramesFunction()
    {
        return ((mValue).VFramesFunction).addr();
    }
    const FramesFunction*
    constptr_FramesFunction() const
    {
        return ((mValue).VFramesFunction).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TimingFunction() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TimingFunction(const null_t& aOther);

    MOZ_IMPLICIT TimingFunction(const CubicBezierFunction& aOther);

    MOZ_IMPLICIT TimingFunction(const StepFunction& aOther);

    MOZ_IMPLICIT TimingFunction(const FramesFunction& aOther);

    MOZ_IMPLICIT TimingFunction(const TimingFunction& aOther);

    ~TimingFunction();

    Type
    type() const
    {
        return mType;
    }

    TimingFunction&
    operator=(const null_t& aRhs);

    TimingFunction&
    operator=(const CubicBezierFunction& aRhs);

    TimingFunction&
    operator=(const StepFunction& aRhs);

    TimingFunction&
    operator=(const FramesFunction& aRhs);

    TimingFunction&
    operator=(const TimingFunction& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const CubicBezierFunction& aRhs) const;

    bool
    operator==(const StepFunction& aRhs) const;

    bool
    operator==(const FramesFunction& aRhs) const;

    bool
    operator==(const TimingFunction& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    CubicBezierFunction&
    get_CubicBezierFunction()
    {
        AssertSanity(TCubicBezierFunction);
        return (*(ptr_CubicBezierFunction()));
    }
    const CubicBezierFunction&
    get_CubicBezierFunction() const
    {
        AssertSanity(TCubicBezierFunction);
        return (*(constptr_CubicBezierFunction()));
    }
    void
    get(CubicBezierFunction* aOutValue) const;
    operator CubicBezierFunction&()
    {
        return get_CubicBezierFunction();
    }
    operator const CubicBezierFunction&() const
    {
        return get_CubicBezierFunction();
    }

    StepFunction&
    get_StepFunction()
    {
        AssertSanity(TStepFunction);
        return (*(ptr_StepFunction()));
    }
    const StepFunction&
    get_StepFunction() const
    {
        AssertSanity(TStepFunction);
        return (*(constptr_StepFunction()));
    }
    void
    get(StepFunction* aOutValue) const;
    operator StepFunction&()
    {
        return get_StepFunction();
    }
    operator const StepFunction&() const
    {
        return get_StepFunction();
    }

    FramesFunction&
    get_FramesFunction()
    {
        AssertSanity(TFramesFunction);
        return (*(ptr_FramesFunction()));
    }
    const FramesFunction&
    get_FramesFunction() const
    {
        AssertSanity(TFramesFunction);
        return (*(constptr_FramesFunction()));
    }
    void
    get(FramesFunction* aOutValue) const;
    operator FramesFunction&()
    {
        return get_FramesFunction();
    }
    operator const FramesFunction&() const
    {
        return get_FramesFunction();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CSSAngle|
//
namespace mozilla {
namespace layers {
class CSSAngle final
{
private:

public:
    MOZ_IMPLICIT CSSAngle();

    MOZ_IMPLICIT CSSAngle(
            const float& _value,
            const int& _unit)
    {
        Init();
        Assign(_value, _unit);
    }

    MOZ_IMPLICIT CSSAngle(const CSSAngle& _o)
    {
        Init();
        Assign((_o).value(), (_o).unit());
    }

    ~CSSAngle();

    void
    operator=(const CSSAngle& _o)
    {
        Assign((_o).value(), (_o).unit());
    }

    bool
    operator==(const CSSAngle& _o) const;

    bool
    operator!=(const CSSAngle& _o) const;

    float&
    value()
    {
        return value_;
    }
    const float&
    value() const
    {
        return value_;
    }

    int&
    unit()
    {
        return unit_;
    }
    const int&
    unit() const
    {
        return unit_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _value,
            const int& _unit);

    float value_;
    int unit_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LayerColor|
//
namespace mozilla {
namespace layers {
class LayerColor final
{
private:
    typedef mozilla::gfx::Color Color;

public:
    MOZ_IMPLICIT LayerColor();

    MOZ_IMPLICIT LayerColor(const Color& _value)
    {
        Init();
        Assign(_value);
    }

    MOZ_IMPLICIT LayerColor(const LayerColor& _o)
    {
        Init();
        Assign((_o).value());
    }

    ~LayerColor();

    void
    operator=(const LayerColor& _o)
    {
        Assign((_o).value());
    }

    bool
    operator==(const LayerColor& _o) const;

    bool
    operator!=(const LayerColor& _o) const;

    Color&
    value()
    {
        return value_;
    }
    const Color&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(const Color& _value);

    Color value_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Perspective|
//
namespace mozilla {
namespace layers {
class Perspective final
{
private:

public:
    MOZ_IMPLICIT Perspective();

    MOZ_IMPLICIT Perspective(const float& _value)
    {
        Init();
        Assign(_value);
    }

    MOZ_IMPLICIT Perspective(const Perspective& _o)
    {
        Init();
        Assign((_o).value());
    }

    ~Perspective();

    void
    operator=(const Perspective& _o)
    {
        Assign((_o).value());
    }

    bool
    operator==(const Perspective& _o) const;

    bool
    operator!=(const Perspective& _o) const;

    float&
    value()
    {
        return value_;
    }
    const float&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(const float& _value);

    float value_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RotationX|
//
namespace mozilla {
namespace layers {
class RotationX final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT RotationX();

    MOZ_IMPLICIT RotationX(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT RotationX(const RotationX& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~RotationX();

    void
    operator=(const RotationX& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const RotationX& _o) const;

    bool
    operator!=(const RotationX& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RotationY|
//
namespace mozilla {
namespace layers {
class RotationY final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT RotationY();

    MOZ_IMPLICIT RotationY(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT RotationY(const RotationY& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~RotationY();

    void
    operator=(const RotationY& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const RotationY& _o) const;

    bool
    operator!=(const RotationY& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RotationZ|
//
namespace mozilla {
namespace layers {
class RotationZ final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT RotationZ();

    MOZ_IMPLICIT RotationZ(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT RotationZ(const RotationZ& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~RotationZ();

    void
    operator=(const RotationZ& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const RotationZ& _o) const;

    bool
    operator!=(const RotationZ& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Rotation|
//
namespace mozilla {
namespace layers {
class Rotation final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT Rotation();

    MOZ_IMPLICIT Rotation(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT Rotation(const Rotation& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~Rotation();

    void
    operator=(const Rotation& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const Rotation& _o) const;

    bool
    operator!=(const Rotation& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Rotation3D|
//
namespace mozilla {
namespace layers {
class Rotation3D final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT Rotation3D();

    MOZ_IMPLICIT Rotation3D(
            const float& _x,
            const float& _y,
            const float& _z,
            const CSSAngle& _angle)
    {
        Init();
        Assign(_x, _y, _z, _angle);
    }

    MOZ_IMPLICIT Rotation3D(const Rotation3D& _o)
    {
        Init();
        Assign((_o).x(), (_o).y(), (_o).z(), (_o).angle());
    }

    ~Rotation3D();

    void
    operator=(const Rotation3D& _o)
    {
        Assign((_o).x(), (_o).y(), (_o).z(), (_o).angle());
    }

    bool
    operator==(const Rotation3D& _o) const;

    bool
    operator!=(const Rotation3D& _o) const;

    float&
    x()
    {
        return x_;
    }
    const float&
    x() const
    {
        return x_;
    }

    float&
    y()
    {
        return y_;
    }
    const float&
    y() const
    {
        return y_;
    }

    float&
    z()
    {
        return z_;
    }
    const float&
    z() const
    {
        return z_;
    }

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x,
            const float& _y,
            const float& _z,
            const CSSAngle& _angle);

    float x_;
    float y_;
    float z_;
    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Scale|
//
namespace mozilla {
namespace layers {
class Scale final
{
private:

public:
    MOZ_IMPLICIT Scale();

    MOZ_IMPLICIT Scale(
            const float& _x,
            const float& _y,
            const float& _z)
    {
        Init();
        Assign(_x, _y, _z);
    }

    MOZ_IMPLICIT Scale(const Scale& _o)
    {
        Init();
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    ~Scale();

    void
    operator=(const Scale& _o)
    {
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    bool
    operator==(const Scale& _o) const;

    bool
    operator!=(const Scale& _o) const;

    float&
    x()
    {
        return x_;
    }
    const float&
    x() const
    {
        return x_;
    }

    float&
    y()
    {
        return y_;
    }
    const float&
    y() const
    {
        return y_;
    }

    float&
    z()
    {
        return z_;
    }
    const float&
    z() const
    {
        return z_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x,
            const float& _y,
            const float& _z);

    float x_;
    float y_;
    float z_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Skew|
//
namespace mozilla {
namespace layers {
class Skew final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT Skew();

    MOZ_IMPLICIT Skew(
            const CSSAngle& _x,
            const CSSAngle& _y)
    {
        Init();
        Assign(_x, _y);
    }

    MOZ_IMPLICIT Skew(const Skew& _o)
    {
        Init();
        Assign((_o).x(), (_o).y());
    }

    ~Skew();

    void
    operator=(const Skew& _o)
    {
        Assign((_o).x(), (_o).y());
    }

    bool
    operator==(const Skew& _o) const;

    bool
    operator!=(const Skew& _o) const;

    CSSAngle&
    x()
    {
        return x_;
    }
    const CSSAngle&
    x() const
    {
        return x_;
    }

    CSSAngle&
    y()
    {
        return y_;
    }
    const CSSAngle&
    y() const
    {
        return y_;
    }

private:
    void
    Init();

    void
    Assign(
            const CSSAngle& _x,
            const CSSAngle& _y);

    CSSAngle x_;
    CSSAngle y_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SkewX|
//
namespace mozilla {
namespace layers {
class SkewX final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT SkewX();

    MOZ_IMPLICIT SkewX(const CSSAngle& _x)
    {
        Init();
        Assign(_x);
    }

    MOZ_IMPLICIT SkewX(const SkewX& _o)
    {
        Init();
        Assign((_o).x());
    }

    ~SkewX();

    void
    operator=(const SkewX& _o)
    {
        Assign((_o).x());
    }

    bool
    operator==(const SkewX& _o) const;

    bool
    operator!=(const SkewX& _o) const;

    CSSAngle&
    x()
    {
        return x_;
    }
    const CSSAngle&
    x() const
    {
        return x_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _x);

    CSSAngle x_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SkewY|
//
namespace mozilla {
namespace layers {
class SkewY final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT SkewY();

    MOZ_IMPLICIT SkewY(const CSSAngle& _y)
    {
        Init();
        Assign(_y);
    }

    MOZ_IMPLICIT SkewY(const SkewY& _o)
    {
        Init();
        Assign((_o).y());
    }

    ~SkewY();

    void
    operator=(const SkewY& _o)
    {
        Assign((_o).y());
    }

    bool
    operator==(const SkewY& _o) const;

    bool
    operator!=(const SkewY& _o) const;

    CSSAngle&
    y()
    {
        return y_;
    }
    const CSSAngle&
    y() const
    {
        return y_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _y);

    CSSAngle y_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransformMatrix|
//
namespace mozilla {
namespace layers {
class TransformMatrix final
{
private:
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;

public:
    MOZ_IMPLICIT TransformMatrix();

    MOZ_IMPLICIT TransformMatrix(const Matrix4x4& _value)
    {
        Init();
        Assign(_value);
    }

    MOZ_IMPLICIT TransformMatrix(const TransformMatrix& _o)
    {
        Init();
        Assign((_o).value());
    }

    ~TransformMatrix();

    void
    operator=(const TransformMatrix& _o)
    {
        Assign((_o).value());
    }

    bool
    operator==(const TransformMatrix& _o) const;

    bool
    operator!=(const TransformMatrix& _o) const;

    Matrix4x4&
    value()
    {
        return value_;
    }
    const Matrix4x4&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(const Matrix4x4& _value);

    Matrix4x4 value_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Translation|
//
namespace mozilla {
namespace layers {
class Translation final
{
private:

public:
    MOZ_IMPLICIT Translation();

    MOZ_IMPLICIT Translation(
            const float& _x,
            const float& _y,
            const float& _z)
    {
        Init();
        Assign(_x, _y, _z);
    }

    MOZ_IMPLICIT Translation(const Translation& _o)
    {
        Init();
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    ~Translation();

    void
    operator=(const Translation& _o)
    {
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    bool
    operator==(const Translation& _o) const;

    bool
    operator!=(const Translation& _o) const;

    float&
    x()
    {
        return x_;
    }
    const float&
    x() const
    {
        return x_;
    }

    float&
    y()
    {
        return y_;
    }
    const float&
    y() const
    {
        return y_;
    }

    float&
    z()
    {
        return z_;
    }
    const float&
    z() const
    {
        return z_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x,
            const float& _y,
            const float& _z);

    float x_;
    float y_;
    float z_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Perspective;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RotationX;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RotationY;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RotationZ;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Rotation;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Rotation3D;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Scale;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Skew;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SkewX;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SkewY;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Translation;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TransformMatrix;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TransformFunction|
//
namespace mozilla {
namespace layers {
class TransformFunction final
{
public:
    enum Type {
        T__None,
        TPerspective = 1,
        TRotationX,
        TRotationY,
        TRotationZ,
        TRotation,
        TRotation3D,
        TScale,
        TSkew,
        TSkewX,
        TSkewY,
        TTranslation,
        TTransformMatrix,
        T__Last = TTransformMatrix
    };

private:
    typedef mozilla::layers::Perspective Perspective;
    typedef mozilla::layers::RotationX RotationX;
    typedef mozilla::layers::RotationY RotationY;
    typedef mozilla::layers::RotationZ RotationZ;
    typedef mozilla::layers::Rotation Rotation;
    typedef mozilla::layers::Rotation3D Rotation3D;
    typedef mozilla::layers::Scale Scale;
    typedef mozilla::layers::Skew Skew;
    typedef mozilla::layers::SkewX SkewX;
    typedef mozilla::layers::SkewY SkewY;
    typedef mozilla::layers::Translation Translation;
    typedef mozilla::layers::TransformMatrix TransformMatrix;
    typedef Perspective Perspective__tdef;
    typedef RotationX RotationX__tdef;
    typedef RotationY RotationY__tdef;
    typedef RotationZ RotationZ__tdef;
    typedef Rotation Rotation__tdef;
    typedef Rotation3D Rotation3D__tdef;
    typedef Scale Scale__tdef;
    typedef Skew Skew__tdef;
    typedef SkewX SkewX__tdef;
    typedef SkewY SkewY__tdef;
    typedef Translation Translation__tdef;
    typedef TransformMatrix TransformMatrix__tdef;

    union Value {
        mozilla::AlignedStorage2<Perspective> VPerspective;
        mozilla::AlignedStorage2<RotationX> VRotationX;
        mozilla::AlignedStorage2<RotationY> VRotationY;
        mozilla::AlignedStorage2<RotationZ> VRotationZ;
        mozilla::AlignedStorage2<Rotation> VRotation;
        mozilla::AlignedStorage2<Rotation3D> VRotation3D;
        mozilla::AlignedStorage2<Scale> VScale;
        mozilla::AlignedStorage2<Skew> VSkew;
        mozilla::AlignedStorage2<SkewX> VSkewX;
        mozilla::AlignedStorage2<SkewY> VSkewY;
        mozilla::AlignedStorage2<Translation> VTranslation;
        mozilla::AlignedStorage2<TransformMatrix> VTransformMatrix;
    };

    Perspective*
    ptr_Perspective()
    {
        return ((mValue).VPerspective).addr();
    }
    const Perspective*
    constptr_Perspective() const
    {
        return ((mValue).VPerspective).addr();
    }
    RotationX*
    ptr_RotationX()
    {
        return ((mValue).VRotationX).addr();
    }
    const RotationX*
    constptr_RotationX() const
    {
        return ((mValue).VRotationX).addr();
    }
    RotationY*
    ptr_RotationY()
    {
        return ((mValue).VRotationY).addr();
    }
    const RotationY*
    constptr_RotationY() const
    {
        return ((mValue).VRotationY).addr();
    }
    RotationZ*
    ptr_RotationZ()
    {
        return ((mValue).VRotationZ).addr();
    }
    const RotationZ*
    constptr_RotationZ() const
    {
        return ((mValue).VRotationZ).addr();
    }
    Rotation*
    ptr_Rotation()
    {
        return ((mValue).VRotation).addr();
    }
    const Rotation*
    constptr_Rotation() const
    {
        return ((mValue).VRotation).addr();
    }
    Rotation3D*
    ptr_Rotation3D()
    {
        return ((mValue).VRotation3D).addr();
    }
    const Rotation3D*
    constptr_Rotation3D() const
    {
        return ((mValue).VRotation3D).addr();
    }
    Scale*
    ptr_Scale()
    {
        return ((mValue).VScale).addr();
    }
    const Scale*
    constptr_Scale() const
    {
        return ((mValue).VScale).addr();
    }
    Skew*
    ptr_Skew()
    {
        return ((mValue).VSkew).addr();
    }
    const Skew*
    constptr_Skew() const
    {
        return ((mValue).VSkew).addr();
    }
    SkewX*
    ptr_SkewX()
    {
        return ((mValue).VSkewX).addr();
    }
    const SkewX*
    constptr_SkewX() const
    {
        return ((mValue).VSkewX).addr();
    }
    SkewY*
    ptr_SkewY()
    {
        return ((mValue).VSkewY).addr();
    }
    const SkewY*
    constptr_SkewY() const
    {
        return ((mValue).VSkewY).addr();
    }
    Translation*
    ptr_Translation()
    {
        return ((mValue).VTranslation).addr();
    }
    const Translation*
    constptr_Translation() const
    {
        return ((mValue).VTranslation).addr();
    }
    TransformMatrix*
    ptr_TransformMatrix()
    {
        return ((mValue).VTransformMatrix).addr();
    }
    const TransformMatrix*
    constptr_TransformMatrix() const
    {
        return ((mValue).VTransformMatrix).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TransformFunction() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TransformFunction(const Perspective& aOther);

    MOZ_IMPLICIT TransformFunction(const RotationX& aOther);

    MOZ_IMPLICIT TransformFunction(const RotationY& aOther);

    MOZ_IMPLICIT TransformFunction(const RotationZ& aOther);

    MOZ_IMPLICIT TransformFunction(const Rotation& aOther);

    MOZ_IMPLICIT TransformFunction(const Rotation3D& aOther);

    MOZ_IMPLICIT TransformFunction(const Scale& aOther);

    MOZ_IMPLICIT TransformFunction(const Skew& aOther);

    MOZ_IMPLICIT TransformFunction(const SkewX& aOther);

    MOZ_IMPLICIT TransformFunction(const SkewY& aOther);

    MOZ_IMPLICIT TransformFunction(const Translation& aOther);

    MOZ_IMPLICIT TransformFunction(const TransformMatrix& aOther);

    MOZ_IMPLICIT TransformFunction(const TransformFunction& aOther);

    ~TransformFunction();

    Type
    type() const
    {
        return mType;
    }

    TransformFunction&
    operator=(const Perspective& aRhs);

    TransformFunction&
    operator=(const RotationX& aRhs);

    TransformFunction&
    operator=(const RotationY& aRhs);

    TransformFunction&
    operator=(const RotationZ& aRhs);

    TransformFunction&
    operator=(const Rotation& aRhs);

    TransformFunction&
    operator=(const Rotation3D& aRhs);

    TransformFunction&
    operator=(const Scale& aRhs);

    TransformFunction&
    operator=(const Skew& aRhs);

    TransformFunction&
    operator=(const SkewX& aRhs);

    TransformFunction&
    operator=(const SkewY& aRhs);

    TransformFunction&
    operator=(const Translation& aRhs);

    TransformFunction&
    operator=(const TransformMatrix& aRhs);

    TransformFunction&
    operator=(const TransformFunction& aRhs);

    bool
    operator==(const Perspective& aRhs) const;

    bool
    operator==(const RotationX& aRhs) const;

    bool
    operator==(const RotationY& aRhs) const;

    bool
    operator==(const RotationZ& aRhs) const;

    bool
    operator==(const Rotation& aRhs) const;

    bool
    operator==(const Rotation3D& aRhs) const;

    bool
    operator==(const Scale& aRhs) const;

    bool
    operator==(const Skew& aRhs) const;

    bool
    operator==(const SkewX& aRhs) const;

    bool
    operator==(const SkewY& aRhs) const;

    bool
    operator==(const Translation& aRhs) const;

    bool
    operator==(const TransformMatrix& aRhs) const;

    bool
    operator==(const TransformFunction& aRhs) const;

    Perspective&
    get_Perspective()
    {
        AssertSanity(TPerspective);
        return (*(ptr_Perspective()));
    }
    const Perspective&
    get_Perspective() const
    {
        AssertSanity(TPerspective);
        return (*(constptr_Perspective()));
    }
    void
    get(Perspective* aOutValue) const;
    operator Perspective&()
    {
        return get_Perspective();
    }
    operator const Perspective&() const
    {
        return get_Perspective();
    }

    RotationX&
    get_RotationX()
    {
        AssertSanity(TRotationX);
        return (*(ptr_RotationX()));
    }
    const RotationX&
    get_RotationX() const
    {
        AssertSanity(TRotationX);
        return (*(constptr_RotationX()));
    }
    void
    get(RotationX* aOutValue) const;
    operator RotationX&()
    {
        return get_RotationX();
    }
    operator const RotationX&() const
    {
        return get_RotationX();
    }

    RotationY&
    get_RotationY()
    {
        AssertSanity(TRotationY);
        return (*(ptr_RotationY()));
    }
    const RotationY&
    get_RotationY() const
    {
        AssertSanity(TRotationY);
        return (*(constptr_RotationY()));
    }
    void
    get(RotationY* aOutValue) const;
    operator RotationY&()
    {
        return get_RotationY();
    }
    operator const RotationY&() const
    {
        return get_RotationY();
    }

    RotationZ&
    get_RotationZ()
    {
        AssertSanity(TRotationZ);
        return (*(ptr_RotationZ()));
    }
    const RotationZ&
    get_RotationZ() const
    {
        AssertSanity(TRotationZ);
        return (*(constptr_RotationZ()));
    }
    void
    get(RotationZ* aOutValue) const;
    operator RotationZ&()
    {
        return get_RotationZ();
    }
    operator const RotationZ&() const
    {
        return get_RotationZ();
    }

    Rotation&
    get_Rotation()
    {
        AssertSanity(TRotation);
        return (*(ptr_Rotation()));
    }
    const Rotation&
    get_Rotation() const
    {
        AssertSanity(TRotation);
        return (*(constptr_Rotation()));
    }
    void
    get(Rotation* aOutValue) const;
    operator Rotation&()
    {
        return get_Rotation();
    }
    operator const Rotation&() const
    {
        return get_Rotation();
    }

    Rotation3D&
    get_Rotation3D()
    {
        AssertSanity(TRotation3D);
        return (*(ptr_Rotation3D()));
    }
    const Rotation3D&
    get_Rotation3D() const
    {
        AssertSanity(TRotation3D);
        return (*(constptr_Rotation3D()));
    }
    void
    get(Rotation3D* aOutValue) const;
    operator Rotation3D&()
    {
        return get_Rotation3D();
    }
    operator const Rotation3D&() const
    {
        return get_Rotation3D();
    }

    Scale&
    get_Scale()
    {
        AssertSanity(TScale);
        return (*(ptr_Scale()));
    }
    const Scale&
    get_Scale() const
    {
        AssertSanity(TScale);
        return (*(constptr_Scale()));
    }
    void
    get(Scale* aOutValue) const;
    operator Scale&()
    {
        return get_Scale();
    }
    operator const Scale&() const
    {
        return get_Scale();
    }

    Skew&
    get_Skew()
    {
        AssertSanity(TSkew);
        return (*(ptr_Skew()));
    }
    const Skew&
    get_Skew() const
    {
        AssertSanity(TSkew);
        return (*(constptr_Skew()));
    }
    void
    get(Skew* aOutValue) const;
    operator Skew&()
    {
        return get_Skew();
    }
    operator const Skew&() const
    {
        return get_Skew();
    }

    SkewX&
    get_SkewX()
    {
        AssertSanity(TSkewX);
        return (*(ptr_SkewX()));
    }
    const SkewX&
    get_SkewX() const
    {
        AssertSanity(TSkewX);
        return (*(constptr_SkewX()));
    }
    void
    get(SkewX* aOutValue) const;
    operator SkewX&()
    {
        return get_SkewX();
    }
    operator const SkewX&() const
    {
        return get_SkewX();
    }

    SkewY&
    get_SkewY()
    {
        AssertSanity(TSkewY);
        return (*(ptr_SkewY()));
    }
    const SkewY&
    get_SkewY() const
    {
        AssertSanity(TSkewY);
        return (*(constptr_SkewY()));
    }
    void
    get(SkewY* aOutValue) const;
    operator SkewY&()
    {
        return get_SkewY();
    }
    operator const SkewY&() const
    {
        return get_SkewY();
    }

    Translation&
    get_Translation()
    {
        AssertSanity(TTranslation);
        return (*(ptr_Translation()));
    }
    const Translation&
    get_Translation() const
    {
        AssertSanity(TTranslation);
        return (*(constptr_Translation()));
    }
    void
    get(Translation* aOutValue) const;
    operator Translation&()
    {
        return get_Translation();
    }
    operator const Translation&() const
    {
        return get_Translation();
    }

    TransformMatrix&
    get_TransformMatrix()
    {
        AssertSanity(TTransformMatrix);
        return (*(ptr_TransformMatrix()));
    }
    const TransformMatrix&
    get_TransformMatrix() const
    {
        AssertSanity(TTransformMatrix);
        return (*(constptr_TransformMatrix()));
    }
    void
    get(TransformMatrix* aOutValue) const;
    operator TransformMatrix&()
    {
        return get_TransformMatrix();
    }
    operator const TransformMatrix&() const
    {
        return get_TransformMatrix();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeTimeDuration|
//
namespace mozilla {
namespace layers {
class MaybeTimeDuration final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TTimeDuration,
        T__Last = TTimeDuration
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::TimeDuration TimeDuration;
    typedef null_t null_t__tdef;
    typedef TimeDuration TimeDuration__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<TimeDuration> VTimeDuration;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    TimeDuration*
    ptr_TimeDuration()
    {
        return ((mValue).VTimeDuration).addr();
    }
    const TimeDuration*
    constptr_TimeDuration() const
    {
        return ((mValue).VTimeDuration).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeTimeDuration() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeTimeDuration(const null_t& aOther);

    MOZ_IMPLICIT MaybeTimeDuration(const TimeDuration& aOther);

    MOZ_IMPLICIT MaybeTimeDuration(const MaybeTimeDuration& aOther);

    ~MaybeTimeDuration();

    Type
    type() const
    {
        return mType;
    }

    MaybeTimeDuration&
    operator=(const null_t& aRhs);

    MaybeTimeDuration&
    operator=(const TimeDuration& aRhs);

    MaybeTimeDuration&
    operator=(const MaybeTimeDuration& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const TimeDuration& aRhs) const;

    bool
    operator==(const MaybeTimeDuration& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    TimeDuration&
    get_TimeDuration()
    {
        AssertSanity(TTimeDuration);
        return (*(ptr_TimeDuration()));
    }
    const TimeDuration&
    get_TimeDuration() const
    {
        AssertSanity(TTimeDuration);
        return (*(constptr_TimeDuration()));
    }
    void
    get(TimeDuration* aOutValue) const;
    operator TimeDuration&()
    {
        return get_TimeDuration();
    }
    operator const TimeDuration&() const
    {
        return get_TimeDuration();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TransformFunction;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union Animatable|
//
namespace mozilla {
namespace layers {
class Animatable final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        Tfloat,
        TArrayOfTransformFunction,
        T__Last = TArrayOfTransformFunction
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::TransformFunction TransformFunction;
    typedef null_t null_t__tdef;
    typedef float float__tdef;
    typedef nsTArray<TransformFunction> ArrayOfTransformFunction__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<float> Vfloat;
        mozilla::AlignedStorage2<nsTArray<TransformFunction>> VArrayOfTransformFunction;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    float*
    ptr_float()
    {
        return ((mValue).Vfloat).addr();
    }
    const float*
    constptr_float() const
    {
        return ((mValue).Vfloat).addr();
    }
    nsTArray<TransformFunction>*
    ptr_ArrayOfTransformFunction()
    {
        return ((mValue).VArrayOfTransformFunction).addr();
    }
    const nsTArray<TransformFunction>*
    constptr_ArrayOfTransformFunction() const
    {
        return ((mValue).VArrayOfTransformFunction).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT Animatable() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT Animatable(const null_t& aOther);

    MOZ_IMPLICIT Animatable(const float& aOther);

    MOZ_IMPLICIT Animatable(const nsTArray<TransformFunction>& aOther);

    MOZ_IMPLICIT Animatable(const Animatable& aOther);

    ~Animatable();

    Type
    type() const
    {
        return mType;
    }

    Animatable&
    operator=(const null_t& aRhs);

    Animatable&
    operator=(const float& aRhs);

    Animatable&
    operator=(const nsTArray<TransformFunction>& aRhs);

    Animatable&
    operator=(const Animatable& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const float& aRhs) const;

    bool
    operator==(const nsTArray<TransformFunction>& aRhs) const;

    bool
    operator==(const Animatable& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    float&
    get_float()
    {
        AssertSanity(Tfloat);
        return (*(ptr_float()));
    }
    const float&
    get_float() const
    {
        AssertSanity(Tfloat);
        return (*(constptr_float()));
    }
    void
    get(float* aOutValue) const;
    operator float&()
    {
        return get_float();
    }
    operator const float&() const
    {
        return get_float();
    }

    nsTArray<TransformFunction>&
    get_ArrayOfTransformFunction()
    {
        AssertSanity(TArrayOfTransformFunction);
        return (*(ptr_ArrayOfTransformFunction()));
    }
    const nsTArray<TransformFunction>&
    get_ArrayOfTransformFunction() const
    {
        AssertSanity(TArrayOfTransformFunction);
        return (*(constptr_ArrayOfTransformFunction()));
    }
    void
    get(nsTArray<TransformFunction>* aOutValue) const;
    operator nsTArray<TransformFunction>&()
    {
        return get_ArrayOfTransformFunction();
    }
    operator const nsTArray<TransformFunction>&() const
    {
        return get_ArrayOfTransformFunction();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Animatable;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TimingFunction;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AnimationSegment|
//
namespace mozilla {
namespace layers {
class AnimationSegment final
{
private:
    typedef mozilla::layers::Animatable Animatable;
    typedef mozilla::layers::TimingFunction TimingFunction;

public:
    MOZ_IMPLICIT AnimationSegment();

    MOZ_IMPLICIT AnimationSegment(
            const Animatable& _startState,
            const Animatable& _endState,
            const float& _startPortion,
            const float& _endPortion,
            const uint8_t& _startComposite,
            const uint8_t& _endComposite,
            const TimingFunction& _sampleFn)
    {
        Init();
        Assign(_startState, _endState, _startPortion, _endPortion, _startComposite, _endComposite, _sampleFn);
    }

    MOZ_IMPLICIT AnimationSegment(const AnimationSegment& _o)
    {
        Init();
        Assign((_o).startState(), (_o).endState(), (_o).startPortion(), (_o).endPortion(), (_o).startComposite(), (_o).endComposite(), (_o).sampleFn());
    }

    ~AnimationSegment();

    void
    operator=(const AnimationSegment& _o)
    {
        Assign((_o).startState(), (_o).endState(), (_o).startPortion(), (_o).endPortion(), (_o).startComposite(), (_o).endComposite(), (_o).sampleFn());
    }

    bool
    operator==(const AnimationSegment& _o) const;

    bool
    operator!=(const AnimationSegment& _o) const;

    Animatable&
    startState()
    {
        return startState_;
    }
    const Animatable&
    startState() const
    {
        return startState_;
    }

    Animatable&
    endState()
    {
        return endState_;
    }
    const Animatable&
    endState() const
    {
        return endState_;
    }

    float&
    startPortion()
    {
        return startPortion_;
    }
    const float&
    startPortion() const
    {
        return startPortion_;
    }

    float&
    endPortion()
    {
        return endPortion_;
    }
    const float&
    endPortion() const
    {
        return endPortion_;
    }

    uint8_t&
    startComposite()
    {
        return startComposite_;
    }
    const uint8_t&
    startComposite() const
    {
        return startComposite_;
    }

    uint8_t&
    endComposite()
    {
        return endComposite_;
    }
    const uint8_t&
    endComposite() const
    {
        return endComposite_;
    }

    TimingFunction&
    sampleFn()
    {
        return sampleFn_;
    }
    const TimingFunction&
    sampleFn() const
    {
        return sampleFn_;
    }

private:
    void
    Init();

    void
    Assign(
            const Animatable& _startState,
            const Animatable& _endState,
            const float& _startPortion,
            const float& _endPortion,
            const uint8_t& _startComposite,
            const uint8_t& _endComposite,
            const TimingFunction& _sampleFn);

    Animatable startState_;
    Animatable endState_;
    float startPortion_;
    float endPortion_;
    uint8_t startComposite_;
    uint8_t endComposite_;
    TimingFunction sampleFn_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransformData|
//
namespace mozilla {
namespace layers {
class TransformData final
{
private:
    typedef mozilla::gfx::Point3D Point3D;

public:
    MOZ_IMPLICIT TransformData();

    MOZ_IMPLICIT TransformData(
            const nsPoint& _origin,
            const Point3D& _transformOrigin,
            const nsRect& _bounds,
            const int32_t& _appUnitsPerDevPixel,
            const float& _inheritedXScale,
            const float& _inheritedYScale,
            const bool& _hasPerspectiveParent)
    {
        Init();
        Assign(_origin, _transformOrigin, _bounds, _appUnitsPerDevPixel, _inheritedXScale, _inheritedYScale, _hasPerspectiveParent);
    }

    MOZ_IMPLICIT TransformData(const TransformData& _o)
    {
        Init();
        Assign((_o).origin(), (_o).transformOrigin(), (_o).bounds(), (_o).appUnitsPerDevPixel(), (_o).inheritedXScale(), (_o).inheritedYScale(), (_o).hasPerspectiveParent());
    }

    ~TransformData();

    void
    operator=(const TransformData& _o)
    {
        Assign((_o).origin(), (_o).transformOrigin(), (_o).bounds(), (_o).appUnitsPerDevPixel(), (_o).inheritedXScale(), (_o).inheritedYScale(), (_o).hasPerspectiveParent());
    }

    bool
    operator==(const TransformData& _o) const;

    bool
    operator!=(const TransformData& _o) const;

    nsPoint&
    origin()
    {
        return origin_;
    }
    const nsPoint&
    origin() const
    {
        return origin_;
    }

    Point3D&
    transformOrigin()
    {
        return transformOrigin_;
    }
    const Point3D&
    transformOrigin() const
    {
        return transformOrigin_;
    }

    nsRect&
    bounds()
    {
        return bounds_;
    }
    const nsRect&
    bounds() const
    {
        return bounds_;
    }

    int32_t&
    appUnitsPerDevPixel()
    {
        return appUnitsPerDevPixel_;
    }
    const int32_t&
    appUnitsPerDevPixel() const
    {
        return appUnitsPerDevPixel_;
    }

    float&
    inheritedXScale()
    {
        return inheritedXScale_;
    }
    const float&
    inheritedXScale() const
    {
        return inheritedXScale_;
    }

    float&
    inheritedYScale()
    {
        return inheritedYScale_;
    }
    const float&
    inheritedYScale() const
    {
        return inheritedYScale_;
    }

    bool&
    hasPerspectiveParent()
    {
        return hasPerspectiveParent_;
    }
    const bool&
    hasPerspectiveParent() const
    {
        return hasPerspectiveParent_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsPoint& _origin,
            const Point3D& _transformOrigin,
            const nsRect& _bounds,
            const int32_t& _appUnitsPerDevPixel,
            const float& _inheritedXScale,
            const float& _inheritedYScale,
            const bool& _hasPerspectiveParent);

    nsPoint origin_;
    Point3D transformOrigin_;
    nsRect bounds_;
    int32_t appUnitsPerDevPixel_;
    float inheritedXScale_;
    float inheritedYScale_;
    bool hasPerspectiveParent_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TransformData;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AnimationData|
//
namespace mozilla {
namespace layers {
class AnimationData final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TTransformData,
        T__Last = TTransformData
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::TransformData TransformData;
    typedef null_t null_t__tdef;
    typedef TransformData TransformData__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<TransformData> VTransformData;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    TransformData*
    ptr_TransformData()
    {
        return ((mValue).VTransformData).addr();
    }
    const TransformData*
    constptr_TransformData() const
    {
        return ((mValue).VTransformData).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AnimationData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AnimationData(const null_t& aOther);

    MOZ_IMPLICIT AnimationData(const TransformData& aOther);

    MOZ_IMPLICIT AnimationData(const AnimationData& aOther);

    ~AnimationData();

    Type
    type() const
    {
        return mType;
    }

    AnimationData&
    operator=(const null_t& aRhs);

    AnimationData&
    operator=(const TransformData& aRhs);

    AnimationData&
    operator=(const AnimationData& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const TransformData& aRhs) const;

    bool
    operator==(const AnimationData& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    TransformData&
    get_TransformData()
    {
        AssertSanity(TTransformData);
        return (*(ptr_TransformData()));
    }
    const TransformData&
    get_TransformData() const
    {
        AssertSanity(TTransformData);
        return (*(constptr_TransformData()));
    }
    void
    get(TransformData* aOutValue) const;
    operator TransformData&()
    {
        return get_TransformData();
    }
    operator const TransformData&() const
    {
        return get_TransformData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class MaybeTimeDuration;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class AnimationSegment;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class AnimationData;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TimingFunction;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Animatable;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Animation|
//
namespace mozilla {
namespace layers {
class Animation final
{
private:
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::layers::MaybeTimeDuration MaybeTimeDuration;
    typedef mozilla::TimeDuration TimeDuration;
    typedef mozilla::layers::AnimationSegment AnimationSegment;
    typedef mozilla::layers::AnimationData AnimationData;
    typedef mozilla::layers::TimingFunction TimingFunction;
    typedef mozilla::layers::Animatable Animatable;

public:
    MOZ_IMPLICIT Animation();

    MOZ_IMPLICIT Animation(
            const TimeStamp& _originTime,
            const MaybeTimeDuration& _startTime,
            const TimeDuration& _delay,
            const TimeDuration& _endDelay,
            const TimeDuration& _holdTime,
            const TimeDuration& _duration,
            const nsTArray<AnimationSegment>& _segments,
            const float& _iterations,
            const float& _iterationStart,
            const uint8_t& _direction,
            const uint8_t& _fillMode,
            const nsCSSPropertyID& _property,
            const AnimationData& _data,
            const float& _playbackRate,
            const TimingFunction& _easingFunction,
            const uint8_t& _iterationComposite,
            const bool& _isNotPlaying,
            const Animatable& _baseStyle)
    {
        Init();
        Assign(_originTime, _startTime, _delay, _endDelay, _holdTime, _duration, _segments, _iterations, _iterationStart, _direction, _fillMode, _property, _data, _playbackRate, _easingFunction, _iterationComposite, _isNotPlaying, _baseStyle);
    }

    MOZ_IMPLICIT Animation(const Animation& _o)
    {
        Init();
        Assign((_o).originTime(), (_o).startTime(), (_o).delay(), (_o).endDelay(), (_o).holdTime(), (_o).duration(), (_o).segments(), (_o).iterations(), (_o).iterationStart(), (_o).direction(), (_o).fillMode(), (_o).property(), (_o).data(), (_o).playbackRate(), (_o).easingFunction(), (_o).iterationComposite(), (_o).isNotPlaying(), (_o).baseStyle());
    }

    ~Animation();

    void
    operator=(const Animation& _o)
    {
        Assign((_o).originTime(), (_o).startTime(), (_o).delay(), (_o).endDelay(), (_o).holdTime(), (_o).duration(), (_o).segments(), (_o).iterations(), (_o).iterationStart(), (_o).direction(), (_o).fillMode(), (_o).property(), (_o).data(), (_o).playbackRate(), (_o).easingFunction(), (_o).iterationComposite(), (_o).isNotPlaying(), (_o).baseStyle());
    }

    bool
    operator==(const Animation& _o) const;

    bool
    operator!=(const Animation& _o) const;

    TimeStamp&
    originTime()
    {
        return originTime_;
    }
    const TimeStamp&
    originTime() const
    {
        return originTime_;
    }

    MaybeTimeDuration&
    startTime()
    {
        return startTime_;
    }
    const MaybeTimeDuration&
    startTime() const
    {
        return startTime_;
    }

    TimeDuration&
    delay()
    {
        return delay_;
    }
    const TimeDuration&
    delay() const
    {
        return delay_;
    }

    TimeDuration&
    endDelay()
    {
        return endDelay_;
    }
    const TimeDuration&
    endDelay() const
    {
        return endDelay_;
    }

    TimeDuration&
    holdTime()
    {
        return holdTime_;
    }
    const TimeDuration&
    holdTime() const
    {
        return holdTime_;
    }

    TimeDuration&
    duration()
    {
        return duration_;
    }
    const TimeDuration&
    duration() const
    {
        return duration_;
    }

    nsTArray<AnimationSegment>&
    segments()
    {
        return segments_;
    }
    const nsTArray<AnimationSegment>&
    segments() const
    {
        return segments_;
    }

    float&
    iterations()
    {
        return iterations_;
    }
    const float&
    iterations() const
    {
        return iterations_;
    }

    float&
    iterationStart()
    {
        return iterationStart_;
    }
    const float&
    iterationStart() const
    {
        return iterationStart_;
    }

    uint8_t&
    direction()
    {
        return direction_;
    }
    const uint8_t&
    direction() const
    {
        return direction_;
    }

    uint8_t&
    fillMode()
    {
        return fillMode_;
    }
    const uint8_t&
    fillMode() const
    {
        return fillMode_;
    }

    nsCSSPropertyID&
    property()
    {
        return property_;
    }
    const nsCSSPropertyID&
    property() const
    {
        return property_;
    }

    AnimationData&
    data()
    {
        return data_;
    }
    const AnimationData&
    data() const
    {
        return data_;
    }

    float&
    playbackRate()
    {
        return playbackRate_;
    }
    const float&
    playbackRate() const
    {
        return playbackRate_;
    }

    TimingFunction&
    easingFunction()
    {
        return easingFunction_;
    }
    const TimingFunction&
    easingFunction() const
    {
        return easingFunction_;
    }

    uint8_t&
    iterationComposite()
    {
        return iterationComposite_;
    }
    const uint8_t&
    iterationComposite() const
    {
        return iterationComposite_;
    }

    bool&
    isNotPlaying()
    {
        return isNotPlaying_;
    }
    const bool&
    isNotPlaying() const
    {
        return isNotPlaying_;
    }

    Animatable&
    baseStyle()
    {
        return baseStyle_;
    }
    const Animatable&
    baseStyle() const
    {
        return baseStyle_;
    }

private:
    void
    Init();

    void
    Assign(
            const TimeStamp& _originTime,
            const MaybeTimeDuration& _startTime,
            const TimeDuration& _delay,
            const TimeDuration& _endDelay,
            const TimeDuration& _holdTime,
            const TimeDuration& _duration,
            const nsTArray<AnimationSegment>& _segments,
            const float& _iterations,
            const float& _iterationStart,
            const uint8_t& _direction,
            const uint8_t& _fillMode,
            const nsCSSPropertyID& _property,
            const AnimationData& _data,
            const float& _playbackRate,
            const TimingFunction& _easingFunction,
            const uint8_t& _iterationComposite,
            const bool& _isNotPlaying,
            const Animatable& _baseStyle);

    TimeStamp originTime_;
    MaybeTimeDuration startTime_;
    TimeDuration delay_;
    TimeDuration endDelay_;
    TimeDuration holdTime_;
    TimeDuration duration_;
    nsTArray<AnimationSegment> segments_;
    float iterations_;
    float iterationStart_;
    uint8_t direction_;
    uint8_t fillMode_;
    nsCSSPropertyID property_;
    AnimationData data_;
    float playbackRate_;
    TimingFunction easingFunction_;
    uint8_t iterationComposite_;
    bool isNotPlaying_;
    Animatable baseStyle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Animation;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CompositorAnimations|
//
namespace mozilla {
namespace layers {
class CompositorAnimations final
{
private:
    typedef mozilla::layers::Animation Animation;

public:
    MOZ_IMPLICIT CompositorAnimations();

    MOZ_IMPLICIT CompositorAnimations(
            const nsTArray<Animation>& _animations,
            const uint64_t& _id)
    {
        Init();
        Assign(_animations, _id);
    }

    MOZ_IMPLICIT CompositorAnimations(const CompositorAnimations& _o)
    {
        Init();
        Assign((_o).animations(), (_o).id());
    }

    ~CompositorAnimations();

    void
    operator=(const CompositorAnimations& _o)
    {
        Assign((_o).animations(), (_o).id());
    }

    bool
    operator==(const CompositorAnimations& _o) const;

    bool
    operator!=(const CompositorAnimations& _o) const;

    nsTArray<Animation>&
    animations()
    {
        return animations_;
    }
    const nsTArray<Animation>&
    animations() const
    {
        return animations_;
    }

    uint64_t&
    id()
    {
        return id_;
    }
    const uint64_t&
    id() const
    {
        return id_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<Animation>& _animations,
            const uint64_t& _id);

    nsTArray<Animation> animations_;
    uint64_t id_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CompositorAnimations;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CommonLayerAttributes|
//
namespace mozilla {
namespace layers {
class CommonLayerAttributes final
{
private:
    typedef mozilla::LayerIntRegion LayerIntRegion;
    typedef mozilla::layers::EventRegions EventRegions;
    typedef mozilla::ParentLayerIntRect ParentLayerIntRect;
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::CompositorAnimations CompositorAnimations;
    typedef mozilla::layers::ScrollMetadata ScrollMetadata;

public:
    MOZ_IMPLICIT CommonLayerAttributes();

    MOZ_IMPLICIT CommonLayerAttributes(
            const LayerIntRegion& _visibleRegion,
            const EventRegions& _eventRegions,
            const bool& _useClipRect,
            const ParentLayerIntRect& _clipRect,
            const LayerHandle& _maskLayer,
            const nsTArray<LayerHandle>& _ancestorMaskLayers,
            const CompositorAnimations& _compositorAnimations,
            const nsIntRegion& _invalidRegion,
            const nsTArray<ScrollMetadata>& _scrollMetadata,
            const nsCString& _displayListLog)
    {
        Init();
        Assign(_visibleRegion, _eventRegions, _useClipRect, _clipRect, _maskLayer, _ancestorMaskLayers, _compositorAnimations, _invalidRegion, _scrollMetadata, _displayListLog);
    }

    MOZ_IMPLICIT CommonLayerAttributes(const CommonLayerAttributes& _o)
    {
        Init();
        Assign((_o).visibleRegion(), (_o).eventRegions(), (_o).useClipRect(), (_o).clipRect(), (_o).maskLayer(), (_o).ancestorMaskLayers(), (_o).compositorAnimations(), (_o).invalidRegion(), (_o).scrollMetadata(), (_o).displayListLog());
    }

    ~CommonLayerAttributes();

    void
    operator=(const CommonLayerAttributes& _o)
    {
        Assign((_o).visibleRegion(), (_o).eventRegions(), (_o).useClipRect(), (_o).clipRect(), (_o).maskLayer(), (_o).ancestorMaskLayers(), (_o).compositorAnimations(), (_o).invalidRegion(), (_o).scrollMetadata(), (_o).displayListLog());
    }

    bool
    operator==(const CommonLayerAttributes& _o) const;

    bool
    operator!=(const CommonLayerAttributes& _o) const;

    LayerIntRegion&
    visibleRegion()
    {
        return visibleRegion_;
    }
    const LayerIntRegion&
    visibleRegion() const
    {
        return visibleRegion_;
    }

    EventRegions&
    eventRegions()
    {
        return eventRegions_;
    }
    const EventRegions&
    eventRegions() const
    {
        return eventRegions_;
    }

    bool&
    useClipRect()
    {
        return useClipRect_;
    }
    const bool&
    useClipRect() const
    {
        return useClipRect_;
    }

    ParentLayerIntRect&
    clipRect()
    {
        return clipRect_;
    }
    const ParentLayerIntRect&
    clipRect() const
    {
        return clipRect_;
    }

    LayerHandle&
    maskLayer()
    {
        return maskLayer_;
    }
    const LayerHandle&
    maskLayer() const
    {
        return maskLayer_;
    }

    nsTArray<LayerHandle>&
    ancestorMaskLayers()
    {
        return ancestorMaskLayers_;
    }
    const nsTArray<LayerHandle>&
    ancestorMaskLayers() const
    {
        return ancestorMaskLayers_;
    }

    CompositorAnimations&
    compositorAnimations()
    {
        return compositorAnimations_;
    }
    const CompositorAnimations&
    compositorAnimations() const
    {
        return compositorAnimations_;
    }

    nsIntRegion&
    invalidRegion()
    {
        return invalidRegion_;
    }
    const nsIntRegion&
    invalidRegion() const
    {
        return invalidRegion_;
    }

    nsTArray<ScrollMetadata>&
    scrollMetadata()
    {
        return scrollMetadata_;
    }
    const nsTArray<ScrollMetadata>&
    scrollMetadata() const
    {
        return scrollMetadata_;
    }

    nsCString&
    displayListLog()
    {
        return displayListLog_;
    }
    const nsCString&
    displayListLog() const
    {
        return displayListLog_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerIntRegion& _visibleRegion,
            const EventRegions& _eventRegions,
            const bool& _useClipRect,
            const ParentLayerIntRect& _clipRect,
            const LayerHandle& _maskLayer,
            const nsTArray<LayerHandle>& _ancestorMaskLayers,
            const CompositorAnimations& _compositorAnimations,
            const nsIntRegion& _invalidRegion,
            const nsTArray<ScrollMetadata>& _scrollMetadata,
            const nsCString& _displayListLog);

    LayerIntRegion visibleRegion_;
    EventRegions eventRegions_;
    bool useClipRect_;
    ParentLayerIntRect clipRect_;
    LayerHandle maskLayer_;
    nsTArray<LayerHandle> ancestorMaskLayers_;
    CompositorAnimations compositorAnimations_;
    nsIntRegion invalidRegion_;
    nsTArray<ScrollMetadata> scrollMetadata_;
    nsCString displayListLog_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PaintedLayerAttributes|
//
namespace mozilla {
namespace layers {
class PaintedLayerAttributes final
{
private:

public:
    MOZ_IMPLICIT PaintedLayerAttributes();

    MOZ_IMPLICIT PaintedLayerAttributes(const nsIntRegion& _validRegion)
    {
        Init();
        Assign(_validRegion);
    }

    MOZ_IMPLICIT PaintedLayerAttributes(const PaintedLayerAttributes& _o)
    {
        Init();
        Assign((_o).validRegion());
    }

    ~PaintedLayerAttributes();

    void
    operator=(const PaintedLayerAttributes& _o)
    {
        Assign((_o).validRegion());
    }

    bool
    operator==(const PaintedLayerAttributes& _o) const;

    bool
    operator!=(const PaintedLayerAttributes& _o) const;

    nsIntRegion&
    validRegion()
    {
        return validRegion_;
    }
    const nsIntRegion&
    validRegion() const
    {
        return validRegion_;
    }

private:
    void
    Init();

    void
    Assign(const nsIntRegion& _validRegion);

    nsIntRegion validRegion_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ContainerLayerAttributes|
//
namespace mozilla {
namespace layers {
class ContainerLayerAttributes final
{
private:
    typedef mozilla::layers::EventRegionsOverride EventRegionsOverride;

public:
    MOZ_IMPLICIT ContainerLayerAttributes();

    MOZ_IMPLICIT ContainerLayerAttributes(
            const float& _preXScale,
            const float& _preYScale,
            const float& _inheritedXScale,
            const float& _inheritedYScale,
            const float& _presShellResolution,
            const bool& _scaleToResolution,
            const EventRegionsOverride& _eventRegionsOverride)
    {
        Init();
        Assign(_preXScale, _preYScale, _inheritedXScale, _inheritedYScale, _presShellResolution, _scaleToResolution, _eventRegionsOverride);
    }

    MOZ_IMPLICIT ContainerLayerAttributes(const ContainerLayerAttributes& _o)
    {
        Init();
        Assign((_o).preXScale(), (_o).preYScale(), (_o).inheritedXScale(), (_o).inheritedYScale(), (_o).presShellResolution(), (_o).scaleToResolution(), (_o).eventRegionsOverride());
    }

    ~ContainerLayerAttributes();

    void
    operator=(const ContainerLayerAttributes& _o)
    {
        Assign((_o).preXScale(), (_o).preYScale(), (_o).inheritedXScale(), (_o).inheritedYScale(), (_o).presShellResolution(), (_o).scaleToResolution(), (_o).eventRegionsOverride());
    }

    bool
    operator==(const ContainerLayerAttributes& _o) const;

    bool
    operator!=(const ContainerLayerAttributes& _o) const;

    float&
    preXScale()
    {
        return preXScale_;
    }
    const float&
    preXScale() const
    {
        return preXScale_;
    }

    float&
    preYScale()
    {
        return preYScale_;
    }
    const float&
    preYScale() const
    {
        return preYScale_;
    }

    float&
    inheritedXScale()
    {
        return inheritedXScale_;
    }
    const float&
    inheritedXScale() const
    {
        return inheritedXScale_;
    }

    float&
    inheritedYScale()
    {
        return inheritedYScale_;
    }
    const float&
    inheritedYScale() const
    {
        return inheritedYScale_;
    }

    float&
    presShellResolution()
    {
        return presShellResolution_;
    }
    const float&
    presShellResolution() const
    {
        return presShellResolution_;
    }

    bool&
    scaleToResolution()
    {
        return scaleToResolution_;
    }
    const bool&
    scaleToResolution() const
    {
        return scaleToResolution_;
    }

    EventRegionsOverride&
    eventRegionsOverride()
    {
        return eventRegionsOverride_;
    }
    const EventRegionsOverride&
    eventRegionsOverride() const
    {
        return eventRegionsOverride_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _preXScale,
            const float& _preYScale,
            const float& _inheritedXScale,
            const float& _inheritedYScale,
            const float& _presShellResolution,
            const bool& _scaleToResolution,
            const EventRegionsOverride& _eventRegionsOverride);

    float preXScale_;
    float preYScale_;
    float inheritedXScale_;
    float inheritedYScale_;
    float presShellResolution_;
    bool scaleToResolution_;
    EventRegionsOverride eventRegionsOverride_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class LayerColor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct GlyphArray|
//
namespace mozilla {
namespace layers {
class GlyphArray final
{
private:
    typedef mozilla::layers::LayerColor LayerColor;
    typedef mozilla::gfx::Glyph Glyph;

public:
    MOZ_IMPLICIT GlyphArray();

    MOZ_IMPLICIT GlyphArray(
            const LayerColor& _color,
            const nsTArray<Glyph>& _glyphs)
    {
        Init();
        Assign(_color, _glyphs);
    }

    MOZ_IMPLICIT GlyphArray(const GlyphArray& _o)
    {
        Init();
        Assign((_o).color(), (_o).glyphs());
    }

    ~GlyphArray();

    void
    operator=(const GlyphArray& _o)
    {
        Assign((_o).color(), (_o).glyphs());
    }

    bool
    operator==(const GlyphArray& _o) const;

    bool
    operator!=(const GlyphArray& _o) const;

    LayerColor&
    color()
    {
        return color_;
    }
    const LayerColor&
    color() const
    {
        return color_;
    }

    nsTArray<Glyph>&
    glyphs()
    {
        return glyphs_;
    }
    const nsTArray<Glyph>&
    glyphs() const
    {
        return glyphs_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerColor& _color,
            const nsTArray<Glyph>& _glyphs);

    LayerColor color_;
    nsTArray<Glyph> glyphs_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class GlyphArray;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TextLayerAttributes|
//
namespace mozilla {
namespace layers {
class TextLayerAttributes final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::layers::GlyphArray GlyphArray;

public:
    MOZ_IMPLICIT TextLayerAttributes();

    MOZ_IMPLICIT TextLayerAttributes(
            const IntRect& _bounds,
            const nsTArray<GlyphArray>& _glyphs,
            const uintptr_t& _scaledFont)
    {
        Init();
        Assign(_bounds, _glyphs, _scaledFont);
    }

    MOZ_IMPLICIT TextLayerAttributes(const TextLayerAttributes& _o)
    {
        Init();
        Assign((_o).bounds(), (_o).glyphs(), (_o).scaledFont());
    }

    ~TextLayerAttributes();

    void
    operator=(const TextLayerAttributes& _o)
    {
        Assign((_o).bounds(), (_o).glyphs(), (_o).scaledFont());
    }

    bool
    operator==(const TextLayerAttributes& _o) const;

    bool
    operator!=(const TextLayerAttributes& _o) const;

    IntRect&
    bounds()
    {
        return bounds_;
    }
    const IntRect&
    bounds() const
    {
        return bounds_;
    }

    nsTArray<GlyphArray>&
    glyphs()
    {
        return glyphs_;
    }
    const nsTArray<GlyphArray>&
    glyphs() const
    {
        return glyphs_;
    }

    uintptr_t&
    scaledFont()
    {
        return scaledFont_;
    }
    const uintptr_t&
    scaledFont() const
    {
        return scaledFont_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntRect& _bounds,
            const nsTArray<GlyphArray>& _glyphs,
            const uintptr_t& _scaledFont);

    IntRect bounds_;
    nsTArray<GlyphArray> glyphs_;
    uintptr_t scaledFont_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class LayerColor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ColorLayerAttributes|
//
namespace mozilla {
namespace layers {
class ColorLayerAttributes final
{
private:
    typedef mozilla::layers::LayerColor LayerColor;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT ColorLayerAttributes();

    MOZ_IMPLICIT ColorLayerAttributes(
            const LayerColor& _color,
            const IntRect& _bounds)
    {
        Init();
        Assign(_color, _bounds);
    }

    MOZ_IMPLICIT ColorLayerAttributes(const ColorLayerAttributes& _o)
    {
        Init();
        Assign((_o).color(), (_o).bounds());
    }

    ~ColorLayerAttributes();

    void
    operator=(const ColorLayerAttributes& _o)
    {
        Assign((_o).color(), (_o).bounds());
    }

    bool
    operator==(const ColorLayerAttributes& _o) const;

    bool
    operator!=(const ColorLayerAttributes& _o) const;

    LayerColor&
    color()
    {
        return color_;
    }
    const LayerColor&
    color() const
    {
        return color_;
    }

    IntRect&
    bounds()
    {
        return bounds_;
    }
    const IntRect&
    bounds() const
    {
        return bounds_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerColor& _color,
            const IntRect& _bounds);

    LayerColor color_;
    IntRect bounds_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CanvasLayerAttributes|
//
namespace mozilla {
namespace layers {
class CanvasLayerAttributes final
{
private:
    typedef mozilla::gfx::SamplingFilter SamplingFilter;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT CanvasLayerAttributes();

    MOZ_IMPLICIT CanvasLayerAttributes(
            const SamplingFilter& _samplingFilter,
            const IntRect& _bounds)
    {
        Init();
        Assign(_samplingFilter, _bounds);
    }

    MOZ_IMPLICIT CanvasLayerAttributes(const CanvasLayerAttributes& _o)
    {
        Init();
        Assign((_o).samplingFilter(), (_o).bounds());
    }

    ~CanvasLayerAttributes();

    void
    operator=(const CanvasLayerAttributes& _o)
    {
        Assign((_o).samplingFilter(), (_o).bounds());
    }

    bool
    operator==(const CanvasLayerAttributes& _o) const;

    bool
    operator!=(const CanvasLayerAttributes& _o) const;

    SamplingFilter&
    samplingFilter()
    {
        return samplingFilter_;
    }
    const SamplingFilter&
    samplingFilter() const
    {
        return samplingFilter_;
    }

    IntRect&
    bounds()
    {
        return bounds_;
    }
    const IntRect&
    bounds() const
    {
        return bounds_;
    }

private:
    void
    Init();

    void
    Assign(
            const SamplingFilter& _samplingFilter,
            const IntRect& _bounds);

    SamplingFilter samplingFilter_;
    IntRect bounds_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RefLayerAttributes|
//
namespace mozilla {
namespace layers {
class RefLayerAttributes final
{
private:
    typedef mozilla::layers::EventRegionsOverride EventRegionsOverride;

public:
    MOZ_IMPLICIT RefLayerAttributes();

    MOZ_IMPLICIT RefLayerAttributes(
            const uint64_t& _id,
            const EventRegionsOverride& _eventRegionsOverride)
    {
        Init();
        Assign(_id, _eventRegionsOverride);
    }

    MOZ_IMPLICIT RefLayerAttributes(const RefLayerAttributes& _o)
    {
        Init();
        Assign((_o).id(), (_o).eventRegionsOverride());
    }

    ~RefLayerAttributes();

    void
    operator=(const RefLayerAttributes& _o)
    {
        Assign((_o).id(), (_o).eventRegionsOverride());
    }

    bool
    operator==(const RefLayerAttributes& _o) const;

    bool
    operator!=(const RefLayerAttributes& _o) const;

    uint64_t&
    id()
    {
        return id_;
    }
    const uint64_t&
    id() const
    {
        return id_;
    }

    EventRegionsOverride&
    eventRegionsOverride()
    {
        return eventRegionsOverride_;
    }
    const EventRegionsOverride&
    eventRegionsOverride() const
    {
        return eventRegionsOverride_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _id,
            const EventRegionsOverride& _eventRegionsOverride);

    uint64_t id_;
    EventRegionsOverride eventRegionsOverride_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ImageLayerAttributes|
//
namespace mozilla {
namespace layers {
class ImageLayerAttributes final
{
private:
    typedef mozilla::gfx::SamplingFilter SamplingFilter;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::ScaleMode ScaleMode;

public:
    MOZ_IMPLICIT ImageLayerAttributes();

    MOZ_IMPLICIT ImageLayerAttributes(
            const SamplingFilter& _samplingFilter,
            const IntSize& _scaleToSize,
            const ScaleMode& _scaleMode)
    {
        Init();
        Assign(_samplingFilter, _scaleToSize, _scaleMode);
    }

    MOZ_IMPLICIT ImageLayerAttributes(const ImageLayerAttributes& _o)
    {
        Init();
        Assign((_o).samplingFilter(), (_o).scaleToSize(), (_o).scaleMode());
    }

    ~ImageLayerAttributes();

    void
    operator=(const ImageLayerAttributes& _o)
    {
        Assign((_o).samplingFilter(), (_o).scaleToSize(), (_o).scaleMode());
    }

    bool
    operator==(const ImageLayerAttributes& _o) const;

    bool
    operator!=(const ImageLayerAttributes& _o) const;

    SamplingFilter&
    samplingFilter()
    {
        return samplingFilter_;
    }
    const SamplingFilter&
    samplingFilter() const
    {
        return samplingFilter_;
    }

    IntSize&
    scaleToSize()
    {
        return scaleToSize_;
    }
    const IntSize&
    scaleToSize() const
    {
        return scaleToSize_;
    }

    ScaleMode&
    scaleMode()
    {
        return scaleMode_;
    }
    const ScaleMode&
    scaleMode() const
    {
        return scaleMode_;
    }

private:
    void
    Init();

    void
    Assign(
            const SamplingFilter& _samplingFilter,
            const IntSize& _scaleToSize,
            const ScaleMode& _scaleMode);

    SamplingFilter samplingFilter_;
    IntSize scaleToSize_;
    ScaleMode scaleMode_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BorderLayerAttributes|
//
namespace mozilla {
namespace layers {
class BorderLayerAttributes final
{
private:
    typedef mozilla::LayerRect LayerRect;
    typedef mozilla::layers::BorderColors BorderColors;
    typedef mozilla::layers::BorderCorners BorderCorners;
    typedef mozilla::layers::BorderWidths BorderWidths;

public:
    MOZ_IMPLICIT BorderLayerAttributes();

    MOZ_IMPLICIT BorderLayerAttributes(
            const LayerRect& _rect,
            const BorderColors& _colors,
            const BorderCorners& _corners,
            const BorderWidths& _widths)
    {
        Init();
        Assign(_rect, _colors, _corners, _widths);
    }

    MOZ_IMPLICIT BorderLayerAttributes(const BorderLayerAttributes& _o)
    {
        Init();
        Assign((_o).rect(), (_o).colors(), (_o).corners(), (_o).widths());
    }

    ~BorderLayerAttributes();

    void
    operator=(const BorderLayerAttributes& _o)
    {
        Assign((_o).rect(), (_o).colors(), (_o).corners(), (_o).widths());
    }

    bool
    operator==(const BorderLayerAttributes& _o) const;

    bool
    operator!=(const BorderLayerAttributes& _o) const;

    LayerRect&
    rect()
    {
        return rect_;
    }
    const LayerRect&
    rect() const
    {
        return rect_;
    }

    BorderColors&
    colors()
    {
        return colors_;
    }
    const BorderColors&
    colors() const
    {
        return colors_;
    }

    BorderCorners&
    corners()
    {
        return corners_;
    }
    const BorderCorners&
    corners() const
    {
        return corners_;
    }

    BorderWidths&
    widths()
    {
        return widths_;
    }
    const BorderWidths&
    widths() const
    {
        return widths_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerRect& _rect,
            const BorderColors& _colors,
            const BorderCorners& _corners,
            const BorderWidths& _widths);

    LayerRect rect_;
    BorderColors colors_;
    BorderCorners corners_;
    BorderWidths widths_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PaintedLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ContainerLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ColorLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CanvasLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TextLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RefLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ImageLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class BorderLayerAttributes;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union SpecificLayerAttributes|
//
namespace mozilla {
namespace layers {
class SpecificLayerAttributes final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TPaintedLayerAttributes,
        TContainerLayerAttributes,
        TColorLayerAttributes,
        TCanvasLayerAttributes,
        TTextLayerAttributes,
        TRefLayerAttributes,
        TImageLayerAttributes,
        TBorderLayerAttributes,
        T__Last = TBorderLayerAttributes
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::PaintedLayerAttributes PaintedLayerAttributes;
    typedef mozilla::layers::ContainerLayerAttributes ContainerLayerAttributes;
    typedef mozilla::layers::ColorLayerAttributes ColorLayerAttributes;
    typedef mozilla::layers::CanvasLayerAttributes CanvasLayerAttributes;
    typedef mozilla::layers::TextLayerAttributes TextLayerAttributes;
    typedef mozilla::layers::RefLayerAttributes RefLayerAttributes;
    typedef mozilla::layers::ImageLayerAttributes ImageLayerAttributes;
    typedef mozilla::layers::BorderLayerAttributes BorderLayerAttributes;
    typedef null_t null_t__tdef;
    typedef PaintedLayerAttributes PaintedLayerAttributes__tdef;
    typedef ContainerLayerAttributes ContainerLayerAttributes__tdef;
    typedef ColorLayerAttributes ColorLayerAttributes__tdef;
    typedef CanvasLayerAttributes CanvasLayerAttributes__tdef;
    typedef TextLayerAttributes TextLayerAttributes__tdef;
    typedef RefLayerAttributes RefLayerAttributes__tdef;
    typedef ImageLayerAttributes ImageLayerAttributes__tdef;
    typedef BorderLayerAttributes BorderLayerAttributes__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<PaintedLayerAttributes> VPaintedLayerAttributes;
        mozilla::AlignedStorage2<ContainerLayerAttributes> VContainerLayerAttributes;
        mozilla::AlignedStorage2<ColorLayerAttributes> VColorLayerAttributes;
        mozilla::AlignedStorage2<CanvasLayerAttributes> VCanvasLayerAttributes;
        mozilla::AlignedStorage2<TextLayerAttributes> VTextLayerAttributes;
        mozilla::AlignedStorage2<RefLayerAttributes> VRefLayerAttributes;
        mozilla::AlignedStorage2<ImageLayerAttributes> VImageLayerAttributes;
        mozilla::AlignedStorage2<BorderLayerAttributes> VBorderLayerAttributes;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    PaintedLayerAttributes*
    ptr_PaintedLayerAttributes()
    {
        return ((mValue).VPaintedLayerAttributes).addr();
    }
    const PaintedLayerAttributes*
    constptr_PaintedLayerAttributes() const
    {
        return ((mValue).VPaintedLayerAttributes).addr();
    }
    ContainerLayerAttributes*
    ptr_ContainerLayerAttributes()
    {
        return ((mValue).VContainerLayerAttributes).addr();
    }
    const ContainerLayerAttributes*
    constptr_ContainerLayerAttributes() const
    {
        return ((mValue).VContainerLayerAttributes).addr();
    }
    ColorLayerAttributes*
    ptr_ColorLayerAttributes()
    {
        return ((mValue).VColorLayerAttributes).addr();
    }
    const ColorLayerAttributes*
    constptr_ColorLayerAttributes() const
    {
        return ((mValue).VColorLayerAttributes).addr();
    }
    CanvasLayerAttributes*
    ptr_CanvasLayerAttributes()
    {
        return ((mValue).VCanvasLayerAttributes).addr();
    }
    const CanvasLayerAttributes*
    constptr_CanvasLayerAttributes() const
    {
        return ((mValue).VCanvasLayerAttributes).addr();
    }
    TextLayerAttributes*
    ptr_TextLayerAttributes()
    {
        return ((mValue).VTextLayerAttributes).addr();
    }
    const TextLayerAttributes*
    constptr_TextLayerAttributes() const
    {
        return ((mValue).VTextLayerAttributes).addr();
    }
    RefLayerAttributes*
    ptr_RefLayerAttributes()
    {
        return ((mValue).VRefLayerAttributes).addr();
    }
    const RefLayerAttributes*
    constptr_RefLayerAttributes() const
    {
        return ((mValue).VRefLayerAttributes).addr();
    }
    ImageLayerAttributes*
    ptr_ImageLayerAttributes()
    {
        return ((mValue).VImageLayerAttributes).addr();
    }
    const ImageLayerAttributes*
    constptr_ImageLayerAttributes() const
    {
        return ((mValue).VImageLayerAttributes).addr();
    }
    BorderLayerAttributes*
    ptr_BorderLayerAttributes()
    {
        return ((mValue).VBorderLayerAttributes).addr();
    }
    const BorderLayerAttributes*
    constptr_BorderLayerAttributes() const
    {
        return ((mValue).VBorderLayerAttributes).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT SpecificLayerAttributes() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT SpecificLayerAttributes(const null_t& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const PaintedLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const ContainerLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const ColorLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const CanvasLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const TextLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const RefLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const ImageLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const BorderLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const SpecificLayerAttributes& aOther);

    ~SpecificLayerAttributes();

    Type
    type() const
    {
        return mType;
    }

    SpecificLayerAttributes&
    operator=(const null_t& aRhs);

    SpecificLayerAttributes&
    operator=(const PaintedLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const ContainerLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const ColorLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const CanvasLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const TextLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const RefLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const ImageLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const BorderLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const SpecificLayerAttributes& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const PaintedLayerAttributes& aRhs) const;

    bool
    operator==(const ContainerLayerAttributes& aRhs) const;

    bool
    operator==(const ColorLayerAttributes& aRhs) const;

    bool
    operator==(const CanvasLayerAttributes& aRhs) const;

    bool
    operator==(const TextLayerAttributes& aRhs) const;

    bool
    operator==(const RefLayerAttributes& aRhs) const;

    bool
    operator==(const ImageLayerAttributes& aRhs) const;

    bool
    operator==(const BorderLayerAttributes& aRhs) const;

    bool
    operator==(const SpecificLayerAttributes& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    PaintedLayerAttributes&
    get_PaintedLayerAttributes()
    {
        AssertSanity(TPaintedLayerAttributes);
        return (*(ptr_PaintedLayerAttributes()));
    }
    const PaintedLayerAttributes&
    get_PaintedLayerAttributes() const
    {
        AssertSanity(TPaintedLayerAttributes);
        return (*(constptr_PaintedLayerAttributes()));
    }
    void
    get(PaintedLayerAttributes* aOutValue) const;
    operator PaintedLayerAttributes&()
    {
        return get_PaintedLayerAttributes();
    }
    operator const PaintedLayerAttributes&() const
    {
        return get_PaintedLayerAttributes();
    }

    ContainerLayerAttributes&
    get_ContainerLayerAttributes()
    {
        AssertSanity(TContainerLayerAttributes);
        return (*(ptr_ContainerLayerAttributes()));
    }
    const ContainerLayerAttributes&
    get_ContainerLayerAttributes() const
    {
        AssertSanity(TContainerLayerAttributes);
        return (*(constptr_ContainerLayerAttributes()));
    }
    void
    get(ContainerLayerAttributes* aOutValue) const;
    operator ContainerLayerAttributes&()
    {
        return get_ContainerLayerAttributes();
    }
    operator const ContainerLayerAttributes&() const
    {
        return get_ContainerLayerAttributes();
    }

    ColorLayerAttributes&
    get_ColorLayerAttributes()
    {
        AssertSanity(TColorLayerAttributes);
        return (*(ptr_ColorLayerAttributes()));
    }
    const ColorLayerAttributes&
    get_ColorLayerAttributes() const
    {
        AssertSanity(TColorLayerAttributes);
        return (*(constptr_ColorLayerAttributes()));
    }
    void
    get(ColorLayerAttributes* aOutValue) const;
    operator ColorLayerAttributes&()
    {
        return get_ColorLayerAttributes();
    }
    operator const ColorLayerAttributes&() const
    {
        return get_ColorLayerAttributes();
    }

    CanvasLayerAttributes&
    get_CanvasLayerAttributes()
    {
        AssertSanity(TCanvasLayerAttributes);
        return (*(ptr_CanvasLayerAttributes()));
    }
    const CanvasLayerAttributes&
    get_CanvasLayerAttributes() const
    {
        AssertSanity(TCanvasLayerAttributes);
        return (*(constptr_CanvasLayerAttributes()));
    }
    void
    get(CanvasLayerAttributes* aOutValue) const;
    operator CanvasLayerAttributes&()
    {
        return get_CanvasLayerAttributes();
    }
    operator const CanvasLayerAttributes&() const
    {
        return get_CanvasLayerAttributes();
    }

    TextLayerAttributes&
    get_TextLayerAttributes()
    {
        AssertSanity(TTextLayerAttributes);
        return (*(ptr_TextLayerAttributes()));
    }
    const TextLayerAttributes&
    get_TextLayerAttributes() const
    {
        AssertSanity(TTextLayerAttributes);
        return (*(constptr_TextLayerAttributes()));
    }
    void
    get(TextLayerAttributes* aOutValue) const;
    operator TextLayerAttributes&()
    {
        return get_TextLayerAttributes();
    }
    operator const TextLayerAttributes&() const
    {
        return get_TextLayerAttributes();
    }

    RefLayerAttributes&
    get_RefLayerAttributes()
    {
        AssertSanity(TRefLayerAttributes);
        return (*(ptr_RefLayerAttributes()));
    }
    const RefLayerAttributes&
    get_RefLayerAttributes() const
    {
        AssertSanity(TRefLayerAttributes);
        return (*(constptr_RefLayerAttributes()));
    }
    void
    get(RefLayerAttributes* aOutValue) const;
    operator RefLayerAttributes&()
    {
        return get_RefLayerAttributes();
    }
    operator const RefLayerAttributes&() const
    {
        return get_RefLayerAttributes();
    }

    ImageLayerAttributes&
    get_ImageLayerAttributes()
    {
        AssertSanity(TImageLayerAttributes);
        return (*(ptr_ImageLayerAttributes()));
    }
    const ImageLayerAttributes&
    get_ImageLayerAttributes() const
    {
        AssertSanity(TImageLayerAttributes);
        return (*(constptr_ImageLayerAttributes()));
    }
    void
    get(ImageLayerAttributes* aOutValue) const;
    operator ImageLayerAttributes&()
    {
        return get_ImageLayerAttributes();
    }
    operator const ImageLayerAttributes&() const
    {
        return get_ImageLayerAttributes();
    }

    BorderLayerAttributes&
    get_BorderLayerAttributes()
    {
        AssertSanity(TBorderLayerAttributes);
        return (*(ptr_BorderLayerAttributes()));
    }
    const BorderLayerAttributes&
    get_BorderLayerAttributes() const
    {
        AssertSanity(TBorderLayerAttributes);
        return (*(constptr_BorderLayerAttributes()));
    }
    void
    get(BorderLayerAttributes* aOutValue) const;
    operator BorderLayerAttributes&()
    {
        return get_BorderLayerAttributes();
    }
    operator const BorderLayerAttributes&() const
    {
        return get_BorderLayerAttributes();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CommonLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SpecificLayerAttributes;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LayerAttributes|
//
namespace mozilla {
namespace layers {
class LayerAttributes final
{
private:
    typedef mozilla::layers::CommonLayerAttributes CommonLayerAttributes;
    typedef mozilla::layers::SpecificLayerAttributes SpecificLayerAttributes;

public:
    MOZ_IMPLICIT LayerAttributes();

    MOZ_IMPLICIT LayerAttributes(
            const CommonLayerAttributes& _common,
            const SpecificLayerAttributes& _specific)
    {
        Init();
        Assign(_common, _specific);
    }

    MOZ_IMPLICIT LayerAttributes(const LayerAttributes& _o)
    {
        Init();
        Assign((_o).common(), (_o).specific());
    }

    ~LayerAttributes();

    void
    operator=(const LayerAttributes& _o)
    {
        Assign((_o).common(), (_o).specific());
    }

    bool
    operator==(const LayerAttributes& _o) const;

    bool
    operator!=(const LayerAttributes& _o) const;

    CommonLayerAttributes&
    common()
    {
        return common_;
    }
    const CommonLayerAttributes&
    common() const
    {
        return common_;
    }

    SpecificLayerAttributes&
    specific()
    {
        return specific_;
    }
    const SpecificLayerAttributes&
    specific() const
    {
        return specific_;
    }

private:
    void
    Init();

    void
    Assign(
            const CommonLayerAttributes& _common,
            const SpecificLayerAttributes& _specific);

    CommonLayerAttributes common_;
    SpecificLayerAttributes specific_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PluginWindowData|
//
namespace mozilla {
namespace layers {
class PluginWindowData final
{
private:
    typedef mozilla::LayoutDeviceIntRect LayoutDeviceIntRect;

public:
    MOZ_IMPLICIT PluginWindowData();

    MOZ_IMPLICIT PluginWindowData(
            const uintptr_t& _windowId,
            const nsTArray<LayoutDeviceIntRect>& _clip,
            const LayoutDeviceIntRect& _bounds,
            const bool& _visible)
    {
        Init();
        Assign(_windowId, _clip, _bounds, _visible);
    }

    MOZ_IMPLICIT PluginWindowData(const PluginWindowData& _o)
    {
        Init();
        Assign((_o).windowId(), (_o).clip(), (_o).bounds(), (_o).visible());
    }

    ~PluginWindowData();

    void
    operator=(const PluginWindowData& _o)
    {
        Assign((_o).windowId(), (_o).clip(), (_o).bounds(), (_o).visible());
    }

    bool
    operator==(const PluginWindowData& _o) const;

    bool
    operator!=(const PluginWindowData& _o) const;

    uintptr_t&
    windowId()
    {
        return windowId_;
    }
    const uintptr_t&
    windowId() const
    {
        return windowId_;
    }

    nsTArray<LayoutDeviceIntRect>&
    clip()
    {
        return clip_;
    }
    const nsTArray<LayoutDeviceIntRect>&
    clip() const
    {
        return clip_;
    }

    LayoutDeviceIntRect&
    bounds()
    {
        return bounds_;
    }
    const LayoutDeviceIntRect&
    bounds() const
    {
        return bounds_;
    }

    bool&
    visible()
    {
        return visible_;
    }
    const bool&
    visible() const
    {
        return visible_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _windowId,
            const nsTArray<LayoutDeviceIntRect>& _clip,
            const LayoutDeviceIntRect& _bounds,
            const bool& _visible);

    uintptr_t windowId_;
    nsTArray<LayoutDeviceIntRect> clip_;
    LayoutDeviceIntRect bounds_;
    bool visible_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetSimpleLayerAttributes|
//
namespace mozilla {
namespace layers {
class OpSetSimpleLayerAttributes final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::SimpleLayerAttributes SimpleLayerAttributes;

public:
    MOZ_IMPLICIT OpSetSimpleLayerAttributes();

    MOZ_IMPLICIT OpSetSimpleLayerAttributes(
            const LayerHandle& _layer,
            const SimpleLayerAttributes& _attrs)
    {
        Init();
        Assign(_layer, _attrs);
    }

    MOZ_IMPLICIT OpSetSimpleLayerAttributes(const OpSetSimpleLayerAttributes& _o)
    {
        Init();
        Assign((_o).layer(), (_o).attrs());
    }

    ~OpSetSimpleLayerAttributes();

    void
    operator=(const OpSetSimpleLayerAttributes& _o)
    {
        Assign((_o).layer(), (_o).attrs());
    }

    bool
    operator==(const OpSetSimpleLayerAttributes& _o) const;

    bool
    operator!=(const OpSetSimpleLayerAttributes& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

    SimpleLayerAttributes&
    attrs()
    {
        return attrs_;
    }
    const SimpleLayerAttributes&
    attrs() const
    {
        return attrs_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _layer,
            const SimpleLayerAttributes& _attrs);

    LayerHandle layer_;
    SimpleLayerAttributes attrs_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class LayerAttributes;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetLayerAttributes|
//
namespace mozilla {
namespace layers {
class OpSetLayerAttributes final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::LayerAttributes LayerAttributes;

public:
    MOZ_IMPLICIT OpSetLayerAttributes();

    MOZ_IMPLICIT OpSetLayerAttributes(
            const LayerHandle& _layer,
            const LayerAttributes& _attrs)
    {
        Init();
        Assign(_layer, _attrs);
    }

    MOZ_IMPLICIT OpSetLayerAttributes(const OpSetLayerAttributes& _o)
    {
        Init();
        Assign((_o).layer(), (_o).attrs());
    }

    ~OpSetLayerAttributes();

    void
    operator=(const OpSetLayerAttributes& _o)
    {
        Assign((_o).layer(), (_o).attrs());
    }

    bool
    operator==(const OpSetLayerAttributes& _o) const;

    bool
    operator!=(const OpSetLayerAttributes& _o) const;

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

    LayerAttributes&
    attrs()
    {
        return attrs_;
    }
    const LayerAttributes&
    attrs() const
    {
        return attrs_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _layer,
            const LayerAttributes& _attrs);

    LayerHandle layer_;
    LayerAttributes attrs_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetRoot|
//
namespace mozilla {
namespace layers {
class OpSetRoot final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpSetRoot();

    MOZ_IMPLICIT OpSetRoot(const LayerHandle& _root)
    {
        Init();
        Assign(_root);
    }

    MOZ_IMPLICIT OpSetRoot(const OpSetRoot& _o)
    {
        Init();
        Assign((_o).root());
    }

    ~OpSetRoot();

    void
    operator=(const OpSetRoot& _o)
    {
        Assign((_o).root());
    }

    bool
    operator==(const OpSetRoot& _o) const;

    bool
    operator!=(const OpSetRoot& _o) const;

    LayerHandle&
    root()
    {
        return root_;
    }
    const LayerHandle&
    root() const
    {
        return root_;
    }

private:
    void
    Init();

    void
    Assign(const LayerHandle& _root);

    LayerHandle root_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpInsertAfter|
//
namespace mozilla {
namespace layers {
class OpInsertAfter final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpInsertAfter();

    MOZ_IMPLICIT OpInsertAfter(
            const LayerHandle& _container,
            const LayerHandle& _childLayer,
            const LayerHandle& _after)
    {
        Init();
        Assign(_container, _childLayer, _after);
    }

    MOZ_IMPLICIT OpInsertAfter(const OpInsertAfter& _o)
    {
        Init();
        Assign((_o).container(), (_o).childLayer(), (_o).after());
    }

    ~OpInsertAfter();

    void
    operator=(const OpInsertAfter& _o)
    {
        Assign((_o).container(), (_o).childLayer(), (_o).after());
    }

    bool
    operator==(const OpInsertAfter& _o) const;

    bool
    operator!=(const OpInsertAfter& _o) const;

    LayerHandle&
    container()
    {
        return container_;
    }
    const LayerHandle&
    container() const
    {
        return container_;
    }

    LayerHandle&
    childLayer()
    {
        return childLayer_;
    }
    const LayerHandle&
    childLayer() const
    {
        return childLayer_;
    }

    LayerHandle&
    after()
    {
        return after_;
    }
    const LayerHandle&
    after() const
    {
        return after_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _container,
            const LayerHandle& _childLayer,
            const LayerHandle& _after);

    LayerHandle container_;
    LayerHandle childLayer_;
    LayerHandle after_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpPrependChild|
//
namespace mozilla {
namespace layers {
class OpPrependChild final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpPrependChild();

    MOZ_IMPLICIT OpPrependChild(
            const LayerHandle& _container,
            const LayerHandle& _childLayer)
    {
        Init();
        Assign(_container, _childLayer);
    }

    MOZ_IMPLICIT OpPrependChild(const OpPrependChild& _o)
    {
        Init();
        Assign((_o).container(), (_o).childLayer());
    }

    ~OpPrependChild();

    void
    operator=(const OpPrependChild& _o)
    {
        Assign((_o).container(), (_o).childLayer());
    }

    bool
    operator==(const OpPrependChild& _o) const;

    bool
    operator!=(const OpPrependChild& _o) const;

    LayerHandle&
    container()
    {
        return container_;
    }
    const LayerHandle&
    container() const
    {
        return container_;
    }

    LayerHandle&
    childLayer()
    {
        return childLayer_;
    }
    const LayerHandle&
    childLayer() const
    {
        return childLayer_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _container,
            const LayerHandle& _childLayer);

    LayerHandle container_;
    LayerHandle childLayer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRemoveChild|
//
namespace mozilla {
namespace layers {
class OpRemoveChild final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpRemoveChild();

    MOZ_IMPLICIT OpRemoveChild(
            const LayerHandle& _container,
            const LayerHandle& _childLayer)
    {
        Init();
        Assign(_container, _childLayer);
    }

    MOZ_IMPLICIT OpRemoveChild(const OpRemoveChild& _o)
    {
        Init();
        Assign((_o).container(), (_o).childLayer());
    }

    ~OpRemoveChild();

    void
    operator=(const OpRemoveChild& _o)
    {
        Assign((_o).container(), (_o).childLayer());
    }

    bool
    operator==(const OpRemoveChild& _o) const;

    bool
    operator!=(const OpRemoveChild& _o) const;

    LayerHandle&
    container()
    {
        return container_;
    }
    const LayerHandle&
    container() const
    {
        return container_;
    }

    LayerHandle&
    childLayer()
    {
        return childLayer_;
    }
    const LayerHandle&
    childLayer() const
    {
        return childLayer_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _container,
            const LayerHandle& _childLayer);

    LayerHandle container_;
    LayerHandle childLayer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRepositionChild|
//
namespace mozilla {
namespace layers {
class OpRepositionChild final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpRepositionChild();

    MOZ_IMPLICIT OpRepositionChild(
            const LayerHandle& _container,
            const LayerHandle& _childLayer,
            const LayerHandle& _after)
    {
        Init();
        Assign(_container, _childLayer, _after);
    }

    MOZ_IMPLICIT OpRepositionChild(const OpRepositionChild& _o)
    {
        Init();
        Assign((_o).container(), (_o).childLayer(), (_o).after());
    }

    ~OpRepositionChild();

    void
    operator=(const OpRepositionChild& _o)
    {
        Assign((_o).container(), (_o).childLayer(), (_o).after());
    }

    bool
    operator==(const OpRepositionChild& _o) const;

    bool
    operator!=(const OpRepositionChild& _o) const;

    LayerHandle&
    container()
    {
        return container_;
    }
    const LayerHandle&
    container() const
    {
        return container_;
    }

    LayerHandle&
    childLayer()
    {
        return childLayer_;
    }
    const LayerHandle&
    childLayer() const
    {
        return childLayer_;
    }

    LayerHandle&
    after()
    {
        return after_;
    }
    const LayerHandle&
    after() const
    {
        return after_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _container,
            const LayerHandle& _childLayer,
            const LayerHandle& _after);

    LayerHandle container_;
    LayerHandle childLayer_;
    LayerHandle after_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRaiseToTopChild|
//
namespace mozilla {
namespace layers {
class OpRaiseToTopChild final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;

public:
    MOZ_IMPLICIT OpRaiseToTopChild();

    MOZ_IMPLICIT OpRaiseToTopChild(
            const LayerHandle& _container,
            const LayerHandle& _childLayer)
    {
        Init();
        Assign(_container, _childLayer);
    }

    MOZ_IMPLICIT OpRaiseToTopChild(const OpRaiseToTopChild& _o)
    {
        Init();
        Assign((_o).container(), (_o).childLayer());
    }

    ~OpRaiseToTopChild();

    void
    operator=(const OpRaiseToTopChild& _o)
    {
        Assign((_o).container(), (_o).childLayer());
    }

    bool
    operator==(const OpRaiseToTopChild& _o) const;

    bool
    operator!=(const OpRaiseToTopChild& _o) const;

    LayerHandle&
    container()
    {
        return container_;
    }
    const LayerHandle&
    container() const
    {
        return container_;
    }

    LayerHandle&
    childLayer()
    {
        return childLayer_;
    }
    const LayerHandle&
    childLayer() const
    {
        return childLayer_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerHandle& _container,
            const LayerHandle& _childLayer);

    LayerHandle container_;
    LayerHandle childLayer_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetDiagnosticTypes|
//
namespace mozilla {
namespace layers {
class OpSetDiagnosticTypes final
{
private:
    typedef mozilla::layers::DiagnosticTypes DiagnosticTypes;

public:
    MOZ_IMPLICIT OpSetDiagnosticTypes();

    MOZ_IMPLICIT OpSetDiagnosticTypes(const DiagnosticTypes& _diagnostics)
    {
        Init();
        Assign(_diagnostics);
    }

    MOZ_IMPLICIT OpSetDiagnosticTypes(const OpSetDiagnosticTypes& _o)
    {
        Init();
        Assign((_o).diagnostics());
    }

    ~OpSetDiagnosticTypes();

    void
    operator=(const OpSetDiagnosticTypes& _o)
    {
        Assign((_o).diagnostics());
    }

    bool
    operator==(const OpSetDiagnosticTypes& _o) const;

    bool
    operator!=(const OpSetDiagnosticTypes& _o) const;

    DiagnosticTypes&
    diagnostics()
    {
        return diagnostics_;
    }
    const DiagnosticTypes&
    diagnostics() const
    {
        return diagnostics_;
    }

private:
    void
    Init();

    void
    Assign(const DiagnosticTypes& _diagnostics);

    DiagnosticTypes diagnostics_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpWindowOverlayChanged|
//
namespace mozilla {
namespace layers {
class OpWindowOverlayChanged final
{
private:

public:
    MOZ_IMPLICIT OpWindowOverlayChanged()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT OpWindowOverlayChanged(const OpWindowOverlayChanged& _o)
    {
        Init();
        Assign();
    }

    ~OpWindowOverlayChanged();

    void
    operator=(const OpWindowOverlayChanged& _o)
    {
        Assign();
    }

    bool
    operator==(const OpWindowOverlayChanged& _o) const;

    bool
    operator!=(const OpWindowOverlayChanged& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ShmemSection|
//
namespace mozilla {
namespace layers {
class ShmemSection final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT ShmemSection();

    MOZ_IMPLICIT ShmemSection(
            Shmem& _shmem,
            const uint32_t& _offset,
            const size_t& _size)
    {
        Init();
        Assign(_shmem, _offset, _size);
    }

    MOZ_IMPLICIT ShmemSection(const ShmemSection& _o)
    {
        Init();
        Assign((_o).shmem(), (_o).offset(), (_o).size());
    }

    ~ShmemSection();

    void
    operator=(const ShmemSection& _o)
    {
        Assign((_o).shmem(), (_o).offset(), (_o).size());
    }

    bool
    operator==(const ShmemSection& _o) const;

    bool
    operator!=(const ShmemSection& _o) const;

    Shmem&
    shmem()
    {
        return shmem_;
    }
    Shmem&
    shmem() const
    {
        return const_cast<Shmem&>(shmem_);
    }

    uint32_t&
    offset()
    {
        return offset_;
    }
    const uint32_t&
    offset() const
    {
        return offset_;
    }

    size_t&
    size()
    {
        return size_;
    }
    const size_t&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            Shmem& _shmem,
            const uint32_t& _offset,
            const size_t& _size);

    Shmem shmem_;
    uint32_t offset_;
    size_t size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CrossProcessSemaphoreDescriptor|
//
namespace mozilla {
namespace layers {
class CrossProcessSemaphoreDescriptor final
{
private:
    typedef mozilla::CrossProcessSemaphoreHandle CrossProcessSemaphoreHandle;

public:
    MOZ_IMPLICIT CrossProcessSemaphoreDescriptor();

    MOZ_IMPLICIT CrossProcessSemaphoreDescriptor(const CrossProcessSemaphoreHandle& _sem)
    {
        Init();
        Assign(_sem);
    }

    MOZ_IMPLICIT CrossProcessSemaphoreDescriptor(const CrossProcessSemaphoreDescriptor& _o)
    {
        Init();
        Assign((_o).sem());
    }

    ~CrossProcessSemaphoreDescriptor();

    void
    operator=(const CrossProcessSemaphoreDescriptor& _o)
    {
        Assign((_o).sem());
    }

    bool
    operator==(const CrossProcessSemaphoreDescriptor& _o) const;

    bool
    operator!=(const CrossProcessSemaphoreDescriptor& _o) const;

    CrossProcessSemaphoreHandle&
    sem()
    {
        return sem_;
    }
    const CrossProcessSemaphoreHandle&
    sem() const
    {
        return sem_;
    }

private:
    void
    Init();

    void
    Assign(const CrossProcessSemaphoreHandle& _sem);

    CrossProcessSemaphoreHandle sem_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class ShmemSection;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CrossProcessSemaphoreDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ReadLockDescriptor|
//
namespace mozilla {
namespace layers {
class ReadLockDescriptor final
{
public:
    enum Type {
        T__None,
        TShmemSection = 1,
        TCrossProcessSemaphoreDescriptor,
        Tuintptr_t,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::ShmemSection ShmemSection;
    typedef mozilla::layers::CrossProcessSemaphoreDescriptor CrossProcessSemaphoreDescriptor;
    typedef mozilla::null_t null_t;
    typedef ShmemSection ShmemSection__tdef;
    typedef CrossProcessSemaphoreDescriptor CrossProcessSemaphoreDescriptor__tdef;
    typedef uintptr_t uintptr_t__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<ShmemSection> VShmemSection;
        mozilla::AlignedStorage2<CrossProcessSemaphoreDescriptor> VCrossProcessSemaphoreDescriptor;
        mozilla::AlignedStorage2<uintptr_t> Vuintptr_t;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    ShmemSection*
    ptr_ShmemSection()
    {
        return ((mValue).VShmemSection).addr();
    }
    const ShmemSection*
    constptr_ShmemSection() const
    {
        return ((mValue).VShmemSection).addr();
    }
    CrossProcessSemaphoreDescriptor*
    ptr_CrossProcessSemaphoreDescriptor()
    {
        return ((mValue).VCrossProcessSemaphoreDescriptor).addr();
    }
    const CrossProcessSemaphoreDescriptor*
    constptr_CrossProcessSemaphoreDescriptor() const
    {
        return ((mValue).VCrossProcessSemaphoreDescriptor).addr();
    }
    uintptr_t*
    ptr_uintptr_t()
    {
        return ((mValue).Vuintptr_t).addr();
    }
    const uintptr_t*
    constptr_uintptr_t() const
    {
        return ((mValue).Vuintptr_t).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ReadLockDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ReadLockDescriptor(const ShmemSection& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(const CrossProcessSemaphoreDescriptor& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(const uintptr_t& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(const null_t& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(const ReadLockDescriptor& aOther);

    ~ReadLockDescriptor();

    Type
    type() const
    {
        return mType;
    }

    ReadLockDescriptor&
    operator=(const ShmemSection& aRhs);

    ReadLockDescriptor&
    operator=(const CrossProcessSemaphoreDescriptor& aRhs);

    ReadLockDescriptor&
    operator=(const uintptr_t& aRhs);

    ReadLockDescriptor&
    operator=(const null_t& aRhs);

    ReadLockDescriptor&
    operator=(const ReadLockDescriptor& aRhs);

    bool
    operator==(const ShmemSection& aRhs) const;

    bool
    operator==(const CrossProcessSemaphoreDescriptor& aRhs) const;

    bool
    operator==(const uintptr_t& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const ReadLockDescriptor& aRhs) const;

    ShmemSection&
    get_ShmemSection()
    {
        AssertSanity(TShmemSection);
        return (*(ptr_ShmemSection()));
    }
    const ShmemSection&
    get_ShmemSection() const
    {
        AssertSanity(TShmemSection);
        return (*(constptr_ShmemSection()));
    }
    void
    get(ShmemSection* aOutValue) const;
    operator ShmemSection&()
    {
        return get_ShmemSection();
    }
    operator const ShmemSection&() const
    {
        return get_ShmemSection();
    }

    CrossProcessSemaphoreDescriptor&
    get_CrossProcessSemaphoreDescriptor()
    {
        AssertSanity(TCrossProcessSemaphoreDescriptor);
        return (*(ptr_CrossProcessSemaphoreDescriptor()));
    }
    const CrossProcessSemaphoreDescriptor&
    get_CrossProcessSemaphoreDescriptor() const
    {
        AssertSanity(TCrossProcessSemaphoreDescriptor);
        return (*(constptr_CrossProcessSemaphoreDescriptor()));
    }
    void
    get(CrossProcessSemaphoreDescriptor* aOutValue) const;
    operator CrossProcessSemaphoreDescriptor&()
    {
        return get_CrossProcessSemaphoreDescriptor();
    }
    operator const CrossProcessSemaphoreDescriptor&() const
    {
        return get_CrossProcessSemaphoreDescriptor();
    }

    uintptr_t&
    get_uintptr_t()
    {
        AssertSanity(Tuintptr_t);
        return (*(ptr_uintptr_t()));
    }
    const uintptr_t&
    get_uintptr_t() const
    {
        AssertSanity(Tuintptr_t);
        return (*(constptr_uintptr_t()));
    }
    void
    get(uintptr_t* aOutValue) const;
    operator uintptr_t&()
    {
        return get_uintptr_t();
    }
    operator const uintptr_t&() const
    {
        return get_uintptr_t();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class ReadLockDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ReadLockInit|
//
namespace mozilla {
namespace layers {
class ReadLockInit final
{
private:
    typedef mozilla::layers::ReadLockDescriptor ReadLockDescriptor;
    typedef mozilla::layers::ReadLockHandle ReadLockHandle;

public:
    MOZ_IMPLICIT ReadLockInit();

    MOZ_IMPLICIT ReadLockInit(
            const ReadLockDescriptor& _sharedLock,
            const ReadLockHandle& _handle)
    {
        Init();
        Assign(_sharedLock, _handle);
    }

    MOZ_IMPLICIT ReadLockInit(const ReadLockInit& _o)
    {
        Init();
        Assign((_o).sharedLock(), (_o).handle());
    }

    ~ReadLockInit();

    void
    operator=(const ReadLockInit& _o)
    {
        Assign((_o).sharedLock(), (_o).handle());
    }

    bool
    operator==(const ReadLockInit& _o) const;

    bool
    operator!=(const ReadLockInit& _o) const;

    ReadLockDescriptor&
    sharedLock()
    {
        return sharedLock_;
    }
    const ReadLockDescriptor&
    sharedLock() const
    {
        return sharedLock_;
    }

    ReadLockHandle&
    handle()
    {
        return handle_;
    }
    const ReadLockHandle&
    handle() const
    {
        return handle_;
    }

private:
    void
    Init();

    void
    Assign(
            const ReadLockDescriptor& _sharedLock,
            const ReadLockHandle& _handle);

    ReadLockDescriptor sharedLock_;
    ReadLockHandle handle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeTexture|
//
namespace mozilla {
namespace layers {
class MaybeTexture final
{
public:
    enum Type {
        T__None,
        TPTextureParent = 1,
        TPTextureChild,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::null_t null_t;
    typedef PTextureParent* PTextureParent__tdef;
    typedef PTextureChild* PTextureChild__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<PTextureParent*> VPTextureParent;
        mozilla::AlignedStorage2<PTextureChild*> VPTextureChild;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    PTextureParent**
    ptr_PTextureParent()
    {
        return ((mValue).VPTextureParent).addr();
    }
    PTextureParent* const*
    constptr_PTextureParent() const
    {
        return ((mValue).VPTextureParent).addr();
    }
    PTextureChild**
    ptr_PTextureChild()
    {
        return ((mValue).VPTextureChild).addr();
    }
    PTextureChild* const*
    constptr_PTextureChild() const
    {
        return ((mValue).VPTextureChild).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeTexture() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeTexture(PTextureParent* aOther);

    MOZ_IMPLICIT MaybeTexture(PTextureChild* aOther);

    MOZ_IMPLICIT MaybeTexture(const null_t& aOther);

    MOZ_IMPLICIT MaybeTexture(const MaybeTexture& aOther);

    ~MaybeTexture();

    Type
    type() const
    {
        return mType;
    }

    MaybeTexture&
    operator=(PTextureParent* aRhs);

    MaybeTexture&
    operator=(PTextureChild* aRhs);

    MaybeTexture&
    operator=(const null_t& aRhs);

    MaybeTexture&
    operator=(const MaybeTexture& aRhs);

    bool
    operator==(PTextureParent* aRhs) const;

    bool
    operator==(PTextureChild* aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeTexture& aRhs) const;

    PTextureParent*&
    get_PTextureParent()
    {
        AssertSanity(TPTextureParent);
        return (*(ptr_PTextureParent()));
    }
    PTextureParent*
    get_PTextureParent() const
    {
        AssertSanity(TPTextureParent);
        return (*(constptr_PTextureParent()));
    }
    void
    get(PTextureParent** aOutValue) const;
    operator PTextureParent*&()
    {
        return get_PTextureParent();
    }
    operator PTextureParent*() const
    {
        return get_PTextureParent();
    }

    PTextureChild*&
    get_PTextureChild()
    {
        AssertSanity(TPTextureChild);
        return (*(ptr_PTextureChild()));
    }
    PTextureChild*
    get_PTextureChild() const
    {
        AssertSanity(TPTextureChild);
        return (*(constptr_PTextureChild()));
    }
    void
    get(PTextureChild** aOutValue) const;
    operator PTextureChild*&()
    {
        return get_PTextureChild();
    }
    operator PTextureChild*() const
    {
        return get_PTextureChild();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class MaybeTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ReadLockDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TexturedTileDescriptor|
//
namespace mozilla {
namespace layers {
class TexturedTileDescriptor final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::MaybeTexture MaybeTexture;
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::layers::ReadLockDescriptor ReadLockDescriptor;

public:
    MOZ_IMPLICIT TexturedTileDescriptor();

    MOZ_IMPLICIT TexturedTileDescriptor(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const MaybeTexture& _textureOnWhite,
            const IntRect& _updateRect,
            const ReadLockDescriptor& _sharedLock,
            const ReadLockDescriptor& _sharedLockOnWhite,
            const bool& _wasPlaceholder)
    {
        Init();
        Assign(_textureParent, _textureChild, _textureOnWhite, _updateRect, _sharedLock, _sharedLockOnWhite, _wasPlaceholder);
    }

    MOZ_IMPLICIT TexturedTileDescriptor(const TexturedTileDescriptor& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).textureOnWhite(), (_o).updateRect(), (_o).sharedLock(), (_o).sharedLockOnWhite(), (_o).wasPlaceholder());
    }

    ~TexturedTileDescriptor();

    void
    operator=(const TexturedTileDescriptor& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).textureOnWhite(), (_o).updateRect(), (_o).sharedLock(), (_o).sharedLockOnWhite(), (_o).wasPlaceholder());
    }

    bool
    operator==(const TexturedTileDescriptor& _o) const;

    bool
    operator!=(const TexturedTileDescriptor& _o) const;

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    MaybeTexture&
    textureOnWhite()
    {
        return textureOnWhite_;
    }
    const MaybeTexture&
    textureOnWhite() const
    {
        return textureOnWhite_;
    }

    IntRect&
    updateRect()
    {
        return updateRect_;
    }
    const IntRect&
    updateRect() const
    {
        return updateRect_;
    }

    ReadLockDescriptor&
    sharedLock()
    {
        return sharedLock_;
    }
    const ReadLockDescriptor&
    sharedLock() const
    {
        return sharedLock_;
    }

    ReadLockDescriptor&
    sharedLockOnWhite()
    {
        return sharedLockOnWhite_;
    }
    const ReadLockDescriptor&
    sharedLockOnWhite() const
    {
        return sharedLockOnWhite_;
    }

    bool&
    wasPlaceholder()
    {
        return wasPlaceholder_;
    }
    const bool&
    wasPlaceholder() const
    {
        return wasPlaceholder_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const MaybeTexture& _textureOnWhite,
            const IntRect& _updateRect,
            const ReadLockDescriptor& _sharedLock,
            const ReadLockDescriptor& _sharedLockOnWhite,
            const bool& _wasPlaceholder);

    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    MaybeTexture textureOnWhite_;
    IntRect updateRect_;
    ReadLockDescriptor sharedLock_;
    ReadLockDescriptor sharedLockOnWhite_;
    bool wasPlaceholder_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PlaceholderTileDescriptor|
//
namespace mozilla {
namespace layers {
class PlaceholderTileDescriptor final
{
private:

public:
    MOZ_IMPLICIT PlaceholderTileDescriptor()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT PlaceholderTileDescriptor(const PlaceholderTileDescriptor& _o)
    {
        Init();
        Assign();
    }

    ~PlaceholderTileDescriptor();

    void
    operator=(const PlaceholderTileDescriptor& _o)
    {
        Assign();
    }

    bool
    operator==(const PlaceholderTileDescriptor& _o) const;

    bool
    operator!=(const PlaceholderTileDescriptor& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TexturedTileDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PlaceholderTileDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TileDescriptor|
//
namespace mozilla {
namespace layers {
class TileDescriptor final
{
public:
    enum Type {
        T__None,
        TTexturedTileDescriptor = 1,
        TPlaceholderTileDescriptor,
        T__Last = TPlaceholderTileDescriptor
    };

private:
    typedef mozilla::layers::TexturedTileDescriptor TexturedTileDescriptor;
    typedef mozilla::layers::PlaceholderTileDescriptor PlaceholderTileDescriptor;
    typedef TexturedTileDescriptor TexturedTileDescriptor__tdef;
    typedef PlaceholderTileDescriptor PlaceholderTileDescriptor__tdef;

    union Value {
        mozilla::AlignedStorage2<TexturedTileDescriptor> VTexturedTileDescriptor;
        mozilla::AlignedStorage2<PlaceholderTileDescriptor> VPlaceholderTileDescriptor;
    };

    TexturedTileDescriptor*
    ptr_TexturedTileDescriptor()
    {
        return ((mValue).VTexturedTileDescriptor).addr();
    }
    const TexturedTileDescriptor*
    constptr_TexturedTileDescriptor() const
    {
        return ((mValue).VTexturedTileDescriptor).addr();
    }
    PlaceholderTileDescriptor*
    ptr_PlaceholderTileDescriptor()
    {
        return ((mValue).VPlaceholderTileDescriptor).addr();
    }
    const PlaceholderTileDescriptor*
    constptr_PlaceholderTileDescriptor() const
    {
        return ((mValue).VPlaceholderTileDescriptor).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TileDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TileDescriptor(const TexturedTileDescriptor& aOther);

    MOZ_IMPLICIT TileDescriptor(const PlaceholderTileDescriptor& aOther);

    MOZ_IMPLICIT TileDescriptor(const TileDescriptor& aOther);

    ~TileDescriptor();

    Type
    type() const
    {
        return mType;
    }

    TileDescriptor&
    operator=(const TexturedTileDescriptor& aRhs);

    TileDescriptor&
    operator=(const PlaceholderTileDescriptor& aRhs);

    TileDescriptor&
    operator=(const TileDescriptor& aRhs);

    bool
    operator==(const TexturedTileDescriptor& aRhs) const;

    bool
    operator==(const PlaceholderTileDescriptor& aRhs) const;

    bool
    operator==(const TileDescriptor& aRhs) const;

    TexturedTileDescriptor&
    get_TexturedTileDescriptor()
    {
        AssertSanity(TTexturedTileDescriptor);
        return (*(ptr_TexturedTileDescriptor()));
    }
    const TexturedTileDescriptor&
    get_TexturedTileDescriptor() const
    {
        AssertSanity(TTexturedTileDescriptor);
        return (*(constptr_TexturedTileDescriptor()));
    }
    void
    get(TexturedTileDescriptor* aOutValue) const;
    operator TexturedTileDescriptor&()
    {
        return get_TexturedTileDescriptor();
    }
    operator const TexturedTileDescriptor&() const
    {
        return get_TexturedTileDescriptor();
    }

    PlaceholderTileDescriptor&
    get_PlaceholderTileDescriptor()
    {
        AssertSanity(TPlaceholderTileDescriptor);
        return (*(ptr_PlaceholderTileDescriptor()));
    }
    const PlaceholderTileDescriptor&
    get_PlaceholderTileDescriptor() const
    {
        AssertSanity(TPlaceholderTileDescriptor);
        return (*(constptr_PlaceholderTileDescriptor()));
    }
    void
    get(PlaceholderTileDescriptor* aOutValue) const;
    operator PlaceholderTileDescriptor&()
    {
        return get_PlaceholderTileDescriptor();
    }
    operator const PlaceholderTileDescriptor&() const
    {
        return get_PlaceholderTileDescriptor();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TileDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorTiles|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorTiles final
{
private:
    typedef mozilla::layers::TileDescriptor TileDescriptor;
    typedef mozilla::gfx::IntPoint IntPoint;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorTiles();

    MOZ_IMPLICIT SurfaceDescriptorTiles(
            const nsIntRegion& _validRegion,
            const nsTArray<TileDescriptor>& _tiles,
            const IntPoint& _tileOrigin,
            const IntSize& _tileSize,
            const int& _firstTileX,
            const int& _firstTileY,
            const int& _retainedWidth,
            const int& _retainedHeight,
            const float& _resolution,
            const float& _frameXResolution,
            const float& _frameYResolution,
            const bool& _isProgressive)
    {
        Init();
        Assign(_validRegion, _tiles, _tileOrigin, _tileSize, _firstTileX, _firstTileY, _retainedWidth, _retainedHeight, _resolution, _frameXResolution, _frameYResolution, _isProgressive);
    }

    MOZ_IMPLICIT SurfaceDescriptorTiles(const SurfaceDescriptorTiles& _o)
    {
        Init();
        Assign((_o).validRegion(), (_o).tiles(), (_o).tileOrigin(), (_o).tileSize(), (_o).firstTileX(), (_o).firstTileY(), (_o).retainedWidth(), (_o).retainedHeight(), (_o).resolution(), (_o).frameXResolution(), (_o).frameYResolution(), (_o).isProgressive());
    }

    ~SurfaceDescriptorTiles();

    void
    operator=(const SurfaceDescriptorTiles& _o)
    {
        Assign((_o).validRegion(), (_o).tiles(), (_o).tileOrigin(), (_o).tileSize(), (_o).firstTileX(), (_o).firstTileY(), (_o).retainedWidth(), (_o).retainedHeight(), (_o).resolution(), (_o).frameXResolution(), (_o).frameYResolution(), (_o).isProgressive());
    }

    bool
    operator==(const SurfaceDescriptorTiles& _o) const;

    bool
    operator!=(const SurfaceDescriptorTiles& _o) const;

    nsIntRegion&
    validRegion()
    {
        return validRegion_;
    }
    const nsIntRegion&
    validRegion() const
    {
        return validRegion_;
    }

    nsTArray<TileDescriptor>&
    tiles()
    {
        return tiles_;
    }
    const nsTArray<TileDescriptor>&
    tiles() const
    {
        return tiles_;
    }

    IntPoint&
    tileOrigin()
    {
        return tileOrigin_;
    }
    const IntPoint&
    tileOrigin() const
    {
        return tileOrigin_;
    }

    IntSize&
    tileSize()
    {
        return tileSize_;
    }
    const IntSize&
    tileSize() const
    {
        return tileSize_;
    }

    int&
    firstTileX()
    {
        return firstTileX_;
    }
    const int&
    firstTileX() const
    {
        return firstTileX_;
    }

    int&
    firstTileY()
    {
        return firstTileY_;
    }
    const int&
    firstTileY() const
    {
        return firstTileY_;
    }

    int&
    retainedWidth()
    {
        return retainedWidth_;
    }
    const int&
    retainedWidth() const
    {
        return retainedWidth_;
    }

    int&
    retainedHeight()
    {
        return retainedHeight_;
    }
    const int&
    retainedHeight() const
    {
        return retainedHeight_;
    }

    float&
    resolution()
    {
        return resolution_;
    }
    const float&
    resolution() const
    {
        return resolution_;
    }

    float&
    frameXResolution()
    {
        return frameXResolution_;
    }
    const float&
    frameXResolution() const
    {
        return frameXResolution_;
    }

    float&
    frameYResolution()
    {
        return frameYResolution_;
    }
    const float&
    frameYResolution() const
    {
        return frameYResolution_;
    }

    bool&
    isProgressive()
    {
        return isProgressive_;
    }
    const bool&
    isProgressive() const
    {
        return isProgressive_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsIntRegion& _validRegion,
            const nsTArray<TileDescriptor>& _tiles,
            const IntPoint& _tileOrigin,
            const IntSize& _tileSize,
            const int& _firstTileX,
            const int& _firstTileY,
            const int& _retainedWidth,
            const int& _retainedHeight,
            const float& _resolution,
            const float& _frameXResolution,
            const float& _frameYResolution,
            const bool& _isProgressive);

    nsIntRegion validRegion_;
    nsTArray<TileDescriptor> tiles_;
    IntPoint tileOrigin_;
    IntSize tileSize_;
    int firstTileX_;
    int firstTileY_;
    int retainedWidth_;
    int retainedHeight_;
    float resolution_;
    float frameXResolution_;
    float frameYResolution_;
    bool isProgressive_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class SurfaceDescriptorTiles;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseTiledLayerBuffer|
//
namespace mozilla {
namespace layers {
class OpUseTiledLayerBuffer final
{
private:
    typedef mozilla::layers::SurfaceDescriptorTiles SurfaceDescriptorTiles;

public:
    MOZ_IMPLICIT OpUseTiledLayerBuffer();

    MOZ_IMPLICIT OpUseTiledLayerBuffer(const SurfaceDescriptorTiles& _tileLayerDescriptor)
    {
        Init();
        Assign(_tileLayerDescriptor);
    }

    MOZ_IMPLICIT OpUseTiledLayerBuffer(const OpUseTiledLayerBuffer& _o)
    {
        Init();
        Assign((_o).tileLayerDescriptor());
    }

    ~OpUseTiledLayerBuffer();

    void
    operator=(const OpUseTiledLayerBuffer& _o)
    {
        Assign((_o).tileLayerDescriptor());
    }

    bool
    operator==(const OpUseTiledLayerBuffer& _o) const;

    bool
    operator!=(const OpUseTiledLayerBuffer& _o) const;

    SurfaceDescriptorTiles&
    tileLayerDescriptor()
    {
        return tileLayerDescriptor_;
    }
    const SurfaceDescriptorTiles&
    tileLayerDescriptor() const
    {
        return tileLayerDescriptor_;
    }

private:
    void
    Init();

    void
    Assign(const SurfaceDescriptorTiles& _tileLayerDescriptor);

    SurfaceDescriptorTiles tileLayerDescriptor_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class ThebesBufferData;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpPaintTextureRegion|
//
namespace mozilla {
namespace layers {
class OpPaintTextureRegion final
{
private:
    typedef mozilla::layers::ThebesBufferData ThebesBufferData;

public:
    MOZ_IMPLICIT OpPaintTextureRegion();

    MOZ_IMPLICIT OpPaintTextureRegion(
            const ThebesBufferData& _bufferData,
            const nsIntRegion& _updatedRegion)
    {
        Init();
        Assign(_bufferData, _updatedRegion);
    }

    MOZ_IMPLICIT OpPaintTextureRegion(const OpPaintTextureRegion& _o)
    {
        Init();
        Assign((_o).bufferData(), (_o).updatedRegion());
    }

    ~OpPaintTextureRegion();

    void
    operator=(const OpPaintTextureRegion& _o)
    {
        Assign((_o).bufferData(), (_o).updatedRegion());
    }

    bool
    operator==(const OpPaintTextureRegion& _o) const;

    bool
    operator!=(const OpPaintTextureRegion& _o) const;

    ThebesBufferData&
    bufferData()
    {
        return bufferData_;
    }
    const ThebesBufferData&
    bufferData() const
    {
        return bufferData_;
    }

    nsIntRegion&
    updatedRegion()
    {
        return updatedRegion_;
    }
    const nsIntRegion&
    updatedRegion() const
    {
        return updatedRegion_;
    }

private:
    void
    Init();

    void
    Assign(
            const ThebesBufferData& _bufferData,
            const nsIntRegion& _updatedRegion);

    ThebesBufferData bufferData_;
    nsIntRegion updatedRegion_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRemoveTexture|
//
namespace mozilla {
namespace layers {
class OpRemoveTexture final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;

public:
    MOZ_IMPLICIT OpRemoveTexture();

    MOZ_IMPLICIT OpRemoveTexture(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild)
    {
        Init();
        Assign(_textureParent, _textureChild);
    }

    MOZ_IMPLICIT OpRemoveTexture(const OpRemoveTexture& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()));
    }

    ~OpRemoveTexture();

    void
    operator=(const OpRemoveTexture& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()));
    }

    bool
    operator==(const OpRemoveTexture& _o) const;

    bool
    operator!=(const OpRemoveTexture& _o) const;

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild);

    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TimedTexture|
//
namespace mozilla {
namespace layers {
class TimedTexture final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::ReadLockHandle ReadLockHandle;
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT TimedTexture();

    MOZ_IMPLICIT TimedTexture(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const ReadLockHandle& _sharedLock,
            const TimeStamp& _timeStamp,
            const IntRect& _picture,
            const uint32_t& _frameID,
            const uint32_t& _producerID)
    {
        Init();
        Assign(_textureParent, _textureChild, _sharedLock, _timeStamp, _picture, _frameID, _producerID);
    }

    MOZ_IMPLICIT TimedTexture(const TimedTexture& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).sharedLock(), (_o).timeStamp(), (_o).picture(), (_o).frameID(), (_o).producerID());
    }

    ~TimedTexture();

    void
    operator=(const TimedTexture& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).sharedLock(), (_o).timeStamp(), (_o).picture(), (_o).frameID(), (_o).producerID());
    }

    bool
    operator==(const TimedTexture& _o) const;

    bool
    operator!=(const TimedTexture& _o) const;

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    ReadLockHandle&
    sharedLock()
    {
        return sharedLock_;
    }
    const ReadLockHandle&
    sharedLock() const
    {
        return sharedLock_;
    }

    TimeStamp&
    timeStamp()
    {
        return timeStamp_;
    }
    const TimeStamp&
    timeStamp() const
    {
        return timeStamp_;
    }

    IntRect&
    picture()
    {
        return picture_;
    }
    const IntRect&
    picture() const
    {
        return picture_;
    }

    uint32_t&
    frameID()
    {
        return frameID_;
    }
    const uint32_t&
    frameID() const
    {
        return frameID_;
    }

    uint32_t&
    producerID()
    {
        return producerID_;
    }
    const uint32_t&
    producerID() const
    {
        return producerID_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const ReadLockHandle& _sharedLock,
            const TimeStamp& _timeStamp,
            const IntRect& _picture,
            const uint32_t& _frameID,
            const uint32_t& _producerID);

    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    ReadLockHandle sharedLock_;
    TimeStamp timeStamp_;
    IntRect picture_;
    uint32_t frameID_;
    uint32_t producerID_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TimedTexture;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseTexture|
//
namespace mozilla {
namespace layers {
class OpUseTexture final
{
private:
    typedef mozilla::layers::TimedTexture TimedTexture;

public:
    MOZ_IMPLICIT OpUseTexture();

    MOZ_IMPLICIT OpUseTexture(const nsTArray<TimedTexture>& _textures)
    {
        Init();
        Assign(_textures);
    }

    MOZ_IMPLICIT OpUseTexture(const OpUseTexture& _o)
    {
        Init();
        Assign((_o).textures());
    }

    ~OpUseTexture();

    void
    operator=(const OpUseTexture& _o)
    {
        Assign((_o).textures());
    }

    bool
    operator==(const OpUseTexture& _o) const;

    bool
    operator!=(const OpUseTexture& _o) const;

    nsTArray<TimedTexture>&
    textures()
    {
        return textures_;
    }
    const nsTArray<TimedTexture>&
    textures() const
    {
        return textures_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<TimedTexture>& _textures);

    nsTArray<TimedTexture> textures_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseComponentAlphaTextures|
//
namespace mozilla {
namespace layers {
class OpUseComponentAlphaTextures final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::ReadLockHandle ReadLockHandle;

public:
    MOZ_IMPLICIT OpUseComponentAlphaTextures();

    MOZ_IMPLICIT OpUseComponentAlphaTextures(
            PTextureParent* _textureOnBlackParent,
            PTextureChild* _textureOnBlackChild,
            PTextureParent* _textureOnWhiteParent,
            PTextureChild* _textureOnWhiteChild,
            const ReadLockHandle& _sharedLockBlack,
            const ReadLockHandle& _sharedLockWhite)
    {
        Init();
        Assign(_textureOnBlackParent, _textureOnBlackChild, _textureOnWhiteParent, _textureOnWhiteChild, _sharedLockBlack, _sharedLockWhite);
    }

    MOZ_IMPLICIT OpUseComponentAlphaTextures(const OpUseComponentAlphaTextures& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureOnBlackParent()), const_cast<PTextureChild*>((_o).textureOnBlackChild()), const_cast<PTextureParent*>((_o).textureOnWhiteParent()), const_cast<PTextureChild*>((_o).textureOnWhiteChild()), (_o).sharedLockBlack(), (_o).sharedLockWhite());
    }

    ~OpUseComponentAlphaTextures();

    void
    operator=(const OpUseComponentAlphaTextures& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureOnBlackParent()), const_cast<PTextureChild*>((_o).textureOnBlackChild()), const_cast<PTextureParent*>((_o).textureOnWhiteParent()), const_cast<PTextureChild*>((_o).textureOnWhiteChild()), (_o).sharedLockBlack(), (_o).sharedLockWhite());
    }

    bool
    operator==(const OpUseComponentAlphaTextures& _o) const;

    bool
    operator!=(const OpUseComponentAlphaTextures& _o) const;

    PTextureParent*&
    textureOnBlackParent()
    {
        return textureOnBlackParent_;
    }
    PTextureParent*
    textureOnBlackParent() const
    {
        return textureOnBlackParent_;
    }

    PTextureChild*&
    textureOnBlackChild()
    {
        return textureOnBlackChild_;
    }
    PTextureChild*
    textureOnBlackChild() const
    {
        return textureOnBlackChild_;
    }

    PTextureParent*&
    textureOnWhiteParent()
    {
        return textureOnWhiteParent_;
    }
    PTextureParent*
    textureOnWhiteParent() const
    {
        return textureOnWhiteParent_;
    }

    PTextureChild*&
    textureOnWhiteChild()
    {
        return textureOnWhiteChild_;
    }
    PTextureChild*
    textureOnWhiteChild() const
    {
        return textureOnWhiteChild_;
    }

    ReadLockHandle&
    sharedLockBlack()
    {
        return sharedLockBlack_;
    }
    const ReadLockHandle&
    sharedLockBlack() const
    {
        return sharedLockBlack_;
    }

    ReadLockHandle&
    sharedLockWhite()
    {
        return sharedLockWhite_;
    }
    const ReadLockHandle&
    sharedLockWhite() const
    {
        return sharedLockWhite_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureOnBlackParent,
            PTextureChild* _textureOnBlackChild,
            PTextureParent* _textureOnWhiteParent,
            PTextureChild* _textureOnWhiteChild,
            const ReadLockHandle& _sharedLockBlack,
            const ReadLockHandle& _sharedLockWhite);

    PTextureParent* textureOnBlackParent_;
    PTextureChild* textureOnBlackChild_;
    PTextureParent* textureOnWhiteParent_;
    PTextureChild* textureOnWhiteChild_;
    ReadLockHandle sharedLockBlack_;
    ReadLockHandle sharedLockWhite_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeRegion|
//
namespace mozilla {
namespace layers {
class MaybeRegion final
{
public:
    enum Type {
        T__None,
        TnsIntRegion = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::null_t null_t;
    typedef nsIntRegion nsIntRegion__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<nsIntRegion> VnsIntRegion;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    nsIntRegion*
    ptr_nsIntRegion()
    {
        return ((mValue).VnsIntRegion).addr();
    }
    const nsIntRegion*
    constptr_nsIntRegion() const
    {
        return ((mValue).VnsIntRegion).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeRegion() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeRegion(const nsIntRegion& aOther);

    MOZ_IMPLICIT MaybeRegion(const null_t& aOther);

    MOZ_IMPLICIT MaybeRegion(const MaybeRegion& aOther);

    ~MaybeRegion();

    Type
    type() const
    {
        return mType;
    }

    MaybeRegion&
    operator=(const nsIntRegion& aRhs);

    MaybeRegion&
    operator=(const null_t& aRhs);

    MaybeRegion&
    operator=(const MaybeRegion& aRhs);

    bool
    operator==(const nsIntRegion& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeRegion& aRhs) const;

    nsIntRegion&
    get_nsIntRegion()
    {
        AssertSanity(TnsIntRegion);
        return (*(ptr_nsIntRegion()));
    }
    const nsIntRegion&
    get_nsIntRegion() const
    {
        AssertSanity(TnsIntRegion);
        return (*(constptr_nsIntRegion()));
    }
    void
    get(nsIntRegion* aOutValue) const;
    operator nsIntRegion&()
    {
        return get_nsIntRegion();
    }
    operator const nsIntRegion&() const
    {
        return get_nsIntRegion();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpNotifyNotUsed|
//
namespace mozilla {
namespace layers {
class OpNotifyNotUsed final
{
private:

public:
    MOZ_IMPLICIT OpNotifyNotUsed();

    MOZ_IMPLICIT OpNotifyNotUsed(
            const uint64_t& _TextureId,
            const uint64_t& _fwdTransactionId)
    {
        Init();
        Assign(_TextureId, _fwdTransactionId);
    }

    MOZ_IMPLICIT OpNotifyNotUsed(const OpNotifyNotUsed& _o)
    {
        Init();
        Assign((_o).TextureId(), (_o).fwdTransactionId());
    }

    ~OpNotifyNotUsed();

    void
    operator=(const OpNotifyNotUsed& _o)
    {
        Assign((_o).TextureId(), (_o).fwdTransactionId());
    }

    bool
    operator==(const OpNotifyNotUsed& _o) const;

    bool
    operator!=(const OpNotifyNotUsed& _o) const;

    uint64_t&
    TextureId()
    {
        return TextureId_;
    }
    const uint64_t&
    TextureId() const
    {
        return TextureId_;
    }

    uint64_t&
    fwdTransactionId()
    {
        return fwdTransactionId_;
    }
    const uint64_t&
    fwdTransactionId() const
    {
        return fwdTransactionId_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _TextureId,
            const uint64_t& _fwdTransactionId);

    uint64_t TextureId_;
    uint64_t fwdTransactionId_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpPaintTextureRegion;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseTiledLayerBuffer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRemoveTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseComponentAlphaTextures;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union CompositableOperationDetail|
//
namespace mozilla {
namespace layers {
class CompositableOperationDetail final
{
public:
    enum Type {
        T__None,
        TOpPaintTextureRegion = 1,
        TOpUseTiledLayerBuffer,
        TOpRemoveTexture,
        TOpUseTexture,
        TOpUseComponentAlphaTextures,
        T__Last = TOpUseComponentAlphaTextures
    };

private:
    typedef mozilla::layers::OpPaintTextureRegion OpPaintTextureRegion;
    typedef mozilla::layers::OpUseTiledLayerBuffer OpUseTiledLayerBuffer;
    typedef mozilla::layers::OpRemoveTexture OpRemoveTexture;
    typedef mozilla::layers::OpUseTexture OpUseTexture;
    typedef mozilla::layers::OpUseComponentAlphaTextures OpUseComponentAlphaTextures;
    typedef OpPaintTextureRegion OpPaintTextureRegion__tdef;
    typedef OpUseTiledLayerBuffer OpUseTiledLayerBuffer__tdef;
    typedef OpRemoveTexture OpRemoveTexture__tdef;
    typedef OpUseTexture OpUseTexture__tdef;
    typedef OpUseComponentAlphaTextures OpUseComponentAlphaTextures__tdef;

    union Value {
        mozilla::AlignedStorage2<OpPaintTextureRegion> VOpPaintTextureRegion;
        mozilla::AlignedStorage2<OpUseTiledLayerBuffer> VOpUseTiledLayerBuffer;
        mozilla::AlignedStorage2<OpRemoveTexture> VOpRemoveTexture;
        mozilla::AlignedStorage2<OpUseTexture> VOpUseTexture;
        mozilla::AlignedStorage2<OpUseComponentAlphaTextures> VOpUseComponentAlphaTextures;
    };

    OpPaintTextureRegion*
    ptr_OpPaintTextureRegion()
    {
        return ((mValue).VOpPaintTextureRegion).addr();
    }
    const OpPaintTextureRegion*
    constptr_OpPaintTextureRegion() const
    {
        return ((mValue).VOpPaintTextureRegion).addr();
    }
    OpUseTiledLayerBuffer*
    ptr_OpUseTiledLayerBuffer()
    {
        return ((mValue).VOpUseTiledLayerBuffer).addr();
    }
    const OpUseTiledLayerBuffer*
    constptr_OpUseTiledLayerBuffer() const
    {
        return ((mValue).VOpUseTiledLayerBuffer).addr();
    }
    OpRemoveTexture*
    ptr_OpRemoveTexture()
    {
        return ((mValue).VOpRemoveTexture).addr();
    }
    const OpRemoveTexture*
    constptr_OpRemoveTexture() const
    {
        return ((mValue).VOpRemoveTexture).addr();
    }
    OpUseTexture*
    ptr_OpUseTexture()
    {
        return ((mValue).VOpUseTexture).addr();
    }
    const OpUseTexture*
    constptr_OpUseTexture() const
    {
        return ((mValue).VOpUseTexture).addr();
    }
    OpUseComponentAlphaTextures*
    ptr_OpUseComponentAlphaTextures()
    {
        return ((mValue).VOpUseComponentAlphaTextures).addr();
    }
    const OpUseComponentAlphaTextures*
    constptr_OpUseComponentAlphaTextures() const
    {
        return ((mValue).VOpUseComponentAlphaTextures).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT CompositableOperationDetail() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT CompositableOperationDetail(const OpPaintTextureRegion& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const OpUseTiledLayerBuffer& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const OpRemoveTexture& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const OpUseTexture& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const OpUseComponentAlphaTextures& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const CompositableOperationDetail& aOther);

    ~CompositableOperationDetail();

    Type
    type() const
    {
        return mType;
    }

    CompositableOperationDetail&
    operator=(const OpPaintTextureRegion& aRhs);

    CompositableOperationDetail&
    operator=(const OpUseTiledLayerBuffer& aRhs);

    CompositableOperationDetail&
    operator=(const OpRemoveTexture& aRhs);

    CompositableOperationDetail&
    operator=(const OpUseTexture& aRhs);

    CompositableOperationDetail&
    operator=(const OpUseComponentAlphaTextures& aRhs);

    CompositableOperationDetail&
    operator=(const CompositableOperationDetail& aRhs);

    bool
    operator==(const OpPaintTextureRegion& aRhs) const;

    bool
    operator==(const OpUseTiledLayerBuffer& aRhs) const;

    bool
    operator==(const OpRemoveTexture& aRhs) const;

    bool
    operator==(const OpUseTexture& aRhs) const;

    bool
    operator==(const OpUseComponentAlphaTextures& aRhs) const;

    bool
    operator==(const CompositableOperationDetail& aRhs) const;

    OpPaintTextureRegion&
    get_OpPaintTextureRegion()
    {
        AssertSanity(TOpPaintTextureRegion);
        return (*(ptr_OpPaintTextureRegion()));
    }
    const OpPaintTextureRegion&
    get_OpPaintTextureRegion() const
    {
        AssertSanity(TOpPaintTextureRegion);
        return (*(constptr_OpPaintTextureRegion()));
    }
    void
    get(OpPaintTextureRegion* aOutValue) const;
    operator OpPaintTextureRegion&()
    {
        return get_OpPaintTextureRegion();
    }
    operator const OpPaintTextureRegion&() const
    {
        return get_OpPaintTextureRegion();
    }

    OpUseTiledLayerBuffer&
    get_OpUseTiledLayerBuffer()
    {
        AssertSanity(TOpUseTiledLayerBuffer);
        return (*(ptr_OpUseTiledLayerBuffer()));
    }
    const OpUseTiledLayerBuffer&
    get_OpUseTiledLayerBuffer() const
    {
        AssertSanity(TOpUseTiledLayerBuffer);
        return (*(constptr_OpUseTiledLayerBuffer()));
    }
    void
    get(OpUseTiledLayerBuffer* aOutValue) const;
    operator OpUseTiledLayerBuffer&()
    {
        return get_OpUseTiledLayerBuffer();
    }
    operator const OpUseTiledLayerBuffer&() const
    {
        return get_OpUseTiledLayerBuffer();
    }

    OpRemoveTexture&
    get_OpRemoveTexture()
    {
        AssertSanity(TOpRemoveTexture);
        return (*(ptr_OpRemoveTexture()));
    }
    const OpRemoveTexture&
    get_OpRemoveTexture() const
    {
        AssertSanity(TOpRemoveTexture);
        return (*(constptr_OpRemoveTexture()));
    }
    void
    get(OpRemoveTexture* aOutValue) const;
    operator OpRemoveTexture&()
    {
        return get_OpRemoveTexture();
    }
    operator const OpRemoveTexture&() const
    {
        return get_OpRemoveTexture();
    }

    OpUseTexture&
    get_OpUseTexture()
    {
        AssertSanity(TOpUseTexture);
        return (*(ptr_OpUseTexture()));
    }
    const OpUseTexture&
    get_OpUseTexture() const
    {
        AssertSanity(TOpUseTexture);
        return (*(constptr_OpUseTexture()));
    }
    void
    get(OpUseTexture* aOutValue) const;
    operator OpUseTexture&()
    {
        return get_OpUseTexture();
    }
    operator const OpUseTexture&() const
    {
        return get_OpUseTexture();
    }

    OpUseComponentAlphaTextures&
    get_OpUseComponentAlphaTextures()
    {
        AssertSanity(TOpUseComponentAlphaTextures);
        return (*(ptr_OpUseComponentAlphaTextures()));
    }
    const OpUseComponentAlphaTextures&
    get_OpUseComponentAlphaTextures() const
    {
        AssertSanity(TOpUseComponentAlphaTextures);
        return (*(constptr_OpUseComponentAlphaTextures()));
    }
    void
    get(OpUseComponentAlphaTextures* aOutValue) const;
    operator OpUseComponentAlphaTextures&()
    {
        return get_OpUseComponentAlphaTextures();
    }
    operator const OpUseComponentAlphaTextures&() const
    {
        return get_OpUseComponentAlphaTextures();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CompositableOperationDetail;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CompositableOperation|
//
namespace mozilla {
namespace layers {
class CompositableOperation final
{
private:
    typedef mozilla::layers::CompositableHandle CompositableHandle;
    typedef mozilla::layers::CompositableOperationDetail CompositableOperationDetail;

public:
    MOZ_IMPLICIT CompositableOperation();

    MOZ_IMPLICIT CompositableOperation(
            const CompositableHandle& _compositable,
            const CompositableOperationDetail& _detail)
    {
        Init();
        Assign(_compositable, _detail);
    }

    MOZ_IMPLICIT CompositableOperation(const CompositableOperation& _o)
    {
        Init();
        Assign((_o).compositable(), (_o).detail());
    }

    ~CompositableOperation();

    void
    operator=(const CompositableOperation& _o)
    {
        Assign((_o).compositable(), (_o).detail());
    }

    bool
    operator==(const CompositableOperation& _o) const;

    bool
    operator!=(const CompositableOperation& _o) const;

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

    CompositableOperationDetail&
    detail()
    {
        return detail_;
    }
    const CompositableOperationDetail&
    detail() const
    {
        return detail_;
    }

private:
    void
    Init();

    void
    Assign(
            const CompositableHandle& _compositable,
            const CompositableOperationDetail& _detail);

    CompositableHandle compositable_;
    CompositableOperationDetail detail_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpCreatePaintedLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateContainerLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateImageLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateColorLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateTextLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateBorderLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateCanvasLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateRefLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetDiagnosticTypes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpWindowOverlayChanged;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetRoot;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpInsertAfter;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpPrependChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRemoveChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRepositionChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRaiseToTopChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAttachCompositable;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAttachAsyncCompositable;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CompositableOperation;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union Edit|
//
namespace mozilla {
namespace layers {
class Edit final
{
public:
    enum Type {
        T__None,
        TOpCreatePaintedLayer = 1,
        TOpCreateContainerLayer,
        TOpCreateImageLayer,
        TOpCreateColorLayer,
        TOpCreateTextLayer,
        TOpCreateBorderLayer,
        TOpCreateCanvasLayer,
        TOpCreateRefLayer,
        TOpSetDiagnosticTypes,
        TOpWindowOverlayChanged,
        TOpSetRoot,
        TOpInsertAfter,
        TOpPrependChild,
        TOpRemoveChild,
        TOpRepositionChild,
        TOpRaiseToTopChild,
        TOpAttachCompositable,
        TOpAttachAsyncCompositable,
        TCompositableOperation,
        T__Last = TCompositableOperation
    };

private:
    typedef mozilla::layers::OpCreatePaintedLayer OpCreatePaintedLayer;
    typedef mozilla::layers::OpCreateContainerLayer OpCreateContainerLayer;
    typedef mozilla::layers::OpCreateImageLayer OpCreateImageLayer;
    typedef mozilla::layers::OpCreateColorLayer OpCreateColorLayer;
    typedef mozilla::layers::OpCreateTextLayer OpCreateTextLayer;
    typedef mozilla::layers::OpCreateBorderLayer OpCreateBorderLayer;
    typedef mozilla::layers::OpCreateCanvasLayer OpCreateCanvasLayer;
    typedef mozilla::layers::OpCreateRefLayer OpCreateRefLayer;
    typedef mozilla::layers::OpSetDiagnosticTypes OpSetDiagnosticTypes;
    typedef mozilla::layers::OpWindowOverlayChanged OpWindowOverlayChanged;
    typedef mozilla::layers::OpSetRoot OpSetRoot;
    typedef mozilla::layers::OpInsertAfter OpInsertAfter;
    typedef mozilla::layers::OpPrependChild OpPrependChild;
    typedef mozilla::layers::OpRemoveChild OpRemoveChild;
    typedef mozilla::layers::OpRepositionChild OpRepositionChild;
    typedef mozilla::layers::OpRaiseToTopChild OpRaiseToTopChild;
    typedef mozilla::layers::OpAttachCompositable OpAttachCompositable;
    typedef mozilla::layers::OpAttachAsyncCompositable OpAttachAsyncCompositable;
    typedef mozilla::layers::CompositableOperation CompositableOperation;
    typedef OpCreatePaintedLayer OpCreatePaintedLayer__tdef;
    typedef OpCreateContainerLayer OpCreateContainerLayer__tdef;
    typedef OpCreateImageLayer OpCreateImageLayer__tdef;
    typedef OpCreateColorLayer OpCreateColorLayer__tdef;
    typedef OpCreateTextLayer OpCreateTextLayer__tdef;
    typedef OpCreateBorderLayer OpCreateBorderLayer__tdef;
    typedef OpCreateCanvasLayer OpCreateCanvasLayer__tdef;
    typedef OpCreateRefLayer OpCreateRefLayer__tdef;
    typedef OpSetDiagnosticTypes OpSetDiagnosticTypes__tdef;
    typedef OpWindowOverlayChanged OpWindowOverlayChanged__tdef;
    typedef OpSetRoot OpSetRoot__tdef;
    typedef OpInsertAfter OpInsertAfter__tdef;
    typedef OpPrependChild OpPrependChild__tdef;
    typedef OpRemoveChild OpRemoveChild__tdef;
    typedef OpRepositionChild OpRepositionChild__tdef;
    typedef OpRaiseToTopChild OpRaiseToTopChild__tdef;
    typedef OpAttachCompositable OpAttachCompositable__tdef;
    typedef OpAttachAsyncCompositable OpAttachAsyncCompositable__tdef;
    typedef CompositableOperation CompositableOperation__tdef;

    union Value {
        mozilla::AlignedStorage2<OpCreatePaintedLayer> VOpCreatePaintedLayer;
        mozilla::AlignedStorage2<OpCreateContainerLayer> VOpCreateContainerLayer;
        mozilla::AlignedStorage2<OpCreateImageLayer> VOpCreateImageLayer;
        mozilla::AlignedStorage2<OpCreateColorLayer> VOpCreateColorLayer;
        mozilla::AlignedStorage2<OpCreateTextLayer> VOpCreateTextLayer;
        mozilla::AlignedStorage2<OpCreateBorderLayer> VOpCreateBorderLayer;
        mozilla::AlignedStorage2<OpCreateCanvasLayer> VOpCreateCanvasLayer;
        mozilla::AlignedStorage2<OpCreateRefLayer> VOpCreateRefLayer;
        mozilla::AlignedStorage2<OpSetDiagnosticTypes> VOpSetDiagnosticTypes;
        mozilla::AlignedStorage2<OpWindowOverlayChanged> VOpWindowOverlayChanged;
        mozilla::AlignedStorage2<OpSetRoot> VOpSetRoot;
        mozilla::AlignedStorage2<OpInsertAfter> VOpInsertAfter;
        mozilla::AlignedStorage2<OpPrependChild> VOpPrependChild;
        mozilla::AlignedStorage2<OpRemoveChild> VOpRemoveChild;
        mozilla::AlignedStorage2<OpRepositionChild> VOpRepositionChild;
        mozilla::AlignedStorage2<OpRaiseToTopChild> VOpRaiseToTopChild;
        mozilla::AlignedStorage2<OpAttachCompositable> VOpAttachCompositable;
        mozilla::AlignedStorage2<OpAttachAsyncCompositable> VOpAttachAsyncCompositable;
        mozilla::AlignedStorage2<CompositableOperation> VCompositableOperation;
    };

    OpCreatePaintedLayer*
    ptr_OpCreatePaintedLayer()
    {
        return ((mValue).VOpCreatePaintedLayer).addr();
    }
    const OpCreatePaintedLayer*
    constptr_OpCreatePaintedLayer() const
    {
        return ((mValue).VOpCreatePaintedLayer).addr();
    }
    OpCreateContainerLayer*
    ptr_OpCreateContainerLayer()
    {
        return ((mValue).VOpCreateContainerLayer).addr();
    }
    const OpCreateContainerLayer*
    constptr_OpCreateContainerLayer() const
    {
        return ((mValue).VOpCreateContainerLayer).addr();
    }
    OpCreateImageLayer*
    ptr_OpCreateImageLayer()
    {
        return ((mValue).VOpCreateImageLayer).addr();
    }
    const OpCreateImageLayer*
    constptr_OpCreateImageLayer() const
    {
        return ((mValue).VOpCreateImageLayer).addr();
    }
    OpCreateColorLayer*
    ptr_OpCreateColorLayer()
    {
        return ((mValue).VOpCreateColorLayer).addr();
    }
    const OpCreateColorLayer*
    constptr_OpCreateColorLayer() const
    {
        return ((mValue).VOpCreateColorLayer).addr();
    }
    OpCreateTextLayer*
    ptr_OpCreateTextLayer()
    {
        return ((mValue).VOpCreateTextLayer).addr();
    }
    const OpCreateTextLayer*
    constptr_OpCreateTextLayer() const
    {
        return ((mValue).VOpCreateTextLayer).addr();
    }
    OpCreateBorderLayer*
    ptr_OpCreateBorderLayer()
    {
        return ((mValue).VOpCreateBorderLayer).addr();
    }
    const OpCreateBorderLayer*
    constptr_OpCreateBorderLayer() const
    {
        return ((mValue).VOpCreateBorderLayer).addr();
    }
    OpCreateCanvasLayer*
    ptr_OpCreateCanvasLayer()
    {
        return ((mValue).VOpCreateCanvasLayer).addr();
    }
    const OpCreateCanvasLayer*
    constptr_OpCreateCanvasLayer() const
    {
        return ((mValue).VOpCreateCanvasLayer).addr();
    }
    OpCreateRefLayer*
    ptr_OpCreateRefLayer()
    {
        return ((mValue).VOpCreateRefLayer).addr();
    }
    const OpCreateRefLayer*
    constptr_OpCreateRefLayer() const
    {
        return ((mValue).VOpCreateRefLayer).addr();
    }
    OpSetDiagnosticTypes*
    ptr_OpSetDiagnosticTypes()
    {
        return ((mValue).VOpSetDiagnosticTypes).addr();
    }
    const OpSetDiagnosticTypes*
    constptr_OpSetDiagnosticTypes() const
    {
        return ((mValue).VOpSetDiagnosticTypes).addr();
    }
    OpWindowOverlayChanged*
    ptr_OpWindowOverlayChanged()
    {
        return ((mValue).VOpWindowOverlayChanged).addr();
    }
    const OpWindowOverlayChanged*
    constptr_OpWindowOverlayChanged() const
    {
        return ((mValue).VOpWindowOverlayChanged).addr();
    }
    OpSetRoot*
    ptr_OpSetRoot()
    {
        return ((mValue).VOpSetRoot).addr();
    }
    const OpSetRoot*
    constptr_OpSetRoot() const
    {
        return ((mValue).VOpSetRoot).addr();
    }
    OpInsertAfter*
    ptr_OpInsertAfter()
    {
        return ((mValue).VOpInsertAfter).addr();
    }
    const OpInsertAfter*
    constptr_OpInsertAfter() const
    {
        return ((mValue).VOpInsertAfter).addr();
    }
    OpPrependChild*
    ptr_OpPrependChild()
    {
        return ((mValue).VOpPrependChild).addr();
    }
    const OpPrependChild*
    constptr_OpPrependChild() const
    {
        return ((mValue).VOpPrependChild).addr();
    }
    OpRemoveChild*
    ptr_OpRemoveChild()
    {
        return ((mValue).VOpRemoveChild).addr();
    }
    const OpRemoveChild*
    constptr_OpRemoveChild() const
    {
        return ((mValue).VOpRemoveChild).addr();
    }
    OpRepositionChild*
    ptr_OpRepositionChild()
    {
        return ((mValue).VOpRepositionChild).addr();
    }
    const OpRepositionChild*
    constptr_OpRepositionChild() const
    {
        return ((mValue).VOpRepositionChild).addr();
    }
    OpRaiseToTopChild*
    ptr_OpRaiseToTopChild()
    {
        return ((mValue).VOpRaiseToTopChild).addr();
    }
    const OpRaiseToTopChild*
    constptr_OpRaiseToTopChild() const
    {
        return ((mValue).VOpRaiseToTopChild).addr();
    }
    OpAttachCompositable*
    ptr_OpAttachCompositable()
    {
        return ((mValue).VOpAttachCompositable).addr();
    }
    const OpAttachCompositable*
    constptr_OpAttachCompositable() const
    {
        return ((mValue).VOpAttachCompositable).addr();
    }
    OpAttachAsyncCompositable*
    ptr_OpAttachAsyncCompositable()
    {
        return ((mValue).VOpAttachAsyncCompositable).addr();
    }
    const OpAttachAsyncCompositable*
    constptr_OpAttachAsyncCompositable() const
    {
        return ((mValue).VOpAttachAsyncCompositable).addr();
    }
    CompositableOperation*
    ptr_CompositableOperation()
    {
        return ((mValue).VCompositableOperation).addr();
    }
    const CompositableOperation*
    constptr_CompositableOperation() const
    {
        return ((mValue).VCompositableOperation).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT Edit() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT Edit(const OpCreatePaintedLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateContainerLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateImageLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateColorLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateTextLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateBorderLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateCanvasLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateRefLayer& aOther);

    MOZ_IMPLICIT Edit(const OpSetDiagnosticTypes& aOther);

    MOZ_IMPLICIT Edit(const OpWindowOverlayChanged& aOther);

    MOZ_IMPLICIT Edit(const OpSetRoot& aOther);

    MOZ_IMPLICIT Edit(const OpInsertAfter& aOther);

    MOZ_IMPLICIT Edit(const OpPrependChild& aOther);

    MOZ_IMPLICIT Edit(const OpRemoveChild& aOther);

    MOZ_IMPLICIT Edit(const OpRepositionChild& aOther);

    MOZ_IMPLICIT Edit(const OpRaiseToTopChild& aOther);

    MOZ_IMPLICIT Edit(const OpAttachCompositable& aOther);

    MOZ_IMPLICIT Edit(const OpAttachAsyncCompositable& aOther);

    MOZ_IMPLICIT Edit(const CompositableOperation& aOther);

    MOZ_IMPLICIT Edit(const Edit& aOther);

    ~Edit();

    Type
    type() const
    {
        return mType;
    }

    Edit&
    operator=(const OpCreatePaintedLayer& aRhs);

    Edit&
    operator=(const OpCreateContainerLayer& aRhs);

    Edit&
    operator=(const OpCreateImageLayer& aRhs);

    Edit&
    operator=(const OpCreateColorLayer& aRhs);

    Edit&
    operator=(const OpCreateTextLayer& aRhs);

    Edit&
    operator=(const OpCreateBorderLayer& aRhs);

    Edit&
    operator=(const OpCreateCanvasLayer& aRhs);

    Edit&
    operator=(const OpCreateRefLayer& aRhs);

    Edit&
    operator=(const OpSetDiagnosticTypes& aRhs);

    Edit&
    operator=(const OpWindowOverlayChanged& aRhs);

    Edit&
    operator=(const OpSetRoot& aRhs);

    Edit&
    operator=(const OpInsertAfter& aRhs);

    Edit&
    operator=(const OpPrependChild& aRhs);

    Edit&
    operator=(const OpRemoveChild& aRhs);

    Edit&
    operator=(const OpRepositionChild& aRhs);

    Edit&
    operator=(const OpRaiseToTopChild& aRhs);

    Edit&
    operator=(const OpAttachCompositable& aRhs);

    Edit&
    operator=(const OpAttachAsyncCompositable& aRhs);

    Edit&
    operator=(const CompositableOperation& aRhs);

    Edit&
    operator=(const Edit& aRhs);

    bool
    operator==(const OpCreatePaintedLayer& aRhs) const;

    bool
    operator==(const OpCreateContainerLayer& aRhs) const;

    bool
    operator==(const OpCreateImageLayer& aRhs) const;

    bool
    operator==(const OpCreateColorLayer& aRhs) const;

    bool
    operator==(const OpCreateTextLayer& aRhs) const;

    bool
    operator==(const OpCreateBorderLayer& aRhs) const;

    bool
    operator==(const OpCreateCanvasLayer& aRhs) const;

    bool
    operator==(const OpCreateRefLayer& aRhs) const;

    bool
    operator==(const OpSetDiagnosticTypes& aRhs) const;

    bool
    operator==(const OpWindowOverlayChanged& aRhs) const;

    bool
    operator==(const OpSetRoot& aRhs) const;

    bool
    operator==(const OpInsertAfter& aRhs) const;

    bool
    operator==(const OpPrependChild& aRhs) const;

    bool
    operator==(const OpRemoveChild& aRhs) const;

    bool
    operator==(const OpRepositionChild& aRhs) const;

    bool
    operator==(const OpRaiseToTopChild& aRhs) const;

    bool
    operator==(const OpAttachCompositable& aRhs) const;

    bool
    operator==(const OpAttachAsyncCompositable& aRhs) const;

    bool
    operator==(const CompositableOperation& aRhs) const;

    bool
    operator==(const Edit& aRhs) const;

    OpCreatePaintedLayer&
    get_OpCreatePaintedLayer()
    {
        AssertSanity(TOpCreatePaintedLayer);
        return (*(ptr_OpCreatePaintedLayer()));
    }
    const OpCreatePaintedLayer&
    get_OpCreatePaintedLayer() const
    {
        AssertSanity(TOpCreatePaintedLayer);
        return (*(constptr_OpCreatePaintedLayer()));
    }
    void
    get(OpCreatePaintedLayer* aOutValue) const;
    operator OpCreatePaintedLayer&()
    {
        return get_OpCreatePaintedLayer();
    }
    operator const OpCreatePaintedLayer&() const
    {
        return get_OpCreatePaintedLayer();
    }

    OpCreateContainerLayer&
    get_OpCreateContainerLayer()
    {
        AssertSanity(TOpCreateContainerLayer);
        return (*(ptr_OpCreateContainerLayer()));
    }
    const OpCreateContainerLayer&
    get_OpCreateContainerLayer() const
    {
        AssertSanity(TOpCreateContainerLayer);
        return (*(constptr_OpCreateContainerLayer()));
    }
    void
    get(OpCreateContainerLayer* aOutValue) const;
    operator OpCreateContainerLayer&()
    {
        return get_OpCreateContainerLayer();
    }
    operator const OpCreateContainerLayer&() const
    {
        return get_OpCreateContainerLayer();
    }

    OpCreateImageLayer&
    get_OpCreateImageLayer()
    {
        AssertSanity(TOpCreateImageLayer);
        return (*(ptr_OpCreateImageLayer()));
    }
    const OpCreateImageLayer&
    get_OpCreateImageLayer() const
    {
        AssertSanity(TOpCreateImageLayer);
        return (*(constptr_OpCreateImageLayer()));
    }
    void
    get(OpCreateImageLayer* aOutValue) const;
    operator OpCreateImageLayer&()
    {
        return get_OpCreateImageLayer();
    }
    operator const OpCreateImageLayer&() const
    {
        return get_OpCreateImageLayer();
    }

    OpCreateColorLayer&
    get_OpCreateColorLayer()
    {
        AssertSanity(TOpCreateColorLayer);
        return (*(ptr_OpCreateColorLayer()));
    }
    const OpCreateColorLayer&
    get_OpCreateColorLayer() const
    {
        AssertSanity(TOpCreateColorLayer);
        return (*(constptr_OpCreateColorLayer()));
    }
    void
    get(OpCreateColorLayer* aOutValue) const;
    operator OpCreateColorLayer&()
    {
        return get_OpCreateColorLayer();
    }
    operator const OpCreateColorLayer&() const
    {
        return get_OpCreateColorLayer();
    }

    OpCreateTextLayer&
    get_OpCreateTextLayer()
    {
        AssertSanity(TOpCreateTextLayer);
        return (*(ptr_OpCreateTextLayer()));
    }
    const OpCreateTextLayer&
    get_OpCreateTextLayer() const
    {
        AssertSanity(TOpCreateTextLayer);
        return (*(constptr_OpCreateTextLayer()));
    }
    void
    get(OpCreateTextLayer* aOutValue) const;
    operator OpCreateTextLayer&()
    {
        return get_OpCreateTextLayer();
    }
    operator const OpCreateTextLayer&() const
    {
        return get_OpCreateTextLayer();
    }

    OpCreateBorderLayer&
    get_OpCreateBorderLayer()
    {
        AssertSanity(TOpCreateBorderLayer);
        return (*(ptr_OpCreateBorderLayer()));
    }
    const OpCreateBorderLayer&
    get_OpCreateBorderLayer() const
    {
        AssertSanity(TOpCreateBorderLayer);
        return (*(constptr_OpCreateBorderLayer()));
    }
    void
    get(OpCreateBorderLayer* aOutValue) const;
    operator OpCreateBorderLayer&()
    {
        return get_OpCreateBorderLayer();
    }
    operator const OpCreateBorderLayer&() const
    {
        return get_OpCreateBorderLayer();
    }

    OpCreateCanvasLayer&
    get_OpCreateCanvasLayer()
    {
        AssertSanity(TOpCreateCanvasLayer);
        return (*(ptr_OpCreateCanvasLayer()));
    }
    const OpCreateCanvasLayer&
    get_OpCreateCanvasLayer() const
    {
        AssertSanity(TOpCreateCanvasLayer);
        return (*(constptr_OpCreateCanvasLayer()));
    }
    void
    get(OpCreateCanvasLayer* aOutValue) const;
    operator OpCreateCanvasLayer&()
    {
        return get_OpCreateCanvasLayer();
    }
    operator const OpCreateCanvasLayer&() const
    {
        return get_OpCreateCanvasLayer();
    }

    OpCreateRefLayer&
    get_OpCreateRefLayer()
    {
        AssertSanity(TOpCreateRefLayer);
        return (*(ptr_OpCreateRefLayer()));
    }
    const OpCreateRefLayer&
    get_OpCreateRefLayer() const
    {
        AssertSanity(TOpCreateRefLayer);
        return (*(constptr_OpCreateRefLayer()));
    }
    void
    get(OpCreateRefLayer* aOutValue) const;
    operator OpCreateRefLayer&()
    {
        return get_OpCreateRefLayer();
    }
    operator const OpCreateRefLayer&() const
    {
        return get_OpCreateRefLayer();
    }

    OpSetDiagnosticTypes&
    get_OpSetDiagnosticTypes()
    {
        AssertSanity(TOpSetDiagnosticTypes);
        return (*(ptr_OpSetDiagnosticTypes()));
    }
    const OpSetDiagnosticTypes&
    get_OpSetDiagnosticTypes() const
    {
        AssertSanity(TOpSetDiagnosticTypes);
        return (*(constptr_OpSetDiagnosticTypes()));
    }
    void
    get(OpSetDiagnosticTypes* aOutValue) const;
    operator OpSetDiagnosticTypes&()
    {
        return get_OpSetDiagnosticTypes();
    }
    operator const OpSetDiagnosticTypes&() const
    {
        return get_OpSetDiagnosticTypes();
    }

    OpWindowOverlayChanged&
    get_OpWindowOverlayChanged()
    {
        AssertSanity(TOpWindowOverlayChanged);
        return (*(ptr_OpWindowOverlayChanged()));
    }
    const OpWindowOverlayChanged&
    get_OpWindowOverlayChanged() const
    {
        AssertSanity(TOpWindowOverlayChanged);
        return (*(constptr_OpWindowOverlayChanged()));
    }
    void
    get(OpWindowOverlayChanged* aOutValue) const;
    operator OpWindowOverlayChanged&()
    {
        return get_OpWindowOverlayChanged();
    }
    operator const OpWindowOverlayChanged&() const
    {
        return get_OpWindowOverlayChanged();
    }

    OpSetRoot&
    get_OpSetRoot()
    {
        AssertSanity(TOpSetRoot);
        return (*(ptr_OpSetRoot()));
    }
    const OpSetRoot&
    get_OpSetRoot() const
    {
        AssertSanity(TOpSetRoot);
        return (*(constptr_OpSetRoot()));
    }
    void
    get(OpSetRoot* aOutValue) const;
    operator OpSetRoot&()
    {
        return get_OpSetRoot();
    }
    operator const OpSetRoot&() const
    {
        return get_OpSetRoot();
    }

    OpInsertAfter&
    get_OpInsertAfter()
    {
        AssertSanity(TOpInsertAfter);
        return (*(ptr_OpInsertAfter()));
    }
    const OpInsertAfter&
    get_OpInsertAfter() const
    {
        AssertSanity(TOpInsertAfter);
        return (*(constptr_OpInsertAfter()));
    }
    void
    get(OpInsertAfter* aOutValue) const;
    operator OpInsertAfter&()
    {
        return get_OpInsertAfter();
    }
    operator const OpInsertAfter&() const
    {
        return get_OpInsertAfter();
    }

    OpPrependChild&
    get_OpPrependChild()
    {
        AssertSanity(TOpPrependChild);
        return (*(ptr_OpPrependChild()));
    }
    const OpPrependChild&
    get_OpPrependChild() const
    {
        AssertSanity(TOpPrependChild);
        return (*(constptr_OpPrependChild()));
    }
    void
    get(OpPrependChild* aOutValue) const;
    operator OpPrependChild&()
    {
        return get_OpPrependChild();
    }
    operator const OpPrependChild&() const
    {
        return get_OpPrependChild();
    }

    OpRemoveChild&
    get_OpRemoveChild()
    {
        AssertSanity(TOpRemoveChild);
        return (*(ptr_OpRemoveChild()));
    }
    const OpRemoveChild&
    get_OpRemoveChild() const
    {
        AssertSanity(TOpRemoveChild);
        return (*(constptr_OpRemoveChild()));
    }
    void
    get(OpRemoveChild* aOutValue) const;
    operator OpRemoveChild&()
    {
        return get_OpRemoveChild();
    }
    operator const OpRemoveChild&() const
    {
        return get_OpRemoveChild();
    }

    OpRepositionChild&
    get_OpRepositionChild()
    {
        AssertSanity(TOpRepositionChild);
        return (*(ptr_OpRepositionChild()));
    }
    const OpRepositionChild&
    get_OpRepositionChild() const
    {
        AssertSanity(TOpRepositionChild);
        return (*(constptr_OpRepositionChild()));
    }
    void
    get(OpRepositionChild* aOutValue) const;
    operator OpRepositionChild&()
    {
        return get_OpRepositionChild();
    }
    operator const OpRepositionChild&() const
    {
        return get_OpRepositionChild();
    }

    OpRaiseToTopChild&
    get_OpRaiseToTopChild()
    {
        AssertSanity(TOpRaiseToTopChild);
        return (*(ptr_OpRaiseToTopChild()));
    }
    const OpRaiseToTopChild&
    get_OpRaiseToTopChild() const
    {
        AssertSanity(TOpRaiseToTopChild);
        return (*(constptr_OpRaiseToTopChild()));
    }
    void
    get(OpRaiseToTopChild* aOutValue) const;
    operator OpRaiseToTopChild&()
    {
        return get_OpRaiseToTopChild();
    }
    operator const OpRaiseToTopChild&() const
    {
        return get_OpRaiseToTopChild();
    }

    OpAttachCompositable&
    get_OpAttachCompositable()
    {
        AssertSanity(TOpAttachCompositable);
        return (*(ptr_OpAttachCompositable()));
    }
    const OpAttachCompositable&
    get_OpAttachCompositable() const
    {
        AssertSanity(TOpAttachCompositable);
        return (*(constptr_OpAttachCompositable()));
    }
    void
    get(OpAttachCompositable* aOutValue) const;
    operator OpAttachCompositable&()
    {
        return get_OpAttachCompositable();
    }
    operator const OpAttachCompositable&() const
    {
        return get_OpAttachCompositable();
    }

    OpAttachAsyncCompositable&
    get_OpAttachAsyncCompositable()
    {
        AssertSanity(TOpAttachAsyncCompositable);
        return (*(ptr_OpAttachAsyncCompositable()));
    }
    const OpAttachAsyncCompositable&
    get_OpAttachAsyncCompositable() const
    {
        AssertSanity(TOpAttachAsyncCompositable);
        return (*(constptr_OpAttachAsyncCompositable()));
    }
    void
    get(OpAttachAsyncCompositable* aOutValue) const;
    operator OpAttachAsyncCompositable&()
    {
        return get_OpAttachAsyncCompositable();
    }
    operator const OpAttachAsyncCompositable&() const
    {
        return get_OpAttachAsyncCompositable();
    }

    CompositableOperation&
    get_CompositableOperation()
    {
        AssertSanity(TCompositableOperation);
        return (*(ptr_CompositableOperation()));
    }
    const CompositableOperation&
    get_CompositableOperation() const
    {
        AssertSanity(TCompositableOperation);
        return (*(constptr_CompositableOperation()));
    }
    void
    get(CompositableOperation* aOutValue) const;
    operator CompositableOperation&()
    {
        return get_CompositableOperation();
    }
    operator const CompositableOperation&() const
    {
        return get_CompositableOperation();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OpDestroy|
//
namespace mozilla {
namespace layers {
class OpDestroy final
{
public:
    enum Type {
        T__None,
        TPTextureParent = 1,
        TPTextureChild,
        TCompositableHandle,
        T__Last = TCompositableHandle
    };

private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::CompositableHandle CompositableHandle;
    typedef PTextureParent* PTextureParent__tdef;
    typedef PTextureChild* PTextureChild__tdef;
    typedef CompositableHandle CompositableHandle__tdef;

    union Value {
        mozilla::AlignedStorage2<PTextureParent*> VPTextureParent;
        mozilla::AlignedStorage2<PTextureChild*> VPTextureChild;
        mozilla::AlignedStorage2<CompositableHandle> VCompositableHandle;
    };

    PTextureParent**
    ptr_PTextureParent()
    {
        return ((mValue).VPTextureParent).addr();
    }
    PTextureParent* const*
    constptr_PTextureParent() const
    {
        return ((mValue).VPTextureParent).addr();
    }
    PTextureChild**
    ptr_PTextureChild()
    {
        return ((mValue).VPTextureChild).addr();
    }
    PTextureChild* const*
    constptr_PTextureChild() const
    {
        return ((mValue).VPTextureChild).addr();
    }
    CompositableHandle*
    ptr_CompositableHandle()
    {
        return ((mValue).VCompositableHandle).addr();
    }
    const CompositableHandle*
    constptr_CompositableHandle() const
    {
        return ((mValue).VCompositableHandle).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OpDestroy() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OpDestroy(PTextureParent* aOther);

    MOZ_IMPLICIT OpDestroy(PTextureChild* aOther);

    MOZ_IMPLICIT OpDestroy(const CompositableHandle& aOther);

    MOZ_IMPLICIT OpDestroy(const OpDestroy& aOther);

    ~OpDestroy();

    Type
    type() const
    {
        return mType;
    }

    OpDestroy&
    operator=(PTextureParent* aRhs);

    OpDestroy&
    operator=(PTextureChild* aRhs);

    OpDestroy&
    operator=(const CompositableHandle& aRhs);

    OpDestroy&
    operator=(const OpDestroy& aRhs);

    bool
    operator==(PTextureParent* aRhs) const;

    bool
    operator==(PTextureChild* aRhs) const;

    bool
    operator==(const CompositableHandle& aRhs) const;

    bool
    operator==(const OpDestroy& aRhs) const;

    PTextureParent*&
    get_PTextureParent()
    {
        AssertSanity(TPTextureParent);
        return (*(ptr_PTextureParent()));
    }
    PTextureParent*
    get_PTextureParent() const
    {
        AssertSanity(TPTextureParent);
        return (*(constptr_PTextureParent()));
    }
    void
    get(PTextureParent** aOutValue) const;
    operator PTextureParent*&()
    {
        return get_PTextureParent();
    }
    operator PTextureParent*() const
    {
        return get_PTextureParent();
    }

    PTextureChild*&
    get_PTextureChild()
    {
        AssertSanity(TPTextureChild);
        return (*(ptr_PTextureChild()));
    }
    PTextureChild*
    get_PTextureChild() const
    {
        AssertSanity(TPTextureChild);
        return (*(constptr_PTextureChild()));
    }
    void
    get(PTextureChild** aOutValue) const;
    operator PTextureChild*&()
    {
        return get_PTextureChild();
    }
    operator PTextureChild*() const
    {
        return get_PTextureChild();
    }

    CompositableHandle&
    get_CompositableHandle()
    {
        AssertSanity(TCompositableHandle);
        return (*(ptr_CompositableHandle()));
    }
    const CompositableHandle&
    get_CompositableHandle() const
    {
        AssertSanity(TCompositableHandle);
        return (*(constptr_CompositableHandle()));
    }
    void
    get(CompositableHandle* aOutValue) const;
    operator CompositableHandle&()
    {
        return get_CompositableHandle();
    }
    operator const CompositableHandle&() const
    {
        return get_CompositableHandle();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpContentBufferSwap|
//
namespace mozilla {
namespace layers {
class OpContentBufferSwap final
{
private:
    typedef mozilla::layers::CompositableHandle CompositableHandle;

public:
    MOZ_IMPLICIT OpContentBufferSwap();

    MOZ_IMPLICIT OpContentBufferSwap(
            const CompositableHandle& _compositable,
            const nsIntRegion& _frontUpdatedRegion)
    {
        Init();
        Assign(_compositable, _frontUpdatedRegion);
    }

    MOZ_IMPLICIT OpContentBufferSwap(const OpContentBufferSwap& _o)
    {
        Init();
        Assign((_o).compositable(), (_o).frontUpdatedRegion());
    }

    ~OpContentBufferSwap();

    void
    operator=(const OpContentBufferSwap& _o)
    {
        Assign((_o).compositable(), (_o).frontUpdatedRegion());
    }

    bool
    operator==(const OpContentBufferSwap& _o) const;

    bool
    operator!=(const OpContentBufferSwap& _o) const;

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

    nsIntRegion&
    frontUpdatedRegion()
    {
        return frontUpdatedRegion_;
    }
    const nsIntRegion&
    frontUpdatedRegion() const
    {
        return frontUpdatedRegion_;
    }

private:
    void
    Init();

    void
    Assign(
            const CompositableHandle& _compositable,
            const nsIntRegion& _frontUpdatedRegion);

    CompositableHandle compositable_;
    nsIntRegion frontUpdatedRegion_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ImageCompositeNotification|
//
namespace mozilla {
namespace layers {
class ImageCompositeNotification final
{
private:
    typedef mozilla::layers::CompositableHandle CompositableHandle;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ImageCompositeNotification();

    MOZ_IMPLICIT ImageCompositeNotification(
            const CompositableHandle& _compositable,
            const TimeStamp& _imageTimeStamp,
            const TimeStamp& _firstCompositeTimeStamp,
            const uint32_t& _frameID,
            const uint32_t& _producerID)
    {
        Init();
        Assign(_compositable, _imageTimeStamp, _firstCompositeTimeStamp, _frameID, _producerID);
    }

    MOZ_IMPLICIT ImageCompositeNotification(const ImageCompositeNotification& _o)
    {
        Init();
        Assign((_o).compositable(), (_o).imageTimeStamp(), (_o).firstCompositeTimeStamp(), (_o).frameID(), (_o).producerID());
    }

    ~ImageCompositeNotification();

    void
    operator=(const ImageCompositeNotification& _o)
    {
        Assign((_o).compositable(), (_o).imageTimeStamp(), (_o).firstCompositeTimeStamp(), (_o).frameID(), (_o).producerID());
    }

    bool
    operator==(const ImageCompositeNotification& _o) const;

    bool
    operator!=(const ImageCompositeNotification& _o) const;

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

    TimeStamp&
    imageTimeStamp()
    {
        return imageTimeStamp_;
    }
    const TimeStamp&
    imageTimeStamp() const
    {
        return imageTimeStamp_;
    }

    TimeStamp&
    firstCompositeTimeStamp()
    {
        return firstCompositeTimeStamp_;
    }
    const TimeStamp&
    firstCompositeTimeStamp() const
    {
        return firstCompositeTimeStamp_;
    }

    uint32_t&
    frameID()
    {
        return frameID_;
    }
    const uint32_t&
    frameID() const
    {
        return frameID_;
    }

    uint32_t&
    producerID()
    {
        return producerID_;
    }
    const uint32_t&
    producerID() const
    {
        return producerID_;
    }

private:
    void
    Init();

    void
    Assign(
            const CompositableHandle& _compositable,
            const TimeStamp& _imageTimeStamp,
            const TimeStamp& _firstCompositeTimeStamp,
            const uint32_t& _frameID,
            const uint32_t& _producerID);

    CompositableHandle compositable_;
    TimeStamp imageTimeStamp_;
    TimeStamp firstCompositeTimeStamp_;
    uint32_t frameID_;
    uint32_t producerID_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpNotifyNotUsed;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AsyncParentMessageData|
//
namespace mozilla {
namespace layers {
class AsyncParentMessageData final
{
public:
    enum Type {
        T__None,
        TOpNotifyNotUsed = 1,
        T__Last = TOpNotifyNotUsed
    };

private:
    typedef mozilla::layers::OpNotifyNotUsed OpNotifyNotUsed;
    typedef OpNotifyNotUsed OpNotifyNotUsed__tdef;

    union Value {
        mozilla::AlignedStorage2<OpNotifyNotUsed> VOpNotifyNotUsed;
    };

    OpNotifyNotUsed*
    ptr_OpNotifyNotUsed()
    {
        return ((mValue).VOpNotifyNotUsed).addr();
    }
    const OpNotifyNotUsed*
    constptr_OpNotifyNotUsed() const
    {
        return ((mValue).VOpNotifyNotUsed).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AsyncParentMessageData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AsyncParentMessageData(const OpNotifyNotUsed& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(const AsyncParentMessageData& aOther);

    ~AsyncParentMessageData();

    Type
    type() const
    {
        return mType;
    }

    AsyncParentMessageData&
    operator=(const OpNotifyNotUsed& aRhs);

    AsyncParentMessageData&
    operator=(const AsyncParentMessageData& aRhs);

    bool
    operator==(const OpNotifyNotUsed& aRhs) const;

    bool
    operator==(const AsyncParentMessageData& aRhs) const;

    OpNotifyNotUsed&
    get_OpNotifyNotUsed()
    {
        AssertSanity(TOpNotifyNotUsed);
        return (*(ptr_OpNotifyNotUsed()));
    }
    const OpNotifyNotUsed&
    get_OpNotifyNotUsed() const
    {
        AssertSanity(TOpNotifyNotUsed);
        return (*(constptr_OpNotifyNotUsed()));
    }
    void
    get(OpNotifyNotUsed* aOutValue) const;
    operator OpNotifyNotUsed&()
    {
        return get_OpNotifyNotUsed();
    }
    operator const OpNotifyNotUsed&() const
    {
        return get_OpNotifyNotUsed();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PaintTiming|
//
namespace mozilla {
namespace layers {
class PaintTiming final
{
private:

public:
    MOZ_IMPLICIT PaintTiming();

    MOZ_IMPLICIT PaintTiming(
            const float& _serializeMs,
            const float& _sendMs,
            const float& _dlMs,
            const float& _flbMs,
            const float& _rasterMs)
    {
        Init();
        Assign(_serializeMs, _sendMs, _dlMs, _flbMs, _rasterMs);
    }

    MOZ_IMPLICIT PaintTiming(const PaintTiming& _o)
    {
        Init();
        Assign((_o).serializeMs(), (_o).sendMs(), (_o).dlMs(), (_o).flbMs(), (_o).rasterMs());
    }

    ~PaintTiming();

    void
    operator=(const PaintTiming& _o)
    {
        Assign((_o).serializeMs(), (_o).sendMs(), (_o).dlMs(), (_o).flbMs(), (_o).rasterMs());
    }

    bool
    operator==(const PaintTiming& _o) const;

    bool
    operator!=(const PaintTiming& _o) const;

    float&
    serializeMs()
    {
        return serializeMs_;
    }
    const float&
    serializeMs() const
    {
        return serializeMs_;
    }

    float&
    sendMs()
    {
        return sendMs_;
    }
    const float&
    sendMs() const
    {
        return sendMs_;
    }

    float&
    dlMs()
    {
        return dlMs_;
    }
    const float&
    dlMs() const
    {
        return dlMs_;
    }

    float&
    flbMs()
    {
        return flbMs_;
    }
    const float&
    flbMs() const
    {
        return flbMs_;
    }

    float&
    rasterMs()
    {
        return rasterMs_;
    }
    const float&
    rasterMs() const
    {
        return rasterMs_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _serializeMs,
            const float& _sendMs,
            const float& _dlMs,
            const float& _flbMs,
            const float& _rasterMs);

    float serializeMs_;
    float sendMs_;
    float dlMs_;
    float flbMs_;
    float rasterMs_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Edit;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetSimpleLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CompositableOperation;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpDestroy;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TargetConfig;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PluginWindowData;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransactionInfo|
//
namespace mozilla {
namespace layers {
class TransactionInfo final
{
private:
    typedef mozilla::layers::Edit Edit;
    typedef mozilla::layers::OpSetSimpleLayerAttributes OpSetSimpleLayerAttributes;
    typedef mozilla::layers::OpSetLayerAttributes OpSetLayerAttributes;
    typedef mozilla::layers::CompositableOperation CompositableOperation;
    typedef mozilla::layers::OpDestroy OpDestroy;
    typedef mozilla::layers::TargetConfig TargetConfig;
    typedef mozilla::layers::PluginWindowData PluginWindowData;
    typedef mozilla::layers::FocusTarget FocusTarget;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT TransactionInfo();

    MOZ_IMPLICIT TransactionInfo(
            const nsTArray<Edit>& _cset,
            const nsTArray<OpSetSimpleLayerAttributes>& _setSimpleAttrs,
            const nsTArray<OpSetLayerAttributes>& _setAttrs,
            const nsTArray<CompositableOperation>& _paints,
            const nsTArray<OpDestroy>& _toDestroy,
            const uint64_t& _fwdTransactionId,
            const uint64_t& _id,
            const TargetConfig& _targetConfig,
            const nsTArray<PluginWindowData>& _plugins,
            const bool& _isFirstPaint,
            const FocusTarget& _focusTarget,
            const bool& _scheduleComposite,
            const uint32_t& _paintSequenceNumber,
            const bool& _isRepeatTransaction,
            const TimeStamp& _transactionStart,
            const TimeStamp& _fwdTime)
    {
        Init();
        Assign(_cset, _setSimpleAttrs, _setAttrs, _paints, _toDestroy, _fwdTransactionId, _id, _targetConfig, _plugins, _isFirstPaint, _focusTarget, _scheduleComposite, _paintSequenceNumber, _isRepeatTransaction, _transactionStart, _fwdTime);
    }

    MOZ_IMPLICIT TransactionInfo(const TransactionInfo& _o)
    {
        Init();
        Assign((_o).cset(), (_o).setSimpleAttrs(), (_o).setAttrs(), (_o).paints(), (_o).toDestroy(), (_o).fwdTransactionId(), (_o).id(), (_o).targetConfig(), (_o).plugins(), (_o).isFirstPaint(), (_o).focusTarget(), (_o).scheduleComposite(), (_o).paintSequenceNumber(), (_o).isRepeatTransaction(), (_o).transactionStart(), (_o).fwdTime());
    }

    ~TransactionInfo();

    void
    operator=(const TransactionInfo& _o)
    {
        Assign((_o).cset(), (_o).setSimpleAttrs(), (_o).setAttrs(), (_o).paints(), (_o).toDestroy(), (_o).fwdTransactionId(), (_o).id(), (_o).targetConfig(), (_o).plugins(), (_o).isFirstPaint(), (_o).focusTarget(), (_o).scheduleComposite(), (_o).paintSequenceNumber(), (_o).isRepeatTransaction(), (_o).transactionStart(), (_o).fwdTime());
    }

    bool
    operator==(const TransactionInfo& _o) const;

    bool
    operator!=(const TransactionInfo& _o) const;

    nsTArray<Edit>&
    cset()
    {
        return cset_;
    }
    const nsTArray<Edit>&
    cset() const
    {
        return cset_;
    }

    nsTArray<OpSetSimpleLayerAttributes>&
    setSimpleAttrs()
    {
        return setSimpleAttrs_;
    }
    const nsTArray<OpSetSimpleLayerAttributes>&
    setSimpleAttrs() const
    {
        return setSimpleAttrs_;
    }

    nsTArray<OpSetLayerAttributes>&
    setAttrs()
    {
        return setAttrs_;
    }
    const nsTArray<OpSetLayerAttributes>&
    setAttrs() const
    {
        return setAttrs_;
    }

    nsTArray<CompositableOperation>&
    paints()
    {
        return paints_;
    }
    const nsTArray<CompositableOperation>&
    paints() const
    {
        return paints_;
    }

    nsTArray<OpDestroy>&
    toDestroy()
    {
        return toDestroy_;
    }
    const nsTArray<OpDestroy>&
    toDestroy() const
    {
        return toDestroy_;
    }

    uint64_t&
    fwdTransactionId()
    {
        return fwdTransactionId_;
    }
    const uint64_t&
    fwdTransactionId() const
    {
        return fwdTransactionId_;
    }

    uint64_t&
    id()
    {
        return id_;
    }
    const uint64_t&
    id() const
    {
        return id_;
    }

    TargetConfig&
    targetConfig()
    {
        return targetConfig_;
    }
    const TargetConfig&
    targetConfig() const
    {
        return targetConfig_;
    }

    nsTArray<PluginWindowData>&
    plugins()
    {
        return plugins_;
    }
    const nsTArray<PluginWindowData>&
    plugins() const
    {
        return plugins_;
    }

    bool&
    isFirstPaint()
    {
        return isFirstPaint_;
    }
    const bool&
    isFirstPaint() const
    {
        return isFirstPaint_;
    }

    FocusTarget&
    focusTarget()
    {
        return focusTarget_;
    }
    const FocusTarget&
    focusTarget() const
    {
        return focusTarget_;
    }

    bool&
    scheduleComposite()
    {
        return scheduleComposite_;
    }
    const bool&
    scheduleComposite() const
    {
        return scheduleComposite_;
    }

    uint32_t&
    paintSequenceNumber()
    {
        return paintSequenceNumber_;
    }
    const uint32_t&
    paintSequenceNumber() const
    {
        return paintSequenceNumber_;
    }

    bool&
    isRepeatTransaction()
    {
        return isRepeatTransaction_;
    }
    const bool&
    isRepeatTransaction() const
    {
        return isRepeatTransaction_;
    }

    TimeStamp&
    transactionStart()
    {
        return transactionStart_;
    }
    const TimeStamp&
    transactionStart() const
    {
        return transactionStart_;
    }

    TimeStamp&
    fwdTime()
    {
        return fwdTime_;
    }
    const TimeStamp&
    fwdTime() const
    {
        return fwdTime_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<Edit>& _cset,
            const nsTArray<OpSetSimpleLayerAttributes>& _setSimpleAttrs,
            const nsTArray<OpSetLayerAttributes>& _setAttrs,
            const nsTArray<CompositableOperation>& _paints,
            const nsTArray<OpDestroy>& _toDestroy,
            const uint64_t& _fwdTransactionId,
            const uint64_t& _id,
            const TargetConfig& _targetConfig,
            const nsTArray<PluginWindowData>& _plugins,
            const bool& _isFirstPaint,
            const FocusTarget& _focusTarget,
            const bool& _scheduleComposite,
            const uint32_t& _paintSequenceNumber,
            const bool& _isRepeatTransaction,
            const TimeStamp& _transactionStart,
            const TimeStamp& _fwdTime);

    nsTArray<Edit> cset_;
    nsTArray<OpSetSimpleLayerAttributes> setSimpleAttrs_;
    nsTArray<OpSetLayerAttributes> setAttrs_;
    nsTArray<CompositableOperation> paints_;
    nsTArray<OpDestroy> toDestroy_;
    uint64_t fwdTransactionId_;
    uint64_t id_;
    TargetConfig targetConfig_;
    nsTArray<PluginWindowData> plugins_;
    bool isFirstPaint_;
    FocusTarget focusTarget_;
    bool scheduleComposite_;
    uint32_t paintSequenceNumber_;
    bool isRepeatTransaction_;
    TimeStamp transactionStart_;
    TimeStamp fwdTime_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeTransform|
//
namespace mozilla {
namespace layers {
class MaybeTransform final
{
public:
    enum Type {
        T__None,
        TMatrix4x4 = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::void_t void_t;
    typedef Matrix4x4 Matrix4x4__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Matrix4x4> VMatrix4x4;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    Matrix4x4*
    ptr_Matrix4x4()
    {
        return ((mValue).VMatrix4x4).addr();
    }
    const Matrix4x4*
    constptr_Matrix4x4() const
    {
        return ((mValue).VMatrix4x4).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeTransform() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeTransform(const Matrix4x4& aOther);

    MOZ_IMPLICIT MaybeTransform(const void_t& aOther);

    MOZ_IMPLICIT MaybeTransform(const MaybeTransform& aOther);

    ~MaybeTransform();

    Type
    type() const
    {
        return mType;
    }

    MaybeTransform&
    operator=(const Matrix4x4& aRhs);

    MaybeTransform&
    operator=(const void_t& aRhs);

    MaybeTransform&
    operator=(const MaybeTransform& aRhs);

    bool
    operator==(const Matrix4x4& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const MaybeTransform& aRhs) const;

    Matrix4x4&
    get_Matrix4x4()
    {
        AssertSanity(TMatrix4x4);
        return (*(ptr_Matrix4x4()));
    }
    const Matrix4x4&
    get_Matrix4x4() const
    {
        AssertSanity(TMatrix4x4);
        return (*(constptr_Matrix4x4()));
    }
    void
    get(Matrix4x4* aOutValue) const;
    operator Matrix4x4&()
    {
        return get_Matrix4x4();
    }
    operator const Matrix4x4&() const
    {
        return get_Matrix4x4();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

#endif // ifndef LayersMessages_h
